C $$-part.for  -  vykonna cast modelovani pohybu castic
      SUBROUTINE PARTICLE
C Modifikace polohy castic
      INCLUDE '$FEMEQ'
      LOGICAL INSIDE
C Pro vypocet stredni rychlosti a stredni uhlove rychlosti castic se vyuziva
C zona EPAR
C   1      2      3       4       5       6       7       8       9     10
C  NU     VX     VY      VZ      RX      RY      RZ      x0      y0     z0
C
C Poloha castice je dana souradnicemi XX,YY,ZZ definicnich uzlu
C
C Faze 1. - vypocet strednich rychlosti prohlizenim seznamu uzlovych bodu
C           NPART-pocet elementu typu castice, 
C           NPARN-pocet uzlu definujicich castice
C ------------------------------------------------- 
      DO IE=NE+1,NE+NPART
         DO J=1,7
           EPAR(IE,J)=0
         ENDDO
      ENDDO
      WRITE(2,*)' Translational velocities of particles begins...'
      DO IND=1,ND
         DO J=1,NPART
            NEJ=NE+J
            LEGRP=MAX0(1,IGROUP(NEJ))
            NAMELE=JGROUP(LEGRP,$ENAME)
            CALL NDINPART(IND,J,NAMELE,INSIDE)
            IF(INSIDE)THEN
               EPAR(NEJ,1)=EPAR(NEJ,1)+1
               SELECT CASE(NAMELE)
               CASE($CYLINDER)
                  VX=VAL(LPU($VX)+IND,2)
                  VY=VAL(LPU($VY)+IND,2)
                  EPAR(NEJ,2)=EPAR(NEJ,2)+VX
                  EPAR(NEJ,3)=EPAR(NEJ,3)+VY
               CASE($SPHERE)
                  VX=VAL(LPU($VX)+IND,2)
                  VY=VAL(LPU($VY)+IND,2)
                  VZ=VAL(LPU($VZ)+IND,2)
C Hruba aproximace prumer - spravne by se mel pocitat integral (ale jak?)
                  EPAR(NEJ,2)=EPAR(NEJ,2)+VX
                  EPAR(NEJ,3)=EPAR(NEJ,3)+VY
                  EPAR(NEJ,4)=EPAR(NEJ,4)+VZ
                ENDSELECT
C Je treba doplnit rotacni slozky vzhledem k tezisti castice
C Prohlizeni seznamu castic neukoncime, protoze nelze vyloucit jejich prolinani
            ENDIF
         ENDDO
      ENDDO
C Souradnice teziste castice a Prumerne rychlosti 
      DO IE=NE+1,NE+NPART
        L0=LUE(IE)
        INP=IABS(IUE(L0+1))
        EPAR(IE,8) =XX(INP)
        EPAR(IE,9) =YY(INP)
        EPAR(IE,10)=ZZ(INP)
        N=FLOOR(EPAR(IE,1))
        IF(N.GE.1)THEN
           DO J=2,4
             EPAR(IE,J)=EPAR(IE,J)/N
           ENDDO
        ELSE
           WRITE(2,*)' There is no node in the particle number',IE
        ENDIF
      ENDDO
C 
C Faze 2. uhlove rychlosti RX,RY,RZ. 
C --------------------------------------
      WRITE(2,*)' Angular velocities of particles begins...'
      DO IND=1,ND
         DO J=1,NPART
            NEJ=NE+J
            LEGRP=MAX0(1,IGROUP(NEJ))
            NAMELE=JGROUP(LEGRP,$ENAME)
            CALL NDINPART(IND,J,NAMELE,INSIDE)
            IF(INSIDE)THEN
               SELECT CASE(NAMELE)
               CASE($CYLINDER)
C VX,VY relativni rychlosti uzlu IND vuci translacni rychlosti castice NEJ
                  VX=VAL(LPU($VX)+IND,2)-EPAR(NEJ,2)
                  VY=VAL(LPU($VY)+IND,2)-EPAR(NEJ,3)
C souradnice stredu castice X0,Y0 a uzlu XI,YI
                  X0=EPAR(NEJ,8)
                  Y0=EPAR(NEJ,9)
                  XI=XX(IND)
                  YI=YY(IND)
                  R2=(X0-XI)**2+(Y0-YI)**2
C jedina slozka rotace RZ (SEDMY SLOUPEC)
                  EPAR(NEJ,7)=EPAR(NEJ,7)+(VY*(XI-X0)-VX*(YI-Y0))/R2
               CASE($SPHERE)
C VX,VY,VZ relativni rychlosti uzlu IND vuci translacni rychlosti castice NEJ
                  VX=VAL(LPU($VX)+IND,2)-EPAR(NEJ,2)
                  VY=VAL(LPU($VY)+IND,2)-EPAR(NEJ,3)
                  VZ=VAL(LPU($VZ)+IND,2)-EPAR(NEJ,4)
C souradnice stredu castice X0,Y0,Z0 a uzlu XI,YI,ZI
                  X0=EPAR(NEJ,8)
                  Y0=EPAR(NEJ,9)
                  Z0=EPAR(NEJ,10)
                  XI=XX(IND)
                  YI=YY(IND)
                  ZI=ZZ(IND)
                  R2=(X0-XI)**2+(Y0-YI)**2+(Z0-ZI)**2
C Korekce uzlovych rychlosti, spocivajici v odecteni slozky rychlosti, 
C odpovidajici radialnimu pohybu uzlu.
                  R=(VX*(XI-X0)+VY*(YI-Y0)+VZ*(ZI-Z0))/R2
                  VX=VX-(XI-X0)*R
                  VY=VY-(YI-Y0)*R
                  VZ=VZ-(ZI-Z0)*R
C VX,VY,VX jsou slozky relativni rychlosti v tangencialnim smeru k povrchu
C koule. De facto jsou tedy jen 2 slozky rychlosti nezavisle, tudiz lze 
C stanovit jen 2 nezavisle slozky uhlovych rychlosti. TATO UVAHA MUZE BYT CHYBNA!!
                  IF(XI.NE.X0)THEN
C RX=0 (EPAR 5)
                    EPAR(NEJ,6)=EPAR(NEJ,6)-VZ/(XI-X0)
                    EPAR(NEJ,7)=EPAR(NEJ,7)+VY/(XI-X0)
                  ELSEIF(YI.NE.Y0)THEN
C RY=0 (EPAR 6)                    
                    EPAR(NEJ,5)=EPAR(NEJ,5)+VZ/(YI-Y0)
                    EPAR(NEJ,7)=EPAR(NEJ,7)-VX/(YI-Y0)
                  ELSEIF(ZI.NE.Z0)THEN
C RZ=0 (EPAR 7)                    
                    EPAR(NEJ,5)=EPAR(NEJ,5)-VY/(ZI-Z0)
                    EPAR(NEJ,6)=EPAR(NEJ,6)+VX/(ZI-Z0)
                  ENDIF
               END SELECT
            ENDIF
         ENDDO
      ENDDO
C Dopocet prumernych uhlovych rychlosti castic
      DO IE=NE+1,NE+NPART
        N=FLOOR(EPAR(IE,1))
        IF(N.GE.1)THEN
           DO J=5,7
             EPAR(IE,J)=EPAR(IE,J)/N
           ENDDO
        ENDIF
      ENDDO
C 
C Posun castic dle vypoctenych translacnich rychlosti za cas DTIME
C
      DO IE=NE+1,NE+NPART
        N=FLOOR(EPAR(IE,1))
        IF(N.GE.1)THEN           
           L0=LUE(IE)           
           INP=IABS(IUE(L0+1))
           XX(INP)=EPAR(IE,8)+DTIME*EPAR(IE,2)
           YY(INP)=EPAR(IE,9)+DTIME*EPAR(IE,3)
           ZZ(INP)=EPAR(IE,10)+DTIME*EPAR(IE,4)
        ENDIF
      ENDDO
C
C Chybi analyza kolizi novych poloh castic a eventualni korekce. 
C Jsou alespon dve moznosti: 1. Vygenerovat objemove sily v uzlech, ktere
C lezi uvnitr kolidujicich castic, nebo 2. pouzit model pruzin a vazkych 
C tlumicu (asi ne setrvacnych hmot) a korigovat vypoctene polohy castic.
C
      WRITE(2,*)' Transfer of particles velocities begins'
C            
C Prenos vypoctenych rychlosti castice VX,VY,VZ do uzlu konecnych elementu
C
      DO IND=1,ND
         DO J=1,NPART
            NEJ=NE+J
            LEGRP=MAX0(1,IGROUP(NEJ))
            NAMELE=JGROUP(LEGRP,$ENAME)
            CALL NDINPART(IND,J,NAMELE,INSIDE)
            IF(INSIDE)THEN
               L0=LUE(IE)           
               INP=IABS(IUE(L0+1))
               SELECT CASE(NAMELE)
               CASE($CYLINDER)
                  X0=XX(INP)
                  Y0=YY(INP)
                  XI=XX(IND)
                  YI=YY(IND)
                  RZ=EPAR(NEJ,7)
                  VX0=EPAR(NEJ,2)
                  VY0=EPAR(NEJ,3)
                  VAL(LPU($VX)+IND,3)=VX0-(YI-Y0)*RZ
                  VAL(LPU($VY)+IND,3)=VY0+(XI-X0)*RZ
               CASE($SPHERE)
                  X0=XX(INP)
                  Y0=YY(INP)
                  Z0=ZZ(INP)
                  XI=XX(IND)
                  YI=YY(IND)
                  ZI=ZZ(IND)
                  RX=EPAR(NEJ,5)
                  RY=EPAR(NEJ,6)
                  RZ=EPAR(NEJ,7)
                  VX0=EPAR(NEJ,2)
                  VY0=EPAR(NEJ,3)
                  VZ0=EPAR(NEJ,4)
                  VAL(LPU($VX)+IND,3)=VX0+(ZI-Z0)*RY-(YI-Y0)*RZ
                  VAL(LPU($VY)+IND,3)=VY0-(ZI-Z0)*RX+(XI-X0)*RZ
                  VAL(LPU($VZ)+IND,3)=VZ0+(YI-Y0)*RX-(XI-X0)*RY
               ENDSELECT
            ENDIF
         ENDDO
      ENDDO
      END

      SUBROUTINE NDINPART(IND,J,NAMELE,INSIDE)
C Zjisteni zda uzel IND jezi uvnitr castice J (typ castice NAMELE je bud
C $SPHERE nebo $CYLINDER)
      INCLUDE '$FEMB'
      LOGICAL INSIDE
      INSIDE=.FALSE.
      IE=NE+J
      L0=LUE(IE)
      INP=IABS(IUE(L0+1))
      LRCON=MAX0(1,IRCONS(IE))
      SELECT CASE(NAMELE)
      CASE($SPHERE)
        X0=XX(INP)
        Y0=YY(INP)
        Z0=ZZ(INP)
        R=RRCONS(LRCON,$D)/2.
        IF((XX(IND)-X0)**2+(YY(IND)-Y0)**2+(ZZ(IND)-Z0)**2.LE.R**2)THEN
           INSIDE=.TRUE.
        ELSE
           INSIDE=.FALSE.
        ENDIF
      CASE($CYLINDER)
        X0=XX(INP)
        Y0=YY(INP)
        R=RRCONS(LRCON,$D)/2.
        IF((XX(IND)-X0)**2+(YY(IND)-Y0)**2.LE.R**2)THEN
           INSIDE=.TRUE.
        ELSE
           INSIDE=.FALSE.
        ENDIF
      ENDSELECT
      END

