      SUBROUTINE WRNOD(IUN)
      INCLUDE '$FEM'
C     Nazvy DOF odvozeny od prvniho uzloveho bodu
      WRITE(IUN,131)PROBLEM,
     /                  ND,NDOF,(TDOF(JPU(J)),J=1,MDOF)
131   FORMAT(1X,A/2I7,' (Number of nodes, DOF-active)'/
     /      ' Node      X          Y          Z      ',
     /22('  IPU_____',A))
      DO I=1,ND
         WRITE(IUN,'(I6,3E11.3,2X,22(I3,E11.3))')
     /        I,XX(I),YY(I),ZZ(I),
     /        (IPU(MAXND*(J-1)+I),VAL(MAXND*(J-1)+I,3),J=1,MDOF)
      ENDDO
      WRITE(10,'('' Writing'',i7,'' nodes completed''\)')ND
      END

      SUBROUTINE WRELE(IUN)
      INCLUDE '$FEM'
      WRITE(IUN,132)PROBLEM,NE
132   FORMAT(1X,A/I5,' (Number of elements)'/
     /' Elem. Eg  Mp  Rc  Nue   N1    N2    N3    N4    N5    N6    N7  
     /  N8    N9   N10   N11   N12   N13   N14   N15   N16   N17   N18  
     / N19   N20')
      DO I=1,NE
         L0=LUE(I)
         WRITE(IUN,'(I5,4I4,8I6)')I,IGROUP(I),IMPROP(I),
     /             IRCONS(I),MUE(I),(IUE(L0+J),J=1,IABS(MUE(I)))
      ENDDO
      WRITE(10,'('' Writing'',i7,'' elements completed''\)')NE
      END

      SUBROUTINE WREGROUP(IUN)
      INCLUDE '$FEM'
      WRITE(IUN,133)PROBLEM,TANAL(KANAL),MGROUP,MRCONS,MMPROP
133   FORMAT(1X,A,5X,A/3I5,' (Number of E-groups, RConst, MP)')
      WRITE(IUN,134) (TGROUP(J),J=1,MAXNGROUP)
134   FORMAT(/' E-group  ',20(X,A4))
      DO I=1,MGROUP
         WRITE(IUN,135)I,(JGROUP(I,J),J=1,MAXNGROUP)
135      FORMAT(I8,X,20I5)
      ENDDO
      WRITE(IUN,136) (TRCONS(J),J=1,MAXNRCONS)
136   FORMAT(/' RC-group ',30(7X,A4))
      DO I=1,MRCONS
         WRITE(IUN,137)I,(RRCONS(I,J),J=1,MAXNRCONS)
137      FORMAT(I8,2X,30E11.3)
      ENDDO
      WRITE(IUN,138) (TMPROP(J),J=1,MAXNMPROP)
138   FORMAT(/' MP-group ',30(3X,A8))
      DO I=1,MMPROP
         WRITE(IUN,139)I,(RMPROP(I,J),J=1,MAXNMPROP)
139      FORMAT(I8,2X,30E11.3)
         WRITE(IUN,140)(JMPROP(I,J),J=1,MAXNMPROP)
140      FORMAT(10X,30I11)
      ENDDO
CWRITE       List of functions and tables
      WRITE(IUN,'(/'' Index_RPN_Function'')')
      DO J=MIFUN,MAFUN
         IFF=INDFUN(J)
         IF(IFF.GT.0)THEN
            WRITE(IUN,'(I6.2,I6.3,'' : '',A)')
     /               J,MRPN(IFF),FUNTXT(IFF)
         ELSEIF(IFF.LT.0)THEN
            WRITE(IUN,'(I6.2,I6.3,'' table'')')J,MTPT(-IFF)
         ENDIF
      ENDDO
      WRITE(10,'('' Writing'',i3,''-Eg,'',i3,''-RC'',i3,''-MP and list o
     /f functs completed''\)')MGROUP,MRCONS,MMPROP
      END
    
      SUBROUTINE WREPAR(IUN)
C
C Zapis matice parametru elementu na zarizeni IUN. Ponekud problematicke je to,
C ze kazdy element muze mit ruzny pocet parametru (je to dano typem elementu).
C Hlavicku sestrojime dle prvniho elementu.
C
      INCLUDE '$FEMB'
      NAMELE=JGROUP(IGROUP(1),$ENAME)
      WRITE(IUN,'(/i7,'' -auxilliary parameters of elements'')')NE
      WRITE(IUN,'(/'' Index  '',20(A8,4X))')
     /    (TEPAR(JEPAR(NAMELE,I)),I=1,NEPAR(NAMELE))
      DO I=1,NE
         NAMELE=JGROUP(IGROUP(I),$ENAME)
         WRITE(IUN,'(I6,1X\)')I
         DO I1=1,NEPAR(NAMELE)
           IF(JEPAR(NAMELE,I1).NE.$EE1.AND.JEPAR(NAMELE,I1).NE.$EE2)THEN
                WRITE(IUN,'(E11.3,1X\)')EPAR(I,I1)
           ELSE
                WRITE(IUN,'(I11,1X\)')IEPAR(I,I1)
           ENDIF
         ENDDO
         WRITE(IUN,'(1X)')
      ENDDO 
      WRITE(10,'('' Writing parameters of'',i6,''-elements completed''\)
     /')NE
      END

      SUBROUTINE WPCS(IUN)
      INCLUDE '$FEM'
      WRITE(IUN,1)PROBLEM
1     FORMAT(1X,A)
      WRITE(IUN,2)NPT,(J,PTX(J),PTY(J),PTZ(J),J=1,NPT)
2     FORMAT(/I6,' NPT (No. of points)'/' Index       X           Y      
     /    Z'/(i6,3e11.3))
      WRITE(IUN,3)NCR
3     FORMAT(/I6,' NCR (No. of curves)'/' Index  NPTs PT1   PT2   PT3')
      DO I=1,NCR
        WRITE(IUN,4)I,MCR(I),(ICR(J,I),J=1,MCR(I))
4       FORMAT(2I5,20I6)
      ENDDO
      WRITE(IUN,5)NSF
5     FORMAT(/I6,' NSF (No. of surfaces)'/' Index  NPTs PT1   PT2   PT3 
     /  PT4   PT5   PT6   PT7   PT8')
      DO I=1,NSF
        WRITE(IUN,4)I,MSF(I),(ISF(J,I),J=1,MSF(I))
      ENDDO
      WRITE(IUN,6)NVL
6     FORMAT(/I6,' NVL (No. of volumes)'/' Index  NPTs PT1   PT2   PT3  
     / PT4  PT5   PT6   PT7   PT8   PT9  PT10  PT11  PT12  PT13  PT14  P
     /T15  PT16  PT17  PT18  PT19  PT20')
      DO I=1,NVL
        WRITE(IUN,4)I,MVL(I),(IVL(J,I),J=1,MVL(I))
      ENDDO
      END

      SUBROUTINE WRDAT(IUN)
C
C Zapis matice bodu pozorovani na zarizeni IUN
C
      INCLUDE '$FEM'
      WRITE(IUN,'(''   Row'',10(4X,A8))')
     /(TTC(MAX0(1,IQGR(I)+1)),I=1,MAXSEL)
      WRITE(IUN,'(4X,10I12)')(IQGR(I),I=1,MAXSEL)
      DO IG=1,NGR
         WRITE(IUN,'(I6,10E12.4)')IG,(YGR(IG,I),I=1,MAXSEL)
      ENDDO
      WRITE(10,'('' Writing'',I7,''-observation points completed''\)')NG
     /R
      END

      SUBROUTINE WRTC(IUN,I)
C
C WRITE TC  - vypis krivky cislo I na zarizeni IUN (musi byt otevreno)
C
      INCLUDE '$FEM'
      WRITE(IUN,'(I4,''(Number of points)'')')
     /          NGR
      DO J=1,NGR
c         WRITE(IUN,'(i5,2e12.4)')J,YGR(J,1),YGR(J,I)
         WRITE(IUN,'(2e12.4)')YGR(J,1),YGR(J,I)
      ENDDO
      WRITE(10,'('' Writing'',i5,'' points of TC-curve'',i2,'' completed
     /''\)')NGR,I
      END

      SUBROUTINE RENOD(IUN)
C
C Cteni uzlovych bodu
C
      INCLUDE '$FEM'
      READ(IUN,*,END=9999,ERR=1)ND
C
C Auxilliary format
C 1.  nd
C 2.  x1,y1,z1,v1
C 3.  x2,y2,z2,v2
C    ....
C
      IF(ND.GT.0.AND.ND.LE.MAXND)THEN
         DO I=1,ND
            READ(IUN,*,ERR=9999,END=9999)XX(I),YY(I),ZZ(I),VAL(I,3)
         ENDDO
         WRITE(10,'('' Reading'',i7,'' nodes in simplified format comple
     /ted''\)')ND
         RETURN   
      ENDIF
C  
C FEMINA format
C
1     READ(IUN,*,END=9999,ERR=9999)ND
      READ(IUN,*,END=9999)
      IF(ND.GT.0.AND.ND.LE.MAXND)THEN
        DO I=1,ND
           READ(IUN,*,END=9999,ERR=9999)
     /          IDUMMY,XX(I),YY(I),ZZ(I),
     /          (IPU(MAXND*(J-1)+I),VAL(MAXND*(J-1)+I,3),J=1,MDOF)
        ENDDO
        WRITE(10,'('' Reading'',i7,'' nodes completed''\)')ND
      ENDIF
      RETURN
9999  CALL HELPC(4,'Incompatible format for NODEs.')
      END

      SUBROUTINE RELE(IUN)
C
C READ elementy
C
      INCLUDE '$FEM'
      READ(IUN,*,END=999)
      READ(IUN,*,END=999,ERR=999)NE
      READ(IUN,*,END=999)
      IF(NE.GT.0.AND.NE.LE.MAXEL)THEN
        LUE(1)=0
        DO I=1,NE
          L0=LUE(I)
          READ(IUN,*,END=999,ERR=999)IDUMMY,IGROUP(I),IMPROP(I),
     /             IRCONS(I),MUE(I),(IUE(L0+J),J=1,IABS(MUE(I)))
          LUE(I+1)=LUE(I)+MUE(I)
        ENDDO
      ENDIF
      WRITE(10,'('' Reading'',i7,'' elements completed''\)')NE
      RETURN
999   CALL HELPC(4,'Incompatible format for ELEMENTs')
      END

      SUBROUTINE REGROUP(IUN)
      INCLUDE '$FEM'
CREAD groups
      READ(IUN,*,END=999)
      READ(IUN,*,END=999,ERR=999)MGROUP,MRCONS,MMPROP
      READ(IUN,*,END=999)
      READ(IUN,*,END=999)
      DO I=1,MGROUP
         READ(IUN,*,END=999,ERR=999)IDUMMY,(JGROUP(I,J),J=1,MAXNGROUP)
      ENDDO
      READ(IUN,*,END=999)
      READ(IUN,*,END=999)
      DO I=1,MRCONS
         READ(IUN,*,END=999,ERR=999)IDU,(RRCONS(I,J),J=1,MAXNRCONS)
      ENDDO
      READ(IUN,*,END=999)
      READ(IUN,*,END=999)
      DO I=1,MMPROP
         READ(IUN,*,END=999,ERR=999)Idum,(RMPROP(I,J),J=1,MAXNMPROP)
         READ(IUN,*,END=999,ERR=999)     (JMPROP(I,J),J=1,MAXNMPROP)
      ENDDO
C     List of functions and tables ommited
      READ(IUN,*,END=999)
      READ(IUN,*,END=999)
      WRITE(10,'('' Reading'',i3,''-Eg,'',i3,''-RC'',i3,''-MP groups com
     /pleted''\)')MGROUP,MRCONS,MMPROP
      RETURN
999   CALL HELPC(4,'Incompatible format for GROUPs')
      END

      SUBROUTINE RELPAR(IUN)
      INCLUDE '$FEMB'
CREAD Parametry elementu
      READ(IUN,*,END=999,ERR=999)
      READ(IUN,*,END=999,ERR=999)NE
      READ(IUN,*,END=999,ERR=999)
      READ(IUN,*,END=999,ERR=999)
      DO I=1,NE
        NAMELE=JGROUP(IGROUP(I),$ENAME)
        READ(IUN,*,END=999,ERR=999)Idum,(EPAR(I,J),J=1,NEPAR(NAMELE))
C Kontrola toho, zda nebylo zadano cele cislo elementu
        DO I1=1,NEPAR(NAMELE)
         IF(JEPAR(NAMELE,I1).NE.$EE1.AND.JEPAR(NAMELE,I1).NE.$EE2)
     /             IEPAR(I,I1)=EPAR(I,I1)
        ENDDO
      ENDDO 
      WRITE(10,'('' Reading parameters of'',i6,''-elements completed''\)
     /')NE
      RETURN
999   CALL HELPC(4,'Incompatible format for E-PARAMETERs')
      END

      SUBROUTINE RPCS(IUN)
C Cteni dat POINT, CURVE, SURFACE, VOLUME ve formatu PCS
      INCLUDE '$FEM'
      INTEGER RETINT
      CHARACTER*6 LINE
	CHARACTER*1 CH
      READ(IUN,*,END=999,ERR=999)
      READ(IUN,*,END=999,ERR=999)NPT
      READ(IUN,'(A)',END=999,ERR=999)LINE
      IF(LINE.NE.' Index')GOTO 999
	write(9,'('' Read x,y,z of'',i6,'' points'')')NPT
	do j=1,npt
      READ(IUN,*,END=999,ERR=999)JDUM,PTX(J),PTY(J),PTZ(J)
	write(9,'(i6,3e12.4)')JDUM,PTX(J),PTY(J),PTZ(J)
	enddo
	WRITE(10,'('' read '',i6,'' X,Y,Z points correctly'')')NPT
      READ(IUN,*,END=999,ERR=999)
      READ(IUN,*,END=999,ERR=999)NCR
      READ(IUN,*,END=999,ERR=999)
	DO I=1,NCR
        READ(IUN,*,END=999,ERR=999)IDUMMY,MCR(I),(ICR(J,I),J=1,MCR(I))
	  write(9,'(6i6)')IDUMMY,MCR(I),(ICR(J,I),J=1,MCR(I))
      ENDDO
	WRITE(10,'('' read '',i4,'' curves correctly'')')NCR
      READ(IUN,*,END=999,ERR=999)
      READ(IUN,*,END=999,ERR=999)NSF
      READ(IUN,*,END=999,ERR=999)
      DO I=1,NSF
        READ(IUN,*,END=999,ERR=999)IDUMMY,MSF(I),(ISF(J,I),J=1,MSF(I))
      ENDDO
      READ(IUN,*,END=999,ERR=999)
      READ(IUN,*,END=999,ERR=999)NVL
      READ(IUN,*,END=999,ERR=999)
      DO I=1,NVL
        READ(IUN,*,END=999,ERR=999)IDUMMY,MVL(I),(IVL(J,I),J=1,MVL(I))
      ENDDO
      WRITE(10,'('' Reading geometry completed''\)')
      RETURN
999   CALL HELPC(4,'Incompatible format for Point_Curve_Surfaces')
      WRITE(10,'('' Data are not in the standard PCS format. It is possi
     /ble''/''    1-read points in free format: ipt x y z (one line for 
     /each point)''/''    2-read lines (CR) in free format: icr ipt1 ipt
     /2''/'' Any other number quits the operation. Please, specify numbe
     /r 0,1, or 2...'')')
C      READ(10,*,IOSTAT=RETINT)IPCFORM
C	CALL GC(CH,ICH)
	CALL GC(CH,ICH)
      SELECT CASE (CH)
      CASE('1')
         WRITE(10,'('' Reading points from unit'',i3)')IUN
         REWIND(IUN)
         CALL HELPC(4,'Read coordinates of selected POINTs I,X,Y,Z in fr
     /ee format')
1        READ(IUN,*,END=888,ERR=888)IPT,XXP,YYP,ZZP
         IF(IPT.GT.0.AND.IPT.LE.MAXPT)THEN
            PTX(IPT)=XXP         
            PTY(IPT)=YYP         
            PTZ(IPT)=ZZP         
            NPT=MAX0(NPT,IPT)
            WRITE(10,'(''  reading key-point'',i5)')IPT
            GOTO 1
         ENDIF
      CASE('2')
         CALL HELPC(4,'Read selected CURVES I,IP1,IP2 in free format')
         REWIND(IUN)
2        READ(IUN,*,END=888,ERR=888)IC,IPT1,IPT2
         IF(IC.GT.0.AND.IC.LE.MAXCR)THEN
            MCR(IC)=2
            ICR(1,IC)=IPT1
            ICR(2,IC)=IPT2
            NCR=MAX0(NCR,IC)
            WRITE(10,'(''  reading line CR'',i5)')IC
            GOTO 2
         ENDIF
      ENDSELECT
888   REWIND(IUN)
      END

      SUBROUTINE REDAT(IUN)
      INCLUDE '$FEM'
CREAD observation points
      READ(IUN,*,END=999)
      READ(IUN,*,ERR=999,END=999)(IQGR(I),I=1,MAXSEL)
      IG=1
      DO WHILE(IG.LE.MAXNTS)
         READ(IUN,*,END=777,ERR=999)IDUMMY,(YGR(IG,I),I=1,MAXSEL)
         IG=IG+1
      ENDDO
777   NGR=IG-1
      IF(NGR.GT.1.AND.YGR(NGR,1).GT.YGR(1,1))THEN
          DTIME=(YGR(NGR,1)-YGR(1,1))/(NGR-1)
          NTSTEP=NGR
          CALL GRANGE(2,0,0,XMI,XMA,YMI,YMA)
          CALL GRAPUT(2,XMI,XMA,YMI,YMA)
      ENDIF
      WRITE(10,'('' Reading'',i6,''-rows of observation matrix completed
     /''\)')NGR
      RETURN
999   CALL HELPC(4,'Incompatible data for OBSERVATION MATRIX')
      END

      SUBROUTINE READCO(IUN,ICDAT,ICYGR,NCOL,IHEAD,IFIRST)
C
C READ COLUMN cteni dat ze souboru IUN
C ICDAT - sloupec dat ve vstupnim souboru (prvni)
C ICYGR - sloupec matice bodu pozorovani (prvni)
C NCOL  - pocet prenasenych sloupcu
C IHEAD - radek, kde jsou hlavicky sloupcu, ktere se priradi vektoru TTC
C         v zone FEM (uzivatelske typy 11-tym prvkem TTC pocinaje)
C IFIRST- prvni radek numerickych dat
C
      INCLUDE '$FEM'
      CHARACTER*256 LINE
      LOGICAL SPACE
C Cteni hlavicky souboru kdyz IHEAD>0 a IHEAD<IFIRST
C sloupecky dat ICDAT,ICDAT+1,... se ukladaji do sloupcu matice YGR
C               ICYGR,ICYGR+1,...,ICYGR+NCOL-1
C
      DO I=1,IFIRST-1
         IF(IHEAD.EQ.I)THEN
            READ(IUN,'(A)',END=999,ERR=999)LINE
            SPACE=.TRUE.
            NCDAT=0
            NTCC=10
            DO J=1,256
              IF(LINE(J:J).EQ.' ')THEN
                 SPACE=.TRUE.
              ELSE
                 IF(SPACE)THEN
                   NCDAT=NCDAT+1
                   NCYGR=NCDAT+ICYGR-ICDAT
                   IF(NCDAT.GE.ICDAT.AND.NCDAT.LT.ICDAT+NCOL.AND.
     /                NCYGR.GE.1.AND.NCYGR.LE.MAXSEL)THEN
                      NTCC=MIN0(20,NTCC+1)
                      IQGR(NCYGR)=NTCC-1
                      NCH=1
                      TTC(NTCC)='        '
                      TTC(NTCC)(1:1)=LINE(J:J)
                   ELSE
                      NCH=0
                   ENDIF
                 ELSEIF(NCH.GT.0)THEN
                   NCH=MIN0(NCH+1,8)
                   TTC(NTCC)(NCH:NCH)=LINE(J:J)
                 ENDIF
                 SPACE=.FALSE.
              ENDIF
            ENDDO
         ELSE
            READ(IUN,*,END=999,ERR=999)
         ENDIF
      ENDDO
      IF(ICYGR.GT.MAXSEL)GOTO999
      DO I=1,MAXNTS
         READ(IUN,'(A)',END=998,ERR=999)LINE
         ICARKA=INDEX(LINE,',')
         DO WHILE(ICARKA.GT.0)
            LINE(ICARKA:ICARKA)='.'
            ICARKA=INDEX(LINE,',')
         ENDDO
         J0=0
         NCDAT=0
         DO J=1,MAXSEL
            CALL TAKERD(LINE,256,J0,WESULT,J0)
            IF(J0.LE.0)GOTO 996
            NCDAT=NCDAT+1
            NCYGR=NCDAT+ICYGR-ICDAT
            IF(NCDAT.GE.ICDAT.AND.NCDAT.LT.ICDAT+NCOL.AND.
     /         NCYGR.GE.1.AND.NCYGR.LE.MAXSEL)THEN
               YGR(I,NCYGR)=WESULT
               IF(I.EQ.1)THEN
                  FILEXPERI(NCYGR)=FILEDAT
                  IF(IHEAD.LE.0)IQGR(NCYGR)=3
               ENDIF
            ENDIF
         ENDDO
996      CONTINUE
      ENDDO
998   WRITE(10,'('' Reading'',i4,'' points into'',I2,'' curve done''\)')
     /               I-1,ICYGR
      NGR=MAX0(NGR,I-1)
      RETURN
999   WRITE(10,'('' Unable read data, point:'',I5)')I
      END

      SUBROUTINE REOMAT(IUN,ICDAT,ICYGR,NCOL,IHEAD,IFIRST)
C
C READ COLUMN cteni dat ze souboru IUN
C ICDAT(NCOL) - vektor sloupcu dat ve vstupnim souboru 
C ICYGR(NCOL) - vektor sloupcu matice bodu pozorovani 
C NCOL  - pocet prenasenych sloupcu
C IHEAD - radek, kde jsou hlavicky sloupcu, ktere se priradi vektoru TTC
C         v zone FEM (uzivatelske typy 11-tym prvkem TTC pocinaje)
C IFIRST- prvni radek numerickych dat
C
      INCLUDE '$FEM'
      CHARACTER*256 LINE
      INTEGER ICDAT(*),ICYGR(*)
      LOGICAL SPACE
C Cteni hlavicky souboru kdyz IHEAD>0 a IHEAD<IFIRST
C sloupecky dat ICDAT(1),ICDAT(2),... se ukladaji do sloupcu matice YGR
C               ICYGR(1),ICYGR(2),...,ICYGR(NCOL)
C
      DO I=1,IFIRST-1
         IF(IHEAD.EQ.I)THEN
            READ(IUN,'(A)',END=999,ERR=999)LINE
            CALL LINETAB(LINE,256)
            SPACE=.TRUE.
            NCDAT=0
            NTCC=10
            DO J=1,256
              IF(LINE(J:J).EQ.' ')THEN
                 SPACE=.TRUE.
              ELSE
                 IF(SPACE)THEN
                   NCDAT=NCDAT+1
                   DO K=1,NCOL
                     IF(NCDAT.EQ.ICDAT(K))THEN
                       NTCC=MIN0(20,NTCC+1)
                       IQGR(ICYGR(K))=NTCC-1
                       NCH=1
                       TTC(NTCC)='        '
                       TTC(NTCC)(1:1)=LINE(J:J)
                       EXIT
                     ELSE
                       NCH=0
                     ENDIF
                   ENDDO
                 ELSEIF(NCH.GT.0)THEN
                   NCH=MIN0(NCH+1,8)
                   TTC(NTCC)(NCH:NCH)=LINE(J:J)
                 ENDIF
                 SPACE=.FALSE.
              ENDIF
            ENDDO
         ELSE
            READ(IUN,*,END=999,ERR=999)
         ENDIF
      ENDDO
      DO I=1,MAXNTS
         READ(IUN,'(A)',END=998,ERR=999)LINE
         CALL LINETAB(LINE,256)
         ICARKA=INDEX(LINE,',')
         DO WHILE(ICARKA.GT.0)
            LINE(ICARKA:ICARKA)='.'
            ICARKA=INDEX(LINE,',')
         ENDDO
         J0=0
         NCDAT=0
         DO J=1,MAXSEL
            CALL TAKERD(LINE,256,J0,WESULT,J0)
            IF(J0.LE.0)GOTO 996
            NCDAT=NCDAT+1
            DO K=1,NCOL
               IF(NCDAT.EQ.ICDAT(K))THEN
                  YGR(I,ICYGR(K))=WESULT
                  IF(I.EQ.1)THEN
                     FILEXPERI(ICYGR(K))=FILEDAT
C IQGR - typ dat (=1-time,=2-FEM,=3-experiment,=4-vstup modelu,...)
                     IQGR(ICYGR(K))=3
c                    IF(IHEAD.LE.0)IQGR(ICYGR(K))=3
                  ENDIF
               ENDIF
            ENDDO
         ENDDO
996      CONTINUE
      ENDDO
998   CONTINUE
      WRITE(10,'('' Reading'',i4,'' points done.'')')
     /               I-1
C      NGR=MAX0(NGR,I-1)
      NGR=MAX0(1,I-1)
      IF(NGR.GE.2)THEN
         NTSTEP=NGR
         DTIME=(YGR(NTSTEP,1)-YGR(1,1))/(NTSTEP-1)
      ENDIF
      RETURN
999   CONTINUE
      WRITE(10,'('' Unable read data, point:'',I5)')I
      END

      SUBROUTINE READTC(IUN,ITDAT,ICDAT,ICYGR,IFIRST)
C
C READ COLUMN ze zarizeni IUN
C ITDAT - sloupec dat obsahujici cas
C ICDAT - sloupec dat obsahujici hodnotu
C ICYGR - sloupec matice bodu pozorovani
C IFIRST- prvni radek dat v souboru
C
      INCLUDE '$FEM'
      CHARACTER*256 LINE
      IF(ITDAT.LE.0.OR.ICDAT.LE.0.OR.
     /   ICYGR.LE.0.OR.ICYGR.GT.MAXSEL.OR.NGR.LE.1)GOTO999
      NROWS=0
      DO WHILE(NROWS.LT.1000000)
        READ(IUN,*,END=100)
        NROWS=NROWS+1
      ENDDO
100   REWIND IUN
      DO I=1,IFIRST-1
         READ(IUN,*,END=999,ERR=999)
      ENDDO
C Vetveni algoritmu dle poctu prectenych dat
      IF(NROWS.GT.2*NGR)THEN
         WRITE(10,'('' N-data rows='',i6,'' is greater than'',i5,'', the
     /refore summing algorithm'')')NROWS,NGR
         NROWS=0
         NROWC=1
         SUMA=0.
         NSUM=0.
         TOLD=0.
         TNEW=YGR(2,1)
         DO WHILE(NROWC.LT.NGR)
C Cteni dvojice dat t0,r0
            READ(IUN,'(A)',END=998,ERR=999)LINE
            CALL LINETAB(LINE,256)
            NROWS=NROWS+1
            J0=0
            MAXCOL=MAX0(ICDAT,ITDAT)
            DO J=1,MAXCOL
               CALL TAKERD(LINE,256,J0,RES,J0)
               IF(J0.LT.0)GOTO 999
               IF(J.EQ.ITDAT)T0=RES
               IF(J.EQ.ICDAT)R0=RES
            ENDDO
            IF(T0.GT.TOLD.AND.T0.LT.TNEW)THEN
              SUMA=SUMA+R0
              NSUM=NSUM+1
            ELSE
              YGR(NROWC,ICYGR)=SUMA/MAX0(1,NSUM)
              SUMA=0
              NSUM=0
              TOLD=TNEW
              NROWC=NROWC+1
              TNEW=YGR(NROWC,1)
            ENDIF
         ENDDO
      ELSE
         WRITE(10,'('' N-data rows='',i6,'' is not so big, therefore reg
     /ression interpolation is activated'')')NROWS
         T1=0
         R1=0
         T2=0
         R2=0
         T3=0
         R3=0
         NROWS=0
         DO WHILE(.TRUE.)
C Cteni ctverice dat t0,r0, t1,r1, t2,r2 t3,r3 pro kvadratickou regresni interpolaci
            READ(IUN,'(A)',END=998,ERR=999)LINE
            CALL LINETAB(LINE,256)
            NROWS=NROWS+1
C Shift trojice hodnot
            T0=T1
            R0=R1
            T1=T2
            R1=R2
            T2=T3
            R2=R3
            J0=0
            MAXCOL=MAX0(ICDAT,ITDAT)
            DO J=1,MAXCOL
               CALL TAKERD(LINE,256,J0,RES,J0)
               IF(J0.LT.0)GOTO 999
               IF(J.EQ.ITDAT)T3=RES
               IF(J.EQ.ICDAT)R3=RES
            ENDDO
C nalezeni bodu v tabulce, ktere jsou mezi hodnotami T1,T3
            DO I=1,NGR
               T=YGR(I,1)
               IF(T.GE.T1.AND.T.LE.T3)THEN
C 
                  TT0=T0-T1
                  TT2=T2-T1
                  TT3=T3-T1
                  IF(TT2.NE.0.)THEN
                     A1=(R0-R1-(R2-R1)*TT0/TT2)*(TT2*TT0-TT0**2)+
     /                  (R3-R1-(R2-R1)*TT3/TT2)*(TT2*TT3-TT3**2)
                     A2=(TT2*TT0-TT0**2)**2+(TT2*TT3-TT3**2)**2
                     C=-A1/A2
                     B=(R2-R1)/TT2-C*TT2
                     YGR(I,ICYGR)=R1+B*(T-T1)+C*(T-T1)**2
                  ELSE
                     YGR(I,ICYGR)=R2
                  ENDIF
               ENDIF
               IF(T.GT.T3)EXIT
            ENDDO
         ENDDO
      ENDIF
998   WRITE(10,'('' Reading'',i6,''-rows into'',I2,'' curve done''\)')
     /               NROWS,ICYGR
C IQGR Typ sloupce - experimentalni data
      IQGR(ICYGR)=3
      FILEXPERI(ICYGR)=FILEDAT
      RETURN
999   WRITE(10,'('' Unable interpolate data into observation matrix havi
     /ng'',I5,''-rows.'')')NGR
      END

      SUBROUTINE READCOSM(IUNIT)
C
C Import dat MODFILE (COSMOS) souradnice uzlu a matice konektivity
C
      INCLUDE '$FEM'
      CHARACTER*256 LINE
      ND=0
      NE=0
1     READ(IUNIT,'(A)',END=999)LINE
      IF(LINE(1:3).EQ.' N,')THEN
          CALL TAKISD(LINE,256,3,ND,J)
          IF(ND.GE.1.AND.ND.LE.MAXND)THEN
              CALL TAKERD(LINE,256,J+1,XX(ND),J)
              CALL TAKERD(LINE,256,J,YY(ND),J)
              CALL TAKERD(LINE,256,J,ZZ(ND),J)
          ENDIF
      ELSEIF(LINE(1:3).EQ.' E,')THEN
          CALL TAKISD(LINE,256,3,NE,J)
          IF(NE.GE.1.AND.NE.LE.MAXEL)THEN
              L0=LUE(NE)
              M=0
              CALL TAKISD(LINE,256,J+1,I,J)
              DO WHILE(J.GT.0)
                 M=M+1
                 IUE(L0+M)=I
                 CALL TAKISD(LINE,256,J+1,I,J)
              ENDDO
              LUE(NE+1)=L0+M
              MUE(NE)=M                               
              IGROUP(NE)=IGR
              IRCONS(NE)=IRC
              IMPROP(NE)=IMAT
          ENDIF
      ELSEIF(LINE(9:13).EQ.'GROUP')THEN
          CALL TAKIS(LINE,256,13,IGR,J)
      ELSEIF(LINE(9:11).EQ.'MAT')THEN
          CALL TAKIS(LINE,256,12,IMAT,J)
      ELSEIF(LINE(9:12).EQ.'REAL')THEN
          CALL TAKIS(LINE,256,13,IRC,J)
      ENDIF
      GOTO 1
999   END

      SUBROUTINE READPATR(IUNIT)
C
C Import PATRAN NEUTRAL file (FLUENT) souradnice uzlu a matice konektivity
C
      INCLUDE '$FEMB'
      CHARACTER*256 LINE
      ND=0
      NE=0
10    READ(IUNIT,'(A)',END=999)LINE
      IF(LINE(1:2).NE.'26')GOTO 10
      READ(IUNIT,'(A)',END=999)LINE
C COORDINATES X,Y,Z
20    READ(IUNIT,*,END=999)IZONE,INDEX
      IF(IZONE.NE.1)GOTO 29
      IF(INDEX.LE.0.OR.INDEX.GT.MAXND)RETURN
      ND=INDEX
      READ(IUNIT,'(3E16.9)',END=999)XX(ND),YY(ND),ZZ(ND)
      READ(IUNIT,'(A)',END=999)LINE
      IF(LINE(1:2).EQ.'1G')GOTO 20
29    WRITE(10,'('' X,Y,Z nodal coordinates read ('',i6,'' nodes)'')')ND
C ELEMENTS
30    IF(IZONE.NE.2)GOTO 40
      IF(INDEX.LE.0.OR.INDEX.GT.MAXEL)RETURN
      READ(IUNIT,*,END=999)NODEL,IDUMM,IZON
      IF(IZON.EQ.2)THEN
        NE=INDEX
        MUE(NE)=NODEL
        IGROUP(NE)=1
        IRCONS(NE)=1
        IMPROP(NE)=1
        L0=LUE(NE)
        READ(IUNIT,*,END=999)(IUE(L0+I),I=1,NODEL)
        LUE(NE+1)=L0+NODEL
        READ(IUNIT,*,END=999)IZONE,INDEX
        GOTO 30
      ENDIF
40    JGROUP(1,$ENAME)=$SOLID
      WRITE(10,'('' Connectivity matrix read ('',i6,'' elements)'')')NE
999   END

      SUBROUTINE READCONC(IUNIT,IDOF,IZONE)
C
C Import PATRAN RES file (FLUENT) vektor uzlovych parametru
C
      INCLUDE '$FEMB'
      CHARACTER*256 LINE
10    READ(IUNIT,'(A)',END=999)LINE
      READ(IUNIT,*,END=999)NNODES
      IF(NNODES.NE.ND)THEN
         WRITE(10,*)' Warning: No.of nodes',NNODES,' does not match',ND
         RETURN
      ELSEIF(IDOF.LE.0.OR.IZONE.LE.0.OR.IZONE.GT.4)THEN
         WRITE(10,*)' Warning: wrong DOF',IDOF,' or zone',IZONE
         RETURN
      ELSEIF(LPU(IDOF).LT.0)THEN
         WRITE(10,*)' Warning: undefined DOF (change kind of analysis)'
         RETURN
      ENDIF
      READ(IUNIT,'(A)',END=999)LINE
      READ(IUNIT,'(A)',END=999)LINE
      LP1=LPU(IDOF)
      DO I=1,ND
         READ(IUNIT,*,END=999)IND,VALUE
         IF(IND.GT.0.AND.IND.LE.ND)VAL(LP1+IND,IZONE)=VALUE
      ENDDO
      WRITE(10,'('' Nodal values read ('',i6,'') succesfully.'')')ND
      RETURN
999   WRITE(10,'('' EOF found when reading nodal values'')')
      END

      SUBROUTINE UNIFIL(FILEOUT,FILTEMP,NST,TD)
C
C Vytvoreni souboru FILE.OUT sjednocenim dat s Fluentovych souboru
C
      INCLUDE '$FEMB'
      CHARACTER*(*) FILEOUT,FILTEMP
      CHARACTER*256 LINE
      CHARACTER*20  FILA
      LOGICAL EXIST
      FILA=TRIM(FILEOUT)//'.OUT'
      OPEN(3,FILE=FILA)
      WRITE(3,'('' SOLVE '',A,'' ND='',I6)')PROBLEM,ND
      ICOUNT=0
      DO ITIME=1,NST
         CALL FILINUM(FILTEMP,ITIME)
         CALL FILEXIST(FILTEMP,EXIST)
         IF(EXIST)THEN
            ICOUNT=ICOUNT+1
            WRITE(3,'(E12.4,E15.2,7E10.3,'' (time,dtime,PowerE,PowerF,Po
     /werT,PowerC,PowerD,PowerA,PowerS)'')')
     /ITIME*TD,TD,(RALGOR(I),I=39,45)
            WRITE(3,'(6X,20(6X,A4))')(TDOF(JPU(J)),J=1,MDOF)
            OPEN(5,FILE=FILTEMP)
            READ(5,'(A)',END=999)LINE
            READ(5,*,END=999)NNODES
            READ(5,'(A)',END=999)LINE
            READ(5,'(A)',END=999)LINE
            DO I=1,NNODES
              READ(5,*,END=999)IND,VALUE
              WRITE(3,'(I6,20E10.3)')I,(VALUE,J=1,MDOF)
            ENDDO
         ENDIF
      ENDDO
      WRITE(10,'('' File formed from ('',i3,'') FLUENT files.'')')ICOUNT
999   CLOSE(3)
      CLOSE(5)
      END

      SUBROUTINE FILINUM(FILE,NUMBER)
C
C Vloz cislo NUMBER do textu FILE pred tecku.
C
      CHARACTER*(*) FILE
      IDOT=INDEX(FILE,'.')
      IF(IDOT.GT.1)THEN
        IF(NUMBER.LE.9)THEN
          WRITE(FILE(IDOT-1:IDOT-1),'(I1)')NUMBER
        ELSEIF(NUMBER.LE.99.AND.IDOT.GT.2)THEN
          WRITE(FILE(IDOT-2:IDOT-1),'(I2)')NUMBER
        ELSEIF(NUMBER.LE.999.AND.IDOT.GT.3)THEN
          WRITE(FILE(IDOT-3:IDOT-1),'(I3)')NUMBER
        ELSEIF(NUMBER.LE.9999.AND.IDOT.GT.4)THEN
          WRITE(FILE(IDOT-4:IDOT-1),'(I4)')NUMBER
        ELSE
          WRITE(10,*)' Unable to create filename'
        ENDIF
      ENDIF
      END

      SUBROUTINE FOPEN(IUNIT,FILENAM)
C
C OPEN(IUNIT,file=FILENAM)
C IUNIT, FILENAM jsou vstupni parametry
C Pokud se to nepodari, pouzije se dialogove okno pro vyber souboru.
C
C FILENAM muze byt jen "jmeno.pripona" nebo ".\FILES\jmeno.pripona"
C Dokonce i kdyz je uvedeno jen "jmeno.pripona" a soubor tehoz jmena existuje
C na adresari \FILES\ bude nejprve zavren a pote otevren.
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      CHARACTER *(*) FILENAM
      CHARACTER*20 FILAUX,FILENA
	LOGICAL EXST,OPND
C FILENA - bez pocatecnich a koncovych mezer
	FILAUX=ADJUSTL(FILENAM)
      FILENA=TRIM(FILAUX)
C Zavirame soubor na zarizeni IUNIT
      CLOSE(IUNIT)
C Zjistujeme, zda soubor FILENAM jiz neni otevren na jine jednotce.
C Pokud to tak je, soubor na teto jednotce zavreme
	INQUIRE(FILE=FILENA,EXIST=EXST,OPENED=OPND,NUMBER=IUN)
	IF(EXST)THEN
	   IF(OPND)CLOSE(IUN)
      ELSEIF(INDEX(FILENA,'\').LE.0)THEN
C Toto je pripad, kdy je uvedeno jmeno souboru bez cesty, ale soubor existuje na \FILES\
         INQUIRE(FILE='.\FILES\'//FILENA,EXIST=EXST,OPENED=OPND,
     /           NUMBER=IUN)
         IF(EXST)THEN
	       IF(OPND)CLOSE(IUN)
		   OPEN(IUNIT,FILE='.\FILES\'//FILENA,ERR=1)	    
             WRITE(10,'('' Opening '',A,'' (directory /FILES) on unit'',
     /                   i3)')FILENA,IUNIT
	       RETURN
         ENDIF
      ENDIF
      OPEN(IUNIT,FILE=FILENA,ERR=1)
      WRITE(10,'('' Opening file '',A,'' on unit'',i3)')FILENA,IUNIT
      RETURN
C
C To je stara verze nahrazena v kvetnu 2007 prikazy INQUIRE
C Zasadni zmena je v tom, ze kdyz soubor jiz existuje otevira se
C a to bud na pracovnim adresari, nebo i na adresari FILES
C      L=LEN(FILENA)
C      CALL TUPC(L,FILENA,FILENA)
C      DO I=1,50
C        CALL FINQUIRE(I,FILAUX)
C        LA=LEN(TRIM(FILAUX))
C        CALL TUPC(LA,FILAUX,FILAUX)
C        IF(FILAUX(1:LA).EQ.FILENA)THEN
C          WRITE(10,'('' File '',A,'' must be closed on unit'',i3)')
C     /    FILENA,I
C          CLOSE(I)
C        ENDIF
C      ENDDO

1     OPEN(IUNIT,FILE='',ERR=2)
2     CALL FINQUIRE(IUNIT,FILENAM)
      WRITE(10,'('' Opening file '',A)')FILENAM
      END

 
      SUBROUTINE LINETAB(LINE,N)
      CHARACTER*(N) LINE
      NS=LEN_TRIM(LINE)
      IF(NS.GT.0)THEN
         DO I=1,NS
           IF(LINE(I:I).EQ.'	'.OR.LINE(I:I).EQ.';')LINE(I:I)=' '
         ENDDO
      ENDIF
      END

      SUBROUTINE FLUENF(FILET,FILESCR,NIT)
C
      CHARACTER*(*) FILET,FILESCR
      CHARACTER*120 LINEIN,LINEOUT
      CHARACTER*20 FILET20,FILES20
      FILET20=TRIM(FILET)
      FILES20=TRIM(FILESCR)//'.SCF'
      IF(LEN(FILET20).GT.0.AND.LEN(FILES20).GT.4)THEN
        WRITE(10,'('' Creating ['',A,'']'')')FILES20
        CLOSE(3)
        CLOSE(5)
        OPEN(3,FILE=FILET20)
        OPEN(5,FILE=FILES20)
        ICOUNT=0
1       READ(3,'(A)',END=999)LINEIN
        ICOUNT=ICOUNT+1
        CALL ANALYSE(LINEIN,LINEOUT,FILESCR,I,DTS,
     /               ID2,ID3,ID4,NIT,IOUT)
C IOUT=1  write
C IOUT=2  if true
C IOUT=3  if not
C IOUT=4  endif
C IOUT=5  loop
C IOUT=6  endloop
        IF(IOUT.EQ.1)WRITE(5,'(A)')TRIM(LINEOUT)
        GOTO 1
      ELSE
        WRITE(10,'('' Unable to create script file'')')
      ENDIF
999   CLOSE(3)
      CLOSE(5)
      END


      SUBROUTINE FLUENT(FILET,FILESCR,DTS,NTS,INSTART,INEND,NSAV,NIT)
C
      CHARACTER*(*) FILET,FILESCR
      CHARACTER*120 LINEIN,LINEOUT
      LOGICAL OK
      CHARACTER*20 FILET20,FILES20
      FILET20=TRIM(FILET)
      FILES20=TRIM(FILESCR)//'.SCT'
      IF(LEN(FILET20).GT.0.AND.LEN(FILES20).GT.4)THEN
        WRITE(10,'('' Creating ['',A,'']'')')FILES20
        CLOSE(3)
        CLOSE(5)
        OPEN(3,FILE=FILET20)
        OPEN(5,FILE=FILES20)
        ICOUNT=0
        OK=.TRUE.
1       READ(3,'(A)',END=999)LINEIN
        ICOUNT=ICOUNT+1
        CALL ANALYSE(LINEIN,LINEOUT,FILESCR,I,
     /               DTS,INSTART,INEND,NSAV,NIT,IOUT)
C IOUT=1  write
C IOUT=2  if true
C IOUT=3  if not
C IOUT=4  endif
C IOUT=5  loop
C IOUT=6  endloop
        SELECT CASE(IOUT)
          CASE(1)
             IF(OK)WRITE(5,'(A)')TRIM(LINEOUT)
          CASE(2,4)
             OK=.TRUE.
          CASE(3)
             OK=.FALSE.
          CASE(5)
             I=1
             LOOPIN=ICOUNT
          CASE(6)
             I=I+1
             IF(I.LE.NTS)THEN
                REWIND(3)
                DO J=1,LOOPIN
                   READ(3,*)
                ENDDO
             ENDIF
        END SELECT       
        GOTO 1
      ELSE
        WRITE(10,'('' Unable to create script file'')')
      ENDIF
999   CLOSE(3)
      CLOSE(5)
      END

      SUBROUTINE ANALYSE(LINEIN,LINEOUT,FILESCR,I,
     /                   DTS,INSTART,INEND,NSAV,NIT,IOUT)
C IOUT=1  write
C IOUT=2  if true
C IOUT=3  if not
C IOUT=4  endif
C IOUT=5  loop
C IOUT=6  endloop
      CHARACTER*120 LINEIN,LINEOUT
      CHARACTER*20  FILESTE
      CHARACTER*(*) FILESCR
      CHARACTER*1 C1,C2
	INTEGER I,INSTART,INEND,NSAV,NIT,IOUT
	REAL DTS

      FILESTE=TRIM(FILESCR)
      L1=LEN(TRIM(LINEIN))
      L2=LEN(TRIM(FILESTE))
      I1=INDEX(LINEIN,'[')
      I2=INDEX(LINEIN,']')
      J1=I1-1
      CALL TLWC(L1,LINEIN,LINEIN)
      LINEOUT=LINEIN
      IOUT=1
      IF(I1.GT.1.AND.I2.GT.I1)THEN
         LINEOUT=LINEIN(1:J1)
      ELSEIF(I1.EQ.1.AND.I2.GT.1)THEN
         LINEOUT=''
      ELSEIF(I1.EQ.0)THEN
         IF(I2.NE.0)IOUT=0
         RETURN
      ENDIF
C Modifikace 
      C1=LINEIN(I1+1:I1+1)
      C2=LINEIN(I1+2:I1+2)
      SELECT CASE(C1)
      CASE('t')
          LINEOUT(J1+1:J1+L2+L1-I2)=FILESTE(1:L2-1)//C2//LINEIN(I2+1:L1)
      CASE('d')
          WRITE(LINEOUT(J1+1:J1+11),'(E11.4)')DTS
      CASE('n')
          WRITE(LINEOUT(J1+1:J1+8),'(I8)')NSAV
      CASE('l')
          IOUT=5
      CASE('e')
          IN1=INDEX(LINEIN(I1:L1),'l')
          IN2=INDEX(LINEIN(I1:L1),'i')
          IF(IN1.GT.0)THEN
             IOUT=6
          ELSEIF(IN2.GT.0)THEN
             IOUT=4
          ELSE
             IOUT=0
          ENDIF
      CASE('i')
          IN1=INDEX(LINEIN(I1:L1),'1')
          IN2=INDEX(LINEIN(I1:L1),'2')
          IF(IN1.GT.0)THEN
C IF I=N1
            IF(I.EQ.INSTART)THEN
               IOUT=2
            ELSE
               IOUT=3
            ENDIF
          ELSEIF(IN2.GT.0)THEN
C IF I=N2
            IF(I.EQ.INEND)THEN
               IOUT=2
            ELSE
               IOUT=3
            ENDIF
          ELSE
C WRITE NIT
            WRITE(LINEOUT(J1+1:J1+8),'(I8)')NIT
          ENDIF
      CASE('''')
C ['ffffff.ppp' i-1] nebo ['fffffff.ppp' i]
          IM1=INDEX(LINEIN(I1:L1),'i-1')
          IF(IM1.GT.0)THEN
            IG1=I-1
          ELSE
            IG1=I
          ENDIF
          IF(IG1.GE.0)THEN
            IL2=INDEX(LINEIN(I1+2:L1),'''')
            FILESTE=LINEIN(I1+2:I1+IL2)
            CALL FILINUM(FILESTE,IG1)
            LINEOUT(J1+1:J1+IL2-1)=FILESTE
          ELSE
            IOUT=0
          ENDIF
      ENDSELECT    
      END
