      SUBROUTINE $RUNMESH
C
C RUNMESH.for
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (MAXT=10000,MAXDIV=100)
      INCLUDE '$FEMLOC'
      DIMENSION IUET(3,MAXT),INB(MAXT),XP(MAXT),YP(MAXT),LP(MAXT),
     /          IAUXC(MAXT),RX(3),XA(MAXDIV)
      LOGICAL NEW
      DATA RX /-1.,1.,0./
C parametry prikazoveho radku
      NNCONT=IP(1)
      NX=IP(2)
      NY=IP(3)
      NU1=IP(4)
      NU2=IP(5)
      CONTROL=RP(6)
C
C Rozsah key-points
C
      XMI=1E10
      YMI=1E10
      XMA=-1E10
      YMA=-1E10
      DO I=1,NPT
         XMI=AMIN1(XMI,PTX(I))
         YMI=AMIN1(YMI,PTY(I))
         XMA=AMAX1(XMA,PTX(I))
         YMA=AMAX1(YMA,PTY(I))
      ENDDO
      DX=(XMA-XMI)/(NX-1)
      DY=(YMA-YMI)/(NY-1)
      DXS=DX*0.4
      DYS=DY*0.4
      DXSS=DX*0.2
      DYSS=DY*0.2
      XMI=XMI-DXS
      XMA=XMA+DXS
      YMI=YMI-DYS
      YMA=YMA+DYS
      N=1
C Generovani hranicnich bodu
      DO IC=1,NNCONT
        DO J=1,MCONTOUR(IC)
          ICURVE=ICONTOUR(J,IC)
          NPCURVE=MCR(ICURVE)
C Doplneni bodu krivky ICURVE dle NXCR a FLAFI
          NNCURVE=NXCR(ICURVE)
          IF(NNCURVE.LE.3)NNCURVE=MAX0(NX,NY)
          AX=FLAFI(ICURVE)
          IF(AX.EQ.0.)AX=1.
          CALL FEMDIV(-1.,1.,XA,NNCURVE-1,AX)
          DO IX=1,NNCURVE
            XP(N)=0
            YP(N)=0
            DO I=1,NPCURVE
               ZX=XA(IX)*RX(I)
               IF(NPCURVE.EQ.2)THEN
                  BI=(1+ZX)/2.
               ELSEIF(I.LE.2)THEN
                  BI=(1+ZX)*ZX/2.
               ELSE
                  BI=1-XA(IX)**2
               ENDIF
               IND=ICR(I,ICURVE)
               XP(N)=XP(N)+PTX(IND)*BI
               YP(N)=YP(N)+PTY(IND)*BI
C LP(N)=-1 oznacuje fixovany bod na hranici
               LP(N)=-1
            ENDDO
C Zjisti, zda uzel jiz nebyl vygenerovan na jinych krivkach
            NEW=.TRUE.
            DO K=1,N-1
              IF(ABS(XP(N)-XP(K)).LT.DXSS.AND.
     /           ABS(YP(N)-YP(K)).LT.DYSS)NEW=.FALSE.
            ENDDO
            IF(NEW)N=N+1
          ENDDO
        ENDDO
      ENDDO
      N=N-1
      NBOUND=N
      WRITE(*,*)' Boundary points, total N=',n
C Add INNER points as soon as they are not too close to boundary points
      DO I=1,NX
        XN=(I-1)*DX+XMI
        SIGN=1.
        DO J=1,NY
          SIGN=-SIGN
          X=XN+SIGN*DXSS
          Y=(J-1)*DY+YMI
          CALL PTCTIN(X,Y,PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,IN)
          IF(IN.EQ.1)THEN
            NEW=.TRUE.
            DO K=1,NBOUND
               DXK=X-XP(K)
               DYK=Y-YP(K)
               ADXK=ABS(DXK)
               ADYK=ABS(DYK)
               IF(ADXK.LE.DXS.AND.ADYK.LE.DYS)THEN
                  ii=focusqq(20)
                  call gmfmrk(x,y,30)
                  call gmfmrk(xp(k),yp(k),31)
                  TX=1.
                  TY=1.
                  IF(ADXK.GT.DXSS)TX=1.+DXSS/ADXK
                  IF(ADYK.GT.DYSS)TY=1.+DYSS/ADYK
                  T=AMAX1(TX,TY)
                  IF(T.GT.1.001)THEN
                     X=XP(K)+T*DXK
                     Y=YP(K)+T*DYK
                    call gmfmrk(x,y,10)
                  ELSE
                     NEW=.FALSE.
                  ENDIF
               ENDIF
            ENDDO
            IF(NEW)THEN
              N=N+1
              XP(N)=X
              YP(N)=Y
C LP=0 OZNACUJE VNITRNI BOD
              LP(N)=0
            ENDIF
          ENDIF
        ENDDO
      ENDDO
      WRITE(*,*)' Inner+boundary points',N
C
C generovani trojuhelnikove site
C
      WRITE(*,*)' FEMPT STARTS WITH ',N,' POINTS. CONTROL=',CONTROL
      CALL FEMPT(XP,YP,N,CONTROL,IUET,NET,INB,NB,IAUXC)
C prenos vygenerovane site trojuhelniku do databaze
      WRITE(*,*)' FEMPT GENERATED ',NET,' ELEMENTS'
      ND=N
      DO I=1,N
        XX(I)=XP(I)
        YY(I)=YP(I)
        ZZ(I)=0.
      ENDDO
      DO IET=1,NET
CHECK gravity center of possibly generated triangle
         TX=0.
         TY=0.
         DO I=1,3
           IND=IUET(I,IET)
           TX=TX+XP(IND)
           TY=TY+YP(IND)
         ENDDO
         CALL PTCTIN(TX/3.,TY/3.,PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,IN)
         IF(IN.EQ.1)THEN
           NE=NE+1
           MUE(NE)=3
           IGROUP(NE)=1
           IRCONS(NE)=1
           IMPROP(NE)=1
           L0=LUE(NE)
           DO I=1,3
             IUE(L0+I)=IUET(I,IET)
           ENDDO
           LUE(NE+1)=LUE(NE)+3
         ENDIF
      ENDDO
1000  CONTINUE
      END

      INCLUDE 'FEMPT.FOR'
