C $S-OPTIM.FOR
      SUBROUTINE GMODEL(ITYP,PARAM,LOCPARAM,NPARAM)
C 
C ITYP=0 interpretace modelu RPN (impulsni odezva - vstupy delta funkce)
C ITYP=1 interpretace modelu RPN (se vstupy NINPUTS - potlacene I.C.)
C ITYP=2 interpretace modelu RPN (se vstupy NINPUTS - respektovaner I.C.)
C ITYP>2 interpretace souboru na zarizeni ITYP
C 
C PARAM(nparam)    - zadavane hodnoty vybranych parametru
C LOCPARAM(nparam) - indexy vybranych parametru 
C
      DIMENSION PARAM(*),LOCPARAM(*)
      INCLUDE '$FEMLOC'
C Prirazeni hodnot parametru
      DO I=1,NPARAM
        IQ=LOCPARAM(I)
        IF(IQ.GT.0.AND.IQ.LE.NUMODP)THEN
           IF(JMODEL(IQ).EQ.1)THEN
              REALRC(LMODEL(IQ))=PARAM(I)
           ELSEIF(JMODEL(IQ).EQ.2)THEN
              INTERC(LMODEL(IQ))=NINT(PARAM(I))
           ENDIF
        ENDIF
      ENDDO
      SELECT CASE(ITYP)
      CASE(0)
         KEYW='IMPULS'
         CALL RUNMOD
      CASE(1)
         KEYW='CONVOL'
         CALL RUNMOD
      CASE(2)
         KEYW='INTEGR'
         CALL RUNMOD
      CASE DEFAULT
C TRUE  - kopiruji se prikazy na zarizeni cislo 9 (to je jen protokol) a interpretuji se ridici prikazy
C FALSE - blokuji se ridici prikazy a hned probiha interpretace
         CALL COMFIL(ITYP,9,.TRUE.)
      END SELECT
      END

	SUBROUTINE GMODPLOT(ITYP,INDPAR,PARIMI,PARIMA,NDIVI,ICOLP,ICOLOR)
	USE DFLIB
	INCLUDE '$FEMLOC'
	DIMENSION PLI(10),SENSI(10)
	NDIV=MIN0(NDIVI,10)
C Ponechame vsechny parametry: menime jen parametr cislo INDPAR
      IF(NDIV.LE.0.OR.ICOLP.LE.0.OR.ICOLP.GT.10.OR.NGR.LE.0)THEN
	  CALL HELPC(5,'Incorrect parameters for GMOD')
	  RETURN
	ENDIF
      LQ=LMODEL(INDPAR)
	JQ=JMODEL(INDPAR)
	IF(JQ.EQ.1)THEN
	  ASAV=REALRC(LQ)
      ELSE
	  ISAV=INTERC(LQ)
	ENDIF
	DPAR=(PARIMA-PARIMI)/NDIV
	DO I=1,NDIV
	  PARAA=PARIMI+DPAR*(I-1)
 	  IF(JQ.EQ.1)THEN
	     REALRC(LQ)=PARAA
        ELSE
	     INTERC(LQ)=PARAA
	  ENDIF
	  IF(I.LE.10)PLI(I)=PARAA
        SELECT CASE(ITYP)
        CASE(0)
          KEYW='IMPULS'
          CALL RUNMOD
        CASE(1)
          KEYW='CONVOL'
          CALL RUNMOD
        CASE(2)
          KEYW='INTEGR'
          CALL RUNMOD
        CASE DEFAULT
          CALL COMFIL(ITYP,9,.TRUE.)
        END SELECT
C Vykresleni casoveho prubehu 
	  II=SETACTIVEQQ(20)
        CALL GMFPL(MAX0(2,NGR),YGR(1,1),YGR(1,ICOLP),ICOLOR)
C Vycisleni odchylky a citlivosti na zmenu parametru
        IF(I.GT.1)THEN
	     S0=0
	     S1=0
	     DO J=1,NGR
	        S0=S0+ABS(VGR(J)+YGR(J,ICOLP))*.5
	        S1=S1+ABS(VGR(J)-YGR(J,ICOLP))
	     ENDDO
	     S0=S0/NGR
	     S1=S1/NGR
	     IF(PARAA.NE.0..AND.S0.NE.0.)THEN
	        SENS=(S1/S0)/(DPAR/PARAA)
           ELSE
	        SENS=S1/DPAR
           ENDIF
	     SENSI(I-1)=SENS
        ENDIF
	  DO J=1,NGR
	     VGR(J)=YGR(J,ICOLP)
        ENDDO
	ENDDO
	IF(JQ.EQ.1)THEN
	  REALRC(LQ)=ASAV
      ELSE
	  INTERC(LQ)=ISAV
	ENDIF
	WRITE(10,'('' Plotted '',A,'':'',7ES11.3)')
     /TRIM(VARTXT(INDPAR)),(PLI(I),I=1,MIN0(7,NDIV))
	WRITE(10,'('' Sensitivities:'',7ES11.3)')
     /(SENSI(I),I=1,MIN0(7,NDIV-1))
	WRITE(9,'('' Plotted '',A,'':'',7ES11.3)')
     /TRIM(VARTXT(INDPAR)),(PLI(I),I=1,MIN0(7,NDIV))
	WRITE(9,'('' Sensitivities:'',7ES11.3)')
     /(SENSI(I),I=1,MIN0(7,NDIV-1))
	END


      SUBROUTINE OPTIMA(ITYP,LISTPAR,NLISTPAR,ITER,SUMBEST)
C
C OPTIMALIZACE MARQUARDT LEVENGERG
C ITYP =0,1,2 interpretovany model dif.rov, 
C          >2 prikazy v souboru na jednotce ITYP
C LISTPAR(NLISTPAR) - indexy regresnich parametru (1,2,... max.NUMODP)
C                     informace o nich jsou LMODEL(),KMODEL(),JMODEL()
C ITER - pocet iteraci
C SUMBEST- vysledny vazeny soucet ctvercu odchylek
C
      PARAMETER (MAXREG=8,MAXPAIR=5)
      DIMENSION LISTPAR(*)
      INCLUDE '$FEMLOC'
      DIMENSION YP(MAXNTS,MAXPAIR),YPBEST(MAXNTS,MAXPAIR)
C KPARA=1 (LIN),=2 (NLIN),  RPARA (relax), LPARA indexy linearnich param.
      DIMENSION PARA(MAXREG),PARABEST(MAXREG),ZMI(MAXREG),ZMA(MAXREG),
     /       LOCPARA(MAXREG),KPARA(MAXREG),RPARA(MAXREG),LPARA(MAXREG),
     /       LPARAS(MAXREG),JPARA(MAXREG),PARATBEST(MAXREG),
     /       PARAINI(MAXREG)
      LOGICAL OPE
C Testy chybejicich parametru
      IF(NCOMPAR.LE.0.OR.ICOMP2-ICOMP1.LT.0)THEN
         CALL HELPC(6,'Specify data for comparison using COMPAR')
         RETURN
      ELSEIF(NLISTPAR.LE.0)THEN
         CALL HELPC(6,'Specify model parameters using PARDEF,PARSET')
         RETURN
      ELSEIF(ITYP.GT.2)THEN
         INQUIRE(UNIT=ITYP,OPENED=OPE)
         IF(.NOT.OPE)THEN
             CALL HELPC(6,'Open session file using OPEN')
             RETURN
         ENDIF
      ENDIF
C Stanoveni skutecnych parametru, ktere se budou zjistovat regresi
C NREG  pocet parametru linearnich, nelinearnich i typu search
C NLREG pocet prametru linearnich (kod 1)
C NSREG pocet parametru prohledavanych bezderivacne zlatym rezem (kod 3)
C IQT   index parametru, ktery je prohledavan linearne (kod 4,5,...)
      NREG=0
      NLREG=0
      NSREG=0
      IQT=0
      KQT=1
      DO I=1,NLISTPAR
         IQ=LISTPAR(I)
         IF(IQ.GE.1.AND.IQ.LE.NUMODP)THEN
C PMODEL(MAXPMOD) -pomocny vektor (muze to byt vektor parametru modelu, zalezi na LMODEL)
C RMODEL(MAXPMOD) -vektor relaxacnich parametru (pro kazdy optimalizovany parametr)
C ZMINP(MAXPMOD)  -vektor urcujici dolni meze optimalizovanych parametru 
C ZMAXP(MAXPMOD)  -vektor urcujici horni meze optimalizovanych parametru 
C LMODEL(MAXPMOD) -indexy parametru odkazujici na prvek /FEM/.
C JMODEL(MAXPMOD) -typ parametru =1 real, =2 integer
C KMODEL(MAXPMOD) -urceni toho, zda ma byt parametr stanoven regresi 
C            (0-nepocitat, 1-linearni parametr, 2-nelinearni, 3-search)
            JQ=JMODEL(IQ)
            KQ=KMODEL(IQ)
            LQ=LMODEL(IQ)
C pro regresi vybirame parametry typu REAL/INTEGER, linearni/nelinearni
            IF(LQ.GT.0.AND.(KQ.EQ.1.OR.KQ.EQ.2.OR.KQ.EQ.3))THEN
               NREG=NREG+1
               IF(NREG.GT.MAXREG)THEN
                  CALL HELPC(6,'Too many optimised parameters')
                  RETURN
               ENDIF
               LOCPARA(NREG)=IQ
               JPARA(NREG)=JQ
               IF(JQ.EQ.1)THEN
                  PARA(NREG)=REALRC(LQ)
               ELSE
                  PARA(NREG)=INTERC(LQ)
               ENDIF
               PARABEST(NREG)=PARA(NREG)
               KPARA(NREG)=KQ
               IF(KQ.EQ.1)THEN
                  NLREG=NLREG+1
                  LPARA(NLREG)=NREG
               ELSEIF(KQ.EQ.3)THEN
                  NSREG=NSREG+1
                  LPARAS(NSREG)=NREG
               ENDIF
               RPARA(NREG)=RMODEL(IQ)
               IF(RPARA(NREG).LE.0.)THEN
                  CALL HELPC(6,'Relax.parameter <=0 use PARSET')
                  RETURN
               ENDIF
               ZMI(NREG)=ZMINP(IQ)
               ZMA(NREG)=ZMAXP(IQ)
            ELSEIF(LQ.GT.0.AND.KQ.GT.3)THEN
C Varianta primeho hledani z intervalu (ZMIT,ZMAT) v KQ bodech
               IQT=IQ
               LQT=LQ
               JQT=JQ
               KQT=KQ
               ZMIT=ZMINP(IQ)
               ZMAT=ZMAXP(IQ)
            ELSE
            WRITE(9,'('' Parameter number'',i3,'' is not suitable'')')IQ
            ENDIF
         ENDIF
      ENDDO
      RLAMUP=RALGOR(36)
      RLAMDW=RALGOR(37)
      ISCALP=IALGOR(17)
      WRITE(9,'(/1X,30(''-''),''OPTIMA BEGINS''/'' No of points'',i5,'', 
     /params'',i2,''. Scale='',i1,'' Lambda factors'',2f6.2/15X,8E10.3)'
     /) NCOMPAR*(ICOMP2-ICOMP1+1),NREG,ISCALP,RLAMUP,RLAMDW,
     /  (PARA(I),I=1,NREG)
      OPEN(35,FILE='$OPTIMA.OUT')
      OPEN(36,FILE='$OPTIMA.DBG')
      SUMTBEST=1E20
	DO I=1,NREG
	   PARAINI(I)=PARA(I)
	ENDDO
C
C Opakovane 
      DO IT=1,KQT
         IF(IQT.GT.0)THEN
	     DO I=1,NREG
	        PARA(I)=PARAINI(I)
	     ENDDO
           CALL DIVPAR(ZMIT,ZMAT,(IT-0.5)/KQT,P)
           IF(JQT.EQ.1)THEN        
              REALRC(LQT)=P
           ELSE
              INTERC(LQT)=NINT(P)
           ENDIF
           WRITE(35,'('' P('',I2,'')='',E11.4,'' linear search'')')IQT,P
         ENDIF
C
C Nalezeni optimalnich parametru PARABEST metodami GS a ML
C
         CALL OPGSML(ITYP,NREG,NLREG,NSREG,ITER,RLAMUP,RLAMDW,ISCALP,
     /     LOCPARA,LPARA,LPARAS,JPARA,KPARA,RPARA,PARA,PARABEST,ZMI,ZMA,
     /     YP,YPBEST,SUMBEST)
         IF(SUMBEST.LT.SUMTBEST)THEN
           SUMTBEST=SUMBEST
           WRITE(35,'('' IMPROVED PARAMS SAVED. SUM='',E11.4,'' P('',i2,
     /'')='',E11.4)')SUMBEST,IQT,P
           DO K=1,NREG
               PARATBEST(K)=PARABEST(K)
           ENDDO
           PBEST=P
         ENDIF
         WRITE(10,'('' Step'',I2,'' SSQ='',E11.4)')IT,SUMBEST
      ENDDO
      IF(IQT.GT.0)THEN
C
C Presun optimalniho parametru linearniho prohledavani
C
         IF(JQT.EQ.1)THEN        
           REALRC(LQT)=PBEST
         ELSE
           INTERC(LQT)=NINT(PBEST)
         ENDIF
         WRITE(35,'('' FINAL P('',i2,'')='',E11.4)')IQT,PBEST
      ENDIF
C
C Vypocet odezvy a vyhodnoceni odchylky. Nejlepsi parametry jsou PARATBEST
C
      CALL HELPC(6,'Final evaluation')
      CALL GMODEL(ITYP,PARATBEST,LOCPARA,NREG)
	CALL DMODLIST(ITYP)
      WRITE(9 ,112)SUMTBEST
      WRITE(10,112)SUMTBEST
112   FORMAT(/' OPTIMA Final SSQ=',e11.4)
999   CLOSE(35)
      CLOSE(36)
      SCOMPAR=SUMTBEST
	IRESULT=RUNQQ('NOTEPAD.EXE','$OPTIMA.OUT')
      END

      SUBROUTINE OPGSML(ITYP,NREG,NLREG,NSREG,ITER,RLAMUP,RLAMDW,ISCALP,
     /  LOCPARA,LPARA,LPARAS,JPARA,KPARA,RPARA,PARA,PARABEST,ZMI,ZMA,
     /  YP,YPBEST,SUMBEST)
C Zpracovani ITER iteraci metodou zlateho rezu, a Marquardt-Levenberg
      USE PEEKAPPMODULE
      PARAMETER (MAXREG=8,MAXPAIR=5,MAXITER=100,NALFA=3)
      INCLUDE '$FEMLOC'
      DIMENSION DYDP(MAXNTS,MAXPAIR,MAXREG),
     /          YP(MAXNTS,MAXPAIR),YPBEST(MAXNTS,MAXPAIR)
      DIMENSION PARA(MAXREG),PARABEST(MAXREG),PARA0(MAXREG),
     /       PARAMIN(MAXREG),PARAMAX(MAXREG),ZMI(MAXREG),ZMA(MAXREG),
     /       LOCPARA(MAXREG),KPARA(MAXREG),RPARA(MAXREG),LPARA(MAXREG),
     /       LPARAS(MAXREG),JPARA(MAXREG),PSERA(MAXITER,2)
      REAL*8 C(MAXREG,MAXREG),CM(MAXREG,MAXREG),
     /       CDM(MAXREG),DPM(MAXREG),DP(MAXREG)
      LOGICAL ZER
      CHARACTER*40 TSUMSQ
C
      SUMOLD=1E10
      SUMBEST=1E10
      ALAM=0.01
      DO I=1,NREG
         DP(I)=0.D0
         PARAMIN(I)=PARA(I)
         PARAMAX(I)=PARA(I)
      ENDDO
C
C Systematicke prohledavani parametru v intervalu ZMIN,ZMAX u typu 3
C
      IF(NSREG.GT.0)THEN
        CALL HELPC(6,' GMODEL search, results in the file $OPTIMA.OUT')
C kdyz chceme vzdy vybrat nektery interval
        SUMBEST=1E10
        DO J1=1,NSREG
          J=LPARAS(J1)
          ITBEST=1
          DO IT=1,ITER
             CALL DIVPAR(ZMI(J),ZMA(J),FLOAT(IT)/FLOAT(ITER+1),PARA(J))
             CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
             CALL SUMS(SUMSQ,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
             WRITE(TSUMSQ,'(I3,'': P'',i1,''='',e10.3,4X,''S='',E12.4)')
     /IT,J,PARA(J),SUMSQ
             CALL HELPC(6,TSUMSQ(1:36))
             IF(IT.LE.MAXITER)THEN
                PSERA(IT,1)=PARA(J)
                PSERA(IT,2)=SUMSQ
                IF(SUMSQ.LE.SUMBEST)ITBEST=IT
             ENDIF
          ENDDO
C GOLDEN SECTION jen kdyz je nejlepsi bod uvnitr
          IF(ITBEST.LE.1.OR.ITBEST.GE.ITER)THEN
             CALL HELPC(6,'Global optimum out of range')
          ELSE
             UPA=PSERA(ITBEST-1,1)
             UPB=PSERA(ITBEST+1,1)
             USA=PSERA(ITBEST-1,2)
             USB=PSERA(ITBEST+1,2)
             URK=0.61803
             UPX=UPA+(1-URK)*(UPB-UPA)
             UPY=UPA+URK*(UPB-UPA)
             PARA(J)=UPX
             CALL HELPC(4,' Golden section LEFT  bound')
             CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
             CALL SUMS(USX,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
             PARA(J)=UPY
             CALL HELPC(4,' Golden section RIGHT bound')
             CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
             CALL SUMS(USY,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
             DO IT=1,MIN0(ITER,5)
               IF(USX.LT.USY)THEN
                  UPB=UPY
                  UPY=UPX
                  USY=USX
                  UPX=UPA+(1-URK)*(UPB-UPA)
                  PARA(J)=UPX
                  CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
                  CALL SUMS(USX,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
               ELSE
                  UPA=UPX
                  UPX=UPY
                  USX=USY
                  UPY=UPA+URK*(UPB-UPA)
                  PARA(J)=UPY
                  CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
                  CALL SUMS(USY,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
               ENDIF
               WRITE(TSUMSQ,'('' Golden Section      P'',i1,''='',e10.3)
     /')J,PARA(J)
               CALL HELPC(4,TSUMSQ(1:34))
             ENDDO
          ENDIF
          DO K=1,NREG
             PARA(K)=PARABEST(K)
          ENDDO
        ENDDO
      ENDIF
C
C Kdyz jsou vsechny parametry typu 3, dalsi zpresneni se neprovadi
C
      IF(NSREG.EQ.NREG)RETURN
C -----------------------------------
      NFAIL=0
      DO IT=1,ITER
C test stisknute klavesy USERPEEKCHAR() exit iteraci
       II=FOCUSQQ(10)
	 WRITE(10,'('' Iteration'',i4,'' of'',i4,''. Press a key to interr
     /upt...'')')IT,ITER
	 CALL SLEEPQQ(10)
       IF(USERPEEKCHAR())EXIT
C Prohledane rozpeti parametru
       DO I=1,NREG
          PARAMIN(I)=AMIN1(PARAMIN(I),PARA(I))
          PARAMAX(I)=AMAX1(PARAMAX(I),PARA(I))
       ENDDO
C Vypocet odchylky SUMSQ dle specifikovaneho kriteria pro aktualni parametry
C modelu PARA(i). Aktualizace nejlepsiho vysledku SUMBEST a PARABEST(i).
       CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
       CALL SUMS(SUMSQ,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
       CALL GRESID(IT,ITER,SUMSQ,ALAM,0)
       WRITE(TSUMSQ,'(I4,'' S='',E12.4)')IT,SUMSQ
       CALL HELPC(5,TSUMSQ(1:19))
C Vyhodnoceni vypoctene sumy souctu ctvercu odchylek
       IF(NFAIL.LE.4.AND.SUMSQ.LT.50.*SUMBEST)THEN
C Ve 3 nasledujicich krocich nedoslo ke zhorseni
        IF(SUMSQ.LT.SUMOLD)THEN
C Snizeni SSQ
           NFAIL=0
           SUMOLD=SUMSQ
           ALAM=ALAM*RLAMDW
           WRITE(9,337)SUMSQ,IT,ALAM
           WRITE(36,337)SUMSQ,IT,ALAM
337        FORMAT(10x,' SSQ',e11.4,' improved  in iteration',i3,' LAMBDA
     /=',E11.3)
           IF(NLREG.GT.0)THEN
C  LINEARNI regrese pro NLREG parametru
C  ------------------------------------
C              Vypocet derivaci modelu dle LINEARNICH parametru
             DO J1=1,NLREG
               J=LPARA(J1)
               PSJ=PARA(J)
               DPJ=AMAX1(ABS(PSJ),1.)
               PARA(J)=PSJ+DPJ
               CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
               WRITE(TSUMSQ,'(''Iter'',I4,'' P'',I4,''-linreg'')')IT,J1
               CALL HELPC(5,TSUMSQ(1:21))
               DO IC=1,NCOMPAR
                 DO I=ICOMP1,ICOMP2
                    DYDP(I,IC,J)=(YGR(I,ICOMPAR(1,IC))-YP(I,IC))/DPJ
                 ENDDO
               ENDDO
               PARA(J)=PSJ
             ENDDO
C              Soustava normalnich rovnic pro LINEARNI parametry modelu
             DO K=1,NLREG
               DPM(K)=0.D0
               DO J=1,NLREG
                 CM(K,J)=0.D0
               ENDDO
             ENDDO
             DO IC=1,NCOMPAR
               DO I=ICOMP1,ICOMP2
                 DYYP=YGR(I,ICOMPAR(2,IC))-YP(I,IC)
                 IF(ICOMPAR(3,IC).LE.0)THEN
                    W=1
                 ELSE
                    W=YGR(I,ICOMPAR(3,IC))
                 ENDIF
                 DO K1=1,NLREG
                    K=LPARA(K1)
                    WT=DYDP(I,IC,K)*W
                    DPM(K1)=DPM(K1)+DYYP*WT
                    DO J1=1,NLREG
                       J=LPARA(J1)
                       CM(K1,J1)=CM(K1,J1)+WT*DYDP(I,IC,J)
                    ENDDO
                 ENDDO
               ENDDO
             ENDDO
             CALL DGAUSS(CM,NLREG,MAXREG,DPM,1,1,ier)
             IF(IER.NE.0)THEN
                 WRITE(10,'('' ERROR in Gauss elimination'')')
                 NFAIL=10
                 CYCLE
             ENDIF
             DO K1=1,NLREG
               K=LPARA(K1)
               PARA(K)=PARA(K)+DPM(K1)
             ENDDO
C               Proved vyhodnoceni modelu po linearni regresi
             CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
C              Uloz vysledek (vektory MOUTPUTS) do pracovni matice YP
C              a soucasne pocitej soucet ctvercu odchylek
             CALL SUMS(SUMSQ,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
             WRITE(TSUMSQ,'('' After linear regression  S='',E12.4)')
     /             SUMSQ
             CALL HELPC(5,TSUMSQ(1:40))
           ENDIF
C 
C NELINEARNI regrese pro NREG parametru
C -------------------------------------------
C             Vypocet derivaci modelu dle VSECH parametru
           DO J=1,NREG
              PSJ=PARA(J)
              IF(KPARA(J).EQ.1)THEN
C               Linearni parametr (velky prirustek)
                 REL=1
              ELSE
C               Nelinearni parametr (maly prirustek)
C                 REL=0.05
                 REL=.02
              ENDIF
              DPJ=AMAX1(ABS(REL*PSJ),(ZMA(J)-ZMI(J))*1E-4)
C               Celociselny parametr
              IF(JPARA(J).EQ.2)DPJ=1.
              PARA(J)=PSJ+DPJ
              CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
              WRITE(TSUMSQ,'(''Iter='',I3,''  dY/dP'',I1)')IT,J
              CALL HELPC(5,TSUMSQ(1:16))
C                Vyhodnoceni DYDP
              ZER=.TRUE.
              DO IC=1,NCOMPAR
                 DO I=ICOMP1,ICOMP2
                    DYDP(I,IC,J)=(YGR(I,ICOMPAR(1,IC))-YP(I,IC))/DPJ
                    IF(ABS(DYDP(I,IC,J)).GT.1E-7)ZER=.FALSE.
                 ENDDO
              ENDDO
              IF(ZER)THEN
                 WRITE(10,'('' Zero dY/dP'',i1,'' P='',E10.3)')J,PSJ
C                  Nahradni reseni - vysoka hodnota derivace
                 DO IC=1,NCOMPAR
                    DO I=ICOMP1,ICOMP2
                       DYDP(I,IC,J)=1000.
                    ENDDO
                 ENDDO
              ENDIF
              PARA(J)=PSJ
           ENDDO
C             Vypocet soustavy normalnich rovnic
           DO K=1,NREG
              DPM(K)=0.D0
              DO J=K,NREG
                CM(K,J)=0.D0
              ENDDO
           ENDDO
           DO IC=1,NCOMPAR
              DO I=ICOMP1,ICOMP2
                 DYYP=YGR(I,ICOMPAR(2,IC))-YP(I,IC)
                 IF(ICOMPAR(3,IC).LE.0)THEN
                    W=1
                 ELSE
                    W=YGR(I,ICOMPAR(3,IC))
                 ENDIF
                 DO K=1,NREG
                    WT=DYDP(I,IC,K)*W
                    DPM(K)=DPM(K)+DYYP*WT
                    DO J=K,NREG
                       CM(K,J)=CM(K,J)+WT*DYDP(I,IC,J)
                    ENDDO
                 ENDDO
              ENDDO
           ENDDO
C Konec sekce provadene pri snizeni souctu ctvercu
        ELSE
C Reakce na zhorseni souctu ctvercu SSQ
C Regenerace puvodniho vektoru parametru, ponechani puvodni 
C soustavy normalnich rovnic, jenom preskalovani a opakovane reseni
           NFAIL=NFAIL+1
           ALAM=ALAM*RLAMUP
           DO K=1,NREG
             PARA(K)=PARA(K)-DP(K)*RPARA(K)
           ENDDO
           WRITE(9,336)SUMSQ,IT,ALAM,(PARA(K),K=1,NREG)
           WRITE(36,336)SUMSQ,IT,ALAM,(PARA(K),K=1,NREG)
336        FORMAT(10X,' SSQ',E11.4,' increased in iteration',i3,' LAMBDA
     /=',E10.3/' Restored P:',8E11.4)
        ENDIF
c ---------------------------------------------
        IF(ISCALP.EQ.1)THEN
C Skalovani
           DO K=1,NREG
              CDM(K)=DMAX1(DSQRT(CM(K,K)),1D-10)
           ENDDO
           DO K=1,NREG
              DP(K)=DPM(K)/CDM(K)
              IF(DABS(DP(K)).GT.1D20)THEN
                  WRITE(10,'('' DP'',I2,'' too large'')')K
                  EXIT
              ENDIF
              DO J=1,K-1
                  C(J,K)=CM(J,K)/(CDM(J)*CDM(K))
                  C(K,J)=C(J,K)
              ENDDO
              C(K,K)=1.+ALAM
           ENDDO
        ELSE
           DO K=1,NREG
              CDM(K)=1
              DP(K)=DPM(K)
              DO J=1,K-1
                  C(J,K)=CM(J,K)
                  C(K,J)=C(J,K)
              ENDDO
              C(K,K)=CM(K,K)+ALAM
           ENDDO
        ENDIF
C Reseni soustavy normalnich rovnic Gaussovou eliminaci
        CALL DGAUSS(C,NREG,MAXREG,DP,1,1,IER)
        IF(IER.NE.0)THEN
            WRITE(*,'('' ERROR in Gauss elimination'')')
            NFAIL=10
            CYCLE
        ENDIF
        DO K=1,NREG
           DP(K)=DP(K)/CDM(K)
           PARA(K)=PARA(K)+DP(K)*RPARA(K)
           IF(PARA(K).LT.ZMI(K).OR.PARA(K).GT.ZMA(K))THEN
              WRITE(9,'('' Parameter (P'',i1,'')='',E10.3,'' out of rang
     /e ('',E9.2,'','',E9.2,'')'')')K,PARA(K),ZMI(K),ZMA(K)
              PARA(K)=PARABEST(K)
           ENDIF
        ENDDO
        WRITE(9,667)IT,(PARA(K),K=1,NREG)
        WRITE(36,667)IT,(PARA(K),K=1,NREG)
667     FORMAT(' Iter.',I3,' P:',8E11.4)
C ------------pokusne reseni jednorozmerne hledani ve smeru vektoru DP
        IF(ISCALP.EQ.0)THEN
	     DO KK=1,NREG
	       PARA0(KK)=PARA(KK)
	     ENDDO
	     ALFA=.8
           SBEST=1E20
	     DO K=1,NALFA
	       DO KK=1,NREG
	         PARA(KK)=PARA0(KK)+DP(KK)*ALFA
	         PARA(KK)=AMAX1(ZMI(KK),AMIN1(ZMA(KK),PARA(KK)))
             ENDDO
             CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
             CALL SUMS(SUMSQ,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
	       WRITE(36,679)ALFA,SUMSQ,SUMBEST
679	       FORMAT(' ALFA=',F6.2,' SUMSQ=',E13.6,' Best',E13.6)
             IF(SUMSQ.LE.SBEST)THEN
		      ALOPT=ALFA
	          SBEST=SUMSQ
	       ENDIF
	       ALFA=-5*ALFA
	     ENDDO
C Vyhodnoceni nejlepsi varianty - minimum kvadratickou regresi nedava rozumne vysledky
C asi nejrozumnejsi je proste vzit nejlepsi hodnotu
           WGH=.8
           DO KK=1,NREG
             PARA(KK)=(PARA0(KK)+ALOPT*DP(KK))*WGH+PARABEST(KK)*(1-WGH)
             PARA(KK)=AMAX1(ZMI(KK),AMIN1(ZMA(KK),PARA(KK)))
           ENDDO
	     WRITE(36,680)ALOPT,(PARA(KK),KK=1,NREG)
680        FORMAT(' Optimised ALPHA=',f8.3,' Parameters:',8E11.3)
	  ENDIF
C ------------konec pokusne sekce
C konec sekce, kde se pocitalo zpresneni vektoru PARA
       ELSE
C
C Opakovane zhorsovani SSQ - nahodne permutace z nejlepsiho vychoziho vektoru
C
        WRITE(TSUMSQ,'(''Iter'',I4,'' RANDOMISING'')')IT
        CALL HELPC(6,TSUMSQ(1:20))
C        WRITE(10,*)'Please, specify weight of the best previous result (
C     /0-1), safe value is for    example 0.9999. If you want to quit OPT
C     /IMA now, set the weight > 1.'
C        WEIGHT=1
C        READ(10,*,ERR=50)WEIGHT
C        IF(WEIGHT.GT.1.)EXIT
        WEIGHT=0.98
50      DO I=1,NREG
           R=RAN(IDUM)
           CALL DIVPAR(PARAMIN(I),PARAMAX(I),R,P)
           PARA(I)=P*(1-WEIGHT)+PARABEST(I)*WEIGHT
        ENDDO
        NFAIL=0
        ALAM=0.02
        SUMOLD=1E10
       ENDIF
C Konec cyklu iteraci DO IT=1,ITER
      ENDDO
      END

      SUBROUTINE SUMS(SUMSQ,SUMBEST,NREG,PARA,PARABEST,YP,YPBEST)
C Vypocet vazeneho souctu ctvercu a eventualni aktualizace nejlepsiho vysledku
      PARAMETER (MAXPAIR=5,MAXREG=8)
      INCLUDE '$FEM'
      DIMENSION YP(MAXNTS,MAXPAIR),YPBEST(MAXNTS,MAXPAIR),
     /          PARA(MAXREG),PARABEST(MAXREG)
      REAL*8 DSUMSQ
C DSUMSQ -suma odchylek pres vsechny pary sloupcu
      DSUMSQ=0.
      DO IC=1,NCOMPAR
         DO I=ICOMP1,ICOMP2
            YP(I,IC)=YGR(I,ICOMPAR(1,IC))
            Y1=YP(I,IC)
            Y2=YGR(I,ICOMPAR(2,IC))
            IF(ICOMPAR(3,IC).LE.0)THEN
               W=1
            ELSE
               W=YGR(I,ICOMPAR(3,IC))
            ENDIF
            IF(KCOMPAR.GT.3)THEN
               IF(I.LT.ICOMP2)THEN
                  W=W*(YGR(I+1,1)-YGR(I,1))
               ELSE
                  W=0
               ENDIF
            ENDIF
	      W=AMAX1(1E-10,W)
C COMPAR - kriterium porovnani (=0 absolutni odchylky, =2 kvadraty odchylek)
            SELECT CASE(KCOMPAR)
            CASE(0,4)
               DSUMSQ=DSUMSQ+ABS(Y1-Y2)*W
            CASE(1,5)
               DSUMSQ=DSUMSQ+ABS(Y1-Y2)/AMAX1(1E-10,ABS(Y1),ABS(Y2))*W
            CASE(2,6)
               DSUMSQ=DSUMSQ+(Y1-Y2)**2*W
            CASE(3,7)
               DSUMSQ=DSUMSQ+((Y1-Y2)/AMAX1(1E-10,ABS(Y1),ABS(Y2)))**2*W
            END SELECT
         ENDDO
      ENDDO
      NPOINTS=MAX0(1,(ICOMP2-ICOMP1+1)*NCOMPAR)
      SELECT CASE(KCOMPAR)
      CASE(0,1)
         SUMSQ=DSUMSQ/NPOINTS
      CASE(2,3)
         SUMSQ=DSQRT(DSUMSQ/NPOINTS)
      CASE(4,5)
         SUMSQ=DSUMSQ
      CASE(6,7)
         SUMSQ=DSQRT(DSUMSQ)
      END SELECT
      IF(SUMSQ.LE.SUMBEST)THEN
         SUMBEST=SUMSQ
         DO I=1,NREG
            PARABEST(I)=PARA(I)
         ENDDO
         DO IC=1,NCOMPAR
            DO I=ICOMP1,ICOMP2
               YPBEST(I,IC)=YP(I,IC)
            ENDDO
         ENDDO
      ENDIF
      WRITE(35,'('' S='',E14.7,'' PARAMS:'',10E11.3)')
     /SUMSQ,(PARA(I),I=1,NREG)
      END

      SUBROUTINE DIVPAR(ZMI,ZMA,REL,Z)
C Rozdeleni intervalu ZMI,ZMA v pomeru REL
      IF(ZMI.GT.0..AND.ZMA.GT.ZMI.AND.ZMA/ZMI.GT.10.)THEN
         ZLMI=ALOG10(ZMI)
         ZLMA=ALOG10(ZMA)
         ZL=ZLMI+REL*(ZLMA-ZLMI)
         Z=10.**ZL
      ELSE
         Z=ZMI+REL*(ZMA-ZMI)
      ENDIF
      END

      SUBROUTINE SOMA(ITYP,LISTPAR,NLISTPAR,ITER,SUMSQ,
     /                NSPECI,PRT,STEP,TMASS,WEIGHTI)
C OPTIMALIZACE metodou  SOMA
C ITYP =0,1,2 interpretovany model dif.rov, 
C          >2 prikazy v souboru na jednotce ITYP
C LISTPAR(NLISTPAR) - indexy regresnich parametru (1,2,... max.NUMODP)
C                     informace o nich jsou LMODEL(),KMODEL(),JMODEL()
C ITER - pocet iteraci
C SUMSQ- vysledny vazeny soucet ctvercu odchylek
C NSPEC- pocet jedincu (priblizne NREG nebo i mene)
C PRT  - perturbace (0 az 1)
C STEP - krok parametru (minimalne 0.11, max. TMASS)
C TMASS- horni mez parametru (1.1 az 5)
      USE PEEKAPPMODULE
      PARAMETER (MAXREG=8,MAXPAIR=5,MAXSPEC=6)
      INCLUDE '$FEMLOC'
      DIMENSION LISTPAR(*)
      LOGICAL OPE,ZER
      DIMENSION YP(MAXNTS,MAXPAIR),YPBEST(MAXNTS,MAXPAIR), 
     /  PARA(MAXREG,MAXSPEC),PARABEST(MAXREG,MAXSPEC),SUMBEST(MAXSPEC),
     /  ZMI(MAXREG),ZMA(MAXREG),PWORK(MAXREG),PWBEST(MAXREG),
     /  LOCPARA(MAXREG),KPARA(MAXREG),JPARA(MAXREG),PRTV(MAXREG)
      NSPEC=MIN0(MAXSPEC,NSPECI)
      WEIGHT=AMIN1(0.99,WEIGHTI)
      IF(NCOMPAR.LE.0.OR.ICOMP2-ICOMP1.LT.0)THEN
         CALL HELPC(6,'Specify data for comparison using COMPAR')
         RETURN
      ELSEIF(NLISTPAR.LE.0)THEN
         CALL HELPC(6,'Specify model parameters using PARDEF,PARSET')
         RETURN
      ELSEIF(ITYP.GT.2)THEN
         INQUIRE(UNIT=ITYP,OPENED=OPE)
         IF(.NOT.OPE)THEN
             CALL HELPC(6,'Open session file using OPEN')
             RETURN
         ENDIF
      ENDIF
      OPEN(35,FILE='$SOMA.OUT')
C NREG  pocet parametru linearnich i nelinearnich
      NREG=0
      DO I=1,NLISTPAR
         IQ=LISTPAR(I)
         IF(IQ.GE.1.AND.IQ.LE.NUMODP)THEN
            JQ=JMODEL(IQ)
            KQ=KMODEL(IQ)
            LQ=LMODEL(IQ)
            IF(LQ.GT.0.AND.KQ.GE.1)THEN
               NREG=MIN0(MAXREG,NREG+1)
               LOCPARA(NREG)=IQ
               JPARA(NREG)=JQ
               KPARA(NREG)=KQ
               ZMI(NREG)=ZMINP(IQ)
               ZMA(NREG)=ZMAXP(IQ)
C pocatecni nastaveni NSPEC jedincu. Prvni jedinec - default hodnoty
               IF(JQ.EQ.1)THEN
                 PARA(NREG,1)=REALRC(LQ)
               ELSE
                 PARA(NREG,1)=INTERC(LQ)
               ENDIF
               DO J=2,NSPEC
                 PARAN=ZMI(NREG)+(ZMA(NREG)-ZMI(NREG))*RND(IDUMMY)
                 PARA(NREG,J)=PARA(NREG,1)*WEIGHT+PARAN*(1.-WEIGHT)
               ENDDO
            ELSE
            WRITE(9,'('' Parameter number'',i3,'' is not suitable'')')IQ
            ENDIF
         ENDIF
      ENDDO
C Vyhodnoceni NSPEC jedincu
      SUMLEAD=1E10
      DO ISPEC=1,NSPEC
        SUMBEST(ISPEC)=1E10
        CALL GMODEL(ITYP,PARA(1,ISPEC),LOCPARA,NREG)
        CALL SUMS(SUMSQ,SUMBEST(ISPEC),NREG,
     /            PARA(1,ISPEC),PARABEST(1,ISPEC),YP,YPBEST)
        IF(SUMSQ.LE.SUMLEAD)THEN
            SUMLEAD=SUMSQ
            LEADER=ISPEC
        ENDIF
      ENDDO
Cyklus MIGRACNICH KOL
      WRITE(9,'(/1X,30(''-''),''SOMA''/'' No of points'',i6,'' params'',
     /i2/15X,8E11.3)')
     /        NCOMPAR*(ICOMP2-ICOMP1+1),NREG,(PARA(I,LEADER),I=1,NREG)
      DO IT=1,ITER
	  WRITE(10,'('' Migration loop'',i4,'' of'',i4,''. Press a key to 
     /interrupt...'')')IT,ITER
	  CALL SLEEPQQ(20)
        IF(USERPEEKCHAR())EXIT
        DO ISPEC=1,NSPEC
C Pohyby vsech jedincu, s vyjimkou LEADERa
          IF(ISPEC.NE.LEADER)THEN
C Generuj PRTV vektor perturbaci dle hodnoty PRT
             ZER=.TRUE.
             DO WHILE(ZER)
               DO I=1,NREG
                 IF(RND(IDUMMY).LE.PRT)THEN
                    PRTV(I)=1.
                    ZER=.FALSE.
                 ELSE
                    PRTV(I)=0.
                 ENDIF
               ENDDO
             ENDDO
             DO I=1,NREG
               PWBEST(I)=PARABEST(I,ISPEC)
             ENDDO
             T=STEP
             DO WHILE(T.LE.TMASS)
                DO I=1,NREG
                  PWORK(I)=PWBEST(I)+
     /                  (PARABEST(I,LEADER)-PWBEST(I))*T*PRTV(I)
                  IF(PWORK(I).LT.ZMI(I).OR.PWORK(I).GT.ZMA(I))THEN
                        PWORK(I)=ZMI(I)+(ZMA(I)-ZMI(I))*RND(IDUMMY)
                  ENDIF
                ENDDO
                CALL GMODEL(ITYP,PWORK,LOCPARA,NREG)
                CALL SUMS(SUMSQ,SUMBEST(ISPEC),NREG,
     /                   PWORK,PARABEST(1,ISPEC),YP,YPBEST)
                T=T+STEP
             ENDDO
          ENDIF
        ENDDO
C Novy LEADER po skonceni migracniho kola
        SUMLEAD=1E10
        LEADOLD=LEADER
        DO I=1,NSPEC
           IF(SUMBEST(I).LE.SUMLEAD)THEN
              SUMLEAD=SUMBEST(I)
              LEADER=I
           ENDIF
        ENDDO
        CALL GRESID(IT,ITER,SUMLEAD,1./LEADER,1)
        IF(LEADOLD.NE.LEADER)THEN
           WRITE(9,667)IT,SUMLEAD,(PARABEST(K,LEADER),K=1,NREG)
           WRITE(10,667)IT,SUMLEAD,(PARABEST(K,LEADER),K=1,NREG)
667        FORMAT(I3,' SSQ=',E11.3,' Pleader:',8E11.3)
        ENDIF
      ENDDO
C Vyhodnoceni odchylky
      CALL GMODEL(ITYP,PARABEST(1,LEADER),LOCPARA,NREG)
      CALL SUMS(SUMSQ,SUMBEST(LEADER),NREG,
     /PARABEST(1,LEADER),PARABEST(1,LEADER),YP,YPBEST)
	CALL DMODLIST(ITYP)
      WRITE(9,112)SUMSQ
      WRITE(10,112)SUMSQ
112   FORMAT(/' SOMA Final SSQ=',e11.4)
C Presun parametry PARABEST do finalnich pozic; 
      DO K=1,NREG
         LQ=LMODEL(LOCPARA(K))
         IF(JPARA(K).EQ.1)THEN        
            REALRC(LQ)=PARABEST(K,LEADER)
         ELSE
            INTERC(LQ)=PARABEST(K,LEADER)
         ENDIF
      ENDDO
C Presun nejlepsi predikci do matice bodu pozorovani
      DO IC=1,NCOMPAR
         DO I=ICOMP1,ICOMP2
            YGR(I,ICOMPAR(1,IC))=YPBEST(I,IC)
         ENDDO
      ENDDO
      CLOSE(35)
      SCOMPAR=SUMSQ
	IRESULT=RUNQQ('NOTEPAD.EXE','$SOMA.OUT')
      END


      SUBROUTINE NELDER(ITYP,LISTPAR,NLISTPAR,ITER,NINIT,ALFA,BETA,GAMA,
     /                  SUMSQ)
C OPTIMALIZACE NELDER-MEAN simplexova metoda
C ITYP =0,1,2 interpretovany model dif.rov, 
C          >2 prikazy v souboru na jednotce ITYP
C LISTPAR(NLISTPAR) - indexy regresnich parametru (1,2,... max.NUMODP)
C                     informace o nich jsou LMODEL(),KMODEL(),JMODEL()
C ITER - pocet iteraci
C NINIT- pocet kroku jednorozmerne optimalizace pri generovani prvniho simplexu
C SUMSQ- vysledny vazeny soucet ctvercu odchylek
      USE PEEKAPPMODULE
      PARAMETER (MAXREG=8,MAXPAIR=5,MAXSPEC=6)
      INCLUDE '$FEMLOC'
      DIMENSION LISTPAR(*)
      LOGICAL OPE,ZER
      DIMENSION YP(MAXNTS,MAXPAIR),YPBEST(MAXNTS,MAXPAIR), 
     /  PARA(MAXREG,MAXSPEC),PARABEST(MAXREG,MAXSPEC),SUMBEST(MAXSPEC),
     /  ZMI(MAXREG),ZMA(MAXREG),
     /  PWORK(MAXREG),PWBEST(MAXREG),PWORST(MAXREG),PWCENT(MAXREG),
     /  LOCPARA(MAXREG),KPARA(MAXREG),JPARA(MAXREG),PRTV(MAXREG)
      CHARACTER*57 TSUMSQ

      IF(NCOMPAR.LE.0.OR.ICOMP2-ICOMP1.LT.0)THEN
         CALL HELPC(6,'Specify data for comparison using COMPAR')
         RETURN
      ELSEIF(NLISTPAR.LE.0)THEN
         CALL HELPC(6,'Specify model parameters using PARDEF,PARSET')
         RETURN
      ELSEIF(ITYP.GT.2)THEN
         INQUIRE(UNIT=ITYP,OPENED=OPE)
         IF(.NOT.OPE)THEN
             CALL HELPC(6,'Open session file using OPEN')
             RETURN
         ENDIF
      ENDIF
      OPEN(35,FILE='$NELDER.OUT')
C NREG  pocet parametru linearnich i nelinearnich
      NREG=0
      DO I=1,NLISTPAR
         IQ=LISTPAR(I)
         IF(IQ.GE.1.AND.IQ.LE.NUMODP)THEN
            JQ=JMODEL(IQ)
            KQ=KMODEL(IQ)
            LQ=LMODEL(IQ)
            IF(LQ.GT.0.AND.KQ.GE.1)THEN
               NREG=MIN0(MAXREG,NREG+1)
               LOCPARA(NREG)=IQ
               JPARA(NREG)=JQ
               KPARA(NREG)=KQ
               ZMI(NREG)=ZMINP(IQ)
               ZMA(NREG)=ZMAXP(IQ)
C pocatecni nastaveni NSPEC jedincu. Prvni jedinec - default hodnoty
               IF(JQ.EQ.1)THEN
                 PARA(NREG,1)=REALRC(LQ)
               ELSE
                 PARA(NREG,1)=INTERC(LQ)
               ENDIF
            ELSE
            WRITE(9,'('' Parameter number'',i3,'' is not suitable'')')IQ
            ENDIF
         ENDIF
      ENDDO

      CALL HELPC(5,'Generate simplex')

	NSPEC=NREG+1
C generuje simplex - vrcholy 2,3,...,NSPEC
      DO J=2,NSPEC
	   DO I=1,NREG
             PARA(I,J)=PARA(I,1)
	   ENDDO
	   IR=J-1
	   P=PARA(IR,1)
         IF(NINIT.LE.3)THEN
C jednoduchy nastrel
	      IF(P-ZMI(IR).GT.ZMA(IR)-P)THEN
C optimum blize k horni hranici
       	     PARA(IR,J)=P*.8+ZMA(IR)*.2
	      ELSE
C optimum blize k dolnbi hranici
       	     PARA(IR,J)=P*.8+ZMI(IR)*.2
	      ENDIF
	   ELSE
C-------------alternativni sekce jednorozmerne optimalizace
            WRITE(35,'(/'' 1D minimisation''/)')
            ITBEST=1
	      SBEST=1E10
            DO IT=1,ITER
               CALL DIVPAR(ZMI(IR),ZMA(IR),FLOAT(IT)/FLOAT(ITER+1),
     /                   PARA(IR,J))
               CALL GMODEL(ITYP,PARA(1,J),LOCPARA,NREG)
C sbest=-1 znamen, e vsledek nebude uloen do PARABEST
               CALL SUMS(SUMSQ,-1.,NREG,
     /                   PARA(1,J),PARABEST(1,J),YP,YPBEST)
C ST,NREG,PARA,PARABEST,YP,YPBEST)
               WRITE(TSUMSQ,'(I3,'': P'',i1,''='',e10.3,4X,''S='',E12.4)
     /')IT,IR,PARA(IR,J),SUMSQ
               CALL HELPC(6,TSUMSQ(1:36))
               IF(SUMSQ.LE.SBEST)ITBEST=IT
            ENDDO
            CALL DIVPAR(ZMI(IR),ZMA(IR),FLOAT(ITBEST)/FLOAT(ITER+1),
     /                   PARA(IR,J))
         ENDIF
      ENDDO

C Vyhodnoceni NSPEC jedincu
      SWORST=0
	SBEST=1E10
      DO ISPEC=1,NSPEC
        SUMBEST(ISPEC)=1E10
        CALL GMODEL(ITYP,PARA(1,ISPEC),LOCPARA,NREG)
        CALL SUMS(SUMSQ,SUMBEST(ISPEC),NREG,
     /            PARA(1,ISPEC),PARABEST(1,ISPEC),YP,YPBEST)
        IF(SUMSQ.GT.SWORST)THEN
            SWORST=SUMSQ
            LWORST=ISPEC
        ENDIF
        IF(SUMSQ.LE.SBEST)THEN
            SBEST=SUMSQ
            LBEST=ISPEC
        ENDIF
      ENDDO

      CALL HELPC(5,'Simplex created')

	WRITE(35,'(/'' Initial simplex''/5x,
     /''       P1        P2        P3        P4        P5        P6'')')
	DO ISPEC=1,NSPEC
	   WRITE(35,'(5X,10E10.3)')(PARA(I,ISPEC),I=1,NREG)
	ENDDO
      

Cyklus iteraci
      WRITE(9,'(/1X,30(''-''),''NELDER''/'' No of points'',i6,
     /'' params'',i2/15X,8E11.3)')
     /        NCOMPAR*(ICOMP2-ICOMP1+1),NREG,(PARA(I,1),I=1,NREG)

      DO IT=1,ITER
	  WRITE(10,'('' Simplex loop'',i4,'' of'',i4,''. Press a key to 
     /interrupt...'')')IT,ITER
	  CALL SLEEPQQ(20)
        IF(USERPEEKCHAR())EXIT
	WRITE(35,'(/'' ITERation'',I3)')IT
C Center of samples excluding the worst
        PWCENT=0
	  DO ISPEC=1,NSPEC
           IF(ISPEC.NE.LWORST)THEN
		    DO I=1,NREG
                 PWCENT(I)=PWCENT(I)+PARA(I,ISPEC)
              ENDDO
	     ENDIF
	  ENDDO
	  METODA=0
        DO I=1,NREG
	     PWCENT(I)=PWCENT(I)/NREG
	     PWORST(I)=PARA(I,LWORST)
C Reflection
           PWORK(I)=2*PWCENT(I)-PWORST(I)
           IF(PWORK(I).LT.ZMI(I).OR.PWORK(I).GT.ZMA(I))THEN
                  PWORK(I)=ZMI(I)+(ZMA(I)-ZMI(I))*RND(IDUMMY)
           ENDIF
	  ENDDO
C Evaluate reflection
        CALL GMODEL(ITYP,PWORK,LOCPARA,NREG)
C sbest=-1 znamen, e vsledek nebude uloen do PARABEST
        CALL SUMS(SUMSQ,-1.,NREG,
     /                   PWORK,PARABEST,YP,YPBEST)
        IF(SUMSQ.LE.SBEST.OR.SUMSQ.GE.SWORST)THEN
	     IF(SUMSQ.LE.SBEST)THEN
C Zlepseni vysledku / expanze
              METODA=1
              DO I=1,NREG
	           PWORK(I)=PWCENT(I)*(1+ALFA)-ALFA*PWORST(I)
                 IF(PWORK(I).LT.ZMI(I).OR.PWORK(I).GT.ZMA(I))THEN
                     PWORK(I)=ZMI(I)+(ZMA(I)-ZMI(I))*RND(IDUMMY)
                 ENDIF
	        ENDDO
               CALL HELPC(4,'Very good-expansion')
	     ELSE
C Velmi spatny vysledek /kontrakce
              METODA=2
              DO I=1,NREG
	           PWORK(I)=PWCENT(I)*(1-BETA)+BETA*PWORST(I)
                 IF(PWORK(I).LT.ZMI(I).OR.PWORK(I).GT.ZMA(I))THEN
                     PWORK(I)=ZMI(I)+(ZMA(I)-ZMI(I))*RND(IDUMMY)
                 ENDIF
	        ENDDO
              CALL HELPC(6,'Very bad-contraction')
	     ENDIF
C Prepocitej extrakci, kontrakci
           CALL GMODEL(ITYP,PWORK,LOCPARA,NREG)
C sbest=-1 znamen, e vsledek nebude uloen do PARABEST
           CALL SUMS(SUMSQ,-1.,NREG,
     /                   PWORK,PARABEST,YP,YPBEST)
	  ENDIF
	  WRITE(35,'('' New vertex using '',i2,'' (=0 REFLECTION, =1 EXPAN
     /SION, =2 CONTRACTION)'')')METODA
C Novy krok PWRK(i) a SUMSQ. Rozhodni, zda ma probehnout redukce simplexu
        IF(SUMSQ.LT.SWORST)THEN
C	neni treba provadet redukci, staci nahradit LWORST
           DO I=1,NREG
	        PARA(I,LWORST)=PWORK(I)
	     ENDDO
	     SUMBEST(LWORST)=SUMSQ
	  ELSE
C     redukuj simplex koeficientem GAMA vzhledek k bodu LBEST
           CALL HELPC(6,'Simplex reduction')
           WRITE(35,'('' Simplex reduction'')')
           DO ISPEC=1,NSPEC
	       IF(ISPEC.NE.LBEST)THEN
	         DO I=1,NREG
	           PARA(I,ISPEC)=PARA(I,ISPEC)*GAMA+PARA(I,LBEST)*(1-GAMA)
	         ENDDO
               CALL GMODEL(ITYP,PARA(1,ISPEC),LOCPARA,NREG)
               CALL SUMS(SUMSQ,SUMBEST(ISPEC),NREG,
     /            PARA(1,ISPEC),PARABEST(1,ISPEC),YP,YPBEST)
	       ENDIF
	     ENDDO
	  ENDIF
C Na zaklade hodnot SUMBEST(i) vyber nejlepsi a nejhorsi vrchol simplexu
        SWORST=0
	  SBEST=1E10
        DO ISPEC=1,NSPEC
            SUMSQ=SUMBEST(ISPEC)
            IF(SUMSQ.GT.SWORST)THEN
               SWORST=SUMSQ
               LWORST=ISPEC
            ENDIF
            IF(SUMSQ.LE.SBEST)THEN
               SBEST=SUMSQ
               LBEST=ISPEC
            ENDIF
        ENDDO
	  WRITE(35,'('' Worst vertex'',i3,''('',E12.5,''), best'',i3,'' ('
     /',e12.5,'')'')')LWORST,SWORST,LBEST,SBEST
        T=T+1
        CALL GRESID(IT,ITER,SUMSQ,1.,2)
	  WRITE(TSUMSQ,
     /'(''Iter='',I3,11x,''S-WORST='',E11.4,'' S-BEST='',E11.4)')
     /ITER,SWORST,SBEST
        CALL HELPC(6,TSUMSQ(1:57))
	  
      ENDDO
C Presun nejlepsi predikci do matice bodu pozorovani
      CALL GMODEL(ITYP,PARA(1,LBEST),LOCPARA,NREG)
C Presun parametry PARABEST do finalnich pozic; 
      DO K=1,NREG
         LQ=LMODEL(LOCPARA(K))
         IF(JPARA(K).EQ.1)THEN        
            REALRC(LQ)=PARA(K,LBEST)
         ELSE
            INTERC(LQ)=PARA(K,LBEST)
         ENDIF
      ENDDO
      CLOSE(35)
      SCOMPAR=SUMSQ
C Vyhodnoceni odchylky
      CALL DMODLIST(ITYP)
      WRITE(9,112)SBEST
      WRITE(10,112)SBEST
112   FORMAT(/' Simplex Final SSQ=',e11.4)
	IRESULT=RUNQQ('NOTEPAD.EXE','$NELDER.OUT')
      END


      SUBROUTINE RANDM(ITYP,LISTPAR,NLISTPAR,ITER,SUMSQ)
C Nahodna OPTIMALIZACE
C ITYP =0,1,2 interpretovany model dif.rov, 
C          >2 prikazy v souboru na jednotce ITYP
C LISTPAR(NLISTPAR) - indexy regresnich parametru (1,2,... max.NUMODP)
C                     informace o nich jsou LMODEL(),KMODEL(),JMODEL()
C ITER - pocet iteraci
C SUMSQ- vysledny vazeny soucet ctvercu odchylek
      USE PEEKAPPMODULE
      PARAMETER (MAXREG=8,MAXPAIR=5,MAXSPEC=6)
      INCLUDE '$FEMLOC'
      DIMENSION LISTPAR(*)
      LOGICAL OPE,ZER
      DIMENSION YP(MAXNTS,MAXPAIR),YPBEST(MAXNTS,MAXPAIR), 
     /  PARA(MAXREG),PARABEST(MAXREG),
     /  ZMI(MAXREG),ZMA(MAXREG),PWORK(MAXREG),PWBEST(MAXREG),
     /  LOCPARA(MAXREG),KPARA(MAXREG),JPARA(MAXREG),PRTV(MAXREG)
      IF(NCOMPAR.LE.0.OR.ICOMP2-ICOMP1.LT.0)THEN
         CALL HELPC(6,'Specify data for comparison using COMPAR')
         RETURN
      ELSEIF(NLISTPAR.LE.0)THEN
         CALL HELPC(6,'Specify model parameters using PARDEF,PARSET')
         RETURN
      ELSEIF(ITYP.GT.2)THEN
         INQUIRE(UNIT=ITYP,OPENED=OPE)
         IF(.NOT.OPE)THEN
             CALL HELPC(6,'Open session file using OPEN')
             RETURN
         ENDIF
      ENDIF
      OPEN(35,FILE='$RANDOM.OUT')
C NREG  pocet parametru linearnich i nelinearnich
      NREG=0
      DO I=1,NLISTPAR
         IQ=LISTPAR(I)
         IF(IQ.GE.1.AND.IQ.LE.NUMODP)THEN
            JQ=JMODEL(IQ)
            KQ=KMODEL(IQ)
            LQ=LMODEL(IQ)
            IF(LQ.GT.0.AND.KQ.GE.1)THEN
               NREG=MIN0(MAXREG,NREG+1)
               LOCPARA(NREG)=IQ
               JPARA(NREG)=JQ
               KPARA(NREG)=KQ
               ZMI(NREG)=ZMINP(IQ)
               ZMA(NREG)=ZMAXP(IQ)
C pocatecni nastaveni 
               IF(JQ.EQ.1)THEN
                 PARA(NREG)=REALRC(LQ)
               ELSE
                 PARA(NREG)=INTERC(LQ)
               ENDIF
            ELSE
            WRITE(9,'('' Parameter number'',i3,'' is not suitable'')')IQ
            ENDIF
         ENDIF
      ENDDO
C Vyhodnoceni pocatecniho nastrelu
        SUMBEST=1E10
        CALL GMODEL(ITYP,PARA,LOCPARA,NREG)
        CALL SUMS(SUMSQ,SUMBEST,NREG,
     /            PARA,PARABEST,YP,YPBEST)
Cyklus NAHODNYCH pokusu
      WRITE(9,'(/1X,30(''-''),''RAND''/'' No of points'',i6,'' params'',
     /i2/15X,8E11.3)')
     /        NCOMPAR*(ICOMP2-ICOMP1+1),NREG,(PARA(I),I=1,NREG)
      DO IT=1,ITER
	  WRITE(10,'('' Random sample '',i4,'' of'',i4,''. Press a key to 
     /interrupt...'')')IT,ITER
	  CALL SLEEPQQ(20)
        IF(USERPEEKCHAR())EXIT
        DO I=1,NREG
           PWORK(I)=ZMI(I)+(ZMA(I)-ZMI(I))*RND(IDUMMY)
        ENDDO
        CALL GMODEL(ITYP,PWORK,LOCPARA,NREG)
        CALL SUMS(SUMSQ,SUMBEST,NREG,
     /                   PWORK,PARABEST,YP,YPBEST)
                T=T+1
        CALL GRESID(IT,ITER,SUMSQ,1.,2)
      ENDDO
C Vyhodnoceni odchylky
      CALL GMODEL(ITYP,PARABEST,LOCPARA,NREG)
      CALL SUMS(SUMSQ,SUMBEST,NREG,PARABEST,PARABEST,YP,YPBEST)
	CALL DMODLIST(ITYP)
      WRITE(9,112)SUMSQ
      WRITE(10,112)SUMSQ
112   FORMAT(' Final SSQ=',e11.4)
C Presun parametry PARABEST do finalnich pozic; 
      DO K=1,NREG
         LQ=LMODEL(LOCPARA(K))
         IF(JPARA(K).EQ.1)THEN        
            REALRC(LQ)=PARABEST(K)
         ELSE
            INTERC(LQ)=PARABEST(K)
         ENDIF
      ENDDO
C Presun nejlepsi predikci do matice bodu pozorovani
      DO IC=1,NCOMPAR
         DO I=ICOMP1,ICOMP2
            YGR(I,ICOMPAR(1,IC))=YPBEST(I,IC)
         ENDDO
      ENDDO
      CLOSE(35)
      SCOMPAR=SUMSQ
	IRESULT=RUNQQ('NOTEPAD.EXE','$RANDOM.OUT')
      END



      SUBROUTINE DGAUSS(A,N,NP,B,M,MP,ier)
C
C RESENI SOUSTAVY LINEARNICH ALGEBRAICKYCH ROVNIC GAUSS-JORDANOVOU ELIMINACI
C VSTUPNI PARAMETRY:
C N         - POCET RESENYCH ROVNIC
C M         - POCET RESENYCH PRAVYCH STRAN
C NP,MP     - DEKLARACNI ROZMERY A(NP,NP),B(NP,MP)
C VSTUPNI A VYSTUPNI PARAMETRY
C A(NP,NP)  - MATICE SOUSTAVY
C B(NP,MP)  - PRAVA STRANA A RESENI
C MAXIMALNI POCET ROVNIC = 100
C
C Numerical Recipes p. 28
C
      parameter (nmax=100)
      real*8 a(np,np),b(np,mp),dum,big,pivinv
      dimension ipiv(nmax),indxr(nmax),indxc(nmax)
      ier=0
      do i=1,n
         ipiv(i)=0
      enddo
      do i=1,n
         big=0
         do j=1,n
             if(ipiv(j).ne.1)then
                   do k=1,n
                         if(ipiv(k).eq.0)then
                               if(dabs(a(j,k)).ge.big)then
                                    big=dabs(a(j,k))
                                    irow=j
				    icol=k
                               endif
                         elseif(ipiv(k).gt.1)then
                               ier=1
                               return
                         endif
                    enddo
               endif
          enddo
          ipiv(icol)=ipiv(icol)+1
          if(irow.ne.icol)then
              do l=1,n
                 dum=a(irow,l)
                 a(irow,l)=a(icol,l)
                 a(icol,l)=dum
              enddo
              do l=1,m
                 dum=b(irow,l)
                 b(irow,l)=b(icol,l)
                 b(icol,l)=dum
              enddo
          endif
          indxr(i)=irow
          indxc(i)=icol
          if(a(icol,icol).eq.0.)then
             ier=2
             return
          endif
          pivinv=1.d0/a(icol,icol)
          a(icol,icol)=1.d0
          do l=1,n
             a(icol,l)=a(icol,l)*pivinv
          enddo
          do l=1,m
             b(icol,l)=b(icol,l)*pivinv
          enddo
          do ll=1,n
              if(ll.ne.icol)then
                  dum=a(ll,icol)
                  a(ll,icol)=0
                  do l=1,n
                     a(ll,l)=a(ll,l)-a(icol,l)*dum
                  enddo
                  do l=1,m
                     b(ll,l)=b(ll,l)-b(icol,l)*dum
                  enddo
               endif
           enddo
      enddo
      do l=n,1,-1
         if(indxr(l).ne.indxc(l))then
            do k=1,n
               dum=a(k,indxr(l))
               a(k,indxr(l))=a(k,indxc(l))
               a(k,indxc(l))=dum
            enddo
         endif
      enddo
      end

