      SUBROUTINE MIDE(ICONTR,IE,NL,NUE,AL,BL)
C
C MINIMUM DISSPIVANE A KINETICKE ENERGIE metoda nejmensich ctvercu (uzlove prametry Vx,Vy)
C OPTIONS:  PLANE/AXISYM,
C Elementy: T3,T6,Q4,Q8 (v kazdem uzlu dva parametry VX,VY)
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),
     /          AXX(9,9),AXY(9,9),AYX(9,9),AYY(9,9),
     /          T(9),VX(9),VY(9),
     /          G1(16),G2(16),WT(16),F(9),FX(9),FY(9)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE PRENOSU, 
C T -TEPLOTY Z PREDCHOZI ITERACE, 
C VX,VY-rychlosti proudeni
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE (FK derivace dle ksi)
C 
C TEST PRIPUSTNOSTI ELEMENTU
      IF(NUE.LT.3)RETURN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NGAUS=JGROUP(LEGRP,$GAUSS)
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS)
      H=RRCONS(LRCON,$H)

      IF(ICONTR.EQ.0)THEN
C          
C Stanoveni uzlovych teplot T(*) a rychlosti VX(*),VY(*) z predchozich kroku.
C
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        T(IU)=VAL(LPU($TEMP)+IND,3)
        VX(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,3)
      ENDDO
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C $RPENFAKT    penalizacni faktor (viz $FEM)
C
C NULOVANI MATIC PRENOSU - rozmer NUE
      AXX=0
      AXY=0
      AYX=0
      AYY=0
C
C SESTAVENI MATIC AXX
C
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
         DETWT=DET*WT(IG)
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C
         TEMP=0
         VVX=0
         VVY=0
         RR=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            RR=RR+Y(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
         ENDDO
C MPROP  (3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RHO=RMPROP(LPROP,$RHO)
         VISC=RMPROP(LPROP,$VISC)
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$VISC).NE.0)THEN
C Vypocet invariantu rychlosti deformace jen v pripade, 
C ze je uvazovana promenna viskozita
            DVXDX=0
            DVYDY=0
            DVXDY=0
            DVYDX=0
            DO I=1,NUE
               DVXDX=DVXDX+VX(I)*FX(I)
               DVYDY=DVYDY+VY(I)*FY(I)
               DVXDY=DVXDY+VX(I)*FY(I)
               DVYDX=DVYDX+VY(I)*FX(I)
            ENDDO
C Druhy invariant je AUX(5)
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
            VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
         ENDIF
C SESTAVENI
         DO I=1,NUE
            DO J=1,NUE
              IF(NAXIS.EQ.1)THEN
C Cylindricky souradny system
                 DXX=RR*((4*VISC+2*$RPENFAKT)*FX(I)*FX(J)+
     /                    2*VISC*FY(I)*FY(J)+RHO*F(I)*F(J))
                 DXY=2*RR*(VISC*FY(I)*FX(J)+$RPENFAKT*FX(I)*FY(J)+
     /                     $RPENFAKT*F(J)/RR*FX(I))
                 DYX=2*RR*(VISC*FX(I)*FY(J)+$RPENFAKT*FY(I)*FX(J)+
     /                     $RPENFAKT*F(I)/RR*FX(J))
                 DYY=RR*((4*VISC+2*$RPENFAKT)*FY(I)*FY(J)+
     /                    2*VISC*FX(I)*FX(J)+
     /                    (RHO+(4*VISC+2*$RPENFAKT)/RR**2)*F(I)*F(J)+
     /                    2*$RPENFAKT/RR*(F(I)*FY(J)+F(J)*FY(I)))
               ELSE
C kartezsky souradny system
                 DXX=(4*VISC+2*$RPENFAKT)*FX(I)*FX(J)+
     /                    2*VISC*FY(I)*FY(J)+RHO*F(I)*F(J)
                 DXY=2*(VISC*FY(I)*FX(J)+$RPENFAKT*FX(I)*FY(J))
                 DYX=2*(VISC*FX(I)*FY(J)+$RPENFAKT*FY(I)*FX(J))
                 DYY=(4*VISC+2*$RPENFAKT)*FY(I)*FY(J)+
     /                    2*VISC*FX(I)*FX(J)+RHO*F(I)*F(J)
               ENDIF
               AXX(I,J)=AXX(I,J)+DXX*DETWT
               AXY(I,J)=AXY(I,J)+DXY*DETWT
               AYX(I,J)=AYX(I,J)+DYX*DETWT
               AYY(I,J)=AYY(I,J)+DYY*DETWT
            ENDDO
         ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]] ma rozmer NL = 2 x NUE
C
      AL=0
      BL=0
      DO I=1,NUE
C Stacionarni
         DO J=1,NUE
             AL(2*I-1,2*J-1)=AXX(I,J)
             AL(2*I,2*J)=AYY(I,J)
             AL(2*I-1,2*J)=AXY(I,J)
             AL(2*I,2*J-1)=AYX(I,J)
         ENDDO
      ENDDO

      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing - vypocet invariantu, hustoty dissipovane energie a vykonu
C
        L0=LUE(IE)
        DO IU=1,NUE
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           T(IU)=VAL(LPU($TEMP)+IND,3)
           VX(IU)=VAL(LPU($VX)+IND,3)
           VY(IU)=VAL(LPU($VY)+IND,3)
        ENDDO
C 1.POINT GAUSS
        IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
           CALL FDFT(NUE,X,Y,.33333,.33333,F,FX,FY,DET)
        ELSE
           CALL FDFQ(NUE,X,Y,0.,0.,F,FX,FY,DET)
           DET=DET*4
        ENDIF
        VYM=0
        DVXDX=0
        DVXDY=0
        DVYDX=0
        DVYDY=0
        TEMP=0
        R=0
        DO I=1,NUE
           VYM=VYM+F(I)*VY(I)
           DVXDX=DVXDX+VX(I)*FX(I)
           DVXDY=DVXDY+VX(I)*FY(I)
           DVYDX=DVYDX+VY(I)*FX(I)
           DVYDY=DVYDY+VY(I)*FY(I)
           TEMP=TEMP+T(I)*F(I)
           R=R+Y(I)*F(I)
        ENDDO
        IF(NAXIS.EQ.0)THEN
C Kartezsky souradny system
C DRUHY INVARIANT 
           SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
           EPAR(IE,LEPAR(NAMELE,$EII))=SINV
C DISSIPACE
           VISC=RMPROP(LPROP,$VISC)
           IF(JMPROP(LPROP,$VISC).NE.0)
     /                 VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
           DISSIP=2*VISC*SINV
           EPAR(IE,LEPAR(NAMELE,$EDISS))=DISSIP
C DISSIPOVANY VYKON
           EPAR(IE,LEPAR(NAMELE,$EPOWER))=DISSIP*DET
         ELSE
C CYLINDRICKY SOURADNY SYSTEM
C DRUHY INVARIANT 
           SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2+(VYM/R)**2
           EPAR(IE,LEPAR(NAMELE,$EII))=SINV
C DISSIPACE
           VISC=RMPROP(LPROP,$VISC)
           IF(JMPROP(LPROP,$VISC).NE.0)
     /                   VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
           DISSIP=2*VISC*SINV
           EPAR(IE,LEPAR(NAMELE,$EDISS))=DISSIP
C DISSIPOVANY VYKON
           EPAR(IE,LEPAR(NAMELE,$EPOWER))=DISSIP*DET*R*6.282
         ENDIF
         $RPOWERF=$RPOWERF+EPAR(IE,LEPAR(NAMELE,$EPOWER))
C ----ENDIF ICONTR
      ENDIF
      END

      SUBROUTINE CREE(ICONTR,IE,NL,NUE,AL,BL)
C
C PLOUZIVY TOK NEWTONSKE KAPALINY: RESENI PROUDOVOU FUNKCI
C CYLINDRICKY/KARTEZSKY SOURADNY SYSTEM Z,R
C STACIONARNI PRIPAD. ELEMENTY T3.
C
C POUZITI TROJUHELNIKOVYCH PRVKU BAZELEY (NEUPLNE KUBICKE POLYNOMY) 
C VIZ ZIENKIEWICZ (RUSKY PREKLAD), STR. 203 
C GAUSSOVA INTEGRACE 7 UZLU
C
C Vypocet rychlosti ze stanovenych hodnot derivaci proudove funkce
C
      INCLUDE '$FEMEQ'
      PARAMETER (NGAUS=7)
      DIMENSION AL(NL,NL),BL(NL),
     / X(3),Y(3),GL1(NGAUS),GL2(NGAUS),W(NGAUS),
     / F(9),FX(9),FY(9),FXX(9),FYY(9),FXY(9),FL(3),FLX(3),FLY(3),
     / T(3),VX(3),VY(3)
      DATA GL1,GL2,W/
     /.3333333,.05971587,.4701421,.4701421,.797427,.1012865,.1012865,
     /.3333333,.4701421,.05971587,.4701421,.1012865,.797427,.1012865,
     /.225,.13239415,.13239415,.13239415,.12593918,.12593918,.12593918/
      IF(ICONTR.EQ.0)THEN
C
C ICONTR=0 proudove funkce
        L0=LUE(IE)
        DO I=1,NUE
          IU=IABS(IUE(L0+I))
          X(I)=XX(IU)
          Y(I)=YY(IU)
          T(I)=VAL(LPU($TEMP)+IU,3)
          VX(I)=VAL(LPU($VX)+IU,3)
          VY(I)=VAL(LPU($VY)+IU,3)
        ENDDO
C EGROUP,MPROP,RRCONS
        LEGRP=MAX0(1,IGROUP(IE))
        LPROP=MAX0(1,IMPROP(IE))
C EGROUP (1-THERMAL|STRESS,2-NGAUS,3-PLANE/AXISYM)
        NAMELE=JGROUP(LEGRP,$ENAME)
        NAXIS=JGROUP(LEGRP,$AXIS)
C
C NULOVANI VEKTORU PRAVE STRANY A MATICE AL
        BL=0
        AL=0
        DO IG=1,NGAUS
C Vypocet kubickych bazovych funkci
          CALL FDF3(X,Y,GL1(IG),GL2(IG),F,FX,FY,FXX,FYY,FXY,S)
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-beta) 
          VISC=RMPROP(LPROP,$VISC)
          IF(JMPROP(LPROP,$VISC).NE.0)THEN
C Vypocet invariantu rychlosti deformace a teploty jen v pripade, 
C ze je uvazovana promenna viskozita. Pro aproximaci teploty a
C rychlosti se pouziji linearni bazove funkce
            CALL FDFT(3,X,Y,GL1(IG),GL2(IG),FL,FLX,FLY,S)
            DVXDX=0
            DVYDY=0
            DVXDY=0
            DVYDX=0
            TEMP=0
            DO I=1,3
               DVXDX=DVXDX+VX(I)*FLX(I)
               DVYDY=DVYDY+VY(I)*FLY(I)
               DVXDY=DVXDY+VX(I)*FLY(I)
               DVYDX=DVYDX+VY(I)*FLX(I)
               TEMP=TEMP+T(I)*F(I)
            ENDDO
C Druhy invariant je AUX(5), teplota AUX(11)
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
            VISC=VISC*CURFUN(JMPROP(LPROP,7))
          ENDIF
          RR=Y(1)*GL1(IG)+Y(2)*GL2(IG)+Y(3)*(1-GL1(IG)-GL2(IG))
          DO I=1,NL
            DO J=1,NL
              IF(NAXIS.EQ.1)THEN
C Rov.(7)
                DA=4*(FXY(I)*FXY(J)+FX(I)*FX(J)/RR**2)
     /           -2/RR*(FXY(I)*FX(J)+FXY(J)*FX(I))
     /           +(FXX(J)-FYY(J)+FY(J)/RR)*(FXX(I)-FYY(I)+FY(I)/RR)
                AL(I,J)=AL(I,J)+DA*S*W(IG)*VISC/RR
              ELSE
C Rov.(9)
                DA=(FYY(I)-FXX(I))*(FYY(J)-FXX(J))+4*FXY(I)*FXY(J)
                AL(I,J)=AL(I,J)+DA*S*W(IG)*VISC
              ENDIF
            ENDDO
          ENDDO
        ENDDO
C
      ELSEIF(ICONTR.GT.0)THEN
C
C ICONTR=1 Postprocessing - vypocet rychlosti VX,VY z vypoctenych PSX,PSY
C          ve vsech uzlech elementu
C BL ps1,psx1,psy1, ps2,psx2,psy2, ...
C
        LEGRP=MAX0(1,IGROUP(IE))
        NAXIS=JGROUP(LEGRP,$AXIS)
C Nejprve je treba definovat souradnice, aby bylo mozne v dalsi fazi
C pocitat bazove funkce
        L0=LUE(IE)
        DO I=1,NUE
          IU=IABS(IUE(L0+I))
          X(I)=XX(IU)
          Y(I)=YY(IU)
        ENDDO
        DO I=1,NUE
          IU=IABS(IUE(L0+I))
C VX=DPS/DY
C VY=-DPS/DX
          IF(NAXIS.EQ.0)THEN
              VAL(LPU($VX)+IU,3)=BL(3*I)
              VAL(LPU($VY)+IU,3)=-BL(3*I-1)
          ELSEIF(Y(I).NE.0.)THEN
              VAL(LPU($VX)+IU,3)=BL(3*I)/Y(I)
              VAL(LPU($VY)+IU,3)=-BL(3*I-1)/Y(I)
          ELSE
C rychlost v ose - spravne by to mela byt druha derivace proudove funkce dle R
C musela by se tudiz pouzit FDF3(X,Y,GL1(IG),GL2(IG),F,FX,FY,FXX,FYY,FXY,S),
C pro bod na ose (musel by se stanovit gaussuv uzel). Spokojime se s hodnotou
C druhe derivace FYY v tezisti elementu.
              CALL FDF3(X,Y,0.33333,0.33333,F,FX,FY,FXX,FYY,FXY,S)
              VAX=0
              DO K=1,9
                 VAX=VAX+FYY(K)*BL(K)
              ENDDO
              VAL(LPU($VX)+IU,3)=VAX
C Radialni slozka rychlosti na ose je nulova
              VAL(LPU($VY)+IU,3)=0
          ENDIF
        ENDDO
      ENDIF
      END

      SUBROUTINE MIKE(ICONTR,IE,NL,NUE,AL,BL)
C
C PROUDENI S MINIMALNI KINETICKOU ENERGII
C Dve varianty trojuhelnikovych elementu:
C 1)  Trojuhelnikove elementy 6 uzlu (tlaky jen ve vrcholech), 15 DOF
C     Kvadraticke bazove funkce pro rychlosti, linearni pro tlaky
C 2)  Trojuhelnikove elementy 4 uzly (tlak jen v tezisti), 7 DOF
C     Linearni bazove funkce rychlosti, konstantni pro tlak
C
      INCLUDE '$FEMEQ'
      DIMENSION X(6),Y(6),AL(NL,NL),BL(NL),RM(6,6),
     /          PMX(6,3),PMY(6,3),BX(3)
      DIMENSION G1(7),G2(7),WT(7),T(6),IZ(6),VX(6),VY(6),
     /          F(6),FX(6),FY(6),FL(3),FLX(3),FLY(3)
C Blokovani sestaveni pro nevhodny typ elementu
      IF((NUE.NE.6.AND.NUE.NE.4).OR.
     /   (NL.NE.15.AND.NL.NE.7))RETURN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=JGROUP(LEGRP,$GAUSS)
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,4-ALPHA,5-TE)
      H=RRCONS(LRCON,$H)

      IF(ICONTR.EQ.0)THEN
C Telo procedury jen v rezimu ICONTR=0
         L0=LUE(IE)
         DO IU=1,NUE
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           T(IU)=VAL(LPU($TEMP)+IND,3)
         ENDDO
C TROJUHELNIKOVY ELEMENT
         CALL TGAUS(NGAUS,NGAUS,G1,G2,WT)
C  
C NULOVANI MATIC HMOTNOSTI (RM 6 x 6) 
C                TLAKU (PPX,PPY 6 x 3) EXPANZE (BX 6 x 1)
         RM=0 
         PMX=0
         PMY=0
         BX=0
         DO IG=1,NGAUS
C
C Teprve nyni se vypocet deli na variantu se 6 resp. 4 uzly
C
           IF(NUE.EQ.6)THEN
              IMX=6
              KMX=3          
              CALL FDFT(6,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
              CALL FDFT(3,X,Y,G1(IG),G2(IG),FL,FLX,FLY,DETL)
           ELSE
              IMX=3
              KMX=1          
              CALL FDFT(3,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
              FL(1)=1
           ENDIF
           DETWT=DET*WT(IG)
C Rychlosti a teploty z predchozi iterace v Gaussove uzlu
C Teplota se prirazuje promenne AUX(11) pro interpret funkci
           TEMP=0
           DO I=1,IMX
             TEMP=TEMP+T(I)*F(I)
           ENDDO
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-beta) 
           BETA=RMPROP(LPROP,$BETA)
C TEMPERATURE DEPENDENCIES
           IF(JMPROP(LPROP,$BETA).NE.0)
     /                BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
C------------------------------------------------------------
           DO I=1,IMX
             DO J=1,IMX
C Matice M
               RM(I,J)=RM(I,J)+F(I)*F(J)*DETWT
             ENDDO
C Matice PXX,PYY 
             DO J=1,KMX
C Matice P varianta s uvazovanim asymetricke slozky
                PMX(I,J)=PMX(I,J)-FL(J)*FX(I)*DETWT
                PMY(I,J)=PMY(I,J)-FL(J)*FY(I)*DETWT
             ENDDO
           ENDDO
           DO I=1,KMX
             BX(I)=BX(I)-BETA*FL(I)*DETWT
           ENDDO
         ENDDO
C
C Nulovani matice soustavy a vektoru prave strany
C
         AL=0
         BL=0
C
C Casovy krok DTIME je systemova promenna
C
         IF(NUE.EQ.6)THEN
C
C 6 UZLOVY TROJUHELNIK Sestaveni matic 15 x 15
C Matice M (6 x 6) se presouvaji na pozice 1,4,7,10,12,14 (+1) 
C
            IZ(1:6)=(/1,4,7,10,12,14/)
            DO I=1,6
               DO J=1,6
                  AL(IZ(I),IZ(J))=2*RM(I,J)
                  AL(IZ(I)+1,IZ(J)+1)=2*RM(I,J)
               ENDDO
            ENDDO
C Umisteni prvku PMX a PMY
            DO I=1,3
              BL(3*I)=BX(I)
              DO J=1,3
                 AL(3*I-2,3*J)=PMX(I,J)*DTIME
                 AL(3*I-1,3*J)=PMY(I,J)*DTIME
                 AL(3*I,3*J-2)=PMX(I,J)*DTIME
                 AL(3*I,3*J-1)=PMY(I,J)*DTIME
              ENDDO
            ENDDO
            DO I=4,6
              DO J=1,3
                 AL(2*I+2,3*J)=PMX(I,J)*DTIME
                 AL(2*I+3,3*J)=PMY(I,J)*DTIME
                 AL(3*J,2*I+2)=PMX(I,J)*DTIME
                 AL(3*J,2*I+3)=PMY(I,J)*DTIME
              ENDDO
            ENDDO
         ELSE
C
C 4 UZLOVY TROJUHELNIK MATICE 7 x 7
C
            DO I=1,3
               I2=2*I
               DO J=1,3
                  AL(I2-1,2*J-1)=2*RM(I,J)
                  AL(I2,2*J)=2*RM(I,J)
               ENDDO
               AL(I2-1,7)=PMX(I,1)
               AL(I2,7)=PMY(I,1)
               AL(7,I2-1)=PMX(I,1)
               AL(7,I2)=PMY(I,1)
            ENDDO
         ENDIF

      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing - vypocet invariantu, hustoty dissipovane energie a vykonu
C
        IF(NUE.EQ.6)THEN
           NVEL=6
        ELSE
           NVEL=3
        ENDIF
        L0=LUE(IE)
        DO IU=1,NVEL
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           T(IU)=VAL(LPU($TEMP)+IND,3)
           VX(IU)=VAL(LPU($VX)+IND,4)
           VY(IU)=VAL(LPU($VY)+IND,4)
        ENDDO
C 1.POINT GAUSS
        CALL FDFT(NVEL,X,Y,0.33333,0.33333,F,FX,FY,DET)
        VYM=0
        DVXDX=0
        DVXDY=0
        DVYDX=0
        DVYDY=0
        TEMP=0
        R=0
        DO I=1,NVEL
           VYM=VYM+F(I)*VY(I)
           DVXDX=DVXDX+VX(I)*FX(I)
           DVXDY=DVXDY+VX(I)*FY(I)
           DVYDX=DVYDX+VY(I)*FX(I)
           DVYDY=DVYDY+VY(I)*FY(I)
           TEMP=TEMP+T(I)*F(I)
           R=R+Y(I)*F(I)
        ENDDO
        IF(NAXIS.EQ.0)THEN
C Kartezsky souradny system
C DRUHY INVARIANT 
           SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
           EPAR(IE,LEPAR(NAMELE,$EII))=SINV
C DISSIPACE
           VISC=RMPROP(LPROP,$VISC)
           IF(JMPROP(LPROP,$VISC).NE.0)
     /                 VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
           DISSIP=2*VISC*SINV
           EPAR(IE,LEPAR(NAMELE,$EDISS))=DISSIP
C DISSIPOVANY VYKON
           EPAR(IE,LEPAR(NAMELE,$EPOWER))=DISSIP*DET
         ELSE
C CYLINDRICKY SOURADNY SYSTEM
C DRUHY INVARIANT 
           SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2+(VYM/R)**2
           EPAR(IE,LEPAR(NAMELE,$EII))=SINV
C DISSIPACE
           VISC=RMPROP(LPROP,$VISC)
           IF(JMPROP(LPROP,$VISC).NE.0)
     /                   VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
           DISSIP=2*VISC*SINV
           EPAR(IE,LEPAR(NAMELE,$EDISS))=DISSIP
C DISSIPOVANY VYKON
           EPAR(IE,LEPAR(NAMELE,$EPOWER))=DISSIP*DET*R*6.282
         ENDIF
         $RPOWERF=$RPOWERF+EPAR(IE,LEPAR(NAMELE,$EPOWER))
C ----ENDIF ICONTR
      ENDIF
      END

