C $S14-KLOC
      SUBROUTINE THER3(ICONTR,IE,NL,NUE,AL,BL)
C
C HEAT TRANSFER 3D
C OPTIONS:  STEADY/TRANSIENT
C Elementy: Q8,Q20
C Gaussova integrace Q:1,2,3
C Konvekce: UPWIND (Zienkiewicz)
C Zdrojovy clen: ohmicky ohrev
C Okrajove podminky 3.druhu (alfa-parametr uzlu, Te-Real Const.), IPU>20
C Integrace v case: implicitni, 1.rad
C
C Postprocessing ICONTR=1 vypocet gradientu teploty 
C    EPAR(*,4)=dT/dx  EPAR(*,5)=dT/dy
C
      INCLUDE '$FEMEQ'
      DIMENSION X(20),Y(20),Z(20),AL(NL,NL),BL(NL),
     /      AM(20,20),RM(20,20),BM(20),XG(8),YG(8),ZG(8),
     /      T(20),TOLD(20),U(20),VX(20),VY(20),VZ(20),
     /      IBND(20),IBSF(8,6),ALPHA(20),
     /      G1(27),G2(27),G3(27),WT(27),G(3),W(3),
     /      F(20),FX(20),FY(20),FZ(20)
      LOGICAL LSF
      DATA IBSF /1,2,3,4,9,10,11,12,
     /           5,6,7,8,13,14,15,16,
     /           1,2,6,5,9,18,13,17,
     /           2,3,7,6,10,19,14,18,
     /           3,4,8,7,11,20,15,19,
     /           4,1,5,8,12,17,16,20/
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE VODIVOSTI, RM-MATICE TEPELNYCH KAPACIT, BM-ZDROJ TEPLA
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 4),TOLD-POCATECNI PODMINKA (zona 3), 
C U-elektricky potencial,
C VX,VY,VZ-rychlosti proudeni (zona 3)
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY,FZ-BAZOVE FUNKCE A JEJICH DERIVACE (FK - derivace dle ksi)
C 
C Ze zony $FEM jsou vyuzivany i prvky 
C          IALGOR(2)-potlaceni vypoctu konvektivnich clenu
C          IALGOR(4)-potlaceni vypoctu zdroje tepla
C          IALGOR(5)-upwind
C
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=JGROUP(LEGRP,$GAUSS)
      NHEAT=JGROUP(LEGRP,$HEAT)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,5-TE)
      TE=RRCONS(LRCON,$TE)

      IF(ICONTR.EQ.0)THEN
C          
C   Stanoveni uzlovych teplot T(*), elektrickeho potencialu U(*),
C a rychlosti VX(*),VY(*) z predchozich kroku.
C Identifikace uzlu elementu IBND(*), v nich je status teploty 
C             20 < IPU  . 
C Tento uzel je povazovan za uzel lezici na hranici Gamma, kde je predepsana
C okrajova podminka tretiho druhu (soucinitel prostupu tepla ALPHA 
C je primo uzlovy parametr, proto ho ukladame do vektoru ALPHA(ibnd),
C vnejsi teplota Te je ve vektoru realnych konstant elementu - je tedy
C konstantni).
C   Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VXM,VYM. Tyto hodnoty
C budou vyuzity pro vypocet Pecletova cisla elementu.
C
      IF(MOD(IE,1000).EQ.0)WRITE(*,'('' Element'',i6,'' NL='',i2,'' S/T=
     /'',I1,'' Gauss='',I1,'' Source='',I1)')IE,NL,NONST,NGAUS,NHEAT

      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      ZMIN=1E10
      ZMAX=-1E10
      VXM=0
      VYM=0
      VZM=0
      IBND=0
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))
        ZMIN=AMIN1(ZMIN,Z(IU))
        ZMAX=AMAX1(ZMAX,Z(IU))
        LOCT=LPU($TEMP)+IND
        T   (IU)=VAL(LOCT,4)
        TOLD(IU)=VAL(LOCT,3)
C Identifikace uzlu s okrajovou podminkou tretiho druhu pro teplotu
C IPU>20. Soucinitel alfa nemusi byt konstantni (nasobeni funkci CURFUN)
        IF(IPU(LOCT).GT.20)THEN
           IBND(IU)=IPU(LOCT)
           ALPHA(IU)=VAL(LOCT,1)*CURFUN(IPU(LOCT))
        ENDIF
C elektricky potencial i rychlosti v zone 3 (pocatecni podminky)
        U (IU)=VAL(LPU($VOLT)+IND,3)
        VX(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,3)
        IF(LPU($VZ).GE.0)THEN
           VZ(IU)=VAL(LPU($VZ)+IND,3)
        ELSE
           VZ(IU)=0
        ENDIF
        VXM=VXM+VX(IU)
        VYM=VYM+VY(IU)
        VZM=VZM+VZ(IU)
      ENDDO
      VXM=VXM/NUE
      VYM=VYM/NUE
      VZM=VZM/NUE
      DX=XMAX-XMIN
      DY=YMAX-YMIN
      DZ=ZMAX-ZMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VXM*DX+VYM*DY+VZM*DZ
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VXM**2+VYM**2+VZM**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2+DZ**2)
      ENDIF
C Vypocet uzlu Gaussovy integrace 
C -------------------------------------
      IF(NUE.EQ.8.OR.NUE.EQ.20)THEN
C Isoparametric 8 or 20-node element.
        CALL SGAUS(NGAUS,NGSS,G1,G2,G3,WT,G,W)
      ELSEIF(NUE.EQ.4)THEN
C Tetra
        CALL VGAUS(NGAUS,NGSS,G1,G2,G3,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC VODIVOSTI, TEPELNYCH KAPACIT A ZDROJOVYCH CLENU
      AM=0
      RM=0
      BM=0
C
C SESTAVENI MATICE AM(VODIVOSTI),RM(TEPELNYCH KAPACIT), vektor BM
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.4)THEN
           CALL FDTETRA(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
         ELSE
           CALL FDFVL(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
         ENDIF
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C (hustotu, el.vodivost, cp, tepelnou vodivost). TEMP je promenna AUX(11). 
C Soucasne se pocita intenzita elektrickeho pole UX,UY,UZ (vyuzivaji se
C derivace bazovych funkci FX,FY,FZ) a vektor rychlosti VVX,VVY,VVZ.
C
         TEMP=0
         UX=0
         UY=0
         UZ=0
         VVX=0
         VVY=0
         VVZ=0
         XGA=0
         YGA=0
         ZGA=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            XGA=XGA+X(I)*F(I)
            YGA=YGA+Y(I)*F(I)
            ZGA=ZGA+Z(I)*F(I)
            UX=UX+FX(I)*U(I)
            UY=UY+FY(I)*U(I)
            UZ=UZ+FZ(I)*U(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
            VVZ=VVZ+VZ(I)*F(I)
         ENDDO
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RK=RMPROP(LPROP,$KX)
         CP=RMPROP(LPROP,$CP)
         RHO=RMPROP(LPROP,$RHO)
         RKAPA=RMPROP(LPROP,$KAPPA)
         IF(JMPROP(LPROP,$KX).NE.0)RK=RK*CURFUN(JMPROP(LPROP,$KX))
         IF(JMPROP(LPROP,$CP).NE.0)CP=CP*CURFUN(JMPROP(LPROP,$CP))
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$KAPPA).NE.0)
     /                        RKAPA=RKAPA*CURFUN(JMPROP(LPROP,$KAPPA))
C Modifikace hostoty, cp,... u castice
         CALL PARTMOD3(XGA,YGA,ZGA,VISC,RHO,CP,RK,RKAPA)
         AOPT=0
C Vypocet Pecletova cisla jen pro pripad uvazovani konvekce (IALGOR(2)) 
C a nastaveni upwindu (IALGOR(5))
         IF($ICONV.NE.0.AND.$IUPW.NE.0)THEN
C Soucinitel upwind ALF jako funkce Pecletova cisla elementu
            PE=UMEAN*HMEAN*RHO*CP/(2*RK)
            IF(PE.GT.0.01)THEN
               PE=AMIN1(PE,50.)
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient zadavany uzivatelem $RUPW
               AOPT=ALF*$RUPW*HMEAN/(2*UMEAN)
            ELSE
               AOPT=0
            ENDIF
         ENDIF
C
C Vnitrni zdroje tepla
C Hustota tepelneho vykonu
         Q=RKAPA*(UX**2+UY**2+UZ**2)
         IF(NHEAT.NE.0)Q=Q+CURFUN(NHEAT)
         E1=DET*WT(IG)*RK
         C1=DET*WT(IG)*RHO*CP
         D1=DET*WT(IG)
         DO I=1,NUE
            CONV=F(I)+AOPT*(VVX*FX(I)+VVY*FY(I)+VVZ*FZ(I))
C Respektovani zdroje tepla jen pri nastavenem priznaku IALGOR(4)
         IF($ISOURCE.NE.0)BM(I)=BM(I)+D1*CONV*Q
            DO J=1,NUE
C Viz rovnice (75)
               AM(I,J)=AM(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J)+FZ(I)*FZ(J))
         IF($ICONV.NE.0)AM(I,J)=
     /            AM(I,J)+C1*CONV*(VVX*FX(J)+VVY*FY(J)+VVZ*FZ(J))
               RM(I,J)=RM(I,J)+C1*F(I)*F(J)
            ENDDO
         ENDDO
C----------------------------------------------
      ENDDO
C
C Urceni PLOCH, ktere tvori hranici elementu a na nichz je predepsana
C okrajova podminka tretiho druhu. Vychazi se ze seznamu hranicnich uzlu
C IBND(NBND). Vysledkem je matice IBSF(8,*), jejich sloupce definuji PLOCHU
C indexy (1,2,..NUE) uzlu. Plocha je urcena 4 nebo 8 body, zalezi
C na typu elementu. Pocet ploch je NBSF.
C
      IF(NUE.EQ.8)THEN
        NS=4
      ELSE
        NS=8
      ENDIF
      DO IS=1,6
        LSF=.TRUE.
        DO I=1,NS
           IN=IBSF(I,IS)
           IF(IBND(IN).LE.20)LSF=.FALSE.
           XG(I)=X(IN)
           YG(I)=Y(IN)
           ZG(I)=Z(IN)
        ENDDO
        IF(LSF)THEN
C
C Prispevek hranicnich integralu k matici AM a k vektoru BM
C PLOSNE integraly pocitane NGAUS x NGAUS-bodovou Gaussovou integraci 
C
           DO IG=1,NGAUS
             DO JG=1,NGAUS
C Bazove funkce F(*) v integracnim uzlu IG pocita procedura FDQ
               CALL FDFQ3(NS,XG,YG,ZG,G(IG),G(JG),XXX,YYY,ZZZ,
     /                    F,FX,FY,FZ,DET)
               DETA=DET*W(IG)*W(JG)
C ALPHA (oznacovane AA) v integracnim uzlu IG
               AA=0
               DO I=1,NS
                 AA=AA+ALPHA(IBSF(I,IS))*F(I)
               ENDDO
C Pricteni prispevku k vektoru BM a matici AM
               DO I=1,NS
                  IQ=IBSF(I,IS)
                  BM(IQ)=BM(IQ)+F(I)*TE*DETA*AA
                  DO J=1,NS
                    JQ=IBSF(J,IS)
                    AM(IQ,JQ)=AM(IQ,JQ)+F(I)*F(J)*DETA*AA
                  ENDDO
               ENDDO
             ENDDO
           ENDDO
        ENDIF
      ENDDO
C Konec sekce, ktera identifikovala hranicni PLOCHY (krivky (IBCR)
C =====================================================================
C
C MATICE SOUSTAVY  [[AL]]=[[CM]]  +  [[AM]]*dt
C PRAVA STRANA      [BL] =[[CM]]*[X0] + [Q]*dt
C ...uvazovani okrajovych podminek [[AM]]= ++ alfa*Ni*Nj
C ...konvekce                      [[AM]]= ++ rho*cp*Ni*(ux*Nj,x+uy*Nj,y)
C ...zdrojovy clen                 [Q]= qNi + (alfa*Ni*Te)|gamma
C
C     DTIME je systemova promenna COMMON /FEM/...
C
     
      DO I=1,NL
        IF(NONST.EQ.1)THEN
           BL(I)=BM(I)*DTIME
           DO J=1,NL
C NONSTEADY
             AL(I,J)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
             BL(I)=BL(I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))*TOLD(J)
           ENDDO
        ELSE
C STEADY STATE
           BL(I)=BM(I)
           DO J=1,NL
             AL(I,J)=AM(I,J)
           ENDDO
        ENDIF
      ENDDO
C ==================================

      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing, vypocet gradientu teploty
C
        L0=LUE(IE)
        DO IU=1,NUE
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
          Y(IU)=YY(IND)
          Z(IU)=ZZ(IND)
          T(IU)=VAL(LPU($TEMP)+IND,2)
        ENDDO
C Bazove funkce v tezisti elementu
        IF(NUE.EQ.4)THEN
          CALL FDTETRA(NUE,X,Y,Z,.3333,.3333,.3333,F,FX,FY,FZ,DET)
        ELSE
          CALL FDFVL(NUE,X,Y,Z,.0,.0,0.,F,FX,FY,FZ,DET)
        ENDIF
        GRADX=0
        GRADY=0
        GRADZ=0
        DO I=1,NUE
           GRADX=GRADX+FX(I)*T(I)
           GRADY=GRADY+FY(I)*T(I)
           GRADZ=GRADZ+FZ(I)*T(I)
        ENDDO
        LPX=MAX0(1,LEPAR(NAMELE,$EGTX))
        LPY=MAX0(1,LEPAR(NAMELE,$EGTY))
        LPZ=MAX0(1,LEPAR(NAMELE,$EGTZ))
        EPAR(IE,LPX)=GRADX
        EPAR(IE,LPY)=GRADY
        EPAR(IE,LPZ)=GRADZ
        KEPAR(NAMELE,LPX)=1
        KEPAR(NAMELE,LPY)=1
        KEPAR(NAMELE,LPZ)=1
      ENDIF
      END

      SUBROUTINE CONC3(IOPER,ICONTR,IE,NL,NUE,AL,BL)
C
C KONCENTRACE - TRANSPORTNI ROVNICE HMOTY S REAKCI PRVNIHO RADU
C OPTIONS:  STEADY/TRANSIENT
C Elementy: Q8,Q20
C Gaussova integrace Q:1,2,3
C Konvekce: UPWIND (Zienkiewicz)
C Zdrojovy clen: CHEMICKA REAKCE
C Integrace v case: implicitni, 1.rad
C
      INCLUDE '$FEMEQ'
      DIMENSION X(20),Y(20),Z(20),AL(NL,NL),BL(NL),
     /          AM(20,20),RM(20,20),BM(20),
     /          T(20),C(20),CBC(20),VX(20),VY(20),VZ(20),
     /          G1(27),G2(27),G3(27),WT(27),G(3),W(3),
     /          F(20),FX(20),FY(20),FZ(20)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE DIFUZE, RM-MATICE HMOT, 
C T,C-TEPLOTY A KONCENTRACE Z PREDCHOZIHO CASOVEHO KROKU, 
C VX,VY,VZ-rychlosti proudeni
C G -GAUSSOVY UZLY PRO USECKU, G1,G2,G3-GAUSSOVY UZLY PRO ELEMENT 3D
C W -VAHY GAUS.UZLU PRO USECKU, WT-VAHY GAUS. UZLU PRO ELEMENT 3D
C F,FX,FY,FZ-BAZOVE FUNKCE A JEJICH DERIVACE
C 
C Ze zony $FEM jsou vyuzivany i prvky 
C          IALGOR(2)-potlaceni vypoctu konvektivnich clenu
C          IALGOR(4)-potlaceni vypoctu reakcniho clenu
C          IALGOR(5)-upwind
C          
      IF(ICONTR.EQ.0)THEN
C
C   Stanoveni uzlovych teplot T(*), koncentraci C(*),
C a rychlosti VX(*),VY(*),VZ(*) z predchozich kroku.
C Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VXM,VYM. Tyto hodnoty
C budou vyuzity pro vypocet difuzniho Pecletova cisla elementu.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      ZMIN=1E10
      ZMAX=-1E10
      VXM=0
      VYM=0
      VZM=0
      ACN=0
      ACD=0
      ACA=0
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))
        ZMIN=AMIN1(ZMIN,Z(IU))
        ZMAX=AMAX1(ZMAX,Z(IU))
        T (IU)=VAL(LPU($TEMP)+IND,3)
        SELECT CASE(IOPER)
          CASE($CONC)
            LOC=LPU($CN)+IND
          CASE($COND)
            LOC=LPU($CD)+IND
          CASE($CONA)
            LOC=LPU($CA)+IND
        ENDSELECT
        C(IU)=AMAX1(0.,VAL(LOC,4))
        CBC(IU)=AMAX1(0.,VAL(LOC,3))
        ACN=ACN+VAL(LPU($CN)+IND,4)
        ACD=ACD+VAL(LPU($CD)+IND,4)
        ACA=ACA+VAL(LPU($CA)+IND,4)
        VX(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,3)
        IF(LPU($VZ).GE.0)THEN
           VZ(IU)=VAL(LPU($VZ)+IND,3)
        ELSE
           VZ(IU)=0
        ENDIF
        VXM=VXM+VX(IU)
        VYM=VYM+VY(IU)
        VZM=VZM+VZ(IU)
      ENDDO
      AUX($LDOF+$CN)=ACN/NUE
      AUX($LDOF+$CD)=ACD/NUE
      AUX($LDOF+$CA)=ACA/NUE
      VXM=VXM/NUE
      VYM=VYM/NUE
      VZM=VZM/NUE
      DX=XMAX-XMIN
      DY=YMAX-YMIN
      DZ=ZMAX-ZMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VXM*DX+VYM*DY+VZM*DZ
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VXM**2+VYM**2+VZM**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2+DZ**2)
      ENDIF
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (2-TRANSIENT|STATIC,3-NGAUS,4-PLANE/AXISYM)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=JGROUP(LEGRP,$GAUSS)
      SELECT CASE(IOPER)
      CASE($CONC)
        IDN  =$DN
        IAN  =$AN
        NSOURCE=JGROUP(LEGRP,$NSOURCE)
        NSINK=JGROUP(LEGRP,$NSINK)
      CASE($COND)
        IDN  =$DD
        IAN  =$AD
        NSOURCE=JGROUP(LEGRP,$DSOURCE)
        NSINK=JGROUP(LEGRP,$DSINK)
      CASE($CONA)
        IDN  =$DA
        IAN  =$AA
        NSOURCE=JGROUP(LEGRP,$ASOURCE)
        NSINK=JGROUP(LEGRP,$ASINK)
      ENDSELECT
      IF(MOD(IE,1000).EQ.0)WRITE(*,'('' Element'',i6,'' NL='',i2,'' S/T=
     /'',I1,'' Gauss='',I1)')IE,NL,NONST,NGAUS
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,5-TE)
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.8.OR.NUE.EQ.20)THEN
C Isoparametric 8 or 20-node element.
        CALL SGAUS(NGAUS,NGSS,G1,G2,G3,WT,G,W)
      ELSEIF(NUE.EQ.4)THEN
C Tetra
        CALL VGAUS(NGAUS,NGSS,G1,G2,G3,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC DIFUZE, HMOT
      AM=0
      RM=0
C
C SESTAVENI MATICE AM(DIFUZE),RM(HMOT)
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.4)THEN
           CALL FDTETRA(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
         ELSE
           CALL FDFVL(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
         ENDIF
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru T()) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C (difuzni soucinitel, aktivacni energie, frekvencni faktor). 
C TEMP je promenna AUX(11). 
C
         TEMP=0
         VVX=0
         VVY=0
         VVZ=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
            VVZ=VVZ+VZ(I)*F(I)
         ENDDO
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA,9-DN,10-EN,11-AN) 
         DN =RMPROP(LPROP,IDN)
         AN =RMPROP(LPROP,IAN)
         IF(JMPROP(LPROP,IDN).NE.0)DN=DN*CURFUN(JMPROP(LPROP,IDN))
         IF(JMPROP(LPROP,IAN).NE.0)AN=AN*CURFUN(JMPROP(LPROP,IAN))
         AOPT=0
C Vypocet Pecletova cisla jen pro pripad uvazovani konvekce (IALGOR(2)) 
C a nastaveni upwindu (IALGOR(5))
         IF($ICONV.NE.0.AND.$IUPW.NE.0)THEN
C Soucinitel upwind ALF jako funkce Pecletova cisla elementu
            PE=UMEAN*HMEAN/(2*DN)
            IF(PE.GT.0.01)THEN
               PE=AMIN1(PE,50.)
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient zadavany uzivatelem $RUPW
               AOPT=ALF*$RUPW*HMEAN/(2*UMEAN)
            ELSE
               AOPT=0
            ENDIF
         ENDIF
C Spotreba slozky N chemickou reakci
         Q=AN
         IF(NSINK.NE.0)Q=Q+CURFUN(NSINK)
         SOURCE=0
         IF(NSOURCE.NE.0)SOURCE=CURFUN(NSOURCE)
         E1=DET*WT(IG)*DN
         C1=DET*WT(IG)
         DO I=1,NUE
            WI=F(I)+AOPT*(VVX*FX(I)+VVY*FY(I)+VVZ*FZ(I))
            DO J=1,NUE
               AM(I,J)=AM(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J)+FZ(I)*FZ(J))
               IF($ICONV.NE.0)
     /   AM(I,J)=AM(I,J)+C1*WI*(VVX*FX(J)+VVY*FY(J)+VVZ*FZ(J))
C Respektovani REAKCE jen pri nastavenem priznaku IALGOR(4)
               IF($ISOURCE.NE.0)
     /   AM(I,J)=AM(I,J)+C1*WI*Q*F(J)
               RM(I,J)=RM(I,J)+C1*F(I)*F(J)
            ENDDO
            BM(I)=SOURCE*F(I)*C1
         ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]]=[[CM]]  +  [[AM]]*dt
C PRAVA STRANA      [BL] =[[CM]]*[X0] + [Q]*dt
C
C     DTIME je systemova promenna COMMON /FEM/...
C
      DO I=1,NL
        IF(NONST.EQ.1)THEN
C NONSTEADY
          BL(I)=BM(I)*DTIME
          DO J=1,NL
             AL(I,J)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
             BL(I)=BL(I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))*CBC(J)
          ENDDO
        ELSE
C STEADY STATE
          BL(I)=BM(I)
          DO J=1,NL
             AL(I,J)=AM(I,J)
          ENDDO
        ENDIF
      ENDDO
      ENDIF
      END

      SUBROUTINE ELEC3(ICONTR,IE,NL,NUE,AL,BL)
C
C ELEKTRICKY POTENCIAL - TEPLOTNE ZAVISLA KONDUKTIVITA
C Elementy: T3,T6, Q4,Q8
C Volitelny pocet Gaussovych uzlu integrace T:1,3,4,7 Q:1,2,3
C
      INCLUDE '$FEMEQ'
      DIMENSION X(20),Y(20),Z(20),AL(NL,NL),BL(NL)
      DIMENSION G(3),G1(27),G2(27),G3(27),WT(27),W(3),
     /          F(20),FX(20),FY(20),FZ(20),T(20),V(20)
C AL-MATICE SOUSTAVY, AM-MATICE ELEKTRICKE VODIVOSTI, 
C T -TEPLOTY Z PREDCHOZI ITERACE,
C G -GAUSSOVY UZLY PRO USECKU, G1,G2-GAUSSOVY UZLY PRO ELEMENT
C W -VAHY GAUS.UZLU PRO USECKU, WT-VAHY GAUS. UZLU PRO ELEMENT
C F,FX,FY,FZ-BAZOVE FUNKCE A JEJICH DERIVACE
C
      IF(ICONTR.GE.0)THEN
C
C Stanoveni teplot v uzlovych bodech aby bylo mozne pocitat teplotne
C zavislou elektrickou vodivost
C
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        T(IU)=VAL(LPU($TEMP)+IND,3)
        V(IU)=VAL(LPU($VOLT)+IND,4)
      ENDDO
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (3-NGAUS)
      NGAUS=JGROUP(LEGRP,$GAUSS)
      IF(MOD(IE,1000).EQ.0)WRITE(*,'('' Element'',i6,'' NL='',i2,'' Gaus
     /s='',I1)')IE,NL,NGAUS
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE)

C GAUSSOVA INTEGRACE
      IF(NUE.EQ.8.OR.NUE.EQ.20)THEN
C Isoparametric 8 or 20-node element.
        CALL SGAUS(NGAUS,NGSS,G1,G2,G3,WT,G,W)
      ELSEIF(NUE.EQ.4)THEN
C Tetra
        CALL VGAUS(NGAUS,NGSS,G1,G2,G3,WT)
      ENDIF
C -------------------------
      IF(ICONTR.EQ.0)THEN
C LOKALNI MATICE AL(VODIVOSTI)
C NULOVANI MATICE ELEKTRICKE VODIVOSTI A PRAVE STRANY
        AL=0 
        BL=0
      ELSE
C POWER=integral(kappa.(grad Volt)^2) pres plochu elementu
        POWER=0
      ENDIF
      DO IG=1,NGSS
        IF(NUE.EQ.4)THEN
           CALL FDTETRA(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
        ELSE
           CALL FDFVL(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
        ENDIF
C teplota
        TEMP=0
        XGA=0
        YGA=0
        ZGA=0
        DO I=1,NUE
           TEMP=TEMP+T(I)*F(I)
           XGA=XGA+X(I)*F(I)
           YGA=YGA+Y(I)*F(I)
           ZGA=ZGA+Z(I)*F(I)
        ENDDO
C Vypocet merne elektricke vodivosti v integracnim uzlu
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
        RKAPPA=RMPROP(LPROP,$KAPPA)
        IF(JMPROP(LPROP,$KAPPA).NE.0)
     /               RKAPPA=RKAPPA*CURFUN(JMPROP(LPROP,$KAPPA))
        CALL PARTMOD3(XGA,YGA,ZGA,VISC,RHO,CP,RK,RKAPPA)
        E1=DET*WT(IG)*RKAPPA
        IF(ICONTR.EQ.0)THEN
          DO I=1,NUE
            DO J=1,NUE
              AL(I,J)=AL(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J)+FZ(I)*FZ(J))   
            ENDDO
          ENDDO
        ELSE
          VX=0
          VY=0
          VZ=0
          DO I=1,NUE
             VX=VX+FX(I)*V(I)
             VY=VY+FY(I)*V(I)
             VZ=VZ+FZ(I)*V(I)
          ENDDO
          POWER=POWER+E1*(VX**2+VY**2+VZ**2)
        ENDIF
      ENDDO
      $RPOWERE=$RPOWERE+POWER
      ENDIF
      END

