C $S15-KLO.for

      SUBROUTINE BPIPE(IOPER,MLEV)
C IOPER=3 vypocet teploty
C IOPER=4 vypocet koncentrace
C ciste konvektivni prenos: vychozi hodnoty teplot nebo koncentraci 
C jsou v zone 3, vysledek je prenesen do zony 2 a pak zpet do 3!!
      INCLUDE '$FEMEQ'
      PARAMETER (MAXB=5)
      LENREC=20*MAXB+4
      OPEN(30,FILE='$PIPE.BIN',ACCESS='DIRECT',FORM='BINARY',
     /RECL=LENREC)
      SELECT CASE(IOPER)
      CASE($THER)
         IPP=LPU($TEMP)
      CASE($CONC)
         IPP=LPU($CN)
      CASE($COND)
         IPP=LPU($CD)
      CASE($CONA)
         IPP=LPU($CA)
      ENDSELECT
C MLEV - maximalni uroven rekurze
      MLEV=0
      DO I=1,ND
C Vynechavame uzly, kde je predepsana silna okrajova podminka
C Hodnoty v zone 2 jsou jiz na nove hladine casu TIME.
         KSTATUS=IPU(IPP+I)
         IF(KSTATUS.GE.0)THEN
            CALL CN(IOPER,I,TIME-DTIME,TIME,CNEW,LEV)
            MLEV=MAX0(LEV,MLEV)
            VAL(IPP+I,2)=CNEW
         ENDIF
      ENDDO
      DO I=1,ND
         VAL(IPP+I,3)=VAL(IPP+I,2)
      ENDDO
      CLOSE(30)
      END

      SUBROUTINE CN(IOPER,INOD,T0,T,C,MLEV)
C vypocet koncentrace (ioper=4) nebo teplot (ioper=3) v uzlu INOD v novem
C case T (T0 stary cas). Vychozi hodnoty jsou v zone 3 (pocatecni podminky),
C okrajove podminky jsou vybirany ze zony 2.
C MLEV - maximalni uroven rekurze
      PARAMETER (MAXB=5,MAXL=50)
      INCLUDE '$FEMEQ'
      LOGICAL FIL
      DIMENSION NL(MAXL),IB(MAXL,MAXB),IBE(MAXB),UBE(MAXL,MAXB),
     /          QBE(MAXL,MAXB),HBE(MAXL,MAXB),
     /          JL(MAXL),IL(MAXL),QL(MAXL),CL(MAXL),TL(MAXL)
      SELECT CASE(IOPER)
      CASE($THER)
         IPP=LPU($TEMP)
      CASE($CONC)
         IPP=LPU($CN)
      CASE($COND)
         IPP=LPU($CD)
      CASE($CONA)
         IPP=LPU($CA)
      ENDSELECT
C LEVEL je hloubka vnoreni aktualniho uzlu ICURR ve stromu, ktery ma koren INOD.
C TL(level) je mensi nez T o dobu, kterou potrebuje castice k tomu,
C           aby protekla z korene do uzlu na hladine LEVEL
C N(level)  je pocet sousedu uzlu ICURR, a jejich indexy jsou IB(level,*)
C 
      C=0
      MLEV=1
      LEVEL=1
      I=INOD
      TL(LEVEL)=T
C Navesti 1 zacina novou hladinu LEVEL s korenem v uzlu IL(level)
1     IF(LEVEL.GT.MAXL)THEN
        WRITE(2,'(/'' RECURSION LEVEL EXCEEDS'',I3,'' IN NODE'',I5)')
     /        LEVEL,ICURR
        RETURN
      ENDIF
      READ(30,REC=I)NL(LEVEL),(IB(LEVEL,J),J=1,MAXB),
     /                        (IBE(J),J=1,MAXB),
     /                        (UBE(LEVEL,J),J=1,MAXB),
     /                        (QBE(LEVEL,J),J=1,MAXB),
     /                        (HBE(LEVEL,J),J=1,MAXB)
C QL-soucet kladnych prutoku do uzlu ICURR
C CL-stredni koncetrace v uzlu ICURR pocitana z vazenych koncentraci natoku
C JL-citac sousednich uzlu v uzlu CURRENT (jejich indexy jsou v IB)
      QL(LEVEL)=0
      CL(LEVEL)=0
      JL(LEVEL)=1
      IL(LEVEL)=I
      FIL=.TRUE.
C Navesti 2 zacina cyklus pres sousedy uzlu ICURR
C FIL = FALSE znamena, ze jsme se na 2 vratili po ukonceni vypoctu
C uzlu na vyssi hladine, a ze jiz byla spoctena jeho stredni koncentrace C.
2     ICURR=IL(LEVEL)
      DO WHILE(JL(LEVEL).LE.NL(LEVEL))
C J je pocitadlo sousednich uzlu
C tok z uzlu I do uzlu ICURR rychlosti U
         J=JL(LEVEL)
         I=IB(LEVEL,J)
         U=UBE(LEVEL,J)
         DT=TL(LEVEL)-T0
         UDT=U*DT
         IF(U.GT.0.)THEN
C U>0 znamena pritok do uzlu ICURR z uzlu I
           IF(FIL)THEN
             H=HBE(LEVEL,J)
             IF(H.GE.UDT)THEN
C Element je dost dlouhy - vychozi bod je nekde uvnitr mezi uzly ICURR a I
                CALL CEX(IOPER,ICURR,I,1.-UDT/H,C)
             ELSE
C Element je kratky, vychozi bod bude az v elementech na vyssi hladine
                LEVEL=LEVEL+1
                TL(LEVEL)=TL(LEVEL-1)-H/U
                MLEV=MAX0(MLEV,LEVEL)
                GOTO 1
             ENDIF
           ENDIF
           FIL=.TRUE.
           CL(LEVEL)=CL(LEVEL)+C*QBE(LEVEL,J)
           QL(LEVEL)=QL(LEVEL)+QBE(LEVEL,J)
         ENDIF
         JL(LEVEL)=JL(LEVEL)+1
      ENDDO
      IF(QL(LEVEL).NE.0.)THEN
         C=CL(LEVEL)/QL(LEVEL)
      ELSE
C Do uzlu ICURR nic nepriteka - tzn. musi to byt vstupni uzel a odpovidajici
C hodnota musi byt definovana silnou okrajovou podminku v zone 2 pro
C cas TL(LEVEL)
         TIMESAV=TIME
         TIME=TL(LEVEL)
         KSTATUS=IPU(IPP+ICURR)
         C=VAL(IPP+ICURR,1)*CURFUN(KSTATUS)
         TIME=TIMESAV
      ENDIF
      LEVEL=LEVEL-1
C Dokoncen vypocet koncentrace C v uzlu na vyssi hladine, vracime se
C na nizsi hladinu
      FIL=.FALSE.
      IF(LEVEL.GE.1)GOTO 2
      END

      SUBROUTINE CEX(IOPER,I1,I2,HREL,CC)
      INCLUDE '$FEMEQ'
C Interpolace teploty (ioper=3) nebo koncentrace (ioper=4) mezi uzly I1 a I2
C HREL je relativni vzdalenost od uzlu I1
      SELECT CASE(IOPER)
      CASE($THER)
         CC=VAL(LPU($TEMP)+I1,3)*HREL+VAL(LPU($TEMP)+I2,3)*(1-HREL)
      CASE($CONC)
         CC=VAL(LPU($CN)+I1,3)*HREL+VAL(LPU($CN)+I2,3)*(1-HREL)
      CASE($COND)
         CC=VAL(LPU($CD)+I1,3)*HREL+VAL(LPU($CD)+I2,3)*(1-HREL)
      CASE($CONA)
         CC=VAL(LPU($CA)+I1,3)*HREL+VAL(LPU($CA)+I2,3)*(1-HREL)
      ENDSELECT
      END

      SUBROUTINE BHEXC(ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT metodou charakteristik, 
C Druha faze nasledujici po metode charakteristik,jejiz vysledky jsou v zone 3.
C Vypocet TEPLOT v uzlovych bodech - neuvazuji se konvektivni cleny
C
C Elementy: L2, V4 (specialni 4-uzlovy prvek vymenik)
C Laminarni Newtonska kapalina
C Teplotne zavisla vodivost, cp, hustota (teploty v iteracni zone 4)
C Ohmicky ohrev (napeti v zone 3)
C
      INCLUDE '$FEMEQ'
      DIMENSION X(4),Y(4),Z(4),AL(NL,NL),BL(NL),
     /  RM(2,2),AM(2,2),T(4),TOLD(4),U(2),IEH(2),F(2),FX(2),B(2)
      IF(NUE.NE.2.AND.NUE.NE.4)RETURN
C EGROUP,MPROP,RRCONS
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      LEGRP=MAX0(1,IGROUP(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
      IF(ICONTR.GE.0)THEN
C Reseni i postprocessing
C NEPROVADI SE ZADNE KONTROLY BLOKOVANI 
C EGROUP stationarni/nestacionarni 
      NONST=JGROUP(LEGRP,$ST)
C RRCONS (2-DIAMETER,4-alpha,5-Te,6-Area,7-Perim,8-Volume,9-ratio,10-dUdy)
C Zakladni charakteristiky stejne pro 2-uzlove segmenty i 4-uzlovy vymenik
C ale trochu odlisne interpretovane: U elementu vymenik oznacuje ALPHA sou-
C cinitel prostupu tepla mezi proudy, AREA teplosmennou plochu (a ne plochu
C prurezu kanalu)
      R    =RRCONS(LRCON,$D)/2.
      ALPHA=RRCONS(LRCON,$ALFA)
      TE   =RRCONS(LRCON,$TE)
      AREA =ABS(RRCONS(LRCON,$AREA))
      PERIM=RRCONS(LRCON,$PERIM)
      DUDY =RRCONS(LRCON,$DUDY)
C
      IF(NUE.EQ.2)THEN
C
C 2-UZLOVY SEGMENT TRUBKA
C   Tlaky i prutoky jiz musi byt vypocteny. 
C   Prutoky Q jsou ve sloupci LEPAR(name,$EQ) matice EPAR. 
C   Kladna hodnota Q znamena smer 1-2.
C   Reynoldsovo cislo je ve sloupci LEPAR(name,$ERE)
C   Smykove napeti Tau je ve sloupci LEPAR(name,$ETAU)
C   Parametry ALPHA a TE maji vyznam pro vypocet tepelnych ztrat do okoli.
C
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 4)
C TOLD-pocatecni podminky ze zony 3 (vysledek konvektivni faze reseni)
C U-napeti ze zony pocatecnich podminek (zona 3), urcuje intenzitu elektrickeho
C   pole ve smeru osy trubky. Pokud existuje jeste slozka intenzity elektrickeho
C   pole kolma k ose trubky zadava jako parametr RRCONS dUdy (V/m). 
C   Obe dve tyto slozky elektrickeho pole se povazuji za objemovy zdroj tepla.
C
       L0=LUE(IE)
       DO IU=1,2
         IND=IABS(IUE(L0+IU))
         X(IU)=XX(IND)
         Y(IU)=YY(IND)
         Z(IU)=ZZ(IND)
         T(IU)=VAL(LPU($TEMP)+IND,4)
         TOLD(IU)=VAL(LPU($TEMP)+IND,3)
         U(IU)=VAL(LPU($VOLT)+IND,3)
       ENDDO
C H-delka trubky
       H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
C Stredni teplota elementu pro vypocet viskozity (z predchozi iterace)
       TMEAN=(T(1)+T(2))/2.
       EPAR(IE,LEPAR(NAMELE,$ETMEAN))=TMEAN

       IF(ICONTR.EQ.0)THEN
C
C 2-UZLOVY ELEMENT GENEROVANI SOUSTAVY ROVNIC
C
         TEMP=TMEAN
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RKX =RMPROP(LPROP,$KX)
         CP  =RMPROP(LPROP,$CP)
         RHO =RMPROP(LPROP,$RHO)
         RKAP=RMPROP(LPROP,$KAPPA)
         IF(JMPROP(LPROP,$KX).NE.0)RKX =RKX *CURFUN(JMPROP(LPROP,$KX))
         IF(JMPROP(LPROP,$CP).NE.0)CP  =CP  *CURFUN(JMPROP(LPROP,$CP))
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO *CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$KAPPA).NE.0)
     /                            RKAP=RKAP*CURFUN(JMPROP(LPROP,$KAPPA))
         IF(AREA.GT.0..AND.PERIM.GT.0.)THEN
             R=2.*AREA/PERIM
         ELSEIF(R.GT.0.)THEN
             AREA=3.14159*R**2
             PERIM=6.2832*R
         ELSE
             WRITE(2,*)' Zero cross section in element',IE
             STOP
         ENDIF
C
C Zdroje tepla
C Elektricky vykon (PODELNA A PRICNA SLOZKA INTENZITY EL.POLE)
         IF($ISOURCE.NE.0)THEN
            Q=RKAP*(((U(2)-U(1))/H)**2+DUDY**2)
            IF(NHEAT.NE.0)Q=Q+CURFUN(NHEAT)
            Q=Q*AREA
         ELSE
            Q=0
         ENDIF
C A - teplotni vodivost
         A=RKX/(RHO*CP)
C Termicky odpor jako soucet vnitrnich a vnejsich odporu
         RF=AMAX1(0.,EPAR(IE,LEPAR(NAMELE,$EFOUL)))
         RNU=AMAX1(0.,EPAR(IE,LEPAR(NAMELE,$EQZ)))/RKX
         REXT=1./AMAX1(1E-5,ALPHA)
         RSUM=RF+RNU+REXT
         HH=PERIM/RSUM
C Stredni rychlost 
         UMEAN=EPAR(IE,LEPAR(NAMELE,$EQ))/AREA
         AUMEAN=ABS(UMEAN)
         IF(AUMEAN.LE.1e-10)THEN
            WRITE(*,'('' BHEXC: Zero Flowrate in Element'',I6)')IE
         ENDIF
C Vypocet teplotni disperse AEFF (efektivni teplotni vodivost)
         RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
         CALL DISPERS(A,2.*R,RE,AUMEAN,$RTAUDISP,AEFF,ITAYLOR)
         IF(AEFF.LE.0.)THEN
             WRITE(2,*)' BHEXC: Zero thermal dispersion coefficient'
             STOP
         ENDIF
         ARCP=AREA*RHO*CP
C Bazove funkce a derivace v tezisti elementu (1 bodova Gaussova integrace)
         F(1)=0.5
         F(2)=0.5
         FX(1)=-1./H
         FX(2)=1./H
         RM(1,1)=H/3
         RM(1,2)=H/6
         RM(2,1)=H/6
         RM(2,2)=H/3
         DO I=1,2
           DO J=1,2
             AM(I,J)=(AEFF*FX(I)*FX(J)*ARCP+HH*F(I)*F(J))*H
           ENDDO
           B(I)=F(I)*(HH*TE+Q)*H
         ENDDO
C Lokalni matice elementu
C 
         IF(NONST)THEN
            DO I=1,2
              BL(I)=DTIME*B(I)
              DO J=1,2
                AL(I,J)=RM(I,J)+DTIME*AM(I,J)*$RTHETA
                BL(I)=BL(I)+(RM(I,J)-DTIME*(1-$RTHETA)*AM(I,J))*TOLD(J)
              ENDDO
            ENDDO
          ELSE
C STACIONARNI PRIPAD
            DO I=1,2
              BL(I)=B(I)
              DO J=1,2
                AL(I,J)=AM(I,J)
              ENDDO
            ENDDO
          ENDIF

       ELSE

C 2-UZLOVY ELEMENT POSTPROCESSING (ICONTR.EQ.1) VYPOCET FOULINGU
C   Vyznam parametru zony elementu EPAR: 1-Q, 2-Re, 3-Tau, 4-RF, 5-Tmean
         RFOLD=AMAX1(0.,EPAR(IE,LEPAR(NAMELE,$EFOUL)))
         TAU=EPAR(IE,LEPAR(NAMELE,$ETAU))
         RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
         SELECT CASE($IFOUL)
         CASE(0)
           RF=0.
         CASE(1)
C   Konstanty modelu Ebert Panchal (alfa, aktiv.energie, gamma):
           EPALP=8.39
           EPE=68E3
           EPGAM=4.03E-11
           RGAS=8.314
           RF=RFOLD+DTIME*(EPALP/RE**0.88*EXP(-EPE/(RGAS*(TMEAN+273)))
     /                   -EPGAM*TAU)
         CASE DEFAULT
           RF=RFOLD+DTIME*CURFUN($IFOUL)
         END SELECT
         EPAR(IE,LEPAR(NAMELE,$EFOUL))=AMAX1(0.,RF)
       ENDIF

      ELSE
C
C 4-UZLOVY ELEMENT VYMENIKU TEPLA, TVORENY DVEMA SEGMENTY, JEJICHZ
C   INDEXY JSOU V ZONE EPAR (MAXEPAR-1, MAXEPAR).    
C
       IEH(1)=IEPAR(IE,LEPAR(NAMELE,$EE1))
       IEH(2)=IEPAR(IE,LEPAR(NAMELE,$EE2))
       IF(ALPHA.LE.0..OR.AREA.LE.0.)THEN
          WRITE(*,'('' ZERO ALPHA OR AREA IN HEXCH ELEMENT'',I6)')IE
       ENDIF
C Soucinitel prostupu tepla ze souctu termickych odporu
       RTSUM=1./AMAX1(1E-5,ALPHA)
       DO K=1,2
          IEHK=IEH(K)
C Termofyzikalni vlastnosti proudu K
          NAMELEK=JGROUP(IGROUP(IEHK),$ENAME)
          LPROP=MAX0(1,IMPROP(IEHK))
          RKK  =RMPROP(LPROP,$KX)
C Stredni teplota pro korekce termofyzikalnich vlastnosti
          TEMP=EPAR(IEHK,LEPAR(NAMELEK,$ETMEAN))
          IF(JMPROP(LPROP,$KX).NE.0)RKK =RKK *CURFUN(JMPROP(LPROP,$KX))
C RFK   termicky odpor foulingu
          RFK=EPAR(IEHK,LEPAR(NAMELEK,$EFOUL))
          RTSUM=RTSUM+ABS(EPAR(IEHK,LEPAR(NAMELEK,$EQZ)))/RKK+RFK
       ENDDO
C AREA  teplosmenna plocha
       SK=AREA/RTSUM
C Lokalni matice vymeniku
       BL=0
       AL=0
       DO K=1,2
C Delka segmentu K
          L0=LUE(IEHK)
          DO IU=1,2
             IND=IABS(IUE(L0+IU))
             X(IU)=XX(IND)
             Y(IU)=YY(IND)
             Z(IU)=ZZ(IND)
          ENDDO
          HK=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
C Bazove funkce a derivace v tezisti elementu (1 bodova Gaussova integrace)
          F(1)=0.5
          F(2)=0.5
          FX(1)=-1./HK
          FX(2)=1./HK
C STEADY/TRANSIENT
          IF(NONST)THEN
            SHD=SK*DTIME*HK
          ELSE
            SHD=SK*HK
          ENDIF
          DO I=1,2
            DO J=1,2
              BIJ=F(I)*F(J)*SHD
              IF(K.EQ.2)BIJ=-BIJ
              AL(2*(K-1)+I,J)=BIJ
              AL(2*(K-1)+I,J+2)=-BIJ
            ENDDO
          ENDDO
C konec cyklu pres K-segmenty vymeniku
       ENDDO
      ENDIF
C VYNECHANI TELA PROCEDURY PRI KONTROLE BLOKOVANI PROCEDUROU FTFRIN
      ENDIF
      END

      SUBROUTINE BRTD(IOPER,ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT druha faze
C Vypocet koncentraci v uzlovych bodech metodou charakteristik (bez konvekce)
C
C Elementy: L2 (AXIALNI DISPERZE, CSTR)
C Rozliseni techto dvou typu je dano hodnotou NAMELE =1 (pipe), =2 (CSTR)
C Pocatecni koncentrace je v zone 3 (jako vysledek konvektivniho transportu).
C
      INCLUDE '$FEMEQ'
      DIMENSION X(2),Y(2),Z(2),AL(NL,NL),BL(NL),T(2),C(2),COLD(2),
     /          RM(2,2),AM(2,2),F(2),FX(2)
      IF(NUE.NE.2)RETURN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (NONST=1-TRANSIENT, NAMELE=1-PIPE2D,=7-CSTR,=8-PUMP)
      NONST=JGROUP(LEGRP,$ST)
      NAMELE=JGROUP(LEGRP,$ENAME)
      IF(ICONTR.EQ.0)THEN
C
C NORMALNI VYPOCET FTFRON
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C T-TEPLOTY ZE ZONY 3
C C-KONCENTRACE V ZONE 4 (iteracni)
C COLD- pocatecni koncentrace ze zony 3 (vysledek konvektivniho pulkroku)
C
      L0=LUE(IE)
      DO IU=1,2
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        T(IU)=VAL(LPU($TEMP)+IND,3)
        SELECT CASE(IOPER)
        CASE($CONC)
          C(IU)=AMAX1(0.,VAL(LPU($CN)+IND,4))
          COLD(IU)=AMAX1(0.,VAL(LPU($CN)+IND,3))
        CASE($COND)
          C(IU)=AMAX1(0.,VAL(LPU($CD)+IND,4))
          COLD(IU)=AMAX1(0.,VAL(LPU($CD)+IND,3))
        CASE($CONA)
          C(IU)=AMAX1(0.,VAL(LPU($CA)+IND,4))
          COLD(IU)=AMAX1(0.,VAL(LPU($CA)+IND,3))
        ENDSELECT
      ENDDO
C H-delka trubky
      H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
C RRCONS (2-DIAMETER), AREA-prut.prurez, PERIM-smoceny obvod, V-objem misice
      R=RRCONS(LRCON,$D)/2.
      AREA=ABS(RRCONS(LRCON,$AREA))
      PERIM=RRCONS(LRCON,$PERIM)
      V=RRCONS(LRCON,$VOL)
      IF(AREA.GT.0..AND.PERIM.GT.0.)THEN
          R=2.*AREA/PERIM
      ELSEIF(R.GT.0.)THEN
          AREA=3.14159*R**2
          PERIM=6.2832*R
      ELSE
          WRITE(2,*)' Zero cross section in element',IE
          STOP
      ENDIF
C Stredni teplota elementu pro vypocet koeficientu difuze
      TMEAN=(T(1)+T(2))/2.
      TEMP=TMEAN
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA,9-DN,10-EN,11-AN) 
      DN =RMPROP(LPROP,$DN)
      AN =RMPROP(LPROP,$AN)
      IF(JMPROP(LPROP,$DN).NE.0)DN=DN*CURFUN(JMPROP(LPROP,$DN))
      IF(JMPROP(LPROP,$AN).NE.0)AN=AN*CURFUN(JMPROP(LPROP,$AN))
      ARRHEN=AN
      UMEAN=EPAR(IE,LEPAR(NAMELE,$EQ))/AREA
      AUMEAN=ABS(UMEAN)
      IF(NAMELE.EQ.$PIPE2D)THEN
C
C PIPE model axialni disperze s chemickou reakci
C
C Dispersni koeficient DNEFF
C
         RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
         CALL DISPERS(DN,2.*R,RE,AUMEAN,$RTAUDISP,DNEFF,ITAYLOR)
         IF(DNEFF.LE.0.)THEN
             WRITE(2,*)' BRTD: Zero dispersion coefficient'
             STOP
         ENDIF
C Bazove funkce a derivace v tezisti elementu (1 bodova Gaussova integrace)
         F(1)=0.5
         F(2)=0.5
         FX(1)=-1./H
         FX(2)=1./H
         RM(1,1)=H/3
         RM(1,2)=H/6
         RM(2,1)=H/6
         RM(2,2)=H/3
         DO I=1,2
           DO J=1,2
             AM(I,J)=(DNEFF*FX(I)*FX(J)+F(I)*F(J)*ARRHEN)*H
           ENDDO
         ENDDO
C Lokalni matice elementu bez konvektivnich clenu
         DO I=1,2
           BL(I)=0
           DO J=1,2
             IF(NONST)THEN
                AL(I,J)=RM(I,J)+DTIME*AM(I,J)*$RTHETA
                BL(I)=BL(I)+(RM(I,J)-DTIME*(1-$RTHETA)*AM(I,J))*COLD(J)
             ELSE
                AL(I,J)=AM(I,J)
             ENDIF
           ENDDO
         ENDDO
      ELSEIF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP.OR.NAMELE.EQ.$VALVE)THEN
C
C CSTR - idealne michany reaktor (cista konvekce)
C
         IF(V.LE.0.)THEN
            WRITE(2,'(''ZERO VOLUME OF CSTR ELEMENT='',I6)')IE
            STOP
         ENDIF
         Q=EPAR(IE,LEPAR(NAMELE,$EQ))
         AA=DTIME*ABS(Q)/V
         AC=ARRHEN*DTIME
         AL=0
         BL=0
         IF(Q.GT.0.)THEN
C Uzel 1 je vstup, 2 vystup idealniho misice (nebo cerpadla, ci ventilu)
            AL(2,1)=AA
            AL(2,2)=1+AA+AC
            BL(2)=C(2)
         ELSE
C Uzel 2 je vstup, 1 vystup idealniho misice (nebo crpadla, ci ventilu)
            AL(1,2)=AA
            AL(1,1)=1+AA+AC
            BL(1)=C(1)
          ENDIF
      ENDIF
      ENDIF
      END

      SUBROUTINE WPIPE
C
C zjisteni navaznosti uzlu (a elementu) a zapis do souboru s primym pristupem
C
      PARAMETER (MAXB=5)
      INCLUDE '$FEMEQ'
C IB - indexy sousednich uzlu
C IEB- indexy sousednich elementu
C UBE- rychlosti v sousednich elementech (kladne, kdyz smeruji z IB do I)
C QBE- prutoky v sousednich elementech (kladne, kdyz smeruji z IB do I)
C HBE- delky sousednich elementu
      DIMENSION IB(MAXB),IBE(MAXB),UBE(MAXB),QBE(MAXB),HBE(MAXB),
     /          RHOE(MAXB)
      LENREC=20*MAXB+4
      OPEN(30,FILE='$PIPE.BIN',ACCESS='DIRECT',FORM='BINARY',
     /RECL=LENREC)
      write(*,*)'WPIPE begins. Flow tracking recorded in $PIPE.BIN'
      DO ID=1,ND
        NB=0
        DO IE=1,NE
          IG=IGROUP(IE)
          IF(IG.GT.0.AND.IG.LE.MAXMGROUP.AND.
     /      (JGROUP(IG,$ENAME).EQ.$PIPE2D.OR.
     /       JGROUP(IG,$ENAME).EQ.$VALVE .OR.
     /       JGROUP(IG,$ENAME).EQ.$PUMP  .OR.
     /       JGROUP(IG,$ENAME).EQ.$CSTR)      )THEN
             LE=LUE(IE)
             I1=IABS(IUE(LE+1))
             I2=IABS(IUE(LE+2))
             IF(I1.EQ.ID.OR.I2.EQ.ID)THEN
               NB=MIN0(MAXB,NB+1)
               HBE(NB)=SQRT((XX(I1)-XX(I2))**2+(YY(I1)-YY(I2))**2+
     /                      (ZZ(I1)-ZZ(I2))**2)
               IBE(NB)=IE
               IF(I1.EQ.ID)THEN
                 IB(NB)=I2
                 UBE(NB)=-EPAR(IE,LEPAR($PIPE2D,$EVX))
                 QBE(NB)=-EPAR(IE,LEPAR($PIPE2D,$EQ))
               ELSE
                 IB(NB)=I1
                 UBE(NB)=EPAR(IE,LEPAR($PIPE2D,$EVX))
                 QBE(NB)=EPAR(IE,LEPAR($PIPE2D,$EQ))
               ENDIF
               MULTI=MAX0(1,JGROUP(IG,$EX1))
               QBE(NB)=QBE(NB)*MULTI
             ENDIF
          ENDIF
        ENDDO
        DO I=NB+1,MAXB
           IB(I)=0
           IBE(I)=0
           QBE(I)=0
           UBE(I)=0
           HBE(I)=0
        ENDDO
        WRITE(30,REC=ID)NB,IB,IBE,UBE,QBE,HBE
      ENDDO
C
C Uzel ID ma NB sousednich elementu IBE(1),...,IBE(NB) v nichz jsou
C prutoky QBE(1),...,QBE(NB) (kladne, kdyz smeruji do uzlu ID). 
C NB elementy jsou pouze typu PIPE2D, CSTR, PUMP nebo VALVE.
C Pokus o iteracni zpresneni prutoku tak, aby byla splnena rovnice kontinuity.
C
      write(*,*)' No. of iteration for flowrate correction (variable ICO
     /NT)=',$icont
      DO ITER=1,$ICONT
        DIF=0
        DO ID=1,ND
          READ(30,REC=ID)NB,IB,IBE,UBE,QBE,HBE
C Status tlaku v uzlu ID
          IND=LPU($PRES)+ID
          IPP=IPU(IND)
          IF(IPP.GE.0.AND.NB.GE.1)THEN
C V uzlech, kde je statut PRES=0, musi byt nulovy soucet prutoku.
C V uzlech, kde je zaporny status, je zadan tlak a o prutocich nelze rici nic
C V uzlech, kde je status kladny, je zadan bud objemovy nebo hmotnostni prutok
C Podminka NB>0 znamena, ze vylucujeme uzly, ktere nesouvisi s elementy typu PIPE.
            IF(IPP.GT.0)THEN
              AUX(2)=XX(ID)
              AUX(3)=YY(ID)
              AUX(4)=ZZ(ID)
              DO J=1,MDOF
C AUX(): TIME,XX,YY,ZZ,TEMP,UX,UY,UZ
                 IF(LPU(J).GE.0)AUX(J+$LDOF)=VAL(LPU(J)+ID,3)
              ENDDO
              DM=VAL(IND,1)*CURFUN(IPP)
            ELSE
              DM=0.
            ENDIF
C DM je suma hmotnostnich prutoku v uzlu
            DO INDE=1,NB
              IE=IBE(INDE)
C HUSTOTA kapaliny v elementu IE jako funkce stredni teploty elementu
              LEGRP=MAX0(1,IGROUP(IE))
              LPROP=MAX0(1,IMPROP(IE))
              LE=LUE(IE)
              IF(IABS(IUE(LE+1)).EQ.ID)THEN
                 QBE(INDE)=-EPAR(IE,LEPAR($PIPE2D,$EQ))
              ELSE
                 QBE(INDE)= EPAR(IE,LEPAR($PIPE2D,$EQ))
              ENDIF
C Uprava pro pripad paralelne razenych trubek
              MULTI=MAX0(1,JGROUP(IG,$EX1))
              QBE(NB)=QBE(NB)*MULTI
              IF($IVOLU.EQ.0)THEN
                 NAMELE=JGROUP(LEGRP,$ENAME)
                 TEMP=EPAR(IE,LEPAR(NAMELE,$ETMEAN))
                 RHO=RMPROP(LPROP,$RHO)
                 IF(JMPROP(LPROP,$RHO).NE.0)
     /                  RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
                 RHOE(INDE)=RHO
              ELSE
                 RHOE(INDE)=1.
              ENDIF
              DM=DM+RHOE(INDE)*QBE(INDE)
            ENDDO
C DM by spravne melo byt nula. Je treba jeho pomernou cast odecist od
C prutoku ve vsech vetvich
            DIF=DIF+ABS(DM)
            DM=DM/NB
            DO INDE=1,NB
              Q=QBE(INDE)-DM/RHOE(INDE)*$RELFAKT
C Uloz modifikovane prutoky do zony EPAR 
              IE=IBE(INDE)
              LE=LUE(IE)
              IF(IABS(IUE(LE+1)).EQ.ID)THEN
                 EPAR(IE,LEPAR($PIPE2D,$EQ))=-Q
              ELSE
                 EPAR(IE,LEPAR($PIPE2D,$EQ))=Q
              ENDIF
            ENDDO
          ENDIF
        ENDDO
        IF($DEBUG.NE.0)WRITE(*,*)' ITER=',iter,' Continuity resid:',DIF
C Pozadujeme snizeni DIF o jeden rad.
        IF(ITER.EQ.1)THEN
           DIFDES=DIF*0.1
        ELSEIF(DIF.LE.DIFDES)THEN
           EXIT
        ENDIF
      ENDDO
      CLOSE(30)
      END

      SUBROUTINE BLAYERS(ITER)
C
C Vypocet tloustky mezni vrstvy. Uklada se do zony parametru elementu
C EPAR(IE,LEPAR($PIPE2D,$EQZ)) tzn. sdili stejnou pozici jako pricna sila.
C
      PARAMETER (MAXB=5)
      INCLUDE '$FEMB'
C IB - indexy sousednich uzlu
C IBE- indexy sousednich elementu
C UBE- rychlosti v sousednich elementech (kladne, kdyz smeruji z IB do I)
C QBE- prutoky v sousednich elementech (kladne, kdyz smeruji z IB do I)
C HBE- delky sousednich elementu
      DIMENSION IB(MAXB),IBE(MAXB),UBE(MAXB),QBE(MAXB),HBE(MAXB)
C
      LENREC=20*MAXB+4
      OPEN(30,FILE='$PIPE.BIN',ACCESS='DIRECT',FORM='BINARY',
     /RECL=LENREC)
      DO IE=1,NE
        CALL BLIND(IE,IND,NAM)
        IF(IND.GT.0)EPAR(IE,IND)=0.
      ENDDO
      DO ITER=1,50
        ERROR=0.
        DO ID=1,ND   
          READ(30,REC=ID)NB,IB,IBE,UBE,QBE,HBE
C Prohlizeni sousednich uzlu IB, resp. elementu IBE.
C Nenulova tloustka mezni vrstvy muze byt pouze v elemetech PIPE2D,
C ve vsech ostatnich byla vynulovana a dale se jiz nebude menit.
          IF(NB.EQ.1)THEN
C Pokud je soused jen jeden a tece to do neho, pocita se tloustka z nuly.
            IF(UBE(1).LT.0.) CALL BLAYER(IBE(1),HBE(1),0.)
          ELSEIF(NB.EQ.2)THEN
C Pokud jsou sousede 2, a z obou to priteka (u>0), nedelej nic.
            IF(UBE(1).LT.0..AND.UBE(2).LT.0.)THEN
C Pokud jsou sousede 2, a do obou to odteka, pocitej tloustku z nuly.
               CALL BLAYER(IBE(1),HBE(1),0.)
               CALL BLAYER(IBE(2),HBE(2),0.)
            ELSEIF(UBE(1).LT.0..OR.UBE(2).LT.0.)THEN
C Pokud jsou sousede 2, a tece to z jednoho do druheho, nastavi se tloustka 
C mezni vrstvy v druhem elementu jako prirustek tloustky v elementu prichozim.
               IF(UBE(1).LT.0)THEN
                 I1=2
                 I2=1
               ELSE
                 I1=1
                 I2=2
               ENDIF
               CALL BLIND(IBE(I1),IND,NAM)
               EOLD=EPAR(IBE(I2),IND)
               CALL BLAYER(IBE(I2),HBE(I2),EPAR(IBE(I1),IND))
               ERROR=ERROR+ABS(EOLD-EPAR(IBE(I2),IND))
            ENDIF
          ELSEIF(NB.GT.2)THEN
C Pokud je vice nez 2 sousednich uzlu (vetveni) nastavuje se tloustka
C mezni vrstvy v elementech PIPE2D do nichz smeruje proud (z nuly). 
            DO K=1,NB
               IF(UBE(K).LT.0.) CALL BLAYER(IBE(K),HBE(K),0.)
            ENDDO
          ENDIF
        ENDDO
        IF(ERROR.LE.1E-6)EXIT
      ENDDO
      CLOSE(30)
      END

      SUBROUTINE BLAYER(IE,H,BOLD)
C
C VYPOCET TLOUSTKY MEZNI VRSTVY V ELEMENTU PIPE2D
C IE - index elementu, H - delka elementu, BOLD - tloustka v predchozim
C elementu
C
      INCLUDE '$FEMB'
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      LEGRP=MAX0(1,IGROUP(IE))
      IND=0
      NAM=JGROUP(LEGRP,$ENAME)
      IF(NAM.EQ.$PIPE2D)THEN
C REYNOLDS, D, ...
       RE  =ABS(EPAR(IE,LEPAR($PIPE2D,$ERE)))
       VEL =ABS(EPAR(IE,LEPAR($PIPE2D,$EVX)))
       IF(RE.GT.0..AND.VEL.GT.0.)THEN
         D   =RRCONS(LRCON,$D)
         RKX =RMPROP(LPROP,$KX)
         CP  =RMPROP(LPROP,$CP)
         RHO =RMPROP(LPROP,$RHO)
         A=RKX/(RHO*CP)
         RNY=VEL*D/RE
         PR=RNY/A
         GAMMA=8*VEL/D
C Vypocet rychlosti deformace na stene ze znamych teplot steny a smykoveho
C napeti na stene
         TEMP=EPAR(IE,LEPAR($PIPE2D,$ENU))
         SINV=EPAR(IE,LEPAR($PIPE2D,$ETAU))
         VISC=RMPROP(LPROP,$VISC)
         IF(JMPROP(LPROP,$VISC).NE.0)THEN
C Nenewtonska nebo teplotne zavisla viskozita TEMP,SINV
             VISCA=CURFUN(JMPROP(LPROP,$VISC))*VISC
             IF(VISCA.GT.0.)THEN
               GANEW=SINV/VISCA
               IF(GAMMA*.2<GANEW.AND.GANEW<5.*GAMMA)THEN
                 GAMMA=GANEW
               ELSE
                 WRITE(2,*)IE,' Too large gamma correction',GANEW/GAMMA
                 WRITE(*,*)IE,' Too large gamma correction',GANEW/GAMMA
               ENDIF
             ENDIF
         ENDIF
         IF(RE.LE.2300.)THEN
C LAMINARNI REZIM LEVEQUE
           B1=(D/3.66)**3
           B2=BOLD**3+1.845*PI*A*H/GAMMA
C          B2=BOLD**3+0.7967*A*D*H/VEL
           BNEW=AMIN1(B1,B2)**0.3333333
         ELSE
C TURBULENTNI REZIM COLBURN
           BNEW=D/(0.023*RE**0.8*PR**0.4)
         ENDIF
         CALL BLIND(IE,IND,NAM)
         EPAR(IE,IND)=BNEW
       ENDIF
      ENDIF
      END
         
      SUBROUTINE BLIND(IE,IND,NAM)
C Urceni sloupce matice EPAR kde je tloustka teplotni mezni vrstvy
C IE - vstupni, IND a NAM jsou vystupni parametry
      INCLUDE '$FEMB'
      IG=IGROUP(IE)
      IND=0
      NAM=JGROUP(IG,$ENAME)
      IF(NAM.EQ.$PIPE2D)IND=LEPAR($PIPE2D,$EQZ)
      IF(NAM.EQ.$VALVE )IND=LEPAR($VALVE ,$EQZ)
      IF(NAM.EQ.$PUMP  )IND=LEPAR($PUMP  ,$EQZ)
      IF(NAM.EQ.$CSTR  )IND=LEPAR($CSTR  ,$EQZ)
      END

