C $S16-KLO
      SUBROUTINE BCONVE(IOPER)
C Dvourozmerne elementy PLANE2D nebo FLOW2D
C IOPER=3 vypocet teploty
C IOPER=4 vypocet koncentrace
C ciste konvektivni prenos: vychozi hodnoty teplot nebo koncentraci 
C jsou v zone 3, vysledek je prenesen do zony 2 a pak zpet do 3!!
      INCLUDE '$FEMEQ'
      open(99,file='bconve.out')
      write(99,'(//'' BCONVE starts''/)')
      IF(IOPER.EQ.3)THEN
         IPP=$TEMP
      ELSE
         IPP=$CN
      ENDIF
      DO I=1,ND
C Je-li status uzlu I zaporny, je jiz v zone 2 okrajova podminka 
         LOC=LPU(IPP)+I
         ISTAT=IPU(LOC)
         IF(ISTAT.GE.0)THEN
            CALL CNC(IOPER,I,CNEW)
            VAL(LOC,2)=CNEW
         ENDIF
      ENDDO
      DO I=1,ND
         LOC=LPU(IPP)+I
         VAL(LOC,3)=VAL(LOC,2)
      ENDDO
	CLOSE(99)
      END

      SUBROUTINE CNC(IOPER,INOD,CNEW)
C
C konvektivni transport dle trajektorie
C
      INCLUDE '$FEMEQ'
      DIMENSION VEL(3),XYZ(3),IDF(3)
      DATA IDF/$VX,$VY,$VZ/
      IF(IOPER.EQ.3)THEN
         IPP=$TEMP
      ELSE
         IPP=$CN
      ENDIF
      XYZ(1)=XX(INOD)
      XYZ(2)=YY(INOD)
      XYZ(3)=ZZ(INOD)
      NI=$IHEPI
C Integrace trajektorie s casovym krokem DTIME/METHOD 
      DI=DTIME/NI
      DO I=1,NI
C Rychlosti vyhodnocene v case TIME-DI*(I-1)
         CALL DOFINV(3,IDF,3,XYZ(1),XYZ(2),XYZ(3),IE,VEL)
C	if(i.le.10)write(99,'('' v'',2i3,''='',2e10.3,'' x,y='',2f6.3,
C     /'' ie='',i5)')inod,i,vel(1),vel(2),xyz(1),xyz(2),ie
         IF(IE.LE.0)THEN
C Bod XYZ je jiz mimo vysetrovanou oblast a k prechodu hranice doslo
C priblizne v case TIME - DI*(2I-3)/2. Vyhledame nejblizsi uzel
           NEARI=0
           DISMIN=1E10
           DO J=1,ND
             DIST=(XX(J)-XYZ(1))**2+(YY(J)-XYZ(2))**2+(ZZ(J)-XYZ(3))**2
             IF(DIST.LT.DISMIN)THEN
                NEARI=J
                DISMIN=DIST
             ENDIF
           ENDDO
           LOC=LPU(IPP)+NEARI
           ISTAT=IPU(LOC)
           IF(ISTAT.LT.0)THEN
C Pokud je na vstupu silna okrajova podminka (status<0) pouzijeme hodnoty 
C ze zony 2, ale vyhodnocene v case TIME-DI*I
              TIMESAV=TIME
              TIME=TIME-DI*FLOAT(2*I-3)/2.
              AUX(2)=XX(NEARI)
              AUX(3)=YY(NEARI)
              AUX(4)=ZZ(NEARI)
              CNEW=VAL(LOC,1)*CURFUN(ISTAT)
              TIME=TIMESAV
           ELSE
C Vstupni uzel nebyl fixovany - pouzijeme pocatecni podminku jako nahradni reseni
              CNEW=VAL(LOC,3)
           ENDIF
           RETURN
         ELSE
C Bod XYZ je uvnitr elementu IE a lze aktualizovat jeho pozici.
C Znamenko - odpovida integraci zpet do predchoziho casoveho kroku
           XYZ=XYZ-VEL*DI
         ENDIF
      ENDDO
      CALL DOFINT(IPP,3,XYZ(1),XYZ(2),XYZ(3),IE,CNEW)
      IF(IE.LE.0)THEN
C Stejna situace jako drive, ale k prechodu hranice doslo doslo
C priblizne v case TIME - DIME. Vyhledame nejblizsi uzel
           NEARI=0
           DISMIN=1E10
           DO J=1,ND
             DIST=(XX(J)-XYZ(1))**2+(YY(J)-XYZ(2))**2+(ZZ(J)-XYZ(3))**2
             IF(DIST.LT.DISMIN)THEN
                NEARI=J
                DISMIN=DIST
             ENDIF
           ENDDO
           LOC=LPU(IPP)+NEARI
           ISTAT=IPU(LOC)
           IF(ISTAT.LT.0)THEN
C Pokud je na vstupu silna okrajova podminka (status<0) pouzijeme hodnoty 
C ze zony 2, ale vyhodnocene v case TIME-DTIME (zona 2 totiz odpovida TIME)
              TIMESAV=TIME
              TIME=TIME-DTIME
              AUX(2)=XX(NEARI)
              AUX(3)=YY(NEARI)
              AUX(4)=ZZ(NEARI)
              CNEW=VAL(LOC,1)*CURFUN(ISTAT)
              TIME=TIMESAV
           ELSE
C Vstupni uzel nebyl fixovany - pouzijeme pocatecni podminku jako nahradni reseni
              CNEW=VAL(LOC,3)
           ENDIF
      ENDIF    
      CNEW=AMAX1(0.,CNEW)
      END

      SUBROUTINE BTHER(ICONTR,IE,NL,NUE,AL,BL)
C
C HEAT TRANSFER metoda charakteristik - druhy pulkrok
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C
C Elementy: T3,T6,Q4,Q8
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Zdrojovy clen: ohmicky ohrev
C Okrajove podminky 3.druhu (alfa-parametr uzlu, Te-Real Const.), IPU>20
C Integrace v case: implicitni, 1.rad
C
C Postprocessing ICONTR=1 vypocet gradientu teploty 
C    EPAR(*,4)=dT/dx  EPAR(*,5)=dT/dy
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),
     /          AM(9,9),RM(9,9),BM(9),XG(3),YG(3),
     /          T(9),TOLD(9),U(9),VX(9),VY(9),
     /          IBND(9),IBCR(3,3),ALPHA(9),
     /          G1(16),G2(16),WT(16),F(9),FX(9),FY(9),FK(3),
     /          G(3),W(3)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE VODIVOSTI, RM-MATICE TEPELNYCH KAPACIT, BM-ZDROJ TEPLA
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 4),TOLD-POCATECNI PODMINKA (zona 3!), 
C U-elektricky potencial,
C VX,VY-rychlosti proudeni (zona 3)
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE (FK - derivace dle ksi)
C 
C Ze zony $FEM jsou vyuzivany i prvky 
C          IALGOR(2)-potlaceni vypoctu konvektivnich clenu
C          IALGOR(4)-potlaceni vypoctu zdroje tepla
C          IALGOR(5)-upwind
C
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=JGROUP(LEGRP,$GAUSS)
      NAXIS=JGROUP(LEGRP,$AXIS)
      NHEAT=JGROUP(LEGRP,$HEAT)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,5-TE)
      H=RRCONS(LRCON,$H)
      TE=RRCONS(LRCON,$TE)

      IF(ICONTR.EQ.0)THEN
C          
C   Stanoveni uzlovych teplot T(*), elektrickeho potencialu U(*),
C a rychlosti VX(*),VY(*) z predchozich kroku.
C Identifikace uzlu elementu IBND(*), v nich je status teploty 
C             20 < IPU  . 
C Tento uzel je povazovan za uzel lezici na hranici Gamma, kde je predepsana
C okrajova podminka tretiho druhu (soucinitel prostupu tepla ALPHA 
C je primo uzlovy parametr, proto ho ukladame do vektoru ALPHA(ibnd),
C vnejsi teplota Te je ve vektoru realnych konstant elementu - je tedy
C konstantni).
C   Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VXM,VYM. Tyto hodnoty
C budou vyuzity pro vypocet Pecletova cisla elementu.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      VXM=0
      VYM=0
      L0=LUE(IE)
C NBND - pocet uzlu elementu s okrajovou podminkou tretiho druhu
      NBND=0
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))

        LOCT=LPU($TEMP)+IND
        T   (IU)=VAL(LOCT,4)
        TOLD(IU)=VAL(LOCT,3)
C Identifikace uzlu s okrajovou podminkou tretiho druhu pro teplotu
C IPU>20
        IF(IPU(LOCT).GT.20)THEN
           NBND=NBND+1
           IBND(NBND)=IU
           ALPHA(IU)=VAL(LOCT,1)*CURFUN(IPU(LOCT))
        ENDIF
C elektricky potencial i rychlosti v zone 3 (pocatecni podminky)
        U (IU)=VAL(LPU($VOLT)+IND,3)
        VX(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,3)
        VXM=VXM+VX(IU)
        VYM=VYM+VY(IU)
      ENDDO
      VXM=VXM/NUE
      VYM=VYM/NUE
      DX=XMAX-XMIN
      DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VXM*DX+VYM*DY
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VXM**2+VYM**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2)
      ENDIF
C ======================================================================
C Urceni krivek, ktere tvori hranici elementu a na nichz je predepsana
C okrajova podminka tretiho druhu. Vychazi se ze seznamu hranicnich uzlu
C IBND(NBND). Vysledkem je matice IBCR(3,*), jejich sloupce definuji krivku
C indexy (1,2,..NUE) uzlu. Krivka je urcena dvema nebo tremi body, zalezi
C na typu elementu. Pocet krivek je NBCR.
C
      NBCR=0
      IBCR=0
      IF(NBND.GT.1)THEN
         SELECT CASE(NUE)
         CASE (3)
C
C Trojuhelnik se 3 uzly. 1 nebo 2 strany jsou casti hranice (2 nebo 3 uzly).
C 3333333333333333333333333333333333333333333333333333333333333333333333333
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Dve strany jsou casti hranice. Vsechny 3 vrcholy lezi na hranici a neni jasne
C kterou ze tri stran vyradit. Tato vyjimecna situace se resi prohlizenim
C cele matice konektivity - hleda se vrchol, jehoz uzel neni soucasti zadneho
C jineho elementu.
               DO IB=1,3
C Stanoveni globalniho indexu uzlu
                 INDU=IABS(IUE(L0+IBND(IB)))
                 NB=0
                 DO J=1,NE
                   LOC=LUE(J)
                   DO K=1,NUE
                     IF(IABS(IUE(LOC+K)).EQ.INDU)NB=NB+1
                   ENDDO
                 ENDDO
                 IF(NB.EQ.1)THEN
                   ICORN=IB
                   EXIT
                 ENDIF
               ENDDO
C Uzel ICORN (1,2,3) je roh - v matici konektivity se vyskytl jen jednou.
               IF(ICORN.NE.0)THEN
                 NBCR=2
                 IBCR(1,1)=IBND(ICORN)
                 IBCR(1,2)=IBND(ICORN)
                 IC1=MOD(ICORN,3)+1
                 IC2=MOD(IC1,3)+1
                 IBCR(2,1)=IBND(IC1)
                 IBCR(2,2)=IBND(IC2)
               ENDIF
            ENDIF
         CASE(4)
C Ctyruhelnik se 4-uzly. 1 nebo 2 strany casti hranice (2 nebo 3 uzly)
C 44444444444444444444444444444444444444444444444444444444444444444444
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Soucasti hranice jsou dve strany (3 vylucujeme, i kdyz je to teoreticky mozne)
               NBCR=2             
               IF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.3)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=2
                  IBCR(2,2)=3
              ELSEIF(IBND(1).EQ.2.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=2
                  IBCR(2,1)=3
                  IBCR(1,2)=3
                  IBCR(2,2)=4
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=3
                  IBCR(2,1)=4
                  IBCR(1,2)=4
                  IBCR(2,2)=1
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=4
                  IBCR(2,2)=1
               ENDIF
            ENDIF
         CASE (6)   
C
C Trojuhelnik se 6 uzly. 1 nebo 2 strany (3 nebo 5 uzlu na hranici)
C 66666666666666666666666666666666666666666666666666666666666666666
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-3
               IBCR(2,IB)=IBCR(3,IB)-2
               IF(IBCR(2,IB).GT.3)IBCR(2,IB)=1
            ENDDO
         CASE (8)   
C
C Ctyruhelnik s 8 uzly. 1,2 nebo 3 strany (3,5 nebo 7 uzlu na hranici)
C 88888888888888888888888888888888888888888888888888888888888888888888
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-4
               IBCR(2,IB)=IBCR(3,IB)-3
               IF(IBCR(2,IB).GT.4)IBCR(2,IB)=1
            ENDDO
         END SELECT
      ENDIF
C Konec sekce, ktera identifikovala hranicni krivky (IBCR)
C =====================================================================
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Isoparametric 4 or 8-node element.
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC VODIVOSTI, TEPELNYCH KAPACIT A ZDROJOVYCH CLENU
      AM=0
      RM=0
      BM=0
C
C SESTAVENI MATICE AM(VODIVOSTI),RM(TEPELNYCH KAPACIT), vektor BM
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C (hustotu, el.vodivost, cp, tepelnou vodivost). TEMP je promenna AUX(11). 
C Soucasne se pocita intenzita elektrickeho pole UX,UY (vyuzivaji se
C derivace bazovych funkci FX,FY) a vektor rychlosti VVX,VVY.
C
         TEMP=0
         UX=0
         UY=0
         VVX=0
         VVY=0
         RR=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            UX=UX+FX(I)*U(I)
            UY=UY+FY(I)*U(I)
            RR=RR+Y(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
         ENDDO
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RK=RMPROP(LPROP,$KX)
         CP=RMPROP(LPROP,$CP)
         RHO=RMPROP(LPROP,$RHO)
         RKAPA=RMPROP(LPROP,$KAPPA)
         IF(JMPROP(LPROP,$KX).NE.0)RK=RK*CURFUN(JMPROP(LPROP,$KX))
         IF(JMPROP(LPROP,$CP).NE.0)CP=CP*CURFUN(JMPROP(LPROP,$CP))
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$KAPPA).NE.0)
     /                        RKAPA=RKAPA*CURFUN(JMPROP(LPROP,$KAPPA))
C
C Vnitrni zdroje tepla
C Hustota tepelneho vykonu
         Q=RKAPA*(UX**2+UY**2)
         IF(NHEAT.NE.0)Q=Q+CURFUN(NHEAT)
C Cylindricky souradny system - vse je nasobeno polomerem RR
         IF(NAXIS.EQ.1)H=RR
         E1=DET*WT(IG)*H*RK
         C1=DET*WT(IG)*H*RHO*CP
         D1=DET*WT(IG)*H
         DO I=1,NUE
            CONV=F(I)
C Respektovani zdroje tepla jen pri nastavenem priznaku IALGOR(4)
         IF($ISOURCE.NE.0)BM(I)=BM(I)+D1*CONV*Q
            DO J=1,NUE
C Viz rovnice (75)
               AM(I,J)=AM(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J))
               RM(I,J)=RM(I,J)+C1*F(I)*F(J)
            ENDDO
         ENDDO
C----------------------------------------------
      ENDDO
C
C Prispevek hranicnich integralu k matici AM a k vektoru BM
C Krivkove integraly pocitane 3-bodovou Gaussovou integraci 
C
      G(1:3)=(/-.77459666,0.,.77459666/)
      W(1:3)=(/.5555555,.8888888,.555555/)
C Pocet hranicnich krivek je NBCR
      DO IC=1,NBCR
        IF(IBCR(3,IC).EQ.0)THEN
            NU=2
        ELSE
            NU=3
        ENDIF
        DO I=1,NU
           XG(I)=X(IBCR(I,IC))
           YG(I)=Y(IBCR(I,IC))
        ENDDO
        DO IG=1,3
C Bazove funkce F(*) v integracnim uzlu IG pocita procedura FDCR
           CALL FDCR(NU,XG,YG,G(IG),F,FK,FX,FY,DET)
C Polomer RR a ALPHA (oznacovane AA) v integracnim uzlu IG
           RR=0
           AA=0
           DO I=1,NU
             RR=RR+YG(I)*F(I)
             AA=AA+ALPHA(IBCR(I,IC))*F(I)
           ENDDO
           IF(NAXIS.EQ.1)H=RR
C Pricteni prispevku k vektoru BM a matici AM
           DO I=1,NU
              IQ=IBCR(I,IC)
              BM(IQ)=BM(IQ)+F(I)*TE*W(IG)*DET*H*AA
              DO J=1,NU
                 JQ=IBCR(J,IC)
                 AM(IQ,JQ)=AM(IQ,JQ)+F(I)*F(J)*W(IG)*DET*H*AA
              ENDDO
           ENDDO
        ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]]=[[CM]]  +  [[AM]]*dt
C PRAVA STRANA      [BL] =[[CM]]*[X0] + [Q]*dt
C ...uvazovani okrajovych podminek [[AM]]= ++ alfa*Ni*Nj
C ...konvekce                      [[AM]]= ++ rho*cp*Ni*(ux*Nj,x+uy*Nj,y)
C ...zdrojovy clen                 [Q]= qNi + (alfa*Ni*Te)|gamma
C
C     DTIME je systemova promenna COMMON /FEM/...
C
     
      DO I=1,NL
        IF(NONST.EQ.1)THEN
           BL(I)=BM(I)*DTIME
           DO J=1,NL
C NONSTEADY
             AL(I,J)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
             BL(I)=BL(I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))*TOLD(J)
           ENDDO
        ELSE
C STEADY STATE
           BL(I)=BM(I)
           DO J=1,NL
             AL(I,J)=AM(I,J)
           ENDDO
        ENDIF
      ENDDO
C ==================================

      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing, vypocet gradientu teploty
C
        L0=LUE(IE)
        DO IU=1,NUE
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
          Y(IU)=YY(IND)
          T(IU)=VAL(LPU($TEMP)+IND,2)
        ENDDO
C Bazove funkce v tezisti elementu
        IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
             CALL FDFT(NUE,X,Y,.3333,.3333,F,FX,FY,DET)
        ELSE
             CALL FDFQ(NUE,X,Y,0.,0.,F,FX,FY,DET)
        ENDIF
        GRADX=0
        GRADY=0
        DO I=1,NUE
           GRADX=GRADX+FX(I)*T(I)
           GRADY=GRADY+FY(I)*T(I)
        ENDDO
        LPX=MAX0(1,LEPAR(NAMELE,$EGTX))
        LPY=MAX0(1,LEPAR(NAMELE,$EGTY))
        EPAR(IE,LPX)=GRADX
        EPAR(IE,LPY)=GRADY
        KEPAR(NAMELE,LPX)=1
        KEPAR(NAMELE,LPY)=1
      ENDIF
      END

      SUBROUTINE BCONC(IOPER,ICONTR,IE,NL,NUE,AL,BL)
C
C KONCENTRACE - TRANSPORTNI ROVNICE HMOTY S REAKCI PRVNIHO RADU
C Metoda charakteristik - druhy difuzni pulkrok
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C
C Elementy: T3,T6,Q4,Q8
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Zdrojovy clen: CHEMICKA REAKCE
C Integrace v case: implicitni, 1.rad
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),
     /          AM(9,9),RM(9,9),BM(9),
     /          T(9),C(9),VX(9),VY(9),CBC(9),
     /          G1(16),G2(16),WT(16),F(9),FX(9),FY(9)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE DIFUZE, RM-MATICE HMOT, 
C T,C-TEPLOTY A KONCENTRACE Z PREDCHOZIHO CASOVEHO KROKU, 
C VX,VY-rychlosti proudeni
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE
C 
C Ze zony $FEM jsou vyuzivany i prvky 
C          IALGOR(2)-potlaceni vypoctu konvektivnich clenu
C          IALGOR(4)-potlaceni vypoctu reakcniho clenu
C          IALGOR(5)-upwind
C          
      IF(ICONTR.EQ.0)THEN

C
C   Stanoveni uzlovych teplot T(*), koncentraci C(*),
C a rychlosti VX(*),VY(*) z predchozich kroku.
C Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VXM,VYM. Tyto hodnoty
C budou vyuzity pro vypocet difuzniho Pecletova cisla elementu.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      VXM=0
      VYM=0
      ACN=0.
      ACD=0.
      ACA=0.
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))
        T (IU)=VAL(LPU($TEMP)+IND,3)
C Koncentrace ze zony 3 (konvektivni)
        SELECT CASE(IOPER)
          CASE($CONC)
            LOC=LPU($CN)+IND
          CASE($COND)
            LOC=LPU($CD)+IND
          CASE($CONA)
            LOC=LPU($CA)+IND
        ENDSELECT
        C(IU)=AMAX1(0.,VAL(LOC,4))
        CBC(IU)=AMAX1(0.,VAL(LOC,3))
        ACN=ACN+VAL(LPU($CN)+IND,4)
        ACD=ACD+VAL(LPU($CD)+IND,4)
        ACA=ACA+VAL(LPU($CA)+IND,4)
        VX(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,3)
        VXM=VXM+VX(IU)
        VYM=VYM+VY(IU)
      ENDDO
      AUX($LDOF+$CN)=ACN/NUE
      AUX($LDOF+$CD)=ACD/NUE
      AUX($LDOF+$CA)=ACA/NUE
      VXM=VXM/NUE
      VYM=VYM/NUE
      DX=XMAX-XMIN
      DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VXM*DX+VYM*DY
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VXM**2+VYM**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2)
      ENDIF
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (2-TRANSIENT|STATIC,3-NGAUS,4-PLANE/AXISYM)
      SELECT CASE(IOPER)
      CASE($CONC)
        IDN  =$DN
        IAN  =$AN
        NSOURCE=JGROUP(LEGRP,$NSOURCE)
        NSINK=JGROUP(LEGRP,$NSINK)
      CASE($COND)
        IDN  =$DD
        IAN  =$AD
        NSOURCE=JGROUP(LEGRP,$DSOURCE)
        NSINK=JGROUP(LEGRP,$DSINK)
      CASE($CONA)
        IDN  =$DA
        IAN  =$AA
        NSOURCE=JGROUP(LEGRP,$ASOURCE)
        NSINK=JGROUP(LEGRP,$ASINK)
      ENDSELECT
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=JGROUP(LEGRP,$GAUSS)
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,5-TE)
      H=RRCONS(LRCON,$H)
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Isoparametric 4 or 8-node element.
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC DIFUZE, HMOT
      AM=0
      RM=0
C
C SESTAVENI MATICE AM(DIFUZE),RM(HMOT)
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru T()) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C (difuzni soucinitel, aktivacni energie, frekvencni faktor). 
C TEMP je promenna AUX(11). 
C
         TEMP=0
         VVX=0
         VVY=0
         RR=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            RR=RR+Y(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
         ENDDO
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA,9-DN,10-EN,11-AN) 
         DN =RMPROP(LPROP,IDN)
         AN =RMPROP(LPROP,IAN)
         IF(JMPROP(LPROP,IDN).NE.0)DN=DN*CURFUN(JMPROP(LPROP,IDN))
         IF(JMPROP(LPROP,IAN).NE.0)AN=AN*CURFUN(JMPROP(LPROP,IAN))
C Spotreba slozky N chemickou reakci
         Q=AN
         IF(NSINK.NE.0)Q=Q+CURFUN(NSINK)
         SOURCE=0.
         IF(NSOURCE.NE.0)SOURCE=CURFUN(NSOURCE)
C Cylindricky souradny system - vse je nasobeno polomerem RR
         IF(NAXIS.EQ.1)H=RR
         E1=DET*WT(IG)*H*DN
         C1=DET*WT(IG)*H
C matice elementu
         DO I=1,NUE
            WI=F(I)
            DO J=1,NUE
C Viz rovnice (86)
               AM(I,J)=AM(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J))
C Respektovani REAKCE jen pri nastavenem priznaku IALGOR(4)
               IF($ISOURCE.NE.0)
     /   AM(I,J)=AM(I,J)+C1*WI*Q*F(J)
               RM(I,J)=RM(I,J)+C1*F(I)*F(J)
            ENDDO
            BM(I)=SOURCE*F(I)*C1
         ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]]=[[CM]]  +  [[AM]]*dt
C PRAVA STRANA      [BL] =[[CM]]*[X0] + [Q]*dt
C
C     DTIME je systemova promenna COMMON /FEM/...
C
      DO I=1,NL
        IF(NONST.EQ.1)THEN
C NONSTEADY
          BL(I)=BM(I)*DTIME
          DO J=1,NL
             AL(I,J)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
             BL(I)=BL(I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))*CBC(J)
          ENDDO
        ELSE
C STEADY STATE
          BL(I)=BM(I)
          DO J=1,NL
             AL(I,J)=AM(I,J)
          ENDDO
        ENDIF
      ENDDO
      ENDIF
      END

