C $S17-KLOC
      SUBROUTINE PENS3(ICONTR,IE,NL,NUE,AL,BL)
C
C 3D STOKESOVY ROVNICE - PENALTY METHOD (uzlove prametry Vx,Vy,Vz)
C OPTIONS:  STEADY/TRANSIENT
C Elementy: TETRA4,Q6,Q20 (v kazdem uzlu TRI parametry VX,VY,VZ)
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Zdrojovy clen: prirozena konvekce
C Integrace v case: implicitni, 1.rad
C
      INCLUDE '$FEMEQ'
      DIMENSION X(20),Y(20),Z(20),AL(NL,NL),BL(NL),
     /          AMX(20,20),AMY(20,20),AMZ(20,20),RM(20,20),
     /          PMXY(20,20),PMXZ(20,20),PMYZ(20,20),
     /          BMX(20),BMY(20),BMZ(20),
     /          T(20),VX(20),VY(20),VZ(20),
     /          VXOLD(20),VYOLD(20),VZOLD(20),
     /          G1(27),G2(27),G3(27),WT(27),G(3),W(3),
     /          F(20),FX(20),FY(20),FZ(20)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE PRENOSU, RM-MATICE HMOT, PM-NAHRADA GRAD.TLAKU
C BM-VZTLAK
C T -TEPLOTY Z PREDCHOZI ITERACE, 
C VX,VY,VZ-rychlosti proudeni
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2,G3-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY,FZ-BAZOVE FUNKCE A JEJICH DERIVACE 
C
C Pocitadlo zpracovavanych elementu
C     ICOUNTS=ICOUNTS+1
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))

      IF(ICONTR.EQ.0)THEN
C          
C Stanoveni uzlovych teplot T(*) a rychlosti VX(*),VY(*),VZ(*) z predchozich kroku.
C
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        T(IU)=VAL(LPU($TEMP)+IND,3)
        VX(IU)=VAL(LPU($VX)+IND,4)
        VXOLD(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,4)
        VYOLD(IU)=VAL(LPU($VY)+IND,3)
        VZ(IU)=VAL(LPU($VZ)+IND,4)
        VZOLD(IU)=VAL(LPU($VZ)+IND,3)
      ENDDO
C 
C Vypocet uzlu Gaussovy integrace zvlast pro CTYRSTENY/SESTISTENY
C ---------------------------------------------------------------------
      IF(NUE.EQ.6.OR.NUE.EQ.20)THEN
C BRICK elementy
        CALL SGAUS(NGAUS,NGSS,G1,G2,G3,WT,G,W)
      ELSE
C TETRA
        CALL VGAUS(NGAUS,NGSS,G1,G2,G3,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C $RGX,$RGY jsou slozky zrychleni 
C $RPENFAKT    penalizacni faktor
C
C NULOVANI MATIC PRENOSU A HMOTNOSTI A ZDROJOVYCH CLENU - rozmer NUE
      AMX=0
      AMY=0
      AMZ=0
      RM=0
      PMXY=0
      PMYZ=0                                 
      PMXZ=0
C je treba doplnit algoritmy interakcnich sil
      BMX=0
      BMY=0
      BMZ=0
C
C SESTAVENI MATICE AM(vazke sily a konvekce),RM(hmotnosti), vektor BM
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.4)THEN 
           CALL FDTETRA(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
         ELSE
           CALL FDFVL(NUE,X,Y,Z,G1(IG),G2(IG),G3(IG),F,FX,FY,FZ,DET)
         ENDIF
         DETWT=DET*WT(IG)
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C
         TEMP=0
         XG=0.
         YG=0.
         ZG=0.
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            XG=XG+F(I)*X(I)
            YG=YG+F(I)*Y(I)
            ZG=ZG+F(I)*Z(I)
         ENDDO
C MPROP  (3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RHO=RMPROP(LPROP,$RHO)
         VISC=RMPROP(LPROP,$VISC)
         BETA=RMPROP(LPROP,$BETA)
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$BETA).NE.0)
     /                           BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
         IF(JMPROP(LPROP,$VISC).NE.0)
     /                           VISC=VISC*CURFUN(JMPROP(LPROP,7))
C ------ PARTICLE modifikace viskozity, hustoty, cp, kx, KAPPA
         CALL PARTMOD3(XG,YG,ZG,VISC,RHO,CP,RKX,RKAPPA)

C SESTAVENI
         DO I=1,NUE
            DO J=1,NUE
C Matice M
              RM(I,J)=RM(I,J)+RHO*F(I)*F(J)*DETWT
C Matice A
              AMX(I,J)=AMX(I,J)+((VISC+$RPENFAKT)*FX(I)*FX(J)+
     /                            VISC*(FY(I)*FY(J)+FZ(I)*FZ(J)))*DETWT
              AMY(I,J)=AMY(I,J)+((VISC+$RPENFAKT)*FY(I)*FY(J)+
     /                            VISC*(FX(I)*FX(J)+FZ(I)*FZ(J)))*DETWT
              AMZ(I,J)=AMZ(I,J)+((VISC+$RPENFAKT)*FZ(I)*FZ(J)+
     /                            VISC*(FY(I)*FY(J)+FX(I)*FX(J)))*DETWT
              PMXY(I,J)=PMXY(I,J)+$RPENFAKT*.5*(FX(I)*FY(J)+FY(I)*FX(J))
     /*DETWT
              PMXZ(I,J)=PMXZ(I,J)+$RPENFAKT*.5*(FX(I)*FZ(J)+FZ(I)*FX(J))
     /*DETWT
              PMYZ(I,J)=PMYZ(I,J)+$RPENFAKT*.5*(FZ(I)*FY(J)+FY(I)*FZ(J))
     /*DETWT
            ENDDO
         ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]] ma rozmer NL = 3 x NUE
C
C     DTIME je systemova promenna COMMON /FEM/...
C
      AL=0
      BL=0
      DO I=1,NUE
        IF(NONST.EQ.1)THEN
C Nestacionarni pripad
           BL(3*I-2)=BMX(I)*DTIME
           BL(3*I-1)=BMY(I)*DTIME
           BL(3*I)  =BMZ(I)*DTIME
           DO J=1,NUE
             BL(3*I-2)=BL(3*I-2)+RM(I,J)*VXOLD(J)
             BL(3*I-1)=BL(3*I-1)+RM(I,J)*VYOLD(J)
             BL(3*I)  =BL(3*I)  +RM(I,J)*VZOLD(J)
             AL(3*I-2,3*J-2)=RM(I,J)+AMX(I,J)*DTIME
             AL(3*I-1,3*J-1)=RM(I,J)+AMY(I,J)*DTIME
             AL(3*I,3*J)    =RM(I,J)+AMZ(I,J)*DTIME
             AL(3*I-2,3*J-1)=PMXY(I,J)*DTIME
             AL(3*I-2,3*J)  =PMXZ(I,J)*DTIME
             AL(3*I-1,3*J-2)=PMXY(I,J)*DTIME
             AL(3*I-1,3*J)  =PMYZ(I,J)*DTIME
             AL(3*I,3*J-2)  =PMXZ(I,J)*DTIME
             AL(3*I,3*J-1)  =PMYZ(I,J)*DTIME
           ENDDO
        ELSE
C Stacionarni
           BL(3*I-2)=BMX(I)
           BL(3*I-1)=BMY(I)
           BL(3*I)  =BMZ(I)
           DO J=1,NUE
             AL(3*I-2,3*J-2)=AMX(I,J)
             AL(3*I-1,3*J-1)=AMY(I,J)
             AL(3*I,3*J)    =AMZ(I,J)
             AL(3*I-2,3*J-1)=PMXY(I,J)
             AL(3*I-2,3*J)  =PMXZ(I,J)
             AL(3*I-1,3*J-2)=PMXY(I,J)
             AL(3*I-1,3*J)  =PMYZ(I,J)
             AL(3*I,3*J-2)  =PMXZ(I,J)
             AL(3*I,3*J-1)  =PMYZ(I,J)
           ENDDO
        ENDIF
      ENDDO

      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing - dissipovana energie? zatim vynechano
C
        L0=LUE(IE)
        DO IU=1,NUE
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           Z(IU)=ZZ(IND)
           T(IU)=VAL(LPU($TEMP)+IND,3)
           VX(IU)=VAL(LPU($VX)+IND,2)
           VY(IU)=VAL(LPU($VY)+IND,2)
           VZ(IU)=VAL(LPU($VZ)+IND,2)
        ENDDO
C 1.POINT GAUSS
        IF(NUE.EQ.4)THEN 
           CALL FDTETRA(NUE,X,Y,Z,.33333,.33333,.33333,F,FX,FY,FZ,DET)
        ELSE
           CALL FDFVL(NUE,X,Y,Z,0.,0.,.0,F,FX,FY,FZ,DET)
        ENDIF
C................. DOPLNIT POSTPROCESSING
      ENDIF
C ENDIF ICONTR 
      END

