      SUBROUTINE PLOTARR(X1,Y1,X2,Y2,ICOL)
C
C Usecka zakoncena sipkou
C Jednoucelova procedura pro vykreslovani schematu RTD v dialogovem okne
C
      DIMENSION X(3),Y(3)
      CALL GMFLINE(X1,Y1,X2,Y2,0)
      X(2)=X2
      Y(2)=Y2
      IF(X1.NE.X2)THEN
C vodorovna
        X(1)=X(2)-SIGN(2.,X2-X1)
        Y(1)=Y(2)+1.2
        X(3)=X(1)
        Y(3)=Y(2)-1.2
      ELSE
C svisla
        X(1)=X(2)-1.1
        X(3)=X(2)+1.1
        Y(1)=Y(2)-SIGN(2.0,Y2-Y1)
        Y(3)=Y(1)
      ENDIF
      XT=0
      YT=0
      DO I=1,3
        XT=XT+X(I)
        YT=YT+Y(I)
      ENDDO
      CALL GMFPLC(3,X,Y,1)
      CALL GMFILL(XT/3.,YT/3.,ICOL,1)
      CALL GMFPLC(3,X,Y,0)
      END

      SUBROUTINE PLOTSER(ITYP,X1,Y1,X2,Y2,NN,HH,HV)
C
C Ikona serie NN-misicu. Velikost HH-HORIZONTALNI, HV-VERTIKALNI
C ITYP=0 serie
C     =1 serie se zpetnym promichavanim
C
      CHARACTER*4 LAB
      N=MIN0(10,NN)
      IF(N.GT.0)THEN
         D=SQRT((X2-X1)**2+(Y2-Y1)**2)
         CALL PLOTARR(X1,Y1,X2,Y2,11)
         XL=AMIN1(X1,X2)
         YL=AMIN1(Y1,Y2)
         DT=D*0.95/N
         T0=D*0.5*(1-0.95*(N+1)/N)
         DO I=1,N
            T=T0+I*DT
            IF(X1.NE.X2)THEN
               CALL PLOTMIX(XL+T,Y1,HH,HV)
               IF(ITYP.EQ.1.AND.I.GT.1)CALL PLOTARR
     /           (XL+T-HH,Y2+HV/2,XL+T-DT+HH,Y2+HV/2,11)
            ELSEIF(Y1.NE.Y2)THEN
               CALL PLOTMIX(X1,YL+T,HH,HV)
            ENDIF
         ENDDO
         IF(NN.GT.10)THEN
C Vybileni vnitrku
            HV1=1.5*HV
            CALL GMFREC(XL+3*DT,XL+7.5*DT,Y1-HV1,Y1+HV1,2)
            CALL GMFILL(XL+5*DT,Y1,15,2)
            CALL GMFREC(XL+3*DT,XL+7.5*DT,Y1-HV1,Y1+HV1,15)
            WRITE(LAB,'(I4)')NN
            CALL GMFTEXT(XL+4*DT,Y1,12,10,LAB//' units')
          ENDIF
      ENDIF
      END

      SUBROUTINE PLOTSTG(ITYP,X1,Y1,X2,Y2,NN,HH,HV,RATION)
C
C Ikona serie N-misicu a stagnantnich oblasti. 
C Velikost HH-HORIZONTALNI, HV-VERTIKALNI
C ITYP=0 serie
C     =1 serie se zpetnym promichavanim
C
      CHARACTER*4 LAB
      N=MIN0(10,NN)
      RATIO=AMAX1(0.25,RATION)
      IF(N.GT.0)THEN
         H2=HV*.3
         H3=RATIO*(HV-H2)
         H1=HV-H2-H3
         D=SQRT((X2-X1)**2+(Y2-Y1)**2)
         CALL PLOTARR(X1,Y1,X2,Y2,11)
         XL=AMIN1(X1,X2)
         DT=D*0.9/N
         T0=D*0.5*(1-0.9*(N+1)/N)
         HH2=HH*.7
         DO I=1,N
            T=T0+I*DT
            XC=XL+T
            CALL PLOTMIX(XC,Y1,HH,H1)
            IF(ITYP.EQ.1.AND.I.GT.1)CALL PLOTARR
     /           (XC-HH,Y2+H1/2,XC-DT+HH,Y2+H1/2,11)
            CALL PLOTMIX(XC,Y1-HV,HH,-H3)
            CALL PLOTARR(XC-HH2,Y1-H1,XC-HH2,Y1-H1-H2,11)
            CALL PLOTARR(XC+HH2,Y1-H1-H2,XC+HH2,Y1-H1,11)
         ENDDO
         IF(NN.GT.10)THEN
C Vybileni vnitrku
            HV1=2*HV
            CALL GMFREC(XL+3*DT,XL+7.5*DT,Y1-HV1,Y1+HV1,2)
            CALL GMFILL(XL+5*DT,Y1,15,2)
            CALL GMFREC(XL+3*DT,XL+7.5*DT,Y1-HV1,Y1+HV1,15)
            WRITE(LAB,'(I4)')NN
            CALL GMFTEXT(XL+4*DT,Y1,12,10,LAB//' units')
          ENDIF
      ENDIF
      END

      SUBROUTINE PLOTDET(X1,Y1,NUM,IGRAF)
C
C Vykresleni ikony dektoru s cislem vystupu NUM a event. zobrazenim
C korekce signalu
C IGRAG=0 bez korekce
C IGRAF=1 plocha (gain)
C IGRAF=2 background 
C IGRAF=3 linearni rust
C
      CHARACTER*1 C
      HX=1.2
      HY=2.5
      CALL GMFREC(X1-HX,X1+HX,Y1-HY,Y1+HY,13)
      CALL GMFILL(X1,Y1,12,13)
      CALL GMFREC(X1-HX,X1+HX,Y1-HY,Y1+HY,0)
      C=CHAR(NUM+48)
      CALL GMFTEXT(X1-0.8,Y1+2.,15,1,C)
      CALL PLOTARR(X1,Y1-HY,X1,Y1-HY-4.,12)
      IF(IGRAF.GT.0)THEN
         CALL GMFREC(X1-6,X1+3,Y1-22,Y1-10,0)
         CALL PLOTARR(X1-4.5,Y1-20.,X1+3.,Y1-20.,14)
         CALL PLOTARR(X1-4.5,Y1-20.,X1-4.5,Y1-10.,14)
         IF(IGRAF.EQ.1)THEN
            CALL GMFLINE(X1-4.5,Y1-20.,X1+2.,Y1-15.,12)
            CALL GMFTEXT(X1-2.,Y1-10.,12,2,'cY')
         ELSEIF(IGRAF.EQ.2)THEN
            CALL GMFLINE(X1-4.5,Y1-17.,X1+2.,Y1-17.,12)
            CALL GMFTEXT(X1-2.5,Y1-10.,12,3,'Y+b')
         ELSEIF(IGRAF.EQ.3)THEN
            CALL GMFLINE(X1-4.5,Y1-18.,X1+2.,Y1-15.,12)
            CALL GMFTEXT(X1-3.,Y1-10.,12,4,'cY+b')
         ENDIF
      ENDIF
      END

      SUBROUTINE PLOTPF(X1,Y1,X2,Y2)
C
C Ikona PISTOVEHO TOKU
C
      D=SQRT((X2-X1)**2+(Y2-Y1)**2)
      CALL PLOTARR(X1,Y1,X2,Y2,11)
      XC=(X1+X2)*.5
      YC=(Y1+Y2)*.5
      DX1=XC-(X2-X1)*.3
      DX2=XC+(X2-X1)*.2
      CALL GMFREC(DX1,DX2,YC-3.,YC+3.,12)
      CALL GMFILL(XC,YC,11,12)
      CALL GMFREC(DX1,DX2,YC-3.,YC+3.,0)
      END

      
      SUBROUTINE PLOTMOD(IDECODE,ITYP,ITYPG,MN1,MN2,VOLRAT)
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
C
C IKONA MODELU
C IDECODE - ciselne oznaceni modelu - dekodovanim vzniknou ITYP,ITYPG,MN1,MN2
C ITYP =0  S  serie N1 misicu
C      =1  A  paralelni serie N1,N2 misicu
C      =2  B  serie se zpetnym promichavanim
C      =3  D  serie stagnantnich oblasti
C      =4  C  dve serie v recyklu 
C      =5  E  serie se zpetnym promichavanim a druhe serie v recyklu
C      =6  F  dve paralelni serie, prvni s pistovym tokem
C      =7  G  dve serie v recyklu, recyklova s pistovym tokem
C      =8  H  serie se zpetnym promich.a pistovym tokem, druha serie v recyklu
C      =9  I  serie stagnantnich oblasti se zpetnym promichavanim
C ITYPG=0  0  zadny "vnejsi obal"
C      =1  P  pripojeny pistovy tok
C      =2  R  okamzity recykl
C      =3  U  zpozdeni v recyklu
C      =4  V  pistovy tok za recyklem
C      =5  W  pistovy tok v serii i v recyklu
C      =6  S  misic v serii
C      =7  T  misic v recyklu
C      =8  X  misic v serii a okamzity recykl
C      =9  Y  misic v serii i v recyklu
C N1,N2    pocet prvku serie
C VOLRAT   pomer objemu V1/V2
C
C Lokalni promenne ITE-typ elementu
C ITE  =0  usecka
C      =1  serie
C      =2  backmixing
C      =3  pistovy tok
C      =4  stagnantni oblast
C      =5  stagnantni oblast se zpetnym promichavanim
C NMX      parametr elementu (pocet misicu)      
C HVE      vertikalni rozmer
      INCLUDE '$FEM'
      PARAMETER (MAXP=15,MAXE=15)
      DIMENSION PX(MAXP),PY(MAXP),ID(3),
     /          IE1(MAXE),IE2(MAXE),ITE(MAXE),NMX(MAXE),HVE(MAXE)
      INTEGER*2 OCOLO,NCOLO
      CHARACTER*15 LINE
      CHARACTER*4  TEX
      DATA PX,PY/
     /10.,75.,85., 0., 5.,10.,75.,85.,88.,100.,10.,75.,85.,5.,88.,
     /80.,80.,80.,60.,60.,60.,60.,60.,60., 60.,45.,45.,45.,95.,95./
C      1   2   3   4   5   6   7   8   9   10  11  12  13  14  15  
C Umisteni uzlovych bodu dle nasledujiciho schematu  
C   14                            15
C        1               2     3       
C 4  5   6               7     8   9     10
C       11              12    13
C
	N1=MAX0(1,MN1)
      N2=MAX0(1,MN2)
      CALL GMFSTW(2,1,21,5,12,'t','Y',0.,1.,0.,1.,0.,100.,0.,100.)
C      CALL GMFSTW(2,1,21,3,14,'t','Y',0.,1.,0.,1.,0.,100.,0.,100.)
      CALL GMFSW(2)
      II=SETBKCOLOR(15)
      OCOLO=SETTEXTCOLOR(INT2(0))
      CALL CLEARSCREEN($GCLEARSCREEN)
      IF(LINESRPN(2).GE.1)WRITE(21,'(1X,A)')TRIM(MODTXT(1:LINESRPN(2)))
	IF(IDECODE.GE.0)THEN
      ITE=0
      NMX=0
      HVE=0.
      NDA=1
      ID(1)=10
C IE1 - index pocatecniho bodu
C IE2 - index koncoveho bodu
C ITE - typ elementu
C HVE - vyska elementu
C NMX - pocet misicu elementu
      SELECT CASE(ITYP)
      CASE(0)
C SERIE N1
        NEA=3
        IE1(1:3)=(/4,6,9/)
        IE2(1:3)=(/6,9,10/)
        ITE(2)=1
        NMX(2)=N1
        HVE(2)=10.
      CASE(1)
C PARALELNI SERIE
        NEA=8
        IE1(1:8)=(/4,6,6,1,11,3,13,8/)
        IE2(1:8)=(/6,1,11,3,13,8,8,10/)
        ITE(4:5)=(/1,1/)
        NMX(4:5)=(/N1,N2/)
        H2=10./(1.+(VOLRAT*N2)/N1)
        H1=AMAX1(1.,10.-H2)
        HVE(4:5)=(/H1,H2/)
      CASE(2)
C SERIE SE ZPETNYM PROMICHAVANIM
        NEA=3
        IE1(1:3)=(/4,6,9/)
        IE2(1:3)=(/6,9,10/)
        ITE(2)=2
        NMX(2)=N1
        HVE(2)=15.
      CASE(3)
C SERIE STAGNANTNICH OBLASTI
        NEA=3
        IE1(1:3)=(/4,6,9/)
        IE2(1:3)=(/6,9,10/)
        ITE(2)=4
        NMX(2)=N1
        HVE(2)=18.
      CASE(4)
C SERIE v recyklu
        NEA=8
        IE1(1:8)=(/4,6,11,1,13,3,8,8/)
        IE2(1:8)=(/6,1,6,3,11,8,13,10/)
        ITE(4:5)=(/1,1/)
        NMX(4:5)=(/N1,N2/)
        H2=10./(1.+(VOLRAT*N2)/N1)
        H1=AMAX1(1.,10.-H2)
        HVE(4:5)=(/H1,H2/)
      CASE(5)
C backmix+SERIE v recyklu
        NEA=8
        IE1(1:8)=(/4,6,11,1,13,3,8,8/)
        IE2(1:8)=(/6,1,6,3,11,8,13,10/)
        ITE(4:5)=(/2,1/)
        NMX(4:5)=(/N1,N2/)
        H2=10./(1.+(VOLRAT*N2)/N1)
        H1=AMAX1(1.,10.-H2)
        HVE(4:5)=(/H1,H2/)
      CASE(6)
C PARALELNI SERIE s pistovym tokem v 1.vetvi
        NEA=9
        IE1(1:9)=(/4,6,6,1,11,2,3,13,8/)
        IE2(1:9)=(/6,1,11,2,13,3,8,8,10/)
        ITE(4:6)=(/1,1,3/)
        NMX(4:5)=(/N1,N2/)
        H2=10./(1.+(VOLRAT*N2)/N1)
        H1=AMAX1(1.,10.-H2)
        HVE(4:5)=(/H1,H2/)
      CASE(7)
C serie s recyklem a pistovym tokem v 2.vetvi
        NEA=9
        IE1(1:9)=(/4,6,11,1,12,13,3,8,8/)
        IE2(1:9)=(/6,1,6,3,11,12,8,13,10/)
        ITE(4:6)=(/1,1,3/)
        NMX(4:5)=(/N1,N2/)
        H2=10./(1.+(VOLRAT*N2)/N1)
        H1=AMAX1(1.,10.-H2)
        HVE(4:5)=(/H1,H2/)
      CASE(8)
C backmixing s recyklem a pistovym tokem v 2.vetvi
        NEA=9
        IE1(1:9)=(/4,6,11,1,12,13,3,8,8/)
        IE2(1:9)=(/6,1,6,3,11,12,8,13,10/)
        ITE(4:6)=(/2,1,3/)
        NMX(4:5)=(/N1,N2/)
        H2=10./(1.+(VOLRAT*N2)/N1)
        H1=AMAX1(1.,10.-H2)
        HVE(4:5)=(/H1,H2/)
      CASE(9)
C SERIE STAGNANTNICH OBLASTI se zpetnym promichavanim
        NEA=3
        IE1(1:3)=(/4,6,9/)
        IE2(1:3)=(/6,9,10/)
        ITE(2)=5
        NMX(2)=N1
        HVE(2)=18.
      END SELECT
C
C Zjisteni elementu typu PF a pripojeni ikonky detektoru
C
      DO I=1,NEA
         IF(ITE(I).EQ.3.AND.ITYP.NE.7.AND.ITYP.NE.8)THEN
            NDA=NDA+1
            ID(NDA)=IE1(I)
         ENDIF
      ENDDO
C
C Rozsireni schematu (podtyp G) o dalsi elementy
C
      SELECT CASE(ITYPG)
      CASE(1)
        NEA=NEA+1
        IE1(NEA)=9
        IE2(NEA)=10
        ITE(NEA)=3
      CASE(2)
        NEA=NEA+3
        IE1(NEA-2:NEA)=(/9,15,14/)
        IE2(NEA-2:NEA)=(/15,14,5/)
      CASE(3)
        NEA=NEA+3
        IE1(NEA-2:NEA)=(/9,15,14/)
        IE2(NEA-2:NEA)=(/15,14,5/)
        ITE(NEA-1)=3
      CASE(4)
        NEA=NEA+4
        IE1(NEA-3:NEA)=(/9,15,14,9/)
        IE2(NEA-3:NEA)=(/15,14,5,10/)
        ITE(NEA)=3
      CASE(5)
        NEA=NEA+4
        IE1(NEA-3:NEA)=(/9,15,14,9/)
        IE2(NEA-3:NEA)=(/15,14,5,10/)
        ITE(NEA)=3
        ITE(NEA-2)=3
      CASE(6)
        NEA=NEA+1
        IE1(NEA)=9
        IE2(NEA)=10
        ITE(NEA)=1
	  NMX(NEA)=1
	  HVE(NEA)=3.
      CASE(7)
        NEA=NEA+3
        IE1(NEA-2:NEA)=(/9,15,14/)
        IE2(NEA-2:NEA)=(/15,14,5/)
        ITE(NEA-1)=1
	  NMX(NEA-1)=1
	  HVE(NEA-1)=3.
      CASE(8)
        NEA=NEA+4
        IE1(NEA-3:NEA)=(/9,15,14,9/)
        IE2(NEA-3:NEA)=(/15,14,5,10/)
        ITE(NEA)=1
	  NMX(NEA)=1
	  HVE(NEA)=3.
      CASE(9)
        NEA=NEA+4
        IE1(NEA-3:NEA)=(/9,15,14,9/)
        IE2(NEA-3:NEA)=(/15,14,5,10/)
        ITE(NEA)=1
        ITE(NEA-2)=1
	  NMX(NEA)=1
	  HVE(NEA)=3.
	  NMX(NEA-2)=1
	  HVE(NEA-2)=3.
      END SELECT
C
C Pozice detektoru
C
      SELECT CASE(ITYPG)
      CASE(1,4,5)
        IF(NDA.LE.1.OR.ID(2).NE.13)THEN
           NDA=NDA+1
           ID(NDA)=9
        ENDIF
      END SELECT
C Vykresleni elementu. HH/HV -horizontalni/vertikalni vyska
      HH=AMAX1(2.,AMIN1(17.,27./MAX0(N1,N2)))
      DO I=1,NEA
         I1=IE1(I)
         I2=IE2(I)
         HV=HVE(I)
         IF(I1.GE.1.AND.I2.GE.1.AND.I1.LE.MAXP.AND.I2.LE.MAXP)THEN
           SELECT CASE(ITE(I))
           CASE(0)
              CALL PLOTARR(PX(I1),PY(I1),PX(I2),PY(I2),11)
           CASE(1)
              CALL PLOTSER(0,PX(I1),PY(I1),PX(I2),PY(I2),NMX(I),HH,HV)  
           CASE(2)
              CALL PLOTSER(1,PX(I1),PY(I1),PX(I2),PY(I2),NMX(I),HH,HV)  
           CASE(3)
              CALL PLOTPF(PX(I1),PY(I1),PX(I2),PY(I2))
           CASE(4)
              CALL PLOTSTG(0,PX(I1),PY(I1),PX(I2),PY(I2),NMX(I),
     /                     HH,HV,VOLRAT)  
           CASE(5)
              CALL PLOTSTG(1,PX(I1),PY(I1),PX(I2),PY(I2),NMX(I),
     /                     HH,HV,VOLRAT)  
           END SELECT
         ENDIF
       ENDDO
C Vykresleni ikon detektoru
       DO I=1,NDA
          ICORR=0
          IF(I.EQ.1.AND.IMODELA.GT.0)THEN
             DX=-3.
             TEX=ADJUSTR(MODKWD(IMODELA))
             IF(TEX(4:4).EQ.'A')THEN
                ICORR=1
             ELSEIF(TEX(4:4).EQ.'B')THEN
                ICORR=2
             ELSEIF(TEX(4:4).EQ.'L')THEN
                ICORR=3
             ENDIF
          ELSE
             DX=1.5
          ENDIF
          CALL PLOTDET(PX(ID(I))+DX,PY(ID(I))-8.,I,ICORR)
       ENDDO
C Vykresleni nastriku
       CALL PLOTARR(3.,PY(4)-8.,3.,PY(4),12)
       SELECT CASE(ITYP)
       CASE(1,6)
          CALL GMFTEXT(PX(1)-3.,PY(1),12,1,'f')
          CALL GMFTEXT(PX(11)-5.,PY(11),12,3,'1-f')
          CALL GMFTEXT(PX(3),PY(3)+5.,12,8,'Branch 1')
       CASE(4,5,7,8)
          CALL GMFTEXT(PX(1)-6.,PY(1),12,3,'1+R')
          CALL GMFTEXT(PX(11)-3.,PY(11),12,1,'R')
          CALL GMFTEXT(PX(3),PY(3)+5.,12,8,'Branch 1')
       END SELECT
	ELSE
C IDECODE < 0 BITMAPA
        SELECT CASE(IDENUM)
	  CASE(-1)
           II=LOADIMAGE('.\FILES\$WAFFLE.BMP',0,0)
	  CASE(-2)
           II=LOADIMAGE('.\FILES\$COOLING.BMP',0,0)
	  CASE DEFAULT
           II=LOADIMAGE('.\FILES\$NOTDEF.BMP',0,0)
	  ENDSELECT
      ENDIF
C Vypis hodnot parametru (COMMON)
       DO I=1,NUMODP
          CALL GETPAR(I,VALDEF,IVALDEF,IR)
          IF(IR.EQ.1)THEN
             WRITE(LINE,'(''RP'',I2,'':'',E10.3)')I,VALDEF
          ELSE
             WRITE(LINE,'(''IP'',I2,'':'',I10)')I,IVALDEF
          ENDIF
          IF(KMODEL(I).GT.0)THEN
             NCOLR=10+KMODEL(I)
          ELSE
             NCOLR=0
          ENDIF
          IF(I.LE.6)THEN
             CALL GMFTEXT(0.,35-5.*I,0,15,LINE(1:15))
             CALL GMFTEXT(20.,35-5.*I,NCOLR,LENDIAL,MODPARTXT(I))
          ELSE
             CALL GMFTEXT(50.,65-5.*I,0,15,LINE(1:15))
             CALL GMFTEXT(70.,65-5.*I,NCOLR,LENDIAL,MODPARTXT(I))
          ENDIF
       ENDDO
       NCOLO=SETTEXTCOLOR(OCOLO)
       CALL GMFSW(1)
      END

