C $S26-KLOC
C RUNFEMW - peceni oplatek resenim toku vytesnovane vrstvicky kapaliny.
C
      SUBROUTINE MFLUX(IE)
C Vypocet hmotnostniho toku pary z elementu

C Parametry elementu
C JEPAR($FLOW2D)=$EDISS,$ELAV,$EII,$EGTX,$EGTY,$EGTZ,$EVX,$EVY,$EVZ,$ESXX,$ESYY,$ESXY,$EMISE,$EFOUL,$EPOWER
C AREA  - pomer ploch deformovaneho/puvodniho trojuhelniku ($ELAV)
C FLUX  - hustota hmotnostniho toku pary ($EMISE)
C HSMALL- tloustka kapalne vrstvy        ($FOUL)
C TEMP  - teplota elementu               ($EII)
C EPS   - porozita                       ($EDISS)
C WSTAR - hmotnost skrobu                ($ESXX)
C WFREE - hmotnost volne vody            ($ESYY)
C WBOND - hmotnost vazane vody           ($ESXY)

C Uzlove parametry
C JPU(MDOF)=$TEMP,$PRES,$VOLT,$CN,$CD,$CA,$VX,$VY,$VZ,$UX,$UY,$RZ,$PS,$PSX,$PSY,$PSZ,$OMG,$HT
C    $PRES   - tlak
C    $UX,$UY - posuvy
C    $VX,$VY - rychlosti
C    $RZ     - soucet vnitrnich uhlu

C RRCONS 
C H   - nominalni tloustka, vzdalenost desek ($H)
C TW  - teplota steny                        ($TE)

C Materialove parametry elementu pro teplotu TEMP
C VISC - viskozita 
C RKX  - tepelna vodivost
C REVA - vyparne teplo
C BETA - soucinitel expanze
C CP   - merna tepelna kapacita
c FI   - odparovaci koeficient vazane vody  ($DN)

      INCLUDE '$FEMEQ'
	DIMENSION X(3),Y(3),XNEW(3),YNEW(3)
	NAMELE=$FLOW2D
      LEGRP =MAX0(1,IGROUP(IE))
      LPROP =MAX0(1,IMPROP(IE))
      LRCON =MAX0(1,IRCONS(IE))

      H   =RRCONS(LRCON,$H)
      TW  =RRCONS(LRCON,$TE)

      LFLUX =MAX0(1,LEPAR(NAMELE,$EMISE))
      LTEMP =MAX0(1,LEPAR(NAMELE,$EII))
      LEPS  =MAX0(1,LEPAR(NAMELE,$EDISS))
      LFOUL =MAX0(1,LEPAR(NAMELE,$EFOUL))
      LSTAR =MAX0(1,LEPAR(NAMELE,$ESXX))
      LFREE =MAX0(1,LEPAR(NAMELE,$ESYY))
      LBOND =MAX0(1,LEPAR(NAMELE,$ESXY))
      LAREA =MAX0(1,LEPAR(NAMELE,$ELAV))
      FLUX  =EPAR(IE,LFLUX)
      TEMP  =EPAR(IE,LTEMP)
      EPS   =EPAR(IE,LEPS)
      HSMALL=EPAR(IE,LFOUL)
      WSTAR =EPAR(IE,LSTAR)
      WFREE =EPAR(IE,LFREE)
      WBOND =EPAR(IE,LBOND)
	WMASS =WSTAR+WFREE+WBOND

      VISC=RMPROP(LPROP,$VISC)
      IF(JMPROP(LPROP,$VISC).NE.0)VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
      RKX =RMPROP(LPROP,$KX)
	IF(JMPROP(LPROP,$KX)  .NE.0)RKX =RKX *CURFUN(JMPROP(LPROP,$KX))
      BETA=RMPROP(LPROP,$BETA)
      IF(JMPROP(LPROP,$BETA).NE.0)BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
      REVA=RMPROP(LPROP,$HM)
      IF(JMPROP(LPROP,$HM)  .NE.0)REVA=REVA*CURFUN(JMPROP(LPROP,$HM))
      CP=RMPROP(LPROP,$CP)
      IF(JMPROP(LPROP,$CP)  .NE.0)CP  =CP  *CURFUN(JMPROP(LPROP,$CP))
      FI=RMPROP(LPROP,$DN)
      IF(JMPROP(LPROP,$DN)  .NE.0)FI  =FI  *CURFUN(JMPROP(LPROP,$DN))

      L0=LUE(IE)
	NUE=3
	PMEAN=0
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        LOCUX=LPU($UX)+IND
        LOCUY=LPU($UY)+IND
	  LOCP=LPU($PRES)+IND
	  X(IU)=XX(IND)
	  Y(IU)=YY(IND)
        XNEW(IU)=XX(IND)+VAL(LOCUX,3)
        YNEW(IU)=YY(IND)+VAL(LOCUY,3)
        PMEAN=PMEAN+VAL(LOCP,3)
      ENDDO
	PMEAN=PMEAN/NUE
C Restrikce tlaku na 100 bar
      PMEAN=AMAX1(1.,AMIN1(100.,PMEAN))
C Vypocet ploch noveho a puvodniho trojuhelniku
      AOLD=ABS(Y(1)*(X(2)-X(3))+Y(2)*(X(3)-X(1))+Y(3)*(X(1)-X(2)))
      ANEW=ABS(YNEW(1)*(XNEW(2)-XNEW(3))+YNEW(2)*(XNEW(3)-XNEW(1))+
     /      YNEW(3)*(XNEW(1)-XNEW(2)))
      EPAR(IE,LAREA)=ANEW/AOLD

C Rozliseni tri fazi
      ISTAGE=0
	IF(TEMP.LT.100.)THEN
C 1.FAZE implicitni metoda
        AA=2*DTIME*ANEW*RKX/(H*CP*WMASS)
	  TNEW=(TEMP+AA*TW)/(1+AA)
	  EPAR(IE,LTEMP)=TNEW
	  ISTAGE=1
      ELSEIF(WFREE.GT.0.)THEN
C 2.FAZE odpar volne vody
        PM=PMEAN
	  TNEW=AMIN1(0.99*TW,100*PM**0.25)
	  HH=AMAX1(0.001*H,H-HSMALL)
	  RMW=2*RKX*(TW-TNEW)/(HH*REVA)
	  HSMALL=AMAX1(1E-4*H,HSMALL-DTIME*BETA*RMW)
	  WFREE=WFREE-DTIME*RMW*ANEW
	  EPAR(IE,LTEMP)=TNEW
	  EPAR(IE,LFOUL)=HSMALL
	  EPAR(IE,LFREE)=WFREE
	  ISTAGE=2
      ELSE
C 3.FAZE vazana voda 
        AA=DTIME*((TW-TEMP)*ANEW*RKX/H-REVA*FI*WBOND)
	  TNEW=TEMP+AA/(CP*WMASS)
        WBOND=WBOND-DTIME*FI*WBOND
	  TNEW=(TEMP+AA*TW)/(1+AA)
	  EPAR(IE,LTEMP)=TNEW
	  EPAR(IE,LBOND)=WBOND
	  ISTAGE=3
      ENDIF

c======================
      IF(IE.EQ.46)WRITE(2,100)ISTAGE,H,HSMALL,TEMP,VISC,RKX,BETA,REVA,
     /CP,FI,WSTAR,WFREE,WBOND,PMEAN
100	FORMAT(/' MFLUX ISTAGE=',I2,' H=',F6.3,' h=',E10.3,' T=',F7.1,
     /' VISC=',E10.3,
     /' KX=',E10.3,' BETA=',E10.3,' R=',E10.3,' CP=',E10.3,' FI=',E10.3/
     /' MS=',E10.3,' MF=',E10.3,' MB=',E10.3,' PMEAN=',E10.3)
C=======================
      END


      SUBROUTINE EXPAND
C Expanze site (vypocet $UX,$UY)
      INCLUDE '$WGRID'
      INCLUDE '$FEMLOC'
	DO IND=1,ND
        LOCVX=LPU($VX)+IND
        LOCVY=LPU($VY)+IND
        LOCRZ=LPU($RZ)+IND
        ANGLE=VAL(LOCRZ,3)
        VX=VAL(LOCVX,3)/ANGLE
        VY=VAL(LOCVY,3)/ANGLE
C Inkrement posuvu
        LOCUX=LPU($UX)+IND
        LOCUY=LPU($UY)+IND
        VAL(LOCUX,3)=VAL(LOCUX,3)+VX*DTIME
        VAL(LOCUY,3)=VAL(LOCUY,3)+VY*DTIME
        VAL(LOCUX,2)=VAL(LOCUX,3)
        VAL(LOCUY,2)=VAL(LOCUY,3)
	ENDDO  
      END

	SUBROUTINE WALLINI
C Vynulovani stenove mrizky a uzlovych parametru (posuv)
      INCLUDE '$FEMLOC'
      INCLUDE '$WGRID'
	DIMENSION X(3),Y(3)
	WGRID=0.
	DO IND=1,ND
        LOCUX=LPU($UX)+IND
        LOCUY=LPU($UY)+IND
        VAL(LOCUX,3)=0
        VAL(LOCUY,3)=0
        VAL(LOCUX,2)=0
        VAL(LOCUY,2)=0
	ENDDO  
C Pocatecni parametry elementu (hmotnosti WSTAR,WFREE,WBOND)
	NAMELE=$FLOW2D
      LFLUX =MAX0(1,LEPAR(NAMELE,$EMISE))
      LTEMP =MAX0(1,LEPAR(NAMELE,$EII))
      LEPS  =MAX0(1,LEPAR(NAMELE,$EDISS))
      LFOUL =MAX0(1,LEPAR(NAMELE,$EFOUL))
      LSTAR =MAX0(1,LEPAR(NAMELE,$ESXX))
      LFREE =MAX0(1,LEPAR(NAMELE,$ESYY))
      LBOND =MAX0(1,LEPAR(NAMELE,$ESXY))
      LAREA =MAX0(1,LEPAR(NAMELE,$ELAV))

	DO IE=1,NE
        LRCON =MAX0(1,IRCONS(IE))
        H     =RRCONS(LRCON,$H)
        L0=LUE(IE)
	  NUE=3
        DO IU=1,NUE
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
	    Y(IU)=YY(IND)
        ENDDO
C Vypocet ploch puvodniho trojuhelniku
        A=ABS(Y(1)*(X(2)-X(3))+Y(2)*(X(3)-X(1))+Y(3)*(X(1)-X(2)))
	  WMASS=A*H*1160
	  OMEGA=0.4
	  Z=0.44
	  WFREE=WMASS*(1.-OMEGA)/(1+Z)
	  WBOND=Z*WFREE
	  WSTAR=WMASS*OMEGA
        EPAR(IE,LFLUX)=0
        EPAR(IE,LTEMP)=20
        EPAR(IE,LEPS)=0
        EPAR(IE,LFOUL)=H
        EPAR(IE,LSTAR)=WSTAR
        EPAR(IE,LFREE)=WFREE
        EPAR(IE,LBOND)=WBOND
      ENDDO
C konec WALLINI
      END


	SUBROUTINE BC
C Okrajove podminky pro tlak
      INCLUDE '$FEMLOC'
      INCLUDE '$WGRID'
C Vynulovani uzlovych parametru VX,VY a UHLU
	DO IND=1,ND
        LOCVX=LPU($VX)+IND
        LOCVY=LPU($VY)+IND
        LOCRZ=LPU($RZ)+IND
        VAL(LOCVX,3)=0.
        VAL(LOCVY,3)=0.
        VAL(LOCRZ,3)=0.
        LOCP=LPU($PRES)+IND
        IBND=IPU(LOCP)
	  IF(IBND.LT.0)THEN
C Hranice. tlak P=const/dist^3
          LOCUX=LPU($UX)+IND
          LOCUY=LPU($UY)+IND
          X=XX(IND)+VAL(LOCUX,3)
          Y=YY(IND)+VAL(LOCUY,3)
	    DISMIN=AMIN1(DIMX,DIMY)*.01
	    DISTY=AMIN1(Y,DIMY-Y)
	    DISTX=AMIN1(X,DIMX-X)
	    DISTXY=AMIN1(DISTX,DISTY)
	    IF(DISTXY.GT.DISMIN)THEN
            VAL(LOCP,1)=0.
          ELSE
            VAL(LOCP,1)=1E-3*(DISMIN-DISTXY)/DISMIN
	    ENDIF
        ENDIF
      ENDDO
	END
