C $S4-KLOC
      SUBROUTINE PIPE(ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT 
C Vypocet tlaku v uzlovych bodech. Vlastni algoritmus v procedure PIPE2.
C Volitelna HMOTNOSTNI/OBJEMOVA bilance prutoku v uzlovych bodech ($IVOLU)
C
C Elementy: L2 (blokovani sestaveni pro NUE<>2)
C Laminarni Newtonska kapalina / turbulentni tok (Churchil)
C Viskozita a hustota funkci TEMP,TAU,CN,CD,CA 
C Tlaky potrebne pro odhad prutokoveho soucinitele v zone 4 (ITERACNI)
C Teploty pro odhad viskozity v zone 3 (POCATECNI PODMINKY)
C
C Uzivatelem definovana hydraulicka charakteristika FI(DP,RE,DE) jako
C funkce cislo EGROUP(7)
C 
C ICONTR=1 vypocet parametru zony EPAR(MAXEL,MAXEPAR) 
C    Q prutok [m^3/s]
C    Re
C    Tau smykove napeti na stene [Pa]
C Prislusne sloupce matice EPAR jsou urceny vektorem LEPAR(elname,ityp)
C
C Uprava brezen 2005: MULTIPIPE - pocet paralelnich trubek JGROUP(i,$EX1)
C
      INCLUDE '$FEMEQ'
      DIMENSION X(2),Y(2),Z(2),AL(NL,NL),BL(NL),T(2),PP(2),IPP(2)
      IF(NUE.NE.2)RETURN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
      MULTI=MAX0(1,JGROUP(LEGRP,$EX1))
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 3)
C p-TLAKY Z PREDCHOZI ITERACE (zona 4)
C
      ALL: IF(ICONTR.GE.0)THEN
C NORMALNI VYPOCET FTFRON
        L0=LUE(IE)
        ACN=0.
        ACD=0.
        ACA=0.
        DO IU=1,2
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
          Y(IU)=YY(IND)
          Z(IU)=ZZ(IND)
          T(IU)=VAL(LPU($TEMP)+IND,3)
          PP(IU)=VAL(LPU($PRES)+IND,4)
	    IF(ISNAN(PP(IU)))PP(IU)=0.
	    IF(ISNAN(T(IU)))T(IU)=0.
	    IPP(IU)=IPU(LPU($PRES)+IND)
          ACN=ACN+VAL(LPU($CN)+IND,3)
          ACD=ACD+VAL(LPU($CD)+IND,3)
          ACA=ACA+VAL(LPU($CA)+IND,3)
        ENDDO
	
C ACN,ACD,ACA jsou prumerne koncentrace v elementu
C preneseme jejich hodnoty do AUX($LDOF+$CN),... aby byly k dispozici pro interpret
        AUX($LDOF+$CN)=ACN/2.
        AUX($LDOF+$CD)=ACD/2.
        AUX($LDOF+$CA)=ACA/2.
C Procedura PIPE2 je spolecna pro PIPE i HPIPE. Vystupem je prutokovy
C soucinitel FI, DQ, DQPi (permeabilitta), RHO,...
        CALL PIPE2(IE,X,Y,Z,T,PP,LRCON,LPROP,LEGRP,
     /    FI,DQ,DQP1,DQP2,RHO,UMEAN,RE,FLOWRATE,TAUW,PDISSIP)
        CONTROL: IF(ICONTR.EQ.0)THEN
C Vypocet matice prutokovych koeficientu
C Bilance hmotnostnich ($IVOLU=0) ci objemovych ($IVOLU=1) prutoku. 
C Proto nasobeni hustotou RHO.
           IF($IVOLU.EQ.0)THEN
              FIRHO=FI*RHO*MULTI
              BL(1)=(-DQ-DQP1)*RHO*MULTI
              BL(2)=(DQ-DQP2)*RHO*MULTI
           ELSE
              FIRHO=FI*MULTI
              BL(1)=(-DQ-DQP1)*MULTI
              BL(2)=(DQ-DQP2)*MULTI
           ENDIF
           DO IU=1,2
              IF(IPP(IU).GT.0)BL(IU)=0.
           ENDDO
           AL(1,1)=FIRHO
           AL(2,2)=FIRHO
           AL(1,2)=-FIRHO
           AL(2,1)=-FIRHO
C
        ELSEIF(ICONTR.GT.0)THEN
C
C ICONTR>0 Vypocet prutoku Q, Re, Tau, vx
C
           INDQ=MAX0(1,LEPAR(NAMELE,$EQ))
           INDRE=MAX0(1,LEPAR(NAMELE,$ERE))
           INDTAU=MAX0(1,LEPAR(NAMELE,$ETAU))
           INDVX=MAX0(1,LEPAR(NAMELE,$EVX))
           KEPAR(NAMELE,INDQ)=1
           KEPAR(NAMELE,INDRE)=1
           KEPAR(NAMELE,INDTAU)=1
           KEPAR(NAMELE,INDVX)=1
           EPAR(IE,INDQ)=FLOWRATE
           EPAR(IE,INDRE)=RE
           EPAR(IE,INDTAU)=TAUW
           EPAR(IE,INDVX)=UMEAN
C DISSIPOVANY VYKON
           $RPOWERF=$RPOWERF+PDISSIP
        ENDIF CONTROL
      ENDIF ALL
      END

      SUBROUTINE PIPE2(IE,X,Y,Z,T,PP,
     /    LRCON,LPROP,LEGRP,FI,DQ,DQP1,DQP2,RHO,UMEAN,RE,FLOWRATE,
     /    TAUW,PDISSIP)
C
C Vypocet FI pro dvouuzlove elementy PIPE, PUMP, VALVE
C Vysledek:
C FI - prutokovy soucinitel (objem. prutok = FI * deltap_treci)
C I v pripade, ze jde o element s paralelnimi trubkami, jsou vsechny hodnoty
C vztazeny na jedinou trubku.
C
      DIMENSION X(2),Y(2),Z(2),T(2),PP(2)
      REAL*8 A,B,FLAMB
      INCLUDE '$FEMEQ'
C NAMELE - bud $PIPE,$PUMP,$VALVE
C IHCH   - Hydraulicka charakteristika aparatu (cerpadlo, ventil,...): 
C          Jako parametr EGROUP se uvadi index funkce Fi(DP,Re,DE,HE). 
C          Pokud je index funkce 0, uvazuje se prazdna trubka.
C METHOD - ma vyznam jen pro cerpadla (vyber z katalogu)
      NAMELE=JGROUP(LEGRP,$ENAME)
      IHCH  =JGROUP(LEGRP,$FI)
      METHOD=JGROUP(LEGRP,$METHOD)
      D     =RRCONS(LRCON,$D)
      QMIN  =RRCONS(LRCON,$ALFA)
      QMAX  =RRCONS(LRCON,$TE)
      AREA  =ABS(RRCONS(LRCON,$AREA))
      PERIM =RRCONS(LRCON,$PERIM)
      VOL   =RRCONS(LRCON,$VOL)
      RA    =RRCONS(LRCON,$RA)
      DUDY  =RRCONS(LRCON,$DUDY)
      ZETA  =RRCONS(LRCON,$ZETA)
      PERM  =RRCONS(LRCON,$PERMEAB)
      PEXT  =RRCONS(LRCON,$P)
C HWALL tloustka steny, DBALL prumer castic vyplne, EPS-porozita
      HWALL =RRCONS(LRCON,$H)
	EPS   =RRCONS(LRCON,$RX1)
      DBALL =RRCONS(LRCON,$RX2)
C EW - younguv modul pruznosti steny
      EW    =RMPROP(LPROP,$E)
C Ztraty unikem stenou trubky
      DQP1=0.
      DQP2=0.
      TAUW=0.
      DQH=0.
      SELECT CASE(NAMELE)
      CASE($PUMP)
C
C Elementy typu PUMP
C ===================
C cerpadlo se bud vybira z katalogu, nebo je definovane jen 
C hydraulickou charakteristikou
C METHOD<=0  objemove cerpadlo, prutok je zadan uzivatelskou charakteristikou
C METHOD>0  index cerpadla v souboru PUMPS.TXT
        TEMP=(T(1)+T(2))/2.
        RHO =RMPROP(LPROP,$RHO)
        IF(JMPROP(LPROP,$RHO).NE.0)RHO =RHO *CURFUN(JMPROP(LPROP,$RHO))
        DP=PP(1)-PP(2)
        DPA=ABS(DP)
        DO WHILE(DPA.GT.1E15)
           WRITE(2,'(10X,''PUMP pressure drop too high, decreased.'')')
           DP=DP/10.
           DPA=ABS(DP)
        ENDDO
        IF(METHOD.LE.0)THEN
C Pro cerpadlo je hydraulicka charakteristika primo Q(p1-p2)
          AUX(3)=DP
          DQ=CURFUN(IHCH)
        ELSE
C Cerpadlo z katalogu. 
C     Hydraulicka charakteristika  Q = a + b DP + c DP^2
C     Koeficienty jsou v zone RCONST:  a=$RX1, b=$RX2, c=$RX3
C     Linearni charakteristika     Q = e + f DP
C     Koeficienty v zone RCONST        e=$RX4   f=$RX5
C     Rozmezi tlaku     pmin=$RX6   pmax=$RX7
C     Rozmezi prutoku   Qmin=$RX8   Qmax=$RX9
C
          P1=RRCONS(LRCON,$RX6)
          P2=RRCONS(LRCON,$RX7)
          AR=RRCONS(LRCON,$RX1)
          BR=RRCONS(LRCON,$RX2)
          CR=RRCONS(LRCON,$RX3)
          ER=RRCONS(LRCON,$RX4)
          FR=RRCONS(LRCON,$RX5)
          QMAX=RRCONS(LRCON,$RX9)
          QMIN=RRCONS(LRCON,$RX8)
          WRITE(2,'(10X,''PUMP Qmin='',E10.3,'' Qmax='',E10.3,''  dpmin=
     /'',E10.3,'' dpmax='',e10.3,'' Q(dpmin)='',e10.3)')
     /QMIN,QMAX,P1,P2,ER+FR*P1
          IF(DP.GE.0.)THEN
C             DQ=AR
             DQ=ER
             WRITE(2,'(10X,''PUMP reversed pressure, substituted Q='',
     /e10.3)')DQ
          ELSEIF(P1.GT.DPA)THEN
             DQ=ER+FR*DPA
             WRITE(2,'(10X,''PUMP dp too small, linear characteristics Q
     /='',E10.3)')DQ
          ELSE
             DQQ=AR+BR*DPA+CR*DPA*DPA
C Prilis vysoke DP - nahradni hyperbolicka charakteristika
             DQ=AMIN1(QMAX,AMAX1(QMIN*P1/DPA,DQQ))
             IF(DQ.NE.DQQ)THEN
             WRITE(2,'(10X,''PUMP quadratic characteristics QQ='',e10.3,
     /'' was corrected by hyperbolic function Q='',e10.3)')DQQ,DQ
             ELSE
             WRITE(2,'(10X,''PUMP quadratic characteristics QQ='',e10.3)
     /')DQ
             ENDIF
          ENDIF
          RRCONS(LRCON,$H)=-DP/9810.
C     Pokud je definovana i uzivatelska funkce, je povazovana za korekci, kterou
C     se nasobi katalogova hodnota DQ
          IF(IHCH.GT.0)DQ=DQ*CURFUN(IHCH)
          IF(DQ.LT.QMIN)THEN
            INDQ=MAX0(1,LEPAR(NAMELE,$EQ))
            DQ=(1.-$RELFAKT)*EPAR(IE,INDQ)+DQ*$RELFAKT
            WRITE(2,'(10X,''PUMP Q is less than QMIN='',e10.3,''. Underr
     /elax with previous Q='',e10.3)')QMIN,EPAR(IE,INDQ)
          ENDIF
          WRITE(2,'(10X,''PUMP Q [l/s]='',E10.3,'' (p2-p1)/(RHO*g)='',
     /F6.1,'' [m]'')')DQ*1000,-DP/9810.
        ENDIF
        FLOWRATE=DQ
        FI=0
      CASE($PIPE2D,$CSTR,$VALVE)
C
C Elementy typu PIPE,CSTR
C =======================
C H-delka trubky
        DX=(X(2)-X(1))
        DY=(Y(2)-Y(1))
        DZ=(Z(2)-Z(1))
        H=SQRT(DX**2+DY**2+DZ**2)
        IF(H.LE.0.)THEN
          WRITE(2,'('' PIPE2: Zero length of pipe at xyz:'',3E10.3)')
     /          X(1),Y(1),Z(1)
          STOP
        ENDIF
C RRCONS (2-DIAMETER)
C Prurez charakterizuji 3 parametry zony RC: D,Area,Perim, ktere nemusi
C byt konzistentni. D-ekvivalentni prumer pro vypocet Re, Area-pro vypocet
C rychlosti a Perim pro vypocet smocene plochy (a teplosmenne plochy).
C Pokud jsou nektere z techto hodnot nulove, dopocitavaji se z predpokladu
C kruhoveho prurezu.
C Ponekud jiny vyznam ma CSTR. D-oznacuje prumer vstupniho potrubi,
C z nehoz se odvozuje ztratovy soucinitel, prepocitavany na rychlost.
C Jinak se ovsem ztrata CSTR pocita jako pro trubku s prurezem AREA.
        IF(NAMELE.EQ.$CSTR)THEN
C Michana nadoba je povazovana za trubku s prumerem danym plochou AREA
          IF(AREA.LE.0..AND.VOL.GT.0.)AREA=VOL/H
          IF(VOL.LE.0..AND.AREA.GT.0.)VOL=AREA*H
          RRCONS(LRCON,$VOL)=VOL
          R=SQRT(AREA/PI)
C Uvazujeme uplnou ztratu kineticke energie na vstupu
C Puvodni hodnota D oznacuje prumer vstupni trubky - vyuzijeme ho pouze
C pro prepocet ZETA. Pak jiz oznacuje D jen polomer valcove casti.
          IF(D.GT.0.)ZETA=ZETA*(2.*R/D)**4
          D=2.*R
        ELSE
C Trubka
C   speciality:
C   = elasticka stena s modulem pruznosti EW
C   = trubka vyplnena casticemi s prumerem DBALL a porozitou EPS
C
C ------korekce D na elasticitu steny
C
          TEMP=(T(1)+T(2))/2.
	    IF(JMPROP(LPROP,$E).NE.0)EW=EW*CURFUN(JMPROP(LPROP,$E))
	    IF(HWALL.GT.0..AND.EW.GT.1E3) 
     /         D=D+(ABS(PP(1))+ABS(PP(2)))*D**2/(4*HWALL*EW)
C prepocet ekvivalentniho hydraulickeho prumeru
          R=D/2.
          IF(R.LE.0..AND.AREA.GT.0..AND.PERIM.GT.0.)THEN
            R=2.*AREA/PERIM
            D=2*R
            RRCONS(LRCON,$D)=D
          ENDIF
          IF(AREA.LE.0..AND.R.GT.0.)AREA=PI*R**2
          IF(PERIM.LT.0.)THEN
            PERIM=0.
          ELSEIF(PERIM.EQ.0.)THEN
            PERIM=PI*D
          ENDIF
        ENDIF
C kontroly geometrickych parametru
        IF(RRCONS(LRCON,$AREA).EQ.0.)RRCONS(LRCON,$AREA)=AREA
        IF(AREA.LE.0..OR.R.LE.0.)THEN
          WRITE(2,*)' PIPE2: Zero cross section in RCgroup',LRCON
          STOP
        ENDIF
C Stredni teplota elementu pro vypocet hustoty (a pozdeji viskozity)
        TEMP=(T(1)+T(2))/2.
C Koncentrace jako dalsi parametry pro interpret jsou jiz nastaveny
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
        RKX =RMPROP(LPROP,$KX)
        RHO =RMPROP(LPROP,$RHO)
        IF(JMPROP(LPROP,$RHO).NE.0)RHO =RHO *CURFUN(JMPROP(LPROP,$RHO))
C Tlakova ztrata DP z predchozi iterace (s odectenim hydrostatickeho tlaku)
C Hydrostaticky tlak H-delka trubky 
        IF($IBUOY.EQ.1)THEN
C Vztlak $IBUOY=1 - jen z hustoty
          DQH=RHO*($RGY*DY+$RGX*DX+$RGZ*DZ)
        ELSEIF($IBUOY.EQ.2)THEN
C Vztlak $IBUOY=2 Boussinesq dle teploty, okolni teploty $TREF a BETA
          BETA=RMPROP(LPROP,$BETA)
          DQH=-RHO*BETA*(TEMP-$TREF)*($RGY*DY+$RGX*DX+$RGZ*DZ)
        ELSE
C $IBUOY=0 neuvazuje se ani hydrostaticky tlak
          DQH=0.
        ENDIF
C Odhad tlakove ztraty a smykoveho napeti po odecteni hydrostatickeho tlaku
        DPSIGN=PP(1)-PP(2)+DQH
        DP=ABS(DPSIGN)
        DO WHILE(DP.GT.1E15)
           DPSIGN=DPSIGN/10.
           DP=ABS(DPSIGN)
        ENDDO
        TAUW=DP*R/(2.*H)
        TW=TEMP
C Zdanliva viskozita==================================
        VISC =RMPROP(LPROP,$VISC)
        JVISC=JMPROP(LPROP,$VISC)
        IF(JVISC.NE.0)THEN
C Nenewtonska kapalina
C vypocet integralu RMW pro FI lichobeznikovou metodou
          SINV=1.
          G1=CURFUN(JVISC)
          SINV=100000.
          G2=CURFUN(JVISC)  	
C RMW muzeme vynutit kdyz index viskozitni funkce >=10 (napr.teplotne zav.viskozita)
          IF(G1.NE.G2.OR.JVISC.GE.10)THEN
C Zdanliva viskozita zavisi na smyk. napeti TAU
C Pro odhad teplotniho profilu pouzijeme predpoklad parabolickeho
C rychlostniho profilu a linearni teplotni profil v mezni vrstve
            CALL BLIND(IE,IND,NAM)
C DBL je relativni tloustka mezni vrstvy delta/R
C TB  je stredni kalorimetricka teplota
C TE =QMAX=RRCONS(LRCON,$TE)   teplota okoli
C RKE=QMIN=RRCONS(LRCON,$ALFA) soucinitel prostupu tepla z vnejsiho prostredi
C    (do RKE by spravne mel byt zahrnut i fouling)
            DBL=AMIN1(1.,EPAR(IE,IND)/R)
            RKE=QMIN
            TE =QMAX
            TB =TEMP
C BI=RKE*R/LAMBDA
            BI =RKE*R/RKX
C Vypocet teploty steny TW a teploty jadra TC (koef.rychl.profile m=2)
            DBL1=1.-DBL
            AA=DBL1**2/2.-DBL1**4/4.
            BB=(1.-DBL1**3)/3.-(1.-DBL1**5)/5.
            CC=(1.-DBL1**2)/2.-(1.-DBL1**4)/4.
            TW=(TB/4.+TE*(DBL*AA+CC-BB)*BI)/
     /         ((1.+BI*DBL)*AA+(1.+BI)*CC-BI*BB)
            TC=TW+BI*DBL*(TW-TE)
            NTAU=100
            DTAU=TAUW/NTAU
            YCTAU=0.
            SINV=0.
            RR=0.
            DN=1./NTAU
	    DO ITAU=1,NTAU
               SINV=SINV+DTAU
               RR  =RR+DN
C Integrand RMW rovnice dle vztahu  tau^3/mi 
C Odhad teploty (=TC v jadre proudu)
               IF(DBL.GT.0.)THEN
                  IF(RR.LE.DBL1)THEN
                     TEMP=TC
                  ELSE
                     TEMP=TC+(RR-DBL1)*(TW-TC)/DBL
                  ENDIF
               ENDIF
C Vyhodnoceni viskozitni funkce pro teplotu TEMP a tau SINV
               VISCO=CURFUN(JVISC)
               IF(VISCO.LE.1E-10)THEN
                  WRITE(2,'('' PIPE2: Viscosity function too small'')')
                  VISCO=1E-10
               ENDIF
               VISCA=VISCO*VISC
               YTAU=AMAX1(0.,(SINV**3)/VISCA)
               IF(ITAU.NE.NTAU)THEN
	          YCTAU=YCTAU+2*YTAU
               ELSE
	          YCTAU=YCTAU+YTAU
               ENDIF
            ENDDO
C Vracime povodni teplotu (mohla by byt pozdeji pouziva v uzivatelske charakteristice)
            TEMP=TB
            CINT=TAUW/2/NTAU*YCTAU
            IF(DP.NE.0..AND.CINT.NE.0.) VISC=(DP*R/H)**4/(64*CINT)
          ELSE
            VISC=VISC*CURFUN(JVISC)
          ENDIF
        ENDIF
C Konec vypoctu ekvivalentni viskozity nenewtonskych kapalin=========================
C Dale pokracuje vypocet jako pro Newtonske kapaliny.
        IF(VISC.LE.0.)THEN
          WRITE(2,*)' PIPE2: Zero viscosity in pipe',IE
          STOP
        ENDIF
C Vypoctenou teplotu steny ulozime do zony parametru elementu 
C pro pozdejsi vyuziti (pro vypocet tloustky mezni vrstvy)
        EPAR(IE,LEPAR($PIPE2D,$ENU))=TW
     
        IF(EPS.GT..99.OR.EPS.LE..001)THEN

C Porozita >0.99 prazdna trubka

C Odhad Re zalozeny na predpokladu laminarniho proudeni
           RE=R**3*DP*RHO/(4*VISC**2*H)
C
C       Hydraulicka charakteristika trubky pro Newtonskou kapalinu
C       ==========================================================
C Pocatecni odhad FI z Blasiova vztahu bez uvazovani mistnich ztrat.
C Re krit je vypocteno umnele, aby hydraulicka charakteristika byla spojita.
           IF(RE.LE.2300.)THEN
              FI=3.14159*R**4/(8*VISC*H)
           ELSE
C Blasius 
              FI=3.14159*(0.558/H)**(4./7.)*(2*R)**(19./7.)/
     /          ((RHO*DP)**(3./7.)*VISC**(1./7.))
           ENDIF
           FLOWRATE=DPSIGN*FI
           UMEAN=FLOWRATE/AREA
           RE=ABS(UMEAN)*D*RHO/VISC
           IF(DP.GT.0..AND.(RE.GE.2300..OR.G1.EQ.G2))THEN
C Iteracni zpresneni dle Churchilova vztahu a s uvazovanim soucinitele ZETA
C Vynechava se u nenewtonskych kapalin pokud je Re<2300.
              DO I=1,30
                IF(RE.LE.2300.)THEN
                  FLAMB=64/AMAX1(RE,1.)
                ELSE
C Churchil
                  A=(2.457D0*DLOG(1.D0/((7.D0/RE)**0.9+0.27*RA/D)))**16.
                  B=(37530D0/RE)**16.
                  FLAMB=8*((8D0/RE)**12.+1D0/(A+B)**1.5)**(1./12.)
                ENDIF 
                FIN=(3.14159D0*D**2)**2/
     /            (8*RHO*(FLAMB*H/D+ZETA)*ABS(FLOWRATE))
                FI=0.6*FI+0.4*FIN
                FLOWRATE=DPSIGN*FI
                UMEAN=FLOWRATE/AREA
                RE=ABS(UMEAN)*D*RHO/VISC
                IF(ABS(FI-FIN).LE.0.0002*FI)EXIT
              ENDDO
           ENDIF

        ELSE

C eps<.99 Brauerova korelace pro porezni loze
C Odhad Re = v.Db.rho/mi(1-eps) zalozeny na predpokladu creepu
           DP=AMAX1(1.,DP)
           RE=(DBALL*EPS/(1.-EPS))**3*DP*RHO/(160*VISC**2*H)
	     DO ITER=1,5
	        RL=160/RE+3.1/RE**.1
C	WRITE(*,*)' RL=',RL,' RE=',RE
C Iteracni zpresneni Re pro dane DP a Lambda (=RL) dle Brauerovy korelace
	        RE=SQRT(DP*DBALL**3*RHO/(RL*H*VISC**2)*(EPS/(1-EPS))**3)
	     ENDDO
	     FI=PI*D**2*VISC*(1-EPS)*RE/(4*DP*DBALL*RHO)

        ENDIF

C
C Hydraulicka charakteristika FI aparatu (ventil,...): 
C Touto funkci se nasobi FI vypoctene pro trubku.
        IF(IHCH.GT.0)THEN
C FI definovana jako funkce FI=f(DP=abs(p1-p2+dqh)) ...pouze treci ztraty
          AUX(3)=DP
          AUX(4)=RE
          SINV=R
          AUX(6)=H
          FI=FI*CURFUN(IHCH)
        ENDIF

        FLOWRATE=FI*DPSIGN
        PDISSIP=ABS(FLOWRATE*DP)
        DQ=DQH*FI
C Vypocet uniku stenami trubky delky H, polomeru R, tl.steny HWALL
        IF(HWALL.GT.0..AND.PERM.GT.0.)THEN
           DPERM=H*PERIM*PERM/(2*VISC*HWALL)
           DQP1=(PP(1)-PEXT)*DPERM
           DQP2=(PP(2)-PEXT)*DPERM
        ENDIF
      END SELECT
      END

      SUBROUTINE HEXC(ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT metodou vazenych residui (pro vsechny typy elementu s vyjimkou
C deskovych a shell&tube vymeniku tepla).
C Vypocet TEPLOT v uzlovych bodech na zaklade stanovenych prutoku
C
C Elementy: L2, V4 (specialni 4-uzlovy prvek vymenik) PIPE2D,HEXC,TRUSS,BEAM
C Laminarni Newtonska kapalina
C Teplotne zavisla vodivost, cp, hustota (teploty v iteracni zone 4)
C Ohmicky ohrev (napeti v zone 3)
C Uzivatelsky definovany zdroj Q i propad S. 
C Okrajova podminka tretiho druhu na konci potrubi (viz ALPEND).
C
C Rychlost proudeni ze zony EPAR
C Prislusne sloupce matice EPAR urcene vektorem LEPAR(elname,ityp)
C ityp=1 Nalfa, 2 Nbeta, 3 Malfa, 4 Mbeta, 5 Qz, 6 Q, 7 Re, 8 Tau,
C      9 Foul, 10 Diss, 11 LAV,  12 II,  13 Tx, 14 Ty, 15 Tz, 
C      16 Sxx, 17 Syy,  18 Sxy,  19 SvMises
C EPAR vstup        EPAR vystup (post processing ICONTR=1)
C  Q prutok         Q-tepelny vykon pro 4-uzlovy prvek (vymenik)
C  Re               RF-fouling
C  tauw             Tmean
C  index pipe1
C  index pipe2
C
      INCLUDE '$FEMEQ'
      DIMENSION X(4),Y(4),Z(4),AL(NL,NL),BL(NL),ALPEND(4),
     /  RM(2,2),AM(2,2),T(4),TBC(4),U(2),IEH(2),F(2),FX(2),B(2)
      IF(NUE.NE.2.AND.NUE.NE.4)RETURN
C EGROUP,MPROP,RRCONS
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      LEGRP=MAX0(1,IGROUP(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
      IF(ICONTR.GE.0)THEN
C Reseni i postprocessing
C EGROUP stationarni/nestacionarni, zdroj tepla a propad
      NONST=JGROUP(LEGRP,$ST)
      NHEAT=JGROUP(LEGRP,$HEAT)
      NSINK=JGROUP(LEGRP,$HSINK)
C RRCONS (2-DIAMETER,4-alpha,5-Te,6-Area,7-Perim,8-Volume,9-ratio,10-dUdy)
C Zakladni charakteristiky stejne pro 2-uzlove segmenty i 4-uzlovy vymenik
C ale trochu odlisne interpretovane: U elementu vymenik oznacuje ALPHA sou-
C cinitel prostupu tepla mezi proudy, AREA teplosmennou plochu (a ne plochu
C prurezu kanalu)
      R    =RRCONS(LRCON,$D)/2.
      ALPHA=RRCONS(LRCON,$ALFA)
      TE   =RRCONS(LRCON,$TE)
      AREA =ABS(RRCONS(LRCON,$AREA))
      PERIM=RRCONS(LRCON,$PERIM)
      VOL  =RRCONS(LRCON,$VOL)
      DUDY =RRCONS(LRCON,$DUDY)
C
      IF(NUE.EQ.2)THEN
C
C 2-UZLOVY SEGMENT TRUBKA nebo CSTR nebo PUMP, TRUSS, BEAM
C   Tlaky i prutoky jiz musi byt vypocteny. 
C   Prutoky Q jsou ve sloupci LEPAR(name,$EQ) matice EPAR. 
C   Kladna hodnota Q znamena smer 1-2.
C   Reynoldsovo cislo je ve sloupci LEPAR(name,$ERE)
C   Smykove napeti Tau je ve sloupci LEPAR(name,$ETAU)
C   Parametry ALPHA a TE maji vyznam pro vypocet tepelnych ztrat do okoli.
C
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 4 vlastnosti, zona 3 poc.podminky)
C U-napeti ze zony pocatecnich podminek (zona 3), urcuje intenzitu elektrickeho
C   pole ve smeru osy trubky. Pokud existuje jeste slozka intenzity elektrickeho
C   pole kolma k ose trubky, zadava se jako parametr RRCONS dUdy (V/m). 
C   Obe tyto slozky intenzity elektrickeho pole jsou objemovy zdroj tepla.
C
       L0=LUE(IE)
       ACN=0.
       ACD=0.
       ACA=0.
       ALPEND=0.
       DO IU=1,2
         IND=IABS(IUE(L0+IU))
         X(IU)=XX(IND)
         Y(IU)=YY(IND)
         Z(IU)=ZZ(IND)
         LOCT=LPU($TEMP)+IND
         T(IU)=VAL(LOCT,4)
         TBC(IU)=VAL(LOCT,3)
C Pokud je status uzlu IPU>20, je zde okrajovava podminka 3.druhu,
C pricemz soucinitel prenosu tepla ALPEND je parametr uzlu v zone 1.
         IF(IPU(LOCT).GT.20)ALPEND(IU)=VAL(LOCT,1)*CURFUN(IPU(LOCT))
         U(IU)=VAL(LPU($VOLT)+IND,3)
         ACN=ACN+VAL(LPU($CN)+IND,3)
         ACD=ACD+VAL(LPU($CD)+IND,3)
         ACA=ACA+VAL(LPU($CA)+IND,3)
       ENDDO
C H-delka trubky
       H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
C Stredni teplota elementu pro vypocet vlastnosti
       TMEAN=(T(1)+T(2))/2.
       EPAR(IE,LEPAR(NAMELE,$ETMEAN))=TMEAN
       TEMP=TMEAN
C Teziste elementu
       AUX(2)=(X(1)+X(2))/2.
       AUX(3)=(Y(1)+Y(2))/2.
       AUX(4)=(Z(1)+Z(2))/2.
       SINV=ABS(EPAR(IE,LEPAR(NAMELE,$ETAU)))
       AUX($LDOF+$CN)=ACN/2.
       AUX($LDOF+$CD)=ACD/2.
       AUX($LDOF+$CA)=ACA/2.
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
       RKX =RMPROP(LPROP,$KX)
       CP  =RMPROP(LPROP,$CP)
       RHO =RMPROP(LPROP,$RHO)
       RKAP=RMPROP(LPROP,$KAPPA)
       IF(JMPROP(LPROP,$KX).NE.0)RKX =RKX *CURFUN(JMPROP(LPROP,$KX))
       IF(JMPROP(LPROP,$CP).NE.0)CP  =CP  *CURFUN(JMPROP(LPROP,$CP))
       IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO *CURFUN(JMPROP(LPROP,$RHO))
       IF(JMPROP(LPROP,$KAPPA).NE.0)
     /                            RKAP=RKAP*CURFUN(JMPROP(LPROP,$KAPPA))

       IF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP)THEN
C CSTR/PUMP - na rozdil od predchozi verze jen uprava geometrie
         IF(VOL.GT.0.)THEN
            AREA=VOL/H
            R=SQRT(AREA/PI)
            D=2*R
         ENDIF
         IF(AREA.LE.0.)AREA=2*PI*R
         IF(VOL.LE.0.)VOL=AREA*H
       ELSE
C PIPE
         IF(R.LE.0..AND.AREA.GT.0..AND.PERIM.GT.0.)R=2.*AREA/PERIM
         IF(AREA.LE.0..AND.R.GT.0.)AREA=3.14159*R**2
         IF(AREA.LE.0..OR.R.LE.0.)THEN
             WRITE(2,*)' HEXC: Zero cross section in pipe element',IE
             STOP
         ENDIF
         IF(PERIM.LT.0.)THEN
             PERIM=0.
         ELSEIF(PERIM.EQ.0.)THEN
             PERIM=2*PI*R
         ENDIF
       ENDIF
C
C Zdroje tepla
C Elektricky vykon (PODELNA A PRICNA SLOZKA INTENZITY EL.POLE)
C
       SINK=0.
       Q=0.
       IF($ISOURCE.NE.0)THEN
           Q=RKAP*(((U(2)-U(1))/H)**2+DUDY**2)
           IF(NHEAT.NE.0)Q=Q+CURFUN(NHEAT)
           IF(NSINK.NE.0)SINK=CURFUN(NSINK)
       ENDIF
C
C==============generovani matic elementu PIPE,PUMP,CSTR
C
       IF(ICONTR.EQ.0)THEN
C
C 2-UZLOVY ELEMENT GENEROVANI SOUSTAVY ROVNIC
C
C A - teplotni vodivost
         A=RKX/(RHO*CP)
         IF(NAMELE.EQ.$TRUSS2D.OR.NAMELE.EQ.$BEAM2D.OR.
     /      NAMELE.EQ.$TRUSS3D.OR.NAMELE.EQ.$BEAM3D)THEN
C Tahla nebo nosniky
           HH=PERIM*ALPHA
           AEFF=A
           ZUPW=0.
           UMEAN=0.
         ELSE
C Elementy s kapalinou
C Termicky odpor jako soucet vnitrnich (RF+RNU) a vnejsich (REXT) odporu
           RF =EPAR(IE,LEPAR(NAMELE,$EFOUL))
           DBL=EPAR(IE,LEPAR(NAMELE,$EQZ))
C $BL - korekce na termicky odpor mezni vrstvy
           RNU=DBL/RKX*$BL
           IF(RNU.GT.0.)EPAR(IE,LEPAR(NAMELE,$EALPHA))=1./RNU
           REXT=1./AMAX1(1E-10,ALPHA)
           RSUM=RF+RNU+REXT
           HH=PERIM/RSUM
C Stredni rychlost 
           UMEAN=EPAR(IE,LEPAR(NAMELE,$EQ))/AREA
           AUMEAN=ABS(UMEAN)
           IF(AUMEAN.LE.1e-10)THEN
             WRITE(*,'('' HEXC: Zero Flowrate in Element'',I6)')IE
           ENDIF
C Vypocet teplotni disperse AEFF (efektivni teplotni vodivost)
           RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
           CALL DISPERS(A,2.*R,RE,AUMEAN,$RTAUDISP,AEFF,ITAYLOR)
           IF(AEFF.LE.0.)THEN
             WRITE(2,*)' HEXC: Zero thermal dispersion coefficient'
             STOP
           ENDIF
           IF($IUPW.NE.0.AND.AUMEAN.NE.0.)THEN
C UPWIND
C Peclet (VZTAZENY NA DELKU ELEMENTU, NE PRUMER TRUBKY)
             PE=AMIN1(20.,AUMEAN*H/AEFF)
C MIN/MAX Pe
             RALGOR(34)=AMIN1(RALGOR(34),PE)
             RALGOR(35)=AMAX1(RALGOR(35),PE)
             IF(PE.GT.0.01)THEN
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
               AOPT=ALF*$RUPW
             ELSE
               AOPT=0.
             ENDIF
             IF(MOD(ICOUNTS,10).EQ.1.AND.$DEBUG.NE.0)THEN
               SELECT CASE(ITAYLOR)
               CASE(1)
               WRITE(*,900)IE,AEFF/A,PE
900   FORMAT(' HEXC: E',i3.3,' Taylor-LAMINAR ae/a=',E9.2,' Pe=',E9.2)
               CASE(2)
               WRITE(*,901)IE,AEFF/A,PE
901   FORMAT(' HEXC: E',i3.3,' Taylor-modified ae/a=',E9.2,' Pe=',E9.2)
               CASE(3)
               WRITE(*,902)IE,AEFF/A,PE
902   FORMAT(' HEXC: E',i3.3,' Taylor-TURBULENT ae/a=',E9.2,' Pe=',E9.2)
               ENDSELECT
             ENDIF
             ZUPW=AOPT*H*UMEAN/(2*AUMEAN)
           ELSE
C UPWIND SUPPRESSED
             ZUPW=0.
           ENDIF 
         ENDIF
C -------spolecna sekce pro PIPE,TRUSS,BEAM,PUMP,CSTR
         ARCP=AREA*RHO*CP
C Bazove funkce a derivace v tezisti elementu (1 bodova Gaussova integrace)
         IF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP)THEN
C asymetricke bazove funkce pro CSTR/PUMP
           FX(1)=-1./H
           FX(2)=1./H
           ZUPW=0.
           RM=0.
           IF(UMEAN.GE.0.)THEN
            F(1)=0.0
            F(2)=1.0
            RM(2,2)=H*ARCP
           ELSE
            F(1)=1.0
            F(2)=0.0
            RM(1,1)=H*ARCP
           ENDIF
         ELSE
C symetricke bazove funkce pro PIPE, TRUSS, BEAM
           F(1)=0.5
           F(2)=0.5
           FX(1)=-1./H
           FX(2)=1./H
           RM(1,1)=(H/3-ZUPW/2)*ARCP
           RM(1,2)=(H/6-ZUPW/2)*ARCP
           RM(2,1)=(H/6+ZUPW/2)*ARCP
           RM(2,2)=(H/3+ZUPW/2)*ARCP
         ENDIF
         DO I=1,2
           WI=F(I)+ZUPW*FX(I)
           DO J=1,2
             AM(I,J)=((WI*FX(J)*UMEAN+AEFF*FX(I)*FX(J))*ARCP+
     /                 WI*(HH+AREA*SINK)*F(J))*H
           ENDDO
           B(I)=WI*(HH*TE+Q*AREA)*H+ALPEND(I)*AREA*TE
           AM(I,I)=AM(I,I)+ALPEND(I)*AREA
         ENDDO
C
C Lokalni matice elementu
C 
         IF(NONST)THEN
            DO I=1,2
              BL(I)=DTIME*B(I)
              DO J=1,2
                AL(I,J)=RM(I,J)+DTIME*AM(I,J)*$RTHETA
                BL(I)=BL(I)+(RM(I,J)-DTIME*(1-$RTHETA)*AM(I,J))*TBC(J)
              ENDDO
            ENDDO
          ELSE
C STACIONARNI PRIPAD
            DO I=1,2
              BL(I)=B(I)
              DO J=1,2
                AL(I,J)=AM(I,J)
              ENDDO
            ENDDO
          ENDIF

       ELSE

C 2-UZLOVY ELEMENT POSTPROCESSING (ICONTR.EQ.1) VYPOCET FOULINGU
C   Vyznam parametru zony elementu EPAR urcuje LEPAR
         RFOLD=AMAX1(0.,EPAR(IE,LEPAR(NAMELE,$EFOUL)))
         TAU=EPAR(IE,LEPAR(NAMELE,$ETAU))
         RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
C Fouling se zvysuje jen pri nastaveni priznaku transient
         IF(NONST.GT.0)THEN
         SELECT CASE($IFOUL)
         CASE(0)
           RF=0.
         CASE(1)
C   Konstanty modelu Ebert Panchal (alfa, aktiv.energie, gamma):
           EPALP=8.39
           EPE=68E3
           EPGAM=4.03E-11
           RGAS=8.314
           RF=RFOLD+DTIME*(EPALP/RE**0.88*EXP(-EPE/(RGAS*(TMEAN+273)))
     /                   -EPGAM*TAU)
         CASE DEFAULT
C    Novy CHISA 
C    Toyoda TEMP i koncentrace ACN,ACD,ACA jsou jiz aktualizovany
           RF=RFOLD+DTIME*CURFUN($IFOUL)
         END SELECT
         EPAR(IE,LEPAR(NAMELE,$EFOUL))=AMAX1(0.,RF)
         ENDIF
         $RPOWERT=$RPOWERT+Q*AREA*H
       ENDIF

      ELSE
C
C ==================================================
C 4-UZLOVY ELEMENT VYMENIKU TEPLA, TVORENY DVEMA SEGMENTY, JEJICHZ
C   INDEXY JSOU V ZONE EPAR (MAXEPAR-1, MAXEPAR).  
C
       IEH(1)=IEPAR(IE,LEPAR(NAMELE,$EE1))
       IEH(2)=IEPAR(IE,LEPAR(NAMELE,$EE2))
       IF(ALPHA.LE.0..OR.AREA.LE.0.)THEN
       WRITE(*,'('' HEXC: Zero ALPHA or AREA in 4-node element'',I6)')IE
       ENDIF
       BL=0
       AL=0
C
C Soucinitel prenosu tepla ze souctu termickych odporu
       RTSUM=1./AMAX1(1E-5,ALPHA)
       DO K=1,2
          IEHK=IEH(K)
C Termofyzikalni vlastnosti proudu K
          NAMELEK=JGROUP(IGROUP(IEHK),$ENAME)
          LPROP=MAX0(1,IMPROP(IEHK))
          RKK  =RMPROP(LPROP,$KX)
C Stredni teplota pro korekce termofyzikalnich vlastnosti
          TEMP=EPAR(IEHK,LEPAR(NAMELEK,$ETMEAN))
          IF(JMPROP(LPROP,$KX).NE.0)RKK =RKK *CURFUN(JMPROP(LPROP,$KX))
C RFK   termicky odpor foulingu
          RFK=EPAR(IEHK,LEPAR(NAMELEK,$EFOUL))
          RTSUM=RTSUM+ABS(EPAR(IEHK,LEPAR(NAMELEK,$EQZ)))/RKK*$BL
     /               +RFK
       ENDDO
C SK - S.K
       SK=AREA/RTSUM
       EPAR(IE,7)=1./RTSUM
       EPAR(IE,8)=RFK
       DO K=1,2
          IEHK=IEH(K)
C Termofyzikalni vlastnosti proudu K
          NAMELEK=JGROUP(IGROUP(IEHK),$ENAME)
          LPROP=MAX0(1,IMPROP(IEHK))
          LRCON=MAX0(1,IRCONS(IEHK))
          DK=RRCONS(LRCON,$D)
          AREAK=ABS(RRCONS(LRCON,$AREA))
          IF(AREAK.LE.0.)THEN
C Vypocet plochy z prumeru trubky
             AREAK=3.14159*DK**2/4.
          ENDIF
          RKK  =RMPROP(LPROP,$KX)
          CPK  =RMPROP(LPROP,$CP)
          RHOK =RMPROP(LPROP,$RHO)
C Stredni teplota pro korekce termofyzikalnich vlastnosti
          TEMP=EPAR(IEHK,LEPAR(NAMELEK,$ETMEAN))
          IF(JMPROP(LPROP,$KX).NE.0)RKK =RKK *CURFUN(JMPROP(LPROP,$KX))
          IF(JMPROP(LPROP,$CP).NE.0)CPK =CPK *CURFUN(JMPROP(LPROP,$CP))
          IF(JMPROP(LPROP,$RHO).NE.0)
     /                             RHOK=RHOK*CURFUN(JMPROP(LPROP,$RHO))
C Delka segmentu K
          L0=LUE(IEHK)
          DO IU=1,2
             IND=IABS(IUE(L0+IU))
             X(IU)=XX(IND)
             Y(IU)=YY(IND)
             Z(IU)=ZZ(IND)
             LOCT=LPU($TEMP)+IND
             T(IU)=VAL(LOCT,4)
          ENDDO
          HK=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
          AK=RKK/(RHOK*CPK)
C REK - Reynolds
          REK=ABS(EPAR(IEHK,LEPAR(NAMELEK,$ERE)))
C Stredni rychlost
          UMEAN=EPAR(IEHK,LEPAR(NAMELEK,$EQ))/AREAK
          AUMEAN=ABS(UMEAN)
          CALL DISPERS(AK,DK,REK,AUMEAN,$RTAUDISP,AKEFF,ITAYLOR)
C Peclet (VZTAZENY NA DELKU ELEMENTU, NE PRUMER TRUBKY)
          PE=AMIN1(20.,AUMEAN*HK/AKEFF)
C MIN/MAX Pe
          RALGOR(34)=AMIN1(RALGOR(34),PE)
          RALGOR(35)=AMAX1(RALGOR(35),PE)
C Upwind
          IF(PE.GT.0.01)THEN
             EE=EXP(PE)
             ALF=(EE+1./EE)/(EE-1./EE)-1./PE
             AOPT=ALF*$RUPW
          ELSE
             AOPT=0.
          ENDIF
          IF(AUMEAN.EQ.0.)THEN
             WRITE(*,'('' HEXC: Zero flowrate in 4-node PIPE'',I3)')
     /                  IEH(K)
             ZUPW=0
          ELSE
             ZUPW=AOPT*HK*UMEAN/(2*AUMEAN)
          ENDIF        
C   Soucasne se pocitaji elementy EPAR (jako postprocessing)
C   1     2     3     4     5     6     7     8     9    10   11   12   
C   Q1    Q2   NTU1  NTU2  QF1   QF2    k     RF    T1   T2   T3   T4   
          FLOWRATK=AUMEAN*AREAK
          WK=FLOWRATK*RHOK*CPK
          IF(WK.GT.0.)THEN
            EPAR(IE,K)=ABS(T(1)-T(2))*WK
            EPAR(IE,K+2)=SK/WK
            EPAR(IE,K+4)=FLOWRATK
            EPAR(IE,K+8)=T(1)
            EPAR(IE,K+10)=T(2)
          ENDIF
C Bazove funkce a derivace v tezisti elementu (1 bodova Gaussova integrace)
          F(1)=0.5
          F(2)=0.5
          FX(1)=-1./HK
          FX(2)=1./HK
C STEADY/TRANSIENT
          IF(NONST)THEN
            SHD=SK*DTIME*HK
          ELSE
            SHD=SK*HK
          ENDIF
          DO I=1,2
            CONV=F(I)+ZUPW*FX(I)
            DO J=1,2
              BIJ=CONV*F(J)*SHD
              IF(K.EQ.2)BIJ=-BIJ
              AL(2*(K-1)+I,J)=BIJ
              AL(2*(K-1)+I,J+2)=-BIJ
            ENDDO
          ENDDO
C konec cyklu pres K-segmenty vymeniku
       ENDDO
      ENDIF
C VYNECHANI TELA PROCEDURY PRI KONTROLE BLOKOVANI PROCEDUROU FTFRIN
      ENDIF
      END

      SUBROUTINE RTD(IOPER,ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT metoda vazenych residui (pro vsechny elementy krome 
C vymeniku tepla CHEVRON a SHELL&TUBE)
C Vypocet koncentraci v uzlovych bodech (nestacionarni pripad)
C IOPER=4 CN, =5 CD, =6 CA
C
C Elementy: L2 (AXIALNI DISPERZE, CSTR)
C Rozliseni techto dvou typu je dano hodnotou NAMELE =1 (pipe), =2 (CSTR)
C Pocatecni koncentrace je v zone 3.
C
      INCLUDE '$FEMEQ'
      DIMENSION X(2),Y(2),Z(2),AL(NL,NL),BL(NL),T(2),C(2),B(2),CBC(2),
     /          RM(2,2),AM(2,2),F(2),FX(2),ALPEND(2)
      IF(NUE.NE.2)RETURN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
      IF(ICONTR.GE.0)THEN
C EGROUP (NONST=1-TRANSIENT, NAMELE=1-PIPE2D,=7-CSTR,=8-PUMP)
      NONST=JGROUP(LEGRP,$ST)
C RRCONS (2-DIAMETER), AREA-prut.prurez, PERIM-smoceny obvod, V-objem misice
      R=RRCONS(LRCON,$D)/2.
      AREA=ABS(RRCONS(LRCON,$AREA))
      PERIM=RRCONS(LRCON,$PERIM)
      VOL=RRCONS(LRCON,$VOL)
C ALPHA - soucinitel prenosu hmoty na vnejsi stene trubky
C TE    - koncetrace CN,CD,CA vnejsiho prostredi (odpovidaji ALPHA)
      SELECT CASE(IOPER)
      CASE($CONC)
        ALPHA=RRCONS(LRCON,$KN)
        TE   =RRCONS(LRCON,$CEN)
        IDN  =$DN
        IAN  =$AN
        NSOURCE=JGROUP(LEGRP,$NSOURCE)
        NSINK=JGROUP(LEGRP,$NSINK)
      CASE($COND)
        ALPHA=RRCONS(LRCON,$KD)
        TE   =RRCONS(LRCON,$CED)
        IDN  =$DD
        IAN  =$AD
        NSOURCE=JGROUP(LEGRP,$DSOURCE)
        NSINK=JGROUP(LEGRP,$DSINK)
      CASE($CONA)
        ALPHA=RRCONS(LRCON,$KA)
        TE   =RRCONS(LRCON,$CEA)
        IDN  =$DA
        IAN  =$AA
        NSOURCE=JGROUP(LEGRP,$ASOURCE)
        NSINK=JGROUP(LEGRP,$ASINK)
      ENDSELECT
C
C NORMALNI VYPOCET FTFRON
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C T-TEPLOTY ZE ZONY 3
C C-KONCENTRACE V ZONE 3, vlastnosti v zone 4
C ALPEND - soucinitel prenosu hmoty v koncovem bode site
C
      L0=LUE(IE)
      ACN=0.
      ACD=0.
      ACA=0.
      ALPEND=0.
      DO IU=1,2
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        T(IU)=VAL(LPU($TEMP)+IND,3)
        SELECT CASE(IOPER)
          CASE($CONC)
            LOC=LPU($CN)+IND
          CASE($COND)
            LOC=LPU($CD)+IND
          CASE($CONA)
            LOC=LPU($CA)+IND
        ENDSELECT
        C(IU)=AMAX1(0.,VAL(LOC,4))
        CBC(IU)=AMAX1(0.,VAL(LOC,3))
        IF(IPU(LOC).GT.20)ALPEND(IU)=VAL(LOC,1)*CURFUN(IPU(LOC))
        ACN=ACN+VAL(LPU($CN)+IND,4)
        ACD=ACD+VAL(LPU($CD)+IND,4)
        ACA=ACA+VAL(LPU($CA)+IND,4)
      ENDDO
C H-delka trubky
      H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
C Stredni teplota elementu, stredni koncentrace a smykove napeti pro vypocet 
C   koeficientu difuze
C   zdrojoveho clenu SOURCE
C   propadu SINK
      TMEAN=(T(1)+T(2))/2.
      TEMP=TMEAN
C Teziste elementu
      AUX(2)=(X(1)+X(2))/2.
      AUX(3)=(Y(1)+Y(2))/2.
      AUX(4)=(Z(1)+Z(2))/2.
      SINV=ABS(EPAR(IE,LEPAR(NAMELE,$ETAU)))
      AUX($LDOF+$CN)=ACN/2.
      AUX($LDOF+$CD)=ACD/2.
      AUX($LDOF+$CA)=ACA/2.
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA,9-DN,10-EN,11-AN) 
      DN =RMPROP(LPROP,IDN)
      AN =RMPROP(LPROP,IAN)
      IF(JMPROP(LPROP,IDN).NE.0)DN=DN*CURFUN(JMPROP(LPROP,IDN))
      IF(JMPROP(LPROP,IAN).NE.0)AN=AN*CURFUN(JMPROP(LPROP,IAN))
      IF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP)THEN
C CSTR/PUMP
         IF(VOL.GT.0.)THEN
           AREA=VOL/H
           R=SQRT(AREA/PI)
           D=2*R
         ENDIF
      ELSE
C PIPE
         IF(R.LE.0..AND.AREA.GT.0..AND.PERIM.GT.0.)R=2.*AREA/PERIM
         IF(AREA.LE.0..AND.R.GT.0.)AREA=PI*R**2
         IF(PERIM.LT.0.)THEN
            PERIM=0.
         ELSEIF(PERIM.EQ.0.)THEN
            PERIM=2.*PI*R
         ENDIF
         IF(AREA.LE.0..OR.R.LE.0.)THEN
            WRITE(2,777)IE
            WRITE(*,777)IE
777         FORMAT(' RTD: Zero cross section in element',I7)
            STOP
         ENDIF
      ENDIF
C
C Zdrojove cleny (reakce)
C
      Q=0.
      ARRHEN=0.
      IF($ISOURCE.NE.0)THEN
         ARRHEN=AN
         IF(NSOURCE.NE.0)Q=Q+CURFUN(NSOURCE)
         IF(NSINK.NE.0)ARRHEN=ARRHEN+CURFUN(NSINK)
      ENDIF
C
C=========generovani matic elementu PIPE,PUMP CSTR
C
      IF(ICONTR.EQ.0)THEN
C Difuzni odpor pocitany zatim jen jako vnejsi odpor (ALPHA-souc.prenosu hmoty)
        REXT=1./AMAX1(1E-5,ALPHA)
        RSUM=REXT
        HH=PERIM/RSUM
C Stredni rychlost
        UMEAN=EPAR(IE,LEPAR(NAMELE,$EQ))/AREA
        AUMEAN=ABS(UMEAN)
C
C Dispersni koeficient DNEFF
C
        RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
        CALL DISPERS(DN,2.*R,RE,AUMEAN,$RTAUDISP,DNEFF,ITAYLOR)
        IF(DNEFF.LE.0.)THEN
             WRITE(2,*)' RTD: Zero dispersion coefficient'
             STOP
        ENDIF
        IF($IUPW.NE.0.AND.AUMEAN.GT.0.)THEN
C UPWIND
C Difuzni Peclet (VZTAZENY NA DELKU ELEMENTU, NE PRUMER TRUBKY)
            PE=AMIN1(20.,ABS(UMEAN)*H/DNEFF)
C MIN/MAX Pe
            RALGOR(34)=AMIN1(RALGOR(34),PE)
            RALGOR(35)=AMAX1(RALGOR(35),PE)
            IF(PE.GT.0.01)THEN
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
               AOPT=ALF*$RUPW
            ELSE
               AOPT=0.
            ENDIF
            ZUPW=AOPT*H*UMEAN/(2*AUMEAN)
        ELSE
C UPWIND SUPPRESSED
            ZUPW=0
        ENDIF
C Bazove funkce a derivace v tezisti elementu (1 bodova Gaussova integrace)
        IF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP)THEN
C asymetricke bazove funkce pro CSTR/PUMP
          FX(1)=-1./H
          FX(2)=1./H
          ZUPW=0.
          RM=0.
          IF(UMEAN.GE.0.)THEN
           F(1)=0.0
           F(2)=1.0
           RM(2,2)=H*AREA
          ELSE
           F(1)=1.0
           F(2)=0.0
           RM(1,1)=H*AREA
          ENDIF
        ELSE
C symetricke bazove funkce pro PIPE
          F(1)=0.5
          F(2)=0.5
          FX(1)=-1./H
          FX(2)=1./H
          RM(1,1)=(H/3-ZUPW/2)*AREA
          RM(1,2)=(H/6-ZUPW/2)*AREA
          RM(2,1)=(H/6+ZUPW/2)*AREA
          RM(2,2)=(H/3+ZUPW/2)*AREA
        ENDIF
        DO I=1,2
           WI=F(I)+ZUPW*FX(I)
           DO J=1,2
             AM(I,J)=((WI*FX(J)*UMEAN+DNEFF*FX(I)*FX(J))*AREA+
     /                WI*(HH+AREA*ARRHEN)*F(J))*H
           ENDDO
           B(I)=WI*(HH*TE+Q*AREA)*H+ALPEND(I)*AREA*TE
           AM(I,I)=AM(I,I)+ALPEND(I)*AREA
        ENDDO
C
C Lokalni matice elementu
C
        IF(NONST)THEN
           DO I=1,2
             BL(I)=DTIME*B(I)
             DO J=1,2
                AL(I,J)=RM(I,J)+DTIME*AM(I,J)*$RTHETA
                BL(I)=BL(I)+(RM(I,J)-DTIME*(1-$RTHETA)*AM(I,J))*CBC(J)
             ENDDO
           ENDDO
        ELSE
           DO I=1,2
             BL(I)=B(I)
             DO J=1,2
                AL(I,J)=AM(I,J)
             ENDDO
           ENDDO
        ENDIF
      ELSE
C Dvouuzlovy postprocessing
      ENDIF
      ENDIF
      END

      SUBROUTINE ELE1(ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT 
C Vypocet POTENCIALU v uzlovych bodech 
C
C Elementy: L2 
C
      INCLUDE '$FEMEQ'
      DIMENSION X(2),Y(2),Z(2),AL(NL,NL),BL(NL),T(2),C(2)
      IF(NUE.NE.2)RETURN
      IF(ICONTR.EQ.0)THEN
C
C NORMALNI VYPOCET FTFRON
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C T-TEPLOTY ZE ZONY 3
C C-KONCENTRACE V ZONE 3
C
      L0=LUE(IE)
      DO IU=1,2
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        T(IU)=VAL(LPU($TEMP)+IND,3)
        C(IU)=VAL(LPU($CN)+IND,3)
      ENDDO
C H-delka trubky
      H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
C EGROUP,MPROP,RRCONS
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C RRCONS (2-DIAMETER), AREA-prut.prurez, PERIM-smoceny obvod, V-objem misice
      R=RRCONS(LRCON,$D)/2.
      AREA=ABS(RRCONS(LRCON,$AREA))
      PERIM=RRCONS(LRCON,$PERIM)
      V=RRCONS(LRCON,$VOL)
      IF(R.LE.0..AND.AREA.GT.0..AND.PERIM.GT.0.)R=2.*AREA/PERIM
      IF(AREA.LE.0..AND.R.GT.0.) AREA=3.14159*R**2
      IF(AREA.LE.0..OR.R.LE.0.)THEN
          WRITE(2,*)' ELE1: Zero cross section in element',IE
          STOP
      ENDIF
C Stredni teplota a koncentrace elementu pro vypocet koeficientu elektricke vodivosti
      TMEAN=(T(1)+T(2))/2.
      CMEAN=(C(1)+C(2))/2.
      TEMP=TMEAN
      AUX($LDOF+$CN)=CMEAN
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA,9-DN,10-EN,11-AN) 
      RKAPPA=RMPROP(LPROP,$KAPPA)
      IF(JMPROP(LPROP,$KAPPA).NE.0)
     /                    RKAPPA=RKAPPA*CURFUN(JMPROP(LPROP,$KAPPA))
      DD=RKAPPA*AREA/H
      AL(1,1)=DD
      AL(1,2)=-DD
      AL(2,1)=-DD
      AL(2,2)=DD
      BL=0
      ENDIF
      END

      SUBROUTINE DISPERS(A,D,RE,U,TAUD,AEFF,ITAYLOR)
C
C Vypocet dispersniho soucinitele
C A-molekularni difuse
C D-prumer trubky
C Re-Reynolds
C U-stredni rychlost
C TAUD-casova konstanta
C Vystupni parametry:
C AEFF - dispersni soucinitel
C ITAYLOR =0 nic, =1 taylor/aris, =2 modifikace, =3 turbulence
C Vybirame tu nejmensi hodnotu
      INCLUDE '$FEM'      
      IF(RE.LE.0.)THEN
         AEFF=A
         ITAYLOR=0
      ELSE
         AETAY=A+(U*D)**2/(192.*A)
         AETUR=A+U*D*(3E7/RE**2.1+1.35/RE**0.125)
         AETAU=A+U**2*TAUD/PI
         IF(AETAY.LE.AETUR.AND.AETAY.LE.AETAU)THEN
C Taylor Arisova disperze LAMINAR
            AEFF=AETAY
            ITAYLOR=1
         ELSEIF(AETAU.LE.AETUR)THEN
C Taylor Arisova ZADAVANE TAU
            AEFF=AETAU
            ITAYLOR=2
         ELSE
C Taylor Arisova disperze TURBULENCE
            AEFF=AETUR
            ITAYLOR=3
         ENDIF
      ENDIF
C MIN/MAX AEFF
      IF(A.GT.0.)THEN
         RALGOR(32)=AMIN1(RALGOR(32),AEFF/A)
         RALGOR(33)=AMAX1(RALGOR(33),AEFF/A)
      ELSE
         WRITE(2,*)' ZERO DIFFUSION COEFFICIENT'
      ENDIF
      END

