C $S4A-KLO.FOR
      SUBROUTINE HPIPE(ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT modifikace pro variantu HEPI=1 (vymeniky tepla)
C Vypocet TLAKU v uzlovych bodech. 
C
C Elementy: L2 nebo L4 (to je rozdil proti PIPE)
C Laminarni Newtonska kapalina / turbulentni tok (Blasius)
C Teplotne zavisla viskozita a hustota 
C Tlaky potrebne pro odhad prutokoveho soucinitele v zone 4 (ITERACNI)
C Teploty pro odhad viskozity v zone 3 (POCATECNI PODMINKY)
C
C Uzivatelem definovana hydraulicka charakteristika FI(DP,RE,DE) jako
C funkce cislo EGROUP(7)
C 
C ICONTR=1 vypocet parametru zony EPAR(MAXEL,MAXEPAR) 
C    Q prutok [m^3/s]
C    Re
C    Tau smykove napeti na stene [Pa]
C Prislusne sloupce matice EPAR jsou urceny vektorem LEPAR(elname,ityp)
C ityp=1 Nalfa, 2 Nbeta, 3 Malfa, 4 Mbeta, 5 Qz, 6 Q, 7 Re, 8 Tau,
C      9 Foul, 10 Diss, 11 LAV,  12 II,  13 Tx, 14 Ty, 15 Tz, 
C      16 Sxx, 17 Syy,  18 Sxy,  19 SvMises
C Odlisne vyznamy maji EPAR u 4-uzlovych elementu vymeniku tepla
C EPAR(IE,1)-Q1, EPAR(IE,2)-Q2,   objemove prutoky
C EPAR(IE,3)-Re1,EPAR(IE,4)-Re2,  Reynoldsova cisla
C EPAR(IE,5)-v1, EPAR(IE,6)-v2,   stredni rychlosti [m/s]
C EPAR(IE,7)-RF1,EPAR(IE,8)-RF2,  termicky odpor usad
C EPAR(IE,9)-W1, EPAR(IE,10)-W2,  tepelne kapacity proudu
C EPAR(IE,11)-EPS                 efektivita vymeniku
C EPAR(IE,12)-EPOWER              tepelny vykon vymeniku
C
      INCLUDE '$FEMEQ'
      DIMENSION X(4),Y(4),Z(4),AL(NL,NL),BL(NL),T(4),PP(4),IM(2),DPV(2)
      DIMENSION S(2),D(2)
      IF(NUE.NE.2.AND.NUE.NE.4)RETURN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
      METHOD=JGROUP(LEGRP,$METHOD)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 3)
C p-TLAKY Z PREDCHOZI ITERACE (zona 4)
C
      IF(ICONTR.GE.0)THEN
C NORMALNI VYPOCET FTFRON
        L0=LUE(IE)
        DO IU=1,NUE
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
          Y(IU)=YY(IND)
          Z(IU)=ZZ(IND)
          T(IU)=VAL(LPU($TEMP)+IND,3)
          PP(IU)=VAL(LPU($PRES)+IND,4)
        ENDDO
C Rozvetveni na pripady elementu dvouuzlove a ctyruzlove (vymeniky)
        IF(NUE.EQ.2)THEN
          CALL PIPE2(IE,X,Y,Z,T,PP,LRCON,LPROP,LEGRP,FI,DQ,DQP1,DQP2,
     /           RHO,UMEAN,RE,FLOWRATE,TAUW,PDISSIP)

          IF(ICONTR.EQ.0)THEN
C Vypocet matice prutokovych koeficientu
             IF($IVOLU.EQ.0)THEN
                FIRHO=FI*RHO
                BL(1)=(-DQ-DQP1)*RHO
                BL(2)=(DQ-DQP2)*RHO
             ELSE
                FIRHO=FI
                BL(1)=(-DQ-DQP1)
                BL(2)=(DQ-DQP2)
             ENDIF
             AL(1,1)=FIRHO
             AL(2,2)=FIRHO
             AL(1,2)=-FIRHO
             AL(2,1)=-FIRHO
C
          ELSEIF(ICONTR.GT.0)THEN
C
C ICONTR>0 Vypocet prutoku Q, Re, Tau
C
             INDQ=MAX0(1,LEPAR(NAMELE,$EQ))
             INDRE=MAX0(1,LEPAR(NAMELE,$ERE))
             INDTAU=MAX0(1,LEPAR(NAMELE,$ETAU))
             INDEVX=MAX0(1,LEPAR(NAMELE,$EVX))
             KEPAR(NAMELE,INDQ)=1
             KEPAR(NAMELE,INDRE)=1
             KEPAR(NAMELE,INDTAU)=1
             EPAR(IE,INDQ)=FLOWRATE
             EPAR(IE,INDRE)=RE
             EPAR(IE,INDTAU)=TAUW
             EPAR(IE,INDEVX)=UMEAN
             $RPOWERF=$RPOWERF+PDISSIP
          ENDIF
C ICONTR-IF
        ELSE
C 4uzlove elementy - vymenik tepla
          SELECT CASE(METHOD)
          CASE($CHEV)
C Deskovy vymenik CHEVRON je definovany parametry
C EGROUP    $fi=m (pocet paralelnich kanalu), $GAUSS=mprop1, $AXIS=mprop2
C RCONST    $H (tl.desky), $D (De), $P (uhel sipu), $ALFA (vodivost desky),
C           $AREA (plocha desky), $PERIM=w (sirka desky), $VOL=L (vyska desky)
C EPAR      EPAR(IE,1)-Q1, EPAR(IE,2)-Q2, EPAR(IE,3)-V1, EPAR(IE,4)-V2
C           EPAR(IE,5)-RE1, EPAR(IE,6)-RE2
            DE=RRCONS(LRCON,$D)
            H =RRCONS(LRCON,$H)
            THE=RRCONS(LRCON,$P)*3.14159/180.
            RLA=RRCONS(LRCON,$ALFA)
            AREA=RRCONS(LRCON,$AREA)
            W=RRCONS(LRCON,$PERIM)
            RL=RRCONS(LRCON,$VOL)
C AREA - teplosmenna plocha jedne desky
            IF(AREA.LE.0..AND.W.GT.0..AND.RL.GT.0.)THEN
               AREA=1.41*W*RL
            ELSEIF(AREA.LE.0.)THEN
               WRITE(2,*)' HPIPE: Zero cross section in element',IE
               STOP
            ENDIF
            M=JGROUP(LEGRP,$FI)
            IM(1)=JGROUP(LEGRP,$GAUSS)
            IM(2)=JGROUP(LEGRP,$AXIS)
            IF(M.LE.0)THEN
               WRITE(2,*)' HPIPE: Zero no.of channels in CHEVRON',IE
               STOP
            ELSEIF(IM(1).LE.0.OR.IM(2).LE.0)THEN
            WRITE(2,*)' HPIPE: Zero index of material properties in CHEV
     /RON',ie
               STOP
            ENDIF
C
C Nulovani matic AL BL
C
            AL=0
            BL=0
            CT=COS(THE)
            ST=SIN(THE)
            TT=ST/CT
C Cyklus pres proudy 1 a 2
            DPV(1)=PP(1)-PP(2)
            DPV(2)=PP(3)-PP(4)
            DO K=1,2
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
              IG=IM(K)
              RHO =RMPROP(IG,$RHO)
              IF(JMPROP(IG,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(IG,$RHO))
              VISC=RMPROP(IG,$VISC)
C Vypocet Re
              Q=EPAR(IE,K)
              DP=DPV(K)
              ADP=AMAX1(1E-2,ABS(DP))
              DO ITER=1,20
                U=ABS(2*Q/(M*DE*W))
                RE=AMAX1(1E-3,U*DE*RHO/VISC)
                IF(RE.LE.2000.)THEN
                  F0=16/RE
                  F1=149/RE+0.9625
                ELSE
                  F0=1/(1.56*ALOG(RE)-3.)
                  F1=9.75/RE**0.289
                ENDIF
                RF=CT/SQRT(0.045*TT+0.09*ST+F0/CT)+(1-CT)/SQRT(3.8*F1)
                FI=M*W*DE**1.5*RF/SQRT(8.*RL*RHO*ADP)
                QOLD=Q
                Q=FI*DP
                IF(ITER.GT.2.AND.ABS(Q-QOLD).LT.1E-8)EXIT
              ENDDO
              EPAR(IE,K)=Q
              EPAR(IE,K+2)=RE
              EPAR(IE,K+4)=U
              EPAR(IE,K+6)=1./RF**2
              IDIAG=2*K
              IF($IVOLU.EQ.0)THEN
                 FIRHO=FI*RHO
              ELSE
                 FIRHO=FI
              ENDIF
              AL(IDIAG,IDIAG)=FIRHO
              AL(IDIAG-1,IDIAG-1)=FIRHO
              AL(IDIAG,IDIAG-1)=-FIRHO
              AL(IDIAG-1,IDIAG)=-FIRHO
            ENDDO

          CASE($STUB)

C Kotlovy vymenik - SHELL and TUBE je definovan parametry
C INDEXY - 1 latka protekana mezitrubkovym prostorem
C          2 latka protekana trubkovym prostorem,
C EGROUP   $fi=np  - pocet prepazek, $GAUSS=mprop1, $AXIS=mprop2,
C          $ST=nch - pocet chodu v trubkovem prostoru,
C          $STRESS=nt - pocet trubek 
C RCONST    $H=tlt  - tloustka trubky,
C           $D=dt2  - vnejsi prumer potrubi,
C           $P=alfat - uhel usporadani trubek,
C           $ALFA=rla - vodivost trubky
C           $AREA=DPS - nejvetsi prumer svazku trubek,
C           $PERIM=DP1 - vnitrni prumer plaste,
C           $PERMEAB=RLt - delka trubek
C           $ZETA=tp - roztec prepazek
C           $KN=sp - tloustka prepazky
C           $CEN=hp - vyska prepazky
C           $TE=rd1 - stredni absolutni drsnost steny trubky
C           $DUDY=stp - vule mezi trubkou a prepazkou
C           $JZ=spp - vule mezi plastem a prepazkou
C           $RA=tt - roztec trubek,
C               
C EPAR(IE,1)-Q1, EPAR(IE,2)-Q2,   objemove prutoky
C EPAR(IE,3)-Re1,EPAR(IE,4)-Re2,  Reynoldsova cisla
C EPAR(IE,5)-v1, EPAR(IE,6)-v2,   stredni rychlosti [m/s]
C EPAR(IE,7)-RF1,EPAR(IE,8)-RF2,  termicky odpor usad
C EPAR(IE,9)-W1, EPAR(IE,10)-W2,  tepelne kapacity proudu
C EPAR(IE,11)-EPS                 efektivita vymeniku
C EPAR(IE,12)-EPOWER              tepelny vykon vymeniku

C Geometrie vymeniku
            TLT=RRCONS(LRCON,$H)
            DT2=RRCONS(LRCON,$D)
            ALFAT=RRCONS(LRCON,$P)
            RLA=RRCONS(LRCON,$ALFA)
            DP1=RRCONS(LRCON,$PERIM)
            RLT=RRCONS(LRCON,$PERMEAB)
            XTP=RRCONS(LRCON,$ZETA)
            SP=RRCONS(LRCON,$KN)
            HP=RRCONS(LRCON,$CEN)
            RD1=RRCONS(LRCON,$TE)
            STP=RRCONS(LRCON,$DUDY)
            SPP=RRCONS(LRCON,$JZ)
            TT=RRCONS(LRCON,$RA)
            DPS=RRCONS(LRCON,$AREA)
            NP=JGROUP(LEGRP,$FI)
            NCH=JGROUP(LEGRP,$ST)
            NT=JGROUP(LEGRP,$STRESS)
            NPL=0
            XLTN=2*(RLT-XTP*(NP-1))
  
C Materialove vlastnosti proudu
            IM(1)=JGROUP(LEGRP,$GAUSS)
            IM(2)=JGROUP(LEGRP,$AXIS)
            IF(IM(1).LE.0.OR.IM(2).LE.0)THEN
              WRITE(2,*)' HPIPE: Zero index of material properties in 
     /SHELTUBE',ie
              STOP
            ENDIF 
      
            IF(ALFAT.GT.90.)THEN
              WRITE(*,*)'PIPE2: ERROR INPUT - ANGEL OF TUBES LAYOUT'
              STOP  
            ENDIF
C Vnitrni prumer trubky		      
            DT1=DT2-2*TLT
C Koeficient C1 pro vypocet uhlu fivsc 
            IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
              C1=0.866
            ELSE
              C1=1.
            ENDIF
            FIVSC=2*ACOSD(2/(DPS-DT2)*(HP-DP1/2))
C Pocet trubek ve vyrezu prepasky
            NTV=(DPS-DT2)**2/8/TT**2/C1*(FIVSC*3.14159/180-SIND(FIVSC))
            IF(NT.LE.0)THEN
              NT=3.14159*(DPS-DT2)**2/4/TT**2/C1
            ENDIF
C Prutocny prurez v TP
            S(2)=(3.14159*DT1**2.*NT)/(4.*NCH)
            TT1=TT*SIN(ALFAT)*2.
            TT2=TT*COS(ALFAT)
            STS=DP1-DPS
            STT=TT-DT2
            IF(ALFAT.GT.25..AND.ALFAT.LT.35.)THEN
              SUMSTT=(DPS-DT2)/TT1*STT
            ELSEIF(ALFAT.GT.85..AND.ALFAT.LE.90.)THEN
              SUMSTT=(DPS-DT2)/TT1*STT
            ELSE
              SUMSTT=(DPS-DT2)/TT1*STT*2
            ENDIF
C Prutocny prurez v MP
            S(1)=(STS+SUMSTT)*(XTP-SP)
            D(2)=DT1
            D(1)=3.14159*DT2/2.
C
C Nulovani matic AL BL
C
            AL=0
            BL=0
            
C Cyklus pres proudy 1 a 2
            DPV(1)=PP(1)-PP(2)
            DPV(2)=PP(3)-PP(4)
            DPV1=DPV(1)
            DPV2=DPV(2)
            DO K=1,2
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
              IG=IM(K)
              RHO =RMPROP(IG,$RHO)
              IF(JMPROP(IG,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(IG,$RHO))
              VISC=RMPROP(IG,$VISC)
C Vypocet Re
              Q=EPAR(IE,K)
              DP=DPV(K)
              ADP=AMAX1(1E-2,ABS(DP))
              DO ITER=1,20
                U=ABS(Q/S(K))
                RE=AMAX1(1E-3,U*D(K)*RHO/VISC)
                IF(K.EQ.1)THEN
                  CALL FISHELL(TLT,DT2,ALFAT,
     /DP1,XTP,SP,HP,TT,DPS,NP,NCH,NPL,FI1,
     /RE,RHO,VISC,Q,NT,XLTN,SPP,STP)
                  FI=FI1*1/ADP**0.5
                ELSE
                  CALL FITUBE(NCH,NT,TLT,DT2,
     /RLT,RD1,FI2,RE,RHO)
                  FI=FI2*1/ADP**0.5
                ENDIF
                QOLD=Q
                Q=FI*DP
                IF(ITER.GT.2.AND.ABS(Q-QOLD).LT.1E-8)EXIT
              ENDDO
              EPAR(IE,K)=Q
              EPAR(IE,K+2)=RE
              EPAR(IE,K+4)=U
              RF=1.
              EPAR(IE,K+6)=1./RF**2
              IDIAG=2*K
              IF($IVOLU.EQ.0)THEN
                FIRHO=FI*RHO
              ELSE
                FIRHO=FI
              ENDIF
              AL(IDIAG,IDIAG)=FIRHO
              AL(IDIAG-1,IDIAG-1)=FIRHO
              AL(IDIAG,IDIAG-1)=-FIRHO
              AL(IDIAG-1,IDIAG)=-FIRHO
            ENDDO

          CASE($STH)
	   
C Kotlovy vymenik - SHELL and TUBE s sroubovicoymi prepazkami
C INDEXY - 1 latka protekana mezitrubkovym prostorem
C          2 latka protekana trubkovym prostorem,
C EGROUP   $fi=np  - pocet prepazek, $GAUSS=mprop1, $AXIS=mprop2,
C          $ST=nch - pocet chodu v trubkovem prostoru,
C          $STRESS=nt - pocet trubek 
C          $HEAT=npl - pocet paru tesnicich list
C RCONST    $H=tlt  - tloustka trubky,
C           $D=dt2  - vnejsi prumer potrubi,
C           $P=alfat - uhel usporadani trubek,
C           $ALFA=rla - vodivost trubky
C           $AREA=DPS - nejvetsi prumer svazku trubek,
C           $PERIM=DP1 - vnitrni prumer plaste,
C           $RA=RLt - delka trubek
C           $ZETA=DMT - prumer stredove trubky
C           $KN=sp - tloustka prepazky
C           $CEN=fis - UHEL STOUPANI
C           $TE=rd1 - stredni absolutni drsnost steny trubky
C           $DUDY=stp - vule mezi trubkou a prepazkou
C           $JZ=spp - vule mezi plastem a prepazkou
C           $VOL=xltn - delka neprepazkovane trubky
C           $PERMEAB=tt - roztec trubek,
C              
C EPAR(IE,1)-Q1, EPAR(IE,2)-Q2,   objemove prutoky
C EPAR(IE,3)-Re1,EPAR(IE,4)-Re2,  Reynoldsova cisla
C EPAR(IE,5)-v1, EPAR(IE,6)-v2,   stredni rychlosti [m/s]
C EPAR(IE,7)-RF1,EPAR(IE,8)-RF2,  termicky odpor usad
C EPAR(IE,9)-W1, EPAR(IE,10)-W2,  tepelne kapacity proudu
C EPAR(IE,11)-EPS                 efektivita vymeniku
C EPAR(IE,12)-EPOWER              tepelny vykon vymeniku

C Geometrie vymeniku
            TLT=RRCONS(LRCON,$H)
            DT2=RRCONS(LRCON,$D)
            ALFAT=RRCONS(LRCON,$P)
            RLA=RRCONS(LRCON,$ALFA)
            DP1=RRCONS(LRCON,$PERIM)
            RLT=RRCONS(LRCON,$RA)
            DMT=RRCONS(LRCON,$ZETA)
            SP=RRCONS(LRCON,$KN)
            FIS=RRCONS(LRCON,$CEN)
            RD1=RRCONS(LRCON,$TE)
            STP=RRCONS(LRCON,$DUDY)
            SPP=RRCONS(LRCON,$JZ)
            XLTN=RRCONS(LRCON,$VOL)
            TT=RRCONS(LRCON,$PERMEAB)
            DPS=RRCONS(LRCON,$AREA)
            NP=JGROUP(LEGRP,$FI)
            NCH=JGROUP(LEGRP,$ST)
            NT=JGROUP(LEGRP,$STRESS)
            NPL=JGROUP(LEGRP,$HEAT)
            XLT0=RLT-XLTN
            IM(1)=JGROUP(LEGRP,$GAUSS)
            IM(2)=JGROUP(LEGRP,$AXIS)
            IF(IM(1).LE.0.OR.IM(2).LE.0)THEN
              WRITE(2,*)' HPIPE: Zero index of material properties in 
     /SHELTUBE',ie
              STOP
            ENDIF
       
            IF(alfat.GT.90.)THEN
              WRITE(*,*)'PIPE2: ERROR INPUT - ANGEL OF TUBES LAYOUT'
              STOP  
            ENDIF
      
            HS=3.14159*DP1*TAND(FIS)
            DT1=DT2-2*TLT
            IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
              C1=0.866
            ELSE
              C1=1.
            ENDIF
            FIVSC=2*ACOSD(2/(DPS-DT2)*(HP-DP1/2))
            NTV=(DPS-DT2)**2/8/TT**2/C1*(FIVSC*3.14159/180-SIND(FIVSC))
            IF(NT.LE.0)NT=3.14159*(DPS-DT2)**2/4/TT**2/C1
            S(2)=(3.14159*DT1**2.*NT)/(4.*NCH)
            IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
              C2=0.866
            ELSEIF(ALFAT.GT.50..AND.ALFAT.LE.70.)
     /THEN
              C2=0.866
            ELSE
              C2=0.707
            ENDIF
            IF(DMT.EQ.0)THEN
            S(1)=((DP1-DPS)/2+(DPS-DT2)*(1+1/C2)*(TT-DT2)/4/TT)*
     /(HS-SP/COSD(FIS))
            ELSE
            S(1)=((DP1-DPS)/2+(DPS-DMT-2*DT2)*(1+1/C2)*(TT-DT2)/4/TT)*
     /(HS-SP/COSD(FIS))
            ENDIF
            D(2)=DT1
            D(1)=3.14159*DT2/2.
C
C Nulovani matic AL BL
C
            AL=0
            BL=0      
C Cyklus pres proudy 1 a 2
            DPV(1)=PP(1)-PP(2)
            DPV(2)=PP(3)-PP(4)
            DO K=1,2
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
              IG=IM(K)
              RHO =RMPROP(IG,$RHO)
              IF(JMPROP(IG,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(IG,$RHO))
              VISC=RMPROP(IG,$VISC)
C Vypocet Re
              Q=EPAR(IE,K)
              DP=DPV(K)
              ADP=AMAX1(1E-2,ABS(DP))
              DO ITER=1,20
                U=ABS(Q/S(K))
                RE=AMAX1(1E-3,U*D(K)*RHO/VISC)
                IF(K.EQ.1)THEN
                  CALL FISHELLH(tlt,dt2,alfat,
     /DP1,hs,sp,fis,tt,DPS,nch,npl,FI1,
     /RE,RHO,nt,DMT,RLt,xlt0)
                    FI=FI1*1/ADP**0.5
                ELSE
                  CALL FITUBE(nch,nt,tlt,dt2,
     /RLt,rd1,FI2,RE,RHO)
                  FI=FI2*1/ADP**0.5
                ENDIF
                QOLD=Q
                Q=FI*DP
                IF(ITER.GT.2.AND.ABS(Q-QOLD).LT.1E-8)EXIT
              ENDDO
              EPAR(IE,K)=Q
              EPAR(IE,K+2)=RE
              EPAR(IE,K+4)=U
              EPAR(IE,K+6)=1./RF**2
              IDIAG=2*K
              AL(IDIAG,IDIAG)=FI
              AL(IDIAG-1,IDIAG-1)=FI
              AL(IDIAG,IDIAG-1)=-FI
              AL(IDIAG-1,IDIAG)=-FI
            ENDDO
          END SELECT
        ENDIF
      ENDIF
      END

      SUBROUTINE HHEXC(ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT metodou entalpickych bilanci
C Vypocet TEPLOT v uzlovych bodech na zaklade stanovenych prutoku
C Uzivatelsky definovane zdrojove a propadove cleny.
C
C Elementy: L2, V4 (specialni 4-uzlove prvky vymeniku tepla:
C                   souproud/protiproud, CHEVron, Shell&TUBe, HAIRpin)
C Laminarni Newtonska kapalina
C Teplotne zavisla vodivost, cp, hustota (teploty v iteracni zone 4)
C Ohmicky ohrev (napeti v zone 3)
C
C Rychlost proudeni ze zony EPAR
C EPAR vstup        EPAR vystup (post processing ICONTR=1)
C  6-Q prutok       12-Q-tepelny vykon pro 4-uzlovy prvek (vymenik)
C  7-Re
C  8-tauw
C  MAXEPAR-1 -index pipe1
C  MAXEPAR   -index pipe2
C Vymeniky tepla maji odlisne usporadani EPAR
C
      INCLUDE '$FEMEQ'
      DIMENSION X(4),Y(4),Z(4),AL(NL,NL),BL(NL),
     / RM(4,4),AM(4,4),BM(4),T(4),TBC(4),U(4),NPU(4),IEH(2),W(2),F(2)
      IF(NUE.NE.2.AND.NUE.NE.4)RETURN
C EGROUP,MPROP,RRCONS
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      LEGRP=MAX0(1,IGROUP(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
      METHOD=JGROUP(LEGRP,$METHOD)
      NHEAT=JGROUP(LEGRP,$HEAT)
      NSINK=JGROUP(LEGRP,$HSINK)
      IF(ICONTR.GE.0)THEN
C Reseni i postprocessing
C EGROUP stationarni/nestacionarni 
      NONST=JGROUP(LEGRP,$ST)
C RRCONS (2-DIAMETER,4-alpha,5-Te,6-Area,7-Perim,8-Volume,9-ratio,10-dUdy)
C Zakladni charakteristiky stejne pro 2-uzlove segmenty i 4-uzlovy vymenik
C ale trochu odlisne interpretovane: U elementu vymenik oznacuje ALPHA sou-
C cinitel prostupu tepla mezi proudy, AREA teplosmennou plochu (a ne plochu
C prurezu kanalu)
      R    =RRCONS(LRCON,$D)/2.
      ALPHA=RRCONS(LRCON,$ALFA)
      TE   =RRCONS(LRCON,$TE)
      AREA =ABS(RRCONS(LRCON,$AREA))
      PERIM=RRCONS(LRCON,$PERIM)
      DUDY =RRCONS(LRCON,$DUDY)
      VOL  =RRCONS(LRCON,$VOL)
C
      L0=LUE(IE)
      ACN=0.
      ACD=0.
      ACA=0.
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        LOCT=LPU($TEMP)+IND
C Teploty z predchozi iterace
        T(IU)=VAL(LOCT,4)
C Teploty - pocatecni podminka
        TBC(IU)=VAL(LOCT,3)
C Status uzlu - pokud je > 20 znamena to, ze uzel je koncovy
        NPU(IU)=IPU(LOCT)
C Elektricke napeti
        U(IU)=VAL(LPU($VOLT)+IND,3)
C Prumerne hodnoty koncentraci
        ACN=ACN+VAL(LPU($CN)+IND,3)
        ACD=ACD+VAL(LPU($CD)+IND,3)
        ACA=ACA+VAL(LPU($CA)+IND,3)
      ENDDO
C
      IF(NUE.EQ.2)THEN
C
C 2-UZLOVY SEGMENT TRUBKA
C   Tlaky i prutoky jiz musi byt vypocteny. 
C   Prutoky Q jsou ve sloupci LEPAR(name,$QE) matice EPAR. 
C   Kladna hodnota Q znamena smer 1-2.
C   Reynoldsovo cislo je ve sloupci LEPAR(name,$ERE).
C   Smykove napeti Tau na stene je ve sloupci LEPAR(name,$ETAU).
C   Parametry ALPHA a TE maji vyznam pro vypocet tepelnych ztrat do okoli.
C
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 4 pro vlastnosti, ze zony 3 pro poc.podminky)
C U-napeti ze zony pocatecnich podminek (zona 3), urcuje intenzitu elektrickeho
C   pole ve smeru osy trubky. Pokud existuje jeste slozka intenzity elektrickeho
C   pole kolma k ose trubky zadava jako parametr RRCONS dUdy (V/m). Obe dve tyto slozky
C   intenzity elektrickeho pole se povazuji za objemovy zdroj tepla.
C
C H-delka trubky
         H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
C Stredni teplota elementu pro vypocet viskozity
         TMEAN=(T(1)+T(2))/2.
         EPAR(IE,LEPAR(NAMELE,$ETMEAN))=TMEAN
         TEMP=TMEAN
C Teziste elementu a prumerne koncentrace
         AUX(2)=(X(1)+X(2))/2.
         AUX(3)=(Y(1)+Y(2))/2.
         AUX(4)=(Z(1)+Z(2))/2.
         AUX(5)=ABS(EPAR(IE,LEPAR(NAMELE,$ETAU)))
         AUX($LDOF+$CN)=ACN/2.
         AUX($LDOF+$CD)=ACD/2.
         AUX($LDOF+$CA)=ACA/2.
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RKX =RMPROP(LPROP,$KX)
         CP  =RMPROP(LPROP,$CP)
         RHO =RMPROP(LPROP,$RHO)
         RKAP=RMPROP(LPROP,$KAPPA)
         IF(JMPROP(LPROP,$KX).NE.0)RKX =RKX*CURFUN(JMPROP(LPROP,$KX))
         IF(JMPROP(LPROP,$CP).NE.0)CP  =CP *CURFUN(JMPROP(LPROP,$CP))
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$KAPPA).NE.0)
     /                            RKAP=RKAP*CURFUN(JMPROP(LPROP,$KAPPA))
C PERIM*H-urcuje teplosmennou plochu,AREA-prutocny prurez,VOL-objem
         IF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP)THEN
C CSTR/PUMP uprava geometrie
            IF(VOL.GT.0.)THEN
               AREA=VOL/H
               R=SQRT(AREA/PI)
               D=2*R
            ENDIF
         ELSE
C PIPE
            IF(R.LE.0..AND.AREA.GT.0..AND.PERIM.GT.0.)R=2.*AREA/PERIM
            IF(AREA.LE.0..AND.R.GT.0.) AREA=PI*R**2
            IF(PERIM.LT.0.)THEN
               PERIM=0.
            ELSEIF(PERIM.EQ.0.)THEN
               PERIM=2.*PI*R
            ENDIF
            IF(AREA.LE.0..OR.R.LE.0.)THEN
               WRITE(2,*)' HHEXC: Zero cross section in element',IE
               STOP
            ENDIF
         ENDIF
C
C Zdroje tepla
C Elektricky vykon (PODELNA A PRICNA SLOZKA INTENZITY EL.POLE)
C Q [W/M^3]
         SINK=0.
         Q=0.
         IF($ISOURCE.NE.0)THEN
             Q=RKAP*(((U(2)-U(1))/H)**2+DUDY**2)
             IF(NHEAT.NE.0)Q=Q+CURFUN(NHEAT)
             IF(NSINK.NE.0)Q=Q+CURFUN(NSINK)
         ENDIF
         IF(ICONTR.EQ.0)THEN
C
C 2-UZLOVY ELEMENT GENEROVANI SOUSTAVY ROVNIC
C
C Ztraty do okoli, seriove odpory vnitrni (RF+RNU) a vnejsi (REXT)
           RF=AMAX1(0.,EPAR(IE,LEPAR(NAMELE,$EFOUL)))
           RNU=AMAX1(0.,EPAR(IE,LEPAR(NAMELE,$EQZ)))/RKX
           REXT=1./AMAX1(1E-5,ALPHA)
C $BL-korekce tloustky mezni vrstvy
           RSUM=RF+RNU*$BL+REXT
C AW = k L O
           AW=PERIM*H/RSUM
C Stredni rychlost 
           UMEAN=EPAR(IE,LEPAR(NAMELE,$EQ))/AREA
           AUMEAN=ABS(UMEAN)
           IF(AUMEAN.LE.1e-10)THEN
             WRITE(*,'('' Zero Flowrate in Element'',I6)')IE
           ENDIF
           IF(NAMELE.EQ.$PIPE2D)THEN
C Vypocet teplotni disperse AEFF (efektivni teplotni vodivost)
             RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
C Teplotni vodivost
             A=RKX/(RHO*CP)
             CALL DISPERS(A,2.*R,RE,AUMEAN,$RTAUDISP,AEFF,ITAYLOR)
             IF(AEFF.LE.0.)THEN
               WRITE(2,*)' HHEXC: Zero thermal dispersion coefficient'
               STOP
             ENDIF
             RKXEFF=AEFF*RHO*CP
             AKXE=AREA*RKXEFF/H
C Tepelna kapacita proudu
             WW=UMEAN*AREA*RHO*CP
C Tepelna kapacita elementu rozpocitana na uzly
             WM=RHO*CP*AREA*H/2.
C AWS = kLO+ALS
             AWW=AW+AREA*H*SINK
C Pomocne matice
             RM=0
             AM=0
             BM=0
             IF(WW.GT.0.)THEN
               RM(2,1)=-WM
               RM(2,2)=-WM
               AM(1,1)=-WW-AKXE
               AM(1,2)=AKXE
               AM(2,1)=WW+AKXE-AWW/2
               AM(2,2)=-AKXE-AWW/2
               IF(NPU(2).GT.20)AM(2,2)=AM(2,2)-WW
               BM(2)=-(Q*AREA*H+AW*TE)
             ELSE
               RM(1,1)=-WM
               RM(1,2)=-WM
               AM(1,1)=-AKXE-AWW/2
               AM(1,2)=-WW-AWW/2+AKXE
               IF(NPU(1).GT.20)AM(1,1)=AM(1,1)+WW
               AM(2,1)=AKXE
               AM(2,2)=WW-AKXE
               BM(1)=-(Q*AREA*H+AW*TE)
             ENDIF
           ELSEIF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP)THEN
C Tepelna kapacita proudu
             WW=UMEAN*AREA*RHO*CP
C Tepelna kapacita elementu
             WM=RHO*CP*VOL
C AWS = kLO+VOL.S
             AWW=AW+VOL*SINK
C Pomocne matice
             RM=0
             AM=0
             BM=0
             IF(WW.GT.0.)THEN
               RM(2,2)=-WM
               AM(1,1)=-WW
               AM(2,1)=WW
               AM(2,2)=-AWW
               IF(NPU(2).GT.20)AM(2,2)=AM(2,2)-WW
               BM(2)=-(Q*VOL+AW*TE)
             ELSE
               RM(1,1)=-WM
               AM(1,1)=-AWW
               AM(1,2)=-WW
               IF(NPU(1).GT.20)AM(1,1)=AM(1,1)+WW
               AM(2,2)=WW
               BM(1)=-(Q*VOL+AW*TE)
             ENDIF
           ENDIF
C Lokalni matice elementu
           AL=0
           BL=0
           IF(NONST)THEN
             DO I=1,2
               BL(I)=DTIME*BM(I)
               DO J=1,2
                 AL(I,J)=RM(I,J)+DTIME*AM(I,J)*$RTHETA
                 BL(I)=BL(I)+(RM(I,J)-DTIME*(1-$RTHETA)*AM(I,J))*TBC(J)
               ENDDO
             ENDDO
           ELSE
C STACIONARNI PRIPAD
             DO I=1,2
               BL(I)=BM(I)
               DO J=1,2
                  AL(I,J)=AM(I,J)
               ENDDO
             ENDDO
           ENDIF

         ELSE

C 2-UZLOVY ELEMENT POSTPROCESSING (ICONTR.EQ.1) VYPOCET FOULINGU
C   Vyznam parametru zony elementu EPAR: 1-Q, 2-Re, 3-Tau, 4-RF, 5-Tmean
           RFOLD=AMAX1(0.,EPAR(IE,LEPAR(NAMELE,$EFOUL)))
           TAU=EPAR(IE,LEPAR(NAMELE,$ETAU))
           RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
           SELECT CASE($IFOUL)
           CASE(0)
             RF=0.
           CASE(1)
C   Konstanty modelu Ebert Panchal (alfa, aktiv.energie, gamma):
             EPALP=8.39
             EPE=68E3
             EPGAM=4.03E-11
             RGAS=8.314
             RF=RFOLD+DTIME*(EPALP/RE**0.88*EXP(-EPE/(RGAS*(TMEAN+273)))
     /                   -EPGAM*TAU)
           CASE DEFAULT
             RF=RFOLD+DTIME*CURFUN($IFOUL)
           END SELECT
           EPAR(IE,LEPAR(NAMELE,$EFOUL))=AMAX1(0.,RF)
         ENDIF

      ELSE
C
C 4-UZLOVY ELEMENT VYMENIKU TEPLA. Rozlisuje se nekolik ruznych variant,
C   dle parametru METHOD v zone JGROUP:
C     =0  vymenik ze dvou trubkovych (a nezavisle sestavovanych) elementu.
C         INDEXY techto trubek jsou zone EPAR (MAXEPAR-1, MAXEPAR).    
C     =11 CHEV  deskovy vymenik
C     =12 STUB  shell&tube
C     =13 HAIR  
C
       SELECT CASE(METHOD)
       CASE(0,1,2)
C Souproud/protiproud
         IEH(1)=IEPAR(IE,LEPAR(NAMELE,$EE1))
         IEH(2)=IEPAR(IE,LEPAR(NAMELE,$EE2))
         IF(ALPHA.LE.0..OR.AREA.LE.0.)THEN
           WRITE(*,'('' ZERO ALPHA OR AREA IN HEXCH ELEMENT'',I6)')IE
         ENDIF
         DO K=1,2
           IEHK=IEH(K)
C Termofyzikalni vlastnosti proudu K
           NAMELEK=JGROUP(IGROUP(IEHK),$ENAME)
           LPROP=MAX0(1,IMPROP(IEHK))
           LRCON=MAX0(1,IRCONS(IEHK))
           CPK  =RMPROP(LPROP,$CP)
           RHOK =RMPROP(LPROP,$RHO)
C Stredni teplota pro korekce termofyzikalnich vlastnosti
           TEMP=EPAR(IEHK,LEPAR(NAMELEK,$ETMEAN))
           IF(JMPROP(LPROP,$KX).NE.0)RKK =RKK *CURFUN(JMPROP(LPROP,$KX))
           IF(JMPROP(LPROP,$CP).NE.0)CPK =CPK *CURFUN(JMPROP(LPROP,$CP))
           IF(JMPROP(LPROP,$RHO).NE.0)
     /                             RHOK=RHOK*CURFUN(JMPROP(LPROP,$RHO))
C RFK   termicky odpor foulingu
           F(K)=EPAR(IEHK,LEPAR(NAMELEK,$EFOUL))
           W(K)=EPAR(IEHK,LEPAR(NAMELEK,$EQ))*RHOK*CPK
         ENDDO
       CASE($CHEV)
         CALL HCHEV(IE,T,LRCON,LEGRP,F,W,AREA,ALPHA)
C ALEF - celkovy soucinitel prostupu tepla
         ALEF=1./(1/ALPHA+F(1)+F(2))
C NTU1=k.S/W1
         RTU1=ALEF*AREA/ABS(W(1))
C R1 - pomer tepelnych kapacit
         R1=ABS(W(1)/W(2))
C EPSILON
         IF(W(1)*W(2).LT.0.)THEN
C PROTIPROUD
            E=EXP(-RTU1*(1-R1))
            EPS=(1-E)/(1-R1*E)
         ELSE
C SOUPROUD
            E=EXP(-RTU1*(1+R1))
            EPS=(1-E)/(1+R1)
         ENDIF
       CASE($STUB)
         CALL HSTUBE(IE,T,LRCON,LEGRP,F,W,AREA,ALPHA,nch)
C ALEF - celkovy soucinitel prostupu tepla
         ALEF=1./(1/ALPHA+F(1)+F(2))
	
C NTU1=k.S/W1
 	   RTU1=ALEF*AREA/ABS(W(1))
C R1 - pomer tepelnych kapacit
         R1=ABS(W(1)/W(2))
C Vymenk typu 1-1 (jeden chod v MP a jeden chod v TP)
        IF(nch.EQ.1)THEN
C EPSILON	   
          IF(W(1)*W(2).LT.0.)THEN
C PROTIPROUD
             IF(R1.EQ.1)THEN
                EPS=RTU1/(1+RTU1)
             ELSE
                E=EXP(-RTU1*(1-R1))
                EPS=(1-E)/(1-R1*E)
	       ENDIF
          ELSE
C SOUPROUD
             E=EXP(-RTU1*(1+R1))
             EPS=(1-E)/(1+R1)
	  ENDIF
	ELSEIF(nch.EQ.2)THEN
	  EP=0.5
	  XM=(1.+R1**2+2*R1*(2*EP-1.))**0.5
	  EPS=(0.5*(1+R1+XM*(TANH(0.5*XM*RTU1))**(-1)))**(-1)
	ELSEIF(nch.EQ.3)THEN
	  EP=0.3333333
	  IF(R1.EQ.1)THEN
	     XE1=1/(EXP(-0.5*RTU1*(1+3*EP))-1)
	     XE2=1/(EXP(0.5*RTU1*(1-EP))+1)
	     XE3=2*((1+EP)/(1+3*EP))**2
	     XE4=EP*(1-EP)/(1+3*EP)
	     EPSI=RTU1*XE4-XE3/(1/XE1+1/XE2)
	     EPS=1/(1+1/EPSI)
	  ELSE
             XP=RTU1*(1-0.5*R1*(1-3*EP))
             XQ=0.5*EP*(1-EP)*RTU1**2*R1*(1-R1)
	     XM1=XP/2.+(XP**2/4-XQ)**0.5
	     XM2=XP/2.-(XP**2/4-XQ)**0.5
	     XM3=0.5*R1*RTU1*(1-EP)
	     XC1=XM1*(EXP(XM1)+EXP(XM3))*(EXP(XM2)-1.)
	     XC2=XM2*(EXP(XM2)+EXP(XM3))*(1.-EXP(XM1))
	     XC3=RTU1*(1-R1)*(EXP(XM2)-EXP(XM1))*(1.+EXP(XM3))
	     XJ1=XM1*(EXP(XM1)+EXP(XM3))*(R1*EXP(XM2)-1.)
	     XJ2=XM2*(EXP(XM2)+EXP(XM3))*(1.-R1*EXP(XM1))
	     XJ3=RTU1*(1-R1)*(EXP(XM2)-EXP(XM1))*(1+R1*EXP(XM3))
	     EPS=(XC1+XC2+XC3)/(XJ1+XJ2+XJ3)
	  ENDIF
        ELSEIF(nch.EQ.4)THEN
	  XM=(TANH(0.25*RTU1*(4+R1**2)**0.5))**(-1)
	  XN=TANH(0.25*R1*RTU1)
	  EPS=0.25*(2+2*R1+(4+R1**2)**0.5*XM+R1*XN)
	ELSE
	  WRITE(*,*)'HPIPE:WRONG INPUT NCH'
	  STOP
	ENDIF
	 	   	       
       CASE($STH)
          CALL HSTH(IE,T,LRCON,LEGRP,F,W,AREA,ALPHA,nch)
C ALEF - celkovy soucinitel prostupu tepla
          ALEF=1./(1/ALPHA+F(1)+F(2))
C NTU1=k.S/W1 - NENI HOTOVO
          RTU1=ALEF*AREA/ABS(W(1))
C R1 - pomer tepelnych kapacit
          R1=ABS(W(1)/W(2))
C Vymenk typu 1-1 (jeden chod v MP a jeden chod v TP)
	  IF(NCH.EQ.1)THEN
C EPSILON	   
             IF(W(1)*W(2).LT.0.)THEN
C PROTIPROUD
               IF(R1.EQ.1)THEN
	         EPS=RTU1/(1+RTU1)
	       ELSE
                 E=EXP(-RTU1*(1-R1))
                 EPS=(1-E)/(1-R1*E)
	       ENDIF
             ELSE
C SOUPROUD
               E=EXP(-RTU1*(1+R1))
               EPS=(1-E)/(1+R1)
	     ENDIF
	  ELSEIF(nch.EQ.2)THEN
	     EP=0.5
	     XM=(1.+R1**2+2*R1*(2*EP-1.))**0.5
	     EPS=(0.5*(1+R1+XM*(TANH(0.5*XM*RTU1))**(-1)))**(-1)
	  ELSEIF(nch.EQ.3)THEN
	     EP=0.3333333
	     IF(R1.EQ.1)THEN
	        XE1=1/(EXP(-0.5*RTU1*(1+3*EP))-1)
	        XE2=1/(EXP(0.5*RTU1*(1-EP))+1)
	        XE3=2*((1+EP)/(1+3*EP))**2
	        XE4=EP*(1-EP)/(1+3*EP)
	        EPSI=RTU1*XE4-XE3/(XE1+XE2)
	        EPS=1/(1+1/EPSI)
	     ELSE
	        XP=RTU1*(1-0.5*R1*(1-3*EP))
	        XQ=0.5*E*(1-EP)*RTU1**2*R1*(1-R1)
	        XM1=XP/2.+(XP**2/4-XQ)**0.5
	        XM2=XP/2.-(XP**2/4-XQ)**0.5
	        XM3=0.5*R1*RTU1*(1-EP)
	        XC1=XM1*(EXP(XM1)+EXP(XM3))*(EXP(XM2)-1.)
	        XC2=XM2*(EXP(XM2)+EXP(XM3))*(1.-EXP(XM1))
	        XC3=RTU1*(1-R1)*(EXP(XM2)-EXP(XM1))*(1.+EXP(XM3))
	        XJ1=XM1*(EXP(XM1)+EXP(XM3))*(R1*EXP(XM2)-1.)
	        XJ2=XM2*(EXP(XM2)+EXP(XM3))*(1.-R1*EXP(XM1))
	        XJ3=RTU1*(1-R1)*(EXP(XM2)-EXP(XM1))*(1+R1*EXP(XM3))
	        EPS=(XC1+XC2+XC3)/(XJ1+XJ2+XJ3)
	     ENDIF
	  ELSEIF(nch.EQ.4)THEN
	     XM=(TANH(0.25*RTU1*(4+R1**2)**0.5))**(-1)
	     XN=TANH(0.25*R1*RTU1)
	     EPS=0.25*(2+2*R1+(4+R1**2)**0.5*XM+R1*XN)
	  ELSE
	     WRITE(*,*)'HPIPE:WRONG INPUT NCH'
	     STOP
	  ENDIF
       
       END SELECT
C Vykon vymeniku, eps a tepelne kapacity proudu
C EPAR(IE,1)-Q1, EPAR(IE,2)-Q2,   objemove prutoky
C EPAR(IE,3)-Re1,EPAR(IE,4)-Re2,  Reynoldsova cisla
C EPAR(IE,5)-v1, EPAR(IE,6)-v2,   stredni rychlosti [m/s]
C EPAR(IE,7)-RF1,EPAR(IE,8)-RF2,  termicky odpor usad
C EPAR(IE,9)-W1, EPAR(IE,10)-W2,  tepelne kapacity proudu
C EPAR(IE,11)-EPS                 efektivita vymeniku
C EPAR(IE,12)-EPOWER              tepelny vykon vymeniku
       EPAR(IE,9)=W(1)
       EPAR(IE,10)=W(2)
       EPAR(IE,11)=EPS
       EPAR(IE,LEPAR(NAMELE,$EPOWER))=ABS((T(1)-T(2))*W(1))
C Matice vodivosti
       AL=0
       BL=0
       WW=ABS(W(2))*EPS
       W1=W(1)
       W2=W(2)
       IF(METHOD.EQ.0)THEN
C V tomto pripade je jiz matice definovana elementy PIPE2D s vyjimkou
C clenu WW, ktery popisuje prenos tepla mezi proudy.
          W1=0
          W2=0
       ENDIF
C Ruzne varianty smeru proudeni
       IF(W(1).GT.0..AND.W(2).GT.0.)THEN
         AL(1,1)=-W1
         AL(2,1)=W1-WW
         AL(2,3)=WW
         AL(3,3)=-W2
         AL(4,1)=WW
         AL(4,3)=W2-WW
         IF(NPU(2).GT.20)AL(2,2)=-W1
         IF(NPU(4).GT.20)AL(4,4)=-W2
       ELSEIF(W(1).GT.0..AND.W(2).LT.0.)THEN
         AL(1,1)=-W1
         AL(2,1)=W1-WW
         AL(2,3)=WW
         AL(3,1)=WW
         AL(3,4)=-W2-WW
         AL(4,4)=W2
         IF(NPU(2).GT.20)AL(2,2)=-W1
         IF(NPU(3).GT.20)AL(3,3)=W2
       ELSEIF(W(1).LT.0..AND.W(2).GT.0.)THEN
         AL(1,2)=-W1-WW
         AL(1,3)=WW
         AL(2,2)=W1
         AL(3,3)=-W2
         AL(4,2)=WW
         AL(4,3)=W2-WW
         IF(NPU(1).GT.20)AL(1,1)=W1
         IF(NPU(4).GT.20)AL(4,4)=-W2
       ELSEIF(W(1).LT.0..AND.W(2).LT.0.)THEN
         AL(1,2)=-W1-WW
         AL(1,4)=WW
         AL(2,2)=W1
         AL(3,2)=WW
         AL(3,4)=-W2-WW
         AL(4,4)=W2
         IF(NPU(1).GT.20)AL(1,1)=W1
         IF(NPU(3).GT.20)AL(3,3)=W2
       ENDIF
      ENDIF


C VYNECHANI TELA PROCEDURY PRI KONTROLE BLOKOVANI PROCEDUROU FTFRIN
      ENDIF
      END

      SUBROUTINE  HCHEV(IE,T,LRCON,LEGRP,F,W,AREA,ALPHA)
      DIMENSION T(*),F(*),W(*),IEH(2)
      INCLUDE '$FEMEQ'
C
C Deskovy vymenik CHEVRON je definovany parametry
C EGROUP    $fi=m (pocet paralelnich kanalu), $GAUSS=mprop1, $AXIS=mprop2
C RCONST    $H (tl.desky), $D (De), $P (uhel sipu), $ALFA (vodivost desky),
C           $AREA (plocha desky), $PERIM=w (sirka desky), $VOL=L (vyska desky)
C EPAR      EPAR(IE,1)-Q1, EPAR(IE,2)-Q2, EPAR(IE,3)-V1, EPAR(IE,4)-V2
C           EPAR(IE,5)-RE1, EPAR(IE,6)-RE2
         DE=RRCONS(LRCON,$D)
         H =RRCONS(LRCON,$H)
         THE=RRCONS(LRCON,$P)*3.14159/180.
         RLA=RRCONS(LRCON,$ALFA)
         AREA=ABS(RRCONS(LRCON,$AREA))
         WW=RRCONS(LRCON,$PERIM)
         RL=RRCONS(LRCON,$VOL) 
C AREA - teplosmenna plocha jedne desky
         IF(AREA.LE.0..AND.WW.GT.0..AND.RL.GT.0.)THEN
            AREA=1.41*WW*RL
         ELSEIF(AREA.LE.0.)THEN
            WRITE(2,*)' HCHEV: Zero plate area in chevron',IE
            STOP
         ENDIF
         M=JGROUP(LEGRP,$FI)
         IEH(1)=JGROUP(LEGRP,$GAUSS)
         IEH(2)=JGROUP(LEGRP,$AXIS) 
         IF(M.LE.0)THEN  
            WRITE(2,*)' HCHEV: Zero no.of channels in CHEVRON' 
            STOP
         ELSEIF(IEH(1).LE.0.OR.IEH(2).LE.0)THEN
            WRITE(2,*)' HCHEV: Zero index of material properties in CHEV
     /RON'
            STOP
         ENDIF
         DO K=1,2
C EPAR        EPAR(IE,1)-Q1, EPAR(IE,2)-Q2, EPAR(IE,3)-V1, EPAR(IE,4)-V2
C             EPAR(IE,5)-RE1, EPAR(IE,6)-RE2, EPAR(IE,7)-F1, EPAR(IE,8)-F2
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
           IG=IEH(K)
           RK  =RMPROP(IG,$KX)
           RHO =RMPROP(IG,$RHO)
           CP  =RMPROP(IG,$CP)
C Stredni teplota pro korekce termofyzikalnich vlastnosti
           TEMP=(T(1)+T(2)+T(3)+T(4))/4.
           IF(JMPROP(IG,$KX).NE.0)RK =RK *CURFUN(JMPROP(IG,$KX))
           IF(JMPROP(IG,$CP).NE.0)CP =CP *CURFUN(JMPROP(IG,$CP))
           IF(JMPROP(IG,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(IG,$RHO))
           VISC=RMPROP(IG,$VISC)
C Vypocet Re
           Q=EPAR(IE,K)
           RE=ABS(EPAR(IE,K+2))
           PR=VISC*CP/RK
           FF=EPAR(IE,K+6)
           RNU=0.205*PR**0.333*(FF*RE**2*SIN(2*THE))**0.374
           F(K)=DE/(RNU*RK)
           W(K)=Q*RHO*CP
         ENDDO
         ALPHA=RLA/H
      END

      SUBROUTINE RRTD(IOPER,ICONTR,IE,NL,NUE,AL,BL)
C
C POTRUBNI SIT koncetracni bilance.
C Vypocet CN,CD,CA v uzlovych bodech na zaklade stanovenych prutoku.
C Uzivatelsky definovane zdrojove a propadove cleny.
C
C Elementy: L2
C
C Rychlost proudeni ze zony EPAR
C
      INCLUDE '$FEMEQ'
      DIMENSION X(2),Y(2),Z(2),AL(NL,NL),BL(NL),T(2),CBC(2),
     /          RM(2,2),AM(2,2),BM(2),NPU(2)
      IF(NUE.NE.2)RETURN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
      IF(ICONTR.GE.0)THEN
C EGROUP (NONST=1-TRANSIENT, NAMELE=1-PIPE2D,=7-CSTR,=8-PUMP)
      NONST=JGROUP(LEGRP,$ST)
C RRCONS (2-DIAMETER), AREA-prut.prurez, PERIM-smoceny obvod, V-objem misice
      R=RRCONS(LRCON,$D)/2.
      AREA=ABS(RRCONS(LRCON,$AREA))
      PERIM=RRCONS(LRCON,$PERIM)
      VOL=RRCONS(LRCON,$VOL)
      SELECT CASE(IOPER)
      CASE($CONC)
        ALPHA=RRCONS(LRCON,$KN)
        TE   =RRCONS(LRCON,$CEN)
        IDN  =$DN
        IAN  =$AN
        NSOURCE=JGROUP(LEGRP,$NSOURCE)
        NSINK=JGROUP(LEGRP,$NSINK)
      CASE($COND)
        ALPHA=RRCONS(LRCON,$KD)
        TE   =RRCONS(LRCON,$CED)
        IDN  =$DD
        IAN  =$AD
        NSOURCE=JGROUP(LEGRP,$DSOURCE)
        NSINK=JGROUP(LEGRP,$DSINK)
      CASE($CONA)
        ALPHA=RRCONS(LRCON,$KA)
        TE   =RRCONS(LRCON,$CEA)
        IDN  =$DA
        IAN  =$AA
        NSOURCE=JGROUP(LEGRP,$ASOURCE)
        NSINK=JGROUP(LEGRP,$ASINK)
      ENDSELECT
C
C NORMALNI VYPOCET FTFRON
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C T-TEPLOTY ZE ZONY 3
C C-KONCENTRACE V ZONE 3, vlastnosti v zone 4
C
      L0=LUE(IE)
      ACN=0.
      ACD=0.
      ACA=0.
      DO IU=1,2
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        T(IU)=VAL(LPU($TEMP)+IND,3)
        SELECT CASE(IOPER)
          CASE($CONC)
            LOC=LPU($CN)+IND
          CASE($COND)
            LOC=LPU($CD)+IND
          CASE($CONA)
            LOC=LPU($CA)+IND
        ENDSELECT
        NPU(IU)=IPU(LOC)
        CBC(IU)=AMAX1(0.,VAL(LOC,3))
        ACN=ACN+VAL(LPU($CN)+IND,4)
        ACD=ACD+VAL(LPU($CD)+IND,4)
        ACA=ACA+VAL(LPU($CA)+IND,4)
      ENDDO
C H-delka trubky
      H=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
C Stredni teplota elementu pro vypocet koeficientu difuze
      TMEAN=(T(1)+T(2))/2.
      TEMP=TMEAN
C Teziste elementu
      AUX(2)=(X(1)+X(2))/2.
      AUX(3)=(Y(1)+Y(2))/2.
      AUX(4)=(Z(1)+Z(2))/2.
      AUX(5)=ABS(EPAR(IE,LEPAR(NAMELE,$ETAU)))
      AUX($LDOF+$CN)=ACN/2.
      AUX($LDOF+$CD)=ACD/2.
      AUX($LDOF+$CA)=ACA/2.
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA,9-DN,10-EN,11-AN) 
      DN =RMPROP(LPROP,IDN)
      AN =RMPROP(LPROP,IAN)
      IF(JMPROP(LPROP,IDN).NE.0)DN=DN*CURFUN(JMPROP(LPROP,IDN))
      IF(JMPROP(LPROP,IAN).NE.0)AN=AN*CURFUN(JMPROP(LPROP,IAN))
      IF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP)THEN
C CSTR/PUMP
         IF(VOL.GT.0.)THEN
           AREA=VOL/H
           R=SQRT(AREA/PI)
           D=2*R
         ENDIF
      ELSE
C PIPE
         IF(R.LE.0..AND.AREA.GT.0..AND.PERIM.GT.0.)R=2.*AREA/PERIM
         IF(AREA.LE.0..AND.R.GT.0.)AREA=PI*R**2
         IF(AREA.LE.0..OR.R.LE.0.)THEN
            WRITE(2,777)IE
            WRITE(*,777)IE
777         FORMAT(' RTD: Zero cross section in element',I7)
            STOP
         ENDIF
      ENDIF
C
C Zdrojove cleny (reakce)
C
      Q=0.
      SINK=0.
      IF($ISOURCE.NE.0)THEN
         SINK=AN
         IF(NSOURCE.NE.0)Q=Q+CURFUN(NSOURCE)
         IF(NSINK.NE.0)SINK=SINK+CURFUN(NSINK)
      ENDIF
C
      IF(ICONTR.EQ.0)THEN
C
C 2-UZLOVY ELEMENT GENEROVANI SOUSTAVY ROVNIC
C
C Difuzni odpor pocitany zatim jen jako vnejsi odpor (ALPHA-souc.prenosu hmoty)
        REXT=1./AMAX1(1E-5,ALPHA)
        RSUM=REXT
        AW=PERIM/RSUM*H
C Stredni rychlost
        UMEAN=EPAR(IE,LEPAR(NAMELE,$EQ))/AREA
        AUMEAN=ABS(UMEAN)
        IF(NAMELE.EQ.$PIPE2D)THEN
C
C Dispersni koeficient DNEFF
C
          RE=ABS(EPAR(IE,LEPAR(NAMELE,$ERE)))
          CALL DISPERS(DN,2.*R,RE,AUMEAN,$RTAUDISP,DNEFF,ITAYLOR)
          IF(DNEFF.LE.0.)THEN
             WRITE(2,*)' RTD: Zero dispersion coefficient'
             STOP
          ENDIF
          RKXEFF=DNEFF
          AKXE=AREA*RKXEFF/H
C kapacita proudu
          WW=UMEAN*AREA
C kapacita elementu rozpocitana na uzly
          WM=AREA*H/2.
C AWS = kLO+ALS
          AWW=AW+AREA*H*SINK
C Pomocne matice
          RM=0
          AM=0
          BM=0
          IF(WW.GT.0.)THEN
             RM(2,1)=-WM
             RM(2,2)=-WM
             AM(1,1)=-WW-AKXE
             AM(1,2)=AKXE
             AM(2,1)=WW+AKXE-AWW/2
             AM(2,2)=-AKXE-AWW/2
             IF(NPU(2).GT.20)AM(2,2)=AM(2,2)-WW
             BM(2)=-(Q*AREA*H+AW*TE)
          ELSE
             RM(1,1)=-WM
             RM(1,2)=-WM
             AM(1,1)=-AKXE-AWW/2
             AM(1,2)=-WW-AWW/2+AKXE
             IF(NPU(1).GT.20)AM(1,1)=AM(1,1)+WW
             AM(2,1)=AKXE
             AM(2,2)=WW-AKXE
             BM(1)=-(Q*AREA*H+AW*TE)
          ENDIF
        ELSEIF(NAMELE.EQ.$CSTR.OR.NAMELE.EQ.$PUMP)THEN
C kapacita proudu
          WW=UMEAN*AREA
C kapacita elementu
          WM=VOL
C AWS = kLO+VOL.S
          AWW=AW+VOL*SINK
C Pomocne matice
          RM=0
          AM=0
          BM=0
          IF(WW.GT.0.)THEN
             RM(2,2)=-WM
             AM(1,1)=-WW
             AM(2,1)=WW
             AM(2,2)=-AWW
             IF(NPU(2).GT.20)AM(2,2)=AM(2,2)-WW
             BM(2)=-(Q*VOL+AW*TE)
          ELSE
             RM(1,1)=-WM
             AM(1,1)=-AWW
             AM(1,2)=-WW
             IF(NPU(1).GT.20)AM(1,1)=AM(1,1)+WW
             AM(2,2)=WW
             BM(1)=-(Q*VOL+AW*TE)
          ENDIF
        ENDIF
C Lokalni matice elementu
        AL=0
        BL=0
        IF(NONST)THEN
          DO I=1,2
            BL(I)=DTIME*BM(I)
            DO J=1,2
              AL(I,J)=RM(I,J)+DTIME*AM(I,J)*$RTHETA
              BL(I)=BL(I)+(RM(I,J)-DTIME*(1-$RTHETA)*AM(I,J))*CBC(J)
            ENDDO
          ENDDO
        ELSE
C STACIONARNI PRIPAD
          DO I=1,2
            BL(I)=BM(I)
            DO J=1,2
               AL(I,J)=AM(I,J)
            ENDDO
          ENDDO
        ENDIF

      ENDIF
      ENDIF
      END