C $S5-KLOC
      SUBROUTINE THER(ICONTR,IE,NL,NUE,AL,BL)
C
C HEAT TRANSFER
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C Doplneny 2D fouling
C
C Elementy: T3,T6,Q4,Q8
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Konvekce: UPWIND (Zienkiewicz)
C Zdrojovy clen: ohmicky ohrev
C Okrajove podminky 3.druhu (alfa-parametr uzlu, Te-Real Const.), IPU>20
C Integrace v case: implicitni, 1.rad
C
C Postprocessing ICONTR=1 vypocet gradientu teploty 
C    EPAR(*,4)=dT/dx  EPAR(*,5)=dT/dy
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),
     /          AM(9,9),RM(9,9),BM(9),XG(3),YG(3),
     /          T(9),TOLD(9),U(9),VX(9),VY(9),CN(9),CD(9),CA(9),
     /          IBND(9),IBCR(3,3),ALPHA(9),ALPHE(9),
     /          G1(16),G2(16),WT(16),F(9),FX(9),FY(9),FK(3),
     /          G(3),W(3)
	REAL *8 Q,D1
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE VODIVOSTI, RM-MATICE TEPELNYCH KAPACIT, BM-ZDROJ TEPLA
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 4),TOLD-POCATECNI PODMINKA (zona 3), 
C U-elektricky potencial,
C VX,VY-rychlosti proudeni (zona 3)
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE (FK - derivace dle ksi)
C 
C Ze zony $FEM jsou vyuzivany i prvky IALGOR()
C    -potlaceni vypoctu konvektivnich clenu
C    -potlaceni vypoctu zdroje tepla
C    -upwind
C
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS=JGROUP(LEGRP,$AXIS)
      NHEAT=JGROUP(LEGRP,$HEAT)
      NSINK=JGROUP(LEGRP,$HSINK)
C RRCONS ($H-THICKNESS,$D-DIAMETER,$PRES-PRESSURE,$TE-TE,$UE-VOLTAGE)
      H=RRCONS(LRCON,$H)
      TE=RRCONS(LRCON,$TE)
      UE=RRCONS(LRCON,$UE)
	ALPHAS=RRCONS(LRCON,$ALFA)
C Tloustka vrstvy foulingu
      HF=AMAX1(1E-6,EPAR(IE,LEPAR(NAMELE,$EFOUL)))
      IF(ICONTR.EQ.0)THEN
C          
C Stanoveni uzlovych teplot T(*), elektrickeho potencialu U(*),
C a rychlosti VX(*),VY(*) z predchozich kroku.
C Identifikace uzlu elementu IBND(*), v nich je status teploty 
C             20 < IPU  . 
C Tento uzel je povazovan za uzel lezici na hranici Gamma, kde je predepsana
C okrajova podminka tretiho druhu (soucinitel prostupu tepla ALPHA 
C je primo uzlovy parametr, proto ho ukladame do vektoru ALPHA(ibnd),
C vnejsi teplota Te je ve vektoru realnych konstant elementu - je tedy
C konstantni).
C   Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VXM,VYM. Tyto hodnoty
C budou vyuzity pro vypocet Pecletova cisla elementu.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      VXM=0
      VYM=0
      L0=LUE(IE)
C NBND - pocet uzlu elementu s okrajovou podminkou tretiho druhu
      NBND=0
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))
        LOCU=LPU($VOLT)+IND
        LOCT=LPU($TEMP)+IND
        T   (IU)=VAL(LOCT,4)
        TOLD(IU)=VAL(LOCT,3)
C Identifikace uzlu s okrajovou podminkou tretiho druhu pro teplotu
C IPU>20. Soucasne se testuje okrajova podminka pro napeti a soucinitel
C elektricke prechodove vodivosti se uklada do ALPHE.
        IF(IPU(LOCT).GT.20)THEN
           NBND=NBND+1
           IBND(NBND)=IU
           ALPHA(IU)=VAL(LOCT,1)*CURFUN(IPU(LOCT))
           IF(IPU(LOCU).GT.20)THEN
              ALPHE(IU)=VAL(LOCU,1)*CURFUN(IPU(LOCU))
           ELSE
              ALPHE(IU)=1E10
           ENDIF
        ENDIF
C elektricky potencial i rychlosti v zone 3 (pocatecni podminky)
        U (IU)=VAL(LOCU,3)
        CN(IU)=VAL(LPU($CN)+IND,3)
        CD(IU)=VAL(LPU($CD)+IND,3)
        CA(IU)=VAL(LPU($CA)+IND,3)
        VX(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,3)
        VXM=VXM+VX(IU)
        VYM=VYM+VY(IU)
      ENDDO
      VXM=VXM/NUE
      VYM=VYM/NUE
      DX=XMAX-XMIN
      DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VXM*DX+VYM*DY
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VXM**2+VYM**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2)
      ENDIF
C ======================================================================
C Urceni krivek, ktere tvori hranici elementu a na nichz je predepsana
C okrajova podminka tretiho druhu. Vychazi se ze seznamu hranicnich uzlu
C IBND(NBND). Vysledkem je matice IBCR(3,*), jejich sloupce definuji krivku
C indexy (1,2,..NUE) uzlu. Krivka je urcena dvema nebo tremi body, zalezi
C na typu elementu. Pocet krivek je NBCR.
C
      NBCR=0
      IBCR=0
      IF(NBND.GT.1)THEN
         SELECT CASE(NUE)
         CASE (3)
C
C Trojuhelnik se 3 uzly. 1 nebo 2 strany jsou casti hranice (2 nebo 3 uzly).
C 3333333333333333333333333333333333333333333333333333333333333333333333333
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Dve strany jsou casti hranice. Vsechny 3 vrcholy lezi na hranici a neni jasne
C kterou ze tri stran vyradit. Tato vyjimecna situace se resi prohlizenim
C cele matice konektivity - hleda se vrchol, jehoz uzel neni soucasti zadneho
C jineho elementu.
               DO IB=1,3
C Stanoveni globalniho indexu uzlu
                 INDU=IABS(IUE(L0+IBND(IB)))
                 NB=0
                 DO J=1,NE
                   LOC=LUE(J)
                   DO K=1,NUE
                     IF(IABS(IUE(LOC+K)).EQ.INDU)NB=NB+1
                   ENDDO
                 ENDDO
                 IF(NB.EQ.1)THEN
                   ICORN=IB
                   EXIT
                 ENDIF
               ENDDO
C Uzel ICORN (1,2,3) je roh - v matici konektivity se vyskytl jen jednou.
               IF(ICORN.NE.0)THEN
                 NBCR=2
                 IBCR(1,1)=IBND(ICORN)
                 IBCR(1,2)=IBND(ICORN)
                 IC1=MOD(ICORN,3)+1
                 IC2=MOD(IC1,3)+1
                 IBCR(2,1)=IBND(IC1)
                 IBCR(2,2)=IBND(IC2)
               ENDIF
            ENDIF
         CASE(4)
C Ctyruhelnik se 4-uzly. 1 nebo 2 strany casti hranice (2 nebo 3 uzly)
C 44444444444444444444444444444444444444444444444444444444444444444444
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Soucasti hranice jsou dve strany (3 vylucujeme, i kdyz je to teoreticky mozne)
               NBCR=2             
               IF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.3)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=2
                  IBCR(2,2)=3
              ELSEIF(IBND(1).EQ.2.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=2
                  IBCR(2,1)=3
                  IBCR(1,2)=3
                  IBCR(2,2)=4
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=3
                  IBCR(2,1)=4
                  IBCR(1,2)=4
                  IBCR(2,2)=1
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=4
                  IBCR(2,2)=1
               ENDIF
            ENDIF
         CASE (6)   
C
C Trojuhelnik se 6 uzly. 1 nebo 2 strany (3 nebo 5 uzlu na hranici)
C 66666666666666666666666666666666666666666666666666666666666666666
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-3
               IBCR(2,IB)=IBCR(3,IB)-2
               IF(IBCR(2,IB).GT.3)IBCR(2,IB)=1
            ENDDO
         CASE (8)   
C
C Ctyruhelnik s 8 uzly. 1,2 nebo 3 strany (3,5 nebo 7 uzlu na hranici)
C 88888888888888888888888888888888888888888888888888888888888888888888
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-4
               IBCR(2,IB)=IBCR(3,IB)-3
               IF(IBCR(2,IB).GT.4)IBCR(2,IB)=1
            ENDDO
         END SELECT
      ENDIF
C Konec sekce, ktera identifikovala hranicni krivky (IBCR)
C =====================================================================
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Isoparametric 4 or 8-node element.
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC VODIVOSTI, TEPELNYCH KAPACIT A ZDROJOVYCH CLENU
      AM=0
      RM=0
      BM=0
C
C SESTAVENI MATICE AM(VODIVOSTI),RM(TEPELNYCH KAPACIT), vektor BM
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C (hustotu, el.vodivost, cp, tepelnou vodivost). TEMP je promenna AUX(11). 
C Soucasne se pocita intenzita elektrickeho pole UX,UY (vyuzivaji se
C derivace bazovych funkci FX,FY) a vektor rychlosti VVX,VVY.
C
         TEMP=0
         UX=0
         UY=0
         VVX=0
         VVY=0
         RR=0
         XGA=0
         AUX($LDOF+$CN)=0.
         AUX($LDOF+$CD)=0.
         AUX($LDOF+$CA)=0.
         DVXDX=0.
         DVXDY=0.
         DVYDX=0.
         DVYDY=0.
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            UX=UX+FX(I)*U(I)
            UY=UY+FY(I)*U(I)
            RR=RR+Y(I)*F(I)
            XGA=XGA+X(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
            AUX($LDOF+$CN)=AUX($LDOF+$CN)+CN(I)*F(I)
            AUX($LDOF+$CD)=AUX($LDOF+$CD)+CD(I)*F(I)
            AUX($LDOF+$CA)=AUX($LDOF+$CA)+CA(I)*F(I)
            DVXDX=DVXDX+VX(I)*FX(I)
            DVYDY=DVYDY+VY(I)*FY(I)
            DVXDY=DVXDY+VX(I)*FY(I)
            DVYDX=DVYDX+VY(I)*FX(I)
         ENDDO
C Druhy invariant je SINV (v zone COMMON)
         SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2

C MPROP 
         RKX=RMPROP(LPROP,$KX)
         RKY=RMPROP(LPROP,$KY)
         CP=RMPROP(LPROP,$CP)
         RHO=RMPROP(LPROP,$RHO)
         RKAPA=RMPROP(LPROP,$KAPPA)
         IF(JMPROP(LPROP,$KX).NE.0)RKX=RKX*CURFUN(JMPROP(LPROP,$KX))
         IF(JMPROP(LPROP,$KY).NE.0)RKY=RKY*CURFUN(JMPROP(LPROP,$KY))
	   IF(RKY.LE.0.)RKY=RKX
         IF(JMPROP(LPROP,$CP).NE.0)CP=CP*CURFUN(JMPROP(LPROP,$CP))
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$KAPPA).NE.0)
     /                        RKAPA=RKAPA*CURFUN(JMPROP(LPROP,$KAPPA))
         CALL PARTMOD2(XGA,RR,VISC,RHO,CP,RKX,RKAPA)
         AOPT=0
C Vypocet Pecletova cisla jen pro pripad uvazovani konvekce (IALGOR(2)) 
C a nastaveni upwindu (IALGOR(5))
         IF($ICONV.NE.0.AND.$IUPW.NE.0)THEN
C Soucinitel upwind ALF jako funkce Pecletova cisla elementu
            PE=UMEAN*HMEAN*RHO*CP/(2*RKX)
            IF(PE.GT.0.01)THEN
               PE=AMIN1(PE,50.)
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient zadavany uzivatelem $RUPW
               AOPT=ALF*$RUPW*HMEAN/(2*UMEAN)
            ELSE
               AOPT=0
            ENDIF
C MIN/MAX Pe
            RALGOR(34)=AMIN1(RALGOR(34),PE)
            RALGOR(35)=AMAX1(RALGOR(35),PE)
         ENDIF
C
C Vnitrni zdroje tepla
C Hustota tepelneho vykonu
         Q=RKAPA*(UX**2+UY**2)
	   IF(NAXIS.EQ.1)THEN
C Cylindricky souradny system - vse je nasobeno polomerem RR
	       H=RR
	       SINK=0.
	   ELSEIF(NAXIS.EQ.0)THEN
C Kartezsky s.s. uvazujeme sdileni tepla s obou stran desky
	       Q=Q +2*ALPHAS*TE/H
	       SINK=2*ALPHAS/H
	   ENDIF
         IF(NHEAT.NE.0)Q=Q+CURFUN(NHEAT)
         IF(NSINK.NE.0)SINK=SINK+CURFUN(NSINK)
         E1X=DET*WT(IG)*H*RKX
         E1Y=DET*WT(IG)*H*RKY
         C1=DET*WT(IG)*H*RHO*CP
         D1=DET*WT(IG)*H
         DO I=1,NUE
            WI=F(I)+AOPT*(VVX*FX(I)+VVY*FY(I))
C Respektovani zdroje tepla jen pri nastavenem priznaku IALGOR(4)
            IF($ISOURCE.NE.0)BM(I)=BM(I)+D1*WI*Q
            DO J=1,NUE
               AM(I,J)=AM(I,J)+E1X*FX(I)*FX(J)+E1Y*FY(I)*FY(J)+
     /                         WI*SINK*F(I)*D1
               IF($ICONV.NE.0)AM(I,J)=
     /                     AM(I,J)+C1*WI*(VVX*FX(J)+VVY*FY(J))
               RM(I,J)=RM(I,J)+C1*F(I)*F(J)
            ENDDO
         ENDDO
C----------------------------------------------
      ENDDO
C
C Prispevek hranicnich integralu k matici AM a k vektoru BM
C Krivkove integraly pocitane 3-bodovou Gaussovou integraci 
C
      G(1:3)=(/-.77459666,0.,.77459666/)
      W(1:3)=(/.5555555,.8888888,.555555/)
C Pocet hranicnich krivek je NBCR
      DO IC=1,NBCR
        IF(IBCR(3,IC).EQ.0)THEN
            NU=2
        ELSE
            NU=3
        ENDIF
        DO I=1,NU
           IND=IBCR(I,IC)
           XG(I)=X(IND)
           YG(I)=Y(IND)
        ENDDO
        DO IG=1,3
C Bazove funkce F(*) v integracnim uzlu IG pocita procedura FDCR
           CALL FDCR(NU,XG,YG,G(IG),F,FK,FX,FY,DET)
C Polomer RR,ALPHA(oznacovane AA),ALPHE(AE),TEMP,UW v integracnim uzlu IG
           RR=0
           AA=0 
           AE=0  
           UW=0
           TEMP=0
           DO I=1,NU
             IND=IBCR(I,IC)
             FI=F(I)
             RR=RR+YG(I)*FI
             AA=AA+ALPHA(IND)*FI
             AE=AE+ALPHE(IND)*FI
             UW=UW+U(IND)*FI
             TEMP=TEMP+T(IND)*FI
           ENDDO
           TEF=TE
           IF($IFOUL.GT.0)THEN
C
C FOULING. Cilem je modifikovat externi teplotu TE --> TEF, a soucinitel
C prenosu tepla ALPHA -->  ALPHAF. 
C Pro tuto modifikaci jsou potrebne parametry:
C   FKAPPA - specif.elektricka vodivost foulingu (MPROP)
C   FKX    - tepelna vodivost foulingu (MPROP)
C   UW     - stredni hodnota napeti v hranicnich uzlech
C   UE     - vnejsi napeti
C   HF     - tloustka vrstvy 
C 
              FKAPPA=RMPROP(LPROP,$KAPPE)
              FKX   =RMPROP(LPROP,$KXE)
              IF(JMPROP(LPROP,$KAPPE).NE.0)
     /           FKAPPA=FKAPPA*CURFUN(JMPROP(LPROP,$KAPPE))
              IF(JMPROP(LPROP,$KXE).NE.0)
     /           FKX=FKX*CURFUN(JMPROP(LPROP,$KXE))
              IF(FKAPPA.GT.0..AND.AA.GT.0..AND.FKX.GT.0.)THEN
                 Q=FKAPPA*(AE*(UE-UW)/(HF*AE+FKAPPA))**2
                 TEF=TE+Q*HF/FKX*(FKX/AA+HF/2.)
                 AA=1./(1./AA+HF/FKX)
              ELSE
                 WRITE(*,*)' THER: Zero parameters of fouling layer'
              ENDIF
           ENDIF
           IF(NAXIS.EQ.1)H=RR
C Pricteni prispevku k vektoru BM a matici AM
           DO I=1,NU
              IQ=IBCR(I,IC)
              BM(IQ)=BM(IQ)+F(I)*TEF*W(IG)*DET*H*AA
              DO J=1,NU
                 JQ=IBCR(J,IC)
                 AM(IQ,JQ)=AM(IQ,JQ)+F(I)*F(J)*W(IG)*DET*H*AA
              ENDDO
           ENDDO
        ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]]=[[CM]]  +  [[AM]]*dt
C PRAVA STRANA      [BL] =[[CM]]*[X0] + [Q]*dt
C ...uvazovani okrajovych podminek [[AM]]= ++ alfa*Ni*Nj
C ...konvekce                      [[AM]]= ++ rho*cp*Ni*(ux*Nj,x+uy*Nj,y)
C ...zdrojovy clen                 [Q]= qNi + (alfa*Ni*Te)|gamma
C
C     DTIME je systemova promenna COMMON /FEM/...
C    
      DO I=1,NL
        IF(NONST.EQ.1)THEN
           BL(I)=BM(I)*DTIME
           DO J=1,NL
C NONSTEADY
             AL(I,J)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
             BL(I)=BL(I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))*TOLD(J)
           ENDDO
        ELSE
C STEADY STATE
           BL(I)=BM(I)
           DO J=1,NL
             AL(I,J)=AM(I,J)
           ENDDO
        ENDIF
      ENDDO
C ==================================

      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing, vypocet gradientu teploty
C
        L0=LUE(IE)
        DO IU=1,NUE
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
          Y(IU)=YY(IND)
          T(IU)=VAL(LPU($TEMP)+IND,2)
        ENDDO
C Bazove funkce v tezisti elementu
        IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
             CALL FDFT(NUE,X,Y,.3333,.3333,F,FX,FY,DET)
        ELSE
             CALL FDFQ(NUE,X,Y,0.,0.,F,FX,FY,DET)
        ENDIF
        GRADX=0
        GRADY=0
        TEMP=0
        DO I=1,NUE
           GRADX=GRADX+FX(I)*T(I)
           GRADY=GRADY+FY(I)*T(I)
           TEMP=TEMP+F(I)*T(I)
        ENDDO
        LPX=MAX0(1,LEPAR(NAMELE,$EGTX))
        LPY=MAX0(1,LEPAR(NAMELE,$EGTY))
        EPAR(IE,LPX)=GRADX
        EPAR(IE,LPY)=GRADY
        KEPAR(NAMELE,LPX)=1
        KEPAR(NAMELE,LPY)=1
C Fouling se zvetsuje jen kdyz je nastaven priznak TRANSIENT
        IF($IFOUL.GT.0.AND.NONST.GT.0)THEN
C   Vyznam parametru zony elementu EPAR urcuje LEPAR
           RFOLD=AMAX1(0.,EPAR(IE,LEPAR(NAMELE,$EFOUL)))
C    Novy CHISA 
C    Toyoda TEMP i koncentrace ACN,ACD,ACA jsou jiz aktualizovany
           RF=RFOLD+DTIME*CURFUN($IFOUL)
           EPAR(IE,LEPAR(NAMELE,$EFOUL))=AMAX1(0.,RF)
        ENDIF
      ENDIF
      END

      SUBROUTINE CONC(IOPER,ICONTR,IE,NL,NUE,AL,BL)
C
C KONCENTRACE - TRANSPORTNI ROVNICE HMOTY S REAKCI PRVNIHO RADU
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C uvazovan soucinitel prenosu hmoty na hranici oblasti
C Elementy: T3,T6,Q4,Q8
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Konvekce: UPWIND (Zienkiewicz)
C Sink: CHEMICKA REAKCE + uzivatelska funkce
C Source: uzivatelska funkce
C Integrace v case: implicitni, 1.rad
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),XG(3),YG(3),G(3),W(3),
     /          AM(9,9),RM(9,9),BM(9),ALPHA(9),IBND(9),IBCR(3,3),
     /          T(9),C(9),CBC(9),VX(9),VY(9),CN(9),CD(9),CA(9),
     /          G1(16),G2(16),WT(16),F(9),FX(9),FY(9),FK(3)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE DIFUZE, RM-MATICE HMOT, 
C T,C-TEPLOTY A KONCENTRACE Z PREDCHOZIHO CASOVEHO KROKU, 
C VX,VY-rychlosti proudeni
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE
C 
C Ze zony $FEM jsou vyuzivany i prvky 
C          IALGOR(2)-potlaceni vypoctu konvektivnich clenu
C          IALGOR(4)-potlaceni vypoctu reakcniho clenu
C          IALGOR(5)-upwind
C          
      IF(ICONTR.EQ.0)THEN
C
C   Stanoveni uzlovych teplot T(*), koncentraci C(*),
C a rychlosti VX(*),VY(*) z predchozich kroku.
C Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VXM,VYM. Tyto hodnoty
C budou vyuzity pro vypocet difuzniho Pecletova cisla elementu.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      VXM=0
      VYM=0
      NBND=0
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))
        T (IU)=VAL(LPU($TEMP)+IND,3)
        SELECT CASE(IOPER)
          CASE($CONC)
            LOC=LPU($CN)+IND
          CASE($COND)
            LOC=LPU($CD)+IND
          CASE($CONA)
            LOC=LPU($CA)+IND
        ENDSELECT
C Identifikace uzlu s okrajovou podminkou 3.druhu (prenos hmoty)
        IF(IPU(LOC).GT.20)THEN
            NBND=NBND+1
            IBND(NBND)=IU
            ALPHA(IU)=VAL(LOC,1)*CURFUN(IPU(LOC))
        ENDIF        
        C(IU)=AMAX1(0.,VAL(LOC,4))
        CBC(IU)=AMAX1(0.,VAL(LOC,3))
        CN(IU)=VAL(LPU($CN)+IND,4)
        CD(IU)=VAL(LPU($CD)+IND,4)
        CA(IU)=VAL(LPU($CA)+IND,4)
        VX(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,3)
        VXM=VXM+VX(IU)
        VYM=VYM+VY(IU)
      ENDDO
      VXM=VXM/NUE
      VYM=VYM/NUE
      DX=XMAX-XMIN
      DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VXM*DX+VYM*DY
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VXM**2+VYM**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2)
      ENDIF
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (2-TRANSIENT|STATIC,3-NGAUS,4-PLANE/AXISYM)
C CE - koncentrace vnejsi
      SELECT CASE(IOPER)
      CASE($CONC)
        IDN  =$DN
        IAN  =$AN
        NSOURCE=JGROUP(LEGRP,$NSOURCE)
        NSINK=JGROUP(LEGRP,$NSINK)
        CE=RRCONS(LRCON,$CEN)
      CASE($COND)
        IDN  =$DD
        IAN  =$AD
        NSOURCE=JGROUP(LEGRP,$DSOURCE)
        NSINK=JGROUP(LEGRP,$DSINK)
        CE=RRCONS(LRCON,$CED)
      CASE($CONA)
        IDN  =$DA
        IAN  =$AA
        NSOURCE=JGROUP(LEGRP,$ASOURCE)
        NSINK=JGROUP(LEGRP,$ASINK)
        CE=RRCONS(LRCON,$CEA)
      ENDSELECT
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,5-TE)
      H=RRCONS(LRCON,$H)
C ======================================================================
C Urceni krivek, ktere tvori hranici elementu a na nichz je predepsana
C okrajova podminka tretiho druhu. Vychazi se ze seznamu hranicnich uzlu
C IBND(NBND). Vysledkem je matice IBCR(3,*), jejich sloupce definuji krivku
C indexy (1,2,..NUE) uzlu. Krivka je urcena dvema nebo tremi body, zalezi
C na typu elementu. Pocet krivek je NBCR.
C
      NBCR=0
      IBCR=0
      IF(NBND.GT.1)THEN
         SELECT CASE(NUE)
         CASE (3)
C
C Trojuhelnik se 3 uzly. 1 nebo 2 strany jsou casti hranice (2 nebo 3 uzly).
C 3333333333333333333333333333333333333333333333333333333333333333333333333
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Dve strany jsou casti hranice. Vsechny 3 vrcholy lezi na hranici a neni jasne
C kterou ze tri stran vyradit. Tato vyjimecna situace se resi prohlizenim
C cele matice konektivity - hleda se vrchol, jehoz uzel neni soucasti zadneho
C jineho elementu.
               DO IB=1,3
C Stanoveni globalniho indexu uzlu
                 INDU=IABS(IUE(L0+IBND(IB)))
                 NB=0
                 DO J=1,NE
                   LOC=LUE(J)
                   DO K=1,NUE
                     IF(IABS(IUE(LOC+K)).EQ.INDU)NB=NB+1
                   ENDDO
                 ENDDO
                 IF(NB.EQ.1)THEN
                   ICORN=IB
                   EXIT
                 ENDIF
               ENDDO
C Uzel ICORN (1,2,3) je roh - v matici konektivity se vyskytl jen jednou.
               IF(ICORN.NE.0)THEN
                 NBCR=2
                 IBCR(1,1)=IBND(ICORN)
                 IBCR(1,2)=IBND(ICORN)
                 IC1=MOD(ICORN,3)+1
                 IC2=MOD(IC1,3)+1
                 IBCR(2,1)=IBND(IC1)
                 IBCR(2,2)=IBND(IC2)
               ENDIF
            ENDIF
         CASE(4)
C Ctyruhelnik se 4-uzly. 1 nebo 2 strany casti hranice (2 nebo 3 uzly)
C 44444444444444444444444444444444444444444444444444444444444444444444
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Soucasti hranice jsou dve strany (3 vylucujeme, i kdyz je to teoreticky mozne)
               NBCR=2             
               IF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.3)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=2
                  IBCR(2,2)=3
              ELSEIF(IBND(1).EQ.2.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=2
                  IBCR(2,1)=3
                  IBCR(1,2)=3
                  IBCR(2,2)=4
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=3
                  IBCR(2,1)=4
                  IBCR(1,2)=4
                  IBCR(2,2)=1
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=4
                  IBCR(2,2)=1
               ENDIF
            ENDIF
         CASE (6)   
C
C Trojuhelnik se 6 uzly. 1 nebo 2 strany (3 nebo 5 uzlu na hranici)
C 66666666666666666666666666666666666666666666666666666666666666666
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-3
               IBCR(2,IB)=IBCR(3,IB)-2
               IF(IBCR(2,IB).GT.3)IBCR(2,IB)=1
            ENDDO
         CASE (8)   
C
C Ctyruhelnik s 8 uzly. 1,2 nebo 3 strany (3,5 nebo 7 uzlu na hranici)
C 88888888888888888888888888888888888888888888888888888888888888888888
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-4
               IBCR(2,IB)=IBCR(3,IB)-3
               IF(IBCR(2,IB).GT.4)IBCR(2,IB)=1
            ENDDO
         END SELECT
      ENDIF
C Konec sekce, ktera identifikovala hranicni krivky (IBCR)
C =====================================================================
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Isoparametric 4 or 8-node element.
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC DIFUZE, HMOT
      AM=0
      RM=0
C
C SESTAVENI MATICE AM(DIFUZE),RM(HMOT)
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru T()) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C (difuzni soucinitel, aktivacni energie, frekvencni faktor). 
C TEMP je promenna AUX(11). 
C
         TEMP=0
         VVX=0
         VVY=0
         RR=0
         AUX($LDOF+$CN)=0.
         AUX($LDOF+$CD)=0.
         AUX($LDOF+$CA)=0.
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            RR=RR+Y(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
            AUX($LDOF+$CN)=AUX($LDOF+$CN)+CN(I)*F(I)
            AUX($LDOF+$CD)=AUX($LDOF+$CD)+CD(I)*F(I)
            AUX($LDOF+$CA)=AUX($LDOF+$CA)+CA(I)*F(I)
            DVXDX=DVXDX+VX(I)*FX(I)
            DVYDY=DVYDY+VY(I)*FY(I)
            DVXDY=DVXDY+VX(I)*FY(I)
            DVYDX=DVYDX+VY(I)*FX(I)
         ENDDO
C Druhy invariant je SINV (v zone COMMON)
         SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2

C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA,9-DN,10-EN,11-AN) 
         DN =RMPROP(LPROP,IDN)
         AN =RMPROP(LPROP,IAN)
         IF(JMPROP(LPROP,IDN).NE.0)DN=DN*CURFUN(JMPROP(LPROP,IDN))
         IF(JMPROP(LPROP,IAN).NE.0)AN=AN*CURFUN(JMPROP(LPROP,IAN))
         AOPT=0
C Vypocet Pecletova cisla jen pro pripad uvazovani konvekce (IALGOR(2)) 
C a nastaveni upwindu (IALGOR(5))
         IF($ICONV.NE.0.AND.$IUPW.NE.0)THEN
C Soucinitel upwind ALF jako funkce Pecletova cisla elementu
            PE=UMEAN*HMEAN/(2*DN)
            IF(PE.GT.0.01)THEN
               PE=AMIN1(PE,50.)
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient zadavany uzivatelem $RUPW
               AOPT=ALF*$RUPW*HMEAN/(2*UMEAN)
            ELSE
               AOPT=0
            ENDIF
C MIN/MAX Pe
            RALGOR(34)=AMIN1(RALGOR(34),PE)
            RALGOR(35)=AMAX1(RALGOR(35),PE)
         ENDIF
C Spotreba slozky N chemickou reakci
         Q=AN
         IF(NSINK.NE.0)Q=Q+CURFUN(NSINK)
         SOURCE=0
         IF(NSOURCE.NE.0)SOURCE=CURFUN(NSOURCE)
C Cylindricky souradny system - vse je nasobeno polomerem RR
         IF(NAXIS.EQ.1)H=RR
         E1=DET*WT(IG)*H*DN
         C1=DET*WT(IG)*H
         DO I=1,NUE
            WI=F(I)+AOPT*(VVX*FX(I)+VVY*FY(I))
            DO J=1,NUE
               AM(I,J)=AM(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J))
               IF($ICONV.NE.0)
     /   AM(I,J)=AM(I,J)+C1*WI*(VVX*FX(J)+VVY*FY(J))
C Respektovani REAKCE jen pri nastavenem priznaku IALGOR(4)
               IF($ISOURCE.NE.0)
     /   AM(I,J)=AM(I,J)+C1*WI*Q*F(J)
               RM(I,J)=RM(I,J)+C1*F(I)*F(J)
            ENDDO
            BM(I)=SOURCE*WI*C1
         ENDDO
      ENDDO
C
C Prispevek hranicnich integralu k matici AM a k vektoru BM
C Krivkove integraly pocitane 3-bodovou Gaussovou integraci 
C
      G(1:3)=(/-.77459666,0.,.77459666/)
      W(1:3)=(/.5555555,.8888888,.555555/)
C Pocet hranicnich krivek je NBCR
      DO IC=1,NBCR
        IF(IBCR(3,IC).EQ.0)THEN
            NU=2
        ELSE
            NU=3
        ENDIF
        DO I=1,NU
           IND=IBCR(I,IC)
           XG(I)=X(IND)
           YG(I)=Y(IND)
        ENDDO
        DO IG=1,3
C Bazove funkce F(*) v integracnim uzlu IG pocita procedura FDCR
           CALL FDCR(NU,XG,YG,G(IG),F,FK,FX,FY,DET)
C Polomer RR,ALPHA(oznacovane AA) v integracnim uzlu IG
           RR=0
           AA=0 
           DO I=1,NU
             IND=IBCR(I,IC)
             FI=F(I)
             RR=RR+YG(I)*FI
             AA=AA+ALPHA(IND)*FI
           ENDDO
           IF(NAXIS.EQ.1)H=RR
C Pricteni prispevku k vektoru BM a matici AM
           DO I=1,NU
              IQ=IBCR(I,IC)
              BM(IQ)=BM(IQ)+F(I)*CE*W(IG)*DET*H*AA
              DO J=1,NU
                 JQ=IBCR(J,IC)
                 AM(IQ,JQ)=AM(IQ,JQ)+F(I)*F(J)*W(IG)*DET*H*AA
              ENDDO
           ENDDO
        ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]]=[[CM]]  +  [[AM]]*dt
C PRAVA STRANA      [BL] =[[CM]]*[X0] + [Q]*dt
C
C     DTIME je systemova promenna COMMON /FEM/...
C
      DO I=1,NL
        IF(NONST.EQ.1)THEN
C NONSTEADY
          BL(I)=BM(I)*DTIME
          DO J=1,NL
             AL(I,J)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
             BL(I)=BL(I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))*CBC(J)
          ENDDO
        ELSE
C STEADY STATE
          BL(I)=BM(I)
          DO J=1,NL
             AL(I,J)=AM(I,J)
          ENDDO
        ENDIF
      ENDDO
      ENDIF
      END

      SUBROUTINE ELEC(ICONTR,IE,NL,NUE,AL,BL)
C
C ELEKTRICKY POTENCIAL - TEPLOTNE ZAVISLA KONDUKTIVITA
C uvazovan prechodovy odpor na hranici oblasti
C OPTIONS:  PLANE/AXISYM, 
C Elementy: T3,T6, Q4,Q8
C Volitelny pocet Gaussovych uzlu integrace T:1,3,4,7 Q:1,2,3
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),XG(3),YG(3),G(3),W(3)
      DIMENSION G1(16),G2(16),WT(16),ALPHA(9),IBND(9),IBCR(3,3),
     /          F(9),FX(9),FY(9),T(9),V(9),FK(3)
C AL-MATICE SOUSTAVY, AM-MATICE ELEKTRICKE VODIVOSTI, 
C T -TEPLOTY Z PREDCHOZI ITERACE,
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE
C
      IF(ICONTR.GE.0)THEN
C
C Stanoveni teplot v uzlovych bodech, aby bylo mozne pocitat teplotne
C zavislou elektrickou vodivost
C
      L0=LUE(IE)
      NBND=0
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        T(IU)=VAL(LPU($TEMP)+IND,3)
        LOC=LPU($VOLT)+IND
        V(IU)=VAL(LOC,4)
C Hranicni uzly s okrajovou podminkou tretiho druhu
        IF(IPU(LOC).GT.20)THEN
           NBND=NBND+1
           IBND(NBND)=IU
           ALPHA(IU)=VAL(LOC,1)*CURFUN(IPU(LOC))
        ELSE
           ALPHA(IU)=1E10
        ENDIF
      ENDDO
C EGROUP,MPROP,RRCONS
      LEGRP =MAX0(1,IGROUP(IE))
      LPROP =MAX0(1,IMPROP(IE))
      LRCON =MAX0(1,IRCONS(IE))
C EGROUP (3-NGAUS,4-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NGAUS =MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS =JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE)
      H =RRCONS(LRCON,$H)
      UE=RRCONS(LRCON,$UE)
C Tloustka vrstvy foulingu
      HF=AMAX1(1E-6,EPAR(IE,LEPAR(NAMELE,$EFOUL)))
C ======================================================================
C Urceni krivek, ktere tvori hranici elementu a na nichz je predepsana
C okrajova podminka tretiho druhu. Vychazi se ze seznamu hranicnich uzlu
C IBND(NBND). Vysledkem je matice IBCR(3,*), jejich sloupce definuji krivku
C indexy (1,2,..NUE) uzlu. Krivka je urcena dvema nebo tremi body, zalezi
C na typu elementu. Pocet krivek je NBCR.
C
      NBCR=0
      IBCR=0
      IF(NBND.GT.1)THEN
         SELECT CASE(NUE)
         CASE (3)
C
C Trojuhelnik se 3 uzly. 1 nebo 2 strany jsou casti hranice (2 nebo 3 uzly).
C 3333333333333333333333333333333333333333333333333333333333333333333333333
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Dve strany jsou casti hranice. Vsechny 3 vrcholy lezi na hranici a neni jasne
C kterou ze tri stran vyradit. Tato vyjimecna situace se resi prohlizenim
C cele matice konektivity - hleda se vrchol, jehoz uzel neni soucasti zadneho
C jineho elementu.
               DO IB=1,3
C Stanoveni globalniho indexu uzlu
                 INDU=IABS(IUE(L0+IBND(IB)))
                 NB=0
                 DO J=1,NE
                   LOC=LUE(J)
                   DO K=1,NUE
                     IF(IABS(IUE(LOC+K)).EQ.INDU)NB=NB+1
                   ENDDO
                 ENDDO
                 IF(NB.EQ.1)THEN
                   ICORN=IB
                   EXIT
                 ENDIF
               ENDDO
C Uzel ICORN (1,2,3) je roh - v matici konektivity se vyskytl jen jednou.
               IF(ICORN.NE.0)THEN
                 NBCR=2
                 IBCR(1,1)=IBND(ICORN)
                 IBCR(1,2)=IBND(ICORN)
                 IC1=MOD(ICORN,3)+1
                 IC2=MOD(IC1,3)+1
                 IBCR(2,1)=IBND(IC1)
                 IBCR(2,2)=IBND(IC2)
               ENDIF
            ENDIF
         CASE(4)
C Ctyruhelnik se 4-uzly. 1 nebo 2 strany casti hranice (2 nebo 3 uzly)
C 44444444444444444444444444444444444444444444444444444444444444444444
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Soucasti hranice jsou dve strany (3 vylucujeme, i kdyz je to teoreticky mozne)
               NBCR=2             
               IF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.3)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=2
                  IBCR(2,2)=3
              ELSEIF(IBND(1).EQ.2.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=2
                  IBCR(2,1)=3
                  IBCR(1,2)=3
                  IBCR(2,2)=4
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=3
                  IBCR(2,1)=4
                  IBCR(1,2)=4
                  IBCR(2,2)=1
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=4
                  IBCR(2,2)=1
               ENDIF
            ENDIF
         CASE (6)   
C
C Trojuhelnik se 6 uzly. 1 nebo 2 strany (3 nebo 5 uzlu na hranici)
C 66666666666666666666666666666666666666666666666666666666666666666
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-3
               IBCR(2,IB)=IBCR(3,IB)-2
               IF(IBCR(2,IB).GT.3)IBCR(2,IB)=1
            ENDDO
         CASE (8)   
C
C Ctyruhelnik s 8 uzly. 1,2 nebo 3 strany (3,5 nebo 7 uzlu na hranici)
C 88888888888888888888888888888888888888888888888888888888888888888888
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-4
               IBCR(2,IB)=IBCR(3,IB)-3
               IF(IBCR(2,IB).GT.4)IBCR(2,IB)=1
            ENDDO
         END SELECT
      ENDIF
C Konec sekce, ktera identifikovala hranicni krivky (IBCR)
C =====================================================================

      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C TROJUHELNIKOVY ELEMENT T3 NEBO T6
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Q4 NEBO Q8
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
      IF(ICONTR.EQ.0)THEN
C LOKALNI MATICE AL(VODIVOSTI)
C NULOVANI MATICE ELEKTRICKE VODIVOSTI A PRAVE STRANY
        AL=0 
        BL=0
      ELSE
C POWER=integral(kappa.(grad Volt)^2) pres plochu elementu
        POWER=0
      ENDIF
      GAUSS: DO IG=1,NGSS
        IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
          CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
        ELSE
          CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
        ENDIF
C Polomer a teplota
        RR=0
        XGA=0
        TEMP=0
        DO I=1,NUE
           RR=RR+Y(I)*F(I)
           XGA=XGA+X(I)*F(I)
           TEMP=TEMP+T(I)*F(I)
        ENDDO
C Vypocet merne elektricke vodivosti v integracnim uzlu
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
        RKAPPA=RMPROP(LPROP,$KAPPA)
        IF(JMPROP(LPROP,$KAPPA).NE.0)
     /               RKAPPA=RKAPPA*CURFUN(JMPROP(LPROP,$KAPPA))
C Modifikace elektricke vodivosti castice
        CALL PARTMOD2(XGA,RR,VISC,RHO,CP,RKX,RKAPPA)
        IF(NAXIS.EQ.1)H=RR
        E1=DET*WT(IG)*H*RKAPPA
        IF(ICONTR.EQ.0)THEN
          DO I=1,NUE
            DO J=1,NUE
              AL(I,J)=AL(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J))   
            ENDDO
          ENDDO
        ELSE
          VX=0
          VY=0
          DO I=1,NUE
             VX=VX+FX(I)*V(I)
             VY=VY+FY(I)*V(I)
          ENDDO
          POWER=POWER+ABS(E1)*(VX**2+VY**2)
        ENDIF
      ENDDO GAUSS
      $RPOWERE=$RPOWERE+POWER
      IF(ICONTR.EQ.0.AND.NBND.GT.0)THEN
C
C Prispevek hranicnich integralu
C Krivkove integraly pocitane 3-bodovou Gaussovou integraci 
C
        G(1:3)=(/-.77459666,0.,.77459666/)
        W(1:3)=(/.5555555,.8888888,.555555/)
C Pocet hranicnich krivek je NBCR
        DO IC=1,NBCR
          IF(IBCR(3,IC).EQ.0)THEN
            NU=2
          ELSE
            NU=3
          ENDIF
          DO I=1,NU
            IND=IBCR(I,IC)
            XG(I)=X(IND)
            YG(I)=Y(IND)
          ENDDO
          DO IG=1,3
C Bazove funkce F(*) v integracnim uzlu IG pocita procedura FDCR
           CALL FDCR(NU,XG,YG,G(IG),F,FK,FX,FY,DET)
C Polomer RR,ALPHA(oznacovane AA) v integracnim uzlu IG
           RR=0
           AA=0 
           DO I=1,NU
             IND=IBCR(I,IC)
             FI=F(I)
             RR=RR+YG(I)*FI
             AA=AA+ALPHA(IND)*FI
           ENDDO
           IF(NAXIS.EQ.1)H=RR
           IF($IFOUL.GT.0)THEN
C
C FOULING. Cilem je modifikovat soucinitel vnejsiho soucinitele
C elektricke vodivosti ALPHA -->  ALPHAF. 
C Pro tuto modifikaci jsou potrebne parametry:
C   FKAPPA - specif.elektricka vodivost foulingu (MPROP)
C   HF     - tloustka vrstvy 
C 
              FKAPPA=RMPROP(LPROP,$KAPPE)
              IF(JMPROP(LPROP,$KAPPE).NE.0)
     /           FKAPPA=FKAPPA*CURFUN(JMPROP(LPROP,$KAPPE))
              IF(FKAPPA.GT.0..AND.AA.GT.0.)THEN
                 AA=AA*FKAPPA/(FKAPPA+HF*AA)
              ELSE
                 WRITE(*,*)' ELEC: Zero parameters of fouling layer'
              ENDIF
           ENDIF
C Pricteni prispevku k vektoru BL a matici AL
           DO I=1,NU
              IQ=IBCR(I,IC)
              BL(IQ)=BL(IQ)+F(I)*UE*W(IG)*DET*H*AA
              DO J=1,NU
                 JQ=IBCR(J,IC)
                 AL(IQ,JQ)=AL(IQ,JQ)+F(I)*F(J)*W(IG)*DET*H*AA
              ENDDO
           ENDDO
          ENDDO
        ENDDO
      ENDIF
      ENDIF
      END

