C $S5a-KLO
      SUBROUTINE BPHASE
C
C Vypocet entalpie z uzlovych teplot. 
C Pouze u varianty $IPHASE=1, tj. soucasne reseni T,H
C
      INCLUDE '$FEMB'
      DO IE=1,NE
C EGROUP,MPROP,RRCONS
         LPROP=MAX0(1,IMPROP(IE))
         CP=RMPROP(LPROP,$CP)
         RHO=RMPROP(LPROP,$RHO)
         TMELT=RMPROP(LPROP,$TM)
         HMELT=RMPROP(LPROP,$HM)*RHO
         NUE=IABS(MUE(IE))
         L0=LUE(IE)
         DO IU=1,NUE
           IND=IABS(IUE(L0+IU))
           LOCT=LPU($TEMP)+IND
           T=VAL(LOCT,3)
           LOCH=LPU($HT)+IND
           IF(LOCH.GT.0)THEN
             IF(T.LT.TMELT)THEN
                VAL(LOCH,3)=RHO*CP*T
             ELSE
                VAL(LOCH,3)=HMELT+RHO*CP*(T-TMELT)
             ENDIF
           ENDIF
         ENDDO
      ENDDO
      END

      SUBROUTINE PTHER(ICONTR,IE,NL,NUE,AL,BL)
C
C HEAT TRANSFER PHASE CHANGES 
C 2D OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C Varianty dle $IPHASE
C $IPHASE=1 Uzlove parametry: TEMP, HT (teplota, entalpie)
C $IPHASE>1 Uzlovy parameter pouze teplota (a ruzne varianty vypoctu dH/dT)
C
C Elementy: T3,T6,Q4,Q8
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Konvekce: UPWIND (Zienkiewicz)
C Zdrojovy clen: ohmicky ohrev
C Okrajove podminky 3.druhu (alfa-parametr uzlu, Te-Real Const.), IPU>20
C Integrace v case: implicitni, 1.rad
C
C Postprocessing ICONTR=1 vypocet gradientu teploty 
C    EPAR(*,4)=dT/dx  EPAR(*,5)=dT/dy
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),
     /          AM(9,9),RM(9,9),HM(9,9),BM(9),XG(3),YG(3),
     /          T(9),TOLD(9),HT(9),HTOLD(9),U(9),VX(9),VY(9),
     /          IBND(9),IBCR(3,3),ALPHA(9),CN(9),CD(9),CA(9),
     /          G1(16),G2(16),WT(16),F(9),FX(9),FY(9),FK(3),
     /          G(3),W(3)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE VODIVOSTI, RM-MATICE TEPELNYCH KAPACIT, BM-ZDROJ TEPLA
C T-TEPLOTY Z PREDCHOZI ITERACE (zona 4),TOLD-POCATECNI PODMINKA (zona 3), 
C U-elektricky potencial,
C VX,VY-rychlosti proudeni (zona 3)
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE (FK - derivace dle ksi)
C 
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS=JGROUP(LEGRP,$AXIS)
      NHEAT=JGROUP(LEGRP,$HEAT)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,5-TE)
      H=RRCONS(LRCON,$H)
      TE=RRCONS(LRCON,$TE)

      IF(ICONTR.EQ.0)THEN
C          
C   Stanoveni uzlovych teplot T(*), elektrickeho potencialu U(*),
C a rychlosti VX(*),VY(*) z predchozich kroku.
C Identifikace uzlu elementu IBND(*), v nich je status teploty 
C             20 < IPU  . 
C Tento uzel je povazovan za uzel lezici na hranici Gamma, kde je predepsana
C okrajova podminka tretiho druhu (soucinitel prostupu tepla ALPHA 
C je primo uzlovy parametr, proto ho ukladame do vektoru ALPHA(ibnd),
C vnejsi teplota Te je ve vektoru realnych konstant elementu - je tedy
C konstantni).
C   Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VXM,VYM. Tyto hodnoty
C budou vyuzity pro vypocet Pecletova cisla elementu.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      VXM=0
      VYM=0
      L0=LUE(IE)
C NBND - pocet uzlu elementu s okrajovou podminkou tretiho druhu
      NBND=0
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))

        LOCT=LPU($TEMP)+IND
        T   (IU)=VAL(LOCT,4)
        TOLD(IU)=VAL(LOCT,3)
        LOCH=LPU($HT)+IND
        HT   (IU)=VAL(LOCH,4)
        HTOLD(IU)=VAL(LOCH,3)
C Identifikace uzlu s okrajovou podminkou tretiho druhu pro teplotu
C IPU>20
        IF(IPU(LOCT).GT.20)THEN
           NBND=NBND+1
           IBND(NBND)=IU
           ALPHA(IU)=VAL(LOCT,1)*CURFUN(IPU(LOCT))
        ENDIF
C elektricky potencial, rychlosti a koncentrace v zone 3 (pocatecni podminky)
        U (IU)=VAL(LPU($VOLT)+IND,3)
        CN(IU)=VAL(LPU($CN)+IND,3)
        CD(IU)=VAL(LPU($CD)+IND,3)
        CA(IU)=VAL(LPU($CA)+IND,3)
        VX(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,3)
        VXM=VXM+VX(IU)
        VYM=VYM+VY(IU)
      ENDDO
      VXM=VXM/NUE
      VYM=VYM/NUE
      DX=XMAX-XMIN
      DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VXM*DX+VYM*DY
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VXM**2+VYM**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2)
      ENDIF
C ======================================================================
C Urceni krivek, ktere tvori hranici elementu a na nichz je predepsana
C okrajova podminka tretiho druhu. Vychazi se ze seznamu hranicnich uzlu
C IBND(NBND). Vysledkem je matice IBCR(3,*), jejich sloupce definuji krivku
C indexy (1,2,..NUE) uzlu. Krivka je urcena dvema nebo tremi body, zalezi
C na typu elementu. Pocet krivek je NBCR.
C
      NBCR=0
      IBCR=0
      IF(NBND.GT.1)THEN
         SELECT CASE(NUE)
         CASE (3)
C
C Trojuhelnik se 3 uzly. 1 nebo 2 strany jsou casti hranice (2 nebo 3 uzly).
C 3333333333333333333333333333333333333333333333333333333333333333333333333
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Dve strany jsou casti hranice. Vsechny 3 vrcholy lezi na hranici a neni jasne
C kterou ze tri stran vyradit. Tato vyjimecna situace se resi prohlizenim
C cele matice konektivity - hleda se vrchol, jehoz uzel neni soucasti zadneho
C jineho elementu.
               DO IB=1,3
C Stanoveni globalniho indexu uzlu
                 INDU=IABS(IUE(L0+IBND(IB)))
                 NB=0
                 DO J=1,NE
                   LOC=LUE(J)
                   DO K=1,NUE
                     IF(IABS(IUE(LOC+K)).EQ.INDU)NB=NB+1
                   ENDDO
                 ENDDO
                 IF(NB.EQ.1)THEN
                   ICORN=IB
                   EXIT
                 ENDIF
               ENDDO
C Uzel ICORN (1,2,3) je roh - v matici konektivity se vyskytl jen jednou.
               IF(ICORN.NE.0)THEN
                 NBCR=2
                 IBCR(1,1)=IBND(ICORN)
                 IBCR(1,2)=IBND(ICORN)
                 IC1=MOD(ICORN,3)+1
                 IC2=MOD(IC1,3)+1
                 IBCR(2,1)=IBND(IC1)
                 IBCR(2,2)=IBND(IC2)
               ENDIF
            ENDIF
         CASE(4)
C Ctyruhelnik se 4-uzly. 1 nebo 2 strany casti hranice (2 nebo 3 uzly)
C 44444444444444444444444444444444444444444444444444444444444444444444
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
            ELSE
C Soucasti hranice jsou dve strany (3 vylucujeme, i kdyz je to teoreticky mozne)
               NBCR=2             
               IF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.3)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=2
                  IBCR(2,2)=3
              ELSEIF(IBND(1).EQ.2.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=2
                  IBCR(2,1)=3
                  IBCR(1,2)=3
                  IBCR(2,2)=4
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=3
                  IBCR(2,1)=4
                  IBCR(1,2)=4
                  IBCR(2,2)=1
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=4
                  IBCR(2,2)=1
               ENDIF
            ENDIF
         CASE (6)   
C
C Trojuhelnik se 6 uzly. 1 nebo 2 strany (3 nebo 5 uzlu na hranici)
C 66666666666666666666666666666666666666666666666666666666666666666
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-3
               IBCR(2,IB)=IBCR(3,IB)-2
               IF(IBCR(2,IB).GT.3)IBCR(2,IB)=1
            ENDDO
         CASE (8)   
C
C Ctyruhelnik s 8 uzly. 1,2 nebo 3 strany (3,5 nebo 7 uzlu na hranici)
C 88888888888888888888888888888888888888888888888888888888888888888888
            NBCR=NBND/2
            DO IB=1,NBCR
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-4
               IBCR(2,IB)=IBCR(3,IB)-3
               IF(IBCR(2,IB).GT.4)IBCR(2,IB)=1
            ENDDO
         END SELECT
      ENDIF
C Konec sekce, ktera identifikovala hranicni krivky (IBCR)
C =====================================================================
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Isoparametric 4 or 8-node element.
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC VODIVOSTI, TEPELNYCH KAPACIT A ZDROJOVYCH CLENU
      AM=0
      HM=0
      RM=0
      BM=0
C
C SESTAVENI MATICE AM(VODIVOSTI),RM(TEPELNYCH KAPACIT), vektor BM
C
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C (hustotu, el.vodivost, cp, tepelnou vodivost). TEMP je promenna AUX(11). 
C Soucasne se pocita intenzita elektrickeho pole UX,UY (vyuzivaji se
C derivace bazovych funkci FX,FY) a vektor rychlosti VVX,VVY.
C
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RK=RMPROP(LPROP,$KX)
         CP=RMPROP(LPROP,$CP)
         RHO=RMPROP(LPROP,$RHO)
         RKAPA=RMPROP(LPROP,$KAPPA)
         TMELT=RMPROP(LPROP,$TM)
C Promenne vlastnosti t,cn,cd,ca,SINV
         TEMP=0
         AUX($LDOF+$CN)=0
         AUX($LDOF+$CD)=0
         AUX($LDOF+$CA)=0
         UX=0
         UY=0
         VVX=0
         VVY=0
         RR=0
         DTDX=0
         DTDY=0
         DVXDX=0
         DVYDY=0
         DVXDY=0
         DVYDX=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            AUX($LDOF+$CN)=AUX($LDOF+$CN)+F(I)*CN(I)
            AUX($LDOF+$CD)=AUX($LDOF+$CD)+F(I)*CD(I)
            AUX($LDOF+$CA)=AUX($LDOF+$CA)+F(I)*CA(I)
            UX=UX+FX(I)*U(I)
            UY=UY+FY(I)*U(I)
            RR=RR+Y(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
            DVXDX=DVXDX+VX(I)*FX(I)
            DVYDY=DVYDY+VY(I)*FY(I)
            DVXDY=DVXDY+VX(I)*FY(I)
            DVYDX=DVYDX+VY(I)*FX(I)
            DTDX=DTDX+FX(I)*T(I)
            DTDY=DTDY+FY(I)*T(I)
         ENDDO
C Druhy invariant je SINV (v zone COMMON)
         SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2

         IF(JMPROP(LPROP,$KX).NE.0)RK=RK*CURFUN(JMPROP(LPROP,$KX))
         IF(JMPROP(LPROP,$CP).NE.0)CP=CP*CURFUN(JMPROP(LPROP,$CP))
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$KAPPA).NE.0)
     /                        RKAPA=RKAPA*CURFUN(JMPROP(LPROP,$KAPPA))
         HMELT=RMPROP(LPROP,$HM)*RHO
         IF(JMPROP(LPROP,$HM).NE.0)
     /                        HMELT=HMELT*CURFUN(JMPROP(LPROP,$HM))
         DHDX=0
         DHDY=0
         DO I=1,NUE
            IF(T(I).LE.TMELT)THEN
              HTI=RHO*CP*T(I)
            ELSE
              HTI=HMELT+RHO*CP*(T(I)-TMELT)
            ENDIF
            DHDX=DHDX+FX(I)*HTI
            DHDY=DHDY+FY(I)*HTI
         ENDDO
         AOPT=0
C Vypocet Pecletova cisla jen pro pripad uvazovani konvekce (IALGOR(2)) 
C a nastaveni upwindu (IALGOR(5))
         IF($ICONV.NE.0.AND.$IUPW.NE.0)THEN
C Soucinitel upwind ALF jako funkce Pecletova cisla elementu
            PE=UMEAN*HMEAN*RHO*CP/(2*RK)
            IF(PE.GT.0.01)THEN
               PE=AMIN1(PE,50.)
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient zadavany uzivatelem $RUPW
               AOPT=ALF*$RUPW*HMEAN/(2*UMEAN)
            ELSE
               AOPT=0
            ENDIF
C MIN/MAX Pe
            RALGOR(34)=AMIN1(RALGOR(34),PE)
            RALGOR(35)=AMAX1(RALGOR(35),PE)
         ENDIF
C
C Vnitrni zdroje tepla
C Hustota tepelneho vykonu
         Q=RKAPA*(UX**2+UY**2)
         IF(NHEAT.NE.0)Q=Q+CURFUN(NHEAT)
C Cylindricky souradny system - vse je nasobeno polomerem RR
         IF(NAXIS.EQ.1)H=RR
C
C Vypocet pomocnych matic RM,AM,HM a vektoru prave strany BM
C zatim bez zapocteni prispevku hranicnich integralu
C
         E1=DET*WT(IG)*H*RK
         D1=DET*WT(IG)*H
         IF($IPHASE.EQ.1)THEN
C ----Varianta s uzlovymi parametry TEPLOTA,ENTALPIE
           DO I=1,NUE
              CONV=F(I)+AOPT*(VVX*FX(I)+VVY*FY(I))
              IF($ISOURCE.NE.0)BM(I)=BM(I)+D1*CONV*Q
              DO J=1,NUE
                 AM(I,J)=AM(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J))
                 IF($ICONV.NE.0)HM(I,J)=
     /                     HM(I,J)+D1*CONV*(VVX*FX(J)+VVY*FY(J))
                 RM(I,J)=RM(I,J)+D1*F(I)*F(J)
              ENDDO
           ENDDO
         ELSE
C ----Varianty s uzlovym parametrem TEPLOTA lisici se algoritmem vypoctu dHdT
           IF(DTDX.EQ.0..AND.DTDY.EQ.0.)THEN
              DHDT=RHO*CP
           ELSE
              SELECT CASE($IPHASE)
              CASE(2)
C LEMMON
                 DHDT=SQRT((DHDX**2+DHDY**2)/(DTDX**2+DTDY**2))
              CASE(3)
C LEWIS,MORGAN
                 DHDT=SQRT((DHDX/DTDX)**2+(DHDY/DTDY)**2)
              CASE(4)
C LEWIS,MORGAN
                 DHDT=0.5*ABS(DHDX/DTDX+DHDY/DTDY)
              CASE(5)
C DEL GUIDICE
                 DHDT=(DHDX*DTDX+DHDY*DTDY)/(DTDX**2+DTDY**2)
              END SELECT
           ENDIF                 
           DO I=1,NUE
              CONV=F(I)+AOPT*(VVX*FX(I)+VVY*FY(I))
              IF($ISOURCE.NE.0)BM(I)=BM(I)+D1*CONV*Q
              DO J=1,NUE
                 AM(I,J)=AM(I,J)+E1*(FX(I)*FX(J)+FY(I)*FY(J))
                 IF($ICONV.NE.0)AM(I,J)=
     /                AM(I,J)+D1*CONV*(VVX*FX(J)+VVY*FY(J))*DHDT
                 RM(I,J)=RM(I,J)+D1*F(I)*F(J)*DHDT
              ENDDO
           ENDDO
         ENDIF
C-----------------------------Konec cyklu Gaussovy integrace IG
      ENDDO
C
C Prispevek hranicnich integralu k matici AM a k vektoru BM
C Krivkove integraly pocitane 3-bodovou Gaussovou integraci 
C
      G(1:3)=(/-.77459666,0.,.77459666/)
      W(1:3)=(/.5555555,.8888888,.555555/)
C Pocet hranicnich krivek je NBCR
      DO IC=1,NBCR
        IF(IBCR(3,IC).EQ.0)THEN
            NU=2
        ELSE
            NU=3
        ENDIF
        DO I=1,NU
           XG(I)=X(IBCR(I,IC))
           YG(I)=Y(IBCR(I,IC))
        ENDDO
        DO IG=1,3
C Bazove funkce F(*) v integracnim uzlu IG pocita procedura FDCR
           CALL FDCR(NU,XG,YG,G(IG),F,FK,FX,FY,DET)
C Polomer RR a ALPHA (oznacovane AA) v integracnim uzlu IG
           RR=0
           AA=0
           DO I=1,NU
             RR=RR+YG(I)*F(I)
             AA=AA+ALPHA(IBCR(I,IC))*F(I)
           ENDDO
           IF(NAXIS.EQ.1)H=RR
C Pricteni prispevku k vektoru BM a matici AM
           DO I=1,NU
              IQ=IBCR(I,IC)
              BM(IQ)=BM(IQ)+F(I)*TE*W(IG)*DET*H*AA
              DO J=1,NU
                 JQ=IBCR(J,IC)
                 AM(IQ,JQ)=AM(IQ,JQ)+F(I)*F(J)*W(IG)*DET*H*AA
              ENDDO
           ENDDO
        ENDDO
      ENDDO
C
C     DTIME je systemova promenna COMMON /FEM/...
C
      AL=0
      BL=0
C
C Lokalni matice $IPHASE=1 AL(2*NUE,2*NUE), zatimco $IPHASE>0 AL(NUE,NUE)
C
      IF($IPHASE.EQ.1)THEN
        DO I=1,NUE
          I1=2*I-1
          I2=2*I
C Vypocet rho,cp v uzlu I
          CP=RMPROP(LPROP,$CP)
          RHO=RMPROP(LPROP,$RHO)
          TEMP=T(I)
          IF(JMPROP(LPROP,$CP).NE.0)CP=CP*CURFUN(JMPROP(LPROP,$CP))
          IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
          IF(NONST.EQ.1)THEN
C 1.row temperature     
C 2.row enthalpy in the node I
             BL(I1)=BM(I)*DTIME
             DO J=1,NUE
               J1=2*J-1
               J2=2*J
               AL(I1,J1)=AM(I,J)*DTIME*$RTHETA
               AL(I1,J2)=RM(I,J)+DTIME*$RTHETA*HM(I,J)
               BL(I1)=BL(I1)+RM(I,J)*HTOLD(J)-(1-$RTHETA)*DTIME*
     /               (HM(I,J)*HTOLD(J)+AM(I,J)*TOLD(J))
             ENDDO
             AL(I2,I2)=1
             AL(I2,I1)=-RHO*CP
             IF(T(I).GT.TMELT)BL(I2)=BL(I2)+HMELT-RHO*CP*TMELT
          ELSE
C STEADY STATE
             BL(I1)=BM(I)
             DO J=1,NUE
               J1=2*J-1
               J2=2*J
               AL(I1,J1)=AM(I,J)
               AL(I1,J2)=HM(I,J)
             ENDDO
             AL(I2,I2)=1
             AL(I2,I1)=-RHO*CP
             IF(T(I).GT.TMELT)BL(I2)=BL(I2)+HMELT-RHO*CP*TMELT
          ENDIF
        ENDDO
      ELSE
C $IPHASE>1 pouze teplota je uzlovy parametr
        DO I=1,NL
          IF(NONST.EQ.1)THEN
             BL(I)=BM(I)*DTIME
             DO J=1,NL
C NONSTEADY
               AL(I,J)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
               BL(I)=BL(I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))*TOLD(J)
             ENDDO
          ELSE
C STEADY STATE
             BL(I)=BM(I)
             DO J=1,NL
               AL(I,J)=AM(I,J)
             ENDDO
          ENDIF
        ENDDO
      ENDIF
C ==================================

      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing, vypocet gradientu teploty
C
        L0=LUE(IE)
        DO IU=1,NUE
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
          Y(IU)=YY(IND)
          T(IU)=VAL(LPU($TEMP)+IND,2)
        ENDDO
C Bazove funkce v tezisti elementu
        IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
             CALL FDFT(NUE,X,Y,.3333,.3333,F,FX,FY,DET)
        ELSE
             CALL FDFQ(NUE,X,Y,0.,0.,F,FX,FY,DET)
        ENDIF
        GRADX=0
        GRADY=0
        DO I=1,NUE
           GRADX=GRADX+FX(I)*T(I)
           GRADY=GRADY+FY(I)*T(I)
        ENDDO
        LPX=MAX0(1,LEPAR(NAMELE,$EGTX))
        LPY=MAX0(1,LEPAR(NAMELE,$EGTY))
        EPAR(IE,LPX)=GRADX
        EPAR(IE,LPY)=GRADY
        KEPAR(NAMELE,LPX)=1
        KEPAR(NAMELE,LPY)=1
      ENDIF
      END
