C $S6-KLOC
      SUBROUTINE UVP(ICONTR,IE,NL,NUE,AL,BL)
C
C NAVIER STOKESOVY ROVNICE - UPWIND
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C
C Tri varianty trojuhelnikovych elementu vetvene dle hodnot 
C MUE (celkovy pocet uzlu) a MINTN (pocet vnitrnich uzlu):
C MUE=6  MINTN=0  NL=15  Trojuhelnikove elementy 6 uzlu (tlaky jen ve vrcholech), 
C     15 DOF, Kvadraticke bazove funkce pro rychlosti, linearni pro tlaky (Taylor-Hood)
C MUE=-4 MINTN=1 NL=7   Trojuhelnikove elementy 4 uzly (tlak jen v tezisti, rychlosti
C     jen ve stredech stran - nestandardni linearni bazove funkce), 7 DOF
C MUE=4  MINTN=1 NL=7   Trojuhelnikove elementy 4 uzly (tlak v tezisti, rychlosti
C     ve vrcholech), 7 DOF
C
C Tri varianty ctyruhelnikovych elementu
C MUE=9  MINTN=1 NL=22  9-uzlu pro rychlosti, tlaky jen ve vrcholech (Taylor Hood)
C MUE=8  MINTN=0 NL=20  8-uzlu pro rychlosti, tlaky ve vrcholech (serendipity)
C MUE=5  MINTN=1 NL=9   Linearni bazove funkce rychlosti (ve vrcholech, konstantni 
C     pro tlak), 9 DOF
C
      INCLUDE '$FEMEQ'
C	COMMON /$ITERAT/ITERATION,NITERATIONS
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),RM(9,9),XE(3),YE(3),
     /          AAX(9,9),AAY(9,9),
     /          PMX(9,4),PMY(9,4),PMYC(9,4),BX(9),BY(9),VX(9),VY(9),
     /          VXOLD(9),VYOLD(9),CN(9),CD(9),CA(9)
      DIMENSION G1(16),G2(16),WT(16),T(9),IZ(9),
     /          F(9),FX(9),FY(9),FL(4),FLX(4),FLY(4),PRESSURE(9)
C MUEL - kodove cislo elementu (zaporna hodnota oznacuje nestandardni usporadani uzlu)
      MUEL=MUE(IE)
      MINTN=MINT(IE)
      MEXTN=IABS(MUEL)-MINTN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (2-TRANSIENT|STATIC,3-NGAUS,4-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,4-ALPHA,5-TE)
      H=RRCONS(LRCON,$H)

C Generovani vektoru L-souradnic G1,G2 integracnich uzlu a jejich vah WT
      IF(MEXTN.EQ.6.OR.MEXTN.EQ.3)THEN
C TROJUHELNIKY
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Q4 NEBO Q8
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF

      IF(ICONTR.EQ.0)THEN
C SESTAVENI A VYPOCET
        L0=LUE(IE)
C Souradnice, stare hodnoty rychlosti a teplot v 6-ti uzlech 
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
C Hodnoty rychlosti z predchozi iterace v zone 4
C Pocatecni podminka pro rychlosti - zona 3
        XMIN=1E10
        XMAX=-1E10
        YMIN=1E10
        YMAX=-1E10
        VXM=0
        VYM=0
        DO IU=1,NUE
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
          Y(IU)=YY(IND)
          XMIN=AMIN1(XMIN,X(IU))
          XMAX=AMAX1(XMAX,X(IU))
          YMIN=AMIN1(YMIN,Y(IU))
          YMAX=AMAX1(YMAX,Y(IU))
          IF(IU.LE.MEXTN)THEN
            T(IU)=VAL(LPU($TEMP)+IND,3)
            CN(IU)=VAL(LPU($CN)+IND,3)
            CD(IU)=VAL(LPU($CD)+IND,3)
            CA(IU)=VAL(LPU($CA)+IND,3)
            VX(IU)=VAL(LPU($VX)+IND,4)
            VXOLD(IU)=VAL(LPU($VX)+IND,3)
            VY(IU)=VAL(LPU($VY)+IND,4)
            VYOLD(IU)=VAL(LPU($VY)+IND,3)
            VXM=VXM+VX(IU)
            VYM=VYM+VY(IU)
          ENDIF
        ENDDO
        VXM=VXM/MEXTN
        VYM=VYM/MEXTN
        DX=XMAX-XMIN
        DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
        HV=VXM*DX+VYM*DY
        UMEAN=SQRT(VXM**2+VYM**2)
        IF(UMEAN.GT.0.)THEN
           HMEAN=HV/UMEAN
        ELSE
           HMEAN=SQRT(DX**2+DY**2)
        ENDIF
C  
C NULOVANI MATIC HMOTNOSTI (RM 9 x 9) , TRANSPORTU (AAX,AAY 9 x 9)
C                TLAKU (PPX,PPY 9 x 4), VZTLAKU (BX,BY 9 x 1)
        RM=0 
        AAX=0
        AAY=0
        PMX=0
        PMY=0
	  PMYC=0
        BX=0
        BY=0
        IF(MUEL.EQ.-4)CALL TEXP(X,Y,XE,YE)
        DO IG=1,NGSS
C 
C Varianta 6-uzlu (kvadraticke rychlosti) nebo 4-uzly (linearni rychlosti)
C    
C          FDFT(NOD,X,Y,RL1,RL2,F,FX,FY,S)
C X(),Y()       SOURADNICE UZLU (1,2,3 -VRCHOLY, 4,5,6-STREDY STRAN)
C NOD=-3   3 linearni bazove funkce odpovidajici uzlum ve stredech stran 
C NOD=3    3 linearni bazove funkce odpovidajici vrcholum
C NOD=4    3 linearni bazove funkce vrcholu, kubicka bublina ctvrteho uzlu
C NOD=6    6 kvadratickych bazovych funkci (vrcholy a stredy stran)
C NOD=7    6 kvadratickych bazovych funkci, kubicka bublina sedmeho uzlu 
C
          SELECT CASE(MUEL)
          CASE(-4)
             IMX=3
             KMX=1       
             CALL FDFT(-3,XE,YE,G1(IG),G2(IG),F,FX,FY,DET)
             FL(1)=1
          CASE(4)
             IMX=3
             KMX=1          
             CALL FDFT(3,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             FL(1)=1
          CASE(5)
             IMX=4
             KMX=1
             CALL FDFQ(4,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             FL(1)=1
          CASE(6)
             IMX=6
             KMX=3          
             CALL FDFT(6,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             CALL FDFT(3,X,Y,G1(IG),G2(IG),FL,FLX,FLY,DETL)
          CASE(8)
             IMX=8
             KMX=4
             CALL FDFQ(8,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             CALL FDFQ(4,X,Y,G1(IG),G2(IG),FL,FLX,FLY,DETL)
          CASE(9)
             IMX=9
             KMX=4
             CALL FDFQ(9,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             CALL FDFQ(4,X,Y,G1(IG),G2(IG),FL,FLX,FLY,DETL)
          END SELECT
          DETWT=DET*WT(IG)
C Rychlosti a teploty z predchozi iterace v Gaussove uzlu
C Teplota se prirazuje promenne AUX(11) pro interpret funkci
          VVX=0
          VVY=0
          RR=0
          TEMP=0
          AUX($LDOF+$CN)=0.
          AUX($LDOF+$CD)=0.
          AUX($LDOF+$CA)=0.
          XG=0.
          YG=0.
          DO I=1,IMX
            XG=XG+X(I)*F(I)
            YG=YG+Y(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
            RR=RR+F(I)*Y(I)
            TEMP=TEMP+T(I)*F(I)
            AUX($LDOF+$CN)=AUX($LDOF+$CN)+CN(I)*F(I)
            AUX($LDOF+$CD)=AUX($LDOF+$CD)+CD(I)*F(I)
            AUX($LDOF+$CA)=AUX($LDOF+$CA)+CA(I)*F(I)
          ENDDO
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-beta) 
          VISC=RMPROP(LPROP,$VISC)
          RHO=RMPROP(LPROP,$RHO)
          BETA=RMPROP(LPROP,$BETA)
C TEMPERATURE DEPENDENCIES
          IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
          IF(JMPROP(LPROP,$BETA).NE.0)
     /                            BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
          IF(JMPROP(LPROP,$VISC).NE.0)THEN
C Vypocet invariantu rychlosti deformace jen v pripade, 
C ze je uvazovana promenna viskozita
             DVXDX=0
             DVYDY=0
             DVXDY=0
             DVYDX=0
             DO I=1,IMX
               DVXDX=DVXDX+VX(I)*FX(I)
               DVYDY=DVYDY+VY(I)*FY(I)
               DVXDY=DVXDY+VX(I)*FY(I)
               DVYDX=DVYDX+VY(I)*FX(I)
             ENDDO
C Druhy invariant je SINV (v zone COMMON)
             SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
             VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
          ENDIF
C Modifikace parametru je-li bod uvnitr castice
          CALL PARTMOD2(XG,YG,VISC,RHO,CP,RKX,RKAPPA)
          IF(VISC.LE.0.)THEN
             WRITE(2,'('' Zero viscosity, quit...'')')
             STOP
          ENDIF
C Pouze pri reseni stacionarniho proudeni, vetsiho poctu iteraci a jen v prvni iteraci pouzijeme nulovou hustotu
C          IF(NITERATIONS.GT.1.AND.NONST.EQ.0)VISC=
C     /         VISC*(FLOAT(NITERATIONS)/ITERATION)**2
C Soucinitel upwind ALPHA jako funkce Pecletova cisla elementu
C Upwind se uvazuje jen tehdy kdyz je nastaven priznak $IUPW
C Vysledkem je promenna AOPT. Kdyz je nulova upwind je potlacen.
          AOPT=0
          IF($IUPW.NE.0)THEN
             PE=UMEAN*HMEAN*RHO/(2*VISC)
             IF(PE.GT.0.01)THEN
                PE=AMIN1(PE,50.)
                EE=EXP(PE)
                ALPHA=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient ALPHA zadavany uzivatelem RALGOR(5)=$RUPW
                AOPT=ALPHA*$RUPW*HMEAN/(2*UMEAN)
             ELSE
                AOPT=0
             ENDIF
          ENDIF
C------------------------------------------------------------
          DO I=1,IMX
            ASYM=AOPT*(VVX*FX(I)+VVY*FY(I))
            DO J=1,IMX
C Matice M (neni uvazovan upwind)
              RM(I,J)=RM(I,J)+RHO*F(I)*F(J)*DETWT
C Matice A
              CONV=RHO*(F(I)+ASYM)*(VVX*FX(J)+VVY*FY(J))
C kartezsky souradny system
              IF($INSGAP.NE.0)THEN
                GAP=CONV*F(J)*12.*VISC/H**2/RHO
                DAX=CONV+VISC*(FX(I)*FX(J)+FY(I)*FY(J))+GAP
              ELSE
                DAX=CONV+VISC*(FX(I)*FX(J)+FY(I)*FY(J))
              ENDIF
              DAY=DAX
              IF(NAXIS.EQ.1)THEN
C cylindricky souradny system
                 DAX=DAX-VISC*F(I)*FY(J)/RR
                 DAY=DAY+VISC*F(J)*FY(I)/RR
              ENDIF
              AAX(I,J)=AAX(I,J)+DAX*DETWT
              AAY(I,J)=AAY(I,J)+DAY*DETWT
            ENDDO
C Matice PXX,PYY i vektory BX,BY jsou stejne v cylindrickem i kartezskem s.s.
C jedinou vyjimkou je matice PMYC pro rovnice kontinuity
            DO J=1,KMX
               PMX(I,J)=PMX(I,J)-FL(J)*FX(I)*DETWT
               PMY(I,J)=PMY(I,J)-FL(J)*FY(I)*DETWT
	         IF(NAXIS.EQ.1)THEN
	             PMYC(I,J)=PMYC(I,J)-FL(J)*(FY(I)+F(I)/RR)*DETWT
	         ELSE
	             PMYC(I,J)=PMY(I,J)
	         ENDIF
            ENDDO          
C Vektor B $RGX,GZ jsou slozky zrychleni 
C                BX(I)=BX(I)+(F(I)+ASYM)*RHO*$RGX*(1-BETA*TEMP)*DETWT
C                BY(I)=BY(I)+(F(I)+ASYM)*RHO*$RGY*(1-BETA*TEMP)*DETWT
            BX(I)=BX(I)-(F(I)+ASYM)*RHO*$RGX*BETA*(TEMP-$TREF)*DETWT
            BY(I)=BY(I)-(F(I)+ASYM)*RHO*$RGY*BETA*(TEMP-$TREF)*DETWT
          ENDDO
C KONEC CYKLU PRES GAUSSOVY BODY
        ENDDO
C
C Nulovani matice soustavy a vektoru prave strany
C -----------------------------------------------
        AL=0
        BL=0
C
C Casovy krok DTIME je systemova promenna
C
C Mapovaci funkce prirazeni prvku matic M,A. Priklad:
C 6 UZLOVY TROJUHELNIK sestaveni matic 15 x 15
C Matice M,A (6 x 6) se presouvaji na pozice 1,4,7,10,12,14 (+1) 
        SELECT CASE (NUE)
        CASE(4)
           IZ(1:IMX)=(/1,3,5/)
        CASE(5)
           IZ(1:IMX)=(/1,3,5,7/)
        CASE(6)
           IZ(1:IMX)=(/1,4,7,10,12,14/)
        CASE(8)
           IZ(1:IMX)=(/1,4,7,10,13,15,17,19/)
        CASE(9)
           IZ(1:IMX)=(/1,4,7,10,13,15,17,19,21/)
        ENDSELECT
C Umisteni prvku AL
        DO I=1,IMX
           BL(IZ(I))=BX(I)*DTIME
           BL(IZ(I)+1)=BY(I)*DTIME
           DO J=1,IMX
              AL(IZ(I),IZ(J))=AAX(I,J)*DTIME+RM(I,J)
              AL(IZ(I)+1,IZ(J)+1)=AAY(I,J)*DTIME+RM(I,J)
              BL(IZ(I))=BL(IZ(I))+RM(I,J)*VXOLD(J)
              BL(IZ(I)+1)=BL(IZ(I)+1)+RM(I,J)*VYOLD(J)
           ENDDO
        ENDDO
C Umisteni prvku PMX a PMY
        SELECT CASE(NUE)
        CASE(6,8,9)
C elementy bez vnitrnich uzlu - tlaky jsou zadane v prvnich KMX uzlech
           DO I=1,KMX
             DO J=1,KMX
C NS rovnice X
               AL(3*I-2,3*J)=PMX(I,J)*DTIME
C NS rovnice Y
               AL(3*I-1,3*J)=PMY(I,J)*DTIME
C Rovnice kontunuity
               AL(3*I,3*J-2)=PMX(I,J)*DTIME
               AL(3*I,3*J-1)=PMYC(I,J)*DTIME
             ENDDO
           ENDDO
           DO I=KMX+1,IMX
             I1=2*I+KMX   
             DO J=1,KMX
C NS rovnice X
               AL(I1-1,3*J)=PMX(I,J)*DTIME
C NS rovnice Y
               AL(I1  ,3*J)=PMY(I,J)*DTIME
C Rovnice kontinuity
               AL(3*J,I1-1)=PMX(I,J)*DTIME
               AL(3*J,I1  )=PMYC(I,J)*DTIME
             ENDDO
           ENDDO
        CASE(4,5)
C elementy, kde tlak je pouze ve vnitrnim uzlu (KMX=1)
           DO I=1,IMX
              I2=2*I
              AL(I2-1,NL)=PMX(I,1)*DTIME
              AL(I2,NL)=PMY(I,1)*DTIME
C rovnice kontinuity
              AL(NL,I2-1)=PMX(I,1)*DTIME
              AL(NL,I2)=PMYC(I,1)*DTIME
           ENDDO
        ENDSELECT
	ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing - vypocet invariantu, hustoty dissipovane energie a vykonu
C
       IF(NUE.EQ.6)THEN
           NVEL=6
       ELSEIF(NUE.EQ.4)THEN
           NVEL=3
       ELSEIF(NUE.EQ.8)THEN
           NVEL=8
       ELSEIF(NUE.EQ.5)THEN
           NVEL=4
       ELSE
           NVEL=9
       ENDIF
       L0=LUE(IE)
       VXMEAN=0.
       VYMEAN=0.
       DO IU=1,NVEL
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           T(IU)=VAL(LPU($TEMP)+IND,3)
           VX(IU)=VAL(LPU($VX)+IND,2)
           VY(IU)=VAL(LPU($VY)+IND,2)
           VXMEAN=VXMEAN+VX(IU)
           VYMEAN=VYMEAN+VY(IU)
           PRESSURE(IU)=VAL(LPU($PRES)+IND,2)
C Dopocitani tlaku ve stredech stran (jako aritmeticky prumer)
           IF(IU.GT.3.AND.NVEL.EQ.6)THEN     
               I1=IU-3
               I2=MOD(I1,3)+1
               VAL(LPU($PRES)+IND,2)=(PRESSURE(I1)+PRESSURE(I2))/2.
           ENDIF
       ENDDO
C 
C Postprocessing - doplneni rychlosti do vnitrniho "tlakoveho" uzlu
C
       IF(NUE.EQ.4.OR.NUE.EQ.5)THEN
           IND=IABS(IUE(L0+NUE))
           VAL(LPU($VX)+IND,2)=VXMEAN/NVEL
           VAL(LPU($VY)+IND,2)=VYMEAN/NVEL
       ENDIF
C SINM/SURFACE-stredni hodnota druheho invariantu (II)
       SINM=0.
C DISS dissipovany vykon v elementu
       DISS=0.
       SURFACE=0.
       IF(MUEL.EQ.-4)CALL TEXP(X,Y,XE,YE)
       GAUS:DO IG=1,NGSS
          IF(NUE.EQ.6)THEN
             CALL FDFT(6,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(MUEL.EQ.-4)THEN
             CALL FDFT(-3,XE,YE,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(MUEL.EQ.4)THEN
             CALL FDFT(3,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(NUE.EQ.9)THEN
             CALL FDFQ(9,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(NUE.EQ.8)THEN
             CALL FDFQ(8,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(NUE.EQ.5)THEN
             CALL FDFQ(4,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ENDIF
          DETWT=DET*WT(IG)
          SURFACE=SURFACE+DETWT
          VYM=0.
          DVXDX=0.
          DVXDY=0.
          DVYDX=0.
          DVYDY=0.
          TEMP=0.
          R=0.
          DO I=1,NVEL
            VYM=VYM+F(I)*VY(I)
            DVXDX=DVXDX+VX(I)*FX(I)
            DVXDY=DVXDY+VX(I)*FY(I)
            DVYDX=DVYDX+VY(I)*FX(I)
            DVYDY=DVYDY+VY(I)*FY(I)
            TEMP=TEMP+T(I)*F(I)
            R=R+Y(I)*F(I)
          ENDDO
          IF(NAXIS.EQ.0)THEN
C Kartezsky souradny system
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
            D=2*SINV
          ELSE
C CYLINDRICKY SOURADNY SYSTEM
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2+(VYM/R)**2
            D=2*SINV*R*6.282
          ENDIF
C Viskozita pri teplote TEMP a invariant II (SINV)
          VISC=RMPROP(LPROP,$VISC)
          IF(JMPROP(LPROP,$VISC).NE.0)
     /           VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
C DRUHY INVARIANT 
          SINM=SINM+SINV*DETWT
          DISS=DISS+D*VISC*DETWT
       ENDDO GAUS
       EPAR(IE,LEPAR(NAMELE,$EII))=SINM/SURFACE
       EPAR(IE,LEPAR(NAMELE,$EDISS))=DISS/SURFACE
       EPAR(IE,LEPAR(NAMELE,$EPOWER))=DISS
       $RPOWERF=$RPOWERF+EPAR(IE,LEPAR(NAMELE,$EPOWER))
      ENDIF
C ENDIF ICONTR 
      END

      SUBROUTINE UVPP(ICONTR,IE,NL,NUE,AL,BL)
C
C NAVIER STOKESOVY ROVNICE - UPWIND metoda pseudostlacitelnosti
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C
C Tri varianty trojuhelnikovych elementu vetvene dle hodnot 
C MUE (celkovy pocet uzlu) a MINTN (pocet vnitrnich uzlu):
C MUE=6 MINTN=0  NL=15  Trojuhelnikove elementy 6 uzlu (tlaky jen ve vrcholech), 
C     15 DOF, Kvadraticke bazove funkce pro rychlosti, linearni pro tlaky (Taylor-Hood)
C MUE=-4 MINTN=1 NL=7   Trojuhelnikove elementy 4 uzly (tlak jen v tezisti, rychlosti
C     jen ve stredech stran - nestandardni linearni bazove funkce), 7 DOF
C MUE=4  MINTN=1 NL=7   Trojuhelnikove elementy 4 uzly (tlak v tezisti, rychlosti
C     ve vrcholech), 7 DOF
C
C Tri varianty ctyruhelnikovych elementu
C MUE=9  MINTN=1 NL=22  9-uzlu pro rychlosti, tlaky jen ve vrcholech (Taylor Hood)
C MUE=8  MINTN=0 NL=20  8-uzlu pro rychlosti, tlaky ve vrcholech (serendipity)
C MUE=5  MINTN=1 NL=9   Linearni bazove funkce rychlosti (ve vrcholech, konstantni 
C     pro tlak), 9 DOF
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),RM(9,9),XE(3),YE(3),
     /          AAX(9,9),AAY(9,9),POLD(9),H(4,4),
     /          PMX(9,4),PMY(9,4),BX(9),BY(9),VX(9),VY(9),
     /          VXOLD(9),VYOLD(9),CN(9),CD(9),CA(9)
      DIMENSION G1(16),G2(16),WT(16),T(9),IZ(9),
     /          F(9),FX(9),FY(9),FL(4),FLX(4),FLY(4),PRESSURE(9)
C MUEL - kodove cislo elementu (zaporna hodnota oznacuje nestandardni konfiguraci)
      MUEL=MUE(IE)
      MINTN=MINT(IE)
      MEXTN=IABS(MUEL)-MINTN
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (2-TRANSIENT|STATIC,3-NGAUS,4-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE,4-ALPHA,5-TE)
      HH=RRCONS(LRCON,$H)

C Generovani vektoru L-souradnic G1,G2 integracnich uzlu a jejich vah WT
      IF(MEXTN.EQ.6.OR.MEXTN.EQ.3)THEN
C TROJUHELNIKY
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Q4 NEBO Q8
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF

      IF(ICONTR.EQ.0)THEN
C SESTAVENI A VYPOCET
        L0=LUE(IE)
C Souradnice, stare hodnoty rychlosti a teplot v 6-ti uzlech 
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
C Hodnoty rychlosti z predchozi iterace v zone 4
C Pocatecni podminka pro rychlosti - zona 3
        XMIN=1E10
        XMAX=-1E10
        YMIN=1E10
        YMAX=-1E10
        VXM=0
        VYM=0
        DO IU=1,NUE
          IND=IABS(IUE(L0+IU))
          X(IU)=XX(IND)
          Y(IU)=YY(IND)
          XMIN=AMIN1(XMIN,X(IU))
          XMAX=AMAX1(XMAX,X(IU))
          YMIN=AMIN1(YMIN,Y(IU))
          YMAX=AMAX1(YMAX,Y(IU))
          IF(IU.LE.MEXTN)THEN
            T(IU)=VAL(LPU($TEMP)+IND,3)
            CN(IU)=VAL(LPU($CN)+IND,3)
            CD(IU)=VAL(LPU($CD)+IND,3)
            CA(IU)=VAL(LPU($CA)+IND,3)
            VX(IU)=VAL(LPU($VX)+IND,4)
            VXOLD(IU)=VAL(LPU($VX)+IND,3)
            VY(IU)=VAL(LPU($VY)+IND,4)
            VYOLD(IU)=VAL(LPU($VY)+IND,3)
            VXM=VXM+VX(IU)
            VYM=VYM+VY(IU)
          ENDIF
          POLD(IU)=VAL(LPU($PRES)+IND,3)
        ENDDO
        VXM=VXM/MEXTN
        VYM=VYM/MEXTN
        DX=XMAX-XMIN
        DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
        HV=VXM*DX+VYM*DY
        UMEAN=SQRT(VXM**2+VYM**2)
        IF(UMEAN.GT.0.)THEN
           HMEAN=HV/UMEAN
        ELSE
           HMEAN=SQRT(DX**2+DY**2)
        ENDIF
C  
C NULOVANI MATIC HMOTNOSTI (RM 9 x 9) , TRANSPORTU (AAX,AAY 9 x 9)
C                TLAKU (PPX,PPY 9 x 4), VZTLAKU (BX,BY 9 x 1)
        RM=0 
        AAX=0
        AAY=0
        PMX=0
        PMY=0
        BX=0
        BY=0
        H=0
        IF(MUEL.EQ.-4)CALL TEXP(X,Y,XE,YE)
        DO IG=1,NGSS
C 
C Varianta 6-uzlu (kvadraticke rychlosti) nebo 4-uzly (linearni rychlosti)
C    
C          FDFT(NOD,X,Y,RL1,RL2,F,FX,FY,S)
C X(),Y()       SOURADNICE UZLU (1,2,3 -VRCHOLY, 4,5,6-STREDY STRAN)
C NOD=-3   3 linearni bazove funkce odpovidajici uzlum ve stredech stran 
C NOD=3    3 linearni bazove funkce odpovidajici vrcholum
C NOD=4    3 linearni bazove funkce vrcholu, kubicka bublina ctvrteho uzlu
C NOD=6    6 kvadratickych bazovych funkci (vrcholy a stredy stran)
C NOD=7    6 kvadratickych bazovych funkci, kubicka bublina sedmeho uzlu 
          SELECT CASE(MUEL)
          CASE(-4)
             IMX=3
             KMX=1       
             CALL FDFT(-3,XE,YE,G1(IG),G2(IG),F,FX,FY,DET)
             FL(1)=1
          CASE(4)
             IMX=3
             KMX=1          
             CALL FDFT(3,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             FL(1)=1
          CASE(5)
             IMX=4
             KMX=1
             CALL FDFQ(4,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             FL(1)=1
          CASE(6)
             IMX=6
             KMX=3          
             CALL FDFT(6,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             CALL FDFT(3,X,Y,G1(IG),G2(IG),FL,FLX,FLY,DETL)
          CASE(8)
             IMX=8
             KMX=4
             CALL FDFQ(8,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             CALL FDFQ(4,X,Y,G1(IG),G2(IG),FL,FLX,FLY,DETL)
          CASE(9)
             IMX=9
             KMX=4
             CALL FDFQ(9,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
             CALL FDFQ(4,X,Y,G1(IG),G2(IG),FL,FLX,FLY,DETL)
          END SELECT
          DETWT=DET*WT(IG)
C Rychlosti a teploty z predchozi iterace v Gaussove uzlu
C Teplota se prirazuje promenne AUX(11) pro interpret funkci
          VVX=0
          VVY=0
          RR=0
          TEMP=0
          XG=0.
          YG=0.
          DO I=1,IMX
            XG=XG+X(I)*F(I)
            YG=YG+Y(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
            RR=RR+F(I)*Y(I)
            TEMP=TEMP+T(I)*F(I)
          ENDDO
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-beta) 
          VISC=RMPROP(LPROP,$VISC)
          RHO=RMPROP(LPROP,$RHO)
          BETA=RMPROP(LPROP,$BETA)
C TEMPERATURE DEPENDENCIES
          IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
          IF(JMPROP(LPROP,$BETA).NE.0)
     /                            BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
          IF(JMPROP(LPROP,$VISC).NE.0)THEN
C Vypocet invariantu rychlosti deformace jen v pripade, 
C ze je uvazovana promenna viskozita
             DVXDX=0
             DVYDY=0
             DVXDY=0
             DVYDX=0
             AUX($LDOF+$CN)=0.
             AUX($LDOF+$CD)=0.
             AUX($LDOF+$CA)=0.
             DO I=1,IMX
               DVXDX=DVXDX+VX(I)*FX(I)
               DVYDY=DVYDY+VY(I)*FY(I)
               DVXDY=DVXDY+VX(I)*FY(I)
               DVYDX=DVYDX+VY(I)*FX(I)
               AUX($LDOF+$CN)=AUX($LDOF+$CN)+CN(I)*F(I)
               AUX($LDOF+$CD)=AUX($LDOF+$CD)+CD(I)*F(I)
               AUX($LDOF+$CA)=AUX($LDOF+$CA)+CA(I)*F(I)
             ENDDO
C Druhy invariant je SINV (v zone COMMON)
             SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
             VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
          ENDIF
          CALL PARTMOD2(XG,YG,VISC,RHO,CP,RKX,RKAPPA)
          IF(VISC.LE.0.)THEN
             WRITE(2,'('' Zero viscosity, quit...'')')
             STOP
          ENDIF
C Soucinitel upwind ALPHA jako funkce Pecletova cisla elementu
C Upwind se uvazuje jen tehdy kdyz je nastaven priznak IALGOR(5)
          AOPT=0
          IF($IUPW.NE.0)THEN
             PE=UMEAN*HMEAN*RHO/(2*VISC)
             IF(PE.GT.0.01)THEN
                PE=AMIN1(PE,50.)
                EE=EXP(PE)
                ALPHA=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient ALPHA zadavany uzivatelem RALGOR(5)=$RUPW
                AOPT=ALPHA*$RUPW*HMEAN/(2*UMEAN)
             ELSE
                AOPT=0
             ENDIF
          ENDIF
C------------------------------------------------------------
          DO I=1,IMX
            ASYM=AOPT*(VVX*FX(I)+VVY*FY(I))
            DO J=1,IMX
C Matice M
              RM(I,J)=RM(I,J)+RHO*F(I)*F(J)*DETWT
C Matice A
              CONV=RHO*(F(I)+ASYM)*(VVX*FX(J)+VVY*FY(J))
C kartezsky souradny system
              IF($INSGAP.NE.0)THEN
                GAP=CONV*F(J)*12.*VISC/HH**2/RHO
                DAX=CONV+VISC*(FX(I)*FX(J)+FY(I)*FY(J))+GAP
              ELSE
                DAX=CONV+VISC*(FX(I)*FX(J)+FY(I)*FY(J))
              ENDIF
              DAY=DAX
              IF(NAXIS.EQ.1)THEN
C cylindricky souradny system
                 DAX=DAX-VISC*F(I)*FY(J)/RR
                 DAY=DAY+VISC*F(J)*FY(I)/RR
              ENDIF
              AAX(I,J)=AAX(I,J)+DAX*DETWT
              AAY(I,J)=AAY(I,J)+DAY*DETWT
            ENDDO
C Matice PXX,PYY i vektory BX,BY jsou stejne v cylindrickem i kartezskem s.s.
            DO J=1,KMX
C Matice P 
C          varianta bez asymetrie
               PMX(I,J)=PMX(I,J)-FL(J)*FX(I)*DETWT
               PMY(I,J)=PMY(I,J)-FL(J)*FY(I)*DETWT
            ENDDO
C Vektor B $RGX,GZ jsou slozky zrychleni 
C               BX(I)=BX(I)+(F(I)+ASYM)*RHO*$RGX*(1-BETA*TEMP)*DETWT
C               BY(I)=BY(I)+(F(I)+ASYM)*RHO*$RGY*(1-BETA*TEMP)*DETWT
            BX(I)=BX(I)-(F(I)+ASYM)*RHO*$RGX*BETA*(TEMP-$TREF)*DETWT
            BY(I)=BY(I)-(F(I)+ASYM)*RHO*$RGY*BETA*(TEMP-$TREF)*DETWT
          ENDDO
C Matice H - souciny linearnich bazovych funkci Hi * Hj
          DO I=1,KMX
            DO J=1,KMX
              H(I,J)=H(I,J)+FL(I)*FL(J)*DETWT
            ENDDO
          ENDDO
C KONEC CYKLU PRES GAUSSOVY BODY
        ENDDO
C
C Nulovani matice soustavy a vektoru prave strany
C -----------------------------------------------
        AL=0
        BL=0
C
C Casovy krok DTIME je systemova promenna
C
C Mapovaci funkce prirazeni prvku matic M,A. Priklad:
C   6ti uzlovy trojuhelnik sestaveni matic 15 x 15
C   Matice M,A (6 x 6) se presouvaji na pozice 1,4,7,10,12,14 (+1) 
        SELECT CASE (NUE)
        CASE(4)
           IZ(1:IMX)=(/1,3,5/)
        CASE(5)
           IZ(1:IMX)=(/1,3,5,7/)
        CASE(6)
           IZ(1:IMX)=(/1,4,7,10,12,14/)
        CASE(8)
           IZ(1:IMX)=(/1,4,7,10,13,15,17,19/)
        CASE(9)
           IZ(1:IMX)=(/1,4,7,10,13,15,17,19,21/)
        ENDSELECT
        DO I=1,IMX
           BL(IZ(I))=BX(I)*DTIME
           BL(IZ(I)+1)=BY(I)*DTIME
           DO J=1,IMX
              AL(IZ(I),IZ(J))=AAX(I,J)*DTIME+RM(I,J)
              AL(IZ(I)+1,IZ(J)+1)=AAY(I,J)*DTIME+RM(I,J)
              BL(IZ(I))=BL(IZ(I))+RM(I,J)*VXOLD(J)
              BL(IZ(I)+1)=BL(IZ(I)+1)+RM(I,J)*VYOLD(J)
           ENDDO
        ENDDO
C Umisteni prvku PMX a PMY
        SELECT CASE(NUE)
        CASE(6,8,9)
C elementy bez vnitrnich uzlu - tlaky jsou zadane v prvnich KMX uzlech
           DO I=1,KMX
             BL(3*I)=0
             DO J=1,KMX
               BL(3*I)=BL(3*I)-H(I,J)*POLD(J)/$RPENFAKT
               AL(3*I,3*J)=-H(I,J)/$RPENFAKT
               AL(3*I-2,3*J)=PMX(I,J)*DTIME
               AL(3*I-1,3*J)=PMY(I,J)*DTIME
               AL(3*I,3*J-2)=PMX(I,J)*DTIME
               AL(3*I,3*J-1)=PMY(I,J)*DTIME
             ENDDO
           ENDDO
           DO I=KMX+1,IMX
             I1=2*I+KMX   
             DO J=1,KMX
               AL(I1-1,3*J)=PMX(I,J)*DTIME
               AL(I1  ,3*J)=PMY(I,J)*DTIME
               AL(3*J,I1-1)=PMX(I,J)*DTIME
               AL(3*J,I1  )=PMY(I,J)*DTIME
             ENDDO
           ENDDO
        CASE(4,5)
C elementy, kde tlak je pouze ve vnitrnim uzlu (KMX=1)
           DO I=1,IMX
              I2=2*I
              AL(I2-1,NL)=PMX(I,1)*DTIME
              AL(I2,NL)=PMY(I,1)*DTIME
              AL(NL,I2-1)=PMX(I,1)*DTIME
              AL(NL,I2)=PMY(I,1)*DTIME
              AL(NL,NL)=-H(1,1)/$RPENFAKT
              BL(NL)=-H(1,1)+POLD(1)/$RPENFAKT
           ENDDO
        ENDSELECT
      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing - vypocet invariantu, hustoty dissipovane energie a vykonu
C
       IF(NUE.EQ.6)THEN
           NVEL=6
       ELSEIF(NUE.EQ.4)THEN
           NVEL=3
       ELSEIF(NUE.EQ.8)THEN
           NVEL=8
       ELSEIF(NUE.EQ.5)THEN
           NVEL=4
       ELSE
           NVEL=9
       ENDIF
       VXMEAN=0.
       VYMEAN=0.
       L0=LUE(IE)
       DO IU=1,NVEL
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           T(IU)=VAL(LPU($TEMP)+IND,3)
           VX(IU)=VAL(LPU($VX)+IND,2)
           VY(IU)=VAL(LPU($VY)+IND,2)
           VXMEAN=VXMEAN+VX(IU)
           VYMEAN=VYMEAN+VY(IU)
           PRESSURE(IU)=VAL(LPU($PRES)+IND,2)
C Dopocitani tlaku ve stredech stran (jako aritmeticky prumer)
           IF(IU.GT.3.AND.NVEL.EQ.6)THEN     
               I1=IU-3
               I2=MOD(I1,3)+1
               VAL(LPU($PRES)+IND,2)=(PRESSURE(I1)+PRESSURE(I2))/2.
           ENDIF
       ENDDO
C 
C Postprocessing - doplneni rychlosti do vnitrniho "tlakoveho" uzlu
C
       IF(NUE.EQ.4.OR.NUE.EQ.5)THEN
           IND=IABS(IUE(L0+NUE))
           VAL(LPU($VX)+IND,2)=VXMEAN/NVEL
           VAL(LPU($VY)+IND,2)=VYMEAN/NVEL
       ENDIF
C SINM/SURFACE-stredni hodnota druheho invariantu (II)
       SINM=0.
C DISS dissipovany vykon v elementu
       DISS=0.
       SURFACE=0.
       IF(MUEL.EQ.-4)CALL TEXP(X,Y,XE,YE)
       GAUS: DO IG=1,NGSS
          IF(NUE.EQ.6)THEN
             CALL FDFT(6,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(MUEL.EQ.-4)THEN
             CALL FDFT(-3,XE,YE,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(MUEL.EQ.4)THEN
             CALL FDFT(3,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(NUE.EQ.9)THEN
             CALL FDFQ(9,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(NUE.EQ.8)THEN
             CALL FDFQ(8,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ELSEIF(NUE.EQ.5)THEN
             CALL FDFQ(4,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
          ENDIF
          DETWT=DET*WT(IG)
          SURFACE=SURFACE+DETWT
          VYM=0.
          DVXDX=0.
          DVXDY=0.
          DVYDX=0.
          DVYDY=0.
          TEMP=0.
          R=0.
          DO I=1,NVEL
            VYM=VYM+F(I)*VY(I)
            DVXDX=DVXDX+VX(I)*FX(I)
            DVXDY=DVXDY+VX(I)*FY(I)
            DVYDX=DVYDX+VY(I)*FX(I)
            DVYDY=DVYDY+VY(I)*FY(I)
            TEMP=TEMP+T(I)*F(I)
            R=R+Y(I)*F(I)
          ENDDO
          IF(NAXIS.EQ.0)THEN
C Kartezsky souradny system
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
            D=2*SINV
          ELSE
C CYLINDRICKY SOURADNY SYSTEM
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2+(VYM/R)**2
            D=2*SINV*R*6.282
          ENDIF
C Viskozita pri teplote TEMP a invariant II (SINV)
          VISC=RMPROP(LPROP,$VISC)
          IF(JMPROP(LPROP,$VISC).NE.0)
     /           VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
C DRUHY INVARIANT 
          SINM=SINM+SINV*DETWT
          DISS=DISS+D*VISC*DETWT
       ENDDO GAUS
       EPAR(IE,LEPAR(NAMELE,$EII))=SINM/SURFACE
       EPAR(IE,LEPAR(NAMELE,$EDISS))=DISS/SURFACE
       EPAR(IE,LEPAR(NAMELE,$EPOWER))=DISS
       $RPOWERF=$RPOWERF+EPAR(IE,LEPAR(NAMELE,$EPOWER))
      ENDIF
C ENDIF ICONTR 
      END



