C $S7-KLOC
      SUBROUTINE PSIN(ICONTR,IE,NL,NUE,AL,BL)
C
C PROUDENI NEWTONSKE KAPALINY: RESENI PROUDOVOU FUNKCI 
C CYLINDRICKY NEBO KARTEZSKY SOURADNY SYSTEM Z,R
C UVAZUJI SE NESTACIONARNI CLENY (BEZ UPWINDU).
C ITERACNI RESENI JE NEZBYTNE, CASOVY KROK MUSI BYT VETSI NEZ 0.
C
C POUZITI TROJUHELNIKOVYCH PRVKU BAZELEY (NEUPLNE KUBICKE POLYNOMY) 
C SEE ZIENKIEWICZ, STR. 203 
C GAUSSOVA INTEGRACE 7 UZLU
C
      INCLUDE '$FEMEQ'
      PARAMETER (NGAUS=7)
      DIMENSION AL(NL,NL),BL(NL),AM(9,9),RM(9,9),BK(9,3),
     / X(3),Y(3),GL1(NGAUS),GL2(NGAUS),W(NGAUS),
     / F(9),FX(9),FY(9),FXX(9),FYY(9),FXY(9),FL(3),FLX(3),FLY(3),
     / VX(3),VY(3),T(3),POLD(9)
      DATA GL1,GL2,W/
     /.3333333,.05971587,.4701421,.4701421,.797427,.1012865,.1012865,
     /.3333333,.4701421,.05971587,.4701421,.1012865,.797427,.1012865,
     /.225,.13239415,.13239415,.13239415,.12593918,.12593918,.12593918/
      IF(ICONTR.EQ.0)THEN
C
C Vypocet proudove funkce
C
      L0=LUE(IE)
      DO I=1,NUE
        IU=IABS(IUE(L0+I))
        X(I)=XX(IU)
        Y(I)=YY(IU)
C stanoveni rychlosti, teploty a predchozich hodnot proudove funkce
C ve trech vrcholech trojuhelnikoveho elementu
C VX-9,VY-10,T-1,PS-14
        T(I)=VAL(LPU($TEMP)+IU,3)
        VX(I)=VAL(LPU($VX)+IU,3)
        VY(I)=VAL(LPU($VY)+IU,3)
        POLD(3*I-2)=VAL(LPU($PS)+IU,3)
        POLD(3*I-1)=VAL(LPU($PSX)+IU,3)
        POLD(3*I)=VAL(LPU($PSY)+IU,3)
      ENDDO
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-THERMAL|STRESS,2-NGAUS,3-PLANE/AXISYM)
      NAXIS=JGROUP(LEGRP,$AXIS)
C
C NULOVANI VEKTORU PRAVE STRANY, MATICE AL, MATICE HMOT RM, VZTLAKU BK
      BL=0
      AL=0
      AM=0
      RM=0
      BK=0
C 7-mi bodova Gaussova integrace matic
      DO IG=1,NGAUS
C Linearni bazove funkce a jejich derivace
        CALL FDFT(3,X,Y,GL1(IG),GL2(IG),FL,FLX,FLY,S)
C Rychlosti a teploty v integracnim uzlu
        VVX=0
        VVY=0
        TMEAN=0
        XGA=0
        YGA=0
        DO I=1,3
          XGA=XGA+X(I)*F(I)
          YGA=YGA+Y(I)*F(I)
          VVX=VVX+VX(I)*FL(I)
          VVY=VVY+VY(I)*FL(I)
          TMEAN=TMEAN+T(I)*FL(I)
        ENDDO
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-beta) 
        VISC=RMPROP(LPROP,$VISC)
        RHO=RMPROP(LPROP,$RHO)
        BETA=RMPROP(LPROP,$BETA)
C TEMPERATURE DEPENDENCIES
        IF(JMPROP(LPROP,$VISC).NE.0)THEN
            DVXDX=0
            DVYDY=0
            DVXDY=0
            DVYDX=0
            TEMP=0
            DO I=1,3
               DVXDX=DVXDX+VX(I)*FLX(I)
               DVYDY=DVYDY+VY(I)*FLY(I)
               DVXDY=DVXDY+VX(I)*FLY(I)
               DVYDX=DVYDX+VY(I)*FLX(I)
               TEMP=TEMP+T(I)*F(I)
            ENDDO
C Druhy invariant je SINV, teplota TEMP
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
            VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
        ENDIF
        IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
        IF(JMPROP(LPROP,$BETA).NE.0)
     /                          BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
        CALL PARTMOD2(XGA,YGA,VISC,RHO,CP,RKX,RKAPPA)
C Kubicke bazove funkce a jejich derivace
        CALL FDF3(X,Y,GL1(IG),GL2(IG),F,FX,FY,FXX,FYY,FXY,S)
C RR-polomer Gaussova uzlu
        RR=Y(1)*GL1(IG)+Y(2)*GL2(IG)+Y(3)*(1-GL1(IG)-GL2(IG))
        DO I=1,NL
          DO J=1,NL
            IF(NAXIS.EQ.1)THEN
C cylindricky s.s. rovnice (34)
              DA=(FXX(J)+FYY(J)-FY(J)/RR)/RR*
     /           (RHO*(VVX*FX(I)+VVY*FY(I))+
     /            VISC*(FXX(I)+FYY(I)-FY(I)/RR))
C Rov.(33)
              DC=RHO*(FX(I)*FX(J)+FY(I)*FY(J))/RR
            ELSE
C kartezsky souradny system, Rov.(22)
c              DA=(FXX(J)+FYY(J))*
c     /           (RHO*(VVX*FX(I)+VVY*FY(I))+
c     /            VISC*(FXX(I)+FYY(I)))
              DA=RHO*(FXX(J)+FYY(J))*(VVX*FX(I)+VVY*FY(I))+
     / VISC*((FXX(J)-FYY(J))*(FXX(I)-FYY(I))+4*FXY(J)*FXY(I))
C Rov.(21)
              DC=RHO*(FX(I)*FX(J)+FY(I)*FY(J))
            ENDIF
            AM(I,J)=AM(I,J)+DA*S*W(IG)
            RM(I,J)=RM(I,J)+DC*S*W(IG)
          ENDDO
C Prirozena konvekce. RALGOR(1)-gx, RALGOR(2)-gy (nezavisle na s.s.)
          DO J=1,3
C Rov.(24)
            DB=RHO*BETA*F(I)*($RGX*FLY(J)-$RGY*FLX(J))
            BK(I,J)=BK(I,J)+DB*S*W(IG)
          ENDDO
        ENDDO
      ENDDO
C to byl konec cyklu Gaussovy integrace
C (M+dt.A).PS = M.PS0+dt.B.T,   Rov.(25)
      DO I=1,NL
        DO J=1,NL
           AL(I,J)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
           BL(I)=BL(I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))*POLD(J)
        ENDDO
        DO J=1,3
           BL(I)=BL(I)+DTIME*BK(I,J)*T(J)
        ENDDO
      ENDDO
C
      ELSEIF(ICONTR.GT.0)THEN
C
C ICONTR=1 Postprocessing - vypocet rychlosti VX,VY z vypoctenych PSX,PSY
C          ve vsech uzlech elementu
C BL ps1,psx1,psy1, ps2,psx2,psy2, ...
C
      LEGRP=MAX0(1,IGROUP(IE))
      NAXIS=JGROUP(LEGRP,$AXIS)
      L0=LUE(IE)
      DO I=1,NUE
        IU=IABS(IUE(L0+I))
        Y(I)=YY(IU)
C VX=DPS/DY
        IF(NAXIS.EQ.0)THEN
           VAL(LPU($VX)+IU,3)=BL(3*I)
        ELSEIF(Y(I).NE.0.)THEN
           VAL(LPU($VX)+IU,3)=BL(3*I)/Y(I)
        ELSE
C rychlost v ose - spravne by to mela byt druha derivace proudove funkce dle R
C musela by se tudiz pouzit FDF3(X,Y,GL1(IG),GL2(IG),F,FX,FY,FXX,FYY,FXY,S),
C pro bod na ose (musel by se stanovit gaussuv uzel). Spokojime se s hodnotou
C druhe derivace FYY v tezisti elementu.
           CALL FDF3(X,Y,0.33333,0.33333,F,FX,FY,FXX,FYY,FXY,S)
           VAX=0
           DO K=1,9
              VAX=VAX+FYY(K)*BL(K)
           ENDDO
           VAL(LPU($VX)+IU,3)=VAX
        ENDIF
C VY=-DPS/DX
        IF(NAXIS.EQ.0)THEN
           VAL(LPU($VY)+IU,3)=-BL(3*I-1)
        ELSEIF(Y(I).NE.0.)THEN
           VAL(LPU($VY)+IU,3)=-BL(3*I-1)/Y(I)
        ELSE
C Radialni slozka rychlosti na ose je nulova
           VAL(LPU($VY)+IU,3)=0
        ENDIF
      ENDDO
      ENDIF
      END

      SUBROUTINE PSBL(ICONTR,IE,NL,NUE,AL,BL)
C
C PROUDENI NEWTONSKE KAPALINY: RESENI PROUDOVOU FUNKCI 
C CYLINDRICKY NEBO KARTEZSKY SOURADNY SYSTEM Z,R
C UVAZUJI SE NESTACIONARNI CLENY (BEZ UPWINDU).
C
C POUZITI TROJUHELNIKOVYCH PRVKU BELL (POLYNOMY 5-TEHO STUPNE, 18 DOF) 
C GAUSSOVA INTEGRACE 7 UZLU
C
      INCLUDE '$FEMEQ'
      PARAMETER (NGAUS=7)
      DIMENSION AL(NL,NL),BL(NL),RM(18,18),BK(18,3),
     / X(3),Y(3),GL1(NGAUS),GL2(NGAUS),W(NGAUS),
     / F(18),FX(18),FY(18),FXX(18),FYY(18),FXY(18),FL(3),FLX(3),FLY(3),
     / VX(3),VY(3),T(3),POLD(18)
      DATA GL1,GL2,W/
     /.3333333,.05971587,.4701421,.4701421,.797427,.1012865,.1012865,
     /.3333333,.4701421,.05971587,.4701421,.1012865,.797427,.1012865,
     /.225,.13239415,.13239415,.13239415,.12593918,.12593918,.12593918/
      IF(ICONTR.EQ.0)THEN
C
C Vypocet proudove funkce
C
      L0=LUE(IE)
      DO I=1,NUE
        IU=IABS(IUE(L0+I))
        X(I)=XX(IU)
        Y(I)=YY(IU)
C stanoveni rychlosti, teploty a predchozich hodnot proudove funkce
C ve trech vrcholech trojuhelnikoveho elementu
C VX-9,VY-10,T-1,PS-14
        T(I)=VAL(LPU($TEMP)+IU,3)
        VX(I)=VAL(LPU($VX)+IU,3)
        VY(I)=VAL(LPU($VY)+IU,3)
        POLD(3*I-2)=VAL(LPU($PS)+IU,3)
        POLD(3*I-1)=VAL(LPU($PSX)+IU,3)
        POLD(3*I)=VAL(LPU($PSY)+IU,3)
      ENDDO
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-THERMAL|STRESS,2-NGAUS,3-PLANE/AXISYM)
      NAXIS=JGROUP(LEGRP,$AXIS)
C
C NULOVANI VEKTORU PRAVE STRANY, MATICE AL, MATICE HMOT RM, VZTLAKU BK
      BL=0
      AL=0
      RM=0
      BK=0
C 7-mi bodova Gaussova integrace matic
      DO IG=1,NGAUS
C Linearni bazove funkce a jejich derivace
        CALL FDFT(3,X,Y,GL1(IG),GL2(IG),FL,FLX,FLY,S)
C Rychlosti a teploty v integracnim uzlu
        VVX=0
        VVY=0
        TMEAN=0
        DO I=1,3
          VVX=VVX+VX(I)*FL(I)
          VVY=VVY+VY(I)*FL(I)
          TMEAN=TMEAN+T(I)*FL(I)
        ENDDO
        TEMP=TMEAN
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-beta) 
        VISC=RMPROP(LPROP,$VISC)
        RHO=RMPROP(LPROP,$RHO)
        BETA=RMPROP(LPROP,$BETA)
C TEMPERATURE DEPENDENCIES
        IF(JMPROP(LPROP,$VISC).NE.0)THEN
            DVXDX=0
            DVYDY=0
            DVXDY=0
            DVYDX=0
            TEMP=0
            DO I=1,3
               DVXDX=DVXDX+VX(I)*FLX(I)
               DVYDY=DVYDY+VY(I)*FLY(I)
               DVXDY=DVXDY+VX(I)*FLY(I)
               DVYDX=DVYDX+VY(I)*FLX(I)
               TEMP=TEMP+T(I)*F(I)
            ENDDO
C Druhy invariant je SINV, teplota TEMP
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
            VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
        ENDIF
        IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
        IF(JMPROP(LPROP,$BETA).NE.0)
     /                          BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
C Kubicke bazove funkce a jejich derivace
        CALL FDF3(X,Y,GL1(IG),GL2(IG),F,FX,FY,FXX,FYY,FXY,S)
C RR-polomer Gaussova uzlu
        RR=Y(1)*GL1(IG)+Y(2)*GL2(IG)+Y(3)*(1-GL1(IG)-GL2(IG))
        DO I=1,NL
          DO J=1,NL
            IF(NAXIS.EQ.1)THEN
C cylindricky s.s. rovnice (34)
              DA=(FXX(J)+FYY(J)-FY(J)/RR)/RR*
     /           (RHO*(VVX*FX(I)+VVY*FY(I))+
     /            VISC*(FXX(I)+FYY(I)-FY(I)/RR))
C Rov.(33)
              DC=RHO*(FX(I)*FX(J)+FY(I)*FY(J))/RR
            ELSE
C kartezsky souradny system, Rov.(22)
              DA=(FXX(J)+FYY(J))*
     /           (RHO*(VVX*FX(I)+VVY*FY(I))+
     /            VISC*(FXX(I)+FYY(I)))
C Rov.(21)
              DC=RHO*(FX(I)*FX(J)+FY(I)*FY(J))
            ENDIF
            AL(I,J)=AL(I,J)+DA*S*W(IG)
            RM(I,J)=RM(I,J)+DC*S*W(IG)
          ENDDO
C Prirozena konvekce. RALGOR(1)-gx, RALGOR(2)-gy (nezavisle na s.s.)
          DO J=1,3
C Rov.(24)
            DB=RHO*BETA*F(I)*($RGX*FLY(J)-$RGY*FLX(J))
            BK(I,J)=BK(I,J)+DB*S*W(IG)
          ENDDO
        ENDDO
      ENDDO
C (M+dt.A).PS = M.PS0+dt.B.T,   Rov.(25)
      DO I=1,NL
        DO J=1,NL
           AL(I,J)=RM(I,J)+AL(I,J)*DTIME
           BL(I)=BL(I)+RM(I,J)*POLD(J)
        ENDDO
        DO J=1,3
           BL(I)=BL(I)+DTIME*BK(I,J)*T(J)
        ENDDO
      ENDDO
      ELSE
C
C ICONTR=1 Postprocessing - vypocet rychlosti VX,VY z vypoctenych PSX,PSY
C          ve vsech uzlech elementu
C BL ps1,psx1,psy1, ps2,psx2,psy2, ...
C
      LEGRP=MAX0(1,IGROUP(IE))
      NAXIS=JGROUP(LEGRP,$AXIS)
      L0=LUE(IE)
      DO I=1,NUE
        IU=IABS(IUE(L0+I))
        Y(I)=YY(IU)
C VX=DPS/DY
        IF(NAXIS.EQ.0)THEN
           VAL(LPU($VX)+IU,3)=BL(3*I)
        ELSEIF(Y(I).NE.0.)THEN
           VAL(LPU($VX)+IU,3)=BL(3*I)/Y(I)
        ELSE
C rychlost v ose - spravne by to mela byt druha derivace proudove funkce dle R
C musela by se tudiz pouzit FDF3(X,Y,GL1(IG),GL2(IG),F,FX,FY,FXX,FYY,FXY,S),
C pro bod na ose (musel by se stanovit gaussuv uzel). Spokojime se s hodnotou
C druhe derivace FYY v tezisti elementu.
           CALL FDF3(X,Y,0.33333,0.33333,F,FX,FY,FXX,FYY,FXY,S)
           VAX=0
           DO K=1,9
              VAX=VAX+FYY(K)*BL(K)
           ENDDO
           VAL(LPU($VX)+IU,3)=VAX
        ENDIF
C VY=-DPS/DX
        IF(NAXIS.EQ.0)THEN
           VAL(LPU($VY)+IU,3)=-BL(3*I-1)
        ELSEIF(Y(I).NE.0.)THEN
           VAL(LPU($VY)+IU,3)=-BL(3*I-1)/Y(I)
        ELSE
C Radialni slozka rychlosti na ose je nulova
           VAL(LPU($VY)+IU,3)=0
        ENDIF
      ENDDO
      ENDIF
      END

