C $S8-KLOC
      SUBROUTINE PSOM(ICONTR,IE,NL,NUE,AL,BL)
C
C NAVIER STOKES - PSI , OMEGA 
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C
C Elementy: T3,T6,Q4,Q8 (v kazdem uzlu dva parametry OMEGA,PSI viz EDOF)
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Konvekce: UPWIND (Zienkiewicz)
C Zdrojovy clen: prirozena konvekce
C Okrajove podminky: je treba vyznacit cast hranice, 
C                    kde neni zadane omega, IPU>20 (typicky STENA)
C Integrace v case: implicitni, 1.rad
C Rychlosti VX,VY nejsou uzlove parametry, ale parametry elementu
C (na rychlosti se nevztahuji pocatecni podminky)
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),
     /          AM(9,9),RM(9,9),CM(9,9),DM(9,9),BM(9,9),XG(3),YG(3),
     /          T(9),OMG(9),PSI(9),IBND(9),IBCR(3,3),NINER(3),
     /          G1(16),G2(16),WT(16),F(9),FK(3),FX(9),FY(9),
     /          G(3),W(3)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE PRENOSU, RM-MATICE HMOT, CM-MATICE VIRIVOSTI 
C DM-MATICE LAPLAC.OP.,BM-VZTLAK
C T,OMG-TEPLOTY,VIRIVOSTI Z PREDCHOZI ITERACE, 
C VX,VY-rychlosti proudeni
C IBND-indexy uzlu na hranici Gamma,
C IBCR-uzly hranicnich krivek, 
C NINER-kazde hranicni krivce je prirazen uzel lezici uvnitr oblasti
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE (FK derivace dle ksi)
C 
C Ze zony $FEM jsou vyuzivany i prvky 
C          IALGOR(2)-potlaceni vypoctu konvektivnich clenu
C          IALGOR(4)-potlaceni vypoctu zdroje tepla
C          IALGOR(5)-upwind
C
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS)
      H=RRCONS(LRCON,$H)

      IF(ICONTR.EQ.0)THEN
C 
C ICONTR=0 Vypocet proudove funkce a virivosti
C          
C Stanoveni uzlovych teplot T(*) a rychlosti VX(*),VY(*) z predchozich kroku.
C Identifikace uzlu elementu IBND(*), v nich je status teploty 
C             20 < IPU  . 
C Tento uzel je povazovan za uzel lezici na STENE, kde neni znama virivost.
C Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VX,VY. Tyto hodnoty
C budou vyuzity pro vypocet Pecletova cisla elementu.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      L0=LUE(IE)
C NBND - pocet uzlu elementu na hranici s neznamou hodnotou pro OMEGA (stena)
      NBND=0
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))
        T(IU)=VAL(LPU($TEMP)+IND,3)
        OMG(IU)=VAL(LPU($OMG)+IND,3)
C Identifikace uzlu steny (virivost) IPU>20
        IF(IPU(LPU($OMG)+IND).GT.20)THEN
           NBND=NBND+1
           IBND(NBND)=IU
        ELSE
           IIND=IU
        ENDIF
      ENDDO
      VX=EPAR(IE,LEPAR(NAMELE,$EVX))
      VY=EPAR(IE,LEPAR(NAMELE,$EVY))
      DX=XMAX-XMIN
      DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VX*DX+VY*DY
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VX**2+VY**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2)
      ENDIF
C ======================================================================
C Urceni krivek, ktere tvori hranici elementu a na nichz je treba
C vyhodnotit krivkovy integral. Vychazi se ze seznamu hranicnich uzlu
C IBND(NBND). Vysledkem je matice IBCR(3,*), jejich sloupce definuji krivku
C indexy (1,2,..NUE) uzlu. Krivka je urcena dvema nebo tremi body, zalezi
C na typu elementu. Pocet krivek je NBCR. Kazde krivce je take prirazen
C uzel NINER(*) lezici uvnitr oblasti - tim je definovan vnitrek a vnejsek.
C
      IF(NBND.GT.1)THEN
         NBCR=0
         IBCR=0
         SELECT CASE(NUE)
         CASE (3)
C
C Trojuhelnik se 3 uzly. 1 nebo 2 strany jsou casti hranice (2 nebo 3 uzly).
C 3333333333333333333333333333333333333333333333333333333333333333333333333
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
               NINER(1)=IIND
            ELSE
C Dve strany jsou casti hranice. Vsechny 3 vrcholy lezi na hranici a neni jasne
C kterou ze tri stran vyradit. Tato vyjimecna situace se resi prohlizenim
C cele matice konektivity - hleda se vrchol, jehoz uzel neni soucasti zadneho
C jineho elementu.
               DO IB=1,3
C Stanoveni globalniho indexu uzlu
                 INDU=IABS(IUE(L0+IBND(IB)))
                 NB=0
                 DO J=1,NE
                   LOC=LUE(J)
                   DO K=1,NUE
                     IF(IABS(IUE(LOC+K)).EQ.INDU)NB=NB+1
                   ENDDO
                 ENDDO
                 IF(NB.EQ.1)THEN
                   ICORN=IB
                   EXIT
                 ENDIF
               ENDDO
C Uzel ICORN (1,2,3) je roh - v matici konektivity se vyskytl jen jednou.
               IF(ICORN.NE.0)THEN
                 NBCR=2
                 IBCR(1,1)=IBND(ICORN)
                 IBCR(1,2)=IBND(ICORN)
                 IC1=MOD(ICORN,3)+1
                 IC2=MOD(IC1,3)+1
                 IBCR(2,1)=IBND(IC1)
                 IBCR(2,2)=IBND(IC2)
                 NINER(1)=IBND(IC2)
                 NINER(2)=IBND(IC1)
               ENDIF
            ENDIF
         CASE(4)
C Ctyruhelnik se 4-uzly. 1 nebo 2 strany casti hranice (2 nebo 3 uzly)
C 44444444444444444444444444444444444444444444444444444444444444444444
            IF(NBND.EQ.2)THEN
C Jen jedna strana je casti hranice
               NBCR=1
               IBCR(1,1)=IBND(1)
               IBCR(2,1)=IBND(2)
               NINER(1)=IIND
            ELSE
C Soucasti hranice jsou dve strany (3 vylucujeme, i kdyz je to teoreticky mozne)
               NBCR=2             
               NINER(1)=IIND
               NINER(2)=IIND
               IF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.3)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=2
                  IBCR(2,2)=3
              ELSEIF(IBND(1).EQ.2.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=2
                  IBCR(2,1)=3
                  IBCR(1,2)=3
                  IBCR(2,2)=4
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.3.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=3
                  IBCR(2,1)=4
                  IBCR(1,2)=4
                  IBCR(2,2)=1
              ELSEIF(IBND(1).EQ.1.AND.IBND(2).EQ.2.AND.IBND(3).EQ.4)THEN
                  IBCR(1,1)=1
                  IBCR(2,1)=2
                  IBCR(1,2)=4
                  IBCR(2,2)=1
               ENDIF
            ENDIF
         CASE (6)   
C
C Trojuhelnik se 6 uzly. 1 nebo 2 strany (3 nebo 5 uzlu na hranici)
C 66666666666666666666666666666666666666666666666666666666666666666
            NBCR=NBND/2
            DO IB=1,NBCR
               NINER(IB)=IIND
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-3
               IBCR(2,IB)=IBCR(3,IB)-2
               IF(IBCR(2,IB).GT.3)IBCR(2,IB)=1
            ENDDO
         CASE (8)   
C
C Ctyruhelnik s 8 uzly. 1,2 nebo 3 strany (3,5 nebo 7 uzlu na hranici)
C 88888888888888888888888888888888888888888888888888888888888888888888
            NBCR=NBND/2
            DO IB=1,NBCR
               NINER(IB)=IIND
C Stredni uzel identifikuje stranu
               IBCR(3,IB)=IBND(NBCR+1+IB)   
               IBCR(1,IB)=IBCR(3,IB)-4
               IBCR(2,IB)=IBCR(3,IB)-3
               IF(IBCR(2,IB).GT.4)IBCR(2,IB)=1
            ENDDO
         END SELECT
      ENDIF
C Konec sekce, ktera identifikovala hranicni krivky (IBCR)
C =====================================================================
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Isoparametric 4 or 8-node element.
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC PRENOSU A HMOTNOSTI A ZDROJOVYCH CLENU - rozmer NUE
      AM=0
      RM=0
      DM=0
      CM=0
      BM=0
C
C SESTAVENI MATICE AM(vazke sily a konvekce),RM(hmotnosti), vektor BM
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
         DETWT=DET*WT(IG)
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C
         TEMP=0
         RR=0
         XGA=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            RR=RR+Y(I)*F(I)
            XGA=XGA+X(I)*F(I)
         ENDDO
C MPROP  (3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RHO=RMPROP(LPROP,$RHO)
         VISC=RMPROP(LPROP,$VISC)
         BETA=RMPROP(LPROP,$BETA)
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$BETA).NE.0)
     /                           BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
         IF(JMPROP(LPROP,$VISC).NE.0)
     /                           VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
C Modifikace materialovych vlastnosti v pripade castice
         CALL PARTMOD2(XGA,RR,VISC,RHO,CP,RKX,RKAPPA)
         AOPT=0
C Vypocet REYNOLDSOVA cisla jen pro pripad uvazovani konvekce (IALGOR(2)) 
C a nastaveni upwindu (IALGOR(5))
         IF($ICONV.NE.0.AND.$IUPW.NE.0)THEN
C Soucinitel upwind ALF jako funkce REYNOLDSOVA cisla elementu
            PE=UMEAN*HMEAN*RHO/(2*VISC)
            IF(PE.GT.0.1)THEN
               PE=AMIN1(PE,50.)
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient zadavany uzivatelem RALGOR(5)=$RUPW
               AOPT=ALF*$RUPW*HMEAN/(2*UMEAN)
            ELSE
               AOPT=0
            ENDIF
         ENDIF
C SESTAVENI
         DO I=1,NUE
            IF(NAXIS.EQ.1)THEN
                ASYM=AOPT*(VX*FX(I)+VY*FY(I)-VY*F(I)/RR)
            ELSE
                ASYM=AOPT*(VX*FX(I)+VY*FY(I))
            ENDIF
            DO J=1,NUE
C Matice M
              RM(I,J)=RM(I,J)+RHO*F(I)*F(J)*DETWT
              CM(I,J)=CM(I,J)+F(I)*F(J)*DETWT
              IF(NAXIS.EQ.1)THEN
C Cylindricky souradny system
C Matice A
                  CONV=RHO*(F(I)+ASYM)*(VX*FX(J)+VY*FY(J)-VY*F(J)/RR)
                  DA=CONV+VISC*(FX(I)*FX(J)+FY(I)*FY(J)+F(J)*FY(I)/RR)
                  DM(I,J)=DM(I,J)+(FX(I)*FX(J)+FY(I)*FY(J))/RR*DETWT
               ELSE
C kartezsky souradny system
                  CONV=RHO*(F(I)+ASYM)*(VX*FX(J)+VY*FY(J))
                  DA=CONV+VISC*(FX(I)*FX(J)+FY(I)*FY(J))
                  DM(I,J)=DM(I,J)+(FX(I)*FX(J)+FY(I)*FY(J))*DETWT
               ENDIF
               AM(I,J)=AM(I,J)+DA*DETWT
C Vektor B $RGX,GZ jsou slozky zrychleni 
               BM(I,J)=BM(I,J)+CONV*BETA*($RGY*FX(J)-$RGX*FY(J))*DETWT
            ENDDO
         ENDDO
      ENDDO
C
C Prispevek hranicnich integralu k matici AM. Pocet krivek je NBCR,
C tvorici uzly ve sloupcich IBCR. NINER-uzel lezici uvnitr.
C Krivkove integraly pocitane 3-bodovou Gaussovou integraci 
C
      G(1:3)=(/-.77459666,0.,.77459666/)
      W(1:3)=(/.5555555,.8888888,.555555/)
C Pocet hranicnich krivek je NBCR
      DO IC=1,NBCR
        IF(IBCR(3,IC).EQ.0)THEN
            NU=2
        ELSE
            NU=3
        ENDIF
        DO I=1,NU
           XG(I)=X(IBCR(I,IC))
           YG(I)=Y(IBCR(I,IC))
        ENDDO
C Souradnice vnitrniho uzlu
        XINER=X(NINER(IC))
        YINER=Y(NINER(IC))
        DO IG=1,3
C Bazove funkce F(*) v integracnim uzlu IG pocita procedura FDCR
           CALL FDCR(NU,XG,YG,G(IG),F,FK,FX,FY,DET)
C Polomer RR v integracnim uzlu IG
           RR=0
           AA=0
           XKSI=0
           YKSI=0
           DO I=1,NU
             RR=RR+YG(I)*F(I)
             XKSI=XKSI+XG(I)*FK(I)
             YKSI=YKSI+YG(I)*FK(I)
           ENDDO
           SUMS=SQRT(XKSI**2+YKSI**2)
           RNX=YKSI/SUMS
           RNY=-XKSI/SUMS
C Urceni smeru normaly RNX,RNY ze znamenka skalarniho soucinu normaly 
C a vnitrni strany
           SKS=RNX*(XINER-XG(1))+RNY*(YINER*YG(1))
           IF(SKS.GT.0.)THEN
              RNX=-RNX
              RNY=-RNY
           ENDIF
C Pricteni prispevku k matici AM
           DO I=1,NU
              IQ=IBCR(I,IC)
              DO J=1,NU
                 JQ=IBCR(J,IC)
                 IF(NAXIS.EQ.1)THEN
                     AM(IQ,JQ)=AM(IQ,JQ)-VISC*F(I)*
     /                 (FX(J)*RNX+FY(J)*RNY+F(J)*RNY/RR)*W(IG)*DET*H*AA
                 ELSE
                     AM(IQ,JQ)=AM(IQ,JQ)-VISC*F(I)*
     /                 (FX(J)*RNX+FY(J)*RNY)*W(IG)*DET*H*AA
                 ENDIF
              ENDDO
           ENDDO
        ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]] ma rozmer NL = 2 x NUE
C
C     DTIME je systemova promenna COMMON /FEM/...
C
      AL=0
      BL=0
      DO I=1,NUE
        IF(NONST.EQ.1)THEN
C Nestacionarni pripad
           DO J=1,NUE
             BL(2*I-1)=BL(2*I-1)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))
     /                 *OMG(J)+BM(I,J)*T(J)*DTIME
             AL(2*I-1,2*J-1)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
             AL(2*I,2*J-1)=CM(I,J)
             AL(2*I,2*J)=DM(I,J)
           ENDDO
        ELSE
C Stacionarni pripad
           DO J=1,NUE
             BL(2*I-1)=BL(2*I-1)+BM(I,J)*T(J)
             AL(2*I-1,2*J-1)=AM(I,J)
             AL(2*I,2*J-1)=CM(I,J)
             AL(2*I,2*J)=DM(I,J)
           ENDDO
        ENDIF
      ENDDO
      ELSE
C
C ICONTR=1 Postprocessing - vypocet rychlosti z proudove funkce do zony elementu
C ------------------------
         L0=LUE(IE)
         DO IU=1,NUE
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           PSI(IU)=VAL(LPU($PS)+IND,2)
         ENDDO        
         LEGRP=MAX0(1,IGROUP(IE))
         NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
         NAXIS=JGROUP(LEGRP,$AXIS)
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
           CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
         ELSE
C Isoparametric 4 or 8-node element.
           CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
         ENDIF
C Vypocet stredni rychlosti VX a VY integraci pres element
         AREA=0
         VX=0
         VY=0
         DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
            IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
                 CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
            ELSE
                 CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
            ENDIF
            DETWT=DET*WT(IG)
            RR=0
            VXI=0
            VYI=0
            DO I=1,NUE
               VXI=VXI+FY(I)*PSI(I)
               VYI=VYI-FX(I)*PSI(I)
               RR=RR+Y(I)*F(I)
            ENDDO
            IF(NAXIS.EQ.1)THEN
               VXI=VXI/RR
               VYI=VYI/RR
            ENDIF
            VX=VX+VXI*DETWT
            VY=VY+VYI*DETWT
            AREA=AREA+DETWT
         ENDDO
         LEX=MAX0(1,LEPAR(NAMELE,$EVX))
         LEY=MAX0(1,LEPAR(NAMELE,$EVY))
         EPAR(IE,LEX)=VX/AREA
         EPAR(IE,LEY)=VY/AREA
         KEPAR(NAMELE,LEX)=1
         KEPAR(NAMELE,LEY)=1
      ENDIF
      END

      SUBROUTINE CARE(ICONTR,IE,NL,NUE,AL,BL)
C
C NAVIER STOKES - PSI , OMEGA  varianta CAMPION-RENSON (bez hranicnich integralu)
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C
C Elementy: T3,T6,Q4,Q8 (v kazdem uzlu dva parametry PSI,OMEGA)
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Konvekce: UPWIND (Zienkiewicz)
C Zdrojovy clen: prirozena konvekce
C Integrace v case: implicitni, 1.rad
C Rychlosti VX,VY nejsou uzlove parametry, ale parametry elementu
C (na rychlosti se nevztahuji pocatecni podminky)
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),
     /          AM(9,9),RM(9,9),CM(9,9),DM(9,9),BM(9,9),
     /          T(9),OMG(9),PSI(9),
     /          G1(16),G2(16),WT(16),F(9),FX(9),FY(9)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE PRENOSU, RM-MATICE HMOT, CM-MATICE VIRIVOSTI 
C DM-MATICE LAPLAC.OP.,BM-VZTLAK
C T,OMG-TEPLOTY,VIRIVOSTI Z PREDCHOZI ITERACE, 
C VX,VY-rychlosti proudeni
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE (FK derivace dle ksi)
C 
C Ze zony $FEM jsou vyuzivany i prvky 
C          IALGOR(2)-potlaceni vypoctu konvektivnich clenu
C          IALGOR(4)-potlaceni vypoctu zdroje tepla
C          IALGOR(5)-upwind
C
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS)
      H=RRCONS(LRCON,$H)

      IF(ICONTR.EQ.0)THEN
C 
C ICONTR=0 Vypocet proudove funkce a virivosti
C          
C Stanoveni uzlovych teplot T(*) a rychlosti VX(*),VY(*) z predchozich kroku.
C Identifikace uzlu elementu IBND(*), v nich je status teploty 
C             20 < IPU  . 
C Tento uzel je povazovan za uzel lezici na STENE, kde neni znama virivost.
C Dale je urcovan obdelnik ramujici dany element (Xmin,Xmax,Ymin,Ymax), 
C a pocita se vektor stredni rychlosti proudeni VX,VY. Tyto hodnoty
C budou vyuzity pro vypocet Pecletova cisla elementu.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))
        T(IU)=VAL(LPU($TEMP)+IND,3)
        OMG(IU)=VAL(LPU($OMG)+IND,3)
      ENDDO
      VX=EPAR(IE,LEPAR(NAMELE,$EVX))
      VY=EPAR(IE,LEPAR(NAMELE,$EVY))
      DX=XMAX-XMIN
      DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VX*DX+VY*DY
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VX**2+VY**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2)
      ENDIF
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Isoparametric 4 or 8-node element.
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C
C NULOVANI MATIC PRENOSU A HMOTNOSTI A ZDROJOVYCH CLENU - rozmer NUE
      AM=0
      RM=0
      DM=0
      CM=0
      BM=0
C
C SESTAVENI MATICE AM(vazke sily a konvekce),RM(hmotnosti), vektor BM
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
         DETWT=DET*WT(IG)
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C
         TEMP=0
         RR=0
         XGA=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            RR=RR+Y(I)*F(I)
            XGA=XGA+X(I)*F(I)
         ENDDO
C MPROP  (3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RHO=RMPROP(LPROP,$RHO)
         VISC=RMPROP(LPROP,$VISC)
         BETA=RMPROP(LPROP,$BETA)
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$BETA).NE.0)
     /                           BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
         IF(JMPROP(LPROP,$VISC).NE.0)
     /                           VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
         CALL PARTMOD2(XGA,RR,VISC,RHO,CP,RKX,RKAPPA)
         AOPT=0
C Vypocet REYNOLDSOVA cisla jen pro pripad uvazovani konvekce (IALGOR(2)) 
C a nastaveni upwindu (IALGOR(5))
         IF($ICONV.NE.0.AND.$IUPW.NE.0)THEN
C Soucinitel upwind ALF jako funkce REYNOLDSOVA cisla elementu
            PE=UMEAN*HMEAN*RHO/(2*VISC)
            IF(PE.GT.0.1)THEN
               PE=AMIN1(PE,50.)
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient zadavany uzivatelem RALGOR(5)=$RUPW
               AOPT=ALF*$RUPW*HMEAN/(2*UMEAN)
            ELSE
               AOPT=0
            ENDIF
         ENDIF
C SESTAVENI
         DO I=1,NUE
            IF(NAXIS.EQ.1)THEN
                ASYM=AOPT*(VX*FX(I)+VY*FY(I)-VY*F(I)/RR)
            ELSE
                ASYM=AOPT*(VX*FX(I)+VY*FY(I))
            ENDIF
            DO J=1,NUE
C Matice M
              RM(I,J)=RM(I,J)+RHO*F(I)*F(J)*DETWT
              CM(I,J)=CM(I,J)+F(I)*F(J)*DETWT
              IF(NAXIS.EQ.1)THEN
C Cylindricky souradny system
C Matice A
                  CONV=RHO*(F(I)+ASYM)*(VX*FX(J)+VY*FY(J)-VY*F(J)/RR)
                  DA=CONV+VISC*(FX(I)*FX(J)+FY(I)*FY(J)+F(J)*FY(I)/RR)
                  DM(I,J)=DM(I,J)+(FX(I)*FX(J)+FY(I)*FY(J))/RR*DETWT
               ELSE
C kartezsky souradny system
                  CONV=RHO*(F(I)+ASYM)*(VX*FX(J)+VY*FY(J))
                  DA=CONV+VISC*(FX(I)*FX(J)+FY(I)*FY(J))
                  DM(I,J)=DM(I,J)+(FX(I)*FX(J)+FY(I)*FY(J))*DETWT
               ENDIF
               AM(I,J)=AM(I,J)+DA*DETWT
C Vektor B $RGX,GZ jsou slozky zrychleni 
               BM(I,J)=BM(I,J)+CONV*BETA*($RGY*FX(J)-$RGX*FY(J))*DETWT
            ENDDO
         ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]] ma rozmer NL = 2 x NUE
C Usporadani parametru OMG1 PS1 OMG2 PS2 ...
C     DTIME je systemova promenna COMMON /FEM/...
C
      AL=0
      BL=0
      DO I=1,NUE
        IF(NONST.EQ.1)THEN
C Nestacionarni pripad
           DO J=1,NUE
             BL(2*I)=BL(2*I)+(RM(I,J)-AM(I,J)*DTIME*(1-$RTHETA))
     /                 *OMG(J)+BM(I,J)*T(J)*DTIME
             AL(2*I,2*J-1)=RM(I,J)+AM(I,J)*DTIME*$RTHETA
             AL(2*I-1,2*J-1)=CM(I,J)
             AL(2*I-1,2*J)=DM(I,J)
           ENDDO
        ELSE
C Stacionarni pripad
           DO J=1,NUE
             BL(2*I)=BL(2*I)+BM(I,J)*T(J)
             AL(2*I,2*J-1)=AM(I,J)
             AL(2*I-1,2*J-1)=CM(I,J)
             AL(2*I-1,2*J)=DM(I,J)
           ENDDO
        ENDIF
      ENDDO
      ELSE
C
C ICONTR=1 Postprocessing - vypocet rychlosti z proudove funkce do zony elementu
C ------------------------
         L0=LUE(IE)
         DO IU=1,NUE
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           PSI(IU)=VAL(LPU($PS)+IND,2)
         ENDDO        
         LEGRP=MAX0(1,IGROUP(IE))
         NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
         NAXIS=JGROUP(LEGRP,$AXIS)
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
           CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
         ELSE
C Isoparametric 4 or 8-node element.
           CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
         ENDIF
C Vypocet stredni rychlosti VX a VY integraci pres element
         AREA=0
         VX=0
         VY=0
         DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
            IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
                 CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
            ELSE
                 CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
            ENDIF
            DETWT=DET*WT(IG)
            RR=0
            VXI=0
            VYI=0
            DO I=1,NUE
               VXI=VXI+FY(I)*PSI(I)
               VYI=VYI-FX(I)*PSI(I)
               RR=RR+Y(I)*F(I)
            ENDDO
            IF(NAXIS.EQ.1)THEN
               VXI=VXI/RR
               VYI=VYI/RR
            ENDIF
            VX=VX+VXI*DETWT
            VY=VY+VYI*DETWT
            AREA=AREA+DETWT
         ENDDO
         LEX=MAX0(1,LEPAR(NAMELE,$EVX))
         LEY=MAX0(1,LEPAR(NAMELE,$EVY))
         EPAR(IE,LEX)=VX/AREA
         EPAR(IE,LEY)=VY/AREA
         KEPAR(NAMELE,LEX)=1
         KEPAR(NAMELE,LEY)=1
      ENDIF
      END

      SUBROUTINE PENS(ICONTR,IE,NL,NUE,AL,BL)
C
C NAVIER STOKESOVY ROVNICE - UPWIND PENALTY METHOD (uzlove prametry Vx,Vy)
C OPTIONS:  PLANE/AXISYM,  STEADY/TRANSIENT
C Elementy: T3,T6,Q4,Q8 (v kazdem uzlu dva parametry VX,VY)
C Gaussova integrace T:1,3,4,7 Q:1,2,3
C Konvekce: UPWIND (Zienkiewicz)
C Zdrojovy clen: prirozena konvekce
C Integrace v case: implicitni, 1.rad
C
      INCLUDE '$FEMEQ'
      DIMENSION X(9),Y(9),AL(NL,NL),BL(NL),
     /          AMX(9,9),AMY(9,9),RM(9,9),PMX(9,9),PMY(9,9),
     /          BMX(9),BMY(9),
     /          T(9),VX(9),VY(9),VXOLD(9),VYOLD(9),
     /          G1(16),G2(16),WT(16),F(9),FX(9),FY(9)
C
C AL-MATICE SOUSTAVY, BL-VEKTOR PRAVE STRANY
C AM-MATICE PRENOSU, RM-MATICE HMOT, PM-NAHRADA GRAD.TLAKU
C BM-VZTLAK
C T -TEPLOTY Z PREDCHOZI ITERACE, 
C VX,VY-rychlosti proudeni
C G -GAUSSOVY UZLY PRO 4-UHELNIK, G1,G2-GAUSSOVY UZLY PRO TROJUHELNIK
C W -VAHY GAUS.UZLU PRO 4-UHELNIK, WT-VAHY GAUS. UZLU PRO TROJUHELNIK
C F,FX,FY-BAZOVE FUNKCE A JEJICH DERIVACE (FK derivace dle ksi)
C 
C Ze zony $FEM jsou vyuzivany i prvky 
C          IALGOR(2)-potlaceni vypoctu konvektivnich clenu
C          IALGOR(4)-potlaceni vypoctu zdroje tepla
C          IALGOR(5)-upwind
C
C Pocitadlo zpracovavanych elementu
C     ICOUNTS=ICOUNTS+1
C EGROUP,MPROP,RRCONS
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP (1-TRANSIENT|STATIC,2-NGAUS,3-PLANE/AXISYM)
      NAMELE=JGROUP(LEGRP,$ENAME)
      NONST=JGROUP(LEGRP,$ST)
      NGAUS=MAX0(1,JGROUP(LEGRP,$GAUSS))
      NAXIS=JGROUP(LEGRP,$AXIS)
C RRCONS (1-THICKNESS)
      H=RRCONS(LRCON,$H)

      IF(ICONTR.EQ.0)THEN
C          
C Stanoveni uzlovych teplot T(*) a rychlosti VX(*),VY(*) z predchozich kroku.
C
      XMIN=1E10
      XMAX=-1E10
      YMIN=1E10
      YMAX=-1E10
      VXM=0
      VYM=0
      L0=LUE(IE)
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        XMIN=AMIN1(XMIN,X(IU))
        XMAX=AMAX1(XMAX,X(IU))
        YMIN=AMIN1(YMIN,Y(IU))
        YMAX=AMAX1(YMAX,Y(IU))
        T(IU)=VAL(LPU($TEMP)+IND,3)
        VX(IU)=VAL(LPU($VX)+IND,4)
        VXOLD(IU)=VAL(LPU($VX)+IND,3)
        VY(IU)=VAL(LPU($VY)+IND,4)
        VYOLD(IU)=VAL(LPU($VY)+IND,3)
        VXM=VXM+VX(IU)
        VYM=VYM+VY(IU)
      ENDDO
      VXM=VXM/NUE
      VYM=VYM/NUE
      DX=XMAX-XMIN
      DY=YMAX-YMIN
C Skalarni soucin rychlosti a "uhlopricky"
      HV=VXM*DX+VYM*DY
C CHARAKTERISTICKY ROZMER ELEMENTU A CHARAKTERISTICKA RYCHLOST
      UMEAN=SQRT(VXM**2+VYM**2)
      IF(UMEAN.GT.0.)THEN
         HMEAN=HV/UMEAN
      ELSE
         HMEAN=SQRT(DX**2+DY**2)
      ENDIF
C 
C Vypocet uzlu Gaussovy integrace zvlast pro trojuhelniky a ctyruhelniky
C ---------------------------------------------------------------------
      IF(NUE.EQ.3.OR.NUE.EQ.6)THEN
C trojuhelnikove elementy
        CALL TGAUS(NGAUS,NGSS,G1,G2,WT)
      ELSE
C Isoparametric 4 or 8-node element.
        CALL QGAUS(NGAUS,NGSS,G1,G2,WT)
      ENDIF
C ---------------konec sekce vypoctu souradnic integracnich bodu
C $RGX,$RGY jsou slozky zrychleni 
C $RPENFAKT    penalizacni faktor
C
C NULOVANI MATIC PRENOSU A HMOTNOSTI A ZDROJOVYCH CLENU - rozmer NUE
      AMX=0
      AMY=0
      RM=0
      PMX=0
      PMY=0                                 
      BM=0
C
C SESTAVENI MATICE AM(vazke sily a konvekce),RM(hmotnosti), vektor BM
      DO IG=1,NGSS
C Bazove funkce F(i) a jejich derivace v integracnim bode IG
         IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
              CALL FDFT(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ELSE
              CALL FDFQ(NUE,X,Y,G1(IG),G2(IG),F,FX,FY,DET)
         ENDIF
         DETWT=DET*WT(IG)
C--------------------------------------------------------
C Bazove funkce F(i) umoznuji vypocitat teplotu v uzlu (z vektoru TM) 
C a pro tuto teplotu pak vypocitat termofyzikalni parametry 
C
         TEMP=0
         VVX=0
         VVY=0
         RR=0
         XGA=0
         DO I=1,NUE
            TEMP=TEMP+F(I)*T(I)
            RR=RR+Y(I)*F(I)
            XGA=XGA+X(I)*F(I)
            VVX=VVX+VX(I)*F(I)
            VVY=VVY+VY(I)*F(I)
         ENDDO
C MPROP  (3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         RHO=RMPROP(LPROP,$RHO)
         VISC=RMPROP(LPROP,$VISC)
         BETA=RMPROP(LPROP,$BETA)
         IF(JMPROP(LPROP,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(LPROP,$RHO))
         IF(JMPROP(LPROP,$BETA).NE.0)
     /                           BETA=BETA*CURFUN(JMPROP(LPROP,$BETA))
         IF(JMPROP(LPROP,$VISC).NE.0)THEN
C Vypocet invariantu rychlosti deformace jen v pripade, 
C ze je uvazovana promenna viskozita
            DVXDX=0
            DVYDY=0
            DVXDY=0
            DVYDX=0
            DO I=1,NUE
               DVXDX=DVXDX+VX(I)*FX(I)
               DVYDY=DVYDY+VY(I)*FY(I)
               DVXDY=DVXDY+VX(I)*FY(I)
               DVYDX=DVYDX+VY(I)*FX(I)
            ENDDO
C Druhy invariant je AUX(5)
            SINV=DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
            VISC=VISC*CURFUN(JMPROP(LPROP,7))
         ENDIF
         CALL PARTMOD2(XGA,RR,VISC,RHO,CP,RKX,RKAPPA)
         AOPT=0
C Vypocet REYNOLDSOVA cisla jen pro pripad uvazovani konvekce (IALGOR(2)) 
C a nastaveni upwindu (IALGOR(5))
         IF($ICONV.NE.0.AND.$IUPW.NE.0)THEN
C Soucinitel upwind ALF jako funkce REYNOLDSOVA cisla elementu
            PE=UMEAN*HMEAN*RHO/(2*VISC)
            IF(PE.GT.0.1)THEN
               PE=AMIN1(PE,50.)
               EE=EXP(PE)
               ALF=(EE+1./EE)/(EE-1./EE)-1./PE
C Korekcni koeficient zadavany uzivatelem RALGOR(5)=$RUPW
               AOPT=ALF*$RUPW*HMEAN/(2*UMEAN)
            ELSE
               AOPT=0
            ENDIF
         ENDIF
C SESTAVENI
         DO I=1,NUE
            ASYM=AOPT*(VVX*FX(I)+VVY*FY(I))
C               BMX(I)=BMX(I)+(F(I)+ASYM)*RHO*BETA*$RGX*(1-BETA*TEMP)*DETWT
C               BMY(I)=BMY(I)+(F(I)+ASYM)*RHO*BETA*$RGY*(1-BETA*TEMP)*DETWT
            BMX(I)=BMX(I)-(F(I)+ASYM)*RHO*BETA*$RGX*(TEMP-$TREF)*DETWT
            BMY(I)=BMY(I)-(F(I)+ASYM)*RHO*BETA*$RGY*(TEMP-$TREF)*DETWT
            DO J=1,NUE
C Matice M
              RM(I,J)=RM(I,J)+RHO*F(I)*F(J)*DETWT
              CONV=RHO*(F(I)+ASYM)*(VVX*FX(J)+VVY*FY(J))
              IF(NAXIS.EQ.1)THEN
C Cylindricky souradny system
C Matice A,P
                  DAX=CONV+VISC*(FY(I)*FY(J)-F(I)*FY(J)/RR)+
     /                     (VISC+$RPENFAKT)*FX(I)*FX(J)
                  DAY=CONV+(VISC+$RPENFAKT)*(FY(I)*FY(J)+F(J)*FY(I)/RR)+
     /                     VISC*FX(I)*FX(J)
                  DPX=$RPENFAKT*(FX(I)*FY(J)+F(J)*FX(I)/RR)
                  DPY=$RPENFAKT*FX(I)*FY(J)
               
C kartezsky souradny system
              ELSE
                IF($INSGAP.NE.0)THEN  
                  GAP=CONV*F(J)*12*VISC/H**2/RHO
                  DAX=CONV+VISC*FY(I)*FY(J)+
     /                     (VISC+$RPENFAKT)*FX(I)*FX(J)+GAP
                  DAY=CONV+(VISC+$RPENFAKT)*FY(I)*FY(J)+
     /                     VISC*FX(I)*FX(J)+GAP
                  ELSE
                  DAX=CONV+VISC*FY(I)*FY(J)+
     /                     (VISC+$RPENFAKT)*FX(I)*FX(J)
                  DAY=CONV+(VISC+$RPENFAKT)*FY(I)*FY(J)+
     /                     VISC*FX(I)*FX(J)
                  DPX=$RPENFAKT*0.5*(FX(I)*FY(J)+FY(I)*FX(J))
                  DPY=DPX
                 ENDIF
               ENDIF
               AMX(I,J)=AMX(I,J)+DAX*DETWT
               AMY(I,J)=AMY(I,J)+DAY*DETWT
               PMX(I,J)=PMX(I,J)+DPX*DETWT
               PMY(I,J)=PMY(I,J)+DPY*DETWT
            ENDDO
         ENDDO
      ENDDO
C
C MATICE SOUSTAVY  [[AL]] ma rozmer NL = 2 x NUE
C
C     DTIME je systemova promenna COMMON /FEM/...
C
      AL=0
      BL=0
      DO I=1,NUE
        IF(NONST.EQ.1)THEN
C Nestacionarni pripad
           BL(2*I-1)=BMX(I)*DTIME
           BL(2*I)=BMY(I)*DTIME
           DO J=1,NUE
             BL(2*I-1)=BL(2*I-1)+RM(I,J)*VXOLD(J)
             BL(2*I)=BL(2*I)+RM(I,J)*VYOLD(J)
             AL(2*I-1,2*J-1)=RM(I,J)+AMX(I,J)*DTIME
             AL(2*I,2*J)=RM(I,J)+AMY(I,J)*DTIME
             AL(2*I-1,2*J)=PMX(I,J)*DTIME
             AL(2*I,2*J-1)=PMY(I,J)*DTIME
           ENDDO
        ELSE
C Stacionarni
           BL(2*I-1)=BMX(I)
           BL(2*I)=BMY(I)
           DO J=1,NUE
             AL(2*I-1,2*J-1)=AMX(I,J)
             AL(2*I,2*J)=AMY(I,J)
             AL(2*I-1,2*J)=PMX(I,J)
             AL(2*I,2*J-1)=PMY(I,J)
           ENDDO
        ENDIF
      ENDDO

      ELSEIF(ICONTR.GT.0)THEN
C
C Postprocessing - vypocet invariantu, hustoty dissipovane energie a vykonu
C
        L0=LUE(IE)
        DO IU=1,NUE
           IND=IABS(IUE(L0+IU))
           X(IU)=XX(IND)
           Y(IU)=YY(IND)
           T(IU)=VAL(LPU($TEMP)+IND,3)
           VX(IU)=VAL(LPU($VX)+IND,2)
           VY(IU)=VAL(LPU($VY)+IND,2)
        ENDDO
C 1.POINT GAUSS
        IF(NUE.EQ.3.OR.NUE.EQ.6)THEN 
           CALL FDFT(NUE,X,Y,.33333,.33333,F,FX,FY,DET)
        ELSE
           CALL FDFQ(NUE,X,Y,0.,0.,F,FX,FY,DET)
           DET=DET*4
        ENDIF
        VYM=0
        DVXDX=0
        DVXDY=0
        DVYDX=0
        DVYDY=0
        TEMP=0
        R=0
        DO I=1,NUE
           VYM=VYM+F(I)*VY(I)
           DVXDX=DVXDX+VX(I)*FX(I)
           DVXDY=DVXDY+VX(I)*FY(I)
           DVYDX=DVYDX+VY(I)*FX(I)
           DVYDY=DVYDY+VY(I)*FY(I)
           TEMP=TEMP+T(I)*F(I)
           R=R+Y(I)*F(I)
        ENDDO
        IF(NAXIS.EQ.0)THEN
C Kartezsky souradny system
C DRUHY INVARIANT 
           EPAR(IE,LEPAR(NAMELE,$EII))=
     /              DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2
C DISSIPACE
           SINV=EPAR(IE,LEPAR(NAMELE,$EII))
           VISC=RMPROP(LPROP,$VISC)
           IF(JMPROP(LPROP,$VISC).NE.0)
     /                        VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
           DISS=2*VISC*SINV
           EPAR(IE,LEPAR(NAMELE,$EDISS))=DISS
C DISSIPOVANY VYKON
           EPAR(IE,LEPAR(NAMELE,$EPOWER))=DISS*DET
         ELSE
C CYLINDRICKY SOURADNY SYSTEM
C DRUHY INVARIANT 
           EPAR(IE,LEPAR(NAMELE,$EII))=
     /            DVXDX**2+DVYDY**2+0.5*(DVXDY+DVYDX)**2+(VYM/R)**2
C DISSIPACE
           SINV=EPAR(IE,LEPAR(NAMELE,$EII))
           VISC=RMPROP(LPROP,$VISC)
           IF(JMPROP(LPROP,$VISC).NE.0)
     /                  VISC=VISC*CURFUN(JMPROP(LPROP,$VISC))
           DISS=2*VISC*SINV
           EPAR(IE,LEPAR(NAMELE,$EDISS))=DISS
C DISSIPOVANY VYKON
           EPAR(IE,LEPAR(NAMELE,$EPOWER))=DISS*DET*R*6.282
         ENDIF
         $RPOWERF=$RPOWERF+EPAR(IE,LEPAR(NAMELE,$EPOWER))
      ENDIF
C ENDIF ICONTR 
      END




