C $S9 - beam, shellax, plane2d

      SUBROUTINE BEAM3(ICONTR,IE,NL,NUE,AL,BL)
C
C Nosnik 3D (elementy BEAM3D a PIPE3D)
C ICONTR=0 - LOKALNI MATICE TUHOSTI A VEKTOR SPOJITEHO ZATIZENI RCONST($PRES)
C ICONTR=1 - VYPOCET VNITRNICH SIL V TEZISTI ELEMENTU
C
      INCLUDE '$FEMB'
      DIMENSION AL(NL,NL),BL(NL),X(2),Y(2),Z(2),UX(2),UY(2),UZ(2),
     /          RX(2),RY(2),RZ(2),PP(2),
     /          Q(12,12),QT(12,12),WORK(12,12),T(2),FORCE(12),FF(12)
      L0=LUE(IE)
C
C UX UY UZ RX RY RZ PRES
C
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        Z(IU)=ZZ(IND)
        UX(IU)=VAL(LPU($UX)+IND,2)
        UY(IU)=VAL(LPU($UY)+IND,2)
        UZ(IU)=VAL(LPU($UZ)+IND,2)
        RX(IU)=VAL(LPU($RX)+IND,2)
        RY(IU)=VAL(LPU($RY)+IND,2)
        RZ(IU)=VAL(LPU($RZ)+IND,2)
        PP(IU)=VAL(LPU($PRES)+IND,3)
        T(IU)=VAL(LPU($TEMP)+IND,3)
      ENDDO
C RL-delka trubky  
      RL=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2+(Z(1)-Z(2))**2)
      IF(RL.LE.0.)THEN
        WRITE(2,*)' ERROR PIPE3D element',IE,' is of a zero length'
        RETURN
      ENDIF
C Matice rotace pocitana dle monografie
C Weaver W., Gear J.M.: Matrix analysis of framed structures, D.van Nostrand 1980
C str.258 a dalsi
      CX=(X(2)-X(1))/RL
      CY=(Y(2)-Y(1))/RL
      CZ=(Z(2)-Z(1))/RL
      CXZ=SQRT(CX**2+CZ**2)
C Matice rotace 12 X 12
      Q=0
      DO I=1,4
         I0=3*(I-1)
         IF(CXZ.NE.0.)THEN
           Q(I0+1,I0+1)=CX
           Q(I0+1,I0+2)=CY
           Q(I0+1,I0+3)=CZ
           Q(I0+2,I0+1)=-CX*CY/CXZ
           Q(I0+2,I0+2)=CXZ
           Q(I0+2,I0+3)=-CZ*CY/CXZ
           Q(I0+3,I0+3)=CX/CXZ
           Q(I0+3,I0+1)=-CZ/CXZ
         ELSE
           Q(I0+1,I0+2)=CY
           Q(I0+2,I0+1)=-CY
           Q(I0+3,I0+3)=1
         ENDIF
      ENDDO
C VLASTNOSTI
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
C MPROP  (1-K,2-C,3-RHO,KAPPA,E,MU)
      E=RMPROP(LPROP,$E)
      RMI=RMPROP(LPROP,$MI)
      G=E/(2*(1+RMI))
C Teplotni roztaznost materialu 
      ALEX=RMPROP(LPROP,$ALEX)
C Geometricke charakteristiky prurezu: 
C RRCONS (1-THICKNESS,2-DIAMETER,3-external PRESSure,6-AREA,11-JZ)
C RJZ=RJY moment setrvacnosti (OHYB). RJZ=PI*D^3*H/8
C RJX-polarni moment setrvacnosti - torzni konstanta (=PI*D^3*H/4)-trubka
C     pro plnou tyc RJX=pi*D^4/32, taumax=Mk.D/(2*RJX)
      H=RRCONS(LRCON,$H)
      D=RRCONS(LRCON,$D)
      IF(NAMELE.EQ.$PIPE3D)THEN
         IF(H.LE.1E-6)THEN
            WRITE(2,'('' ERROR wall thickness too small in el.'',i4)')IE
            H=0.001
         ENDIF
         IF(D.LE.1e-6)THEN
            WRITE(2,'('' ERROR diam.of pipe too small in el.'',i4)')IE
            D=0.001
         ENDIF
         AREA=3.14158*D*H
         RJZ=3.14159*((D+2*H)**4-D**4)/64.
         RJX=2*RJZ
      ELSE
C BEAM3D
         AREA=ABS(RRCONS(LRCON,$AREA))
         IF(AREA.LE.0.)THEN
           WRITE(2,'('' ERROR zero cross-section in element'',i4)')IE
           AREA=3.14158*D*H
         ENDIF
         RJZ=RRCONS(LRCON,$JZ)
         IF(RJZ.LE.1e-10) RJZ=3.14159*((D+2*H)**4-D**4)/64.
         RJX=2*RJZ
      ENDIF
      TE=RRCONS(LRCON,$TE)
      PLOAD=RRCONS(LRCON,$P)
C Vynulovani matice tuhosti i vnitrniho zatizeni
      AL=0
      FORCE=0
C Spojita zatizeni dilatace v lokalnim souradnem systemu
      FORCE(1)=ALEX*(T(1)-TE)*AREA*E
      FORCE(7)=-ALEX*(T(2)-TE)*AREA*E
C Kontrakce vyvolana pretlakem JEN U ELEMENTU PIPE
      IF(NAMELE.EQ.$PIPE3D.AND.H.GT.0.)THEN
        FORCE(1)=FORCE(1)-RMI*PP(1)*D*AREA/(2*H)
        FORCE(7)=FORCE(7)+RMI*PP(2)*D*AREA/(2*H)
      ENDIF
C Spojite vnejsi zatizeni kolme k ose nosniku se uvazuje jen u 2D
      FORCE(2)=-PLOAD*RL/2
      FORCE(8)=FORCE(2)
C
C Matice tuhosti v lokalnim S.S.
C 
      AEL=AREA*E/RL
      EJL=E*RJZ/RL
      EJL2=EJL/RL
      EJL3=EJL2/RL
      GJX=G*RJX/RL
C Horni trojuhelnik matice tuhosti
      AL(1,1)=AEL
      AL(1,7)=-AEL
      AL(2,2)=12*EJL3
      AL(2,6)=6*EJL2
      AL(2,8)=-12*EJL3
      AL(2,12)=6*EJL2
      AL(3,3)=12*EJL3
      AL(3,5)=-6*EJL2
      AL(3,9)=-12*EJL3
      AL(3,11)=-6*EJL2
      AL(4,4)=GJX
      AL(4,10)=-GJX
      AL(5,5)=4*EJL
      AL(5,9)=6*EJL2
      AL(5,11)=2*EJL
      AL(6,6)=4*EJL
      AL(6,8)=6*EJL2
      AL(6,12)=2*EJL
      AL(7,7)=AEL
      AL(8,8)=12*EJL3
      AL(8,12)=-6*EJL2
      AL(9,9)=12*EJL3
      AL(9,11)=6*EJL2
      AL(10,10)=GJX
      AL(11,11)=4*EJL
      AL(12,12)=4*EJL
C symetrie
      DO I=2,12
        DO J=1,I-1
          AL(I,J)=AL(J,I)
        ENDDO
      ENDDO
C Transformace do globalniho souradneho systemu
C Nasobeni zprava matici rotace Q
      CALL MULMAT(AL,Q,WORK,12,12,12)
      CALL TRANSP(Q,QT,12,12)
C Nasobeni zleva transponovanou matici Q
      CALL MULMAT(QT,WORK,AL,12,12,12)
      CALL MULMAT(QT,FORCE,BL,12,12,1)
      IF(ICONTR.EQ.0)RETURN
C Postprocessing - vypocet sil a momentu
C V tomto okamziku je matice WORK soucin LOKALNI matice tuhosti a Q
C vynasobenim vektorem zobecnenych posuvu ziskame vektor vnitrnich sil
      DO I=1,2
         I1=6*(I-1)
         BL(I1+1)=UX(I)
         BL(I1+2)=UY(I)
         BL(I1+3)=UZ(I)
         BL(I1+4)=Rx(I)
         BL(I1+5)=Ry(I)
         BL(I1+6)=RZ(I)
      ENDDO
C FLOKAL= KLOKAL * Q * UGLOBAL + FORCE(DILATACNI)
      CALL MULMAT(WORK,BL,FF,12,12,1)
      DO I=1,6
         FORCE(I)=FORCE(I)+FF(I)
      ENDDO
C FORCE 1-axialni, 2,3-pricne sily, 4,5-ohybove momenty, 6- kroutici moment
      FX=FORCE(1)
      FM=SQRT(FORCE(4)**2+FORCE(5)**2)
      FMX=FORCE(6)
      QZ=SQRT(FORCE(2)**2+FORCE(3)**2)
      EPAR(IE,LEPAR(NAMELE,$ENALFA))=FX
      EPAR(IE,LEPAR(NAMELE,$EMALFA))=FM
      EPAR(IE,LEPAR(NAMELE,$EMBETA))=FMX
      EPAR(IE,LEPAR(NAMELE,$EQZ))=QZ
      IF(NAMELE.EQ.$PIPE3D)THEN
         ARE=3.141*D*H
         TAUM=FMX*2/(3.141*D**2*H)
         TAUQ=QZ/ARE
         ST=(PP(1)+PP(2))*D/(4*H)
         SX=ABS(FM*D/(2*RJZ))+ABS(FX/ARE)
      WRITE(*,*)' TAUM,TAUQ,ST,SX',TAUM,TAUQ,ST,SX
         EPAR(IE,LEPAR(NAMELE,$ENBETA))=ST
C je treba opravit von Mises
         EPAR(IE,LEPAR(NAMELE,$EMISE))=SQRT(((ST-SX)**2+ST**2+SX**2+
     /6.*(TAUQ**2+TAUM**2))/2.)
         KEPAR(NAMELE,LEPAR(NAMELE,$ENBETA))=1
         KEPAR(NAMELE,LEPAR(NAMELE,$EMISE))=1
      ENDIF
      KEPAR(NAMELE,LEPAR(NAMELE,$ENALFA))=1
      KEPAR(NAMELE,LEPAR(NAMELE,$EMALFA))=1
      KEPAR(NAMELE,LEPAR(NAMELE,$EMBETA))=1
      KEPAR(NAMELE,LEPAR(NAMELE,$EQZ))=1
      END

      SUBROUTINE BEAM(ICONTR,IE,NL,NUE,AL,BL)
C
C Nosnik 2D (elementy BEAM2D a PIPE2D)
C ICONTR=0 - LOKALNI MATICE TUHOSTI A VEKTOR SPOJITEHO ZATIZENI RCONST($PRES)
C ICONTR=1 - VYPOCET VNITRNICH SIL V TEZISTI ELEMENTU
C
      INCLUDE '$FEMB'
      DIMENSION AL(NL,NL),BL(NL),X(2),Y(2),UX(2),UY(2),BETA(2),PP(2),
     /          Q(6,6),QT(6,6),WORK(6,6),T(2),FORCE(6),FF(6)
      WRITE(*,*)' BEAM 2D IE=',IE,' NL=',NL
      L0=LUE(IE)
C
C UX UY RZ PRES
C
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        Y(IU)=YY(IND)
        UX(IU)=VAL(LPU($UX)+IND,2)
        UY(IU)=VAL(LPU($UY)+IND,2)
        BETA(IU)=VAL(LPU($RZ)+IND,2)
        PP(IU)=VAL(LPU($PRES)+IND,3)
        T(IU)=VAL(LPU($TEMP)+IND,3)
      ENDDO
C RL-delka trubky  a cos, sin
      RL=SQRT((X(1)-X(2))**2+(Y(1)-Y(2))**2)
      IF(RL.LE.0.)THEN
        WRITE(2,*)' ERROR PIPE2D element',IE,' is of a zero length'
        RETURN
      ENDIF
      C=(X(2)-X(1))/RL
      S=(Y(2)-Y(1))/RL
C Matice rotace
      Q=0
      DO I=1,2
         I0=3*(I-1)
         Q(I0+1,I0+1)=C
         Q(I0+2,I0+2)=C
         Q(I0+3,I0+3)=1
         Q(I0+1,I0+2)=-S
         Q(I0+2,I0+1)=S
      ENDDO
C VLASTNOSTI
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
C MPROP  (1-K,2-C,3-RHO,KAPPA,E,MU)
      E=RMPROP(LPROP,$E)
      RMI=RMPROP(LPROP,$MI)
C Teplotni roztaznost materialu 
      ALEX=RMPROP(LPROP,$ALEX)
C RRCONS (1-THICKNESS,2-DIAMETER,3-external PRESSure,6-AREA,11-JZ)
      H=RRCONS(LRCON,$H)
      D=RRCONS(LRCON,$D)
      IF(NAMELE.EQ.$PIPE2D)THEN
         IF(H.LE.1E-6)THEN
            WRITE(2,'('' ERROR wall thickness too small in el.'',i4)')IE
            H=0.001
         ENDIF
         IF(D.LE.1e-6)THEN
            WRITE(2,'('' ERROR diam.of pipe too small in el.'',i4)')IE
            D=0.001
         ENDIF
         AREA=3.14158*D*H
         RJZ=3.14159*((D+2*H)**4-D**4)/64.
      ELSE
         AREA=ABS(RRCONS(LRCON,$AREA))
         IF(AREA.LE.0.)THEN
            WRITE(2,'('' ERROR zero cross-section in element'',i4)')IE
            AREA=3.14158*D*H
         ENDIF
         RJZ=RRCONS(LRCON,$JZ)
         IF(RJZ.LE.1e-10) RJZ=3.14159*((D+2*H)**4-D**4)/64.
      ENDIF
      TE=RRCONS(LRCON,$TE)
      PLOAD=RRCONS(LRCON,$P)
C Vynulovani matice tuhosti i vnitrniho zatizeni
      AL=0
      FORCE=0
      IF(NAMELE.EQ.$PUMP.OR.NAMELE.EQ.$CSTR)THEN
         IF(AREA.LE.0.)THEN
            IF(D.GT.0.)THEN
               AREA=3.141*D**2/4.
            ELSE
               AREA=RL**2
            ENDIF
         ENDIF
         IF(E.LE.0.)E=2E11
         IF(RJZ.LE.0.)RJZ=1.
         WRITE(2,'(10X,''PUMP-BEAM Area='',e10.3,'' E='',e10.3,'' Jz='',
     /e10.3)')AREA,E,RJZ
      ELSE
C Spojita zatizeni dilatace 
         FORCE(1)=ALEX*(T(1)-TE)*AREA*E
         FORCE(4)=-ALEX*(T(2)-TE)*AREA*E
C Kontrakce vyvolana pretlakem JEN U ELEMENTU PIPE
         IF(NAMELE.EQ.$PIPE2D.AND.H.GT.0.)THEN
            FORCE(1)=FORCE(1)-RMI*PP(1)*D*AREA/(2*H)
            FORCE(4)=FORCE(4)+RMI*PP(2)*D*AREA/(2*H)
         ENDIF
C Spojite vnejsi zatizeni kolme k ose nosniku (proti smeru osy y)
         FORCE(2)=-PLOAD*RL/2
         FORCE(5)=FORCE(2)
      ENDIF
C
C Matice tuhosti v lokalnim S.S.
C 
      AEL=AREA*E/RL
      EJL=E*RJZ/RL
      EJL2=EJL/RL
      EJL3=EJL2/RL
C Horni trojuhelnik matice tuhosti
      AL(1,1)=AEL
      AL(1,4)=-AEL
      AL(2,2)=12*EJL3
      AL(2,3)=6*EJL2
      AL(2,5)=-12*EJL3
      AL(2,6)=6*EJL2
      AL(3,3)=4*EJL
      AL(3,5)=-6*EJL2
      AL(3,6)=2*EJL
      AL(4,4)=AEL
      AL(5,5)=12*EJL3
      AL(5,6)=-6*EJL2
      AL(6,6)=4*EJL
C symetrie
      DO I=2,6
        DO J=1,I-1
          AL(I,J)=AL(J,I)
        ENDDO
      ENDDO
C Transformace do globalniho souradneho systemu
C Nasobeni zprava matici rotace Q
      CALL MULMAT(AL,Q,WORK,6,6,6)
      CALL TRANSP(Q,QT,6,6)
C Nasobeni zleva transponovanou matici Q
      CALL MULMAT(QT,WORK,AL,6,6,6)
      CALL MULMAT(QT,FORCE,BL,6,6,1)
      IF(ICONTR.EQ.0)RETURN
C Postprocessing - vypocet sil a momentu
C V tomto okamziku je matice WORK soucin LOKALNI matice tuhosti a Q
C vynasobenim vektorem zobecnenych posuvu ziskame vektor vnitrnich sil
      DO I=1,2
         I1=3*(I-1)
         BL(I1+1)=UX(I)
         BL(I1+2)=UY(I)
         BL(I1+3)=BETA(I)
      ENDDO
C FLOKAL= KLOKAL * Q * UGLOBAL + FORCE(DILATACNI)
      CALL MULMAT(WORK,BL,FF,6,6,1)
C FORCE(1)-osova sila, FORCE(2)-pricna sila, FORCE(3)-ohybovy moment
      DO I=1,3
         FORCE(I)=FORCE(I)+FF(I)
      ENDDO
      FX=FORCE(1)
      FM=FORCE(3)
      QZ=FORCE(2)
      WRITE(*,*)' BEFORE EPAR...'
      EPAR(IE,LEPAR(NAMELE,$ENALFA))=FX
      EPAR(IE,LEPAR(NAMELE,$EQZ))=QZ
      EPAR(IE,LEPAR(NAMELE,$EMALFA))=FM
      KEPAR(NAMELE,LEPAR(NAMELE,$ENALFA))=1
      KEPAR(NAMELE,LEPAR(NAMELE,$EQZ))=1
      KEPAR(NAMELE,LEPAR(NAMELE,$EMALFA))=1
      IF(NAMELE.EQ.$PIPE2D)THEN
         ARE=3.141*D*H
         TAUQ=FORCE(2)/ARE
         SX=ABS(FM*D/(2*RJZ))+ABS(FX/ARE)
         ST=(PP(1)+PP(2))*D/(4*H)
         EPAR(IE,LEPAR(NAMELE,$ENBETA))=ST
C je treba opravit von Mises
         EPAR(IE,LEPAR(NAMELE,$EMISE))=SQRT(((ST-SX)**2+ST**2+SX**2+
     /6.*TAUQ**2)/2.)
         KEPAR(NAMELE,LEPAR(NAMELE,$ENBETA))=1
         KEPAR(NAMELE,LEPAR(NAMELE,$EMISE))=1
      ENDIF
      END

      SUBROUTINE SHEL(ICONTR,IE,NL,NUE,AL,BL)
C
C ICONTR=0 - LOKALNI MATICE TUHOSTI A VEKTOR ZATIZENI TLAKEM
C ICONTR=1 - VYPOCET VNITRNICH SIL V TEZISTI ELEMENTU
C
      INCLUDE '$FEMB'
      DIMENSION AL(NL,NL),BL(NL),R(2),X(2),U(2),W(2),BETA(2)
      L0=LUE(IE)
C
C SOURADNICE  X-VODOROVNE OSA SYMETRIE, Y-POLOMER
C            
      DO IU=1,NUE
        IND=IABS(IUE(L0+IU))
        X(IU)=XX(IND)
        R(IU)=YY(IND)
        U(IU)=VAL(LPU($UX)+IND,2)
        W(IU)=VAL(LPU($UY)+IND,2)
        BETA(IU)=VAL(LPU($RZ)+IND,2)
      ENDDO
C VLASTNOSTI
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
C MPROP  (1-K,2-C,3-RHO,KAPPA,E,MU) A=K/(RHO*C)
      E=RMPROP(LPROP,$E)
      RMI=RMPROP(LPROP,$MI)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE)
      T=RRCONS(LRCON,$H)
      P=RRCONS(LRCON,$P)
C
      D11=E*T/(1-RMI**2)
      D22=D11
      D12=D11*RMI
      D33=D11*T**2/12
      D44=D33
      D34=D33*RMI
      D55=5*E*T/(12*(1+RMI))
      RL=SQRT((R(1)-R(2))**2+(X(1)-X(2))**2)
C-cos, S-sin uhlu mezi elementem a osou symetrie X
      C=(X(2)-X(1))/RL
      S=(R(2)-R(1))/RL
      RC=(R(1)+R(2))*.5
      IF(ICONTR.EQ.0)THEN
C
C FRONTALNI METODA
C
        S2=S**2
        C2=C**2
        RC4=4*RC**2
        AL(1,1)=RC*(D11*C2+D55*S2)/RL
        AL(4,4)=AL(1,1)
        AL(1,4)=-AL(1,1)
        AL(1,2)=C*RC*(S*(D11-D55)-RL*D12/(2*RC))/RL
        AL(2,4)=-AL(1,2)
        AL(4,5)=C*RC*(S*(D11-D55)+RL*D12/(2*RC))/RL
        AL(1,5)=-AL(4,5)
        AL(3,4)=RC*S/2*D55
        AL(1,6)=-AL(3,4)
        AL(1,3)=-AL(3,4)
        AL(4,6)=AL(3,4)
        AL(2,3)=RC*C/2*D55
        AL(5,6)=-AL(2,3)
        AL(3,5)=-AL(2,3)
        AL(2,6)=AL(2,3)
        H1=S*D34/RC
        H2=D33/RL+D55*RL/4+S2*RL*D44/RC4
        AL(3,3)=RC*(H2-H1)
        AL(6,6)=RC*(H2+H1)
        W1=(S2*D11+C2*D55)/RL
        W2=RL*D22/RC4
        AL(2,2)=RC*(W1+W2-S*D12/RC)
        AL(5,5)=RC*(W1+W2+S*D12/RC)
        AL(2,5)=RL*D22/(4*RC)-RC*W1
        AL(3,6)=RC*(-D33/RL+S2*RL*D44/RC4+D55*RL/4)
        DO1I=2,6
        DO1J=1,I-1
1       AL(I,J)=AL(J,I)
        PL8=P*RL/8
        BL(1)=-PL8*S*(3*R(1)+R(2))
        BL(2)= PL8*C*(3*R(1)+R(2))
        BL(3)=0
        BL(4)=-PL8*S*(R(1)+3*R(2))
        BL(5)= PL8*C*(R(1)+3*R(2))
        BL(6)=0
      ELSE
C
C VNITRNI SILY: U-POSUN X    W-POSUN R
C
        WM=U(2)-U(1)
        UM=W(2)-W(1)
        UP=W(1)+W(2)
        BM=BETA(2)-BETA(1)
        BP=BETA(1)+BETA(2)
        RN1=C*D11/RL*WM+S*D11/RL*UM+D12*UP/(2*RC)
        RN2=C*D12/RL*WM+S*D12/RL*UM+D22*UP/(2*RC)
        RM1=D33*BM/RL+S*D34*BP/(2*RC)
        RM2=D34/RL*BM+S*D33*BP/(2*RC)
        Q=S*D55*WM/RL+C*D55*UM/RL+D55*BP/2
        EPAR(IE,LEPAR(NAMELE,$ENALFA))=RN1
        EPAR(IE,LEPAR(NAMELE,$ENBETA))=RN2
        EPAR(IE,LEPAR(NAMELE,$EMALFA))=RM1
        EPAR(IE,LEPAR(NAMELE,$EMBETA))=RM2
        EPAR(IE,LEPAR(NAMELE,$EQZ))=Q
        KEPAR(NAMELE,LEPAR(NAMELE,$ENALFA))=1
        KEPAR(NAMELE,LEPAR(NAMELE,$ENBETA))=1
        KEPAR(NAMELE,LEPAR(NAMELE,$EMALFA))=1
        KEPAR(NAMELE,LEPAR(NAMELE,$EMBETA))=1
        KEPAR(NAMELE,LEPAR(NAMELE,$EQZ))=1
      ENDIF
      END

      SUBROUTINE MULMAT(A,B,C,M,N,K)
C vysledna matice C nesmi byt totozna s A nebo B
      DIMENSION A(M,N),B(N,K),C(M,K)
      DO IM=1,M
         DO IK=1,K
            S=0.
            DO IN=1,N
               S=S+A(IM,IN)*B(IN,IK)
            ENDDO
            C(IM,IK)=S
         ENDDO
      ENDDO
      END

      SUBROUTINE TRANSP(A,B,M,N)
C Matice nesmi byt totozne
      DIMENSION A(M,N),B(N,M)
      DO IM=1,M
        DO IN=1,N
           B(IN,IM)=A(IM,IN)
        ENDDO        
      ENDDO
      END


      SUBROUTINE PLANE2(ICONTR,IE,NL,NUE,A,B)
      INCLUDE '$FEMB'
C Input: IE-index of element, NL-dimension, NUE-number of nodes
      DIMENSION A(NL,NL),B(NL),EPS(3),D(3,3),SIGMA(3),
     / X(8),Y(8),G(2),W(2),F(8),FX(8),FY(8),U(8),V(8)
      DATA G,W,NGAUS/-.57735,.57735,
     /1.,1.,2/
C
C Nodal values
C
      L0=LUE(IE)
      DO IU=1,NUE
         IND=IABS(IUE(L0+IU))
         X(IU)=XX(IND)
         Y(IU)=YY(IND)
         U(IU)=VAL(LPU($UX)+IND,2)
         V(IU)=VAL(LPU($UY)+IND,2)
      ENDDO
C VLASTNOSTI
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
C EGROUP
      ISTRESS=JGROUP(LEGRP,$STRESS)
      NAMELE =JGROUP(LEGRP,$ENAME)
C MPROP  (1-K,2-C,3-RHO,KAPPA,E,MU) A=K/(RHO*C)
      E=RMPROP(LPROP,$E)
      RMI=RMPROP(LPROP,$MI)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE)
      T=RRCONS(LRCON,$H)
C
      IF(ISTRESS.EQ.0)THEN
C ROVINNA NAPJATOST
        E11=E/(1-RMI**2)
        D12=RMI
        D33=(1-RMI)/2.
      ELSEIF(ISTRESS.EQ.1)THEN
C ROVINNA DEFORMACE
        E11=E*(1-RMI)/((1+RMI)*(1-2*RMI))
        D12=RMI/(1-RMI)
        D33=(1-2*RMI)/(2*(1-RMI))
      ELSE
        RETURN
      ENDIF
C Matice elastickych konstant
      D=0
      D(1,1)=E11
      D(2,2)=E11
      D(1,2)=E11*D12
      D(2,1)=D(1,2)
      D(3,3)=E11*D33
      IF(ICONTR.EQ.0)THEN
        DO I=1,NL
          DO J=1,NL
            A(I,J)=0.
          ENDDO
          B(I)=0
        ENDDO
C
C ASSEMBLY

        IF(NUE.EQ.3)THEN
C triangular element (S2 is twice the triangle area)
           S2=X(2)*Y(3)-X(3)*Y(2)-X(1)*Y(3)+X(3)*Y(1)+
     /        X(1)*Y(2)-X(2)*Y(1)
           E1=S2/2.*E11
           DO I=1,3
             I1=MOD(I,3)+1
             I2=MOD(I1,3)+1
             FX(I)=(Y(I1)-Y(I2))/S2
             FY(I)=(X(I2)-X(I1))/S2
           ENDDO
           DO I=1,3
            DO J=1,3
              A(2*I-1,2*J-1)=E1*(FX(I)*FX(J)+D33*FY(I)*FY(J))   
              A(2*I,2*J)=E1*(FY(I)*FY(J)+D33*FX(I)*FX(J))   
              A(2*I,2*J-1)=E1*(D12*FY(I)*FX(J)+D33*FX(I)*FY(J))   
              A(2*I-1,2*J)=E1*(D12*FX(I)*FY(J)+D33*FY(I)*FX(J))
            ENDDO
           ENDDO
         ELSEIF(NUE.EQ.4.OR.NUE.EQ.8)THEN
C Isoparametric 4 or 8-node element. Gaussian integration 2 x 2
           DO IG=1,NGAUS
            DO JG=1,NGAUS
             CALL FDFQ(NUE,X,Y,G(IG),G(JG),F,FX,FY,DET)
             E1=DET*W(IG)*W(JG)*E11
             DO I=1,NUE
              I1=2*I-1
              I2=2*I
              DO J=1,NUE
                J1=2*J-1
                J2=2*J
                A(I1,J1)=A(I1,J1)+E1*(FX(I)*FX(J)+D33*FY(I)*FY(J))   
                A(I2,J2)=A(I2,J2)+E1*(FY(I)*FY(J)+D33*FX(I)*FX(J))   
                A(I2,J1)=A(I2,J1)+E1*(D12*FY(I)*FX(J)+D33*FX(I)*FY(J))   
                A(I1,J2)=A(I1,J2)+E1*(D12*FX(I)*FY(J)+D33*FY(I)*FX(J))
              ENDDO
             ENDDO
            ENDDO
           ENDDO
         ENDIF
      ELSE
C Post processing - vypocet deformaci a napeti
        EPS=0
        IF(NUE.EQ.3)THEN
C triangular element (S2 is twice the triangle area)
           S2=X(2)*Y(3)-X(3)*Y(2)-X(1)*Y(3)+X(3)*Y(1)+
     /        X(1)*Y(2)-X(2)*Y(1)
           DO I=1,3
             I1=MOD(I,3)+1
             I2=MOD(I1,3)+1
             FX(I)=(Y(I1)-Y(I2))/S2
             FY(I)=(X(I2)-X(I1))/S2
           ENDDO
           DO I=1,NUE
              I1=2*I-1
              EPS(1)=EPS(1)+FX(I)*B(I1)
              EPS(2)=EPS(2)+FY(I)*B(I1+1)
              EPS(3)=EPS(3)+FY(I)*B(I1)+FX(I)*B(I1+1)
           ENDDO
         ELSEIF(NUE.EQ.4.OR.NUE.EQ.8)THEN
C Isoparametric 4 or 8-node element. 
           DO IG=1,NGAUS
             DO JG=1,NGAUS
               CALL FDFQ(NUE,X,Y,G(IG),G(JG),F,FX,FY,DET)
c               E1=DET*W(IG)*W(JG)
               DO I=1,NUE
                 I1=2*I-1
                 EPS(1)=EPS(1)+FX(I)*B(I1)
                 EPS(2)=EPS(2)+FY(I)*B(I1+1)
                 EPS(3)=EPS(3)+(FY(I)*B(I1)+FX(I)*B(I1+1))
               ENDDO
             ENDDO
           ENDDO
         ENDIF
C Vypocet napeti
         CALL MULMAT(D,EPS,SIGMA,3,3,1)
         EPAR(IE,LEPAR(NAMELE,$ESXX))=SIGMA(1)
         EPAR(IE,LEPAR(NAMELE,$ESYY))=SIGMA(2)
         EPAR(IE,LEPAR(NAMELE,$ESXY))=SIGMA(3)
      VMIS=(SIGMA(1)-SIGMA(2))**2+SIGMA(2)**2+SIGMA(1)**2+6*SIGMA(3)**2
         EPAR(IE,LEPAR(NAMELE,$EMISE))=SQRT(VMIS)/3
         KEPAR(NAMELE,LEPAR(NAMELE,$ESXX))=1
         KEPAR(NAMELE,LEPAR(NAMELE,$ESYY))=1
         KEPAR(NAMELE,LEPAR(NAMELE,$ESXY))=1
         KEPAR(NAMELE,LEPAR(NAMELE,$EMISE))=1
      ENDIF
      END

      SUBROUTINE TRUSS2D(ICONTR,IE,NL,NUE,A,B)
      INCLUDE '$FEMB'
C Input: IE-index of element, NL-dimension, NUE-number of nodes
      DIMENSION A(NL,NL),B(NL)
      REAL*8 X(2),Y(2),U(2),V(2),DX,DY,DUX,DUY,H,H2,HN
C
C Nodal values
C
      L0=LUE(IE)
      DO IU=1,NUE
         IND=IABS(IUE(L0+IU))
         X(IU)=XX(IND)
         Y(IU)=YY(IND)
         U(IU)=VAL(LPU($UX)+IND,4)
         V(IU)=VAL(LPU($UY)+IND,4)
      ENDDO
      DX=X(2)-X(1)
      DY=Y(2)-Y(1)
      H2=DX**2+DY**2
      H=SQRT(H2)
C VLASTNOSTI
      LEGRP=MAX0(1,IGROUP(IE))
      LPROP=MAX0(1,IMPROP(IE))
      LRCON=MAX0(1,IRCONS(IE))
      NAMELE=JGROUP(LEGRP,$ENAME)
C MPROP  (1-K,2-C,3-RHO,KAPPA,E,MU) A=K/(RHO*C)
      E=RMPROP(LPROP,$E)
      RMI=RMPROP(LPROP,$MI)
C RRCONS (1-THICKNESS,2-DIAMETER,3-PRESSURE)
      T=RRCONS(LRCON,$H)
      AREA=ABS(RRCONS(LRCON,$AREA))
      IF(AREA.LE.0.)THEN
        D=RRCONS(LRCON,$D)
        AREA=3.14159*D**2/4.
      ENDIF
      DUX=U(2)-U(1)
      DUY=V(2)-V(1)
      HN=DSQRT((DX+DUX)**2+(DY+DUY)**2)
      EX=(DX+DUX)/HN
      EY=(DY+DUY)/HN
      DXDY=(DX*DUX+DY*DUY)/H2
      AX=(DX+DUX/2.-DXDY*DX/2.)/H2
      AY=(DY+DUY/2.-DXDY*DY/2.)/H2
      AXEX=AX*EX*AREA*E
      AYEY=AY*EY*AREA*E
      AXEY=AX*EY*AREA*E
      AYEX=AY*EX*AREA*E

C
      IF(ICONTR.EQ.0)THEN
        DO I=1,4
          B(I)=0
        ENDDO
        A(1,1)=AXEX
        A(3,3)=AXEX
        A(2,2)=AYEY
        A(4,4)=AYEY
        A(1,2)=AYEX
        A(1,3)=-AXEX
        A(1,4)=-AYEX
        A(2,1)=AXEY
        A(2,3)=-AXEY
        A(2,4)=-AYEY
        A(3,1)=-AXEX
        A(3,2)=-AYEX
        A(3,4)=AYEX
        A(4,1)=-AXEY
        A(4,2)=-AYEY
        A(4,3)=AXEY
      ELSE
C
C Postprocessing - vypocet napeti v prutech
        EPAR(IE,LEPAR(NAMELE,$ENALFA))=E*(HN-H)/H
        KEPAR(NAMELE,LEPAR(NAMELE,$ENALFA))=1
      ENDIF
      END
