      SUBROUTINE USER(ICNTR,IOPER,IE,NL,NUE,AL,BL)
C USER defined element matrix AL(NL,NL) and RHS bector BL(NL)
C
C Input parameters:
C ICNTR = -1  prefront (do nothing)
C       = 0   solution (form matrix AL and BL)
C       > 0   postprocessing
C IOPER =1 electric field
C       =2 flow field
C       =3 temperature field
C       =4,5,6 concentrations
C       =7 static analysis
C IE - index of element
C NL - dimension of AL and BL
C NUE- number of element nodes 
C
C Outputs parameters:
C AL(NL,NL),BL(NL) - element matrix and vector of internal loads
C                    if there are no loads (e.g. volumetric heat source)
C                    set the vector BL zero (BL=0.).
C
C When computing AL,BL you can use the following soubroutines
C
C    SUBROUTINE GETXYZ(IE,X,Y,Z)
C    DIMENSION X(*),Y(*),Z(*)    
C    
C    SUBROUTINE GETDOF(IE,IDOF,DOFV)
C    DIMENSION DOFV(*)
C       this subroutine gets nodal parameters from the zone of initial
C       conditions, IDOF=1 temperature, IDOF=8 Volts, IDOF=12 pressure,
C       IDOF=20 concentration
C
C    SUBROUTINE GETEPAR(IE,IST,IGAUS,IMETH,H,D,RKX,RCP,RHO,RKAPPA,VISC,RE,QFLOW,VX,VY)
C       this is a mix of some frequently used element prameters
C
      DIMENSION AL(NL,NL),BL(NL),X(20),Y(20),Z(20),DOF(20)
      NUEDUMMY=NUE
      IF(ICNTR.NE.0)RETURN
         CALL GETXYZ(IE,X,Y,Z)
         SELECT CASE(IOPER)
            CASE(1)
              CALL GETDOF(IE,8,DOF)
            CASE(2)
              CALL GETDOF(IE,12,DOF)
            CASE(3)
              CALL GETDOF(IE,1,DOF)
         END SELECT
         CALL GETEPAR(IE,IST,IGAUS,IMETH,H,D,RKX,RCP,RHO,RKAPPA,VISC,
     /                RE,QFLOW,VX,VY)
         AL=0.
         DO I=1,NL
            BL(I)=0.
            DO J=1,NL
C              AL(I,J)= tepeln kapacita hmotnho bodu
            ENDDO
         ENDDO

      END

