C $S4B-KLO.FOR
      SUBROUTINE  HSTUBE(IE,T,LRCON,LEGRP,F,W,AREA,ALPHA,nch)
      DIMENSION T(*),F(*),W(*),IEH(2),S(2),D(2)
      INCLUDE '$FEMB'
      REAL X8

C Kotlovy vymenik - SHELL and TUBE je definovan parametry
C INDEXY - 1 latka protekana mezitrubkovym prostorem 
C          2 latka protekana trubkovym prostorem,
C EGROUP   $fi=np - pocet prepazek, $GAUSS=mprop1, $AXIS=mprop2,
C          $ST=nch - pocet chodu v trubkovem prostoru,
C          $STRESS=nt - pocet rad trubek mezi seriznutim prepazek
C RCONST    $H=tlt  - tloustka trubky,
C           $D=dt2  - vnejsi prumer potrubi,
C           $P=alfat - uhel usporadani trubek,
C           $ALFA=rla - vodivost trubky
C           $AREA=DPS - nejvetsi prumer svazku trubek,
C           $PERIM=DP1 - vnitrni prumer plaste,
C           $PERMEAB=RLt - delka trubek
C           $ZETA=tp - roztec prepazek
C 		  $KN=sp - tloustka prepazky
C		  $CEN=hp - vyska prepazky
C		  $TE=rd1 - stredni absolutni drsnost steny trubky
C		  $DUDY=stp - vule mezi trubkou a prepazkou
C		  $JZ=spp - vule mezi plastem a prepazkou
C           $RA=tt - roztec trubek,
C

C EPAR      EPAR(IE,1)-Q1, EPAR(IE,2)-Q2, EPAR(IE,3)-V1, EPAR(IE,4)-V2
C           EPAR(IE,5)-RE1, EPAR(IE,6)-RE2

C Geometrie vymeniku	
         TLT=RRCONS(LRCON,$H)
         DT2=RRCONS(LRCON,$D)
         ALFAT=RRCONS(LRCON,$P)
         RLA=RRCONS(LRCON,$ALFA)
         DP1=RRCONS(LRCON,$PERIM)
         RLT=RRCONS(LRCON,$PERMEAB)
         XTP=RRCONS(LRCON,$ZETA)
         SP=RRCONS(LRCON,$KN)
         HP=RRCONS(LRCON,$CEN)
         RD1=RRCONS(LRCON,$TE)
         STP=RRCONS(LRCON,$DUDY)
         SPP=RRCONS(LRCON,$JZ)
         TT=RRCONS(LRCON,$RA)
         DPS=RRCONS(LRCON,$AREA)
         NP=JGROUP(LEGRP,$FI)
         NCH=JGROUP(LEGRP,$ST)
         NT=JGROUP(LEGRP,$STRESS)
         NPL=0

C Vypocet zakladnich geometrickych parametru
         XLTN=2*(RLT-XTP*(NP-1))		  
         DT1=DT2-2*TLT
         IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
           C1=0.866
         ELSE
           C1=1.
         ENDIF
         FIVSC=2*ACOSD(2/(DPS-DT2)*(HP-DP1/2))
         XNTV=(DPS-DT2)**2/8/TT**2/C1*(FIVSC*3.14159/180-SIND(FIVSC))
         NTV=NINT(XNTV)
         IF(NT.EQ.0)NT=3.14159*(DPS-DT2)**2/4/TT**2/C1
         S(2)=(3.14159*DT1**2.*NT)/(4.*NCH)
         TT1=2.*TT*SIND(ALFAT)
         TT2=TT*COSD(ALFAT)
         STS=DP1-DPS
         STT=TT-DT2
         IF(ALFAT.GT.25..AND.ALFAT.LT.35.)THEN
         SUMSTT=(DPS-DT2)/TT1*STT
         ELSEIF(ALFAT.GT.85..AND.ALFAT.LE.90.)THEN
           SUMSTT=(DPS-DT2)/TT1*STT
         ELSE
           SUMSTT=(DPS-DT2)/TT1*STT*2
         ENDIF
         S(1)=(STS+SUMSTT)*(XTP-SP)
         D(2)=DT1
         D(1)=3.14159*DT2/2.
         
C AREA - teplosmenna plocha
         
         AREA=nt*3.14159*dt2*RLt*nch
C Materialove vlastnosti proudu	
         IEH(1)=JGROUP(LEGRP,$GAUSS)
         IEH(2)=JGROUP(LEGRP,$AXIS)
         IF(IEH(1).LE.0.OR.IEH(2).LE.0)THEN
            WRITE(2,*)' STUB: Zero index of material properties in 
     /STUB'
            STOP
         ENDIF
         DO K=1,2
C EPAR        EPAR(IE,1)-Q1, EPAR(IE,2)-Q2, EPAR(IE,3)-V1, EPAR(IE,4)-V2
C             EPAR(IE,5)-RE1, EPAR(IE,6)-RE2, EPAR(IE,7)-F1, EPAR(IE,8)-F2
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
           IG=IEH(K)
           RK  =RMPROP(IG,$KX)
           RHO =RMPROP(IG,$RHO)
           CP  =RMPROP(IG,$CP)
C Stredni teplota pro korekce termofyzikalnich vlastnosti
           TEMP=(T(1)+T(2)+T(3)+T(4))/4.
           IF(JMPROP(IG,$KX).NE.0)RK =RK *CURFUN(JMPROP(IG,$KX))
           IF(JMPROP(IG,$CP).NE.0)CP =CP *CURFUN(JMPROP(IG,$CP))
           IF(JMPROP(IG,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(IG,$RHO))
           VISC=RMPROP(IG,$VISC)
C Vypocet Re
           Q=EPAR(IE,K)
           RE=ABS(EPAR(IE,K+2))
           PR=VISC*CP/RK  
   
C Trubkovy prostor - NUSELTOVO CISLO
           IF(K.EQ.1)THEN
             IF(RE.LE.2320.)THEN
                Y1=DT1/RLT
                Y2=1.
                RNU=(0.19*(RE*PR*Y1)**0.8/(1.+0.117*(RE*PR*Y1)**0.467)
     /+3.65)*Y2
                IF((RE*PR*Y1).GE.10000.OR.(RE*PR*Y1).LE.0.1)
     /             WRITE(2,*)'HSTUBE:NENI SPLNENA PODMINKA PRO VYPOCET
     /NUSELTOVA CISLA V LAMINARNI TOKU TRUBKOVYM PROSTOREM'
             ELSE
                X5=1./8.*(1.82*LOG10(RE)-1.64)**(-2.)
                Y1=dt1/RLt
                Y2=1.
                RNU=X5*(RE-1000.)*PR/(1.+12.7*X5**0.5*(PR**0.666-1))*
     /(1+Y1**0.666)*Y2
                IF(RE.GT.10E6.OR.PR.LT.0.6.OR.PR.GT.2000.OR.Y1.GT.1.)
     /              WRITE(2,*)'HSTUBE:NENI SPLNENA PODMINKA PRO VYPOCET
     /NUSELTOVA CISLA V TURBULENTNIM TOKU TRUBKOVYM PROSTOREM'
             ENDIF

C  Mezitrubkov prostor - NUSELTOVO CISLO		 
           ELSE
             RNULAM=0.664*RE**0.5*PR**0.333
             RNUTURB=0.037*RE**0.8*PR/(1.+2.443*RE**(-0.1)*
     /(PR**0.666-1))
             Y2=1.
             X6=tt1/dt2
             X7=tt2/dt2
             IF(X7.GE.1.)THEN
               XKSI=1.-3.14159/4./X6
             ELSE
               XKSI=1.-3.14159/4./X6/X7
             ENDIF
             IF(ALFAT.GT.85..AND.ALFAT.LE.90.)THEN
               Y3=1.+0.7*(X7/X6-0.3)/XKSI**1.5/(X7/X6+0.7)**2.
             ELSEIF(ALFAT.GT.90.)THEN
               WRITE(*,*)'HSTUBE: ERROR INPUT - ANGLE OF TUBES LAYOUT' 
               STOP
             ELSE
               Y3=1.+2./3./X7
             ENDIF
             NRP=(2*HP-DP1)/TT2
             NRC=NRP*(NP-1)
             Y4M=1.51/NRC**0.18
             IF(RE.LE.20.)THEN
                Y4=Y4M
             ELSEIF(RE.GT.20..AND.RE.LT.100.)THEN
                Y4=Y4M+(20-RE)/80*(Y4M-1)
             ELSE
                Y4=1.
             ENDIF
             IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
               C1=0.866
             ELSE
               C1=1.
             ENDIF
             X8=1.*NTV/(1.*NT)
             IF(XTP/DP1.LT.0.2.AND.XTP/DP1.GT.1..OR.X8.GT.0.8)THEN
                WRITE(2,*)'HSTUBE:NEJSOU SPLNEY PODMINKY PRO POUZITI
     /VZTAHU PRO Y5'
               Y5=1.
             ELSE
               Y5=1.-X8+0.524*X8**0.32
             ENDIF
             DT2P=DT2+2*STP
             STPP=(NT-NTV/2.)*3.14159*(DT2P**2.-DT2**2.)/4.
             FIVP=2*ACOSD(2.*HP/DP1-1.)
             DPP=DP1-2*SPP
             SPS=3.14159/4.*(DP1**2-DPP**2)*(360.-FIVP)/360.
             IF((STPP+SPS)/S(1).LE.0.8)THEN
               Y6=0.4*STPP/(STPP+SPS)+(1.-0.4*STPP/(STPP+SPS))*EXP(-1.5*
     /(STPP+SPS)/S(1))
             ELSE
               WRITE(*,*)'HSTUBE:NEJSOU SPLNENY PODMINKY PRO POUZITI
     / VZTAHU PRO Y6'
               Y6=1.
             ENDIF
             IF(RE.LT.100.)THEN
               C1Z=1.5
             ELSE
               C1Z=1.35
             ENDIF
             SSS=(DP1-DPS-STT)*(XTP-SP)
             IF(NPL.GE.NRP/2.OR.STT.GE.(DP1-DPS))THEN
               Y7=1.
             ELSEIF(SSS/S(1).LE.0.5)THEN
               WRITE(2,*)'HSTUBE:NEJSOU SPLNEY PODMINKY PRO POUZITI
     /VZTAHU PRO Y7'
               Y7=1.
             ELSE
               Y7=EXP(-C1Z*SSS/S(1)*(1.-(2.*NPL/NRP)**(1./3.)))
             ENDIF
             IF(RE.LE.100.)THEN
               AX=0.33
             ELSE
               AX=0.6
             ENDIF
             Y8=((NP-1)+2*(XLTN/2/XTP)**(1-AX))/((NP-1)+XLTN/XTP)
             IF(RE.LT.10..OR.RE.GT.10E6.OR.PR.LT.0.6.OR.PR.GT.1000..OR.
     /NRC.LT.10)THEN
                WRITE(2,*)'HSTUBE:NENI SPLNENA PODMINKA PRO VYPOCET
     /PRESNEHO NUSELTOVA CISLA V MEZITRUBKOVEM PROSTORU'
             RNU=(0.3+(RNULAM**2+RNUTURB**2)**0.5)*Y2*Y3*Y4
	       ELSE
	          RNU=(0.3+(RNULAM**2+RNUTURB**2)**0.5)*Y2*Y3*Y4
     /*Y5*Y6*Y7*Y8
             ENDIF
           ENDIF

C Tepelny odpor resp prevracena hodnota souc. prestupu tepla
           F(K)=D(3-K)/(RNU*RK)*(DT2/DT1)**(2-K)

C Tepelna kapacita proudu
           W(K)=EPAR(IE,K)*RHO*CP
         ENDDO
C Prevracena hodnota tepelneho odporu materialu trubky
         ALPHA=2*RLA/DT2*1/LOG(DT2/DT1)
      END

      SUBROUTINE  HSTH(IE,T,LRCON,LEGRP,F,W,AREA,ALPHA,NCH)
      DIMENSION T(*),F(*),W(*),IEH(2),S(2),D(2)
      INCLUDE '$FEMB'
C Kotlovy vymenik - SHELL and TUBE se sroubovymi prepazkami
C INDEXY - 1 latka protekana mezitrubkovym prostorem 
C          2 latka protekana trubkovym prostorem,
C EGROUP   $fi=np - pocet prepazek, $GAUSS=mprop1, $AXIS=mprop2,
C          $ST=nch - pocet chodu v trubkovem prostoru,
C          $STRESS=nt - pocet rad trubek mezi seriznutim prepazek
C 		 $HEAT=npl - pocet paru tesnicich list
C RCONST    $H=tlt  - tloustka trubky,
C           $D=dt2  - vnejsi prumer potrubi,
C           $P=alfat - uhel usporadani trubek,
C           $ALFA=rla - vodivost trubky
C           $AREA=DPS - nejvetsi prumer svazku trubek,
C           $PERIM=DP1 - vnitrni prumer plaste,
C           $RA=RLt - delka trubek
C           $ZETA=DMT - PRUMER STREDOVE TRUBKY
C 		  $KN=sp - tloustka prepazky
C		  $CEN=fis - UHEL STOUPANI
C		  $TE=rd1 - stredni absolutni drsnost steny trubky
C		  $DUDY=stp - vule mezi trubkou a prepazkou
C		  $JZ=spp - vule mezi plastem a prepazkou
C		  $VOL=xltn - delka neprepazkovane trubky
C           $TT=tt - roztec trubek,
C              
C EPAR      EPAR(IE,1)-Q1, EPAR(IE,2)-Q2, EPAR(IE,3)-V1, EPAR(IE,4)-V2
C           EPAR(IE,5)-RE1, EPAR(IE,6)-RE2

C Geometrie vymeniku	
      TLT=RRCONS(LRCON,$H)
      DT2=RRCONS(LRCON,$D)
      ALFAT=RRCONS(LRCON,$P)
      RLA=RRCONS(LRCON,$ALFA)
      DP1=RRCONS(LRCON,$PERIM)
      RLT=RRCONS(LRCON,$RA)
      XLT0=RRCONS(LRCON,$ZETA)
      SP=RRCONS(LRCON,$KN)
      FIS=RRCONS(LRCON,$CEN)
      RD1=RRCONS(LRCON,$TE)
      STP=RRCONS(LRCON,$DUDY)
      SPP=RRCONS(LRCON,$JZ)
      XLTN=RRCONS(LRCON,$VOL)
      TT=RRCONS(LRCON,$PERMEAB)
      DPS=RRCONS(LRCON,$AREA)
      NP=JGROUP(LEGRP,$FI)
      NCH=JGROUP(LEGRP,$ST)
      NT=JGROUP(LEGRP,$STRESS)
      NPL=JGROUP(LEGRP,$HEAT)
      DMT=RRCONS(LRCON,$TE)
      HS=3.14159*DP1*TAND(FIS)
      DT1=DT2-2*TLT
      IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
          C1=0.866
      ELSE
          C1=1.
      ENDIF
      IF(NT.LE.0)THEN
	  NT=3.14159*(DPS-DT2)**2/4/TT**2/C1
      ENDIF
      S(2)=(3.14159*DT1**2.*NT)/(4.*NCH)
      IF(ALFAT.GT.25..AND.ALFAT.LE.35.)THEN
          C2=0.866
      ELSEIF(ALFAT.GT.50..AND.ALFAT.LE.70.)THEN
          C2=0.866
      ELSE
          C2=0.707
      ENDIF
      IF(DMT.EQ.0)THEN
          S(1)=((DP1-DPS)/2+(DPS-DT2)*(1+1/C2)*(TT-DT2)/4/TT)*
     /(HS-SP/COSD(FIS))
      ELSE
          S(1)=((DP1-DPS)/2+(DPS-DMT-2*DT2)*(1+1/C2)*(TT-DT2)/4/TT)*
     /(HS-SP/COSD(FIS))
      ENDIF
      D(2)=DT1
      D(1)=3.14159*DT2/2.

C AREA - teplosmenna plocha jedne desky 
      AREA=NT*3.14159*DT2*RLT
      IEH(1)=JGROUP(LEGRP,$GAUSS)
      IEH(2)=JGROUP(LEGRP,$AXIS)
      IF(IEH(1).LE.0.OR.IEH(2).LE.0)THEN
         WRITE(2,*)' STUB: Zero index of material properties in     
     /STUB'
         STOP
      ENDIF

      DO K=1,2
C EPAR        EPAR(IE,1)-Q1, EPAR(IE,2)-Q2, EPAR(IE,3)-V1, EPAR(IE,4)-V2
C             EPAR(IE,5)-RE1, EPAR(IE,6)-RE2, EPAR(IE,7)-F1, EPAR(IE,8)-F2
C MPROP  (1-K,2-C,3-RHO,4-KAPPA,5-E,6-MU,7-VISC,8-BETA) 
         IG=IEH(K)
         RK  =RMPROP(IG,$KX)
         RHO =RMPROP(IG,$RHO)
         CP  =RMPROP(IG,$CP)
C Stredni teplota pro korekce termofyzikalnich vlastnosti
         TEMP=(T(1)+T(2)+T(3)+T(4))/4.
         IF(JMPROP(IG,$KX).NE.0)RK =RK *CURFUN(JMPROP(IG,$KX))
         IF(JMPROP(IG,$CP).NE.0)CP =CP *CURFUN(JMPROP(IG,$CP))
         IF(JMPROP(IG,$RHO).NE.0)RHO=RHO*CURFUN(JMPROP(IG,$RHO))
         VISC=RMPROP(IG,$VISC)
C Vypocet Re
         Q=EPAR(IE,K)
         RE=ABS(EPAR(IE,K+2))
         PR=VISC*CP/RK       
C Trubkovy prostor - NUSELTOVO CISLO		 
	 IF(K.EQ.1)THEN
           IF(RE.LE.2320.)THEN
              Y1=dt1/RLt
              Y2=1.
              RNU=(0.19*(RE*PR*Y1)**0.8/(1.+0.117*(RE*PR*Y1)**0.467)
     /+3.65)*Y2
              IF((RE*PR*Y1).GE.10000.OR.(RE*PR*Y1).LE.0.1)THEN
	           WRITE(2,*)'HSTUBE:NENI SPLNENA PODMINKA PRO VYPOCET
     /NUSELTOVA CISLA V LAMINARNI TOKU TRUBKOVYM PROSTOREM'
              ENDIF
	   ELSE
              X5=1/8*(1.82*LOG10(RE)-1.64)**(-2)
              Y1=dt1/RLt
              Y2=1.
	      RNU=X5*(RE-1000.)*PR/(1.+12.7*X5**0.5*(PR**0.666-1))*
     /(1+Y1**0.666)*Y2
	      IF(RE.GT.10E6.OR.PR.LT.0.6.OR.PR.GT.2000.OR.Y1.GT.1.)THEN
	           WRITE(2,*)'HSTUBE:NENI SPLNENA PODMINKA PRO VYPOCET
     /NUSELTOVA CISLA V TURBULENTNIM TOKU TRUBKOVYM PROSTOREM'
              ENDIF
	   ENDIF

C  Mezitrubkov prostor - NUSELTOVO CISLO		 
	 ELSE
           RNULAM=0.664*RE**0.5*PR**0.333
	   RNUTURB=0.037*RE**0.7*PR/(1+2.443*RE**(-0.1)*
     /(PR**(2/3)-1))
	   Y2=1.
           IF(ALFAT.LT.35..AND.ALFAT.GT.25.)THEN
              TT2=0.683*TT
           ELSEIF(ALFAT.LT.65..AND.ALFAT.GT.55.)THEN
              TT2=0.683*TT
           ELSE
              TT2=0.854*TT
	   ENDIF  	    
           X7=TT2/DT2
           IF(ALFAT.GT.85.)THEN
               WRITE(*,*)'HSTH: ERROR INPUT - ANGLE OF TUBES LAYOUT' 
               STOP
           ELSE
	       Y3=1+2/3/X7
	   ENDIF
           IF(ALFAT.LT.35..AND.ALFAT.GT.25.)THEN
               IF(DMT.EQ.0)THEN
		   NRC=3.14159*DPS/1.366/TT*(XLT0/HS)
               ELSE
	           NRC=3.14159*(DPS+DMT)/2.732/TT*(XLT0/HS)
               ENDIF
            ELSEIF(ALFAT.LT.65..AND.ALFAT.GT.55.)THEN
               IF(DMT.EQ.0)THEN
                   NRC=3.14159*DPS/1.366/TT*(XLT0/HS)
	       ELSE
	           NRC=3.14159*(DPS+DMT)/2.732/TT*(XLT0/HS)
               ENDIF
            ELSE
               IF(DMT.EQ.0)THEN
		   NRC=3.14159*DPS/1.708/TT*(XLT0/HS)
               ELSE
	           NRC=3.14159*(DPS+DMT)/3.416/TT*(XLT0/HS)
               ENDIF
            ENDIF  	
            Y4M=1.51/NRC**0.18
            IF(RE.LE.20.)THEN
               Y4=Y4M
            ELSEIF(RE.GT.20..AND.RE.LT.100.)THEN
	       Y4=Y4M+(20-RE)/80*(Y4M-1)
	    ELSE
	       Y4=1.
	    ENDIF
            IF(RE.LT.100.)THEN
               C1Z=1.5
            ELSE
               C1Z=1.35
            ENDIF
            STT=TT-DT2
            STS=DP1-DPS
            IF(ALFAT.LT.35..AND.ALFAT.GT.25.)THEN
               IF(DMT.EQ.0)THEN
		   SUMSTT=1.0774/TT*(DPS-DT2)*STT
		   SZ=0.5*(STS+SUMSTT)*(HS-SP/COSD(FIS))
               ELSE
                   SUMSTT=1.0774/TT*(DPS-DMT-2*DT2)*STT
		   SZ=0.5*(STS+SUMSTT)*(HS-SP/COSD(FIS))	           
	       ENDIF
	    ELSEIF(ALFAT.LT.65..AND.ALFAT.GT.55.)THEN
               IF(DMT.EQ.0)THEN
		   SUMSTT=1.0774/TT*(DPS-DT2)*STT
		   SZ=0.5*(STS+SUMSTT)*(HS-SP/COSD(FIS))
	       ELSE
	           SUMSTT=1.0774/TT*(DPS-DMT-2*DT2)*STT
		   SZ=0.5*(STS+SUMSTT)*(HS-SP/COSD(FIS))
	       ENDIF
	    ELSE
	       IF(DMT.EQ.0)THEN
		   SUMSTT=1.2071/TT*(DPS-DT2)*STT
		   SZ=0.5*(STS+SUMSTT)*(HS-SP/COSD(FIS))
	       ELSE
	           SUMSTT=1.2071/TT*(DPS-DMT-2*DT2)*STT
		   SZ=0.5*(STS+SUMSTT)*(HS-SP/COSD(FIS))
	       ENDIF
            ENDIF  
            SSS=0.5*(DP1-DPS-STT)*(HS-SP/COSD(FIS))
            IF(NPL.GE.(DP1/6/TT).OR.STT.GE.(DP1-DPS))THEN
	       Y7=1.
            ELSE
	       Y7=EXP(-C1Z*SSS/SZ)*(1.-(2.*NPL**3*TT/3.14159/DP1)
     /**(1./3.))
	    ENDIF
            IF(SSS/S(1).LE.0.5)THEN
	         WRITE(2,*)'HSTUBE:NEJSOU SPLNEY PODMINKY PRO POUZITI
     /VZTAHU PRO Y7'
	         Y7=1.
	    ENDIF
            IF(RE.LE.100.)THEN
	         AX=0.33
            ELSE
	         AX=0.6
            ENDIF
            Y8=(XLT0/HS+2*((RLT-XLT0)/2/HS)**(1-AX))/(RLT/HS)
            Y9=0.974+0.004415*FIS-0.0001786*FIS**2
            IF(RE.LE.100.)THEN
	         Y10=1.
            ELSEIF(RE.GE.5000)THEN
	         Y10=1+0.6726*EXP(-0.01443*(FIS-42.59)**2)
            ELSE
	         ZX=1+0.6726*EXP(-0.01443*(FIS-42.59)**2)
			 Y10=(ZX-1)/4900*(RE-100)+1
            ENDIF
            IF(RE.LT.10..OR.RE.GT.10E6.OR.PR.LT.0.6.OR.PR.GT.1000..OR.
     /FIS.LT.5..OR.FIS.GT.45.)THEN
	         WRITE(2,*)'HSTUBE:NENI SPLNENA PODMINKA PRO VYPOCET
     /NUSELTOVA CISLA V MEZITRUBKOVEM PROSTORU'
            ENDIF  
            RNU=0.62*(0.3+(RNULAM**2+RNUTURB**2)**0.5)*Y2*Y3*Y4*Y7*Y8*
     /Y9*Y10
          ENDIF
          F(K)=D(K)/(RNU*RK)*(DT2/DT1)**(K-1)
          W(K)=Q*RHO*CP
         ENDDO
         ALPHA=2*RLA/DT2*1/LOG(DT2/DT1)
      END