@echo off
rem Visual Fortran environment variable batch file
rem
set DF_TOOLS=MSVC
set CPU=i386
if "%PROCESSOR_ARCHITECTURE%"=="ALPHA" set CPU=ALPHA
rem
rem Root of Developer Studio installed files
rem
set MSDevDir=d:\cf\common\Msdev98
set ToolsDir=d:\cf\common\Tools

rem
rem Root of Visual Fortran installed files
rem
set DFDir=d:\cf\df98
set VCDir=d:\cf\vc98
rem
rem Root of Array Visualizer installed files
rem
set AVDir=
rem
rem Root of IMSL installed files
rem
set IMSLNT_F90=

rem
rem Root of Visual Fortran files on CD-ROM
rem NOTE: Comment out the following lines if you do not want to
rem       include the CD-ROM in the environment
rem
rem if exist F:\X86\DF\BIN\DECFOR90.EXE goto setcdrom
rem echo *** WARNING ***  Visual Fortran kit files are not in the expected
rem echo *** WARNING ***  location - F:\X86
:setcdrom
rem set DFcdrom=F:\X86

rem
rem OpSys is used to help create either a Windows 95 or
rem   Windows NT specific path
rem
if "%OS%" == "Windows_NT" goto setnt
set OpSys=WIN95
goto setenv

:setnt
set OpSys=WINNT

:setenv

rem
echo Setting environment for using Visual Fortran tools
rem

if "%DFcdrom%" == "" goto main
rem
rem Include CD-ROM files in the environment
rem
if "%OpSys%" == "WINNT" set PATH=%DFcdrom%\DF\BIN;%DFcdrom%\VC\BIN;%DFcdrom%\TOOLS;%DFcdrom%\TOOLS\%OpSys%;%PATH%
if "%OpSys%" == "WIN95" set PATH="%DFcdrom%\DF\BIN";"%DFcdrom%\VC\BIN";"%DFcdrom%\TOOLS";"%DFcdrom%\TOOLS\%OpSys%";"%PATH%"
set INCLUDE=%DFcdrom%\DF\INCLUDE;%DFcdrom%\VC\INCLUDE;%INCLUDE%
set LIB=%DFcdrom%\DF\LIB;%DFcdrom%\VC\LIB;%LIB%
if not exist %DFcdrom%\DF\IMSL\INCLUDE\IMSL.F90 goto notprocd
set INCLUDE=%DFcdrom%\DF\IMSL\INCLUDE;%INCLUDE%
set LIB=%DFcdrom%\DF\IMSL\LIB;%LIB%
set VNI_F90_MSG=%DFcdrom%\DF\IMSL\MESSAGE
set LINK_F90=imsl.lib imsls_err.lib imslmpistub.lib
:notprocd
set DFcdrom=

:main
if "%OpSys%" == "WINNT" set PATH=%MSDevDir%\BIN;%DFDir%\BIN;%VCDir%\BIN;%ToolsDir%;%ToolsDir%\%OpSys%;%PATH%
if "%OpSys%" == "WIN95" set PATH="%MSDevDir%\BIN";"%DFDir%\BIN";"%VCDir%\BIN";"%ToolsDir%";"%ToolsDir%\%OpSys%";"%PATH%"
set INCLUDE=%DFDir%\INCLUDE;%VCDir%\INCLUDE;%INCLUDE%
set LIB=%DFDir%\LIB;%VCDir%\LIB;%LIB%

if "%AVDir%" == "" goto setimsl
set INCLUDE=%AVDir%\INCLUDE;%INCLUDE%
set LIB=%AVDir%\LIB;%LIB%

:setimsl
if "%IMSLNT_F90%" == "" goto cleanup
set INCLUDE=%IMSLNT_F90%\INCLUDE;%INCLUDE%
set LIB=%IMSLNT_F90%\LIB;%LIB%
set VNI_F90_MSG=%IMSLNT_F90%\MESSAGE
set LINK_F90=

:cleanup
if exist %DFDir%\CXML\LIB\CXMLVARS.BAT call %DFDir%\CXML\LIB\CXMLVARS.BAT
set MSDevDir=
set ToolsDir=
set DFDir=
set VCDir=
set OpSys=

rem
rem Set FPS4 environment variables
rem
set FPS_PATH=D:\pf\BIN
set FPS_INCLUDE=D:\pf\INCLUDE
set FPS_LIB=D:\pf\LIB
