c   Linearni regrese
      PARAMETER (NCVM=10,NDM=5096)
      DIMENSION X(NDM),Y(NDM),SIG(NDM),COVAR(NCVM,NCVM)
      DIMENSION A(NCVM),LISTA(NCVM),AFUN(NCVM)
      EXTERNAL FUN
      LOGICAL DEFSIG

      OPEN(1,FILE='RANNREG.DAT')
      READ(1,*,END=1000,ERR=1000)MFIT,NDATA
      YMEAN=0
      DEFSIG=.TRUE.
      DO I=1,NDATA
         READ(1,*,END=1000,ERR=1000)IDUMMY,X(I),Y(I),SIG(I)
         YMEAN=YMEAN+Y(I)
         IF(SIG(I).GT.0.)DEFSIG=.FALSE.
      ENDDO
      IF(DEFSIG)SIG=1.
      CLOSE(1)
      MFIT=MFIT+1
      IF(NDATA.LE.MFIT.OR.MFIT.GT.NCVM)STOP
      YMEAN=YMEAN/NDATA
      MA=MFIT
      DO I=1,MFIT
        LISTA(I)=I
      ENDDO
      CALL LFIT(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,NCVM,CHISQ,FUN)
      Q=GAMMQ(0.5*(NDATA-MFIT),0.5*CHISQ)
C
      OPEN(1,FILE='RANNREG.OUT')
      WRITE(1,1)MFIT,(A(LISTA(I)),I=1,MFIT)
1     FORMAT(' LINEAR REGRESSION'/
     /       I3,' coeficients B0+B1.x+...'/10E12.4)
      SUMD=0
      SUMM=0
      YMI=1E10
      YMA=-1E10
      DO I=1,NDATA
         CALL FUN(X(I),AFUN,MA)
         S=0
         DO J=1,MA
           S=S+A(J)*AFUN(J)
         ENDDO
         SUMD=SUMD+(Y(I)-S)**2
         SUMM=SUMM+(Y(I)-YMEAN)**2
         YMI=AMIN1(YMI,Y(I))
         YMA=AMAX1(YMA,Y(I))
      ENDDO
      STDEV=SQRT(SUMD/(NDATA-MFIT))
      IF(SUMM.GT.0.)R=SQRT(AMAX1(0.,1-SUMD/SUMM))
      WRITE(1,2)NDATA,STDEV,R,CHISQ,Q
2     FORMAT(I5,' points Stdev=',e10.4,' R=',f6.4,' CHISQ=',E10.4,
     /' Probability=',E9.3/' Covariance matrix')
      DO I=1,MFIT
        WRITE(1,'(10E11.3)')(COVAR(I,J),J=1,MFIT)
      ENDDO
      WRITE(1,3)
3     FORMAT(' PREDICTION')
      DO I=1,NDATA
         CALL FUN(X(I),AFUN,MA)
         S=0
         DO J=1,MA
           S=S+A(J)*AFUN(J)
         ENDDO
         WRITE(1,'(3E12.4)')X(I),Y(I),S
      ENDDO
      WRITE(1,4)X(1),X(NDATA),YMI,YMA
4     FORMAT(' Range XMIN,XMAX, YMIN,YMAX'/4e11.3)
      XX=X(1)
      DX=(X(NDATA)-X(1))/199
      DO I=1,200
         CALL FUN(XX,AFUN,MA)
         S=0
         DO J=1,MA
           S=S+A(J)*AFUN(J)
         ENDDO
         WRITE(1,'(2E12.4)')XX,S
         XX=XX+DX
      ENDDO
1000  CLOSE(1)
      END

      SUBROUTINE FUN(X,A,M)
      DIMENSION A(1)
      A(1)=1
      DO I=2,M
        A(I)=A(I-1)*X
      ENDDO
      END

      SUBROUTINE LFIT(X,Y,SIG,NDATA,A,MA,LISTA,MFIT,COVAR,NCVM,
     /                CHISQ,FUNCS)
C Numerical recipes p.513
      PARAMETER (MMAX=50)
      DIMENSION X(NDATA),Y(NDATA),SIG(NDATA),A(MA),LISTA(MFIT),
     /          COVAR(NCVM,NCVM),BETA(MMAX), AFUNC(MMAX)
      KK=MFIT+1
      DO J=1,MA
         IHIT=0
         DO K=1,MFIT
            IF(LISTA(K).EQ.J)IHIT=IHIT+1
         ENDDO
         IF(IHIT.EQ.0)THEN
            LISTA(KK)=J
            KK=KK+1
         ELSEIF(IHIT.GT.1)THEN
            PAUSE 'Improper set in LISTA'
         ENDIF
      ENDDO
      IF(KK.NE.(MA+1))PAUSE' Improper set in LISTA'
      DO J=1,MFIT
         DO K=1,MFIT
            COVAR(J,K)=0.
         ENDDO
         BETA(J)=0.
      ENDDO
      DO I=1,NDATA
         CALL FUNCS(X(I),AFUNC,MA)
         YM=Y(I)
         IF(MFIT.LT.MA)THEN
             DO J=MFIT+1,MA
                YM=YM-A(LISTA(J))*AFUNC(LISTA(J))
             ENDDO
         ENDIF
         IF(SIG(I).LE.0.)THEN
            SIG2I=0.
         ELSE
            SIG2I=1./SIG(I)**2
         ENDIF
         DO J=1,MFIT
            WT=AFUNC(LISTA(J))*SIG2I
            DO K=1,J
               COVAR(J,K)=COVAR(J,K)+WT*AFUNC(LISTA(K))
            ENDDO
            BETA(J)=BETA(J)+YM*WT
         ENDDO
      ENDDO
      IF(MFIT.GT.1)THEN
         DO J=2,MFIT
            DO K=1,J-1
               COVAR(K,J)=COVAR(J,K)
            ENDDO
         ENDDO
      ENDIF
      CALL GAUSSJ(COVAR,MFIT,NCVM,BETA,1,1)
      DO J=1,MFIT
          A(LISTA(J))=BETA(J)
      ENDDO
      CHISQ=0
      DO I=1,NDATA
          CALL FUNCS(X(I),AFUNC,MA)
          SUM=0
          DO J=1,MA
             SUM=SUM+A(J)*AFUNC(J)
          ENDDO
          IF(SIG(I).GT.0.)CHISQ=CHISQ+((Y(I)-SUM)/SIG(I))**2
      ENDDO
      CALL COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      END

      SUBROUTINE COVSRT(COVAR,NCVM,MA,LISTA,MFIT)
      DIMENSION COVAR(NCVM,NCVM),LISTA(MFIT)
      DO J=1,MA-1
        DO I=J+1,MA
           COVAR(I,J)=0
        ENDDO
      ENDDO
      DO I=1,MFIT-1
         DO J=I+1,MFIT
            IF(LISTA(J).GT.LISTA(I))THEN
                COVAR(LISTA(J),LISTA(I))=COVAR(I,J)
            ELSE
                COVAR(LISTA(I),LISTA(J))=COVAR(I,J)
            ENDIF
         ENDDO
      ENDDO
      SWAP=COVAR(1,1)
      DO J=1,MA
         COVAR(1,J)=COVAR(J,J)
         COVAR(J,J)=0.
      ENDDO
      COVAR(LISTA(1),LISTA(1))=SWAP
      DO J=2,MFIT
         COVAR(LISTA(J),LISTA(J))=COVAR(1,J)
      ENDDO
      DO J=2,MA
         DO I=1,J-1
             COVAR(I,J)=COVAR(J,I)
         ENDDO
      ENDDO
      END

    