C  RUNFEMI.for 
C  FEM 2D + Integralni model WAFI. 
C  Vsechny tri faze peceni jsou resenim obycejnych diferencialnich rovnic pro teploty jednotlivych expandujicich elementu.
C  Expanze je resenim Poissonovy rovnice pro tlak (ale linearni-pro dane teploty, a konstantni tloustku sterbiny)
C          expanze site neznamena presitovani, nybrz jen zmenu souradnic uzlu (tim je expanze omezena).
C  Metodou siti se resi nestacionarni teplotni pole v deskach.
C
C  Procedury
C  MAIN - hlavni program, bez iteraci tlaku
C  FEL  - volani procedury vypoctu lokalnich matic
C  WDOF - definice uzlovych parametru (poze tlak)
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      INCLUDE '$FEMLOC'
	INCLUDE '$WGRID'
C
C WGRID - pravouhla mrizka pokryvajici oblast formy DIMXxDIMY
C
C	COMMON /WGRID/DIMX,DIMY,NDIMX,NDIMY,
C     /   WHG(100,100),IHG(100,100),TOW(100,100),
C     /   IRISE,TWMIN,TWMAX,HPLATE,QPLATE,ATOP,ASIDE,
C     /   RLSTEEL,RHSTEEL,CPSTEEL
	EXTERNAL WDOF,FEL
      INTEGER JDOFEPS(MAXDOF)
      LOGICAL PRESSED,OKEPS
      CHARACTER*1 C
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNFEMI read $RUNFEM.BIN successfully ['',a,'']'')')
     /problem
      WRITE(*,'('' You can quit computation by pressing any key...(time 
     /step will be completed).''/'' User variable DEBUG='',i2)')$DEBUG
C ITELIM-minimalni pocet rovnic pro eliminaci
      ITELIM=IALGOR(7)
      OPEN(2,FILE='$RUNFEM.OUT',ACCESS='APPEND')
C================================================
C WAFI TIME,NTSTEP,DTIME,IAPPENDCLEAR
C IAPPENDCLEAR = 0 otevreni noveho souboru a vynulovani zony EPA
C              = 1 otevreni noveho souboru, ale ponechani zony EPA
C              > 1 pokracovani do jiz otevreneho souboru a ponechani zony EPA
C
C FEM resi jen Poissonovu rovnici pro tlak elementy FLOW2D
C
C Parametry EGROUP, RCONST, MPROP
C LGROUP($FLOW2D)=$ENAME,$ST,$GAUSS,$AXIS,$STRESS,$HEAT,$HSINK,$NSOURCE,$NSINK,$DSOURCE,$DSINK,$ASOURCE,$ASINK
C LRCONS($FLOW2D)=$H,$ALFA,$TE,$DUDY,$KE,$UE
C LMPROP($FLOW2D)=$KX,$CP,$RHO,$KAPPA,$VISC,$BETA,$TM,$HM,$DN,$DD,$DA,$AN,$AD,$AA,$KAPPE,$KXE,$KY,$KZ
C
C Parametry elementu
C JEPAR($FLOW2D)=$EDISS,$ELAV,$EII,$EGTX,$EGTY,$EGTZ,$EVX,$EVY,$EVZ,$ESXX,$ESYY,$ESXY,$EMISE,$EFOUL,$EPOWER
C
C Uzlove parametry
C JPU(MDOF)=$TEMP,$PRES,$VOLT,$CN,$CD,$CA,$VX,$VY,$VZ,$UX,$UY,$RZ,$PS,$PSX,$PSY,$PSZ,$OMG,$HT


      TIME=RP(1)
      NTSTEP=IP(2)
      DTIME=RP(3)
	IAPPEND=IP(4)
	DIMX=RP(5)
      DIMY=RP(6)
C Parametry topne desky
	HPLATE=RP(7)
	QPLATE=RP(8)
	TWMIN=RP(9)
	TWMAX=RP(10)
	ATOP=RP(11)
	ASIDE=RP(12)
	NDIMX=IP(13)
	NDIMY=IP(14)
	RLSTEEL=40
	RHSTEEL=7700
	CPSTEEL=470
      WRITE(2,'(/'' RUNFEMI STARTS'',I4,'' TIME STEPS''/1X,50(''=''))')
     /  NTSTEP
	WRITE(2,500)DIMX,DIMY,HPLATE,RLSTEEL,RHSTEEL,CPSTEEL,QPLATE,TWMIN,
     /TWMAX,ASIDE,ATOP
500   FORMAT(/
     /' |------------------------------------------------------------|'/
     /' | Parameters of upper heating plate                          |'/
     /' |____________________________________________________________|'/
     /' | X-size [m] | Y-size [m]  |  H-plate below spiral [m]       |'/
     /' |',f12.3,   '|',f13.3,    '|',f15.4,      '                  |'/
     /' |____________________________________________________________|'/
     /' | Lambda [W/m^2K] | rho [kg/m^3]   |      cp [J/kg.K]        |'/
     /' |',f13.1,  '    |',f13.0,      '   |',f15.0,      '          |'/
     /' |____________________________________________________________|'/
     /' | Q-[W]    | T-min[C]| T-max[C]| k-side | k-top [W/m^2.K]    |'/
     /' |',f10.0, '|',f9.0, '|',f9.0, '|',f8.1,'|',f10.1, '          |'/
     /' |------------------------------------------------------------|')
      LPROP =MAX0(1,IMPROP(1))
      LRCON =MAX0(1,IRCONS(1))
      H   =RRCONS(LRCON,$H)
      VISC=RMPROP(LPROP,$VISC)
      RKX =RMPROP(LPROP,$KX)
      BETA=RMPROP(LPROP,$BETA)
      REVA=RMPROP(LPROP,$HM)
      CP=RMPROP(LPROP,$CP)
      PSI=RMPROP(LPROP,$DN)
      WRITE(2,510)H,VISC,RKX,CP,BETA,REVA,PSI
510   FORMAT(
     /' | Parameters of heated sample                                |'/
     /' |____________________________________________________________|'/
     /' | Thickness of sample [m]                                    |'/
     /' |',f12.4,   '                                                |'/
     /' |____________________________________________________________|'/
     /' | Viscosity [Pa.s] |    k [W/m.K]     |    cp [J/kg.K]       |'/
     /' |',f13.3,  '     |',f13.2,      '     |',f13.0,    '         |'/
     /' |____________________________________________________________|'/
     /' |  beta            |   H-evap [J/kg]  |      PSI             |'/
     /' |',e16.3,       '  |',e16.3,       '  | ',e12.3,   '         |'/
     /' |____________________________________________________________|')


C Pri prvnim pouziti otevreni souboru PROBLEM.OUT a PROBLEM.TEP
      IF(IAPPEND.LE.1)THEN
C UNIT 3 - stupne volnosti
         CLOSE(3)
         WRITE(*,'(/'' Open file ['',A,''.OUT] for resulting DOFs'')')
     /             TRIM(PROBLEM)
         OPEN(3,FILE=TRIM(PROBLEM)//'.OUT')
         WRITE(3,'('' SOLVE '',A,'' ND='',I6)')PROBLEM,ND
         WRITE(3,'(E10.3,F15.3,'' (time, dtime) INITIAL'')')TIME,DTIME
C Nazvy pouzitych velicin - hlavicka tabulky
         WRITE(3,'(6X,20(7X,A4))')(TDOF(JPU(J)),J=1,MDOF)
         DO I=1,ND
           WRITE(3,'(I6,20E11.3)')I,(VAL((J-1)*MAXND+I,3),J=1,MDOF)
         ENDDO
C UNIT 4 - parametry elementu
         CLOSE(4)
         WRITE(*,'(/'' Open file ['',A,''.TEP] for resulting EPAram'')')
     /             TRIM(PROBLEM)
         OPEN(4,FILE=TRIM(PROBLEM)//'.TEP')
         WRITE(4,'('' SOLVE '',A,'' NE='',I6)')PROBLEM,NE
         NDOF=1
         JDOF(1)=$PRES
         CALL COPY(3,4)
C IAPPEND=0 Vynulovani pracovni zony elementu EPAR 
         IF(IAPPEND.EQ.0)THEN
            WRITE(*,'(/'' Clear'',i3,'' columns of EPAR'')')MAXEPAR
            KEPAR=0
            DO IE=1,NE
              IG=IGROUP(IE)
              IF(IG.GT.0.AND.IG.LE.MAXMGROUP)THEN
                 NAMELE=JGROUP(IG,$ENAME)
                 DO I1=1,NEPAR(NAMELE)
                     EPAR(IE,I1)=0.
                 ENDDO
              ENDIF
            ENDDO

C        Vynulovani pomocne site stenove vrstvy a uzlovych parametru UX,UY,VX,VY
C        Nastaveni vychozi teploty desek
            CALL WALLINI
C        Matice IHG - korespondence se siti konecnych elementu a inicializace teplot
	      CALL WMATCH
         ENDIF
      ELSE
C IAPPEND=2,3,... - pokracovani vypoctu otevreni souboru 3,4
         OPEN(3,FILE=TRIM(PROBLEM)//'.OUT',ACCESS='APPEND')
         OPEN(4,FILE=TRIM(PROBLEM)//'.TEP',ACCESS='APPEND')
         WRITE(*,501)
         WRITE(2,501)
501      FORMAT(/' Append results to files .OUT and .TEP'/)
      ENDIF



COPER FEM  Cyklus casovych / iteracnich kroku 
C -------------------------------------
      DO ITIME=1,NTSTEP

         TIME=TIME+DTIME
         WRITE(*,100)ITIME,TIME
         WRITE(2,100)ITIME,TIME
100      FORMAT(/' BEGIN TIME STEP=',I4,' TIME CALCULATED=',E10.3/
     /            1X,50('-'))
C
C Teplotni pole v desce metodou stridavych smeru a vypis teplotniho pole do souboru $T000i.OUT
C 
         CALL TPLATE(ITIME)
C
C Prvni faze casoveho kroku. V kazdem elementu je treba vyresit tepelnou bilanci dle rovnic integralniho modelu.
C
	   DO IE=1,NE
	       CALL MFLUX(IE)
	   ENDDO
C
C Druha faze: Reseni Poissonovy rovnice pro tlak (povazujeme to za operaci $FLOW - NITER=1)
C
         NDOF=1
         JDOF(1)=$PRES
         JDOFEPS(1)=$PRESEPS
	   IOPER=$FLOW
         ICOUNTS=0
         CALL FMFRIN(IOPER,WDOF,IUE,LUE,MUE,NE,ND)
         WRITE(*,101)TOPER(IOPER),ICOUNTS,(TDOF(JDOF(I)),I=1,NDOF)
         WRITE(2,101)TOPER(IOPER),ICOUNTS,(TDOF(JDOF(I)),I=1,NDOF)
101      FORMAT(4X,A,' FMFRIN(',I7,' elements) start solution of',
     /12(1X,A4))
C        LOADIN kopiruje NDOF V1->V2 (s eventualni funkcni transformaci dle IPU)
         CALL LOADIN
C        Modifikace okrajovych podminek pro tlak v blizkosti steny
         CALL BC
         ICOUNTS=0
         CALL FMFRON(0,IOPER,WDOF,IPU,VAL(1,2),NE,$REPSPIV,ITELIM,0,FEL)
         CALL COPY(2,3)
C        Postprocessing (ICNTR=1) vypocet prutoku z tlaku
         ICOUNTS=0
         CALL FMFRON(1,IOPER,WDOF,IPU,VAL(1,2),NE,$REPSPIV,ITELIM,0,FEL)
         WRITE(*,103)TOPER(IOPER),ICOUNTS,RALGOR(38+IOPER)
         WRITE(2,103)TOPER(IOPER),ICOUNTS,RALGOR(38+IOPER)
103      FORMAT(4X,A,' FMFRON(1;',I5,') postprocessing. POWER=',E10.3)

C
C Treti faze: Expanze site dle vypoctenych rychlosti v uzlech. Souradnice X,Y, se nemeni, nova poloha
C je urcena prictenim vektoru posunuti $UX,$UY. Musi se zajistit i to, aby sit nevytekla z formy. Informace
C o nove siti jsou tedy stejne jako tlaky a uzlove rychlosti ulozeny v souboru OUT.
C
         CALL EXPAND

C Zapis vysledku casoveho kroku - TLAKY a RYCHLOSTI
C
         WRITE(*,104)ITIME,TIME,NTSTEP
         WRITE(2,104)ITIME,TIME,NTSTEP
104      FORMAT(/' END of TIME STEP=',I4,' time=',E9.2,' (no.of steps=',
     /i4,')')
         WRITE(3,'(E12.4,E15.2,7E11.3,'' (time,dtime,PowerE,PowerF,Power
     /T,PowerC,PowerD,PowerA,PowerS)'')')TIME,DTIME,(RALGOR(I),I=39,45)
         WRITE(3,'(6X,20(7X,A4))')(TDOF(JPU(J)),J=1,MDOF)
         DO I=1,ND
           WRITE(3,'(I6,20E11.3)')I,(VAL((J-1)*MAXND+I,3),J=1,MDOF)
         ENDDO
         WRITE(4,'(E12.4,E15.2,7E11.3,'' (time, dtime, PowerE,...)'')') 
     /TIME,DTIME,(RALGOR(I),I=39,45)
         NAMELE=JGROUP(IGROUP(1),$ENAME)
         WRITE(4,'(6X,20(7X,A4))')
     /             (TEPAR(JEPAR(NAMELE,J)),J=1,NEPAR(NAMELE))
         DO I=1,NE
           NAMELE=JGROUP(IGROUP(I),$ENAME)
           WRITE(4,'(I6,20E11.3)')I,(EPAR(I,J),J=1,NEPAR(NAMELE))
         ENDDO
C --------------------------------------
         WRITE(*,*)' Key pressed checking...'
         PRESSED=PEEKCHARQQ()
         IF(PRESSED)THEN
            C=GETCHARQQ()
            IENDCHECK=ICHAR(C)
            GOTO 999
         ENDIF
      ENDDO

999   WRITE(*,'(1X,''Exit from RUNFEMI, writing $RUNFEM.BIN'')')
      WRITE(2,'(//'' RUNFEMI ends'')')
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      CLOSE(6)
      END

      SUBROUTINE FEL(ICNTR,IE,IOPER,NL,NUE,AL,BL)
      DIMENSION AL(NL,NL),BL(NL)
C Vstupni parametry IE-index elementu, IOPER-operace
C 
      CALL PRESSURE(ICNTR,IE,NL,NUE,AL,BL)
      END


      SUBROUTINE WDOF(IE,IOPER,NDL,INDL,MDOFL,NDOFL,IDOFL)
C Vstupni parametry IE-index elementu, IOPER-operace
C Vystupni parametry
C NDL INDL(NDL) indexy uzlu elementu (event. zaporne hodnoty)
C MDOFL celkovy pocet DOF elementu
C NDOFL(I) pocet DOF v uzlu I
C IDOFL(I,J) pozice J-teho DOF I-teho uzlu vzhledem k pocatku matice VAL
C 
      PARAMETER (MAXNDL=20,MAXNDOFL=6)
      DIMENSION INDL(MAXNDL),NDOFL(MAXNDL),IDOFL(MAXNDL,MAXNDOFL)
      INCLUDE '$FEMEQ'
C Indexy uzlu elementu 
C NDL-pocet uzlu
C NDLR-pocet uzlu na hranici (bez vnitrniho uzlu)
C MUEL-kodove cislo poctu uzlu elementu (muze byt i zaporne)
      LOC=LUE(IE)
      MUEL=MUE(IE)
      MINTN=MINT(IE)
      NDL=IABS(MUEL)
      NDLR=NDL-MINTN
      DO I=1,NDL
         INDL(I)=IUE(LOC+I)
      ENDDO
      NDL=NDLR
      MDOFL=NDL
      DO I=1,NDL
         NDOFL(I)=1
         IDOFL(I,1)=LPU($PRES)+IABS(INDL(I))
      ENDDO
      IF(MDOFL.GT.0)ICOUNTS=ICOUNTS+1
      END

