C MCTS - simplified version of CTMESH
C Algoritmus regularni site s upravou hranicnich elementu.
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (MAXQ=10000,MAXDIV=1000)
      INCLUDE '$FEMLOC'
      DIMENSION IUET(3,MAXQ),XP(MAXQ),YP(MAXQ),LP(MAXQ),KQ(MAXQ),
     /          IAUXC(MAXQ),IUES(3,MAXQ),IEES(3,MAXQ),TAB(MAXQ),
     /          IBB(MAXQ),ISU(MAXQ,10)
      LOGICAL NEW,ODD
	character*1 ch
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNMESH read RUNFEM.BIN successfully'')')
      WRITE(*,'('' You can quit computation by Ctrl C...'')')
      WRITE(*,*)
C Protokol vysledku
      OPEN(4,FILE='$RUNMESH.OUT')
C parametry prikazoveho radku
      NNCONT=IP(1)
      NX=IP(2)
      NY=IP(3)
      NU1=IABS(IP(4))
      NU2=IABS(IP(5))
      NEX=NU1-NU2

      KGROUP=MAX0(1,KGROUP)
      KRCONS=MAX0(1,KRCONS)
      KMPROP=MAX0(1,KMPROP)
C
C Rozsah key-points
C
      XMI=1E10
      YMI=1E10
      XMA=-1E10
      YMA=-1E10
      DO I=1,NPT
         XMI=AMIN1(XMI,PTX(I))
         YMI=AMIN1(YMI,PTY(I))
         XMA=AMAX1(XMA,PTX(I))
         YMA=AMAX1(YMA,PTY(I))
      ENDDO
      DX=(XMA-XMI)/(NX-1)*1.005
      DY=(YMA-YMI)/(NY-1)*1.005
	DXS=DX*0.001
	DYS=DY*0.001
	XMI=XMI-DXS
	YMI=YMI-DYS
C
C Generovani regularni site v obdelniku
C
      N=0
	NET=0
      ODD=.FALSE.
	DO IY=1,NY
	  ODD=.NOT.ODD
	  IF(ODD)THEN
	     DO IX=1,NX
	        N=N+1
	        XP(N)=XMI+(IX-1)*DX
	        YP(N)=YMI+(IY-1)*DY
	        IF(IY.LT.NY)THEN
	        NET=NET+1
	        IUET(1,NET)=N
	        IUET(2,NET)=N+NX+1
	        IUET(3,NET)=N+NX
	        IF(IX.LT.NX)THEN
	           NET=NET+1
	           IUET(1,NET)=N
	           IUET(2,NET)=N+1
	           IUET(3,NET)=N+NX+1
	        ENDIF
	        ENDIF
	     ENDDO
	  ELSE
           DO IX=1,NX+1
	        N=N+1
	        XP(N)=XMI+(IX-1.5)*DX
	        YP(N)=YMI+(IY-1)*DY
	        IF(IX.LE.NX.AND.IY.LT.NY)THEN
                NET=NET+1
	          IUET(1,NET)=N
	          IUET(2,NET)=N+1
	          IUET(3,NET)=N+NX+1
	          IF(IX.LT.NX)THEN
	            NET=NET+1
	            IUET(1,NET)=N+1
	            IUET(2,NET)=N+NX+2
	            IUET(3,NET)=N+NX+1
	          ENDIF
	        ENDIF
	     ENDDO
        ENDIF
      ENDDO
C
C Pritahni nejblizsi uzly site k definicnim bodu krivek (rohy IND)
C
	DO ICTU=1,NNCONT
      DO ICU=1,MCONTOUR(ICTU)
        ICRU=ICONTOUR(ICU,ICTU)
	  NCP=MCR(ICRU)
	  DO I=1,NCP
	    IND=ICR(I,ICRU)
	    XIND=PTX(IND)
	    YIND=PTY(IND)
	    DM=1E10
          DO J=1,N
	      D=(XIND-XP(J))**2+(YIND-YP(J))**2
	      IF(D.LT.DM)THEN
	         NEAR=J
	         DM=D
            ENDIF
	    ENDDO
	    XP(NEAR)=XIND
	    YP(NEAR)=YIND
         ENDDO
      ENDDO
	ENDDO
C
C Vyrazovani vnejsich elementu a eventualni ztotoznovani vrcholu trojuhelniku s obrysem
C
	DO ITER=1,2
C
C Identifikace vnitrnich uzlu LP=1
C
	DO K=1,N
        CALL PTCTIN(XP(K),YP(K),PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,LP(K))
	ENDDO
C
C identifikace elementu dle poctu bodu uvnitr oblasti - elementy
C se vsemi uzly mimo jsou vyrazeny.
C IAUXC(i) pocet vnitrnich uzlu trojuhelniku
C ======================================================
C
      IET=0
      DO WHILE(IET.LT.NET)
        IET=IET+1
	  I1=IUET(1,IET)
	  I2=IUET(2,IET)      
	  I3=IUET(3,IET)      
	  L1=LP(I1)      
	  L2=LP(I2)      
	  L3=LP(I3)      
	  NIN=IABS(L1)+IABS(L2)+IABS(L3)
        NIS=L1+L2+L3
	  NIP=L1*L2*L3
	  IF(NIP.EQ.0.AND.NIS.LT.0.OR.NIN.LE.0)THEN
C element IET (VSECHNY UZLY MIMO) je patrne treba vyradit ze seznamu elementu IUET
C Overeni, zda i teziste trojuhelniku lezi mimo oblast
          XT=(XP(I1)+XP(I2)+XP(I3))/3.
          YT=(YP(I1)+YP(I2)+YP(I3))/3.
          CALL PTCTIN(XT,YT,PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,IN)
	    IF(IN.EQ.0)THEN
            NET=NET-1
            DO J=IET,NET
              DO K=1,3
                IUET(K,J)=IUET(K,J+1)
              ENDDO
            ENDDO
            IET=IET-1
	    ENDIF
	  ELSE
	    IAUXC(IET)=NIS
        ENDIF
      ENDDO
      WRITE(*,102)NET
      WRITE(4,102)NET
102   FORMAT(' Some elements outside the region were deleted. Remaining 
     /number of elements=',i6)
C
C Vyrazeni uzlu, ktere nejsou v zadnem elementu. N-definitivni pocet uzlu
C
      CALL NODEL(KQ,IUET,NET,XP,YP,N,NN)
	N=NN
C
C Pruseciky stran trojuhelniku s CT
C
      DO IE=1,NET
	  IF(IAUXC(IE).LT.3)THEN
C Hranicni trojuhelnik
          DO K=1,3
	      IA=IUET(K,IE)
	      K2=MOD(K,3)+1
	      IB=IUET(K2,IE)
            IF(LP(IA).NE.LP(IB))THEN
	         XA=XP(IA)
	         YA=YP(IA)
	         XB=XP(IB)
	         YB=YP(IB)
               CALL PTCTXY(XA,YA,XB,YB,PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,TAB,NTAB)
	         IF(NTAB.GT.0)THEN
C 1 prusecik TAB-male blizko A, TAB-velke blizko B
                 T1=TAB(1)
                 XNEW=XA+(XB-XA)*T1
	           YNEW=YA+(YB-YA)*T1
                 IF(T1.LT.0.3)THEN
	              XP(IA)=XNEW
	              YP(IA)=YNEW
	           ELSEIF(T1.GT.0.7)THEN
	              XP(IB)=XNEW
	              YP(IB)=YNEW
	           ENDIF
               ENDIF
	      ENDIF
          ENDDO
        ENDIF
      ENDDO
      ENDDO 
C
C Nova identifikace uzlu
C
	DO K=1,N
        CALL PTCTIN(XP(K),YP(K),PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,LP(K))
	ENDDO
C
C Vyhledej sousedy VNEJSICH uzlu (maji LP(i)=0)
C
      CALL NEIGHU(LP,IUET,ISU,IBB,N,NET,MAXQ)
C
C Prochazeni seznamu vnejsi uzlu. hledani kombinace vnitrni-vnejsi a prusecik
C
	DO I=1,N
	IF(LP(I).EQ.0)THEN
        TM=1E10
	  JM=1
	  XA=XP(I)
	  YA=YP(I)
C Testuj sousedy vnejsiho uzlu a vyber ten s nejmensi hodnotou T
        DO IS=1,IBB(I)
	    IB=ISU(I,IS)
	    IF(LP(IB).EQ.1)THEN 
		   XB=XP(IB)
		   YB=YP(IB)     
             CALL PTCTXY(XA,YA,XB,YB,PTX,PTY,NPT,
     /          ICR,MCR,NCR,ICONTOUR,MCONTOUR,NNCONT,TAB,NTAB)
	       T=TAB(1)
	       IF(NTAB.GT.0.AND.T.LT.TM)THEN
	         JM=IB
	         TM=T
	       ENDIF
          ENDIF
	  ENDDO
	  IF(TM.LT..95)THEN
          XP(I)=XA+TM*(XP(JM)-XA)
          YP(I)=YA+TM*(YP(JM)-YA)
	  ENDIF
  	ENDIF
	ENDDO

C
C Vyrazeni elementu, ktere jejich teziste je mimo oblast reseni
C
      IET=0
      DO WHILE(IET.LT.NET)
        IET=IET+1
	  I1=IUET(1,IET)
	  I2=IUET(2,IET)      
	  I3=IUET(3,IET)      
C Overeni, zda i teziste trojuhelniku lezi mimo oblast
        XT=(XP(I1)+XP(I2)+XP(I3))/3.
        YT=(YP(I1)+YP(I2)+YP(I3))/3.
        CALL PTCTIN(XT,YT,PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,IN)
	  IF(IN.EQ.0)THEN
            NET=NET-1
            DO J=IET,NET
              DO K=1,3
                IUET(K,J)=IUET(K,J+1)
              ENDDO
            ENDDO
            IET=IET-1
        ENDIF
      ENDDO
C
C Vyrazeni uzlu, ktere nejsou v zadnem elementu. N-definitivni pocet uzlu
C
      CALL NODEL(KQ,IUET,NET,XP,YP,N,NN)
	N=NN
C
C generuj uzly uprostred stran a elementy FEMINA
C
      
      IF(NEX.EQ.6)CALL MIDNOD(IUET,IUES,NET,XP,YP,N,MAXQ)
C
C prenos vygenerovane site trojuhelniku do databaze
C
      DO I=1,N
        XX(ND+I)=XP(I)
        YY(ND+I)=YP(I)
        ZZ(ND+I)=0.
      ENDDO
      DO IET=1,NET
        NE=NE+1
        MUE(NE)=NU1
        MINT(NE)=NU2
        IGROUP(NE)=KGROUP
        IRCONS(NE)=KRCONS
        IMPROP(NE)=KMPROP
        L0=LUE(NE)
        DO I=1,3
          IUE(L0+I)=IUET(I,IET)+ND
          IF(NEX.EQ.6)IUE(L0+I+3)=IUES(I,IET)+ND
        ENDDO
        LUE(NE+1)=LUE(NE)+NU1
      ENDDO
      ND=ND+N
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      END

      SUBROUTINE MIDNOD(IUET,IUES,NET,XP,YP,N,MAXQ)
      DIMENSION IUET(3,*),IUES(3,*),XP(*),YP(*)
      NBAS=N
      DO IE=1,NET
        DO I1=1,3
           I2=MOD(I1,3)+1
           J1=IUET(I1,IE)
           J2=IUET(I2,IE)
           XT=(XP(J1)+XP(J2))*.5
           YT=(YP(J1)+YP(J2))*.5
           INEW=N+1
           DO J=NBAS+1,N
              DIST=(XT-XP(J))**2+(YT-YP(J))**2
              IF(DIST.LE.1E-6)THEN
                 INEW=J
                 EXIT
              ENDIF
           ENDDO
           N=MAX0(N,INEW)
           IF(N.GT.MAXQ)THEN
              WRITE(4,*)' Number of nodes exeeds',maxq
              STOP
           ENDIF
           IUES(I1,IE)=INEW
           XP(INEW)=XT
           YP(INEW)=YT
        ENDDO
      ENDDO
      END

      SUBROUTINE NEIGHU(LP,IUE,ISU,IB,N,NE,NDIM)
C Vyhledani sousedu
      PARAMETER (MAXQQ=30000)
      DIMENSION LP(*),IUE(3,*),ISU(NDIM,*),IB(*)
      LOGICAL NEW
	MAXCOL=MAXQQ*3/NDIM
      DO I=1,N
         IB(I)=0
      ENDDO
      DO I=1,N
	IF(LP(I).EQ.0)THEN
         DO IE=1,NE
            DO K=1,3
               IF(I.EQ.IUE(K,IE))THEN
C Dva potencialni sousede K1,K2 uzlu I
                  K1=K
                  DO J=1,2
                     K1=MOD(K1,3)+1
                     IS=IUE(K1,IE)
                     NEW=.TRUE.
                     DO L=1,IB(I)
                        IF(ISU(I,L).EQ.IS)THEN
                           NEW=.FALSE.
                           EXIT
                        ENDIF
                     ENDDO
                     IF(NEW.AND.IB(I).LT.MAXCOL)THEN
                        IB(I)=IB(I)+1
                        ISU(I,IB(I))=IS
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
	ENDIF
      ENDDO
      END

      SUBROUTINE NODEL(KQ,IUET,NET,XP,YP,N,NN)
	DIMENSION IUET(3,*),KQ(*),XP(*),YP(*)
	DO I=1,N
        KQ(I)=0
	ENDDO
	DO IE=1,NET
        DO I=1,3
	    KQ(IUET(I,IE))=1
	  ENDDO
	ENDDO
      NN=0
	DO I=1,N
	  IF(KQ(I).EQ.1)THEN
	     NN=NN+1
	     KQ(I)=NN
	     XP(NN)=XP(I)
	     YP(NN)=YP(I)
	  ELSE
	     KQ(I)=0
	  ENDIF
	ENDDO
	N=NN
	DO IE=1,NET
	  DO I=1,3
	     IUET(I,IE)=KQ(IUET(I,IE))
        ENDDO
	ENDDO
      END
