C RUNMESH.for
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      PARAMETER (MAXQ=10000,MAXQQ=30000,MAXDIV=1000)
      INCLUDE '$FEMLOC'
      DIMENSION IUET(3,MAXQ),INB(MAXQ),XP(MAXQ),YP(MAXQ),LP(MAXQ),
     /          IAUXC(MAXQ),RX(3),XA(MAXDIV),IBNOD(2,MAXDIV),
     /          IUES(3,MAXQQ),IEES(3,MAXQ),SX(4),SY(4),TCENTER(MAXQ)
      LOGICAL NEW
      DATA RX /-1.,1.,0./
      DATA SX,SY/1.,-1.,0.,0.,0.,0.,1.,-1./
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' RUNMESH read RUNFEM.BIN successfully'')')
      WRITE(*,'('' You can quit computation by Ctrl C...'')')
      WRITE(*,*)
C Protokol vysledku
      OPEN(4,FILE='$RUNMESH.OUT')
C parametry prikazoveho radku
      NNCONT=IP(1)
      NX=IP(2)
      NY=IP(3)
      NU1=IABS(IP(4))
      NU2=IABS(IP(5))
      NEX=NU1-NU2
      NITERS=IP(6)
      NITER=IABS(NITERS)
      NREFINE=IP(7)
      BWEIGHT=RP(8)
      CONTROL=RP(9)
C
      KGROUP=MAX0(1,KGROUP)
      KRCONS=MAX0(1,KRCONS)
      KMPROP=MAX0(1,KMPROP)
C
C Rozsah key-points
C
      XMI=1E10
      YMI=1E10
      XMA=-1E10
      YMA=-1E10
      DO I=1,NPT
         XMI=AMIN1(XMI,PTX(I))
         YMI=AMIN1(YMI,PTY(I))
         XMA=AMAX1(XMA,PTX(I))
         YMA=AMAX1(YMA,PTY(I))
      ENDDO
      DX=(XMA-XMI)/(NX-1)
      DY=(YMA-YMI)/(NY-1)
      DXS=DX*0.5
      DYS=DY*0.5
      DXSS=DX*0.26
      DYSS=DY*0.26
      XMI=XMI-DXS
      XMA=XMA+DXS
      YMI=YMI-DYS
      YMA=YMA+DYS
      N=1
      NBSEG=0
C Generovani hranicnich bodu
      DO IC=1,NNCONT
        DO J=1,MCONTOUR(IC)
          ICURVE=ICONTOUR(J,IC)
          NPCURVE=MCR(ICURVE)
C Doplneni bodu krivky ICURVE dle NXCR a FLAFI
          NNCURVE=NXCR(ICURVE)
          IF(NNCURVE.LE.2)THEN
C implicitni pocet bodu dle delky krivky
            I1=ICR(1,ICURVE)
            I2=ICR(2,ICURVE)
            DX12=ABS(PTX(I1)-PTX(I2))
            DY12=ABS(PTY(I1)-PTY(I2))
            NX1=NX*DX12/(XMA-XMI)
            NY1=NY*DY12/(YMA-YMI)
            NNCURVE=MAX0(2,MAX0(NX1,NY1)+1)
          ENDIF
          AX=FLAFI(ICURVE)
          IF(AX.EQ.0.)AX=1.
          NSEG=NNCURVE-1
          CALL FEMDIV(-1.,1.,XA,NSEG,AX)
          DO IX=1,NNCURVE
            XP(N)=0
            YP(N)=0
            DO I=1,NPCURVE
               ZX=XA(IX)*RX(I)
               IF(NPCURVE.EQ.2)THEN
                  BI=(1+ZX)/2.
               ELSEIF(I.LE.2)THEN
                  BI=(1+ZX)*ZX/2.
               ELSE
                  BI=1-XA(IX)**2
               ENDIF
               IND=ICR(I,ICURVE)
               XP(N)=XP(N)+PTX(IND)*BI
               YP(N)=YP(N)+PTY(IND)*BI
C LP(N)=-1 oznacuje fixovany bod na hranici
               LP(N)=-1
            ENDDO
C Zjisti, zda uzel jiz nebyl vygenerovan na jinych krivkach
            NEW=.TRUE.
            IND=N
            DO K=1,N-1
              IF(ABS(XP(N)-XP(K)).LT.$RTOL.AND.
     /           ABS(YP(N)-YP(K)).LT.$RTOL)THEN
                NEW=.FALSE.
                IND=K
              ENDIF
            ENDDO
            IF(NEW)N=N+1
C DOPLNIME index uzlu IND do seznamu hranicnich uzlu
            IF(IX.EQ.1)THEN
              NBSEG=NBSEG+1
              IBNOD(1,NBSEG)=IND
            ELSEIF(IX.EQ.2)THEN
              IBNOD(2,NBSEG)=IND
            ELSEIF(IX.LE.NSEG)THEN
              NBSEG=NBSEG+1
              IBNOD(1,NBSEG)=IBNOD(2,NBSEG-1)
              IBNOD(2,NBSEG)=IND
            ENDIF            
          ENDDO
          NBSEG=NBSEG+1
          IBNOD(1,NBSEG)=IBNOD(2,NBSEG-1)
          IBNOD(2,NBSEG)=IND
        ENDDO
      ENDDO
      N=N-1
      NBOUND=N
      WRITE(*,*)' Boundary points, total N=',n
      WRITE(4,*)' Boundary segment   Node 1     Node 2'
      DO I=1,NBSEG
         WRITE(4,'(10x,3I8)')I,IBNOD(1,I),IBNOD(2,I)
      ENDDO
C Add INNER points as soon as they are not too close to boundary points
      DO I=1,NX
        XN=(I-1)*DX+XMI
        SIGN=1.
        DO J=1,NY
C SIGN - zakladni motiv priblizne trojuhelnikove a ne ctvercove site
          SIGN=-SIGN
          X=XN+SIGN*DXSS
          Y=(J-1)*DY+YMI
          CALL PTCTIN(X,Y,PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,IN)
          IF(IN.EQ.1)THEN
            NEW=.TRUE.
C Testovani vzdalenosti od hranicnich segmentu
            DO K=1,NBSEG
               I1=IBNOD(1,K)
               I2=IBNOD(2,K)
               XT=(XP(I1)+XP(I2))*.5
               YT=(YP(I1)+YP(I2))*.5
               DXK=X-XT
               DYK=Y-YT
               ADXK=ABS(DXK)
               ADYK=ABS(DYK)
               IF(ADXK.LE.DXS.AND.ADYK.LE.DYS)THEN
C u blizkych bodu hranice provedeme jejich korekci. Vyzkousi se 4 posuny 
                 DIST=SQRT((X-XP(I1))**2+(Y-YP(I1))**2)+
     /                SQRT((X-XP(I2))**2+(Y-YP(I2))**2)
                 X0=X
                 Y0=Y
                 NEW=.FALSE.
                 DO L=1,4
                   X1=X0+DXSS*SX(L)
                   Y1=Y0+DYSS*SY(L)
                   CALL PTCTIN(X1,Y1,PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,IN1)
                   IF(IN1.EQ.1)THEN
                     D1=SQRT((X1-XP(I1))**2+(Y1-YP(I1))**2)+
     /                  SQRT((X1-XP(I2))**2+(Y1-YP(I2))**2)
                      IF(D1.GT.DIST)THEN
                        DIST=D1
                        X=X1
                        Y=Y1
                        NEW=.TRUE.
                      ENDIF
                    ENDIF
                 ENDDO
                 IF(IN1.EQ.0)NEW=.FALSE.
               ENDIF
            ENDDO
            IF(NEW)THEN
              N=N+1
              XP(N)=X
              YP(N)=Y
C LP=0 OZNACUJE VNITRNI BOD
              LP(N)=0
            ENDIF
          ENDIF
        ENDDO
      ENDDO
C
C generovani trojuhelnikove site
C ======================================================
C
      WRITE(*,100)N,CONTROL
      WRITE(4,100)N,CONTROL
100   FORMAT(' FEMPT starts with',i6,' points. CONTROL=',f5.2)
      CALL FEMPT(XP,YP,N,CONTROL,IUET,NET,INB,NB,IAUXC)
      WRITE(*,101)NET
      WRITE(4,101)NET
101   FORMAT(' FEMPT ends giving',i6,' triangles.')
C
C ======================================================
C
      IET=0
      DO WHILE(IET.LT.NET)
        IET=IET+1      
CHECK gravity center of possibly generated triangle
        TX=0.
        TY=0.
        DO I=1,3
          IND=IUET(I,IET)
          TX=TX+XP(IND)
          TY=TY+YP(IND)
        ENDDO
        CALL PTCTIN(TX/3.,TY/3.,PTX,PTY,NPT,ICR,MCR,NCR,
     /                ICONTOUR,MCONTOUR,NNCONT,IN)
        IF(IN.EQ.0)THEN
C element IET je treba vyradit ze seznamu elementu IUET
          NET=NET-1
          DO J=IET,NET
            DO K=1,3
              IUET(K,J)=IUET(K,J+1)
            ENDDO
          ENDDO
          IET=IET-1
        ENDIF
      ENDDO
      WRITE(*,102)NET
      WRITE(4,102)NET
102   FORMAT(' Some elements outside the region were deleted. Remaing nu
     /mber of elements=',i6)
C
C Test, zda vsechny hranicni segmenty jsou casti nektereho elementu.
C Kdyz ne, kazdemu takovemu segmentu se priradi trojuhelnik
C
      DO IS=1,NBSEG      
        NEW=.TRUE.
        DO IE=1,NET
           CALL SEGINT(IUET(1,IE),IBNOD(1,IS),IN)
           IF(IN.EQ.2)THEN
              NEW=.FALSE.
              EXIT
           ENDIF
        ENDDO
        ITER=0
        DO WHILE(NEW.AND.ITER.LE.3)
C 
C generuj trojuhelnik z dvojice uzlu IBNOD(i,IS). Vyber vhodneho kandidata
C z nejblizsich vnitrnich uzlu
C 
           ITER=ITER+1
           I1=IBNOD(1,IS)
           I2=IBNOD(2,IS)
           XT=(XP(I1)+XP(I2))*.5
           YT=(YP(I1)+YP(I2))*.5
           DISTMIN=1E10
           DO I=1,N
              IF(LP(I).EQ.0)THEN
                DIST=(XT-XP(I))**2+(YT-YP(I))**2
                IF(DIST.LT.DISTMIN)THEN
                   DISTMIN=DIST
                   I3=I
                ENDIF
              ENDIF
           ENDDO
           NET=NET+1
           IUET(1,NET)=I1
           IUET(2,NET)=I2
           IUET(3,NET)=I3
C overeni ze element NET nekrizi jine elementy
           NEW=.FALSE.
           DO JE=1,NET-1
              CALL MCTRIN(NET,JE,IUET,NET,XP,YP,N,IN)
              IF(IN.EQ.1)THEN
                NEW=.TRUE.
                LP(I3)=1
                NET=NET-1
                EXIT
              ENDIF
           ENDDO
        WRITE(*,*)' SEGMENT',IS,' NODE', I1,I2,I3,' ERROR:',IN
        ENDDO
      ENDDO
      WRITE(*,103)NET
      WRITE(4,103)NET
103   FORMAT(' Some elements were generated along boundary. Final number
     / of elements=',i6)
C
C smoothing mesh
C
      CALL CTMESM(XP,YP,NBOUND,N,NDNEW,IUET,NET,IUES,IEES,INB,LP,IAUXC,
     /            BWEIGHT,NITER)
      N=NDNEW
C
C Setrideni elementu
C
	CALL CTSORT(XP,YP,IUET,NET,TCENTER)
C
C generuj uzly uprostred stran a elementy FEMINA
C
      DO I=1,NREFINE
        CALL MIDNOD(IUET,IUES,NET,XP,YP,N,MAXQ)
C Nove elementy 1:4
        NENEW=0
        DO IE=1,NET
          I1=IUET(1,IE)
          I2=IUET(2,IE)
          I3=IUET(3,IE)
          I4=IUES(1,IE)
          I5=IUES(2,IE)
          I6=IUES(3,IE)
          NENEW=NENEW+1
          IEES(1,NENEW)=I4
          IEES(2,NENEW)=I5
          IEES(3,NENEW)=I6
          NENEW=NENEW+1
          IEES(1,NENEW)=I1
          IEES(2,NENEW)=I4
          IEES(3,NENEW)=I6
          NENEW=NENEW+1
          IEES(1,NENEW)=I2
          IEES(2,NENEW)=I5
          IEES(3,NENEW)=I4
          NENEW=NENEW+1
          IEES(1,NENEW)=I3
          IEES(2,NENEW)=I6
          IEES(3,NENEW)=I5
        ENDDO
        NET=NENEW
        DO J=1,NET
          DO K=1,3
            IUET(K,J)=IEES(K,J)
          ENDDO
        ENDDO
      ENDDO
C Zaverecne vyhlazeni site
      IF(NREFINE.GT.0.AND.NITERS.LT.0)CALL CTSMOOT(XP,YP,NBND,N,
     /                           IUET,NET,IUES,INB,BWEIGHT,NITER,N)
C
C Setrideni elementu dle souradnic teziste (stejne jako to dela CTR)
C

      CALL MIDNOD(IUET,IUES,NET,XP,YP,N,MAXQ)
C
C prenos vygenerovane site trojuhelniku do databaze
C
      DO I=1,N
        XX(ND+I)=XP(I)
        YY(ND+I)=YP(I)
        ZZ(ND+I)=0.
      ENDDO
      DO IET=1,NET
        IF(NEX.EQ.6)THEN
          NE=NE+1
          MUE(NE)=NU1
          MINT(NE)=NU2
          IGROUP(NE)=KGROUP
          IRCONS(NE)=KRCONS
          IMPROP(NE)=KMPROP
          L0=LUE(NE)
          DO I=1,3
            IUE(L0+I)=IUET(I,IET)+ND
            IUE(L0+I+3)=IUES(I,IET)+ND
          ENDDO
          LUE(NE+1)=LUE(NE)+NU1
        ELSEIF(NEX.EQ.3)THEN
          DO I=1,3
            NE=NE+1
            MUE(NE)=NU1
            MINT(NE)=NU2
            IGROUP(NE)=KGROUP
            IRCONS(NE)=KRCONS
            IMPROP(NE)=KMPROP
            L0=LUE(NE)
            IUE(L0+1)=IUET(I,IET)+ND
            IUE(L0+2)=IUES(I,IET)+ND
            K=MOD(I+1,3)+1
            IUE(L0+3)=IUES(K,IET)+ND
            LUE(NE+1)=LUE(NE)+NU1
          ENDDO   
          NE=NE+1
          MUE(NE)=NU1
          MINT(NE)=NU2
          IGROUP(NE)=KGROUP
          IRCONS(NE)=KRCONS
          IMPROP(NE)=KMPROP
          L0=LUE(NE)
          DO I=1,3
            IUE(L0+I)=IUES(I,IET)+ND
          ENDDO
          LUE(NE+1)=LUE(NE)+NU1
        ENDIF
      ENDDO
      ND=ND+N
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      END

	SUBROUTINE CTSORT(XP,YP,IUET,NE,TCENTER)
C SETRIDENI ELEMENTU
	DIMENSION XP(*),YP(*),IUET(3,*),TCENTER(*)
	LOGICAL SORTED
	DO I=1,NE
	  XT=0
	  YT=0
	  DO J=1,3
	    K=IUET(J,I)
	    XT=XT+XP(K)
	    YT=YT+YP(K)
	  ENDDO
	  TCENTER(I)=XT+YT
	ENDDO
      SORTED=.FALSE.
	DO WHILE(.NOT.SORTED)
        SORTED=.TRUE.
	  DO I=1,NE-1
	    IF(TCENTER(I).GT.TCENTER(I+1))THEN
	       SORTED=.FALSE.
	       A=TCENTER(I)
	       TCENTER(I)=TCENTER(I+1)
	       TCENTER(I+1)=A
	       DO K=1,3
	          IA=IUET(K,I)
	          IUET(K,I)=IUET(K,I+1)
	          IUET(K,I+1)=IA
	       ENDDO
	    ENDIF
	  ENDDO
	ENDDO
	END

      SUBROUTINE SEGINT(IT,IS,IN)
      DIMENSION IT(*),IS(*)
C SEGMENT IS(2) A TROJUHELNIK IT(3)
C Vystup IN=pocet spolecnych bodu
      IN=0
      DO I=1,2
        DO J=1,3
          IF(IS(I).EQ.IT(J))IN=IN+1
        ENDDO
      ENDDO
      END

      SUBROUTINE MIDNOD(IUET,IUES,NET,XP,YP,N,MAXQ)
      DIMENSION IUET(3,*),IUES(3,*),XP(*),YP(*)
      NBAS=N
      DO IE=1,NET
        DO I1=1,3
           I2=MOD(I1,3)+1
           J1=IUET(I1,IE)
           J2=IUET(I2,IE)
           XT=(XP(J1)+XP(J2))*.5
           YT=(YP(J1)+YP(J2))*.5
           INEW=N+1
           DO J=NBAS+1,N
              DIST=(XT-XP(J))**2+(YT-YP(J))**2
              IF(DIST.LE.1E-6)THEN
                 INEW=J
                 EXIT
              ENDIF
           ENDDO
           N=MAX0(N,INEW)
           IF(N.GT.MAXQ)THEN
              WRITE(4,*)' Number of nodes exeeds',maxq
              STOP
           ENDIF
           IUES(I1,IE)=INEW
           XP(INEW)=XT
           YP(INEW)=YT
        ENDDO
      ENDDO
      END

      SUBROUTINE CTSMOOT(XP,YP,NB,NDNEW,IUE,NENEW,
     /    ISU,IB,BWEIGHT,NITER,NDIM)
C
C Modifikace souradnic uzlu elementu. 
C ISU(N,*) -indexy sousednich uzlu,
C ISE(N,*) -indexy sousednich elementu, IB-pocet sousedu, 
C Attractivity hranicnich bodu jsou definovany vahou BWEIGHT
C
      DIMENSION XP(*),YP(*),IUE(3,*),ISU(NDIM,*),IB(*)
C 
C MODIFIKACE SOURADNIC UZLU
C
      CALL NEIGHU(IUE,ISU,IB,NDNEW,NENEW,NDIM)
      ALFA=.4
      DO ITER=1,NITER
        DO I=NB+1,NDNEW
          XA=0
          YA=0
          NS=IB(I)
          IF(NS.GT.5)THEN
            W=0.
            DO J=1,NS
              IS=ISU(I,J)
              IF(IS.LE.NB)THEN
                 B=BWEIGHT
              ELSE
                 B=1.
              ENDIF
              XA=XA+XP(IS)*B
              YA=YA+YP(IS)*B
              W=W+B
            ENDDO
            XP(I)=XP(I)*ALFA+XA/W*(1-ALFA)
            YP(I)=YP(I)*ALFA+YA/W*(1-ALFA)
          ENDIF
        ENDDO
      ENDDO
      END

      SUBROUTINE NEIGHU(IUE,ISU,IB,N,NE,NDIM)
C Vyhledani sousedu
      PARAMETER (MAXQQ=30000)
      DIMENSION IUE(3,*),ISU(NDIM,*),IB(*)
      LOGICAL NEW
	MAXCOL=MAXQQ*3/NDIM
      DO I=1,N
         IB(I)=0
      ENDDO
      DO I=1,N
         DO IE=1,NE
            DO K=1,3
               IF(I.EQ.IUE(K,IE))THEN
C Dva potencialni sousede K1,K2 uzlu I
                  K1=K
                  DO J=1,2
                     K1=MOD(K1,3)+1
                     IS=IUE(K1,IE)
                     NEW=.TRUE.
                     DO L=1,IB(I)
                        IF(ISU(I,L).EQ.IS)THEN
                           NEW=.FALSE.
                           EXIT
                        ENDIF
                     ENDDO
                     IF(NEW.AND.IB(I).LT.MAXCOL)THEN
                        IB(I)=IB(I)+1
                        ISU(I,IB(I))=IS
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
      ENDDO
      END


      SUBROUTINE CTMESM(XP,YP,NB,NDOLD,NDNEW,IUE,NE,
     /    ISU,ISE,IB,IDE,IDU,BWEIGHT,NITER)
C
C Nahrazeni elementu slozenych ze 3 vnitrnich trojuhelniku jedinym elementem,
C a elementu ze 4 trojuhelniku dvema elementy
C Modifikace souradnic uzlu elementu. 
C ISU(N,*) -indexy sousednich uzlu,
C ISE(N,*) -indexy sousednich elementu, IB-pocet sousedu, 
C IDE-priznak zruseneho elementu, IDU-priznak zruseneho uzlu
C Attractivity hranicnich bodu jsou definovany vahou BWEIGHT
C
      DIMENSION XP(*),YP(*),IUE(3,*),ISU(NDOLD,*),ISE(NDOLD,*),IB(*),
     /          IDE(*),IDU(*)
      LOGICAL NEW
C DO WHILE existuje trojuhelnik s vnitrnim uzlem
      NDNEW=NDOLD
      NENEW=NE
      ICOUNT=0
      NEW=.TRUE.
      DO WHILE(NEW)
        ICOUNT=ICOUNT+1
        WRITE(4,'('' CTMESM-3Loop'',I2,'' ND='',I4,'' NE='',I4,'' NB='',
     /I4)')ICOUNT,NDNEW,NENEW,NB
        CALL NEIGHB(IUE,ISU,ISE,IB,NDNEW,NENEW,NDOLD)
C
C VYHLEDANI UZLU, KTERE MAJI PRAVE 3 SOUSEDY (s vyjimkou hranicnich uzlu)
C
        DO I=1,NDNEW
           IDU(I)=0
        ENDDO
        DO I=1,NENEW
           IDE(I)=0
        ENDDO
        NEW=.FALSE.
        DO I=NB+1,NDNEW
           IF(IB(I).EQ.3)THEN
              WRITE(4,'('' CTMESM-node'',I4,'' and connected elements'',
     /3I4)')I,(ISE(I,J),J=1,3)
              NEW=.TRUE.
              DO J=1,3
                INDE=ISE(I,J)
                IF(INDE.LE.0)THEN
                   WRITE(4,'('' ERROR zero index of neighbour el.'')')
                   RETURN
                ENDIF
                IDE(INDE)=1
              ENDDO
              IDU(I)=1
C Novy element
              DO J=1,3
                IUE(J,INDE)=ISU(I,J)
              ENDDO
              IDE(INDE)=0
           ENDIF
        ENDDO
C
C Vynechani predznackovanych elementu a uzlu (zmena matice konektivity)
C
        CALL DELEN(IUE,NENEW,XP,YP,NDNEW,IDE,IDU)
        WRITE(4,'('' CTMESM-purge, NODES ND='',I4,'' NE='',I4)')
     /        NDNEW,NENEW

      ENDDO
C
C vsechny vnitrni trojuhelniky jsou eliminovany
C podobna procedura pr 4-uhelniky
C
      ICOUNT=0
      NEW=.TRUE.
      DO WHILE(NEW)
        ICOUNT=ICOUNT+1
        WRITE(4,'('' CTMESM-4Loop'',I2,'' ND='',I4,'' NE='',I4,'' NB='',
     /I4)')ICOUNT,NDNEW,NENEW,NB
        CALL NEIGHB(IUE,ISU,ISE,IB,NDNEW,NENEW,NDOLD)
C
C VYHLEDANI UZLU, KTERE MAJI PRAVE 4 SOUSEDY (s vyjimkou hranicnich uzlu)
C
        DO I=1,NDNEW
           IDU(I)=0
        ENDDO
        DO I=1,NENEW
           IDE(I)=0
        ENDDO
        NEW=.FALSE.
        DO I=NB+1,NDNEW
           IF(IB(I).EQ.4)THEN
              WRITE(4,'('' CTMESM-node'',I4,'' and connected elements'',
     /4I4)')I,(ISE(I,J),J=1,4)
              NEW=.TRUE.
C Vyhledani souseda ISMAX s nejvetsim poctem sousedu NSMAX
              NSMAX=0
              ISMAX=0
              DO J=1,4
                INDE=ISE(I,J)
                IF(INDE.LE.0)THEN
                   WRITE(4,'('' ERROR zero index of neighbour el.'')')
                   RETURN
                ENDIF
                IDE(INDE)=1
                INDU=ISU(I,J)
                IF(IB(INDU).GT.NSMAX)THEN
                   ISMAX=INDU
                   NSMAX=IB(INDU)
                ENDIF
              ENDDO
              IDU(I)=1
C Dva nove elementy IE1,IE2
              IE1=ISE(I,1)
              IE2=ISE(I,2)
              IDE(IE1)=0
              IDE(IE2)=0
              IUE(1,IE1)=ISMAX
              IC1=1
              IC2=0
              DO J=1,4
                INDS=ISU(I,J)
                IF(INDS.NE.ISMAX)THEN
                  DO K=1,IB(INDS)
                     IF(ISU(INDS,K).EQ.ISMAX)THEN
                       IC1=IC1+1
                       IUE(IC1,IE1)=INDS
                     ENDIF
                  ENDDO
                  IC2=IC2+1
                  IUE(IC2,IE2)=INDS
                ENDIF
              ENDDO
           ENDIF
        ENDDO
C
C Vynechani predznackovanych elementu a uzlu (zmena matice konektivity)
C
        CALL DELEN(IUE,NENEW,XP,YP,NDNEW,IDE,IDU)
        WRITE(4,'('' CTMESM-purge, NODES ND='',I4,'' NE='',I4)')
     /        NDNEW,NENEW
      ENDDO
      NE=NENEW
C 
C MODIFIKACE SOURADNIC UZLU
C
      ALFA=.8
      DO ITER=1,NITER
        DO I=NB+1,NDNEW
          XA=0
          YA=0
          NS=IB(I)
          IF(NS.GT.0)THEN
            W=0.
            DO J=1,NS
              IS=ISU(I,J)
              IF(IS.LE.NB)THEN
                 B=BWEIGHT
              ELSE
                 B=1.
              ENDIF
              XA=XA+XP(IS)*B
              YA=YA+YP(IS)*B
              W=W+B
            ENDDO
            XP(I)=XP(I)*ALFA+XA/W*(1-ALFA)
            YP(I)=YP(I)*ALFA+YA/W*(1-ALFA)
          ENDIF
        ENDDO
      ENDDO
      END

      SUBROUTINE NEIGHB(IUE,ISU,ISE,IB,N,NE,NDIM)
C Vyhledani sousedu
      DIMENSION IUE(3,*),ISU(NDIM,*),ISE(NDIM,*),IB(*)
      LOGICAL NEW
      DO I=1,N
         IB(I)=0
         DO J=1,4
           ISE(I,J)=0
         ENDDO
      ENDDO
      DO I=1,N
         DO IE=1,NE
            DO K=1,3
               IF(I.EQ.IUE(K,IE))THEN
C Dva potencialni sousede K1,K2 uzlu I
                  K1=K
                  DO J=1,2
                     K1=MOD(K1,3)+1
                     IS=IUE(K1,IE)
                     NEW=.TRUE.
                     DO L=1,IB(I)
                        IF(ISU(I,L).EQ.IS)THEN
                           NEW=.FALSE.
                           EXIT
                        ENDIF
                     ENDDO
                     IF(NEW)THEN
                        IB(I)=IB(I)+1
                        ISU(I,IB(I))=IS
                     ENDIF
                  ENDDO
                  DO J=1,4
                     IF(ISE(I,J).EQ.0)THEN
                        ISE(I,J)=IE
                        EXIT
                     ENDIF
                  ENDDO
               ENDIF
            ENDDO
         ENDDO
      ENDDO
      END

      SUBROUTINE DELEN(IUE,NENEW,XP,YP,NDNEW,IDE,IDU)
C
C Vynechani zrusenych elementu (ide=1) a uzlu (idu=1)
C
      DIMENSION IUE(3,*),XP(*),YP(*),IDE(*),IDU(*)
C Nejprve elementy
      NE=NENEW
      IE=1
      DO WHILE(IE.LE.NE)
         IF(IDE(IE).NE.0)THEN
            DO J=IE,NE-1
               DO K=1,3
                  IUE(K,J)=IUE(K,J+1)
               ENDDO
               IDE(J)=IDE(J+1)
            ENDDO
            IDE(NE)=0
            NENEW=NENEW-1
         ELSE
            IE=IE+1
         ENDIF
      ENDDO
C
C Vynechani zrusenych uzlu a jejich precislovani ve vsech elementech
C
      ND=NDNEW
      IU=1
      DO WHILE(IU.LE.ND)
         IF(IDU(IU).NE.0)THEN
           DO J=IU,ND-1
              XP(J)=XP(J+1)
              YP(J)=YP(J+1)
              IDU(J)=IDU(J+1)
           ENDDO
           IDU(ND)=0
           NDNEW=NDNEW-1
           DO J=1,NENEW
              DO K=1,3
                 IF(IUE(K,J).GE.IU)IUE(K,J)=IUE(K,J)-1
              ENDDO
           ENDDO
         ELSE
           IU=IU+1
         ENDIF
      ENDDO
      END

