C RUNMOD.for
C
$IF DEFINED (compaq)
      USE DFLIB
$ELSE
      USE MSFLIB
$ENDIF
      LOGICAL PRESSED
      CHARACTER*1 C
      INCLUDE '$FEMLOC'
C
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      CALL READBIN(1,IEND)
      IENDCHECK=0
      OPEN(9,FILE='$RUNMOD.OUT')
      SELECT CASE(KEYW)
      CASE('INIMOD')
         WRITE(9,'('' Initialization of time integration routine'')')
         CALL RPNINI
      CASE('IMPULS')
         WRITE(9,'('' Impulse response integration (stimul.ignored)'')')
         CALL RUMODL(0)
      CASE('CONVOL')
         WRITE(9,'('' Response to a stimulus function (ZERO I.C.)'')')
         CALL RUMODL(1)
      CASE('INTEGR')
         WRITE(9,'('' Response to stimulus functions (I.C.respected'')')
         CALL RUMODL(2)
      ENDSELECT
      PRESSED=PEEKCHARQQ()
      IF(PRESSED)THEN
          C=GETCHARQQ()
          IENDCHECK=ICHAR(C)
      ENDIF
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE
      CLOSE(1)
      CLOSE(10)
      END

      SUBROUTINE RPNINI
C
C Provedeni interpretace programu \\INI sekce
C SUBROUTINE CVAL(ITC,Time,Cv,ISMOOTH)
C     Preda hodnotu krivky ITC (2,...,MAXSEL) v case Time do promenne Cv
C
      INCLUDE '$FEM'
      EXTERNAL TFUW
      TIME=0
C hodnoty vstupnich a vystupnich funkci v case 0
      DO I=1,NINPUTS
         CALL CVAL(MINPUTS(I),0.,XINPUTS(I),1)
      ENDDO
      DO I=1,NOUTPUTS
         CALL CVAL(MOUTPUTS(I),0.,YOUTPUTS(I),1)
      ENDDO
C vynulovani derivaci i c(i)
      DO I=1,NEQUAT
         CMODEL(I,1)=0.
         CMODEL(I,2)=0.
      ENDDO
      CALL TINQ(MODRPN,MIRPN,IAUX,TFUW,WESULT,9)
      END

      SUBROUTINE RPNMOD(T,IX)
C
C Interpretace sekce \\MOD v case T
C IX=0 nulovani vzruchovych funkci
C SUBROUTINE CVAL(ITC,Time,Cv,ISMOOTH)
C     Preda hodnotu krivky ITC (2,...,MAXSEL) v case Time do promenne Cv
C     ISMOOTH=0  linearni interpolace,=1  kvadraticka interpolace
C Vstupni parametry ze zony FEM
C NINPUTS  - pocet vstupnich funkci  MINPUTS(1),...,MINPUTS(NINPUTS)
C NOUTPUTS - pocet odezvovych funkci MOUTPUTS(1),...,MOUTPUTS(NOUTPUTS)
      INCLUDE '$FEM'
      EXTERNAL TFUW
      TIME=T
C hodnoty vstupnich a vystupnich funkci v case T
      DO I=1,NINPUTS
         IF(IX.NE.0)THEN
            CALL CVAL(MINPUTS(I),T,XINPUTS(I),1)
         ELSE
            XINPUTS(I)=0.
         ENDIF
      ENDDO
      DO I=1,NOUTPUTS
         CALL CVAL(MOUTPUTS(I),T,YOUTPUTS(I),1)
      ENDDO
      CALL TINQ(MODRPN(MIRPN+1),MMRPN,IAUX,TFUW,WESULT,9)
      END

      SUBROUTINE RUNGE(T,DT,IX)
C
C 3 kroky metody Runge-Kutta; zvetseni aktualniho casu T = T + dT
C
      INCLUDE '$FEM'
      DIMENSION FF(4),HH(4),DS(MAXCMOD),CS(MAXCMOD)
      DATA FF,HH/.1666666,2*.3333333,.1666666,2*.5,2*1./
      IF(NEQUAT.GT.MAXCMOD)THEN
           WRITE(*,*)'Too many equations'
           RETURN
      ENDIF
      IF(METHOD.NE.0)THEN
C RUNGE KUTTA
        TS=T
        DTK=HH(1)*DT
        T=TS+DTK
        DO J=1,NEQUAT
          IF(ABS(CMODEL(J,2)).GT.1E10) CMODEL(J,2)=0.
          DS(J)=CMODEL(J,2)*FF(1)
          CS(J)=CMODEL(J,1)
          CMODEL(J,1)=CS(J)+DTK*CMODEL(J,2)
        ENDDO
        DO K=2,4
          CALL RPNMOD(T,IX)
          DTK=HH(K)*DT
          T=TS+DTK
          DO J=1,NEQUAT
             DS(J)=DS(J)+CMODEL(J,2)*FF(K)
             CMODEL(J,1)=CS(J)+DTK*CMODEL(J,2)
          ENDDO
        ENDDO
        DO J=1,NEQUAT
          CMODEL(J,1)=CS(J)+DS(J)*DT
          IF(ABS(CMODEL(J,1)).GT.1E10)THEN
             WRITE(9,'('' Error in Runge, time='',e9.2)')T
             WRITE(*,*)'Calculated concentrations >1E10'
             CMODEL(J,1)=0
          ENDIF
        ENDDO
      ELSE
C EULER
        T=T+DT
        DO J=1,NEQUAT
          CMODEL(J,1)=CMODEL(J,1)+DT*CMODEL(J,2)
          IF(ABS(CMODEL(J,1)).GT.1E10)THEN
             WRITE(9,'('' Error in Euler, time='',e9.2)')T
             WRITE(*,*)'Calculated concentrations >1E10'
             CMODEL(J,1)=0
          ENDIF
        ENDDO
      ENDIF
      END

      SUBROUTINE RUMODL(IX)
C
C Vypocet vektoru odezvy CY(NY) pro dany vzruch CX(NX) a model aparatu,
C zadany jako soustava algebraickych / diferencialnich rovnic.:
C --------------------------------------------------------------------
C IX   =0 - uvazuji se pocatecni podminky a potlaci vstupy XV(i)
C      =1 - nuluji se vsechny pocatecni podminky a respektuje se funkce XV(i)
C      =2 - uvazuji se pocatecni podminky i vstupy XV(i)
C
      INCLUDE '$FEMLOC'
      LOGICAL DTHIGH
      EXTERNAL TFUW
      DIMENSION CS(MAXCMOD),DS(MAXCMOD),CSF(MAXCMOD),YSCALE(MAXCMOD)
C
C Inicializace (pocatecni podminky C(i))
C
      IF(METHOD.LT.0) EPS=10.**METHOD

      CALL RPNINI
C Korekce parametru dle zadanych mezi (mozna modifikovanych v sekci INI)
      DO J=1,NUMODP
         IF(LMODEL(J).LE.0)THEN
            WRITE(9,'('' Error in parameter '',i2,'' definition'')')J
            RETURN
         ENDIF
         IF(JMODEL(J).EQ.1)THEN
            PARAM=REALRC(LMODEL(J))
         ELSE
            PARAM=INTERC(LMODEL(J))
         ENDIF
         IF(PARAM.LT.ZMINP(J).OR.PARAM.GT.ZMAXP(J))THEN
             PARAM=AMIN1(ZMAXP(J),AMAX1(ZMINP(J),PARAM))
             IF(JMODEL(J).EQ.1)THEN
                 REALRC(LMODEL(J))=PARAM
             ELSE
                 INTERC(LMODEL(J))=PARAM+.5
             ENDIF
         ENDIF
      ENDDO
C Pri konvoluci IX=1 vynulujeme vsechny pocatecni podminky
      IF(IX.EQ.1)THEN
         DO J=1,NEQUAT
            CMODEL(J,1)=0.
         ENDDO
      ENDIF
C
C <------CYKLUS CASOVYCH KROKU IND=1,...,NTSTEP
C  DTIME-tabelacni krok
C  DT   -integracni krok
C
      DT=DTIME/MAX(1,IABS(METHOD))
      DTMIN=DTIME*.002
      T=0
      DO IND=1,NTSTEP
         TIND=T
         CALL RPNMOD(T,IX)
C Ulozeni NOUTPUTS vypoctenych hodnot
         CALL SAVEOUT(IND,T)
C
         IF(METHOD.GE.0)THEN
C konstantni integracni krok DT
            CALL RUNGE(T,DT,IX)
            DO I=2,METHOD
               CALL RPNMOD(T,IX)
               CALL RUNGE(T,DT,IX)
            ENDDO
         ELSE
C promenny integracni krok DT
            TLAST=T+DTIME
100         DTC=DT
            DT=AMIN1(DT,TLAST-T)
            DO J=1,NEQUAT
               YSCALE(J)=ABS(CMODEL(J,1))+ABS(DT*CMODEL(J,2))+1E-7
               CS(J)=CMODEL(J,1)
               DS(J)=CMODEL(J,2)
            ENDDO 
            TS=T
            DTHIGH=.TRUE.
C plny krok DT
 20         CALL RUNGE(T,DT,IX)
            DO J=1,NEQUAT
              CSF(J)=CMODEL(J,1)
              CMODEL(J,1)=CS(J)
              CMODEL(J,2)=DS(J)
            ENDDO
C polovicny dvoukrok DTH
            DTH=DT*.5
            T=TS
            CALL RUNGE(T,DTH,IX)
            CALL RPNMOD(T,IX)
            CALL RUNGE(T,DTH,IX)
C porovnani C(DTH) a CSF(DT)
            ERRMAX=0.
            DO J=1,NEQUAT
              CSF(J)=CMODEL(J,1)-CSF(J)
              ERRMAX=AMAX1(ERRMAX,ABS(CSF(J))/YSCALE(J))
            ENDDO
            ERRMAX=ERRMAX/EPS
            IF(ERRMAX.GT.1..AND.DT.GT.DTMIN)THEN
C zkraceni DT a navrat na zacatek
               DT=.9*DT*ERRMAX**(-.25)
               DO J=1,NEQUAT
                 CMODEL(J,1)=CS(J)
                 CMODEL(J,2)=DS(J)
               ENDDO
               T=TS
               DTHIGH=.FALSE.
               GOTO20
            ELSE
               IF(DTC.GT.DT.AND.DTHIGH)THEN
                  DT=DTC
               ELSEIF(ERRMAX.GT.6E-4)THEN
                  DT=0.9*DT*ERRMAX**(-.2)
               ELSE
                  DT=4.*DT
               ENDIF
C vylepseni vysledku
               DO J=1,NEQUAT
                  CMODEL(J,1)=CMODEL(J,1)+CSF(J)/15.
               ENDDO
               IF(T.LT.TLAST-DTMIN)THEN
                  CALL RPNMOD(T,IX)
                  GOTO 100
               ENDIF
            ENDIF
         ENDIF
         T=TIND+DTIME
      ENDDO
C ulozeni vektoru parametru modelu do interface
      END

      SUBROUTINE SAVEOUT(IND,T)
C Ulozeni docasnych hodnot Y 
      INCLUDE '$FEM'
      DO I=1,NOUTPUTS
         LOC=MOUTPUTS(I)
         YGR(IND,1)=T
         YGR(IND,LOC)=YOUTPUTS(I)
      ENDDO
      END

C      INCLUDE '$$-COMM.FOR'
C      INCLUDE '$$-COME.FOR'
C	INCLUDE '$RUN-COL.FOR'
