
      SUBROUTINE CTMESH(XP,YP,N,IC,IB,IQ,NC,IUE,NE,CONTROL,CONEAR,NFAIL,
     /                  MAXQ)
      DIMENSION XP(*),YP(*),IC(*),IB(*),IQ(*),IUE(3,*)
C XP(N),YP(N) - uzlove body (na vstupu pouze N-hranicnich bodu obrysu)
C IC(NC)      - cyklicky seznam nasledniku
C IB(NC)      - index uzlu XP,YP
C N - vstupni i vystupni parametr
C CONTROL - urcuje miru vysky generovanych elementu
C CONEAR  - relativni vzdalenost prohledavani
      PARAMETER (PI=3.141)
      NE=0
      J0=1
C Prochazka seznamem a zjisteni prumerne delky elementu
      L1=J0
      DMEAN=0.
      DO I=1,NC
        K1=IB(L1)
        L1=IC(L1)
        K2=IB(L1)
        D=SQRT((XP(K1)-XP(K2))**2+(YP(K1)-YP(K2))**2)
        DMEAN=DMEAN+D
      ENDDO
      DMEAN=DMEAN/NC
      NCMAX=NC
      NFAIL=0
      DO WHILE(NFAIL.LE.40.AND.NC.GT.1)
      WRITE(4,'(/'' CTMESH N-failure='',I2,'' NElements='',I5,'' Nodes='
     /',I5,'' Cyclic list NC='',I4)')NFAIL,NE,N,NC
C
C Nalezeni prvniho segmentu za J0 (J0 a IC(J0)), kde je mozne generovat element
C
        CALL SIDE(J0,IC,IB,IQ,XP,YP,JNEW)        
        J0=JNEW
        IF(J0.LE.0)THEN
           WRITE(4,'(/'' Side for new element was not found. STOP'')')
           RETURN
        ENDIF
      WRITE(4,'('' SIDE-starts at J0='',I4,'' which is NODE'',I4)')J0,
     / IB(J0)
C
C Generuj novy trojuhelnik nad segmentem J0-IC(J0)
C
        CALL GENELE(J0,IC,IB,XP,YP,IUE,NE,NCMAX,N,DMEAN,JNEW,
     /              NFAIL,CONTROL,CONEAR,MAXQ)
        J0=JNEW
      WRITE(4,'('' GENELE-NE='',I4,'' next side='',I4)')NE,J0
C
C Vynechani nulovych useku a zjisteni delky cesty NC
C
        CALL REDUCE(J0,IC,IB,IQ,NC)
      WRITE(4,'('' REDUCE-NC='',I4,'' new J0='',I4)')NC,J0
C
C Vynechani degenerovanych elementu
C
        IF(NE.GT.0)THEN
          CALL DEGELE(IUE(1,NE),XP,YP,IEND)
          IF(IEND.NE.0)THEN
            WRITE(4,*)' DEGELE-degenerated elements eliminated. NE',NE
            NFAIL=NFAIL+1
            NE=NE-1
          ENDIF
        ENDIF
      ENDDO
      WRITE(4,'('' CTMESH ends giving'',i4,'' elements and'',i4,'' nodes
     /.'')')NE,N
      END

      SUBROUTINE REDUCE(J0,IC,IB,IQ,NC)
C Vynechani nasledniku na identicky uzel a zjisteni delky seznamu
C Redukce seznamu na zaklade informaci IQ o blokovani segmentu (IQ=-1)
      DIMENSION IC(*),IB(*),IQ(*)
      L1=J0
      NC=0
C Redukce seznamu o identicke prvky seznamu
      DO WHILE(.TRUE.)
        L2=IC(L1)
        L3=IC(L2)
        K1=IB(L1)
        K2=IB(L2)
        IF(K1.EQ.K2)THEN
          IC(L1)=L3
          L1=L3
          IF(L2.EQ.J0)J0=L1
          WRITE(4,*)' REDUCE-COINCIDENT POINTER IN NODE',K1
        ELSE
          L1=L2
          NC=NC+1
        ENDIF
        IF(L1.EQ.J0)EXIT
      ENDDO
C Vyhledani blokovanych smycek a jejich vyrazeni.
      L1=J0
      L0=0
      LP=0
      LPP=0
      K0=0
      DO I=1,NC
        L2=IC(L1)
        K1=IQ(L1)
        IF(K0.EQ.-1.AND.K1.EQ.-1.AND.L0.GT.0.AND.LP.GT.0.AND.
     /     IB(L2).EQ.IB(L0))THEN
C Konec uzavrene smycky prehodime pointer 
           IC(LP)=L2
           K0=IQ(LP)
           L0=LP
           LP=LPP
           LPP=0
        ELSE              
           K0=K1
           LPP=LP
           LP=L0
           L0=L1
        ENDIF
        L1=L2
      ENDDO
      J0=L1
      END

      SUBROUTINE DEGELE(IUE,XP,YP,IEND)
      DIMENSION IUE(3),XP(*),YP(*)
C TEST PRIJATELNOSTI TROJUHELNIKOVEHO ELEMENTU
      IF(IUE(1).EQ.IUE(2).OR.
     /   IUE(2).EQ.IUE(3).OR.
     /   IUE(1).EQ.IUE(3))THEN
          IEND=1
          XD=XP(1)
          YD=YP(1)
      ELSE
          IEND=0
      ENDIF
      END

      SUBROUTINE SIDE(J0,IC,IB,IQ,XP,YP,JNEW)        
C Nalezeni prvni strany, ktera nasleduje za J0 a kde lze vytvorit element.
C Pokud takova strane neexistuje je JNEW=0. Strany, ktere byly blokovany
C se oznaci indexem IQ=-1
      DIMENSION IC(*),IB(*),IQ(*),XP(*),YP(*)
      J1=J0
      JSTART=J0
      JNEW=0
      DO WHILE(.TRUE.)
        KA=IB(J1)
        J2=IC(J1)
        KB=IB(J2)
        XA=XP(KA)
        YA=YP(KA)
        XB=XP(KB)
        YB=YP(KB)
        XT=(XA+XB)*.5
        YT=(YA+YB)*.5
        XC=XT+(YA-YB)*0.002
        YC=YT+(XB-XA)*0.002
        JBEG=J0
        CALL PTCIN(XC,YC,XP,YP,JBEG,IC,IB,NC,IN)
        IF(IN.EQ.1)THEN
C Usecka J1-J2 muze generovat trojuhelnik
          IF(JNEW.EQ.0)JNEW=J1
        ELSE
C Usecka J1-J2 nemuze generovat trojuhelnik (blokuje ho protilehly obrys)
          IQ(J1)=-1
        ENDIF
        J1=J2
        IF(J2.EQ.JSTART)EXIT
      ENDDO
      END

      SUBROUTINE GENELE(J0,IC,IB,XP,YP,IUE,NE,NCMAX,N,DMEAN,J1,
     /                  NFAIL,CONTROL,CONEAR,MAXQ)
C
C generovani elementu nad segmentem J0-IC(J0)
C
      DIMENSION IC(*),IB(*),XP(*),YP(*),IUE(3,*)
C
      JA=J0
      JB=IC(JA)
      KA=IB(JA)
      KB=IB(JB)
      XA=XP(KA)
      YA=YP(KA)
      XB=XP(KB)
      YB=YP(KB)
      DISAB=SQRT((XA-XB)**2+(YA-YB)**2)
C DISCO je pokus o omezeni prohledavaci vzdalenosti vzhledem ke stredni
C delce elementu
      DISCO=AMIN1(DMEAN*5,DISAB*CONEAR)
      XT=(XA+XB)*.5
      YT=(YA+YB)*.5
      IF(DISAB.GT.0.)THEN
C Verze s odmocninou je dle testu horsi. Zda se, ze vyrazne prodluzovani
C vysky brani vytvareni drobnych elementu.
C        ALFA=AMAX1(0.2,AMIN1(1.5,SQRT(DMEAN/DISAB)*CONTROL))
         ALFA=AMAX1(0.2,AMIN1(1.5,DMEAN/DISAB*CONTROL))
      ELSE
         NFAIL=NFAIL+1
         WRITE(4,*)' GENELE-ZERO SEGMENT between points',KA,KB
         RETURN
      ENDIF
      NE=NE+1
      IF(NE.GE.MAXQ)THEN
         WRITE(4,*)' Number of elements exceeds',maxq
         STOP
      ENDIF
      IUE(1,NE)=KA
      IUE(2,NE)=KB
C
C Pokus o zaplneni uhlu s vrcholem B. Jako uzel C pouzijeme naslednika B
C
      JC=IC(JB)
      KC=IB(JC)
      XC=XP(KC)
      YC=YP(KC)
      ANGLE=PTANGLE(XA,YA,XB,YB,XC,YC,IER)
      IF(ANGLE.LE.1.0.AND.IER.EQ.0.AND.
     /       KA.NE.KB.AND.KB.NE.KC.AND.KA.NE.KC)THEN
C Test pouzitelnosti elementu
         CALL INTRI(J0,IC,IB,XP,YP,KA,KB,KC,IOK)
         IF(IOK.EQ.1)THEN
C jediny trojuhelnik
             IUE(3,NE)=KC
             IC(JA)=JC
             J1=JC
             RETURN
         ENDIF
      ENDIF
C Sousedni vrchol neprosel
      XC=XT+(YA-YB)*ALFA
      YC=YT+(XB-XA)*ALFA
C
C Hledame body obrysu ruzne od A a B, ktere lezi v pripustne polorovine,
C maji malou vzdalenost od pokusneho vrcholu C a mohou generovat element.
C Pokud je takovych bodu vic, vybirame ten, ktery ma nejmensi vzdalenost 
C od bodu C.
C
      L=J0
      DNEAR=1E10
      KNEAR=0
      DO WHILE(.TRUE.)
         L=IC(L)
         K=IB(L)
         IF(K.NE.KA.AND.K.NE.KB)THEN
            XK=XP(K)
            YK=YP(K)
            DK=(XB-XA)*(YK-YA)-(YB-YA)*(XK-XA)
            DISKC=SQRT((XK-XC)**2+(YK-YC)**2)
C           IF(DK.GT.0..AND.DISKC.LE.DISAB*.6)THEN
            IF(DK.GT.0..AND.DISKC.LE.DISCO)THEN
C
C Testujeme, zda KA-KB-K muze byt elementem
C 
              CALL INTRI(J0,IC,IB,XP,YP,KA,KB,K,IOK)
              IF(IOK.EQ.1.AND.DISKC.LT.DNEAR)THEN
                 DNEAR=DISKC
                 KNEAR=K
              ENDIF
            ENDIF
         ENDIF
         IF(L.EQ.J0)EXIT
      ENDDO
C
C Pokud byl vyber uspesny vytvor trojuhelnik KA-KB-KNEAR a zmen obrys
C
      IF(KNEAR.GT.0)THEN
         IUE(3,NE)=KNEAR
         NCMAX=NCMAX+1
         IF(NCMAX.GT.MAXQ)THEN
            WRITE(4,*)' Number of segments of cyclic list exceeds',maxq
            STOP
         ENDIF
         IC(JA)=NCMAX
         IC(NCMAX)=JB
         IB(NCMAX)=KNEAR
      ELSE
C
C Vygenerovani noveho uzlu C. 
C N=pocet uzlu, na pozici N+1 ulozime pokusny uzel C
C
         NAUX=N+1
         IF(NAUX.GT.MAXQ)THEN
            WRITE(4,*)' Number of nodes exceeds',maxq
            STOP
         ENDIF
         BETA=1.
         IOK=0
         DO WHILE(IOK.EQ.0.AND.BETA.LE.10.)
            XC=XT+(YA-YB)*ALFA/BETA
            YC=YT+(XB-XA)*ALFA/BETA
            XP(NAUX)=XC
            YP(NAUX)=YC
            CALL INTRI(J0,IC,IB,XP,YP,KA,KB,NAUX,IOK)
            BETA=1.3*BETA
         ENDDO
         IF(IOK.EQ.1)THEN
            XC=XT+(YA-YB)*ALFA/BETA
            YC=YT+(XB-XA)*ALFA/BETA
            XP(NAUX)=XC
            YP(NAUX)=YC
            N=NAUX
            IUE(3,NE)=NAUX
            NCMAX=NCMAX+1
            IC(JA)=NCMAX
            IC(NCMAX)=JB
            IB(NCMAX)=NAUX
          ELSE
            NFAIL=NFAIL+1
            NE=NE-1
          ENDIF
      ENDIF      
      J1=JB
      END

      SUBROUTINE INTRI(J0,IC,IB,XP,YP,K1,K2,K3,IOK)
C
C Dan trojuhelnik K1,K2,K3 a seznam IC (pocatek J0). Testujeme, 
C zda trojuhelnik muze byt elementem, pak je IOK=1.
C
      DIMENSION IC(*),IB(*),XP(*),YP(*),XT(3),YT(3)
      REAL*8 DET,TAB,T12
      LOGICAL VA,VB
      XT(1)=XP(K1)
      XT(2)=XP(K2)
      XT(3)=XP(K3)
      YT(1)=YP(K1)
      YT(2)=YP(K2)
      YT(3)=YP(K3)
      LA=J0
      DO WHILE(.TRUE.)
        KA=IB(LA)
        LB=IC(LA)
        KB=IB(LB)
        VA=KA.EQ.K1.OR.KA.EQ.K2.OR.KA.EQ.K3
        VB=KB.EQ.K1.OR.KB.EQ.K2.OR.KB.EQ.K3
C
C neni element A-B totozny s nekterou stranou trojuhelniku?
C
        IF(.NOT.(VA.AND.VB))THEN
C
C Jsou body A a B uvnitr?
C
           CALL EINS2D3(XT,YT,XP(KA),YP(KA),INA)
           CALL EINS2D3(XT,YT,XP(KB),YP(KB),INB)
C
C IN=1 uvnitr, IN=-1,-2,-3 na hranici, IN=0 bod lezi vne
C
           IF(INA.GT.0.OR.INB.GT.0 .OR.
     /       (INA.LT.0.AND..NOT.VA).OR.
     /       (INB.LT.0.AND..NOT.VB)) THEN
              IOK=0
              RETURN
           ELSE
C
C Bod A i bod B jsou vne trojuhelniku. Bod A muze byt vrcholem. Stanoveni pruseciku.
C
              XA=XP(KA)
              YA=YP(KA)
              XB=XP(KB)
              YB=YP(KB)
              DO I1=1,3
                 I2=MOD(I1,3)+1
C Prusecik strany I1-I2 a usecky A-B
                 DET=(XT(I2)-XT(I1))*(YA-YB)-(YT(I2)-YT(I1))*(XA-XB)
                 IF(DET.NE.0.)THEN
                    T12=((XA-XT(I1))*(YA-YB)-(YA-YT(I1))*(XA-XB))/DET
                    TAB=((XT(I2)-XT(I1))*(YA-YT(I1))-(YT(I2)-YT(I1))*
     /                      (XA-XT(I1)))/DET
                    IF(T12.GE.0..AND.T12.LE.1..AND.
     /                 TAB.GT.1D-6.AND.TAB.LT.0.999999D0)THEN
C existuje prusecik, ktery neni koncovym bodem usecky A-B
                             IOK=0
                             RETURN
                    ENDIF
                 ENDIF
              ENDDO
           ENDIF
        ENDIF
        LA=LB
        IF(LA.EQ.J0)EXIT
      ENDDO
      IOK=1
      END       

C      INCLUDE '$$-COMM.FOR'
C	INCLUDE '$$-COME.FOR'
C	INCLUDE '$RUN-COL.FOR'
