C WAFFLE FOAM FD
      parameter (pi=3.141)
	real epsi(100),ti(100),rhoi(100),hti(100),hei(100),
     /     f1i(100),f2i(100),fi(100),uz(100),lami(100),
     /     ad(100),bd(100),cd(100),rd(100),tnew(100)
C Mesc-celkova hmotnost unikle pary
      real K,n,lams,lamw,lamv,lamm
C jednoprikazove funkce T je ve stupnich Celsia
	FCs(T)=1136+3.56*T
	FCw(T)=4170+0.5*T
	Flams(T)=0.0976+0.00167*T
      Flamw(T)=0.58+0.0012*T
      Fdh(T)=2.255e6*((374.15-T)/274.5)**0.38
	FK(T)=5.672*exp(4960/(T+273.15))
C  p=B.exp(-dh/RT) 
	B=4.81e10
	n=0.4
	Rgas=461.9
	Tw=180
	T0=100
	Tb0=373.
c fiktivni rychlost (setina mm/s)
      u0=1e-5
C hmotnst a slozeni vzorku. 
C OMEGAW-podil vody
      omegaw=0.6
	omegas=0.4
	rhos=1648
	rhow=1000
	lamv=0.02
c polovicni tloustka H
	H=0.002
	dt=0.1
	imax=100
c tepelna kapacita pary
	cv=0.02
	open(1,file='foamfd.out')
c pocet uzlu site
      m=50
	dz=H/(m-1)
c pocatecni podminky
      do i=1,m
	   epsi(i)=0
	   ti(i)=t0
	enddo
	ti(m)=tw
c cyklus casovych kroku
C------------------------------------------------
      do itime=1,imax
c termofyzikalni parametry v uzlech
	  do i=1,m
	     z=(i-1)*dz
	     T=ti(i)
	     eps=epsi(i)
	     lams=Flams(T)
	     lamw=Flamw(T)
	     lam=omegaw*lamw+omegas*lams
	     cs=Fcs(T)
	     cw=Fcw(T)
           dh=Fdh(T)
	     Tk=T+273.1
           p=B*exp(-dh/(Rgas*Tk))
	     k=fk(T)
           F=(n/(4*k*(2*sqrt(3.))**(n-1)))**(1/n)
	     Fi(i)=F
           f1i(i)=p**(1/n)*
     /            (1-exp(-dh/rgas*(1/tb0-1/tk)))**(1/n)
           f2i(i)=p**(1/n)*dh/(n*rgas*tk**2)*
     /            (1-exp(-dh/rgas*(1/tb0-1/tk)))**((1-n)/n)
	     hti(i)=omegas*cs+omegaw*cw+dh*eps/(1-eps)*
     /            p/(rgas*tk**2)*(dh/(rgas*tk)-1)*
     /            (rhos*omegaw+rhow*omegas)/(rhos*rhow)
           hei(i)=dh/(1-eps)**2*p/(rgas*tk)*
     /            (rhos*omegaw+rhow*omegas)/(rhos*rhow)
	     uz(i)=3*f*f1i(i)*u0*(z/H-(z/H)**2)
	     rhov=p/(rgas*tk)
	     rhoi(i)=eps*rhov+(1-eps)*rhow*
     /             (1+omegas*(rhos-rhow)/(rhos*omegaw+rhow*omegas))
           lamm=omegaw*lamw+omegas*lams
	     lami(i)=lamm*(1-eps*(1-0.05/lamm))
        enddo
c generovani tridiagonalni soustavy
        do i=2,m-1
	    fe=3*fi(i)*hei(i)*(1-epsi(i)**2)
          ad(i)=-(lami(i-1)+lami(i))/(2*dz**2)
          cd(i)=-(lami(i+1)+lami(i))/(2*dz**2)
	    bd(i)=rhoi(i)*hti(i)/dt+fe*rhoi(i)*f2i(i)
     /           -ad(i)-cd(i)
	    rd(i)=rhoi(i)*(hti(i)/dt+fe*f2i(i))*ti(i)-
     /          fe*rhoi(i)*f1i(i)-rhoi(i)*uz(i)/(2*dz)*
     /          (hti(i)*(ti(i+1)-ti(i-1))+hei(i)*(epsi(i+1)-epsi(i-1)))
	   enddo
c okrajove podminky
         ad(m)=0
	   bd(m)=1
	   rd(m)=Tw
	   bd(1)=1
	   cd(1)=-1
	   rd(1)=0
c reseni tridiagonalni soustavy pro teploty
         call tridag(ad,bd,cd,rd,tnew,m)
c         write(1,'(5e11.3,5x,5e11.3)')(ati(i),i=1,5),(ti(i),i=m-4,m)
	
c porozity
        do i=1,m
	    ff=3*fi(i)*dt*f1i(i)
	    epsi(i)=(epsi(i)*(1+ff)+ff)/(1+ff*(1+epsi(i)))
	    ti(i)=tnew(i)
        enddo
	  write(1,*)' time step=',itime,' temperatures and eps'
        write(1,'(5e11.3,5x,5e11.3)')(ti(i),i=1,5),(ti(i),i=m-4,m)
        write(1,'(5e11.3,5x,5e11.3)')(epsi(i),i=1,5),(epsi(i),i=m-4,m)
	enddo     
	end

      SUBROUTINE TRIDAG(A,B,C,R,U,N)
c
c Tridiagonal linear set of equations (A-lower, B-diagonal, C-upper, R-RHS)
c according to Press: Numerical recipes, p. 40
c Vectors A,B,C,R are not destroyed.
c
      parameter (nmax=100)
      real gam(nmax),a(n),b(n),c(n),r(n),u(n)
      bet=b(1)
      u(1)=r(1)/bet
      do j=2,n
         gam(j)=c(j-1)/bet
         bet=b(j)-a(j)*gam(j)
         u(j)=(r(j)-a(j)*u(j-1))/bet
      enddo
      do j=n-1,1,-1
         u(j)=u(j)-gam(j+1)*u(j+1)
      enddo
      end


