      SUBROUTINE FOAMINT(timax,H,M,OMEGAW,AALFA,PSI,RKONSIST,RB0,
     /                   a1,a2,a3,a4)
C OMEGAW - hmotnostni podil vody (pocatecni)
C AALFA - Vcrust=AALFA*V0*epsilon
C PSI - permeabilita (prutok = PSI * deltap)
C RKONSIST - preexponencialni faktor konzistence
C Rb0 - pocatecni rozmer bublin
C A1,...A4 korekce soucinitelu prenosu tepla (default =1)
      INCLUDE '$FEM'

C WAFFLE FOAM
C      parameter (pi=3.141)
C Mesc-celkova hmotnost unikle pary
      real M,Mc,Ms,Mw0,Mw,Mv,Mf0,Mf,Mb0,Mb,Mesc,
     /K,n,lams,lamw,lamv,lam
C jednoprikazove funkce T je ve stupnich Celsia
	FCs(T)=1136+3.56*T
	FCw(T)=4170+0.5*T
	Flams(T)=0.0976+0.00167*T
      Flamw(T)=0.58+0.0012*T
      Fdh(T)=2.255e6*((374.15-T)/274.5)**0.38
C	FK(T)=0.672*exp(4960/(T+273.15))
	FK(T)=RKONSIST*exp(4960/(T+273.15))
	IF(DTIME.LE.0..OR.TIMAX.LE.0.)RETURN
C  p=B.exp(-dh/RT) 
	B=4.81e10
	n=0.4
	Rgas=461.9
C PSI.(p-pa) = prutok kg/s
C	Psi=2e-10
	Tw=180
	T0=30
C hmotnst a slozeni vzorku. 
C OMEGAW-podil vody
C Z0=Mb0/Mf0   sorption isotherm
C      omegaw=0.6
	Z0=0.02/0.04
C	M=0.25
	Ms=M*(1-omegaw)
	Mw0=M*omegaw
	Mf0=M*omegaw/(1+Z0)
	Mb0=M*omegaw*Z0/(1+Z0)
C      Rb0=2e-6
	Nb=670000
	rhos=1648
	rhow=1000
	rho0=rhos*(1-omegaw)+rhow*omegaw
	lamv=0.02
c	H=0.008
C	dtime=1
c	timax=2400
c rozmery A-celkova teplosmenna plocha (z obou stran)
      Vs=Ms/rhos
	Vw=Mw0/rhow
	V=Vs+Vw
	V0=V
	Vmax=2*V0
	A=2*V/H
      T=T0
	Rb=Rb0
	pa=1e5
c tepelna kapacita pary
	cv=0.02
C	open(1,file='foam.out')
      MAXN=MIN0(MAXNTS,INT(TIMAX/DTIME))
C faze I.
C------------------------------------------------
      ITIME=0
	Mw=Mw0
	Mf=Mf0
	Mb=Mb0
	Mesc=0
	time=0
	do while(T.le.100..AND.ITIME.LT.MAXN)
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
	  time=time+dtime
	  lams=Flams(T)
	  lamw=Flamw(T)
	  lam=(Mw*lamw+Ms*lams)/M
	  rho=(Mw*rhow+Ms*rhos)/M
	  cs=Fcs(T)
	  cw=Fcw(T)
	  c=(Mw*cw+Ms*cs)/M
c A1-korekce soucinitele prenosu tepla 
        alfa=amax1(2*lam/H,sqrt(lam*rho*c/(pi*time)))*A1
	  Mc=Ms*cs+Mw0*cw
	  T=T+dtime*alfa*a*(Tw-T)/Mc
C	  write(1,'(2f10.0)')time,T
        YGR(ITIME,2)=T
	  YGR(ITIME,3)=1
	enddo

C faze II. expanze bublin - ukoncena zaplnenim formy
C -------------------------------------------------------
      do while(V.le.Vmax.AND.ITIME.LT.MAXN)
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
	  time=time+dtime
        T=amin1(374.,amax1(100.,T))
	  Tk=T+273.15
C vyparne teplo
        dh=Fdh(T)
	  lams=Flams(T)
	  lamw=Flamw(T)
	  lam=(Mw*lamw+Ms*lams)/M
	  cs=Fcs(T)
	  cw=Fcw(T)
C rovnovazny tlak
        p=B*exp(-dh/(Rgas*Tk))
C polomer bubliny
	  k=fk(T)
        w=(n/(4*k*(2*sqrt(3.))**(n-1)))**(1/n)
	  dpn=(p-pa)**(1/n)
	  Rb=Rb*exp(dtime*w*dpn)
        write(10,'('' alf='',f5.1,'' V='',e10.3,'' T='',f6.1)')aalfa,v,t
      if(aalfa.ge.0.)then
C verze CRUST
C hmotnosti fazi
        Vv=Nb*4./3.*pi*Rb**3
        Mv=Vv*p/(Rgas*Tk)
        V=Ms/rhos+Mw0/rhow+Mv*(Rgas*Tk/p-1/rhow)
	  eps=Vv/V       
	  Mc=Ms*cs+(Mw0-Mv)*cw+Mv*cv
	  AII=(1-aALFA*EPS)*(Mc+dh*Mv*(dh/(Rgas*Tk**2)-1/Tk))
	  PII=3*W*dpn*(dh*Mv*(1-2*aalfa*eps)-
     /      aalfa*eps*(Mc*T-rho0*omegaw*V0))	  
c A2-korekce soucinitele prenosu tepla
	  AH=4/H**2*(lamv*Vv+lam*(V-Vs))*A2
C diferencialni rovnice entalpie, implicitni
        T=(AII*T+dtime*(AH*Tw-PII))/(AII+dtime*AH)
C rychlost odparovani
        dMdt=3*Vv*aalfa*rho0*omegaw*w*dpn*(1-eps)**2
c	  if(aalfa.gt.0.)psi=dMdt/(p-pa)
	  Mesc=Mesc+dMdt*dtime
      else
C stara verze alfa<0
C hmotnosti fazi
        Vv=Nb*4./3.*pi*Rb**3
        Mv=Vv*p/(Rgas*Tk)
        V=Ms/rhos+Mw0/rhow+Mv*(Rgas*Tk/p-1/rhow)
	  Mc=Ms*cs+(Mw0-Mv)*cw+Mv*cv+((cv-cw)*T+dh)*
     /     (dh/(Rgas*Tk**2)-1./Tk)*Mv
	  Psig=3*Mv*w*((cv-cw)*T+dh)
c A2-korekce soucinitele prenosu tepla
	  AH=4/H**2*(lamv*Vv+lam*(V-Vs))*A2
C diferencialni rovnice entalpie, implicitni
        T=(Mc*T/dtime+AH*Tw-psig*(p-pa)**(1/n))/(Mc/dtime+AH)
      endif
C	  write(1,'(2f10.0,f12.3)')time,T,p/1e5
        YGR(ITIME,2)=T
	  YGR(ITIME,3)=P/1E5
	enddo
	
C faze III. unik pary za soucasne existence volne vody
C -------------------------------------------------------
	do while(Mf.gt.0..AND.ITIME.LT.MAXN)
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
	  time=time+dtime
	  Tk=T+273.15
C vyparne teplo
        dh=Fdh(T)
	  lams=Flams(T)
	  lamw=Flamw(T)
	  lam=(Mw*lamw+Ms*lams)/M
	  cs=Fcs(T)
	  cw=Fcw(T)
C rovnovazny tlak
        p=B*exp(-dh/(Rgas*Tk))
	  Mv=(Vmax-V0)*p/(Rgas*Tk)
	  Psip=Psi*(p-pa)
	  Mesc=Mesc+Psip*dtime
	  Mf=Mf0-Mesc-Mv
	  Mc=Ms*cs+(Mw0-Mesc-Mv)*cw+Mv*cv+(dh-(cw-cv)*T)*
     /     Mv*(dh/(Rgas*Tk**2)-1/Tk)
C A3-korekce soucinitele prenosu tepla
	  AH=4/H**2*(lamv*Vv+lam*(Vmax-Vs))*A3
        T=(Mc*T/dtime+AH*Tw-Psip*dh)/(Mc/dtime-Psip*(cw-cv)+AH)
C	  write(1,'(2f10.0,f12.3,e12.5)')time,T,p/1e5,Mf
        YGR(ITIME,2)=T
	  YGR(ITIME,3)=P/1E5
        YGR(ITIME,4)=MF
      enddo
C faze IV. unik pary jen vazana voda. Zvysene vyparne teplo
C -------------------------------------------------------
      alfa=2.255e6*(Mb0/Ms+0.005)*((374-T)/274)**0.38
C fi-urceno z III.faze
      fi=Psi*(p-pa)/Mb0
	do while(ITIME.LT.MAXN)
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
	  time=time+dtime
	  Tk=T+273.15
C vyparne teplo
        dh=Fdh(T)
	  dhb=alfa/(Mb/Ms+0.005)
	  lams=Flams(T)
	  lamw=Flamw(T)
	  lam=(Mw*lamw+Ms*lams)/M
	  cs=Fcs(T)
	  cw=Fcw(T)
	  dMdt=fi*Mb
	  Mesc=Mesc+dMdt*dtime
C Tlak je dan prutokem pary, ale jiz nekontroluje teplotu
        p=pa+dMdt/Psi
        Mv=(Vmax-V0)*p/(Rgas*Tk)
	  Mb=Mw0-Mesc-Mv
	  Mc=Ms*cs+Mb*cw+Mv*(cv+(dh/(Rgas*Tk**2)-1/Tk)*(dh-(cw-cv)*T))
c A4-korekce suoucinitele prenosu tepla
	  AH=4/H**2*(lamv*Vv+lam*(Vmax-Vs))*A4
        T=(Mc*T/dtime-dMdt*dhb+AH*Tw)/(Mc/dtime-dMdt*(cw-cv)+AH)
c	  write(1,'(2e12.5)')time,T
        YGR(ITIME,2)=T
	  YGR(ITIME,3)=P/1E5
        YGR(ITIME,4)=0
	enddo     
	ngr=itime
	end


        