      SUBROUTINE FOAMEST(TIII,dtIII,dtI,H,M,OMEGAW,T0,
     /                   EPSf,K,PSI,EM,EN,
     /                   a1,a2,a3,a4)
C ODHADY PARAMETRU pro proceduru FOAMIS
C Zjednodusena verze integralniho modelu zalozena na empirickem modelovem vztahu
C porozita      eps = k dp^Em
C permeabilita  dMdt= psi . dp^En  (tyka se jen jedne bubliny)
C
C Odhaduje se K,PSI,A1,A3
C 
C H-tloustka
C M0-hmotnost pocatecni
C OMEGAW - hmotnostni podil vody (pocatecni)
C T0 - pocatecni teplota
C EPSf - finalni porozita
C A1,...A4 korekce soucinitelu prenosu tepla (default =1)
C
      INCLUDE '$FEM'
      real M,Mc,Ms,Mw,Mv,Mf,Mb,Mq,K,En,Em,lam
C konstantni materialove parametry
	Cs=1500
	Cw=4200
	Cv=2000
	lam=0.7
      dh=2.255e6
C  p=B.exp(-dh/RT) 
	B=4.81e10
	Rgas=461.9
	Tw=180
C hmotnost a slozeni vzorku. 
C OMEGAW-podil vody
C Z0=Mb0/Mf0   sorption isotherm
	Z0=0.02/0.04
	Ms=M*(1-omegaw)
	Mw=M*omegaw
	Mf=M*omegaw/(1+Z0)
	Mb=M*omegaw*Z0/(1+Z0)
C pocet bublin/kg vsadky =6975000  vysledek experimentu Skocilas
	Nb=6975000*M
	rhos=1648
	rhow=1000
	rho=rhos*(1-omegaw)+rhow*omegaw
c rozmery A-celkova teplosmenna plocha (z obou stran)
      Vs=Ms/rhos
	Vw=Mw/rhow
	V=Vs+Vw
	V0=V
	A=4*lam*V0/H**2
	pa=1e5
C faze III. volna voda
C -------------------------------------------------------------
      Tk=TIII+273.15
C rovnovazny tlak III
      p=B*exp(-dh/(Rgas*Tk))
	dpn=amax1(0.,p-pa)**en
	dpm=amax1(0.,p-pa)**em
C odhad K
      k=epsf/dpm
C odhad PSI
      PSI=A*(Tw-TIII)/(Nb*dpn*dh)
C odhad A3 dle doba dtIII
      A3=Mf*dh/dtIII/((Tw-TIII)*A)
C odhad A1
      A1=(Ms*cs+Mw*Cw)*(100-T0)/dtI/((Tw-(100+T0)/2.)*A)
	end

      SUBROUTINE FOAMIS(timax,H,M,OMEGAW,T0,
     /                   EPSf,Relk,PSI,EM,EN,
     /                   a1,a2,a3,a4,ictem,icpre,iceps)
C Tato procedura je volana prikazem FOAMS
C Zjednodusena verze integralniho modelu zalozena na empirickem modelovem vztahu
C porozita      eps = k dp^Em
C permeabilita  dMdt= psi . dp^En  (tyka se jen jedne bubliny)
C 
C H-tloustka
C M0-hmotnost pocatecni
C OMEGAW - hmotnostni podil vody (pocatecni)
C T0 - pocatecni teplota
C EPSf - finalni porozita
C A1,...A4 korekce soucinitelu prenosu tepla (default =1)
C
C Klicovy parametr je PSI, z neho se primo odvozuje rovnovazna teplota
C Parametr KREL je jen korekce expanze. K se ve skutecnosti pocita ze zadane
C finalni porozity a rovnovazneho tlaku.
C
C IC... sloupce matice MOP vysledku
      INCLUDE '$FEM'
      real M,Mc,Ms,Mw,Mv,Mf,Mb,Mq,K,En,Em,lam
	IF(DTIME.LE.0..OR.TIMAX.LE.0.)RETURN
C konstantni materialove parametry
	Cs=1500
	Cw=4200
	Cv=2000
	lam=0.7
      dh=2.255e6
C  p=B.exp(-dh/RT) 
	B=4.81e10
	Rgas=461.9
C PSI.(p-pa)**n = prutok pary jednou bublinou
C	Psi=1e-19
	Tw=180
C hmotnost a slozeni vzorku. 
C OMEGAW-podil vody
C Z0=Mb0/Mf0   sorption isotherm
	Z0=0.02/0.04
	Ms=M*(1-omegaw)
	Mw=M*omegaw
	Mf=M*omegaw/(1+Z0)
	Mb=M*omegaw*Z0/(1+Z0)
C pocet bublin/kg vsadky =6975000
	Nb=6975000*M
	rhos=1648
	rhow=1000
	rho=rhos*(1-omegaw)+rhow*omegaw
c rozmery A-celkova teplosmenna plocha (z obou stran)
      Vs=Ms/rhos
	Vw=Mw/rhow
	V=Vs+Vw
	V0=V
	EPS=0
	A=4*lam*V0/H**2
      T=T0
	pa=1e5
C Iteracni stanoveni teploty TIII pro zadane PSI
      AA=A*A3
	TIII=110
	do i=1,6
	  Tk=TIII+273.15
        p=B*exp(-dh/(Rgas*Tk))
	  ax=pa+(aa*(Tw-tiii)/(Nb*psi*dh))**(1./en)
	  taux=-dh/(Rgas*alog(ax/B))-273.15
	  tiii=0.4*taux+0.6*tiii
	enddo
	dpn=amax1(0.,p-pa)**en
	dpm=amax1(0.,p-pa)**em
C Prepocet K z finalni porozity a koncoveho tlaku
      K=epsf/dpm*RELK
c	open(1,file='foam.out')
      MAXN=MIN0(MAXNTS,INT(TIMAX/DTIME))
C faze I.
C------------------------------------------------
      ITIME=1
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T0
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=1
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=0
	time=0
C 10x mensi integracni krok
      nit=10
      ddtime=dtime/nit
	do while(T.le.100..AND.ITIME.LT.MAXN)
	  do it=1,nit
	  time=time+ddtime
C penetracni hloubka hI
	  hI=amin1(H/2,amax1(H/100.,sqrt(pi*lam/rho/cw*time)))
c A1-korekce soucinitele prenosu tepla 
        AA=2*A1*lam*V0/(hI*H)
	  Mc=Ms*cs+Mw*cw
	  T=(Mc*T+ddtime*AA*Tw)/(Mc+ddtime*AA)
	  enddo
C	write(1,'(''Mc='',e10.3)')Mc
C     write(1,'(2f10.0)')time,T
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=1
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=0
C	  YGR(ITIME,10)=1
	enddo
C faze II. expanze bublin - ukoncena dosazenim finalni porozity
C -------------------------------------------------------------
      do while(eps.le.epsf.AND.ITIME.LT.MAXN)
	  do it=1,nit
	  time=time+ddtime
	  Tk=T+273.15
C rovnovazny tlak
        p=B*exp(-dh/(Rgas*Tk))
	  dpn=amax1(0.,p-pa)**en
	  dpm=amax1(0.,p-pa)**em
	  eps=k*dpm
        Vv=V0*eps/(1-eps)
	  V=V0+Vv
        Mv=Vv*p/(Rgas*Tk)
C Resi se diferencialni rovnice  Mc.dT/dt+dh.Z=A(Tw-T)
	  Mc=Ms*cs+(M-Ms-Mv)*cw+Mv*cv
	  Z=Nb*psi*dpn
	  M=M-Z*ddtime
c A2-korekce soucinitele prenosu tepla
	  AA=A*A2
C diferencialni rovnice entalpie, implicitni
        T=(Mc*T+ddtime*(AA*Tw-dh*Z))/(Mc+ddtime*AA)
c	write(1,'(''II. Mc='',e10.3,'' Z='',e10.3,'' Mv='',e10.3,'' Mq='',
c     /e10.3)')Mc,Z,Mv,Mq
        enddo
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=P/1E5
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=EPS
C       YGR(ITIME,10)=2
	enddo
	
C faze III. unik pary za soucasne existence volne vody
C -------------------------------------------------------
	do while(M.gt.Ms+Mb.AND.ITIME.LT.MAXN)
	  do it=1,nit
	  time=time+ddtime
	  Tk=T+273.15
C rovnovazny tlak
        p=B*exp(-dh/(Rgas*Tk))
	  dpn=amax1(0.,p-pa)**en
	  Mv=Vv*p/(Rgas*Tk)
	  Z=Psi*Nb*dpn
	  M=M-Z*ddtime
	  Mc=Ms*cs+(M-Ms-Mv)*cw+Mv*cv
C A3-korekce soucinitele prenosu tepla
	  AA=A*A3
        T=(Mc*T+ddtime*(AA*Tw-dh*Z))/(Mc+ddtime*AA)
c	  write(1,'(''III. Mc='',e10.3,'' Z='',e10.3)')Mc,Z
C	  write(1,'(2f10.0,f12.3,e12.5)')time,T,p/1e5,Mf
        enddo
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=P/1E5
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=EPS
C       YGR(ITIME,10)=3
C prepocet FI
        FI=Z/Mb
      enddo
C faze IV. unik pary jen vazana voda. Zvysene vyparne teplo
C -------------------------------------------------------
	do while(ITIME.LT.MAXN)
	  do it=1,nit
	  time=time+ddtime
	  Tk=T+273.15
C	  Mb=M-Ms
        Mb=Mb-ddtime*Z
	  Z=fi*Mb
        M=M-ddtime*Z
C Tlak je dan prutokem pary, ale jiz nekontroluje teplotu
        p=pa+(Z/(Psi*Nb))**(1./en)
        Mv=Vv*p/(Rgas*Tk)
	  Mc=Ms*cs+Mb*cw+Mv*cv
c A4-korekce suoucinitele prenosu tepla
	  AA=A*A4
        T=(Mc*T+ddtime*(AA*Tw-dh*Z))/(Mc+ddtime*AA)
c	write(1,'(''IV. Mc='',e10.3,'' Z='',e10.3)')Mc,Z
c	write(1,'(2e12.5)')time,T
        enddo
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=P/1E5
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=EPS
C       YGR(ITIME,10)=4
	enddo     
	ngr=itime
	end

      SUBROUTINE FOAMINT(timax,H,M,OMEGAW,T0,
     /                   Vexp,AALFA,PSI,RKONSIST,RB0,
     /                   a1,a2,a3,a4,ictem,icpre,iceps)
C Tato procedura je volana prikazem FOAM
C
C H-tloustka
C M-hmotnost pocatecni
C Drasticky zjednodusena verze / konstantni vlastnosti / krusta
C OMEGAW - hmotnostni podil vody (pocatecni)
C T0 - pocatecni teplota
C Vexp - expanzni pomer (Vmax/Vo)
C AALFA - Vcrust=AALFA*V0*epsilon
C PSI - permeabilita (prutok = PSI * deltap * EPS * H)
C RKONSIST - preexponencialni faktor konzistence
C Rb0 - pocatecni rozmer bublin
C A1,...A4 korekce soucinitelu prenosu tepla (default =1)
C
C IC... sloupce matice MOP vysledku
      INCLUDE '$FEM'

C WAFFLE FOAM
C      parameter (pi=3.141)
C Mesc-celkova hmotnost unikle pary
      real M,Mc,Ms,Mw,Mv,Mf,Mb,Mq,K,n,lam
C jednoprikazove funkce T je ve stupnich Celsia
C	FK(T)=0.672*exp(4960/(T+273.15))
	FK(T)=RKONSIST*exp(4960/(T+273.15))
	IF(DTIME.LE.0..OR.TIMAX.LE.0.)RETURN
C konstantni materialove parametry s vyjimkou konzistence
	Cs=1500
	Cw=4200
	Cv=2000
	lam=0.7
      dh=2.255e6
      SIGMAR=0.01
C  p=B.exp(-dh/RT) 
	B=4.81e10
	n=0.4
	Rgas=461.9
C PSI.(p-pa) = prutok kg/s
C	Psi=2e-10
	Tw=180
C	T0=30
C hmotnost a slozeni vzorku. 
C OMEGAW-podil vody
C Z0=Mb0/Mf0   sorption isotherm
C      omegaw=0.6
	Z0=0.02/0.04
C	M=0.25
	Ms=M*(1-omegaw)
	Mw=M*omegaw
	Mf=M*omegaw/(1+Z0)
	Mb=M*omegaw*Z0/(1+Z0)
C      Rb0=2e-6
C pocet bublin/kg vsadky =6975000
	Nb=6975000*M
	rhos=1648
	rhow=1000
	rho=rhos*(1-omegaw)+rhow*omegaw
c rozmery A-celkova teplosmenna plocha (z obou stran)
      Vs=Ms/rhos
	Vw=Mw/rhow
	V=Vs+Vw
	V0=V
	Vmax=Vexp*V0
	A=4*lam*V0/H**2
      T=T0
	Rb=Rb0
	pa=1e5
c	open(1,file='foam.out')
      MAXN=MIN0(MAXNTS,INT(TIMAX/DTIME))
C faze I.
C------------------------------------------------
      ITIME=1
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T0
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=1
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=0
	time=0
	psia=psi
C 10x mensi integracni krok
      nit=10
      ddtime=dtime/nit
	do while(T.le.100..AND.ITIME.LT.MAXN)
	  do it=1,nit
	  time=time+ddtime
c A1-korekce soucinitele prenosu tepla 
        AA=A*A1
	  Mc=Ms*cs+Mw*cw
	  T=(Mc*T+ddtime*AA*Tw)/(Mc+ddtime*AA)
	  enddo
C	write(1,'(''Mc='',e10.3)')Mc
C	  write(1,'(2f10.0)')time,T
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=1
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=0
	enddo
C faze II. expanze bublin - ukoncena zaplnenim formy
C -------------------------------------------------------
      do while(V.le.Vmax.AND.ITIME.LT.MAXN)
	  do it=1,nit
	  time=time+ddtime
	  Tk=T+273.15
C rovnovazny tlak
        p=B*exp(-dh/(Rgas*Tk))
C polomer bubliny
	  k=fk(T)
        F=(n/(4*k*(2*sqrt(3.))**(n-1)))**(1/n)
	  dpn=amax1(0.,p-pa-2*sigmar/Rb)**(1/n)
C  opravena verze s povrchovym napetim
        ee=ddtime*F*dpn
	  Rb=Rb*exp(ee)
C verze CRUST
        Vv=Nb*4./3.*pi*Rb**3
	  V=V0+Vv
        Mv=Vv*p/(Rgas*Tk)
	  eps=Vv/V       
C Mc-hmotnost peny, Mq-pomocna velicina
C Resi se diferencialni rovnice  Mc.dT/dt+dh.Z=A(Tw-T)
C kde Z=3F.dpn.(Mv+aalfa.eps(1-eps).(M-Ms))
	  Mc=Ms*cs+(M-Ms-Mv)*cw+Mv*cv
	  Mq=aalfa*eps*(1-eps)*(M-Ms)
C	  Mq=aalfa*(1-eps**2)*(M-Ms)
	  Z=3*F*(Mv+Mq)*dpn
	  M=M-3*Mq*F*dpn*ddtime
c A2-korekce soucinitele prenosu tepla
	  AA=A*A2
C diferencialni rovnice entalpie, implicitni
        T=(Mc*T+ddtime*(AA*Tw-dh*Z))/(Mc+ddtime*AA)
c	write(1,'(''II. Mc='',e10.3,'' Z='',e10.3,'' Mv='',e10.3,'' Mq='',
c     /e10.3)')Mc,Z,Mv,Mq
        enddo
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=P/1E5
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=EPS
C prepocet PSI (spojitost - stejne koeficienty dif.rovnice na rozhrani)
C pokud je vstupni hodnota PSI nulova, prepocitava se
        IF(PSI.eq.0.)PSIA=Z/(EPS*H*(p-pa))
	enddo
	
C faze III. unik pary za soucasne existence volne vody
C -------------------------------------------------------
	do while(M.gt.Ms+Mb.AND.ITIME.LT.MAXN)
	  do it=1,nit
	  time=time+ddtime
	  Tk=T+273.15
C rovnovazny tlak
        p=B*exp(-dh/(Rgas*Tk))
	  Mv=(Vmax-V0)*p/(Rgas*Tk)
	  Z=Psia*eps*h*(p-pa)
	  M=M-Z*ddtime
	  Mc=Ms*cs+(M-Ms-Mv)*cw+Mv*cv
C A3-korekce soucinitele prenosu tepla
	  AA=A*A3
        T=(Mc*T+ddtime*(AA*Tw-dh*Z))/(Mc+ddtime*AA)
c	write(1,'(''III. Mc='',e10.3,'' Z='',e10.3)')Mc,Z
C	  write(1,'(2f10.0,f12.3,e12.5)')time,T,p/1e5,Mf
        enddo
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=P/1E5
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=EPS
C prepocet FI
        FI=Z/Mb
      enddo
C faze IV. unik pary jen vazana voda. Zvysene vyparne teplo
C -------------------------------------------------------
	do while(ITIME.LT.MAXN)
	  do it=1,nit
	  time=time+ddtime
	  Tk=T+273.15
	  Mb=M-Ms
	  Z=fi*Mb
        M=M-ddtime*Z
C Tlak je dan prutokem pary, ale jiz nekontroluje teplotu
        p=pa+Z/(Psia*eps*h)
        Mv=(Vmax-V0)*p/(Rgas*Tk)
	  Mc=Ms*cs+Mb*cw+Mv*cv
c A4-korekce suoucinitele prenosu tepla
	  AA=A*A4
        T=(Mc*T+ddtime*(AA*Tw-dh*Z))/(Mc+ddtime*AA)
c	write(1,'(''IV. Mc='',e10.3,'' Z='',e10.3)')Mc,Z
c	  write(1,'(2e12.5)')time,T
        enddo
	  ITIME=ITIME+1
	  YGR(ITIME,1)=TIME
        IF(ICTEM.GT.1.and.ICTEM.LE.MAXSEL)YGR(ITIME,ICTEM)=T
        IF(ICPRE.GT.1.and.ICPRE.LE.MAXSEL)YGR(ITIME,ICPRE)=P/1E5
        IF(ICEPS.GT.1.and.ICEPS.LE.MAXSEL)YGR(ITIME,ICEPS)=EPS
	enddo     
	ngr=itime
	end

        
      SUBROUTINE FOAMIIV(timax,H,M,OMEGAW,AALFA,PSI,RKONSIST,
     /                   RB0,Rf,EPSF,TC,a1,a2,a3)
C Tato procedura je volana prikazem FOAMV
C
C nazev odvozen z fazi I, II+III, IV
C Model zalozeny na rovnici zvysovani poctu jader v krusge (perforovanych porech)
C Ruzne varianty
C  1]  dNc/dt=alfa*(T-Tc)*eps*(epsf-eps)
C  2]  dNc/dt=alfa*(beta.Rb/Rf-1)  
C OMEGAW - hmotnostni podil vody (pocatecni)
C AALFA - Vcrust=AALFA*V0*epsilon
C PSI - permeabilita (prutok = PSI * deltap)
C RKONSIST - preexponencialni faktor konzistence
C Rb0 - pocatecni rozmer bublin
C Rf - konecny rozmer poru
C EPSF- konecna porozita
C Tc - kriticka teplota perforace poru [C]
C A1,...A4 korekce soucinitelu prenosu tepla (default =1)
      INCLUDE '$FEM'
C Mesc-celkova hmotnost unikle pary, RN-pocet poru, Nc pocet perforovanych poru
      real M,Mc,Ms,Mw,Mv,Mf,Mb,Mq,K,n,lam,Np,Nc,mms,mmw,mmv
      real Ncold,Mwold,Rbold
C jednoprikazove funkce T je ve stupnich Celsia
      FK(T)=RKONSIST*exp(4960/(T+273.15))
      IF(DTIME.LE.0..OR.TIMAX.LE.0.)RETURN
C konstantni materialove parametry s vyjimkou konzistence

      open(55,file='foamv.out')

      Cs=1500
      Cw=4200
      Cv=2000
      lam=0.7
      dh=2.255e6
C  p=B.exp(-dh/RT) 
      B=4.81e10
      n=0.4
      Rgas=461.9
C PSI.(p-pa) = prutok kg/s
      Tw=180
      T0=30
C hmotnst a slozeni vzorku. 
C OMEGAW-podil vody
C Z0=Mb0/Mf0   sorption isotherm
      Z0=0.02/0.04
      Ms=M*(1-omegaw)
      Mw=M*omegaw
      Mf=M*omegaw/(1+Z0)
      Mb=M*omegaw*Z0/(1+Z0)
      rhos=1648
      rhow=1000
      rho=rhos*(1-omegaw)+rhow*omegaw
      Np=Ms*epsf/(rhos*(1-epsf)*4*pi*Rf**3/3)
      Nc=0
C hmotnosti vztazene na por
      MMs=Ms/Np
      MMw=Mw/Np
c rozmery A-celkova teplosmenna plocha (z obou stran)
      Vs=Ms/rhos
      Vw=Mw/rhow
      V=Vs+Vw
      V0=V
      A=4*lam*V0/H**2
      T=T0
      Rb=Rb0
      pa=1e5
      MAXN=MIN0(MAXNTS,INT(TIMAX/DTIME))
C faze I.
C------------------------------------------------
      ITIME=0
      time=0
      do while(T.le.100..AND.ITIME.LT.MAXN)
         ITIME=ITIME+1
	 YGR(ITIME,1)=TIME
	 time=time+dtime
c A1-korekce soucinitele prenosu tepla 
         AA=A*A1
         Mc=Ms*cs+Mw*cw
         T=(Mc*T+dtime*AA*Tw)/(Mc+dtime*AA)
         YGR(ITIME,2)=T
         YGR(ITIME,3)=1
      enddo

C faze II+III. expanze bublin a narust perforovanych poru
C -------------------------------------------------------
      do while(Mw.gt.Mb.AND.ITIME.LT.MAXN)
         ITIME=ITIME+1
         YGR(ITIME,1)=TIME
         time=time+dtime
         iter=0
         Told=T
         Rbold=Rb
         Ncold=Nc
         Mwold=Mw
         do while (iter.le.2)
          iter=iter+1
          Tk=T+273.15
C rovnovazny tlak
          p=B*exp(-dh/(Rgas*Tk))
          dp=amax1(1e-10,p-pa)
C polomer bubliny
          k=fk(T)
          F=(n/(4*k*(2*sqrt(3.))**(n-1)))**(1/n)
          dpn=dp**(1/n)
C Varianta Skocilas, ktere tedy vubec nerozumim. 
C  skoc          EE=dtime*F*dpn
C  skoc povrchovzm napetim 0.01 N/m
		SIGMAR=0.000001
C  skoc		krs=4*k*0.5**(n-1)
C  skoc	    Rb=Rb**n/(1-dtime*(dpn/krs-2*SIGMAR/krs/Rb**n)**(1/n))
C 
C  opravena verze s povrchovym napetim
          ee=dtime*F*amax1(0.,(dp-2*sigmar/Rbold)**(1/n))
          Rb=Rbold*exp(ee)
          Rb=AMIN1(Rb,10*RF)
C objemy vztazene na 1 por
          vb=4./3.*pi*rb**3
          vs=mms/rhos
          vw=mmw/rhow
          eps=vb/(vb+vs+vw)
C dNc/dt=...
C [1] dNcdt=amax1(0.,aalfa*(T-Tc)*eps*(epsf-eps)*Np)
C [2] dNcdt=amax1(0.,aalfa*eps*(epsf-eps)*Np)
C [3] dNcdt=amax1(0.,aalfa*(Tc*Rb/Rf-1)
          dNcdt=amax1(0.,aalfa*(Tc*Rb/Rf-1))
          Nc=amin1(Np,Ncold+dtime*dNcdt)
          dMwdt=-psi*Nc/Np*dp
          Mw=Mwold+dtime*dMwdt
C Entalpicka bilance, prirustek teploty
          MMv=vb*p/(Rgas*Tk)
c A2-korekce soucinitele prenosu tepla
          AA=A*A2
          Mc=Ms*cs+Mw*cw
C hexp  spotreba na vyrobu pary v expandujicich bublinach (>0)
C hdmw  spotreba na paru odchazejici z formy (>0 zaporne)
C hdNc  odpocitava se entalpie v porech, ktere penetrovaly (>0) 
          hexp=dh*(Np-Nc)*MMv*F*dpn
          hdmw=-dh*dMwdt
          hdNc=dh*dNcdt*vb*p/(Rgas*Tk)

c      ygr(itime,7)=hexp
c      ygr(itime,8)=hdmw
c      ygr(itime,9)=hdnc
      ygr(itime,10)=Nc/Np
         
          T=(Mc*Told/dtime+AA*Tw-hexp+hdmw+hdNc)/(Mc/dtime+AA)

      write(55,'(i3,''p='',e12.4,'' T='',f7.2,'' Rb='',f10.7)')
     /      iter,p,T,Rb

          T=AMIN1(300.,AMAX1(100.,T))
         enddo
      write(55,'(i6,'' hexp='',e10.3,'' hdmw='',e10.3,'' hdnc='',e10.3,
     /'' Nc/N='',f6.4)')itime,hexp,hdmw,hdnc,Nc/Np
         YGR(ITIME,2)=T
         YGR(ITIME,3)=P/1E5
         YGR(ITIME,4)=(EPS*(Np-Nc)+EPSF*Nc)/Np
C prepocet FI
         FI=-dMwdt/MW
      enddo
	
C faze IV. unik pary jen vazana voda. Zvysene vyparne teplo
C -------------------------------------------------------

      do while(ITIME.LT.MAXN)
         ITIME=ITIME+1
         YGR(ITIME,1)=TIME
         time=time+dtime
         Tk=T+273.15
         Z=fi*Mw
         Mw=Mw-dtime*Z
C Tlak je dan prutokem pary, ale jiz nekontroluje teplotu
         p=pa+Z/Psi
         Mc=Ms*cs+Mw*cw
c A4-korekce suoucinitele prenosu tepla
         AA=A*A3
         T=(Mc*T+dtime*(AA*Tw-dh*Z))/(Mc+dtime*AA)
         YGR(ITIME,2)=T
         YGR(ITIME,3)=P/1E5
         YGR(ITIME,4)=eps
      enddo     
      ngr=itime
      end

