C  PULSE.for 
C  Metoda siti reseni rovnic pro Q a P
C  Metoda charakteristik Z1,Z2
C  Casovy krok dtau = prostorovy krok dksi
C
      USE MSFLIB
      INCLUDE '$FEMLOC'
      PARAMETER (MAXXX=151, MAXTT=529)
	REAL*8 Z1O(MAXXX),Z2O(MAXXX),Z1N(MAXXX),Z2N(MAXXX),
     / RMA,W0,RH,RL,ALPHA,BETA,A,S0,RLAM,RHO,RE,H,F,
     / C1,C2,C3,C4,DXF2,DX

	REAL*8 WQ(MAXXX,maxtt),WP(MAXXX,maxtt),WW(MAXXX,maxtt)

      LOGICAL PRESSED,OKEPS
      CHARACTER*1 C
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
	OPEN(2,FILE='$PULSE.OUT')
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' PULSE read $RUNFEM.BIN successfully ['',a,'']'')')
     /problem
      WRITE(*,'('' You can quit computation by pressing any key...(time 
     /step will be completed).'')')
C 1-R radius
      R=RP(1)
C 2-H tloustka steny
      H=RP(2)
C 3-RH delka pruzne trubice s polomerem R
      RH=RP(3)
C 4-RL delka navazujici trubice s polomerem R
	RL=RP(4)
C 5-E   modul pruznosti steny
	E=RP(5)
C 6-RN  Poisson konst.
	RN=RP(6)
C 7-VISC viskozita
	VISC=RP(7)
C 8-RHO	hustota
	RHO=RP(8)
C 9-UDF prutok [m^3/s]
      IFUN=IP(9)
C 10-NX
      NX=IP(10)
C 11-TMAX
	TMAX=RP(11)
C------------------------------------
C     NXX - krok vykreslovanych profilu
      NXX=NX/5
	S0=PI*R**2
	A=2*R*S0*(1-RN**2)/(E*H)
	RLAM=DSQRT(S0/(A*RHO))
	FF=8*PI*VISC*RH/(S0*RHO*RLAM)
C DX  delta ksi
	DX=1./(NX-1)
C DT casovy krok v sekundach
	DT=DX*RH/RLAM
C NT pocet casovych kroku
      NT=TMAX/DT
C IST kolikaty casovy krok je treba prepocist na cas a ulozit
C      IST=NT/MAXTT+1
C Tiskneme teprve od casu TMAX-1
      NTPRINT=NT-1./DT
      IST=NTPRINT/3000+1
	write(*,*)' Final time [s]=',tmax
	write(*,*)' Number of time steps=',NT
	write(2,'('' FUN Q='',i4//
     /'' R='',f6.4,'' h='',f6.4,'' H='',f5.3,'' L='',f6.3/
     /'' NX='',i2,'' tmax='',f6.1,'' NT='',i9//
     /'' a='',e10.3/
     /'' Pulse velocity [m/s]='',e10.3)')
     /IFUN,R,H,RH,RL,NX,TMAX,NT,A,RLAM
C
C pocatecni podminka - nulova rychlost i tlak
	DO IX=1,NX
	  RKSI=DX*(IX-1)
	  Z1O(IX)=(1+FF*(RL/RH+1-RKSI))/2.
	  Z2O(IX)=(1-FF*(RL/RH+1-RKSI))/2.
      ENDDO
     
	TIME=0
	IPRINT=0
	DO IT=1,NT
	   TIME=TIME+DT
C Q-bezrozmerny prutok (Q/(W0.S0))
	   Q=CURFUN(IFUN)/(S0*RLAM)
C Pomocne vyrazy umele zvyseni viskozity
         F=FF*(1+1000*exp(-20*time/tmax))
	   DXF2=DX*F/2
C integrace po charakteristice, smer vpravo
	   DO I=1,NX-1
	     Z1N(I+1)=Z1O(I)-DXF2*(Z1O(I)+Z2O(I))
         ENDDO
C integrace po charakteristice, smer vlevo
	   DO I=NX,2,-1
	     Z2N(I-1)=Z2O(I)-DXF2*(Z2O(I)+Z1O(I))
         ENDDO
C Okrajova podminka na vstupu - prutok
	   Z1N(1)=Q-Z2N(1)
C Formulace s casovou derivaci
C        ALPHA=RL*RMA/RH
C	   BETA=F*RL/RH*RMA
C	   C1=1-BETA/RMA-ALPHA/(RMA*DX)
C	   C2=ALPHA/DX
C	   C3=ALPHA/(RMA*DX)
C	   C4=BETA+ALPHA/DX+RMA
C        Z2N(NX)=(Z1N(NX)*C1+Z2O(NX)*C2+Z1O(NX)*C3)/C4
C
C Formulace s okrajovou podminkou p=-L/H dp/dxsi
	   C1=RL/(RH*DX)
	   C2=C1+1
	   Z2N(NX)=(Z1N(NX)*C2+(Z2N(NX-1)-Z1N(NX-1))*C1)/C2  
C
C Formulace bez setrvacneho clenu
C         Z2N(NX)=Z1N(NX)*(1-F*RL/RH)/(1+F*RL/RH)

         IF(MOD(IT,IST).EQ.0.AND.IPRINT.LT.MAXTT.AND.IT.GT.NTPRINT)
     /THEN
C tiskovy krok - prepocet prutoku a tlaku 
	      IPRINT=IPRINT+1
	      DO I=1,NX
	        WP(I,IPRINT)=(Z1N(I)-Z2N(I))
	        WQ(I,IPRINT)=(Z2N(I)+Z1N(I))
            ENDDO
	      YGR(IPRINT,1)=TIME
	      DO I=1,4
	         I1=I*NXX
	         YGR(IPRINT,I+1)=WP(I1,IPRINT)
	         YGR(IPRINT,I+5)=WQ(I1,IPRINT)
            ENDDO
	      write(*,*)' Time [s]=',time
         ENDIF
         DO I=1,NX
	      Z1O(I)=Z1N(I)
	      Z2O(I)=Z2N(I)
         ENDDO
C --------------------------------------
         PRESSED=PEEKCHARQQ()
         IF(PRESSED)THEN
            C=GETCHARQQ()
            IENDCHECK=ICHAR(C)
            GOTO 999
         ENDIF
      ENDDO

999   WRITE(*,'(1X,''Exit from PULSE, writing $RUNFEM.BIN'')')
      WRITE(2,'(//'' PULSE ends'')')
	NGR=IPRINT
	DO I=1,4
	   WRITE(TTC(I+10),'(''p'',F7.5)')I*NXX*RH*DX
	   WRITE(TTC(I+14),'(''Q'',F7.5)')I*NXX*RH*DX
	   IQGR(I+1)=I+9
	   IQGR(I+5)=I+13
	ENDDO
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE

C Vypoctena casova historie ulozena do souboru, ktere lze znazornit prikazem TGRID
      OPEN(30,FILE='$T0001.OUT')
      WRITE(30,'(2I6,'' NX,NT  flowrate [m3/s]'')')NX,IPRINT
	DO ITIME=1,IPRINT
        WRITE(30,'(100ES11.3)')(WQ(IX,ITIME),IX=1,NX)
      ENDDO
      CLOSE(30)
      OPEN(30,FILE='$T0002.OUT')
      WRITE(30,'(2I6,'' NX,NT  pressures [Pa]'')')NX,IPRINT
	DO ITIME=1,IPRINT
        WRITE(30,'(100ES11.3)')(WP(IX,ITIME),IX=1,NX)
      ENDDO
      CLOSE(30)
      OPEN(30,FILE='$T0003.OUT')
      WRITE(30,'(2I6,'' NX,NT  relative flowrate'')')NX,IPRINT
	DO ITIME=1,IPRINT
        WRITE(30,'(100ES11.3)')(WW(IX,ITIME),IX=1,NX)
      ENDDO
      CLOSE(30)

	END

