C  PULSE.for 
C  Metoda siti reseni rovnic pro Q a P
C  Lax Wendroff
*C
      USE MSFLIB
      INCLUDE '$FEMLOC'

	REAL*8 Z1O(100),Z2O(100),Z1N(100),Z2N(100),
     / RMA,W0,RH,RL,ALPHA,BETA,A,S0,RLAM,RHO,RE,H,F,
     / C1,C2,C3,C4,DXF2,DX

	REAL*8 WQ(100,100),WP(100,100),WW(100,100)

      LOGICAL PRESSED,OKEPS
      CHARACTER*1 C
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
	OPEN(2,FILE='$PULSE.OUT')
	OPEN(3,FILE='$Z12.OUT')
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' PULSE read $RUNFEM.BIN successfully ['',a,'']'')')
     /problem
      WRITE(*,'('' You can quit computation by pressing any key...(time 
     /step will be completed).'')')
C 1-R radius
      R=RP(1)
C 2-H tloustka steny
      H=RP(2)
C 3-RH delka pruzne trubice s polomerem R
      RH=RP(3)
C 4-RL delka navazujici trubice s polomerem R
	RL=RP(4)
C 5-E   modul pruznosti steny
	E=RP(5)
C 6-RN  Poisson konst.
	RN=RP(6)
C 7-VISC viskozita
	VISC=RP(7)
C 8-RHO	hustota
	RHO=RP(8)
C 9-W0 stredni rychlost [m/s]
	W0=RP(9)
C 10-UDF koeficient, kterym se nasobi nominalni prutok, dany rychlosti W0
      IFUN=IP(10)
C 11-NX
      NX=IP(11)
C 12-TMAX
	TMAX=RP(12)
C------------------------------------
	S0=PI*R**2
	Q0=S0*W0
	A=2*R*S0*(1-RN**2)/(E*H)
	RLAM=DSQRT(S0/(A*RHO))
	RMA=W0/RLAM
	F=8*PI*VISC*RH/(S0*RHO*RLAM)
	BETA=F*RL/RH*RMA
	ALPHA=RL*RMA/RH
C DX  delta ksi
	DX=1./(NX-1)
C DT casovy krok v sekundach
	DT=DX*RH/RLAM
C NT pocet casovych kroku
      NT=TMAX/DT
C IST kolikaty casovy krok je treba prepocist na cas a ulozit
      IST=NT/100+1
	write(*,*)' Final time [s]=',tmax
	write(*,*)' Number of time steps=',NT
	write(2,'('' w0='',f7.3,'' FUN='',i4/
     /'' R='',f6.4,'' h='',f6.4,'' H='',f5.3,'' L='',f6.3/
     /'' NX='',i2,'' tmax='',f6.1,'' NT='',i9/
     /'' Ma='',e10.3,'' a='',e10.3,'' lambda='',e10.3)')
     /W0,IFUN,R,H,RH,RL,NX,TMAX,NT,RMA,A,RLAM
C
C pocatecni podminka - nulova rychlost i tlak
	DO IX=1,NX
	  WQ(IX,1)=0
	  WP(IX,1)=0
	  Z1O(IX)=0
	  Z2O(IX)=0
      ENDDO

C Pomocne vyrazy
	C1=1-BETA/RMA-ALPHA/(RMA*DX)
	C2=ALPHA/DX
	C3=ALPHA/(RMA*DX)
	C4=BETA+ALPHA/DX+RMA
      
	TIME=0
	IPRINT=0
	DO IT=1,NT
	   TIME=TIME+DT
C Q-bezrozmerny prutok (Q/(W0.S0))
	   Q=CURFUN(IFUN)
	   DXF2=DX*F/2
C integrace po charakteristice, smer vpravo
	   DO I=1,NX-1
	     Z1N(I+1)=Z1O(I)-DXF2*(Z1O(I)+RMA*Z2O(I))
         ENDDO
C integrace po charakteristice, smer vlevo
	   DO I=NX,2,-1
	     Z2N(I-1)=Z2O(I)-DXF2*(Z2O(I)+Z1O(I)/RMA)
         ENDDO
	   Z1N(1)=RMA*(Q-Z2N(1))
         Z2N(NX)=(Z1N(NX)*C1+Z2O(NX)*C2+Z1O(NX)*C3)/C4

         IF(MOD(IT,IST).EQ.0.AND.IPRINT.LT.100.AND.IT.GT.NT/5)THEN
C tiskovy krok - prepocet prutoku a tlaku na rozmerove veliciny Q[m3/s] a p[Pa]
	      IPRINT=IPRINT+1
	      DO I=1,NX
	        WP(I,IPRINT)=(Z1N(I)-RMA*Z2N(I))*S0/A
	        WQ(I,IPRINT)=(Z2N(I)+Z1N(I)/RMA)*S0*W0
	        IF(Q.NE.0.)WW(I,IPRINT)=WQ(I,IPRINT)/Q
            ENDDO
	      write(*,*)' Time [s]=',time

	      write(2,'('' t='',e10.3,'' pin='',e11.4,'' pout='',e11.4)')
     /time,wp(1,iprint),wp(nx,iprint)
       write(3,*)' t=',time,' Ma=',rma,' beta=',beta,' alpha=',alpha
       write(3,*)' z2+z1/ma      =',z2n(1)+z1n(1)/rma
       write(3,*)' z1-ma z2      =',z1n(nx)-rma*z2n(nx)
       write(3,*)' beta(z2+z1/ma)=',beta*(z2n(nx)+z1n(nx)/rma)
	 write(3,*)
	 write(3,*)' dz1(nx)/dksi  =',(z1n(nx)-z1n(nx-1))/dx
	 write(3,*)' -f/2(z1+maz2) =',-f/2*(z1n(nx)+rma*z2n(nx))
	 write(3,*)
	 write(3,*)' dz1(1)/dksi   =',(z1n(2)-z1n(1))/dx
	 write(3,*)' -f/2(z1+maz2) =',-f/2*(z1n(1)+rma*z2n(1))
	 write(3,*)
       write(3,*)'-dz2(nx)/dkxi  =',-(z2n(nx)-z2n(nx-1))/dx
	 write(3,*)' -f/2(z2+z1/ma)=',-f/2*(z2n(nx)+z1n(nx)/rma)
	 write(3,*)
       write(3,*)'-dz2(1)/dkxi   =',-(z2n(2)-z2n(1))/dx
	 write(3,*)' -f/2(z2+z1/ma)=',-f/2*(z2n(1)+z1n(1)/rma)
	 write(3,*)
	p1=wp(1,iprint)
	p2=wp(2,iprint)
	s=s0+a*p1
	 write(3,*)' dp(1)/dx =',NX*(p2-p1)/rh,'   s/s0=',s/s0
	 write(3,*)'  rhs1    =',-8*pi*visc/s**2*wq(1,iprint)
	 write(3,*)
	p1=wp(nx-1,iprint)
	p2=wp(nx,iprint)
	s=s0+a*p1
	 write(3,*)' dp(nx)/dx=',NX*(p2-p1)/rh,'   s/s0=',s/s0
	 write(3,*)'  rhs nx  =',-8*pi*visc/s**2*wq(nx,iprint)
	 write(3,*)
	 write(3,'('' Z1old'',4es14.7)')z1o(1),z1o(2),z1o(nx-1),z1o(nx)
	 write(3,'('' Z1new'',4es14.7)')z1n(1),z1n(2),z1n(nx-1),z1n(nx)
	 write(3,'('' Z2old'',4es14.7)')z2o(1),z2o(2),z2o(nx-1),z2o(nx)
	 write(3,'('' Z2new'',4es14.7)')z2n(1),z2n(2),z2n(nx-1),z2n(nx)
         ENDIF
         DO I=1,NX
	      Z1O(I)=Z1N(I)
	      Z2O(I)=Z2N(I)
         ENDDO
C --------------------------------------
         PRESSED=PEEKCHARQQ()
         IF(PRESSED)THEN
            C=GETCHARQQ()
            IENDCHECK=ICHAR(C)
            GOTO 999
         ENDIF
      ENDDO

999   WRITE(*,'(1X,''Exit from RUNFEMW, writing $RUNFEM.BIN'')')
      WRITE(2,'(//'' RUNFEMW ends'')')
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE

C Vypoctena casova historie ulozena do souboru, ktere lze znazornit prikazem TGRID
      OPEN(30,FILE='$T0001.OUT')
      WRITE(30,'(2I6,'' NX,NT  flowrate [m3/s]'')')NX,IPRINT
	DO IY=1,IPRINT
        WRITE(30,'(100ES11.3)')(WQ(IX,IY),IX=1,NX)
      ENDDO
      CLOSE(30)
      OPEN(30,FILE='$T0002.OUT')
      WRITE(30,'(2I6,'' NX,NT  pressures [Pa]'')')NX,IPRINT
	DO IY=1,IPRINT
        WRITE(30,'(100ES11.3)')(WP(IX,IY),IX=1,NX)
      ENDDO
      CLOSE(30)
      OPEN(30,FILE='$T0003.OUT')
      WRITE(30,'(2I6,'' NX,NT  relative flowrate'')')NX,IPRINT
	DO IY=1,IPRINT
        WRITE(30,'(100ES11.3)')(WW(IX,IY),IX=1,NX)
      ENDDO
      CLOSE(30)

	END

