C  PULSEUPW.for 
C  Metoda siti reseni rovnic pro Q a P
C  Upwind (jen predikce - prvni rad presnosti)
C  Rovnice pro prutok Q se integruje zleva 
C  Rovnice pro tlak P se integruje zprava (uvazuje se setrvacny clen v okrajove podmince pro tlak).
C
      USE MSFLIB
      INCLUDE '$FEMLOC'
      PARAMETER (MAXXX=151, MAXTT=529)
	REAL*8 PO(MAXXX),QO(MAXXX),PN(MAXXX),QN(MAXXX),
     / RMA,W0,RH,RL,ALPHA,BETA,A,S0,RLAM,RHO,RE,H,F,FF,
     / DX,DTAU,DT

	REAL*8 WQ(MAXXX,maxtt),WP(MAXXX,maxtt),WW(MAXXX,maxtt)

      LOGICAL PRESSED,OKEPS
      CHARACTER*1 C
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
	OPEN(2,FILE='$PULSEUPW.OUT')
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' PULSEUPW read $RUNFEM.BIN successfully ['',a,'']'')')
     /problem
      WRITE(*,'('' You can quit computation by pressing any key...(time 
     /step will be completed).'')')
C 1-R radius
      R=RP(1)
C 2-H tloustka steny
      H=RP(2)
C 3-RH delka pruzne trubice s polomerem R
      RH=RP(3)
C 4-RL delka navazujici trubice s polomerem R
	RL=RP(4)
C 5-E   modul pruznosti steny
	E=RP(5)
C 6-RN  Poisson konst.
	RN=RP(6)
C 7-VISC viskozita
	VISC=RP(7)
C 8-RHO	hustota
	RHO=RP(8)
C 9-W0 stredni rychlost [m/s]
	W0=RP(9)
C 10-UDF koeficient, kterym se nasobi nominalni prutok, dany rychlosti W0
      IFUN=IP(10)
C 11-NX
      NX=IP(11)
C 12-TMAX
	TMAX=RP(12)
C 13-DTR		redukce casoveho kroku
      DTR=RP(13)
C------------------------------------
C     NXX - krok vykreslovanych profilu
      NXX=NX/5
	S0=PI*R**2
	Q0=S0*W0
	A=2*R*S0*(1-RN**2)/(E*H)
	RLAM=DSQRT(S0/(A*RHO))
	RMA=W0/RLAM
	FF=8*PI*VISC*RH/(S0*RHO*RLAM)
C DX  delta ksi (bezrozmerne)
	DX=1./(NX-1)
C Odhad maximalni casoveho kroku z rychlosti RLAM (V SEKUNDACH)
	DTMAX=DX*RH/RLAM
C DT casovy krok v sekundach
	DT=DTMAX*DTR
	NT=TMAX/DT
C DTAU casovy krok bezrozmerny
	DTAU=DT*RLAM/RH
C IST kolikaty casovy krok je treba prepocist na cas a ulozit
      IST=NT/3000+1
	write(*,*)' Final time [s]=',tmax
	write(*,*)' Number of time steps=',NT
	write(2,'('' w0='',f7.3,'' FUN='',i4//
     /'' R='',f6.4,'' h='',f6.4,'' H='',f5.3,'' L='',f6.3/
     /'' NX='',i2,'' tmax='',f6.1,'' NT='',i9//
     /'' Ma='',e10.3,'' a='',e10.3/
     /'' Pulse velocity [m/s]='',e10.3)')
     /W0,IFUN,R,H,RH,RL,NX,TMAX,NT,RMA,A,RLAM
C
C pocatecni podminka - nulova rychlost i tlak
      X=0
	DO IX=1,NX
	  QO(IX)=1.
	  PO(IX)=RMA*FF*(RL/RH+1-X)
	  X=X+DX
      ENDDO
     
	TIME=0
	IPRINT=0
	DO IT=1,NT
	   TIME=TIME+DT
C Q-bezrozmerny prutok (Q/(W0.S0))
	   Q=CURFUN(IFUN)
C Pomocne vyrazy umele zvyseni viskozity
C        F=FF*(1+1000*exp(-20*time/tmax))
         F=FF
C integrace PRUTOKU VPRAVO
         QN(1)=Q
	   DO I=2,NX
	     QN(I)=QO(I)-DTAU*((PO(I)-PO(I-1))/(RMA*DX)+F*QO(I))
         ENDDO
C integrace TLAKU VLEVO
         PN(NX)=RMA*RL/RH*((QN(NX)-QO(NX))/DTAU+F*QO(NX))
         DO I=NX-1,1,-1
           PN(I)=PO(I)-DTAU*RMA/DX*(QN(I+1)-QN(I))
         ENDDO

         IF(MOD(IT,IST).EQ.0.AND.IPRINT.LT.MAXTT.AND.IT.GT.NT-IST*MAXTT)
     /THEN
C tiskovy krok - prepocet prutoku a tlaku na rozmerove veliciny Q[m3/s] a p[Pa]
	      IPRINT=IPRINT+1
	      DO I=1,NX
	        WP(I,IPRINT)=PN(I)*S0/A
	        WQ(I,IPRINT)=QN(I)*S0*W0
	        IF(Q.NE.0.)WW(I,IPRINT)=WQ(I,IPRINT)/Q
            ENDDO
	      YGR(IPRINT,1)=TIME
	      DO I=1,4
	         I1=I*NXX
	         YGR(IPRINT,I+1)=WP(I1,IPRINT)
	         YGR(IPRINT,I+5)=WQ(I1,IPRINT)
            ENDDO
	      write(*,*)' Time [s]=',time
         ENDIF
         DO I=1,NX
	      PO(I)=PN(I)
	      QO(I)=QN(I)
         ENDDO
	   WRITE(2,*)' time=',time,' P1=',pn(1), 'PN=',pn(nx)
C --------------------------------------
         PRESSED=PEEKCHARQQ()
         IF(PRESSED)THEN
            C=GETCHARQQ()
            IENDCHECK=ICHAR(C)
            GOTO 999
         ENDIF
      ENDDO

999   WRITE(*,'(1X,''Exit from PULSE, writing $RUNFEM.BIN'')')
      WRITE(2,'(//'' PULSE ends'')')
	NGR=IPRINT
	DO I=1,4
	   WRITE(TTC(I+10),'(''p'',F7.5)')I*NXX*RH*DX
	   WRITE(TTC(I+14),'(''Q'',F7.5)')I*NXX*RH*DX
	   IQGR(I+1)=I+9
	   IQGR(I+5)=I+13
	ENDDO
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE

C Vypoctena casova historie ulozena do souboru, ktere lze znazornit prikazem TGRID
      OPEN(30,FILE='$T0001.OUT')
      WRITE(30,'(2I6,'' NX,NT  flowrate [m3/s]'')')NX,IPRINT
	DO IY=1,IPRINT
        WRITE(30,'(100ES11.3)')(WQ(IX,IY),IX=1,NX)
      ENDDO
      CLOSE(30)
      OPEN(30,FILE='$T0002.OUT')
      WRITE(30,'(2I6,'' NX,NT  pressures [Pa]'')')NX,IPRINT
	DO IY=1,IPRINT
        WRITE(30,'(100ES11.3)')(WP(IX,IY),IX=1,NX)
      ENDDO
      CLOSE(30)
      OPEN(30,FILE='$T0003.OUT')
      WRITE(30,'(2I6,'' NX,NT  relative flowrate'')')NX,IPRINT
	DO IY=1,IPRINT
        WRITE(30,'(100ES11.3)')(WW(IX,IY),IX=1,NX)
      ENDDO
      CLOSE(30)

	END

