C  PULSPRES.for 
C  Metoda siti reseni rovnice druheho radu pro P
C  Implicitni metoda, kdy jsou prostorove derivace d2p/dksi2 vyjadreny
C  na trech casovych hladinach s vahami
C   n+1  vaha 1-alfa-beta
C   n    vaha alfa
C   n-1  vaha beta
C  maximalni pocet uzlu MAXXX=151, maximalni pocet ukladanych casovych kroku MAXTT=529
C  Na rozdil od predchozich verzi neni zavedena charakteristicka rychlost W0, tudiz ani
C  Machovo cislo Ma (zmenila se jen definice bezrozmerneho prutoku)
C
      USE MSFLIB
      INCLUDE '$FEMLOC'
      PARAMETER (MAXXX=151, MAXTT=529)
      REAL*8 PNP1(MAXXX),PN0(MAXXX),PNM1(MAXXX),
     / ATRI(MAXXX),BTRI(MAXXX),CTRI(MAXXX),DTRI(MAXXX),
     / RH,RL,ALFA,BETA,A,S0,RLAM,RHO,H,FF,
     / DKSI,DTAU,DKSI2,DTAU2,DX,PREV(3,4),D2
C PREV I,J i-index predchoziho casu, j-index axialni pozice

C Vysledky (profily tlaku) jsou ukladany do matice - sloupec odpovida casu
      REAL*8 WP(MAXXX,maxtt)

      LOGICAL PRESSED,OKEPS
      CHARACTER*1 C
C
C IENDCHECK - signalizace vysledku =0 O.K. bez preruseni
C                                  =-1 chyba pri cteni dat
C                                  kod klavesy (Esc-27, Enter-13, ...)
      IENDCHECK=-1
      OPEN(1,FILE='$RUNFEM.BIN',FORM='BINARY',ERR=1000)
      OPEN(2,FILE='$PULSE.OUT')
      OPEN(3,FILE='MATRIX.TXT')
      CALL READBIN(1,IEND)
      IENDCHECK=0
      WRITE(*,'('' PULSPRES read $RUNFEM.BIN successfully ['',a,'']'')')
     /problem
      WRITE(*,'('' You can quit computation by pressing any key...(time 
     /step will be completed).'')')
C 1-R radius
      R=RP(1)
C 2-H tloustka steny
      H=RP(2)
C 3-RH delka pruzne trubice s polomerem R
      RH=RP(3)
C 4-RL delka navazujici trubice s polomerem R
      RL=RP(4)
C 5-E modul pruznosti steny
      E=RP(5)
C 6-RN Poisson konst.
      RN=RP(6)
C 7-VISC viskozita
      VISC=RP(7)
C 8-RHO	hustota
      RHO=RP(8)
C 9-Q prutok, definovany jako uzivatelska funkce UDF [m^3/s]
      IFUNQ=IP(9)
C 10-dQ/dt derivace prutoku dle casu jako uzivatelska funkce UDF [m^3/s^2]
      IFUNQT=IP(10)
C 11-NX
      NX=IP(11)
C 12-TMAX
      TMAX=RP(12)
C 13-TRED (koeficient redukce casoveho kroku)
      TRED=RP(13)
C 14-ALFA+BETA (=0 ciste implicitni, >0 semiimplicitni, =1 ciste explicitni)
      TIMP=RP(14)
      ALFA=TIMP/2
      BETA=TIMP/2
C------------------------------------
      S0=PI*R**2
      A=2*R*S0*(1-RN**2)/(E*H)
      RLAM=DSQRT(S0/(A*RHO))
      FF=8*PI*VISC*RH/(S0*RHO*RLAM)
C DKSI  delta ksi
      DKSI=1./(NX-1)
C DTAU  casovy krok odpovidajici rychlosti zvuku * TRED
      DTAU=DKSI*TRED
C DT prepocteny casovy krok v sekundach 
      DT=DTAU*RH/RLAM
C NT pocet casovych kroku
      NT=TMAX/DT

	write(*,*)' Final time [s]=',tmax
	write(*,*)' Number of time steps=',NT
	write(2,'('' fun Q='',i4,'' fun dQ/dt='',i4//
     /'' R='',f6.4,'' h='',f6.4,'' H='',f5.3,'' L='',f6.3/
     /'' NX='',i2,'' tmax='',f6.1,'' NT='',i9//
     /'' a='',e10.3,'' Pulse velocity [m/s]='',e10.3/
     /'' alfa='',f5.2,'' beta='',f5.2,'' dt-mult='',f7.3)')
     /IFUNQ,IFUNQT,R,H,RH,RL,NX,TMAX,NT,A,RLAM,ALFA,BETA,TRED
C
C pocatecni podminka - ustaleny prutok (dva predchozi kroky, vcetne prutoku)
C Q0 bezrozmerny prutok v case 0, QT0 casova derivace bezrozmerneho prutoku v case 0 (derivace vzhledem k TAU)
C    uzivatelske funkce udavaji prutok i derivace rozmerove [m^3/s] resp. [m^3/s^2]
      CQ=1./(RLAM*S0)
      CQT=RH/(RLAM**2*S0)
      TIME=0
      Q0=CURFUN(IFUNQ)*CQ
      QT0=CURFUN(IFUNQT)*CQT
      DO IX=1,NX
	  RKSI=DKSI*(IX-1)
	  PNM1(IX)=Q0*FF*(1+RL/RH-RKSI)
	  PN0(IX)=PNM1(IX)
      ENDDO
      QM1=Q0
      QTM1=QT0

      TIME=0
      IPRINT=0
      NXX=NX/5
C IST tiskove kroky, tiskneme jen vysledky od casu TMAX-1
      NTPRINT=NT-1./DT
      IST=NTPRINT/3000+1

      DO IT=1,NT
         TIME=TIME+DT
C Q-bezrozmerny prutok Q
         QP1=CURFUN(IFUNQ)*CQ
C QT-bezrozmerna derivace prutoku
         QTP1=CURFUN(IFUNQT)*CQT
C generovani soustavy s tridiagonalni matici ATRI (pod),BTRI (diagonala),CTRI (nad),DTRI (prava strana)
C pomocne promenne
         DKSI2=DKSI*DKSI
         DTAU2=DTAU*DTAU
         IF(TIMP.GT.0.5)THEN
C Explicitni metoda
           DO I=2,NX-1
             PNP1(I)=((PN0(I-1)+PN0(I+1))/DKSI2-PN0(I)*(2/DKSI2-2/DTAU2)
     /             -PNM1(I)*(1/DTAU2-FF/(2*DTAU)))/(1/DTAU2+FF/(2*DTAU))
           ENDDO
           PNP1(1)=(2*PN0(2)/DKSI2+2/DKSI*(QTP1+FF*QP1)
     /             -PN0(1)*(2/DKSI2-2/DTAU2)
     /             -PNM1(1)*(1/DTAU2-FF/(2*DTAU)))/(1/DTAU2+FF/(2*DTAU))
           PNP1(NX)=(2*PN0(NX-1)/DKSI2
     /             -PN0(NX)*(2/DKSI2-2/DTAU2+2*RH/(RL*DKSI))
     /             -PNM1(1)*(1/DTAU2-FF/(2*DTAU)))/(1/DTAU2+FF/(2*DTAU)) 
         ELSEIF(TIMP.GT.0.)THEN
C Implicitni metoda hladiny n-1 (beta), n (alfa), n+1 (1-alfa-beta)
           AB=(1-ALFA-BETA)/DKSI2
           DO I=2,NX-1
	       ATRI(I)=AB
	       BTRI(I)=-(2*AB+1/DTAU2+FF/(2*DTAU))
             CTRI(I)=AB
	       DTRI(I)=-ALFA/DKSI2*(PN0(I-1)+PN0(I+1))
     /              +PN0(I)*(2*ALFA/DKSI2-2/DTAU2)
     /              -BETA/DKSI2*(PNM1(I-1)+PNM1(I+1))
     /              +PNM1(I)*(1/DTAU2-FF/(2*DTAU)+2*BETA/DKSI2)
           ENDDO
C prvni rovnice (okrajova podminka dp/dksi=-(fQ+dQ/dtau)
           ATRI(1)=0
           BTRI(1)=-(2*AB+1/DTAU2+FF/(2*DTAU))
           CTRI(1)=2*AB
           DTRI(1)=-2/DKSI2*(ALFA*PN0(2)+BETA*PNM1(2))
     /           +PN0(1)*(2*ALFA/DKSI2-2/DTAU2)
     /           +PNM1(1)*(2*BETA/DKSI2+1/DTAU2-FF/(2*DTAU))
     /           -((1-ALFA-BETA)*(FF*QP1+QTP1)
     /                     +ALFA*(FF*Q0+QT0)
     /                     +BETA*(FF*QM1+QTM1))/DKSI2
C Posledni rovnice 
           ATRI(NX)=2*AB
           BTRI(NX)=-(2*AB*(1+RH*DKSI/RL)+1/DTAU2+FF/(2*DTAU))
           CTRI(NX)=0
           DTRI(NX)=-2*ALFA/DKSI2*(PN0(NX-1)-RH*DKSI*PN0(NX)/RL)
     /            +PN0(NX)*2*(ALFA/DKSI2-1/DTAU2)
     /            -2*BETA/DKSI2*(PNM1(NX-1)-RH*DKSI*PNM1(NX)/RL)
     /            +PNM1(NX)*(1/DTAU2-FF/(2*DTAU)+2*BETA/DKSI2)
C Reseni soustavy metodou faktorizace
           CALL TRIDAGD(ATRI,BTRI,CTRI,DTRI,PNP1,NX)
         ELSE
C Plne implicitni - hladina n+1
           DTDX=(DTAU/DKSI)**2
	     FDT=FF*DTAU
	     DO I=2,NX-1
	        ATRI(I)=-DTDX
	        BTRI(I)=1+2*DTDX+1.5*FDT
	        CTRI(I)=-DTDX
	        DTRI(I)=2*PN0(I)*(1+FDT)-PNM1(I)*(1+FDT/2)
	     ENDDO
           ATRI(1)=0
           BTRI(1)=1+2*DTDX+1.5*FDT
	     CTRI(1)=-2*DTDX
	     DTRI(1)=DTAU**2/DKSI*(QTP1+FF*QP1)+
     /              2*PN0(1)*(1+FDT)-PNM1(1)*(1+FDT/2)
	     ATRI(NX)=-2*DTDX
           BTRI(NX)=1+2*DTDX+1.5*FDT+2*RH*DTAU**2/(RL*DKSI)
	     CTRI(NX)=0
           DTRI(NX)=2*PN0(NX)*(1+FDT)-PNM1(NX)*(1+FDT/2)
           CALL TRIDAGD(ATRI,BTRI,CTRI,DTRI,PNP1,NX)
         ENDIF
C Vypocteny profil tlaku na nove casove hladine do matice vysledku WP
C IST kolikaty casovy krok je treba ulozit
         IF(MOD(IT,IST).EQ.0)THEN
	     IF(IPRINT.LT.MAXTT.AND.IT.GT.NTPRINT)THEN
C tiskovy krok - vysledek je bezrozmerny tlakovy profil
             IPRINT=IPRINT+1
             DO I=1,NX
	         WP(I,IPRINT)=PNP1(I)
             ENDDO
             YGR(IPRINT,1)=TIME
C     NXX - krok vykreslovanych profilu do matice bodu pozorovani
             DO I=1,4
	         I1=I*NXX
	         YGR(IPRINT,I+1)=WP(I1,IPRINT)
             ENDDO
           ENDIF
	     write(*,*)' Time [s]=',time
         ENDIF
C hledani lokalniho maxima z predchozich hodnot tlaku
         DO I=1,4
	      DO J=3,2,-1
	         PREV(J,I)=PREV(J-1,I)
	      ENDDO
	      PREV(1,I)=PNP1(I*NXX+1)
	      IF(PREV(2,I).GT.PREV(1,I).AND.PREV(2,I).GT.PREV(3,I))
     /                 WRITE(3,'('' X'',I1,I8,E15.7)')I,IT,TIME-DT
         ENDDO
C prenos hladin
         DO I=1,NX
	      PNM1(I)=PN0(I)
	      PN0(I)=PNP1(I)
         ENDDO
         QM1=Q0
         Q0=QP1
         QTM1=QT0
         QT0=QTP1
C --------------------------------------
         PRESSED=PEEKCHARQQ()
         IF(PRESSED)THEN
            C=GETCHARQQ()
            IENDCHECK=ICHAR(C)
            GOTO 999
         ENDIF
      ENDDO

999   WRITE(*,'(1X,''Exit from PULSE, writing $RUNFEM.BIN'')')
      WRITE(2,'(//'' PULSE ends'')')
	NGR=IPRINT
	DO I=1,4
	   WRITE(TTC(I+10),'(''p'',F7.5)')I*NXX*RH*DKSI
	   IQGR(I+1)=I+9
	ENDDO
      REWIND 1
      CALL WRITEBIN(1,0)
1000  CONTINUE

C Vypoctena casova historie ulozena do souboru, ktere lze znazornit prikazem TGRID
      OPEN(30,FILE='$T0001.OUT')
      WRITE(30,'(2I6,'' NX,NT  pressures [Pa]'')')NX,IPRINT
      DO ITIME=1,IPRINT
        WRITE(30,'(151ES11.3)')(WP(IX,ITIME),IX=1,NX)
      ENDDO
      CLOSE(30)
      END


      SUBROUTINE TRIDAGD(A,B,C,R,U,N)
c
c DOUBLE PRECISION
c Tridiagonal linear set of equations (A-lower, B-diagonal, C-upper, R-RHS)
c according to Press: Numerical recipes, p. 40
c Vectors A,B,C,R are not destroyed.
c
      parameter (nmax=500)
      real*8 gam(nmax),a(n),b(n),c(n),r(n),u(n),bet
      bet=b(1)
      u(1)=r(1)/bet
      do j=2,n
         gam(j)=c(j-1)/bet
         bet=b(j)-a(j)*gam(j)
         u(j)=(r(j)-a(j)*u(j-1))/bet
      enddo
      do j=n-1,1,-1
         u(j)=u(j)-gam(j+1)*u(j+1)
      enddo
      end

