      SUBROUTINE DGAUSSJ(A,N,NP,B,M,MP)
C
C RESENI SOUSTAVY LINEARNICH ALGEBRAICKYCH ROVNIC GAUSS-JORDANOVOU ELIMINACI
C VSTUPNI PARAMETRY:
C N         - POCET RESENYCH ROVNIC
C M         - POCET RESENYCH PRAVYCH STRAN
C NP,MP     - DEKLARACNI ROZMERY A(NP,NP),B(NP,MP)
C VSTUPNI A VYSTUPNI PARAMETRY
C A(NP,NP)  - MATICE SOUSTAVY
C B(NP,MP)  - PRAVA STRANA A RESENI
C MAXIMALNI POCET ROVNIC = 100
C
C Numerical Recipes p. 28
C
      parameter (nmax=100)
      real*8 a(np,np),b(np,mp),dum,big,pivinv
      dimension ipiv(nmax),indxr(nmax),indxc(nmax)
      do i=1,n
         ipiv(i)=0
      enddo
      do i=1,n
         big=0
         do j=1,n
             if(ipiv(j).ne.1)then
                   do k=1,n
                         if(ipiv(k).eq.0)then
                               if(dabs(a(j,k)).ge.big)then
                                    big=dabs(a(j,k))
                                    irow=j
				    icol=k
                               endif
                         elseif(ipiv(k).gt.1)then
                               pause 'Singular matrix'
                               return
                         endif
                    enddo
               endif
          enddo
          ipiv(icol)=ipiv(icol)+1
          if(irow.ne.icol)then
              do l=1,n
                 dum=a(irow,l)
                 a(irow,l)=a(icol,l)
                 a(icol,l)=dum
              enddo
              do l=1,m
                 dum=b(irow,l)
                 b(irow,l)=b(icol,l)
                 b(icol,l)=dum
              enddo
          endif
          indxr(i)=irow
          indxc(i)=icol
          if(a(icol,icol).eq.0.)then
             pause 'Singular'
             return
          endif
          pivinv=1.d0/a(icol,icol)
          a(icol,icol)=1.d0
          do l=1,n
             a(icol,l)=a(icol,l)*pivinv
          enddo
          do l=1,m
             b(icol,l)=b(icol,l)*pivinv
          enddo
          do ll=1,n
              if(ll.ne.icol)then
                  dum=a(ll,icol)
                  a(ll,icol)=0
                  do l=1,n
                     a(ll,l)=a(ll,l)-a(icol,l)*dum
                  enddo
                  do l=1,m
                     b(ll,l)=b(ll,l)-b(icol,l)*dum
                  enddo
               endif
           enddo
      enddo
      do l=n,1,-1
         if(indxr(l).ne.indxc(l))then
            do k=1,n
               dum=a(k,indxr(l))
               a(k,indxr(l))=a(k,indxc(l))
               a(k,indxc(l))=dum
            enddo
         endif
      enddo
      end

