      SUBROUTINE FDF3(X,Y,RL1,RL2,F,FX,FY,FXX,FYY,FXY,S)
C
C 9-BAZOVYCH FUNKCI, KUBICKYCH POLYNOMU V TROJUHELNIKU SE 3-MI UZLY.
C F1,F4,F7 -  JEDNOTKOVE HODNOTY V UZLECH, NULOVE PRVNI DERIVACE
C F2,F5,F8 -  NULOVE HODNOTY A JEDNOTKOVE DERIVACE DX V UZLECH
C F3,F6,F9 -  NULOVE HODNOTY A JEDNOTKOVE DERIVACE DY V UZLECH
C
C VSTUP:
C X,Y      - SOURADNICE VRCHOLU
C RL1,RL2  - PLOSNE SOURADNICE (L1,L2) BODU UVNITR TROJUHELNIKU
C
C VYSTUP:
C F,...,FXY- HODNOTY, PRVNI A DRUHE DERIVACE 9-TI BAZOVYCH FUNKCI V BODE L1,L2
C S        - PLOCHA TROJUHELNIKA
C
      DIMENSION Y(3),X(3),F(9),FY(9),FX(9),FYY(9),FXX(9),FXY(9)
      REAL L(3),LY(3),LX(3),LI,LI1,LI2,
     /     L123,LY123,LX123,LYY123,LXX123,LXY123
       L(1)=RL1
       L(2)=RL2
       L(3)=1.-RL1-RL2
       L123=L(1)*L(2)*L(3)
C
C AREA
       DET=(Y(1)*(X(2)-X(3))+Y(2)*(X(3)-X(1))+Y(3)*(X(1)-X(2)))
       S=ABS(DET*.5)
C DERIVATIVES OF AREA COORDINATES
       DO I=1,3
         I1=MOD(I,3)+1
         I2=MOD(I1,3)+1
         LY(I)=(X(I1)-X(I2))/DET
         LX(I)=(Y(I2)-Y(I1))/DET
       ENDDO
       LY123=LY(1)*L(2)*L(3)+L(1)*LY(2)*L(3)+L(1)*L(2)*LY(3)
       LX123=LX(1)*L(2)*L(3)+L(1)*LX(2)*L(3)+L(1)*L(2)*LX(3)
       LYY123=2*(L(1)*LY(2)*LY(3)+L(2)*LY(1)*LY(3)+L(3)*LY(1)*LY(2))
       LXX123=2*(L(1)*LX(2)*LX(3)+L(2)*LX(1)*LX(3)+L(3)*LX(1)*LX(2))
       LXY123=
     /        LX(1)*(LY(2)*L(3)+L(2)*LY(3))+
     /        LX(2)*(LY(1)*L(3)+L(1)*LY(3))+
     /        LX(3)*(LY(2)*L(1)+L(2)*LY(1))
C
       DO I=1,3
       I1=MOD(I,3)+1
       I2=MOD(I1,3)+1
       LI=L(I)
       LI1=L(I1)
       LI2=L(I2)
C
       F(3*I-2)=LI*(1-LI1**2-LI2**2)+LI**2*(1-LI)
       FY(3*I-2)=LY(I)*(1-LI1**2-LI2**2)-2*LI*(LI1*LY(I1)+LI2*LY(I2))
     /          +2*LI*LY(I)-3*LI**2*LY(I)
       FX(3*I-2)=LX(I)*(1-LI1**2-LI2**2)-2*LI*(LI1*LX(I1)+LI2*LX(I2))
     /          +2*LI*LX(I)-3*LI**2*LX(I)
       FYY(3*I-2)=-4*LY(I)*(LI1*LY(I1)+LI2*LY(I2))
     /            -2*LI*(LY(I1)**2+LY(I2)**2)
     /            +2*LY(I)**2-6*LI*LY(I)**2
       FXX(3*I-2)=-4*LX(I)*(LI1*LX(I1)+LI2*LX(I2))
     /            -2*LI*(LX(I1)**2+LX(I2)**2)
     /            +2*LX(I)**2-6*LI*LX(I)**2
       FXY(3*I-2)=-2*LX(I)*(LI1*LY(I1)+LI2*LY(I2))
     /            -2*LY(I)*(LI1*LX(I1)+LI2*LX(I2))
     /            -2*LI*(LY(I1)*LX(I1)+LY(I2)*LX(I2))
     /            +2*LY(I)*LX(I)-6*LI*LY(I)*LX(I)
C
       F(3*I)=  (Y(I1)-Y(I))*(LI**2*LI1+.5*L123)+
     /          (Y(I2)-Y(I))*(LI**2*LI2+.5*L123)
       FY(3*I)=(Y(I1)-Y(I))*(2*LI*LY(I)*LI1+LI**2*LY(I1)+.5*LY123)+
     /         (Y(I2)-Y(I))*(2*LI*LY(I)*LI2+LI**2*LY(I2)+.5*LY123)
       FX(3*I)=(Y(I1)-Y(I))*(2*LI*LX(I)*LI1+LI**2*LX(I1)+.5*LX123)+
     /         (Y(I2)-Y(I))*(2*LI*LX(I)*LI2+LI**2*LX(I2)+.5*LX123)
       FYY(3*I)=(Y(I1)-Y(I))*(2*LY(I)*LY(I)*LI1+4*LI*LY(I)*LY(I1)
     /           +.5*LYY123)
     /           +(Y(I2)-Y(I))*(2*LY(I)*LY(I)*LI2+4*LI*LY(I)*LY(I2)
     /           +.5*LYY123)
       FXX(3*I)=(Y(I1)-Y(I))*(2*LX(I)*LX(I)*LI1+4*LI*LX(I)*LX(I1)
     /           +.5*LXX123)
     /           +(Y(I2)-Y(I))*(2*LX(I)*LX(I)*LI2+4*LI*LX(I)*LX(I2)
     /           +.5*LXX123)
       FXY(3*I)=(Y(I1)-Y(I))*(2*LY(I)*LX(I)*LI1+2*LI*LX(I)*LY(I1)
     /           +2*LI*LY(I)*LX(I1)+.5*LXY123)
     /           +(Y(I2)-Y(I))*(2*LY(I)*LX(I)*LI2+2*LI*LX(I)*LY(I2)
     /           +2*LI*LY(I)*LX(I2)+.5*LXY123)
C
       F(3*I-1)  =(X(I1)-X(I))*(LI**2*LI1+.5*L123)+
     /            (X(I2)-X(I))*(LI**2*LI2+.5*L123)
       FY(3*I-1)=(X(I1)-X(I))*(2*LI*LY(I)*LI1+LI**2*LY(I1)+.5*LY123)+
     /           (X(I2)-X(I))*(2*LI*LY(I)*LI2+LI**2*LY(I2)+.5*LY123)
       FX(3*I-1)=(X(I1)-X(I))*(2*LI*LX(I)*LI1+LI**2*LX(I1)+.5*LX123)+
     /           (X(I2)-X(I))*(2*LI*LX(I)*LI2+LI**2*LX(I2)+.5*LX123)
       FYY(3*I-1)=(X(I1)-X(I))*(2*LY(I)*LY(I)*LI1+4*LI*LY(I)*LY(I1)
     /           +.5*LYY123)
     /           +(X(I2)-X(I))*(2*LY(I)*LY(I)*LI2+4*LI*LY(I)*LY(I2)
     /           +.5*LYY123)
       FXX(3*I-1)=(X(I1)-X(I))*(2*LX(I)*LX(I)*LI1+4*LI*LX(I)*LX(I1)
     /           +.5*LXX123)
     /           +(X(I2)-X(I))*(2*LX(I)*LX(I)*LI2+4*LI*LX(I)*LX(I2)
     /           +.5*LXX123)
       FXY(3*I-1)=(X(I1)-X(I))*(2*LY(I)*LX(I)*LI1+2*LI*LX(I)*LY(I1)
     /           +2*LI*LY(I)*LX(I1)+.5*LXY123)
     /           +(X(I2)-X(I))*(2*LY(I)*LX(I)*LI2+2*LI*LX(I)*LY(I2)
     /           +2*LI*LY(I)*LX(I2)+.5*LXY123)
      ENDDO
      END
 

