      SUBROUTINE FDFQ(NOD,X,Y,RKSI,RETA,F,FX,FY,DET)
C
C ISOPARAMETRICKE BAZOVE FUNKCE A JEJICH PRVNI DERIVACE
C VE CTYRUHELNIKU SE 4/8/9 UZLY.
C
C VSTUPNI PARAMETRY:
C NOD = 4/8/9   POCET UZLU
C X(),Y()     SOURADNICE UZLU (1,2,3,4 VRCHOLY, 5,6,7,8 UPROSTRED STRAN, 9 teziste)
C RKSI,RETA    BEZROZMERNE SOURADNICE (-1,1) BODU UVNITR ELEMENTU
C
C VYSTUP:
C F(),FX(),FY() HODNOTY A PRVNI DERIVACE VSECH 4/8/9 BAZOVYCH FUNKCI V BODE RKSI,RETA
C DET         JAKOBIAN V BODE RKSI,RETA
C
      DIMENSION X(*),Y(*),F(*),FX(*),FY(*),DFKSI(9),DFETA(9),GX(9),GY(9)
      DATA GX,GY/-1.,1.,1.,-1.,0.,1.,0.,-1.,0.,
     /           -1.,-1.,1.,1.,-1.,0.,1.,0.,0./
      DXKSI=0
      DXETA=0
      DYKSI=0
      DYETA=0
      DO I=1,NOD
         XX=GX(I)*RKSI
         YY=GY(I)*RETA
         IF(NOD.EQ.4)THEN
            F(I)=(1+YY)*(1+XX)/4
            DFKSI(I)=GX(I)/4*(1+YY)
            DFETA(I)=GY(I)/4*(1+XX)
         ELSE
            IF(I.LE.4)THEN
              F(I)=(1+YY)*(1+XX)*(XX+YY-1)/4
              DFKSI(I)=GX(I)/4*(1+YY)*(2*XX+YY)
              DFETA(I)=GY(I)/4*(1+XX)*(2*YY+XX)
            ELSEIF(I.EQ.5.OR.I.EQ.7)THEN
              RKSI2=1-RKSI**2
              F(I)=RKSI2*(1+YY)/2
              DFKSI(I)=-RKSI*(1+YY)
              DFETA(I)=GY(I)*RKSI2/2
            ELSE
              RETA2=1-RETA**2
              F(I)=RETA2*(1+XX)/2
              DFKSI(I)=GX(I)*RETA2/2
              DFETA(I)=-RETA*(1+XX)
            ENDIF
            IF(NOD.EQ.9)THEN
              RKSI2=1-RKSI**2
              RETA2=1-RETA**2
              FB=RKSI2*RETA2
              FBKSI=-2*RKSI*RETA2
              FBETA=-2*RETA*RKSI2
              IF(I.LE.4)THEN
                 F(I)=F(I)+FB/4.
                 DFKSI(I)=DFKSI(I)+FBKSI/4.
                 DFETA(I)=DFETA(I)+FBETA/4.
              ELSEIF(I.LE.8)THEN
                 F(I)=F(I)-FB/2.
                 DFKSI(I)=DFKSI(I)-FBKSI/2.
                 DFETA(I)=DFETA(I)-FBETA/2.
              ELSE
                 F(I)=FB
                 DFKSI(I)=FBKSI
                 DFETA(I)=FBETA
              ENDIF
            ENDIF
         ENDIF
         DXKSI=DXKSI+X(I)*DFKSI(I)
         DXETA=DXETA+X(I)*DFETA (I)
         DYKSI=DYKSI+Y(I)*DFKSI(I)
         DYETA=DYETA+Y(I)*DFETA (I)
      ENDDO
      DET = DXKSI*DYETA-DXETA*DYKSI
      IF(DET.EQ.0.)THEN
         WRITE(*,*)' FDFQ zero determinant'
         RETURN
      ENDIF
      DO I=1,NOD
         FX(I)=(DYETA*DFKSI(I)-DYKSI*DFETA(I))/DET
         FY(I)=(DXKSI*DFETA(I)-DXETA*DFKSI(I))/DET
      ENDDO
      END
 

