      SUBROUTINE FDFQQ(NOD,X8,Y8,RKSI,RETA,
     /                 F,DET,X,Y,DXKSI,DXETA,DYKSI,DYETA)
C
C ISOPARAMETRICKE BAZOVE FUNKCE A PRVNI DERIVACE dX/dksi, dX/dETA, ...
C VE CTYRUHELNIKU SE 4/8 UZLY.
C
C VSTUPNI PARAMETRY:
C NOD = 4/8   POCET UZLU
C X8(),Y8()     SOURADNICE UZLU (1,2,3,4 VRCHOLY, 5,6,7,8 UPROSTRED STRAN)
C RKSI,RETA    BEZROZMERNE SOURADNICE (-1,1) BODU UVNITR ELEMENTU
C
C VYSTUP:
C F()         HODNOTY VSECH 4/8 BAZOVYCH FUNKCI V BODE RKSI,RETA
C DET         JAKOBIAN V BODE RKSI,RETA
C X,Y         kartezske souradnice bodu RKSI,RETA
C DXKSI,DXETA,DYKSI,DYETA prvni derivace souradnice X,Y dle Ksi a ETA.
C
      DIMENSION X8(*),Y8(*),F(*),DFKSI(8),DFETA(8),GX(8),GY(8)
      DATA GX,GY/-1.,1.,1.,-1.,0.,1.,0.,-1.,-1.,-1.,1.,1.,-1.,0.,1.,0./
      X=0.
      Y=0.
      DXKSI=0
      DXETA=0
      DYKSI=0
      DYETA=0
      DO I=1,NOD
         XX=GX(I)*RKSI
         YY=GY(I)*RETA
         IF(NOD.EQ.4)THEN
            F(I)=(1+YY)*(1+XX)/4
            DFKSI(I)=GX(I)/4*(1+YY)
            DFETA(I)=GY(I)/4*(1+XX)
         ELSEIF(I.LE.4)THEN
            F(I)=(1+YY)*(1+XX)*(XX+YY-1)/4
            DFKSI(I)=GX(I)/4*(1+YY)*(2*XX+YY)
            DFETA(I)=GY(I)/4*(1+XX)*(2*YY+XX)
         ELSEIF(I.EQ.5.OR.I.EQ.7)THEN
            F(I)=(1-RKSI**2)*(1+YY)/2
            DFKSI(I)=-RKSI*(1+YY)
            DFETA(I)=GY(I)*(1-RKSI**2)/2
         ELSE
            F(I)=(1-RETA**2)*(1+XX)/2
            DFKSI(I)=GX(I)*(1-RETA**2)/2
            DFETA(I)=-RETA*(1+XX)
         ENDIF
         DXKSI=DXKSI+X8(I)*DFKSI(I)
         DXETA=DXETA+X8(I)*DFETA(I)
         DYKSI=DYKSI+Y8(I)*DFKSI(I)
         DYETA=DYETA+Y8(I)*DFETA(I)
         X=X+X8(I)*F(I)
         Y=Y+Y8(I)*F(I)
      ENDDO
      DET = DXKSI*DYETA-DXETA*DYKSI
      END
 
 
