      SUBROUTINE FDFRON(ICTR,IOPER,EDOF,IPU,X,NE,EPS,NFLIM,IDVP,FEL)
C
C FRONTALNI METODA pro FEMINA verze 3. DOUBLE PRECISION
C modifikace 30.11.2003 - zrychleni 2x vynechanim eliminace nulovych
C clenu matice AG a prehozenim radku a sloupcu AG dle zasady, ze vnitrni
C cyklus by mel probihat po sloupecku.
C
C VSTUPNI PARAMETRY
C ICTR      - ICTR=0 sestaveni a reseni soustavy rovnic
C             ICTR=1 neprovadi se ani sestaveni ani reseni, ale elementy
C                    se zpracovavaji standardne a procedure FEL se predavaji
C                    hodnoty X. Pouzije-li se volani FMFRON v tomto rezimu az
C                    po vyreseni soustavy, muze procedura FEL zpracovavat
C                    vysledky tohoto reseni.
C IOPER     - operace (=1 ELEC, =2 THER, =3 CONC, =4 FLOW, =5 STAT)
C subroutine EDOF(ie,ioper,ndl,indl,mdofl,ndofl,idofl)
C     dimension indl(maxndl),ndofl(maxndl),idofl(maxndl,maxndofl)
C     Pokud preda procedura EDOF nulovy pocet pocitanych stupnu volnosti MDOFL,
C     element se neuvazuje.
C
C VSTUPNI PARAMETRY POPISUJICI UZLOVE BODY
C IPU(NEQ)  - status parametru X(IEQ), IEQ=1,2,...,NEQ.
C             IPU=0  NEZNAMA, NEFIXOVA OKRAJOVOU PODMINKOU, ZADNE ZATIZENI.
C             IPU>0  NEZNAMA, NA VSTUPU DO FEFRON REPREZENTUJE PRISPEVEK K
C                    VEKTORU PRAVE STRANY (PREDAVA SE PROCEDURE FEL)
C             IPU<0  OKRAJOVA PODMINKA PRVNIHO DRUHU (ZADAVANA HODNOTA X())
C X(NEQ)    - VEKTOR UZLOVYCH PARAMETRU X(IEQ), IEQ=1,2,...,NEQ.
C               PRIKLAD: K-TY PARAMETR UZLU IU JE X(LPU(IU)+K).
C
C VSTUPNI PARAMETRY POPISUJICI ELEMENTY
C NE        - POCET ELEMENTU
C
C EPS       - MINIMALNI PRIPUSTNA VELIKOST PIVOTACNIHO PRVKU
C NFLIM     - URCUJE MINIMALNI POCET DOKOMPLETOVANYCH ROVNI S NENULOVYMI PIVOTY,
C             KDY JIZ ZACNE ELIMINACE
C IDVP      - CISLO ZARIZENI (KDYZ IDVP=0, ZAPIS DO PAMETI)
C
C FUNKCE POPISUJICI ALGORITMUS ELEMENTU
C subroutine FEL(ICTR,IE,IOPER,L,NUE,AL,BL)
C ICTR      - PREDAVANA HODNOTA PARAMETRU FEFRON
C IE        - INDEX ELEMENTU
C IOPER     - typ operace
C L         - JE ROZMER LOKALNI MATICE AL(L,L)
C NUE       - pocet uzlu elementu
C AL(L,L)   - LOKALNI MATICE ELEMENTU
C BL(L)     - LOKALNI VEKTOR PRAVE STRANY
C Na vystupu BL predava procedura FEL objemovy zdroj. Pokud je nulovy,
C musi procedura FEL tento vektor vynulovat.
C
C POMOCNE PARAMETRY
C AG(NF,NF)   - GLOBALNI MATICE SOUSTAVY
C AL(NL*NL)   - LOKALNI MATICE SOUSTAVY
C BL  (NL)    - LOKALNI VEKTOR PRAVE STRANY (OBJEMOVY ZDROJ)
C LG  (NL)    - LG(I) RADEK MATICE AG ODPOVIDAJICI I-TEMU RADKU MATICE AL
C LLN (NL)    - LLN(I)INDEX UZLU ODPOVIDAJICI I-TEMU RADKU MATICE AL.
C               LLN(I)<0 ZNAMENA, ZE RADEK ODPOVIDA OKRAJOVE PODMINCE 1.DRUHU
C LLX (NL)    - LLX>0 INDEX X()
C               LLX<0 INDEX X() PRO DOKOMPLETOVANOU ROVNICI
C LGX (NF)    - TOTEZ CO LLX(), TJ. INDEX X()
C PN  (NF)    - POMOCNY VEKTOR PIVOTU
C
C Pouzivane procedury: FEFWR$(sekvencni WRITE), FEFRE$(READ),
C                      FEFOP$(OPEN), FEFBC$ (simulace BACKSPACE).
C
      PARAMETER (NF=500,NL=24,IMA=10000000,MAXNDL=20,MAXNDOFL=6)
C Nastaveni MAXNDOFL zavisi na maximalnim poctu uzlu ve FEMINE
      PARAMETER (MAXNDOF=100000*18)
      DIMENSION INDL(MAXNDL),NDOFL(MAXNDL),IDOFL(MAXNDL,MAXNDOFL)
      DIMENSION IPU(*),X(*)
      REAL*8 AG(NF,NF),SUMROW,PIVM,PIV,AA,XK,TS,DX(MAXNDOF),PN(NF)
      INTEGER LGX(NF),LW(1),IPN(2*NF),IA
      DIMENSION AL(NL*NL),BL(NL),LLX(NL),
     /          LLN(NL),LG(NL)
      COMMON /FEFRON$/IDV,IA(IMA),IRC
      EQUIVALENCE (NFA,LW(1)),(PN,IPN)
      EXTERNAL FEL
C
C Prekopirovani X(*) do dvojnasobne presnosti
C
      DO I=1,MAXNDOF
         DX(I)=X(I)
      ENDDO
C
      IDV=IDVP
C
C Otevreni IDV pro zapis
C
      AG=0.0D0
      CALL FEFOP$
      NREC=0
      NFA=0
      J=1
C
C <-------IE-cyklus--------->
C
      ELOOP: DO IE=1,NE
        CALL EDOF(IE,IOPER,NUE,INDL,LL,NDOFL,IDOFL)
C I kdyz se element nesestavuje (LL=0) provadi se test, zda by nemela
C byt provedena eliminace.
        IF(LL.LE.0.AND.ICTR.EQ.0)GOTO 777
        IF(LL.LE.0)CYCLE ELOOP
        L=0
        DO I=1,NUE
           INDU =INDL(I)
           INDUA=IABS(INDU)
C
C INDU-globalni index I-teho uzlu v elementu IE.
C Pro tento uzel je pocet parametru NDOFL a ukazatele jsou v IDOFL
C
C Nasledujici blok stanovi korespondenci mezi radky lokalni matice
C a indexy DX().
C ----------------------------------------------------------------
           DO IP=1,NDOFL(I)
             IX=IDOFL(I,IP)
             IF(IX.LE.0)THEN
                WRITE(*,*)' ERROR in FMFRON caused by EDOF (wrong index 
     /of DOF)'
                RETURN
             ENDIF
             ISTA=IPU(IX)
             L=L+1
C Ulozeni puvodni hodnoty X() do lokalniho vektoru prave strany BL
C Tato hodnota se muze uplatnit pri vyhodnocovani vysledku
C (napr.vypoctu gradientu)
             BL(L)=DX(IX)
C Pro dokompletovane parametry bude LLX<0
             LLX(L)=IX
             IF(INDU.LT.0) LLX(L)=-IX
C Pro fixovane parametry (o.p.) bude LLN(L)<0
             LLN(L)=INDUA
             IF(ISTA.LT.0) LLN(L)=-INDUA
          ENDDO
        ENDDO
C
C ---KONEC CYKLU PRES UZLY ELEMENTU IE
C
C L  -je v tomto okamziku rovno poctu radku lokalni matice, ktere je
C     treba zahrnout do sestavovane matice AG (L<=NL)
C NFA-je aktualni rozmer globalni matice AG (na zacatku sestaveni 0)
C
C VOLANI UZIVATELSKE PROCEDURY, LL JE ROZMER LOKALNI MATICE
C Na vystupu BL predava procedura FEL objemovy zdroj. Pokud je nulovy,
C musi procedura FEL tento vektor vynulovat.
C
        CALL FEL(ICTR,IE,IOPER,L,NUE,AL,BL)
        IF(ICTR.NE.0) CYCLE ELOOP

C Nasledujici blok stanovi korespondenci mezi radky lokalni a globalni
C matice (vektor LG) a korespondenci mezi globalni matici a vektorem X().
C ----------------------------------------------------------------
        DO I=1,L
          IF(LLN(I).GT.0)THEN
            IF(NFA.LE.0)THEN
               NFA=1
               J=1
            ELSE
               DO J=1,NFA
                  IF(IABS(LGX(J)).EQ.IABS(LLX(I))) GOTO 35
               ENDDO
               NFA=NFA+1
               J=NFA
               IF(NFA.GT.NF)THEN
                   WRITE(*,*)' Too small global matrix AG'
                   RETURN
               ENDIF
            ENDIF
35          LG(I)=J
            LGX(J)=LLX(I)
          ENDIF
        ENDDO
C
C PRICTENI LOKALNI MATICE A(IJ) KE GLOBALNI MATICI AG(NFA,NFA)
C PRICTENI LOKALNIHO VEKTORU B(I) KE GLOBALNIMU VEKTORU ZATIZENI X()
C       Pri sestaveni jsou pouzity vektory LG a LLX vysvetlujici kores-
C pondenci mezi radky lokalni a globalni matice (AL,AG) a vektorem nez-
C namych X.
C LG - indexy radku globalni matice AG.
C LLN- index uzlu (vyuzito jen pri aktivaci externi funkce FBC).
C LLX- indexy neznamych X. LLX<0 je informace o tom, ze rovnice je uplna.
C
        DO I=1,L
          I0=LG(I)
          IF(LLN(I).GT.0)THEN
C LLN>0 ZNAMENA, ZE UVAZUJEME JEN ROVNICE, NEFIXOVANE OKRAJOVOU PODMINKOU
            IR=IABS(LLX(I))
            DX(IR)=DX(IR)+BL(I)
            IJ=I
            DO J=1,L
              J0=LG(J)
              IF(LLN(J).GT.0)THEN
C Parametr neni blokovan okrajovou podminkou - PRICTENI
                 AG(J0,I0)=AG(J0,I0)+AL(IJ)
              ELSE
C Parametry zadavane jako okrajove podminky prevedeme na pravou stranu
                 IX=IABS(LLX(J))
                 DX(IR)=DX(IR)-AL(IJ)*DX(IX)
              ENDIF
              IJ=IJ+L
            ENDDO
          ENDIF
        ENDDO
C
C ELIMINACE. NPIV je pocet nenulovych a dokompletovanych
C pivotacnich prvku.
C ======================================================
777     NPIV=0
        DO I=1,NFA
           IF(LGX(I).LT.0.AND.AG(I,I).NE.0.)NPIV=NPIV+1
        ENDDO
C
C Test, zda uz je zadouci provest eliminaci a vlastni eliminace:
C
      ELIM: DO WHILE((NFA.GT.NF-NL .AND.IE.LT.NE) .OR.
     /               (NPIV.GT.NFLIM.AND.IE.LT.NE) .OR.
     /               (NFA.GT.0    .AND.IE.EQ.NE))
          NPIV=NPIV-1
C
C Algoritmus vyberu pivotacniho prvku,
C zalozeny na volbe prvku s maximalni dominanci.
C
          PIVM=0.
          DO I=1,NFA
            IF(LGX(I).LT.0)THEN
C
C Vyber hlavniho prvku z diagonaly dokompletovaneho radku
C (LGX<0 DOKOMPLETOVANA ROVNICE)
C
              SUMROW=0
              DO J=1,NFA
                 SUMROW=SUMROW+DABS(AG(J,I))
              ENDDO
              IF(SUMROW.LE.0.)THEN
                 WRITE(*,*)' All elements of assembled line are ZERO'
                 RETURN
              ENDIF
              PIV=DABS(AG(I,I))/SUMROW
              IF(PIV.GT.PIVM) THEN
                PIVM=PIV
                LPIV=I
              ENDIF
            ENDIF
          ENDDO
          IF(PIVM.LE.EPS)THEN
            WRITE(*,'('' IE='',I6,'' rel.pivot('',e10.3,'') <'',e10.3)')
     /              IE,PIVM,EPS
            RETURN
          ENDIF
C
C Bude treba provest eliminaci jednoho radku globalni matice AG.
C Z dokompletovanych rovnic (viz. zaporne prvky vektoru LGX) je vybran
C pivotacni prvek (prvek AG na diagonale s nejvyssi dominanci)
C
          PIVM=AG(LPIV,LPIV)
C PROHOZENI SLOUPCU LPIV A NFA
          DO I=1,NFA
            POM=AG(I,LPIV)
            AG(I,LPIV)=AG(I,NFA)
            AG(I,NFA)=POM
          ENDDO
C PROHOZENI RADKU LPIV A NFA
          DO I=1,NFA
            POM=AG(LPIV,I)
            AG(LPIV,I)=AG(NFA,I)
            AG(NFA,I)=POM
          ENDDO
C TIM SE PIVOTACNI PRVEK PRESOUVA NA POZICI NFA,NFA
C PREHOZENI LGX VEKTORU
          IPOM=LGX(LPIV)
          LGX(LPIV)=LGX(NFA)
          LGX(NFA)=IPOM
C          
          KP=IABS(IPOM)
          NFA1=NFA-1
          PN(NFA)=1.
          DO J=1,NFA1
             PN(J)=AG(J,NFA)/PIVM
          ENDDO
          XK=DX(KP)/PIVM
          DX(KP)=XK
          DO I=1,NFA1
C UPRAVA VSECH RADKU S VYJIMKOU PIVOTACNIHO (POSLEDNIHO)
             AA=AG(NFA,I)
             IF(DABS(AA).GE.EPS)THEN
                K=IABS(LGX(I))
                DX(K)=DX(K)-AA*XK
                DO J=1,NFA1
                    AG(J,I)=AG(J,I)-AA*PN(J)
                ENDDO
             ENDIF
          ENDDO
C
C Neformatovany sekvencni zapis techo velicin:
C NFA (=lw(1)), LGX1,...,LGX(NFA), PN1,...,PN(NFA)
C
          NREC=NREC+1
          CALL FEFWR$(1,LW)
          CALL FEFWR$(NFA,LGX)
          CALL FEFWR$(2*NFA,IPN)
C NULOVANI POSLEDNIHO RADKU A SLOUPCE AG
          DO I=1,NFA
            AG(I,NFA)=0.
            AG(NFA,I)=0.
          ENDDO
          NFA=NFA-1
        ENDDO ELIM
      ENDDO ELOOP
C
      IF(ICTR.NE.0)RETURN
C
C ZPETNA SUBSTITUCE
C
      DO IR=1,NREC
C
C BACKSPACE 3*
C
         CALL FEFBC$(3)
         CALL FEFRE$(1,LW)
         CALL FEFRE$(NFA,LGX)
         CALL FEFRE$(NFA*2,IPN)
         KP=IABS(LGX(NFA))
         TS=0.
         DO I=1,NFA-1
           TS=TS-PN(I)*DX(IABS(LGX(I)))
         ENDDO
         DX(KP)=DX(KP)+TS
         CALL FEFBC$(3)
      ENDDO
C Prekopirovani vysledku do jednoduche presnosti
      DO I=1,MAXNDOF
         X(I)=DX(I)
      ENDDO
C
C KONEC RESENI
C
      CONTAINS
C
C POMOCNE PROCEDURY PRO SEKVENCNI ZAPIS A CTENI
C----------------------------------------------
      SUBROUTINE FEFOP$
C
C OPEN souboru IDV. Pri IDV=0 je simulovano otevreni virtualniho souboru.
C
      PARAMETER (IMA=10000000)
      COMMON /FEFRON$/IDV,IA(IMA),IRC
      IF(IDV.GT.0)THEN
        REWIND IDV
      ELSE
        IRC=1
      ENDIF
      END SUBROUTINE FEFOP$
 
      SUBROUTINE FEFRE$(N,IV)
C
C Procedura FEFRE$ precte N-slov vektoru IV() ze zarizeni IDV.
C
      PARAMETER (IMA=10000000)
      INTEGER IV(*)
      COMMON /FEFRON$/IDV,IA(IMA),IRC
      IF(IDV.GT.0) THEN
C CTENI ZE SOUBORU
         READ(IDV)(IV(I),I=1,N)
         RETURN
      ELSE
C CTENI Z COMMON//
         IR1=IRC+1
         IR2=IRC+N
         IF(IR2.GT.IMA)THEN
             WRITE(*,*)' READ failed - too short zone IA//'
             RETURN
         ENDIF
         J=1
         DO I=IR1,IR2
           IV(J)=IA(I)
           J=J+1
         ENDDO
         IRC=IR2+1
         IA(IRC)=N+1
      ENDIF
      END SUBROUTINE FEFRE$
 
      SUBROUTINE FEFWR$(N,IV)
C
C Procedura FEFWR$ zapise N-slov vektoru IV() na zariceni IDV.
C
      PARAMETER (IMA=10000000)
      INTEGER IV(*)
      COMMON /FEFRON$/IDV,IA(IMA),IRC
      IF(IDV.GT.0)THEN
C ZAPIS DO SOUBORU
         WRITE(IDV)(IV(I),I=1,N)
      ELSE
C ZAPIS DO COMMON//
         IR1=IRC+1
         IR2=IRC+N
         IF(IR2.GT.IMA)THEN
             WRITE(*,*)' Too short zone COMMON//',IMA
             RETURN
         ENDIF
         J=1
         DO I=IR1,IR2
           IA(I)=IV(J)
           J=J+1
         ENDDO
         IRC=IR2+1
         IA(IRC)=N+1
      ENDIF
      END SUBROUTINE FEFWR$
 
      SUBROUTINE FEFBC$(N)
C
C BACKSPACE IDV celkem N krat. Pri IDV je tato operace simulovana ve
C vnitrni pameti.
C
      PARAMETER (IMA=10000000)
      COMMON /FEFRON$/IDV,IA(IMA),IRC
      IF(IDV.GT.0)THEN
         DO I=1,N
            BACKSPACE IDV
         ENDDO
         RETURN
      ELSEIF(IRC.LE.IMA)THEN
         DO I=1,N
           NN=IA(IRC)
           IRC=IRC-NN
         ENDDO
      ENDIF
      END SUBROUTINE FEFBC$
 
      END
 
 
