      SUBROUTINE FDFT3(X,Y,RL1,RL2,F,FX,FY,S)
C
C ISOPARAMETRICKY TROJUHELNIKOVY PRVEK (XI,YI) 
C SE 3 UZLOVYMI BODY UPROSTRED STRAN.
C F1,...F(3)  =1 V UZLECH
C
C VSTUPY:
C X(),Y()       SOURADNICE VRCHOLU TROJUHELNIKA (NIKOLIV UZLU!)
C RL1,RL2=L1,L2 PLOSNE SOURADNICE LIBOVOLNEHO BODU (0,1)
C
C VYSTUP:
C F,FX,FY HODNOTY A PRVNI DERIVACE TVAROVYCH FUNKCI V BODE L1,L2
C S=PLOCHA TROJUHELNIKU (=JAKOBIAN/2)
C
      DIMENSION Y(*),X(*),F(*),FY(*),FX(*)
      REAL L(3),LY(3),LX(3)
      L(1)=RL1
      L(2)=RL2
      L(3)=1.-RL1-RL2
C
C AREA
      DET=(Y(1)*(X(2)-X(3))+Y(2)*(X(3)-X(1))+Y(3)*(X(1)-X(2)))
      S=ABS(DET*.5)
C DERIVATIVES OF AREA COORDINATES
      DO I=1,3
         I1=MOD(I,3)+1
         I2=MOD(I1,3)+1
         LY(I)=(X(I1)-X(I2))/DET
         LX(I)=(Y(I2)-Y(I1))/DET
      ENDDO
C 3-UZLY (LINEARNI TVAROVE FUNKCE); TESTED O.K. BY BTEST.FOR
      DO I=1,3
         F(I)=1.-0.5*L(I)
         FX(I)=-0.5*LX(I)
         FY(I)=-0.5*LY(I)
      ENDDO
      END
 
