      SUBROUTINE FDFVL(NOD,X,Y,Z,RKSI,RETA,RZETA,F,FX,FY,FZ,DET)
C
C ISOPARAMETRICKE BAZOVE FUNKCE A JEJICH PRVNI DERIVACE
C V SESTISTENU S 8/20 UZLY.
C
C VSTUPNI PARAMETRY:
C NOD = 8/20   POCET UZLU
C X(),Y(),Z()  SOURADNICE UZLU (1,2,...,8 VRCHOLY, 9,..,12 UPROSTRED DOLNI STRANY, 
C                               13,...,16 HORNI, 17,...20 STRED)
C RKSI,RETA,RZETA    BEZROZMERNE SOURADNICE (-1,1) BODU UVNITR ELEMENTU
C
C VYSTUP:
C F(),FX(),FY(),FZ() HODNOTY A PRVNI DERIVACE VSECH BAZOVYCH FUNKCI V BODE RKSI,RETA,RZETA
C DET         JAKOBIAN V BODE RKSI,RETA,RZETA
C
      DIMENSION X(*),Y(*),Z(*),F(*),FX(*),FY(*),FZ(*),
     /          DFKSI(20),DFETA(20),DFZETA(20),GX(20),GY(20),GZ(20)
      REAL J11,J12,J13,J21,J22,J23,J31,J32,J33
      DATA GX,GY,GZ/
     /              -1.,1.,1.,-1.,-1.,1.,1.,-1.,0.,1.,
     /               0.,-1.,0.,1.,0.,-1.,-1.,1.,1.,-1.,
     /              -1.,-1.,1.,1.,-1.,-1.,1.,1.,-1.,0.,
     /               1.,0.,-1.,0.,1.,0.,-1.,-1.,1.,1.,
     /              -1.,-1.,-1.,-1.,1.,1.,1.,1.,-1.,-1.,
     /              -1.,-1.,1.,1.,1.,1.,0.,0.,0.,0./
      DET=0
      IF(NOD.NE.8.AND.NOD.NE.20)RETURN
      J11=0
      J21=0
      J31=0
      J12=0
      J22=0
      J32=0
      J13=0
      J23=0
      J33=0
      DO I=1,NOD
         XX=GX(I)*RKSI
         YY=GY(I)*RETA
         ZZ=GZ(I)*RZETA
         IF(NOD.EQ.8)THEN
            F(I)=(1+YY)*(1+XX)*(1+ZZ)/8
            DFKSI(I)=GX(I)/8*(1+YY)*(1+ZZ)
            DFETA(I)=GY(I)/8*(1+XX)*(1+ZZ)
            DFZETA(I)=GZ(I)/8*(1+XX)*(1+YY)
         ELSE
            IF(I.LE.8)THEN
              F(I)=(1+YY)*(1+XX)*(1+ZZ)*(XX+YY+ZZ-2)/8
              DFKSI(I)=GX(I)/8*(1+YY)*(1+ZZ)*(2*XX+YY+ZZ-1)
              DFETA(I)=GY(I)/8*(1+XX)*(1+ZZ)*(2*YY+XX+ZZ-1)
              DFZETA(I)=GZ(I)/8*(1+XX)*(1+YY)*(2*ZZ+XX+YY-1)
            ELSEIF(I.EQ.9.OR.I.EQ.11.OR.I.EQ.13.OR.I.EQ.15)THEN
              RKSI2=1-RKSI**2
              F(I)=RKSI2*(1+ZZ)*(1+YY)/4
              DFKSI(I)=-RKSI*(1+ZZ)*(1+YY)/2
              DFETA(I)=GY(I)*RKSI2*(1+ZZ)/4
              DFZETA(I)=GZ(I)*RKSI2*(1+YY)/4
            ELSEIF(I.EQ.10.OR.I.EQ.12.OR.I.EQ.14.OR.I.EQ.16)THEN
              RETA2=1-RETA**2
              F(I)=RETA2*(1+ZZ)*(1+XX)/4
              DFKSI(I)=GX(I)*RETA2*(1+ZZ)/4
              DFETA(I)=-RETA*(1+ZZ)*(1+XX)/2
              DFZETA(I)=GZ(I)*RETA2*(1+XX)/4
            ELSE
              RZETA2=1-RZETA**2
              F(I)=RZETA2*(1+XX)*(1+YY)/4
              DFKSI(I)=GX(I)*RZETA2*(1+YY)/4
              DFETA(I)=GY(I)*RZETA2*(1+XX)/4
              DFZETA(I)=-RZETA*(1+XX)*(1+YY)/2
            ENDIF
         ENDIF
         J11=J11+X(I)*DFKSI(I)
         J21=J21+X(I)*DFETA(I)
         J31=J31+X(I)*DFZETA(I)
         J12=J12+Y(I)*DFKSI(I)
         J22=J22+Y(I)*DFETA(I)
         J32=J32+Y(I)*DFZETA(I)
         J13=J13+Z(I)*DFKSI(I)
         J23=J23+Z(I)*DFETA(I)
         J33=J33+Z(I)*DFZETA(I)
      ENDDO
      DET=J11*(J22*J33-J32*J23)-J12*(J21*J33-J31*J23)+
     /                          J13*(J21*J32-J31*J22)
      IF(DET.EQ.0.)THEN
         WRITE(*,*)' FDFVL zero determinant'
         RETURN
      ENDIF
      DO I=1,NOD
         FX(I)=(DFKSI(I)*(J22*J33-J32*J23)-
     /          DFETA(I)*(J12*J33-J32*J13)+
     /          DFZETA(I)*(J12*J23-J22*J13))/DET
         FY(I)=(DFKSI(I)*(J31*J23-J21*J33)-
     /          DFETA(I)*(J31*J13-J11*J33)+
     /          DFZETA(I)*(J21*J13-J11*J23))/DET
         FZ(I)=(DFKSI(I)*(J21*J32-J31*J22)-
     /          DFETA(I)*(J11*J32-J31*J12)+
     /          DFZETA(I)*(J11*J22-J21*J12))/DET
      ENDDO
      END
 
