      SUBROUTINE FDTETRA(NOD,X,Y,Z,RL1,RL2,RL3,F,FX,FY,FZ,V)
C
C TETRA CTYRSTENNY PRVEK SE 4 uzly nebo 8 uzly (v tezistich stran)
C
C VSTUPY:
C X(),Y(),Z()   SOURADNICE UZLU (1,2,3,4 -VRCHOLY, 5,6,7,8 teziste stran)
C RL1,RL2,RL3=L1,L2,L3 objemove SOURADNICE LIBOVOLNEHO BODU (0,1)
C
C NOD=4	 linearni bazove funkce odpovidajici uzlum ve vrcholech
C NOD=16 neuplny kubicky polynom (F,FX,FY,FZ - 4 DOF ve vrcholech)
C F1,F5,F9, F13 - nulove vsechny derivace,jednotkove hodnoty
C F2,F6,F10,F14 - nulove vsechny hodnoty, jednotkove derivace X
C F3,F7,F11,F15 - nulove vsechny hodnoty, jednotkove derivace Y
C F4,F8,F12,F16 - nulove vsechny hodnoty, jednotkove derivace Z
C NOD=20 uplny kubicky polynom
C F17,F18,F19,F20 - jednotkove hodnoty
C
C VYSTUP:
C F,FX,FY,FZ HODNOTY A PRVNI DERIVACE TVAROVYCH FUNKCI V BODE L1,L2,L3
C V=OBJEM CTYRSTENU (=JAKOBIAN/6)
C
      DIMENSION Y(*),X(*),Z(*),F(*),FY(*),FX(*),FZ(*)
      REAL L(4),LY(4),LX(4),LZ(4),LI,LI1,LI2,LI3,LXI,LXI1,LXI2,LXI3,
     /     LYI,LYI1,LYI2,LYI3,LZI,LZI1,LZI2,LZI3
      L(1)=RL1
      L(2)=RL2
      L(3)=RL3
      L(4)=1.-RL1-RL2-RL3
C AREA
      DET=(X(2)-X(1))*(Y(3)*Z(4)-Y(4)*Z(3))+
     /    (X(1)-X(3))*(Y(2)*Z(4)-Y(4)*Z(2))+
     /    (X(4)-X(1))*(Y(2)*Z(3)-Y(3)*Z(2))+
     /    (X(3)-X(2))*(Y(1)*Z(4)-Y(4)*Z(1))+
     /    (X(2)-X(4))*(Y(1)*Z(3)-Y(3)*Z(1))+
     /    (X(4)-X(3))*(Y(1)*Z(2)-Y(2)*Z(1))
      DO I=1,4
        I1=MOD(I,4)+1
        I2=MOD(I1,4)+1
        I3=MOD(I2,4)+1
        LX(I)=
     /-(Y(I2)*(Z(I3)-Z(I1))+Y(I1)*(Z(I2)-Z(I3))+Y(I3)*(Z(I1)-Z(I2)))/DET
        LY(I)=
     / (X(I2)*(Z(I3)-Z(I1))+X(I1)*(Z(I2)-Z(I3))+X(I3)*(Z(I1)-Z(I2)))/DET
        LZ(I)=
     /-(X(I2)*(Y(I3)-Y(I1))+X(I1)*(Y(I2)-Y(I3))+X(I3)*(Y(I1)-Y(I2)))/DET
        DET=-DET
      ENDDO
      V=ABS(DET/6.)
      SELECT CASE(NOD)
      CASE(4)
C LINEARNI BAZOVE FUNKCE VE VRCHOLECH CTYRSTENU
C DERIVATIVES OF AREA COORDINATES
         DO I=1,4
           F(I)=L(I)
           FX(I)=LX(I)
           FY(I)=LY(I)
           FZ(I)=LZ(I)
         ENDDO
      CASE(16)
C KUBICKE BAZOVE FUNKCE (vrcholy - hodnoty a derivace), uplny kvadraticky, 
C neuplny kubicky polynom.
         DO I=1,4
           I1=MOD(I,4)+1
           I2=MOD(I1,4)+1
           I3=MOD(I2,4)+1
           LI=L(I)
           LI1=L(I1)
           LI2=L(I2)
           LI3=L(I3)
           LXI=LX(I)
           LYI=LY(I)
           LZI=LZ(I)
           LXI1=LX(I1)
           LYI1=LY(I1)
           LZI1=LZ(I1)
           LXI2=LX(I2)
           LYI2=LY(I2)
           LZI2=LZ(I2)
           LXI3=LX(I3)
           LYI3=LY(I3)
           LZI3=LZ(I3)
           XI=X(I)
           YI=Y(I)
           ZI=Z(I)
           XI1=X(I1)
           YI1=Y(I1)
           ZI1=Z(I1)
           XI2=X(I2)
           YI2=Y(I2)
           ZI2=Z(I2)
           XI3=X(I3)
           YI3=Y(I3)
           ZI3=Z(I3)
           J=4*I-3
           F(J)=LI*(3*LI-2*LI**2+2*(LI1*LI2+LI1*LI3+LI2*LI3))
           FX(J)=LXI*(3*LI-2*LI**2+2*(LI1*LI2+LI1*LI3+LI2*LI3))+
     /          LI*(3*LXI-4*LI*LXI+2*(LXI1*LI2+LI1*LXI2+
     /          LXI1*LI3+LI1*LXI3+LXI2*LI3+LI2*LXI3))
           FY(J)=LYI*(3*LI-2*LI**2+2*(LI1*LI2+LI1*LI3+LI2*LI3))+
     /          LI*(3*LYI-4*LI*LYI+2*(LYI1*LI2+LI1*LYI2+
     /          LYI1*LI3+LI1*LYI3+LYI2*LI3+LI2*LYI3))
           FZ(J)=LZI*(3*LI-2*LI**2+2*(LI1*LI2+LI1*LI3+LI2*LI3))+
     /          LI*(3*LZI-4*LI*LZI+2*(LZI1*LI2+LI1*LZI2+
     /          LZI1*LI3+LI1*LZI3+LZI2*LI3+LI2*LZI3))
           J=4*I-2
           X12=XI1-2*XI+XI2
           X13=XI1-2*XI+XI3
           X23=XI2-2*XI+XI3
           X1=XI1-XI
           X2=XI2-XI
           X3=XI3-XI
           F(J)=LI**2*(X1*LI1+X2*LI2+X3*LI3)+
     /          0.5*LI*(LI1*LI2*X12+LI1*LI3*X13+LI2*LI3*X23)
           FX(J)=2*LI*LXI*(X1*LI1+X2*LI2+X3*LI3)+
     /           LI**2*(X1*LXI1+X2*LXI2+X3*LXI3)+
     /          0.5*LXI*(LI1*LI2*X12+LI1*LI3*X13+LI2*LI3*X23)+
     /          0.5*LI*(LXI1*LI2*X12+LXI1*LI3*X13+LXI2*LI3*X23)+
     /          0.5*LI*(LI1*LXI2*X12+LI1*LXI3*X13+LI2*LXI3*X23)
           FY(J)=2*LI*LYI*(X1*LI1+X2*LI2+X3*LI3)+
     /           LI**2*(X1*LYI1+X2*LYI2+X3*LYI3)+
     /          0.5*LYI*(LI1*LI2*X12+LI1*LI3*X13+LI2*LI3*X23)+
     /          0.5*LI*(LYI1*LI2*X12+LYI1*LI3*X13+LYI2*LI3*X23)+
     /          0.5*LI*(LI1*LYI2*X12+LI1*LYI3*X13+LI2*LYI3*X23)
           FZ(J)=2*LI*LZI*(X1*LI1+X2*LI2+X3*LI3)+
     /           LI**2*(X1*LZI1+X2*LZI2+X3*LZI3)+
     /          0.5*LZI*(LI1*LI2*X12+LI1*LI3*X13+LI2*LI3*X23)+
     /          0.5*LI*(LZI1*LI2*X12+LZI1*LI3*X13+LZI2*LI3*X23)+
     /          0.5*LI*(LI1*LZI2*X12+LI1*LZI3*X13+LI2*LZI3*X23)
           J=4*I-1
           Y12=YI1-2*YI+YI2
           Y13=YI1-2*YI+YI3
           Y23=YI2-2*YI+YI3
           Y1=YI1-YI
           Y2=YI2-YI
           Y3=YI3-YI
           F(J)=LI**2*(Y1*LI1+Y2*LI2+Y3*LI3)+
     /          0.5*LI*(LI1*LI2*Y12+LI1*LI3*Y13+LI2*LI3*Y23)
           FX(J)=2*LI*LXI*(Y1*LI1+Y2*LI2+Y3*LI3)+
     /           LI**2*(Y1*LXI1+Y2*LXI2+Y3*LXI3)+
     /          0.5*LXI*(LI1*LI2*Y12+LI1*LI3*Y13+LI2*LI3*Y23)+
     /          0.5*LI*(LXI1*LI2*Y12+LXI1*LI3*Y13+LXI2*LI3*Y23)+
     /          0.5*LI*(LI1*LXI2*Y12+LI1*LXI3*Y13+LI2*LXI3*Y23)
           FY(J)=2*LI*LYI*(Y1*LI1+Y2*LI2+Y3*LI3)+
     /           LI**2*(Y1*LYI1+Y2*LYI2+Y3*LYI3)+
     /          0.5*LYI*(LI1*LI2*Y12+LI1*LI3*Y13+LI2*LI3*Y23)+
     /          0.5*LI*(LYI1*LI2*Y12+LYI1*LI3*Y13+LYI2*LI3*Y23)+
     /          0.5*LI*(LI1*LYI2*Y12+LI1*LYI3*Y13+LI2*LYI3*Y23)
           FZ(J)=2*LI*LZI*(Y1*LI1+Y2*LI2+Y3*LI3)+
     /           LI**2*(Y1*LZI1+Y2*LZI2+Y3*LZI3)+
     /          0.5*LZI*(LI1*LI2*Y12+LI1*LI3*Y13+LI2*LI3*Y23)+
     /          0.5*LI*(LZI1*LI2*Y12+LZI1*LI3*Y13+LZI2*LI3*Y23)+
     /          0.5*LI*(LI1*LZI2*Y12+LI1*LZI3*Y13+LI2*LZI3*Y23)
           J=4*I
           Z12=ZI1-2*ZI+ZI2
           Z13=ZI1-2*ZI+ZI3
           Z23=ZI2-2*ZI+ZI3
           Z1=ZI1-ZI
           Z2=ZI2-ZI
           Z3=ZI3-ZI
           F(J)=LI**2*(Z1*LI1+Z2*LI2+Z3*LI3)+
     /          0.5*LI*(LI1*LI2*Z12+LI1*LI3*Z13+LI2*LI3*Z23)
           FX(J)=2*LI*LXI*(Z1*LI1+Z2*LI2+Z3*LI3)+
     /           LI**2*(Z1*LXI1+Z2*LXI2+Z3*LXI3)+
     /          0.5*LXI*(LI1*LI2*Z12+LI1*LI3*Z13+LI2*LI3*Z23)+
     /          0.5*LI*(LXI1*LI2*Z12+LXI1*LI3*Z13+LXI2*LI3*Z23)+
     /          0.5*LI*(LI1*LXI2*Z12+LI1*LXI3*Z13+LI2*LXI3*Z23)
           FY(J)=2*LI*LYI*(Z1*LI1+Z2*LI2+Z3*LI3)+
     /           LI**2*(Z1*LYI1+Z2*LYI2+Z3*LYI3)+
     /          0.5*LYI*(LI1*LI2*Z12+LI1*LI3*Z13+LI2*LI3*Z23)+
     /          0.5*LI*(LYI1*LI2*Z12+LYI1*LI3*Z13+LYI2*LI3*Z23)+
     /          0.5*LI*(LI1*LYI2*Z12+LI1*LYI3*Z13+LI2*LYI3*Z23)
           FZ(J)=2*LI*LZI*(Z1*LI1+Z2*LI2+Z3*LI3)+
     /           LI**2*(Z1*LZI1+Z2*LZI2+Z3*LZI3)+
     /          0.5*LZI*(LI1*LI2*Z12+LI1*LI3*Z13+LI2*LI3*Z23)+
     /          0.5*LI*(LZI1*LI2*Z12+LZI1*LI3*Z13+LZI2*LI3*Z23)+
     /          0.5*LI*(LI1*LZI2*Z12+LI1*LZI3*Z13+LI2*LZI3*Z23)
         ENDDO
      CASE(20)
C Uplny kubicky polynom
         DO I=1,4
           I1=MOD(I,4)+1
           I2=MOD(I1,4)+1
           I3=MOD(I2,4)+1
           LI=L(I)
           LI1=L(I1)
           LI2=L(I2)
           LI3=L(I3)
           LXI=LX(I)
           LYI=LY(I)
           LZI=LZ(I)
           LXI1=LX(I1)
           LYI1=LY(I1)
           LZI1=LZ(I1)
           LXI2=LX(I2)
           LYI2=LY(I2)
           LZI2=LZ(I2)
           LXI3=LX(I3)
           LYI3=LY(I3)
           LZI3=LZ(I3)
           XI=X(I)
           YI=Y(I)
           ZI=Z(I)
           XI1=X(I1)
           YI1=Y(I1)
           ZI1=Z(I1)
           XI2=X(I2)
           YI2=Y(I2)
           ZI2=Z(I2)
           XI3=X(I3)
           YI3=Y(I3)
           ZI3=Z(I3)
           J=4*I-3
           F(J)=LI*(3*LI-2*LI**2-7*(LI1*LI2+LI1*LI3+LI2*LI3))
           FX(J)=LXI*(3*LI-2*LI**2-7*(LI1*LI2+LI1*LI3+LI2*LI3))+
     /          LI*(3*LXI-4*LI*LXI-7*(LXI1*LI2+LI1*LXI2+
     /          LXI1*LI3+LI1*LXI3+LXI2*LI3+LI2*LXI3))
           FY(J)=LYI*(3*LI-2*LI**2-7*(LI1*LI2+LI1*LI3+LI2*LI3))+
     /          LI*(3*LYI-4*LI*LYI-7*(LYI1*LI2+LI1*LYI2+
     /          LYI1*LI3+LI1*LYI3+LYI2*LI3+LI2*LYI3))
           FZ(J)=LZI*(3*LI-2*LI**2-7*(LI1*LI2+LI1*LI3+LI2*LI3))+
     /          LI*(3*LZI-4*LI*LZI-7*(LZI1*LI2+LI1*LZI2+
     /          LZI1*LI3+LI1*LZI3+LZI2*LI3+LI2*LZI3))
           J=4*I-2
           X1=XI-XI1
           X2=XI-XI2
           X3=XI-XI3
           F(J)=LI*
     /     (X1*LI1*(LI2+LI3-LI)+X2*LI2*(LI1+LI3-LI)+X3*LI3*(LI1+LI2-LI))
           FX(J)=LXI*
     /(X1*LI1*(LI2+LI3-LI)+X2*LI2*(LI1+LI3-LI)+X3*LI3*(LI1+LI2-LI))+LI*
     /(X1*LXI1*(LI2+LI3-LI)+X2*LXI2*(LI1+LI3-LI)+X3*LXI3*(LI1+LI2-LI))+
     /(X1*LI1*(LXI2+LXI3-LXI)+X2*LI2*(LXI1+LXI3-LXI)+
     /X3*LI3*(LXI1+LXI2-LXI))
           FY(J)=LYI*
     /(X1*LI1*(LI2+LI3-LI)+X2*LI2*(LI1+LI3-LI)+X3*LI3*(LI1+LI2-LI))+LI*
     /(X1*LYI1*(LI2+LI3-LI)+X2*LYI2*(LI1+LI3-LI)+X3*LYI3*(LI1+LI2-LI))+
     /(X1*LI1*(LYI2+LYI3-LYI)+X2*LI2*(LYI1+LYI3-LYI)+
     /X3*LI3*(LYI1+LYI2-LYI))
           FZ(J)=LZI*
     /(X1*LI1*(LI2+LI3-LI)+X2*LI2*(LI1+LI3-LI)+X3*LI3*(LI1+LI2-LI))+LI*
     /(X1*LZI1*(LI2+LI3-LI)+X2*LZI2*(LI1+LI3-LI)+X3*LZI3*(LI1+LI2-LI))+
     /(X1*LI1*(LZI2+LZI3-LZI)+X2*LI2*(LZI1+LZI3-LZI)+
     /X3*LI3*(LZI1+LZI2-LZI))
           J=4*I-1
           Y1=YI-YI1
           Y2=YI-YI2
           Y3=YI-YI3
           F(J)=LI*
     /     (Y1*LI1*(LI2+LI3-LI)+Y2*LI2*(LI1+LI3-LI)+Y3*LI3*(LI1+LI2-LI))
           FX(J)=LXI*
     /(Y1*LI1*(LI2+LI3-LI)+Y2*LI2*(LI1+LI3-LI)+Y3*LI3*(LI1+LI2-LI))+LI*
     /(Y1*LXI1*(LI2+LI3-LI)+Y2*LXI2*(LI1+LI3-LI)+Y3*LXI3*(LI1+LI2-LI))+
     /(Y1*LI1*(LXI2+LXI3-LXI)+Y2*LI2*(LXI1+LXI3-LXI)+
     /Y3*LI3*(LXI1+LXI2-LXI))
           FY(J)=LYI*
     /(Y1*LI1*(LI2+LI3-LI)+Y2*LI2*(LI1+LI3-LI)+Y3*LI3*(LI1+LI2-LI))+LI*
     /(Y1*LYI1*(LI2+LI3-LI)+Y2*LYI2*(LI1+LI3-LI)+Y3*LYI3*(LI1+LI2-LI))+
     /(Y1*LI1*(LYI2+LYI3-LYI)+Y2*LI2*(LYI1+LYI3-LYI)+
     /Y3*LI3*(LYI1+LYI2-LYI))
           FZ(J)=LZI*
     /(Y1*LI1*(LI2+LI3-LI)+Y2*LI2*(LI1+LI3-LI)+Y3*LI3*(LI1+LI2-LI))+LI*
     /(Y1*LZI1*(LI2+LI3-LI)+Y2*LZI2*(LI1+LI3-LI)+Y3*LZI3*(LI1+LI2-LI))+
     /(Y1*LI1*(LZI2+LZI3-LZI)+Y2*LI2*(LZI1+LZI3-LZI)+
     /Y3*LI3*(LZI1+LZI2-LZI))
           J=4*I
           Z1=ZI-ZI1
           Z2=ZI-ZI2
           Z3=ZI-ZI3
           F(J)=LI*
     /     (Z1*LI1*(LI2+LI3-LI)+Z2*LI2*(LI1+LI3-LI)+Z3*LI3*(LI1+LI2-LI))
           FX(J)=LXI*
     /(Z1*LI1*(LI2+LI3-LI)+Z2*LI2*(LI1+LI3-LI)+Z3*LI3*(LI1+LI2-LI))+LI*
     /(Z1*LXI1*(LI2+LI3-LI)+Z2*LXI2*(LI1+LI3-LI)+Z3*LXI3*(LI1+LI2-LI))+
     /(Z1*LI1*(LXI2+LXI3-LXI)+Z2*LI2*(LXI1+LXI3-LXI)+
     /Z3*LI3*(LXI1+LXI2-LXI))
           FY(J)=LYI*
     /(Z1*LI1*(LI2+LI3-LI)+Z2*LI2*(LI1+LI3-LI)+Z3*LI3*(LI1+LI2-LI))+LI*
     /(Z1*LYI1*(LI2+LI3-LI)+Z2*LYI2*(LI1+LI3-LI)+Z3*LYI3*(LI1+LI2-LI))+
     /(Z1*LI1*(LYI2+LYI3-LYI)+Z2*LI2*(LYI1+LYI3-LYI)+
     /Z3*LI3*(LYI1+LYI2-LYI))
           FZ(J)=LZI*
     /(Z1*LI1*(LI2+LI3-LI)+Z2*LI2*(LI1+LI3-LI)+Z3*LI3*(LI1+LI2-LI))+LI*
     /(Z1*LZI1*(LI2+LI3-LI)+Z2*LZI2*(LI1+LI3-LI)+Z3*LZI3*(LI1+LI2-LI))+
     /(Z1*LI1*(LZI2+LZI3-LZI)+Z2*LI2*(LZI1+LZI3-LZI)+
     /Z3*LI3*(LZI1+LZI2-LZI))
           J=16+I
           F(J)=27.*LI1*LI2*LI3
           FX(J)=27.*(LXI1*LI2*LI3+LI1*LXI2*LI3+LI1*LI2*LXI3)
           FY(J)=27.*(LYI1*LI2*LI3+LI1*LYI2*LI3+LI1*LI2*LYI3)
           FZ(J)=27.*(LZI1*LI2*LI3+LI1*LZI2*LI3+LI1*LI2*LZI3)
         END DO
      END SELECT
      END
