      SUBROUTINE FEMCR(X3,Y3,N3,NIX,AX,NUID,NPU,
     /                 X,Y,LPU,MPU,NDOLD,NDNEW,IUE,LUE,MUE,NEOLD,NENEW)
C
C GENEROVANI ELEMENTU
C NA ZADANE KRIVCE DEFINOVANE 2-MI NEBO 3-MI BODY (PT).
C
C GENEROVANE ELEMENTY MOHOU MIT RUZNE POCTY UZLU A RUZNY POCET PARAMETRU
C V UZLOVYCH BODECH. JE MOZNE DEFINOVAT TYTO TYPY ELEMENTU:
C  NUID=2   USECKA SE 2 UZLY
C  NUID=-3  USECKA S UZLEM UPROSTRED
C
C VSTUPNI PARAMETRY:
C X3(*),Y3(*) - SOURADNICE DEFINICNICH BODU KRIVKY,
C               PRVNI 2 BODY JSOU KONCOVE BODY A DALSI UPROSTRED
C N3          - POCET DEFINICNICH BODU (PRIPUSTNE HODNOTY 2 NEBO 3)
C NIX         - POCET INTERVALU DELICICH KRIVKU
C AX          - ZHUSTENI ELEMENTU (FEMDIV, zaporne hodnoty symetricke zhusteni)
C NUID        - ABS(NUID)=POCET UZLU ELEMENTU (NUID<0 UZEL V TEZISTI)
C NPU(2)      - NPU(1) POCET PARAMETRU ZAKLADNICH UZLU (VE VRCHOLECH)
C               NPU(2) POCET PARAMETRU UZLU V TEZISTI ELEMENTU
C NDOLD       - NOVE UZLY BUDOU GENEROVANY INDEXEM NDOLD+1 POCINAJE
C               NOVE ODKAZY NA VEKTOR PARAMETRU IPU INDEXEM NDOLD+1 POCINAJE
C NEOLD       - NOVE ELEMENTY BUDOU VYTVARENY INDEXEM NEOLD+1 POCINAJE
C
C VYSTUPNI PARAMETRY:
C NDNEW       - INDEX POSLEDNIHO GENEROVANEHO UZLU
C NENEW       - INDEX POSLEDNIHO GENEROVANEHO ELEMENTU
C X(N),Y(N)   - SOURADNICE UZLOVYCH BODU
C LPU(*)      - LPU(ND)+I INDEX I-TEHO PARAMETRU UZLU CISLO ND.
C               NOVE SE GENERUJI HODNOTY LPU(NDOLD+2),...,LPU(NDNEW+1).
C MPU(*)      - POCET PARAMETRU UZLU (=NPU(1|2|3), O=ZRUSENY UZEL)
C IUE(*)      - VEKTOR KONEKTIVITY ELEMENTU
C LUE(*)      - LUE(IE)+I INDEX I-TEHO UZLU ELEMENTU IE.
C               NOVE SE GENERUJI PRVKY LUE(NEOLD+2),...,LUE(NENEW+1)
C MUE(*)     -  =NUID (VYUZIVANO PRO GRAFIKU, MUE<0 POSLEDNI UZEL V TEZISTI)
C
      PARAMETER (MAXU=200,MAXEL=3000,MAXND=1000)
      DIMENSION X3(*),Y3(*),X(*),Y(*),IUE(*),LUE(*),MUE(*),
     /          LPU(*),MPU(*),NPU(*)
      DIMENSION RX(3),XA(MAXU)
      LOGICAL XODD
      DATA RX /-1.,1.,0./
C NU=POCET UZLU ELEMENTU
      NU=IABS(NUID)
C POCET DELICICH INTERVALU
      IF(NU.LE.2)THEN
         NX=NIX
         NS=1
      ELSE
         NX=2*NIX
         NS=2
      ENDIF
C KONTROLA ZADAVANYCH PARAMETRU
      IF(NU.LT.2.OR.NU.GT.3.OR.N3.LT.2.OR.N3.GT.3.OR.
     /   NX.LT.1.OR.NX.GE.MAXU)RETURN
C VYPOCET VEKTORU BEZROZMERNYCH SOURADNIC DELICICH BODU
      CALL FEMDIV(-1.,1.,XA,NX,AX)
      N=NDOLD
C GENEROVANI SOURADNIC UZLU (ISOPARAMETRICKE FUNKCE)
C A INDEXU UZLOVYCH PARAMETRU LPU.
C---------------------------------------------------------
      XODD=.FALSE.
      DO IX=1,NX+1
         XODD=.NOT.XODD
         N=N+1
         IF(N.GT.MAXND)THEN
            WRITE(*,*)' MAX.NODE=',MAXND
            RETURN
         ENDIF
         X(N)=0
         Y(N)=0
         DO I=1,N3
             ZX=XA(IX)*RX(I)
             IF(N3.EQ.2)THEN
                BI=(1+ZX)/2.
             ELSEIF(I.LE.2)THEN
                BI=(1+ZX)*ZX/2.
             ELSE
                BI=1-XA(IX)**2
             ENDIF
             X(N)=X(N)+X3(I)*BI
             Y(N)=Y(N)+Y3(I)*BI
         ENDDO
C STANOVENI POCTU PARAMETRU UZLOVEHO BODU.
C KDYZ JE NU<=2 JE  TO VZDY NPU(1),
C POKUD JE NU=3 MUZE TO BYT NPU(1) (PRO LICHE IX,IY), JINAK NPU(2)
         IF(NU.LE.2.OR.XODD)THEN
             LPU(N+1)=LPU(N)+NPU(1)
             MPU(N)=NPU(1)
         ELSE
             LPU(N+1)=LPU(N)+NPU(2)
             MPU(N)=NPU(2)
         ENDIF
      ENDDO
C GENEROVANI MATICE KONEKTIVITY
C-------------------------------
      NE=NEOLD
      DO IX=1,NX,NS
         NE=NE+1
         IF(NE.GT.MAXEL)THEN
            WRITE(*,*)' MAX.ELEMENTS=',MAXEL
            RETURN
         ENDIF
         MUE(NE)=NU
         L0=LUE(NE)
         IUE(L0+1)=NDOLD+IX
         IUE(L0+2)=NDOLD+IX+NS
         IF(NU.EQ.3)IUE(L0+3)=NDOLD+IX+1
         LUE(NE+1)=L0+NU
      ENDDO
      NENEW=NE
      NDNEW=N
      END
 
