      SUBROUTINE FEMDIV(X0,X1,X,N,A)
C
C POMOCNA PROCEDURA PRO GENEROVANI SITE DELENIM CTYR-NEBO TROJUHELNIKOVE PLOCHY.
C PROCEDURA ROZDELI ZADANY INTERVAL NA N-SUBINTERVALU.
C
C VSTUPNI PARAMETRY:
C X0,X1 SOURADNICE POCATECNIHO A KONCOVEHO BODU INTERVALU
C A     URCUJE ROVNOMERNOST DELENI INTERVALU:
C         A>0  POMER DELKY POSLEDNIHO A PRVNIHO INTERVALU
C         A<0  MIRA ZHUSTENI K OBEMA KONCUM INTERVALU
C              |A| POMER DELEK PROSTREDNIHO A KRAJNIHO INTERVALU
C N     POCET SUBINTERVALU
C VYSTUPNI PARAMETR:
C X(1),...X(N+1), UZLY SUBINTERVALU (X(1)=X0, X(N+1)=X1)
C
      DIMENSION X(N+1)
      SELECT CASE(N)
      CASE(1)
        X(1)=X0
        X(2)=X1
      CASE(2:)
        IF(A.GT.0.)THEN
C GEOMETRICKA RADA S QUOCIENTEM POCITANYM DLE A
           Q=A**(1./(N-1))
           IF(Q.EQ.1.)THEN
             D=(X1-X0)/N
           ELSE
             D=(X1-X0)*(1-Q)/(1-Q**N)
           ENDIF
           X(1)=X0
           DO I=1,N
             X(I+1)=X(I)+D
             D=D*Q
           ENDDO
         ELSEIF(N.GT.2)THEN
C ZHUSTENI SMEREM KE KONCOVYM BODUM
           AA=ABS(A)
           RK=N**2-N*(N+1)**2/2
           DO I=1,N
             RK=RK+I**2
           ENDDO
           Z=(X1-X0)/(N-4*RK*(AA-1)/(N*(N-2)))
           RK=4*Z*(AA-1)/(N*(N-2))
           X(1)=X0
           DO I=1,N
             X(I+1)=X(I)+RK*(I-1)*(N-I)+Z
           ENDDO
         ELSE
C N=2
           X(1)=X0
           X(2)=(X0+X1)/2
           X(3)=X1
         ENDIF
      END SELECT
      END
 
