      SUBROUTINE FEMPT(X,Y,N,CONTROL,IUE,NE,INC,NC,IC)
C
C GENEROVANI TROJUHELNIKOVE SITE ZE ZADANYCH UZLOVYCH BODU X,Y
C JEDNODUSE SOUVISLA KONVEXNI OBLAST.
C VSTUPNI PARAMETRY:
C X(N),Y(N)  VEKTORY SOURADNIC UZLU
C CONTROL    PARAMETR >=0 OVLIVNUJICI ALGORITMUS vyberu optimalniho 
C            tretiho uzlu (DOPORUCENA HODNOTA 0 AZ 2). Male hodnoty
C            preferuji vyznam vnitrniho uhlu (co nejmensi), velke vzdalenost.
C            
C VYSTUPNI PARAMETRY:
C IUE(3,NE)  MATICE KONEKTIVITY. NE-POCET VYGENEROVANYCH ELEMENTU.
C INC(NC)    VEKTOR INDEXU HRANICNICH UZLU. NC-POCET UZLU NA HRANICI.
C POMOCNY VEKTOR
C IC(N)
C
      DIMENSION X(N),Y(N),IUE(3,*),IC(*),INC(*)
      DIMENSION XT(4),YT(4),DS(3)
      LOGICAL OK
      IF(N.LT.3)RETURN

C
C POCATECNI ELEMENT JE HLEDAN POBLIZ TEZISTE XT,YT
C
      XH=0
      YH=0
      DO I=1,N
        XH=XH+X(I)
        YH=YH+Y(I)
        IC(I)=0
      ENDDO
      XH=XH/N
      YH=YH/N
      DMIN=1E10
      DO I=1,N
        DIST=(XH-X(I))**2+(YH-Y(I))**2
        IF(DIST.LT.DMIN)THEN
           I0=I
           DMIN=DIST
        ENDIF
      ENDDO
C I0- POCATECNI BOD
      DMIN=1E10
      DO I=1,N
        IF(I.NE.I0)THEN
           DIS=(X(I)-X(I0))**2+(Y(I)-Y(I0))**2
           IF(DIS.LT.DMIN)THEN
               I1=I
               DMIN=DIS
           ENDIF
        ENDIF
      ENDDO
C I1- NEJBLIZSI BOD
C     VYTVORIME CYKLICKY SEZNAM ICONT SE DVEMA NENULOVYMI PRVKY
      IC(I0)=I1
      IC(I1)=I0
C NC-DVE USECKY OBRYSU
C NE-ZATIM ZADNY ELEMENT
      NC=2
      NE=0
      NFREE=N-2
C
C PROCHAZENI CYKLICKYM SEZNAMEM A HLEDANI NEJLEPSIHO KANDIDATA
C CYKLICKY SEZNAM ZACINA NA I0 (pokud je IC(I0)>0)
C
1     DBEST=1E10
      OK=.FALSE.
      J0=I0
      DO IS=1,NC
C USECKA OBRYSU J1,J2 SE SOUSEDNIMI UZLY J0 (ZLEVA) A J3 (ZPRAVA)
        J1=IC(J0)
        J2=IC(J1)
        J3=IC(J2)
C
C VYBER NEJLEPSIHO BODU CISLO IOPT K DVOJICI J0,J1,
C
        DOPT=1E20
        X1=X(J1)
        Y1=Y(J1)
        X2=X(J2)
        Y2=Y(J2)
        DX=X2-X1
        DY=Y2-Y1
        D0=DX**2+DY**2
C--------CYKLUS PRES VSECHNY VOLNE UZLY
        DO I=1,N
          IF((IC(I).EQ.0.OR.I.EQ.J0.OR.I.EQ.J3)
     /       .AND.I.NE.J1.AND.I.NE.J2)THEN
C Vyhledavame body jen v jedne polorovine (ve smeru vnejsi normaly hranice)
             IF((Y(I)-Y1)*DX.LE.(X(I)-X1)*DY)THEN
                D1=(X1-X(I))**2+(Y1-Y(I))**2
                D2=(X2-X(I))**2+(Y2-Y(I))**2
                DMA=AMAX1(D1,D2)
                DMI=AMIN1(D1,D2)
C HODNOTA ANGLE=1-COS(FI) SE POHYBUJE V INTERVALU 0 (NULOVY UHEL) AZ
C 2 (TUPY UHEL =PI).  COS(FI) PLYNE Z KOSINOVE VETY.
                IF(DMI.GT.0..AND.D0.GT.0.)THEN
                   ANGLE=1.-(D0+DMI-DMA)/(2.*SQRT(DMI*D0))
                ELSE
                   ANGLE=2.
                ENDIF
C DLE TAKTO NASTAVENEHO KRITERIA JSOU PREFEROVANY TROJUHELNIKY S
C CO NEJMENSIM VNITRNIM UHLEM FI (POKUD JE CONTROL=0), VYSSI HODNOTA
C CONTROL ZNAMENA POTLACENI TOHOTO KRITERIA (VYBIRA SE JEN PODLE VZDALENOSTI
C UZLU):
                D=DMA*(ANGLE+CONTROL)
C V PRIPADE, KDYZ UZ NEEXISTUJI VOLNE VNEJSI BODY, PROBIHA JEN ZAPLNOVANI
C HRANICE OBLASTI; pak jsou akceptovany jen elementy s uhlem, ktery neni o
C mnoho vetsi nez PI/2 (ANGLE=1). ANGLE=2 je PI, 
C coz je nepripustna hodnota. 
                IF(D.LT.DOPT.AND.ANGLE.LT.1.9.AND.
     /                 (NFREE.GT.0.OR.ANGLE.LE.1.6))THEN
                   IOPT=I
                   DOPT=D
                ENDIF
             ENDIF
          ENDIF
        ENDDO
C---------
        IF(DOPT.LT.DBEST)THEN
           J0BEST=J0
           J1BEST=J1
           J2BEST=J2
           J3BEST=J3
           IBEST=IOPT
           DBEST=DOPT
           OK=.TRUE.
        ENDIF
        J0=J1
      ENDDO
C NEJLEPSI KANDIDAT JE TROJUHELNIK J1BEST, J2BEST, IBEST
      IF(OK)THEN
        NE=NE+1
        IUE(1,NE)=J1BEST
        IUE(2,NE)=J2BEST
        IUE(3,NE)=IBEST
C MODIFIKACE HRANICE V ZAVISLOSTI NA TYPU UZLU IBEST (MUZE TO BYT VNEJSI
C UZEL NEBO UZEL HRANICE)
        IF(IC(IBEST).EQ.0)THEN
C VNEJSI UZEL JE VLOZEN DO CYKLICKEHO SEZNAMU ZA UZEL JBEST
          IC(IBEST) =J2BEST
          IC(J1BEST)=IBEST
          NC=NC+1
          NFREE=NFREE-1
        ELSEIF(IBEST.EQ.J0BEST)THEN
C NOVY UZEL JE JIZ CASTI HRANICE (UZEL VLEVO). UZEL J1 SE STANE VNITRNIM UZLEM.
          IC(IBEST)=J2BEST
          IC(J1BEST)=-1
          NC=NC-1
        ELSEIF(IBEST.EQ.J3BEST)THEN
C NOVY UZEL JE JIZ CASTI HRANICE (UZEL VPRAVO). UZEL J2 SE STANE VNITRNIM UZLEM.
          IC(J1BEST)=IBEST
          IC(J2BEST)=-1
          NC=NC-1
        ENDIF
        I0=IBEST
        GOTO 1
      ENDIF
C PRESUN CYKLICKEHO SEZNAMU DO VEKTORU INC
      DO I=1,NC
        INC(I)=I0
        I0=IC(I0)
      ENDDO
C
C -------------------
C POSTPROCESSING - POKUS O VYLEPSENI SITE ELEMENTU PRESKUPENIM
C DIAGONAL V ELEMENTECH S VELKYM UHLEM.
C POMOCNY VEKTOR IC(NE) JE NYNI VYUZIVAN PRO OZNACENI ZPRACOVANYCH
C ELEMENTU (=1)
C
      DO I=1,NE
        IC(I)=0
      ENDDO
      OK=.TRUE.
      DO WHILE(OK)
        OK=.FALSE.
        ANGMAX=0
C-------CYKLUS PRES VSECHNY JESTE NETESTOVANE ELEMENTY
        DO IE=1,NE
          IF(IC(IE).EQ.0)THEN
            CALL ANMAX(X,Y,N,IE,ANGLE,IMA)
            IF(ANGLE.GT.ANGMAX)THEN
              IEMAX=IE
              ISMAX=IMA
              ANGMAX=ANGLE
              OK=.TRUE.
            ENDIF
          ENDIF
        ENDDO
C-------KONEC CYKLU PRES NEZPRACOVANE ELEMENTY
        IF(OK)THEN
C       NALEZEN TROJUHELNIK S NEJVETSIM VNITRNIM UHLEM
          IC(IEMAX)=1
C NEJDELSI STRANA S INDEXY UZLU I1,I2
          ISMAX2=MOD(ISMAX ,3)+1
          ISMAX3=MOD(ISMAX2,3)+1
          I1=IUE(ISMAX ,IEMAX)
          I2=IUE(ISMAX2,IEMAX)
          I3=IUE(ISMAX3,IEMAX)
C HLEDANI VOLNEHO ELEMENTU SE STRANOU I1,I2
      FR: DO IE=1,NE
            IF(IC(IE).EQ.0)THEN
              IF((I1.EQ.IUE(1,IE).OR.I1.EQ.IUE(2,IE).OR.I1.EQ.IUE(3,IE))
     /      .AND.(I2.EQ.IUE(1,IE).OR.I2.EQ.IUE(2,IE).OR.I2.EQ.IUE(3,IE))
     /          )THEN
C NALEZEN SOUSEDNI ELEMENT IE K ELEMENTU IEMAX
C TRETI UZEL (I4) ELEMENTU IE
                 DO J=1,3
                    JS=IUE(J,IE)
                    IF(JS.NE.I1.AND.JS.NE.I2)I4=JS
                 ENDDO
C DEFINICE NOVE VARIANTY (VYMENA UHLOPRICKY CTYRUHELNIKU)
                 IUE(1,IEMAX)=I1
                 IUE(2,IEMAX)=I3
                 IUE(3,IEMAX)=I4
                 IUE(1,IE)   =I3
                 IUE(2,IE)   =I2
                 IUE(3,IE)   =I4
C HODNOCENI NOVE VARIANTY
                 CALL ANMAX(X,Y,N,IEMAX,ANG1,IMA)
                 CALL ANMAX(X,Y,N,IE   ,ANG2,IMA)
                 IF(ANG1.GT.ANGMAX.OR.ANG2.GT.ANGMAX)THEN
C VYMENA SE NEPOVEDLA, NAVRAT K PUVODNI KONFIGURACI
                    IUE(3,IEMAX)=I2
                    IUE(1,IE)   =I1
                 ENDIF
                 EXIT FR
              ENDIF
            ENDIF
          ENDDO FR
        ENDIF
      ENDDO
C
C KRIZENI ELEMENTU. ICMAX je maximalni pocet krizeni elementu INMAX
C
      DO WHILE(.TRUE.)
        ICMAX=0
        INMAX=0
        DO IE=1,NE
          ICE=0
          DO JE=1,NE
            IF(IE.NE.JE)THEN
              CALL MCTRIN(IE,JE,IUE,NE,X,Y,N,IN)
              IF(IN.EQ.1)ICE=ICE+1
            ENDIF
          ENDDO
          IF(ICE.GT.ICMAX)THEN
            ICMAX=ICE
            INMAX=IE
          ENDIF
        ENDDO
        IF(INMAX.EQ.0.OR.NE.LE.1)RETURN
C Vyrazeni elementu, ktery se krizi s nejvetsim poctem elementu
        NE=NE-1
        DO I=INMAX,NE
          DO J=1,3
            IUE(J,I)=IUE(J,I+1)
          ENDDO
        ENDDO
      ENDDO
      RETURN
C===========================
      CONTAINS
 
      SUBROUTINE ANMAX(XX,YY,NN,IE,ANGLE,IMA)
C
C Vypocet nejvetsiho uhlu ANGLE elementu cislo IE. Vystupni parametr
C IMA=1,2,3 urcuje vrchol trojuhelnku s nejvetsim uhlem.
C
      DIMENSION XX(NN),YY(NN)
      DO I=1,3
         IAUX=IUE(I,IE)
         XT(I)=XX(IAUX)
         YT(I)=YY(IAUX)
      ENDDO
      XT(4)=XT(1)
      YT(4)=YT(1)
      DMA=0
      DO I=1,3
         DS(I)=(XT(I)-XT(I+1))**2+(YT(I)-YT(I+1))**2
         IF(DS(I).GT.DMA)THEN
            DMA=DS(I)
            IMA=I
         ENDIF
      ENDDO
C  NEJDELSI STRANA JE IMA,IMA+1. ZJISTIME UHEL ODPOVIDAJICI TETO STRANE
      SELECT CASE(IMA)
         CASE(1)
             D1=DS(2)
             D2=DS(3)
         CASE(2)
             D1=DS(1)
             D2=DS(3)
         CASE(3)
             D1=DS(1)
             D2=DS(2)
      END SELECT
      IF(D1.LE.0..OR.D2.LE.0.)THEN
         ANGLE=2.
      ELSE
         ANGLE=1-(D1+D2-DS(IMA))/(2.*SQRT(D1*D2))
      ENDIF
      END SUBROUTINE ANMAX
      END
