      SUBROUTINE FFNDCR(X3,Y3,V3,MCR,IP,NIPU,X,Y,NU,IPU,V,NDIM)
C
C MODIFIKACE PROCEDURY FENDCR - STATUS IPU A NEZNAME X JSOU V MATICICH
C IPU(NDIM,IP) A V(NDIM,IP).
C
C PRIRAZENI PARAMETRU CISLO IP (PRVNI, DRUHY...) UZLOVYM BODUM,
C KTERE LEZI NA USECCE (MCR=2) NEBO KRIVCE (MCR=3) DANE SOURADNICEMI X3,Y3.
C ZADAVANE HODNOTY SE INTERPOLUJI DLE HODNOT V3 (LINEARNE PRI MCR=2).
C ODPOVIDAJICIM PRVKUM VEKTORU IPU SE PRIRADI HODNOTA NIPU (STATUS PARAMETRU).
C TIMTO ZPUSOBEM LZE PARAMETRY
C A) PASIVOVAT (NIPU=1E6),
C B) FIXOVAT OKRAJOVOU PODMINKOU (NIPU=-1, NIPU<-1 UZIVATELSKA FUNKCE)
C C) TOK VELICINY, ZDROJOVY CLEN (NIPU=1 NEBO NIPU>1 UZIVATELSKA FUNKCE)
C
C VSTUPNI PARAMETRY:
C X3(3),Y3(3),V3(3)  HODNOTY X,Y,V V DEFINICNICH BODECH KRIVKY.
C               PRVNI A DRUHY BOD JSOU KONCOVE, EVENT. TRETI UPROSTRED.
C MCR         - POCET DEFINICNICH BODU (2 NEBO 3).
C IP          - PORADI ZADAVANEHO PARAMETRU UZLU
C X(NU),Y(NU) - SOURADNICE UZLOVYCH BODU
C NU          - POCET UZLU
C
C VYSTUPNI PARAMETRY:
C IPU(NDIM,*)- STATUS PARAMETRU (BUDE SE MU PRIRAZOVAT HODNOTA NIPU).
C V(NDIM,*)  - HODNOTA PARAMETRU INTERPOLOVANA Z V3
C
      DIMENSION X3(3),Y3(3),V3(3),X(*),Y(*),IPU(*),V(*)
      AX=2*X3(3)-X3(1)-X3(2)
      AY=2*Y3(3)-Y3(1)-Y3(2)
      BX=X3(2)-X3(1)
      BY=Y3(2)-Y3(1)
      BX2=BX*BX
      BY2=BY*BY
      TOL=SQRT(BX2+BY2)*2E-3
      DO IU=1,NU
       IV=NDIM*(IP-1)+IU
         XX=X(IU)
         YY=Y(IU)
         IF(MCR.EQ.2)THEN
C PRIPAD USECKY 1-2
C VZDALENOST UZLU IU OD PRIMKY
           DIST=ABS((YY-Y3(1))*BX-(XX-X3(1))*BY)
           IF(DIST.LT.TOL)THEN
C PARAMETRICKA VZDALENOST XX,YY OD KONCE X1,Y1 (MUSI BYT 0 AZ 1)
              IF(X3(1).NE.X3(2))THEN
                 T=(XX-X3(1))/BX
              ELSEIF(Y3(1).NE.Y3(2))THEN
                 T=(YY-Y3(1))/BY
              ELSE
                 T=0.
              ENDIF
              IF(T.GE.-0.00001.AND.T.LE.1.00001)THEN
                 IPU(IV)=NIPU
                 V(IV)=V3(1)*(1-T)+V3(2)*T
              ENDIF
            ENDIF
         ELSE
C PRIPAD KVADRATICKE KRIVKY
            IF(ABS(AX).GT.ABS(AY))THEN
               DET=BX2-8*AX*(XX-X3(3))
               IF(DET.GE.0.)THEN
                  TA=(BX-SQRT(DET))/(2*AX)
                  TB=(BX+SQRT(DET))/(2*AX)
                  YA=TA/2*(Y3(2)*(1+TA)-Y3(1)*(1-TA))+Y3(3)*(1-TA*TA)
                  YB=TB/2*(Y3(2)*(1+TB)-Y3(1)*(1-TB))+Y3(3)*(1-TB*TB)
                  DIFA=ABS(YY-YA)
                  DIFB=ABS(YY-YB)
                  IF(DIFA.LE.DIFB)THEN
                      T=TA
                      DIF=DIFA
                  ELSE
                      T=TB
                      DIF=DIFB
                  ENDIF
               ELSE
                  DIF=1E10
               ENDIF
             ELSEIF(ABS(AY).GT.TOL)THEN
               DET=BY2-8*AY*(YY-Y3(3))
               IF(DET.GE.0.)THEN
                  TA=(BY-SQRT(DET))/(2*AY)
                  TB=(BY+SQRT(DET))/(2*AY)
                  XA=TA/2*(X3(2)*(1+TA)-X3(1)*(1-TA))+X3(3)*(1-TA*TA)
                  XB=TB/2*(X3(2)*(1+TB)-X3(1)*(1-TB))+X3(3)*(1-TB*TB)
                  DIFA=ABS(XX-XA)
                  DIFB=ABS(XX-XB)
                  IF(DIFA.LE.DIFB)THEN
                      T=TA
                      DIF=DIFA
                  ELSE
                      T=TB
                      DIF=DIFB
                  ENDIF
               ELSE
                  DIF=1E10
               ENDIF
             ELSE
C VE SKUTECNOSTI JE TO USECKA S UZLEM UPROSTRED
               DIF=ABS((YY-Y3(1))*BX-(XX-X3(1))*BY)
               IF(X3(2).NE.X3(3))THEN
                  T=(XX-X3(3))/(X3(2)-X3(3))
               ELSEIF(Y3(2).NE.Y3(3))THEN
                  T=(YY-Y3(3))/(Y3(2)-Y3(3))
               ELSE
                  T=0.
               ENDIF
             ENDIF
             IF(DIF.LE.TOL.AND.ABS(T).LE.1.00001)THEN
C UZEL IU LEZI NA KRIVCE
                 IPU(IV)=NIPU
                 V(IV)=T/2*(V3(2)*(1+T)-V3(1)*(1-T))+V3(3)*(1-T*T)
             ENDIF
          ENDIF
      ENDDO
      END
 
