      SUBROUTINE FMMCRE(X3,Y3,Z3,N3,NIX,AX,NUID,NINT,
     /    X,Y,Z,NDOLD,NDNEW,IUE,LUE,MUE,MINT,NEOLD,NENEW)
C
C GENEROVANI ELEMENTU
C NA ZADANE KRIVCE DEFINOVANE 2-MI NEBO 3-MI BODY (PT).
C
C GENEROVANE ELEMENTY MOHOU MIT RUZNE POCTY UZLU A RUZNY POCET PARAMETRU
C V UZLOVYCH BODECH. JE MOZNE DEFINOVAT TYTO TYPY ELEMENTU:
C  NUID=2 NINT=0  USECKA SE 2 UZLY
C  NUID=3 NINT=1  USECKA S UZLEM UPROSTRED
C
C PARAMETRY:
C X3(*),Y3(*),Z3(*) - SOURADNICE DEFINICNICH BODU KRIVKY,
C               PRVNI 2 BODY JSOU KONCOVE BODY A DALSI UPROSTRED
C N3          - POCET DEFINICNICH BODU (PRIPUSTNE HODNOTY 2 NEBO 3)
C NIX         - POCET INTERVALU DELICICH KRIVKU
C AX          - ZHUSTENI ELEMENTU (FEMDIV, zaporne hodnoty symetricke zhusteni)
C NUID        - ABS(NUID)=POCET UZLU ELEMENTU 
C NINT        - POCET VNITRNICH UZLU
C X(N),Y(N),Z(N)   - SOURADNICE UZLOVYCH BODU
C NDOLD       - NOVE UZLY BUDOU GENEROVANY INDEXEM NDOLD+1 POCINAJE
C               NOVE ODKAZY NA VEKTOR PARAMETRU IPU INDEXEM NDOLD+1 POCINAJE
C NDNEW       - INDEX POSLEDNIHO GENEROVANEHO UZLU
C IUE(*)      - VEKTOR KONEKTIVITY ELEMENTU
C LUE(*)      - LUE(IE)+I INDEX I-TEHO UZLU ELEMENTU IE.
C               NOVE SE GENERUJI PRVKY LUE(NEOLD+2),...,LUE(NENEW+1)
C MUE(*)     -  =NUID (VYUZIVANO PRO GRAFIKU, MUE<0 POSLEDNI UZEL V TEZISTI)
C NEOLD       - NOVE ELEMENTY BUDOU VYTVARENY INDEXEM NEOLD+1 POCINAJE
C NENEW       - INDEX POSLEDNIHO GENEROVANEHO ELEMENTU
C
      PARAMETER (MAXU=300,MAXEL=100000,MAXND=100000)
      DIMENSION X3(*),Y3(*),Z3(*),X(*),Y(*),Z(*),
     /          IUE(*),LUE(*),MUE(*),MINT(*)
      DIMENSION RX(3),XA(MAXU)
      LOGICAL XODD
      DATA RX /-1.,1.,0./
C NU=POCET UZLU ELEMENTU
      NU=IABS(NUID)
C POCET DELICICH INTERVALU
      IF(NU.LE.2)THEN
         NX=NIX
         NS=1
      ELSE
         NX=2*NIX
         NS=2
      ENDIF
C KONTROLA ZADAVANYCH PARAMETRU
      IF(NU.LT.2.OR.NU.GT.3.OR.N3.LT.2.OR.N3.GT.3.OR.
     /   NX.LT.1.OR.NX.GE.MAXU)RETURN
C VYPOCET VEKTORU BEZROZMERNYCH SOURADNIC DELICICH BODU
      CALL FEMDIV(-1.,1.,XA,NX,AX)
      N=NDOLD
C GENEROVANI SOURADNIC UZLU (ISOPARAMETRICKE FUNKCE)
C A INDEXU UZLOVYCH PARAMETRU LPU.
C---------------------------------------------------------
      XODD=.FALSE.
      DO IX=1,NX+1
         XODD=.NOT.XODD
         N=N+1
         IF(N.GT.MAXND)THEN
            WRITE(*,*)' MAX.NODE=',MAXND
            RETURN
         ENDIF
         X(N)=0
         Y(N)=0
         Z(N)=0
         DO I=1,N3
             ZX=XA(IX)*RX(I)
             IF(N3.EQ.2)THEN
                BI=(1+ZX)/2.
             ELSEIF(I.LE.2)THEN
                BI=(1+ZX)*ZX/2.
             ELSE
                BI=1-XA(IX)**2
             ENDIF
             X(N)=X(N)+X3(I)*BI
             Y(N)=Y(N)+Y3(I)*BI
             Z(N)=Z(N)+Z3(I)*BI
         ENDDO
      ENDDO
C GENEROVANI MATICE KONEKTIVITY
C-------------------------------
      NE=NEOLD
      DO IX=1,NX,NS
         NE=NE+1
         IF(NE.GT.MAXEL)THEN
            WRITE(*,*)' MAX.ELEMENTS=',MAXEL
            RETURN
         ENDIF
         MUE(NE)=NU
         MINT(NE)=NINT
         L0=LUE(NE)
         IUE(L0+1)=NDOLD+IX
         IUE(L0+2)=NDOLD+IX+NS
         IF(NU.EQ.3)IUE(L0+3)=NDOLD+IX+1
         LUE(NE+1)=L0+NU
      ENDDO
      NENEW=NE
      NDNEW=N
      END
 
