      SUBROUTINE FMMSFT(X6,Y6,Z6,N6,NIX,AX,NUIDIN,
     /     X,Y,Z,NDOLD,NDNEW,IUE,LUE,MUE,NEOLD,NENEW)
C
C GENEROVANI TROJUHELNIKOVYCH ELEMENTU
C V ZADANEM TROJUHELNIKU DEFINOVANEM 3 NEBO 6 BODY (PT).
C
C GENEROVANE ELEMENTY MOHOU MIT RUZNE POCTY UZLU A RUZNY POCET PARAMETRU
C V UZLOVYCH BODECH. JE MOZNE DEFINOVAT TYTO TYPY ELEMENTU NUIDIN:
C  NUID=3   TROJUHELNIK SE 3 UZLY
C  NUID=6   TROJUHELNIK SE 6 UZLY (1,2,3 VRCHOLY, 4,5,6 STREDY STRAN)
C
C PARAMETRY:
C X6(*),Y6(*),Z6(*) - SOURADNICE DEFINICNICH BODU TROJUHELNIKOV0 PLOCHY,
C               PRVNI 3 BODY JSOU VRCHOLY A DALSI TROJICE UPROSTRED STRAN
C N6          - POCET DEFINICNICH BODU (PRIPUSTNE HODNOTY 3 NEBO 6)
C NIX         - POCET INTERVALU DELICICH STRANY
C AX          - ZHUSTENI ELEMENTU (FEMDIV, zaporne hodnoty symetricke zhusteni)
C NUIDIN      - ABS(NUIDIN)=POCET UZLU ELEMENTU (NUIDIN<0 UZEL V TEZISTI)
C X(N),Y(N),Z(N)   - SOURADNICE UZLOVYCH BODU
C NDOLD       - NOVE UZLY BUDOU GENEROVANY INDEXEM NDOLD+1 POCINAJE
C               NOVE ODKAZY NA VEKTOR PARAMETRU IPU INDEXEM NDOLD+1 POCINAJE
C NDNEW       - INDEX POSLEDNIHO GENEROVANEHO UZLU (VYSTUPNI PARAMETR)
C IUE(*)      - VEKTOR KONEKTIVITY ELEMENTU
C LUE(*)      - LUE(IE)+I INDEX I-TEHO UZLU ELEMENTU IE.
C               NOVE SE GENERUJI PRVKY LUE(NEOLD+2),...,LUE(NENEW+1)
C MUE(*)     -  NUID (VYUZIVANO PRO GRAFIKU, MUE<0 POSLEDNI UZEL V TEZISTI)
C NEOLD       - NOVE ELEMENTY BUDOU VYTVARENY INDEXEM NEOLD+1 POCINAJE
C NENEW       - INDEX POSLEDNIHO GENEROVANEHO ELEMENTU
C
      PARAMETER (MAXU=300,MAXEL=100000,MAXND=100000)
      DIMENSION X6(*),Y6(*),Z6(*),X(*),Y(*),Z(*),
     /          IUE(*),LUE(*),MUE(*)
      DIMENSION RL(MAXU),ZL(3)
      LOGICAL XODD,YODD
C Kontrola  parametru NUIDIN. Pripustne hodnoty jsou 3,6
      NUID=NUIDIN
      SELECT CASE(NUIDIN)
         CASE(2)
           NUID=-3
         CASE(7)
           NUID=-7
      END SELECT
C
C NU=POCET UZLU ELEMENTU, NUA-POCET UZLU PRO GRAFIKU
      NU=IABS(NUID)
      IF(NUID.GT.0)THEN
         NUA=NUID
      ELSEIF(NUID.NE.-3)THEN
         NUA=NU-1
      ELSE
         NUA=3
         NU=4
      ENDIF
C POCET DELICICH INTERVALU
      IF(NUA.LE.3.AND.NUID.NE.-3)THEN
         NX=NIX
         NY=NIX
      ELSE
         NX=2*NIX
         NY=2*NIX
      ENDIF
      NXSAVE=NX
C KONTROLA ZADAVANYCH PARAMETRU
      IF(NUA.LT.3.OR.NUA.GT.6.OR.N6.LT.3.OR.N6.GT.6.OR.
     /   NX.LT.1.OR.NX.GE.MAXU)RETURN
C VYPOCET VEKTORU BEZROZMERNYCH SOURADNIC DELICICH BODU
      CALL FEMDIV(0.,1.,RL,NX,AX)
      N=NDOLD
C GENEROVANI SOURADNIC UZLU (ISOPARAMETRICKE FUNKCE)
C A INDEXU UZLOVYCH PARAMETRU LPU.
C NEGENERUJI SE UZLY V TEZISTICH ELEMENTU (ANI KDYZ NUID<0)
C---------------------------------------------------------
      YODD=.FALSE.
C IY odpovida plosne souradnici L3
      DO IY=1,NY+1
       YODD=.NOT.YODD
       XODD=.FALSE.
       DO IX=1,NX+1
         XODD=.NOT.XODD
C U trojuhelniku s uzly jen ve stredech stran je NUID=-4
         IF((NUID.NE.-3.OR..NOT.YODD.OR..NOT.XODD))THEN
           N=N+1
           IF(N.GT.MAXND)THEN
              WRITE(*,*)' MAX.NODE=',MAXND
              RETURN
           ENDIF
           X(N)=0.
           Y(N)=0.
           Z(N)=0.
           ZL(2)=RL(IX)
           ZL(3)=RL(IY)
           ZL(1)=1.-ZL(2)-ZL(3)
           DO I=1,N6
             IF(N6.EQ.3)THEN
                BI=ZL(I)
             ELSEIF(I.LE.3)THEN
                BI=2*ZL(I)*(ZL(I)-0.5)
             ELSEIF(I.EQ.4.OR.I.EQ.5)THEN
                BI=4*ZL(I-3)*ZL(I-2)
             ELSE
                BI=4*ZL(1)*ZL(3)
             ENDIF
             X(N)=X(N)+X6(I)*BI
             Y(N)=Y(N)+Y6(I)*BI
             Z(N)=Z(N)+Z6(I)*BI
           ENDDO
         ENDIF
       ENDDO
       NX=NX-1
      ENDDO
      NX=NXSAVE
C GENEROVANI MATICE KONEKTIVITY
C-------------------------------
      WRITE(10,*)' NODES GENERATED ND=',N
      NE=NEOLD
C LB-INDEX BOTTOM, LM-MIDDLE, LT-TOP
      IF(NUID.EQ.-3)THEN
         LB=NDOLD
         LM=LB+NX/2
         LT=LM+NX
         DO IY=1,NY,2
           DO IX=1,NX,2
              NE=NE+1
              L0=LUE(NE)
              IUE(L0+1)=LM+IX
              IUE(L0+2)=LB+(IX+1)/2
              IUE(L0+3)=LM+IX+1
              LUE(NE+1)=L0+NU
              IF(IX.LT.NX-1)THEN
                 NE=NE+1
                 L0=LUE(NE)
                 IUE(L0+1)=LM+IX+1
                 IUE(L0+2)=LM+IX+2
                 IUE(L0+3)=LT+(IX+1)/2
                 LUE(NE+1)=L0+NU
              ENDIF
           ENDDO
           NX=NX-2
           LB=LT
           LM=LB+NX/2
           LT=LM+NX
         ENDDO
      ELSEIF(NUA.LE.3)THEN
         LB=NDOLD
         LT=LB+NX+1
         DO IY=1,NY
           DO IX=1,NX
              NE=NE+1
              IF(NE.GT.MAXEL)THEN
                WRITE(*,*)' MAX.ELEMENTS=',MAXEL
                RETURN
              ENDIF
              L0=LUE(NE)
              IUE(L0+1)=LB+IX
              IUE(L0+2)=LB+IX+1
              IUE(L0+3)=LT+IX
              LUE(NE+1)=L0+NU
              IF(IX.LT.NX)THEN
                NE=NE+1
                L0=LUE(NE)
                IUE(L0+1)=LB+IX+1
                IUE(L0+2)=LT+IX+1
                IUE(L0+3)=LT+IX
                LUE(NE+1)=L0+NU
              ENDIF
           ENDDO
           LB=LT
           LT=LB+NX
           NX=NX-1
         ENDDO
      ELSEIF(NUA.EQ.6)THEN
C TROJUHELNIKOVE ELEMENTY SE 6 UZLY
         LB=NDOLD
         LM=LB+NX+1
         LT=LM+NX
         DO IY=1,NY,2
           DO IX=1,NX,2
              NE=NE+1
              L0=LUE(NE)
              IUE(L0+1)=LB+IX
              IUE(L0+2)=LB+IX+2
              IUE(L0+3)=LT+IX
              IUE(L0+4)=LB+IX+1
              IUE(L0+5)=LM+IX+1
              IUE(L0+6)=LM+IX
              LUE(NE+1)=L0+NU
              IF(IX.LT.NX-1)THEN
                NE=NE+1
                L0=LUE(NE)
                IUE(L0+1)=LB+IX+2
                IUE(L0+2)=LT+IX+2
                IUE(L0+3)=LT+IX
                IUE(L0+4)=LM+IX+2
                IUE(L0+5)=LT+IX+1
                IUE(L0+6)=LM+IX+1
                LUE(NE+1)=L0+NU
              ENDIF
           ENDDO
           NX=NX-2
           LB=LT
           LM=LB+NX+1
           LT=LM+NX
         ENDDO
      ENDIF
      NENEW=NE
C
C GENEROVANI UZLU V TEZISTICH ELEMENTU
C
      DO IE=NEOLD+1,NENEW
        MUE(IE)=NUID
        IF(NUID.LT.0)THEN
          NUE=LUE(IE+1)-LUE(IE)-1
          L0=LUE(IE)
C TEZISTE ELEMENTU IE
          XG=0
          YG=0
          ZG=0
          DO I=1,NUE
            IU=IUE(L0+I)
            XG=XG+X(IU)
            YG=YG+Y(IU)
            ZG=ZG+Z(IU)
          ENDDO
          N=N+1
          IF(N.GT.MAXND)THEN
             WRITE(*,*)' MAX.NODE=',MAXND
             RETURN
          ENDIF
          X(N)=XG/NUE
          Y(N)=YG/NUE
          Z(N)=ZG/NUE
C DOPLNENI INDEXU UZLU N DO VEKTORU KONEKTIVITY
          IUE(L0+NUE+1)=N
        ENDIF
      ENDDO
      NDNEW=N
      END
 
