      SUBROUTINE FMMVL(X20,Y20,Z20,N20,NIX,NIY,NIZ,AX,AY,AZ,NUIDIN,
     /     X,Y,Z,NDOLD,NDNEW,IUE,LUE,MUE,NEOLD,NENEW)
C
C GENEROVANI ELEMENTU SOLID (8 NEBO 20 UZLU) 
C V ZADANEM OBJEMU DEFINOVANEM 8 NEBO 20 BODY (PT).
C
C GENEROVANE ELEMENTY MOHOU MIT RUZNE POCTY UZLU A RUZNY POCET PARAMETRU
C V UZLOVYCH BODECH. JE MOZNE DEFINOVAT TYTO TYPY ELEMENTU NUIDIN:
C  NUID=8   SESTISTEN S 8 UZLY
C  NUID=20  SESTISTEN S 20 UZLY 
C
C PARAMETRY:
C X20(*),Y20(*),Z20(*) - SOURADNICE DEFINICNICH BODU OBJEMU VL,
C               PRVNICH 8 BODU JSOU VRCHOLY A DALSI CTVERICE UPROSTRED STRAN
C N20         - POCET DEFINICNICH BODU (PRIPUSTNE HODNOTY 8 NEBO 20)
C NIX,NIY,NIZ - POCET INTERVALU DELICICH STRANY 1,2,3
C AX,AY,AZ    - ZHUSTENI ELEMENTU (FEMDIV, zaporne hodnoty symetricke zhusteni)
C NUID        - ABS(NUID)=POCET UZLU ELEMENTU (NUID<0 UZEL V TEZISTI)
C X(N),Y(N),Z(N)   - SOURADNICE UZLOVYCH BODU
C NDOLD       - NOVE UZLY BUDOU GENEROVANY INDEXEM NDOLD+1 POCINAJE
C               NOVE ODKAZY NA VEKTOR PARAMETRU IPU INDEXEM NDOLD+1 POCINAJE
C NDNEW       - INDEX POSLEDNIHO GENEROVANEHO UZLU (VYSTUPNI PARAMETR)
C IUE(*)      - VEKTOR KONEKTIVITY ELEMENTU
C LUE(*)      - LUE(IE)+I INDEX I-TEHO UZLU ELEMENTU IE.
C               NOVE SE GENERUJI PRVKY LUE(NEOLD+2),...,LUE(NENEW+1)
C MUE(*)     -  NUID (VYUZIVANO PRO GRAFIKU, MUE<0 POSLEDNI UZEL V TEZISTI)
C NEOLD       - NOVE ELEMENTY BUDOU VYTVARENY INDEXEM NEOLD+1 POCINAJE
C NENEW       - INDEX POSLEDNIHO GENEROVANEHO ELEMENTU
C
      PARAMETER (MAXU=300,MAXEL=100000,MAXND=100000)
      DIMENSION X20(*),Y20(*),Z20(*),X(*),Y(*),Z(*),
     /          IUE(*),LUE(*),MUE(*)
      DIMENSION XA(MAXU),YA(MAXU),ZA(MAXU),F(20),FX(20),FY(20),FZ(20)
      LOGICAL XODD,YODD,ZODD
C Kontrola  parametru NUIDIN. Pripustne hodnoty jsou 8,20
      NUID=NUIDIN
C NU=POCET UZLU ELEMENTU
      NU=IABS(NUID)
C POCET DELICICH INTERVALU
      IF(NU.EQ.8)THEN
         NX=NIX
         NY=NIY
         NZ=NIZ
         NS=1
      ELSE
         NX=2*NIX
         NY=2*NIY
         NZ=2*NIZ
         NS=2
      ENDIF
C KONTROLA ZADAVANYCH PARAMETRU
      IF(NU.LT.8.OR.NU.GT.20.OR.N20.LT.8.OR.N20.GT.20.OR.
     /   NX.LT.1.OR.NY.LT.1.OR.NZ.LT.1.OR.
     /   NX.GE.MAXU.OR.NY.GE.MAXU.OR.NZ.GE.MAXU)RETURN
C VYPOCET VEKTORU BEZROZMERNYCH SOURADNIC DELICICH BODU
      CALL FEMDIV(-1.,1.,XA,NX,AX)
      CALL FEMDIV(-1.,1.,YA,NY,AY)
      CALL FEMDIV(-1.,1.,ZA,NZ,AZ)
      N=NDOLD
C GENEROVANI SOURADNIC UZLU (ISOPARAMETRICKE FUNKCE)
C A INDEXU UZLOVYCH PARAMETRU LPU.
C NEGENERUJI SE UZLY V TEZISTICH ELEMENTU (ANI KDYZ NUID<0)
C---------------------------------------------------------
      ZODD=.FALSE.
      DO IZ=1,NZ+1
        ZODD=.NOT.ZODD
        YODD=.FALSE.
        DO IY=1,NY+1
          YODD=.NOT.YODD
          XODD=.FALSE.
          DO IX=1,NX+1
            XODD=.NOT.XODD
C UZLY MUSI MIT ALESPON DVE SOURADNICE LICHE
            NODD=0
            IF(XODD)NODD=NODD+1
            IF(YODD)NODD=NODD+1
            IF(ZODD)NODD=NODD+1
            IF(NU.EQ.8.OR.NODD.GE.2)THEN
              N=N+1
              IF(N.GT.MAXND)THEN
                WRITE(*,*)' MAX.NODE=',MAXND
                RETURN
              ENDIF
              CALL FDFVL(N20,X20,Y20,Z20,XA(IX),YA(IY),ZA(IZ),
     /                   F,FX,FY,FZ,DET)
              X(N)=0.
              Y(N)=0.
              Z(N)=0.
              DO I=1,N20
                X(N)=X(N)+X20(I)*F(I)
                Y(N)=Y(N)+Y20(I)*F(I)
                Z(N)=Z(N)+Z20(I)*F(I)
             ENDDO
           ENDIF
         ENDDO
       ENDDO
      ENDDO
C GENEROVANI MATICE KONEKTIVITY
C-------------------------------
      WRITE(10,*)' NODES GENERATED ND=',N
      NDNEW=N
      NE=NEOLD
      NDZ20=(NX+1)*(NY/2+1)+(NY+1)*(NX/2+1)
      NDY20=3*NX/2+2
      NDB20=(NX+1)*(NY/2+1)+(NX/2+1)*NY/2
      NDZ8=(NX+1)*(NY+1)
      NDY8=NX+1
      DO IZ=1,NZ,NS
        DO IY=1,NY,NS
         DO IX=1,NX,NS
            SELECT CASE(NU)
            CASE(8)
C ELEMENTY S 8 UZLY
               LBY0=NDOLD+(IZ-1)*NDZ8+(IY-1)*NDY8
               LBY1=LBY0+NDY8
               LTY0=LBY0+NDZ8
               LTY1=LTY0+NDY8
               NE=NE+1
               MUE(NE)=8
               L0=LUE(NE)
               IUE(L0+1)=LBY0+IX
               IUE(L0+2)=LBY0+IX+1
               IUE(L0+3)=LBY1+IX+1
               IUE(L0+4)=LBY1+IX
               IUE(L0+5)=LTY0+IX
               IUE(L0+6)=LTY0+IX+1
               IUE(L0+7)=LTY1+IX+1
               IUE(L0+8)=LTY1+IX
               LUE(NE+1)=L0+NU
            CASE(20)
C ELEMENTY S 20 UZLY
               LBY0=NDOLD+IZ/2*NDZ20+IY/2*NDY20
               LBY1=LBY0+NDY20
               LBYM=LBY0+NX+1
               LTY0=LBY0+NDZ20
               LTY1=LTY0+NDY20
               LTYM=LTY0+NX+1
               LMY0=NDOLD+IZ/2*NDZ20+NDB20+IY/2*(NX/2+1)
               LMY1=LMY0+NX/2+1
               NE=NE+1
               MUE(NE)=20
               L0=LUE(NE)
               IUE(L0+1)=LBY0+IX
               IUE(L0+2)=LBY0+IX+2
               IUE(L0+3)=LBY1+IX+2
               IUE(L0+4)=LBY1+IX
               IUE(L0+5)=LTY0+IX
               IUE(L0+6)=LTY0+IX+2
               IUE(L0+7)=LTY1+IX+2
               IUE(L0+8)=LTY1+IX
               IUE(L0+9)=LBY0+IX+1
               IUE(L0+10)=LBYM+IX/2+2
               IUE(L0+11)=LBY1+IX+1
               IUE(L0+12)=LBYM+IX/2+1
               IUE(L0+13)=LTY0+IX+1
               IUE(L0+14)=LTYM+IX/2+2
               IUE(L0+15)=LTY1+IX+1
               IUE(L0+16)=LTYM+IX/2+1
               IUE(L0+17)=LMY0+IX/2+1
               IUE(L0+18)=LMY0+IX/2+2
               IUE(L0+19)=LMY1+IX/2+2
               IUE(L0+20)=LMY1+IX/2+1
               LUE(NE+1)=L0+NU
            ENDSELECT
            IF(NE.GT.MAXEL)THEN
              WRITE(*,*)' MAX.ELEMENTS=',MAXEL
              RETURN
            ENDIF
          ENDDO
        ENDDO
      ENDDO
      NENEW=NE
      END
 
