      SUBROUTINE FMND3SF(X8,Y8,Z8,V8,NPT,KTYP,NIPU,X,Y,Z,NU,
     /                  LPU,IPU,V,RTOL)
C
C PRIRAZENI PARAMETRU, KTERY JE TYPU KTYP (T,p,...), UZLUM,
C KTERE LEZI UVNITR PLOCHY DEFINOVANE 4/8  (NPT=4/8) BODY X8,Y8,Z8.
C ZADAVANE HODNOTY SE INTERPOLUJI DLE HODNOT V8 (ISOPARAMETRICKE FUNKCE).
C ODPOVIDAJICIM PRVKUM VEKTORU IPU SE PRIRADI HODNOTA NIPU (STATUS PARAMETRU).
C TIMTO ZPUSOBEM LZE PARAMETRY
C A) PASIVOVAT (NIPU=1E6),
C B) FIXOVAT OKRAJOVOU PODMINKOU (NIPU=-1, NIPU<-1 UZIVATELSKA FUNKCE)
C C) TOK VELICINY, ZDROJOVY CLEN (NIPU=1 NEBO NIPU>1 UZIVATELSKA FUNKCE)
C
C VSTUPNI PARAMETRY:
C X8(8),Y8(8),Z8(8),V8(8)  HODNOTY X,Y,Z,V V DEFINICNICH BODECH PLOCHY.
C NPT         - POCET DEFINICNICH BODU PLOCHY (4 NEBO 8).
C KTYP        - IDENTIFIKACE PARAMETRU (T,p,...) KODOVANA JAKO CELE CISLO
C X(NU),Y(NU),Z(NU) - SOURADNICE UZLOVYCH BODU
C NU          - POCET UZLU
C LPU(*)      - UKAZOVATKO DO IPU(*) A SOUCASENE V(*).
C               Index parametru typu I uzlu IU je LPU(I)+IU.
C RTOL        - relativni tolerance
C
C VYSTUPNI PARAMETRY:
C IPU(*)      - STATUS PARAMETRU (BUDE SE MU PRIRAZOVAT HODNOTA NIPU).
C V(*)        - HODNOTA PARAMETRU INTERPOLOVANA Z V8
C
      DIMENSION X8(*),Y8(*),Z8(*),V8(*),X(*),Y(*),Z(*),
     /          LPU(*),IPU(*),V(*),F(8),DFKSI(8),DFETA(8)
      TOL2=RTOL**2
      DO IU=1,NU
         XX=X(IU)
         YY=Y(IU)
         ZZ=Z(IU)
C ZJISTENI, ZDA BOD XX,YY,ZZ LEZI UVNITR PLOCHY. ITERACNE SE STANOVI
C SOURADNICE ZETA,ETA TOHOTO BODU:
         RKSI=0
         RETA=0
         DO ITER=1,10
            CALL FDQ(NPT,RKSI,RETA,F,DFKSI,DFETA)
            SXKSI=0
            SXETA=0
            SXF=0
            SYKSI=0
            SYETA=0
            SYF=0
            SZKSI=0
            SZETA=0
            SZF=0
            DO I=1,NPT
              SXKSI=SXKSI+X8(I)*DFKSI(I)
              SXETA=SXETA+X8(I)*DFETA(I)
              SXF=SXF+X8(I)*F(I)
              SYKSI=SYKSI+Y8(I)*DFKSI(I)
              SYETA=SYETA+Y8(I)*DFETA(I)
              SYF=SYF+Y8(I)*F(I)
              SZKSI=SZKSI+Z8(I)*DFKSI(I)
              SZETA=SZETA+Z8(I)*DFETA(I)
              SZF=SZF+Z8(I)*F(I)
            ENDDO
            A11=SXKSI**2+SYKSI**2+SZKSI**2
            A12=SXKSI*SXETA+SYKSI*SYETA+SZKSI*SZETA
            A22=SXETA**2+SYETA**2+SZETA**2
            B1=(XX-SXF)*SXKSI+(YY-SYF)*SYKSI+(ZZ-SZF)*SZKSI
            B2=(XX-SXF)*SXETA+(YY-SYF)*SYETA+(ZZ-SZF)*SZETA
            DET=A11*A22-A12*A12
            DK=(B1*A22-B2*A12)/DET
            DN=(B2*A11-B1*A12)/DET
            RKSI=RKSI+DK
            RETA=RETA+DN
            IF(ABS(DK).LT.1E-5.AND.ABS(DN).LT.1E-5)EXIT
         ENDDO
         IF(RKSI.GE.-1.005.AND.RKSI.LE.1.005
     /  .AND.RETA.GT.-1.005.AND.RETA.LE.1.005)
     /      THEN
C Stanoveni souradnic SXF,SYF,SZF dle hodnot RKSI,RETA
            DIST2=(SXF-XX)**2+(SYF-YY)**2+(SZF-ZZ)**2
            IF(DIST2.LE.TOL2)THEN
               IV=LPU(KTYP)+IU
               IPU(IV)=NIPU
               W=0
               DO I=1,NPT
                 W=W+V8(I)*F(I)
               ENDDO
               V(IV)=W
            ENDIF
         ENDIF
      ENDDO
      END
 
