      SUBROUTINE FTFRIN(IDOF,NDOF,JPU,LPU,MPU,IUE,LUE,MUE,NE,NU,FEL)
C ͻ
C  PREFRONT inicializacni procedura zjistujici posledni vyskyt uzlu   
C  ve VEKTORU KONEKTIVITY IUE. LUE je vektor pointeru do IUE.         
C ͼ
C OD PROCEDURY FEFRIN SE LISI MOZNOSTI SELEKCE ELEMENTU.
C VSTUPNI A VYSTUPNI PARAMETR:
C  IUE(*)    - VEKTOR KONEKTIVITY (BUDOU ZMENENA ZNAMENKA U UZLU,
C              KTERE SE VE VEKTORU KONEKTIVITY OBJEVI JAKO POSLEDNI)
C VSTUPNI PARAMETRY:
C  IDOF(ndof)- seznam aktivnich stupnu volnosti
C  JPU(*)    - typ stupne volnosti
C  LPU(*)    - ukazatel do JPU
C  MPU(ND)   - pocet stupnu volnosti uzlu
C  LUE(NE+1) - I-TY UZEL IE-TEHO ELEMENTU JE NA POZICI LUE(IE)+I.
C  MUE(NE)     IABS(MUE(IE))=POCET UZLU IE-TEHO ELEMENTU. 0=ZRUSENY ELEMENT.
C  NE        - POCET ELEMENTU
C  NU        - POCET UZLU
C PROCEDURA IDENTIFIKUJICI BLOKOVANE ELEMENTY
C   SUBROUTINE FEL(ICTR,IE,L,NUE,AL,BL)
C MUZE BYT TOTOZNA S PROCEDUROU GENEROVANI LOKALNICH MATIC.
C NUE JE VSTUPNI I VYSTUPNI PARAMETR: NUE=0 JE PRIZNAK BLOKOVANI.
C ICTR=-1 je vstupni parametr. Predpoklada se, ze procedury FEL pouzivane
C soucasne v procedurach FTFRIN i FTFRON budou konstruovane tak, ze pro za-
C pornou hodnotu ICTR provedou jen kontrolu zda sestaveni elementu nema byt
C blokovano, pro ICTR=0 se provadi sestaveni a reseni soustavy, pro ICTR>0
C postprocessing vysledku.
C
      PARAMETER (NL=24)
      DIMENSION IDOF(*),JPU(*),LPU(*),MPU(*),IUE(*),LUE(*),MUE(*),
     /          AL(NL*NL),BL(NL)
C 1.faze Identifikace blokovanych elementu - jsou oznaceny
C        tim, ze od LUE je odecteno 1000000 (pak to bude zcela
C        jiste zaporne cislo).
C
      DO IE=1,NE
         LE0=LUE(IE)
         IF(MUE(IE).EQ.-3)THEN
           NUE=4
         ELSE
           NUE=IABS(MUE(IE))
         ENDIF
         L=0
         DO I=1,NUE
            INDUA=IABS(IUE(LE0+I))
            IUE(LE0+I)=INDUA
            NP=MPU(INDUA)
            LP=LPU(INDUA)
            DO IP=1,NP
               DO IT=1,NDOF
                  IF(IDOF(IT).EQ.JPU(LP+IP))THEN
                     L=L+1
                     EXIT
                  ENDIF
               ENDDO
            ENDDO
         ENDDO
         CALL FEL(-1,IE,L,NUE,AL,BL)
C NUE=0 priznak blokace elementu
         IF(NUE.LE.0)LUE(IE)=LUE(IE)-1000000
      ENDDO
C 2.faze - klasicky prefront
      DO IU=1,NU
        LSTI=0
        DO IE=1,NE
          L0=LUE(IE)
          IF(L0.GE.0)THEN
             IF(MUE(IE).EQ.-3)THEN
               NUE=4
             ELSE
               NUE=IABS(MUE(IE))
             ENDIF
             DO I=1,NUE
               IF(IABS(IUE(L0+I)).EQ.IU)LSTI=L0+I
             ENDDO
          ENDIF
        ENDDO
        IF(LSTI.GT.0)THEN
          IUE(LSTI)=-IU
        ELSE
          WRITE(*,*)' UZEL',IU,' NENI DEFINOVAN V MATICI KONEKTIVITY'
        ENDIF
      ENDDO
C 3.faze - regenerace blokovanych LUE
      DO IE=1,NE
        IF(LUE(IE).LT.0)LUE(IE)=LUE(IE)+1000000
      ENDDO
      END
