      SUBROUTINE FTN3CR(X3,Y3,Z3,M3,X,Y,Z,RTOL,T)
C
C Zjisteni, zda bod X,Y,Z lezi na krivce (2 nebo 3 body) a 
C jaka je jeho parametricka souradnice T (0,1) dle rovnice
C
C    X=X1+(4*X3-3*X1-X2)T+(-4*X3+2*X2+2*X1)T^2
C
C X3(M3),Y3(M3),Z3(M3) - definicni body krivky
C M3  - bud 2 nebo 3
C X,Y,Z - souradnice testovaneho bodu
C RTOL je relativni povolena vzdalenost bodu X,Y,Z od krivky X3,Y3,Z3.
C T - vystupni hodnota (0,1) pokud bod lezi na krivce,
C     T=-1 pokud bod na krivce nelezi.
C
      DIMENSION X3(*),Y3(*),Z3(*)
      BX=X3(2)-X3(1)
      BY=Y3(2)-Y3(1)
      BZ=Z3(2)-Z3(1)
      BSUM=BX*BX+BY*BY+BZ*BZ
      TOL=RTOL**2
      IF(M3.EQ.2)THEN
C
C LINE
C
         T=((X-X3(1))*BX+(Y-Y3(1))*BY+(Z-Z3(1))*BZ)/BSUM
         IF(T.GE.-0.00001.AND.T.LE.1.00001)THEN
            DIST=(X-X3(1)-T*BX)**2+(Y-Y3(1)-T*BY)**2+(Z-Z3(1)-T*BZ)**2
            IF(DIST.GT.BSUM*TOL)T=-1.
         ELSE
            T=-1.
         ENDIF
      ELSE
C
C 3-BODOVA KVADRATICKA KRIVKA
C
         AX=-4*X3(3)+2*(X3(2)+X3(1))
         AY=-4*Y3(3)+2*(Y3(2)+Y3(1))
         AZ=-4*Z3(3)+2*(Z3(2)+Z3(1))
         BX=4*X3(3)-3*X3(1)-X3(2)
         BY=4*Y3(3)-3*Y3(1)-Y3(2)
         BZ=4*Z3(3)-3*Z3(1)-Z3(2)
         TA=-1
         TB=-1
         AAX=ABS(AX)
         AAY=ABS(AY)
         AAZ=ABS(AZ)
         IF(AAX.GT.AAY.AND.AAX.GT.AAZ.AND.AAX.GT.0.0001*ABS(BX))THEN
C AX JE NEJVETSI
            DET=BX**2-4*AX*(X3(1)-X)
            IF(DET.GE.0.)THEN
               SDET=SQRT(DET)
               TA=(-BX+SDET)/(2*AX)
               TB=(-BX-SDET)/(2*AX)
            ENDIF
         ELSEIF(AAY.GT.AAZ.AND.AAY.GT.0.0001*ABS(BY))THEN
C AY JE NEJVETSI
            DET=BY**2-4*AY*(Y3(1)-Y)
            IF(DET.GE.0.)THEN
               SDET=SQRT(DET)
               TA=(-BY+SDET)/(2*AY)
               TB=(-BY-SDET)/(2*AY)
            ENDIF
         ELSEIF(AAZ.GT.0.0001*ABS(BZ))THEN
C AZ JE NEJVETSI
            DET=BZ**2-4*AZ*(Z3(1)-Z)
            IF(DET.GE.0.)THEN
               SDET=SQRT(DET)
               TA=(-BZ+SDET)/(2*AZ)
               TB=(-BZ-SDET)/(2*AZ)
            ENDIF
         ELSE
C VSECHNa AX,AY,AZ JSOU NULA - PRIMKA S UZLEM UPROSTRED
            TA=((X-X3(1))*BX+(Y-Y3(1))*BY+(Z-Z3(1))*BZ)/BSUM
            TB=TA
         ENDIF
C Vyhodnoceni TA,TB
         IF((TA.LT.-0.00001.OR.TA.GT.1.00001).AND.
     /      (TB.LT.-0.00001.OR.TB.GT.1.00001))THEN
            T=-1.
            RETURN
         ELSEIF((TA.LT.-0.00001.OR.TA.GT.1.00001))THEN
C TA je spatne, TB dobre
            T=TB
            T2=T*T
            DIST=(X-X3(1)-T*BX-T2*AX)**2+
     /          (Y-Y3(1)-T*BY-T2*AY)**2+
     /          (Z-Z3(1)-T*BZ-T2*AZ)**2
         ELSEIF((TB.LT.-0.00001.OR.TB.GT.1.00001))THEN
C TA je dobre, TB je spatne
            T=TA
            T2=T*T
            DIST=(X-X3(1)-T*BX-T2*AX)**2+
     /        (Y-Y3(1)-T*BY-T2*AY)**2+
     /        (Z-Z3(1)-T*BZ-T2*AZ)**2
         ELSE
C TA i TB je dobre
            T=TA
            T2=T*T
            DISTA=(X-X3(1)-T*BX-T2*AX)**2+
     /        (Y-Y3(1)-T*BY-T2*AY)**2+
     /        (Z-Z3(1)-T*BZ-T2*AZ)**2
            T=TB
            T2=T*T
            DISTB=(X-X3(1)-T*BX-T2*AX)**2+
     /        (Y-Y3(1)-T*BY-T2*AY)**2+
     /        (Z-Z3(1)-T*BZ-T2*AZ)**2
            IF(DISTB.LT.DISTA)THEN
               T=TB
               DIST=DISTB
            ELSE
               T=TA
               DIST=DISTA
            ENDIF
         ENDIF
         IF(DIST.GT.BSUM*TOL)T=-1.
      ENDIF
      END
 
