      SUBROUTINE FTND3CR(X3,Y3,Z3,V3,MCR,KTYP,NIPU,X,Y,Z,NU,
     /                  LPU,MPU,IPU,JPU,V,RTOL)
C
C PRIRAZENI PARAMETRU, KTERY JE TYPU KTYP (T,p,...), UZLU,
C KTERE LEZI NA USECCE (MCR=2) NEBO KRIVCE (MCR=3) DANE SOURADNICEMI X3,Y3.
C ZADAVANE HODNOTY SE INTERPOLUJI DLE HODNOT V3 (LINEARNE PRI MCR=2).
C ODPOVIDAJICIM PRVKUM VEKTORU IPU SE PRIRADI HODNOTA NIPU (STATUS PARAMETRU).
C TIMTO ZPUSOBEM LZE PARAMETRY
C A) PASIVOVAT (NIPU=1E6),
C B) FIXOVAT OKRAJOVOU PODMINKOU (NIPU=-1, NIPU<-1 UZIVATELSKA FUNKCE)
C C) TOK VELICINY, ZDROJOVY CLEN (NIPU=1 NEBO NIPU>1 UZIVATELSKA FUNKCE)
C
C VSTUPNI PARAMETRY:
C X3(3),Y3(3),Z3(3),V3(3)  souradnice X,Y,Z a hodnoty V v DEFINICNICH BODECH KRIVKY.
C               PRVNI A DRUHY BOD JSOU KONCOVE, EVENT. TRETI UPROSTRED.
C MCR         - POCET DEFINICNICH BODU (2 NEBO 3).
C KTYP        - IDENTIFIKACE PARAMETRU (T,p,...) KODOVANA JAKO CELE CISLO
C X(NU),Y(NU),Z(NU) - SOURADNICE UZLOVYCH BODU
C NU          - POCET UZLU
C LPU(NU+1)   - UKAZOVATKO DO IPU(*) A SOUCASENE V(*).
C               INDEX I-TEHO PARAMETRU UZLU IU JE LPU(IU)+I.
C MPU(NU)     - pocet uzlovych parametru uzlu
C JPU(NU+1)   - IDENTIFIKACE UZLOVYCH PARAMETRU
C RTOL         - tolerance
C
C VYSTUPNI PARAMETRY:
C IPU(*)      - STATUS PARAMETRU (BUDE SE MU PRIRAZOVAT HODNOTA NIPU).
C V(*)        - HODNOTA PARAMETRU INTERPOLOVANA Z V3
C
      DIMENSION X3(*),Y3(*),Z3(*),V3(*),X(*),Y(*),Z(*),
     /          LPU(*),MPU(*),IPU(*),JPU(*),V(*)
      NODES:DO IU=1,NU
C PROHLEDANI SEZNAMU JPU(*) ZDA SE TAM VYSKYTUJE KTYP
         DO J=1,MPU(IU)
           IV=LPU(IU)+J
           IF(KTYP.EQ.JPU(IV))GOTO 88
         ENDDO
         CYCLE NODES
88       XX=X(IU)
         YY=Y(IU)
         ZZ=Z(IU)
         CALL FTN3CR(X3,Y3,Z3,MCR,XX,YY,ZZ,RTOL,T)
C BOD XX,YY,ZZ LEZI NA KRIVCE KDYZ T JE V INTERVALU (0,1)
         IF(T.GT.-.1)THEN
            IPU(IV)=NIPU
            IF(MCR.EQ.2)THEN
                 V(IV)=V3(1)*(1-T)+V3(2)*T
            ELSE
                 V(IV)=V3(1)+
     /                 (4*V3(3)-3*V3(1)-V3(2))*T+
     /                 (-4*V3(3)+2*V3(2)+2*V3(1))*T*T
            ENDIF
         ENDIF
      ENDDO NODES
      END
 
