      SUBROUTINE FTND3SF(X8,Y8,Z8,V8,NPT,KTYP,NIPU,X,Y,Z,NU,
     /                  LPU,MPU,IPU,JPU,V,RTOL)
C
C PRIRAZENI PARAMETRU, KTERY JE TYPU KTYP (T,p,...), UZLUM,
C KTERE LEZI UVNITR PLOCHY DEFINOVANE 4/8  (NPT=4/8) BODY X8,Y8,Z8.
C ZADAVANE HODNOTY SE INTERPOLUJI DLE HODNOT V8 (ISOPARAMETRICKE FUNKCE).
C ODPOVIDAJICIM PRVKUM VEKTORU IPU SE PRIRADI HODNOTA NIPU (STATUS PARAMETRU).
C TIMTO ZPUSOBEM LZE PARAMETRY
C A) PASIVOVAT (NIPU=1E6),
C B) FIXOVAT OKRAJOVOU PODMINKOU (NIPU=-1, NIPU<-1 UZIVATELSKA FUNKCE)
C C) TOK VELICINY, ZDROJOVY CLEN (NIPU=1 NEBO NIPU>1 UZIVATELSKA FUNKCE)
C
C VSTUPNI PARAMETRY:
C X8(8),Y8(8),Z8(8),V8(8)  HODNOTY X,Y,Z,V V DEFINICNICH BODECH PLOCHY.
C NPT         - POCET DEFINICNICH BODU PLOCHY (4 NEBO 8).
C KTYP        - IDENTIFIKACE PARAMETRU (T,p,...) KODOVANA JAKO CELE CISLO
C X(NU),Y(NU),Z(NU) - SOURADNICE UZLOVYCH BODU
C NU          - POCET UZLU
C LPU(NU+1)   - UKAZOVATKO DO IPU(*) A SOUCASENE V(*).
C               INDEX I-TEHO PARAMETRU UZLU IU JE LPU(IU)+I.
C MPU(NU)     - pocet uzlovych parametru uzlu
C JPU(NU+1)   - IDENTIFIKACE UZLOVYCH PARAMETRU
C RTOL        - relativni tolerance
C
C VYSTUPNI PARAMETRY:
C IPU(*)      - STATUS PARAMETRU (BUDE SE MU PRIRAZOVAT HODNOTA NIPU).
C V(*)        - HODNOTA PARAMETRU INTERPOLOVANA Z V8
C
      DIMENSION X8(*),Y8(*),Z8(*),V8(*),X(*),Y(*),Z(*),
     /          LPU(*),MPU(*),IPU(*),JPU(*),V(*),F(8),DFKSI(8),DFETA(8)
      ONE=1.-RTOL
      NODES:DO IU=1,NU
C PROHLEDANI SEZNAMU JPU(*) ZDA SE TAM VYSKYTUJE KTYP
         DO J=1,MPU(IU)
           IV=LPU(IU)+J
           IF(KTYP.EQ.JPU(IV))GOTO 88
         ENDDO
         CYCLE NODES
88       XX=X(IU)
         YY=Y(IU)
         ZZ=Z(IU)
C ZJISTENI, ZDA BOD XX,YY,ZZ LEZI UVNITR PLOCHY. ITERACNE SE STANOVI
C SOURADNICE ZETA,ETA TOHOTO BODU:
         RKSI=0
         RETA=0
         DO ITER=1,10
            CALL FDQ(NPT,RKSI,RETA,F,DFKSI,DFETA)
            SXKSI=0
            SXETA=0
            SXF=0
            SYKSI=0
            SYETA=0
            SYF=0
            SZKSI=0
            SZETA=0
            SZF=0
            DO I=1,NPT
              SXKSI=SXKSI+X8(I)*DFKSI(I)
              SXETA=SXETA+X8(I)*DFETA(I)
              SXF=SXF+X8(I)*F(I)
              SYKSI=SYKSI+Y8(I)*DFKSI(I)
              SYETA=SYETA+Y8(I)*DFETA(I)
              SYF=SYF+Y8(I)*F(I)
              SZKSI=SZKSI+Z8(I)*DFKSI(I)
              SZETA=SZETA+Z8(I)*DFETA(I)
              SZF=SZF+Z8(I)*F(I)
            ENDDO
            A11=SXKSI**2+SYKSI**2+SZKSI**2
            A12=SXKSI*SXETA+SYKSI*SYETA+SZKSI*SZETA
            A22=SXETA**2+SYETA**2+SZETA**2
            B1=(XX-SXF)*SXKSI+(YY-SYF)*SYKSI+(ZZ-SZF)*SZKSI
            B2=(XX-SXF)*SXETA+(YY-SYF)*SYETA+(ZZ-SZF)*SZETA
            DET=A11*A22-A12*A12
            DK=(B1*A22-B2*A12)/DET
            DN=(B2*A11-B1*A12)/DET
            RKSI=RKSI+DK
            RETA=RETA+DN
            IF(ABS(DK).LT.1E-5.AND.ABS(DN).LT.1E-5)EXIT
         ENDDO
         IF(RKSI.GT.-ONE.AND.RKSI.LT.ONE
     /  .AND.RETA.GT.-ONE.AND.RETA .LT.ONE)
     /      THEN
            IPU(LPU(IU)+J)=NIPU
            W=0
            DO I=1,NPT
              W=W+V8(I)*F(I)
            ENDDO
            V(LPU(IU)+J)=W
         ENDIF
      ENDDO NODES
      END
 
