      SUBROUTINE FTNDSF(X8,Y8,V8,NPT,KTYP,NIPU,X,Y,NU,
     /                  LPU,MPU,IPU,JPU,V,RTOL)
C
C PRIRAZENI PARAMETRU, KTERY JE TYPU KTYP (T,p,...), UZLUM,
C KTERE LEZI UVNITR PLOCHY DEFINOVANE 4/8  (NPT=4/8) BODY X8,Y8.
C ZADAVANE HODNOTY SE INTERPOLUJI DLE HODNOT V8 (ISOPARAMETRICKE FUNKCE).
C ODPOVIDAJICIM PRVKUM VEKTORU IPU SE PRIRADI HODNOTA NIPU (STATUS PARAMETRU).
C TIMTO ZPUSOBEM LZE PARAMETRY
C A) PASIVOVAT (NIPU=1E6),
C B) FIXOVAT OKRAJOVOU PODMINKOU (NIPU=-1, NIPU<-1 UZIVATELSKA FUNKCE)
C C) TOK VELICINY, ZDROJOVY CLEN (NIPU=1 NEBO NIPU>1 UZIVATELSKA FUNKCE)
C
C VSTUPNI PARAMETRY:
C X8(8),Y8(8),V8(8)  HODNOTY X,Y,V v DEFINICNICH BODECH PLOCHY.
C NPT         - POCET DEFINICNICH BODU PLOCHY (4 NEBO 8).
C KTYP        - IDENTIFIKACE PARAMETRU (T,p,...) KODOVANA JAKO CELE CISLO
C X(NU),Y(NU) - SOURADNICE UZLOVYCH BODU
C NU          - POCET UZLU
C LPU(NU+1)   - UKAZOVATKO DO IPU(*) A SOUCASENE V(*).
C               INDEX I-TEHO PARAMETRU UZLU IU JE LPU(IU)+I.
C MPU(NU)     - pocet uzlovych parametru uzlu
C JPU(NU+1)   - IDENTIFIKACE UZLOVYCH PARAMETRU
C RTOL        - relativni tolerance
C
C VYSTUPNI PARAMETRY:
C IPU(*)      - STATUS PARAMETRU (BUDE SE MU PRIRAZOVAT HODNOTA NIPU).
C V(*)        - HODNOTA PARAMETRU INTERPOLOVANA Z V8
C
      DIMENSION X8(*),Y8(*),V8(*),X(*),Y(*),
     /          LPU(*),MPU(*),IPU(*),JPU(*),V(*),F(8)
      ONE=1.-RTOL
      NODES:DO IU=1,NU
C PROHLEDANI SEZNAMU JPU(*) ZDA SE TAM VYSKYTUJE KTYP
         DO J=1,MPU(IU)
           IV=LPU(IU)+J
           IF(KTYP.EQ.JPU(IV))GOTO 88
         ENDDO
         CYCLE NODES
88       XX=X(IU)
         YY=Y(IU)
C ZJISTENI, ZDA BOD XX,YY LEZI UVNITR PLOCHY. ITERACNE SE STANOVI
C SOURADNICE ZETA,ETA TOHOTO BODU:
         RKSI=0
         RNY=0
         DO ITER=1,10
            CALL FDFQQ(NPT,X8,Y8,RKSI,RNY,
     /                 F,DET,XN,YN,DXKSI,DXNY,DYKSI,DYNY)
            DK=((XX-XN)*DYNY-(YY-YN)*DXNY)/DET
            DN=((YY-YN)*DXKSI-(XX-XN)*DYKSI)/DET
            RKSI=RKSI+DK
            RNY=RNY+DN
            IF(ABS(DK).LT.1E-5.AND.ABS(DN).LT.1E-5)EXIT
         ENDDO
         IF(RKSI.GT.-ONE.AND.RKSI.LT.ONE
     /  .AND.RNY.GT.-ONE.AND.RNY .LT.ONE)
     /      THEN
            IPU(LPU(IU)+J)=NIPU
            W=0
            DO I=1,NPT
              W=W+V8(I)*F(I)
            ENDDO
            V(LPU(IU)+J)=W
         ENDIF
      ENDDO NODES
      END
 
