      SUBROUTINE FXYZINSF(X8,Y8,Z8,NPT,XX,YY,ZZ,IN,RTOL)
C
C Zjisteni zda bod XX,YY,ZZ 
C LEZI UVNITR PLOCHY DEFINOVANE 4/8  (NPT=4/8) BODY X8,Y8,Z8.
C
C VSTUPNI PARAMETRY:
C X8(8),Y8(8),Z8(8)  souradnice vrcholu PT.
C NPT         - POCET DEFINICNICH BODU PLOCHY (4 NEBO 8).
C XX,YY,ZZ    - SOURADNICE testovaneho BODU
C RTOL        - relativni tolerance
C
C VYSTUPNI PARAMETRY:
C IN          - =0 bod nelezi v plose
C
      DIMENSION X8(*),Y8(*),Z8(*),F(8),DFKSI(8),DFETA(8)
      ONE=1.-RTOL
C ZJISTENI, ZDA BOD XX,YY,ZZ LEZI UVNITR PLOCHY. ITERACNE SE STANOVI
C SOURADNICE ZETA,ETA TOHOTO BODU:
      RKSI=0
      RETA=0
      IN=0
      DO ITER=1,10
         CALL FDQ(NPT,RKSI,RETA,F,DFKSI,DFETA)
         SXKSI=0
         SXETA=0
         SXF=0
         SYKSI=0
         SYETA=0
         SYF=0
         SZKSI=0
         SZETA=0
         SZF=0
         DO I=1,NPT
            SXKSI=SXKSI+X8(I)*DFKSI(I)
            SXETA=SXETA+X8(I)*DFETA(I)
            SXF=SXF+X8(I)*F(I)
            SYKSI=SYKSI+Y8(I)*DFKSI(I)
            SYETA=SYETA+Y8(I)*DFETA(I)
            SYF=SYF+Y8(I)*F(I)
            SZKSI=SZKSI+Z8(I)*DFKSI(I)
            SZETA=SZETA+Z8(I)*DFETA(I)
            SZF=SZF+Z8(I)*F(I)
         ENDDO
         A11=SXKSI**2+SYKSI**2+SZKSI**2
         A12=SXKSI*SXETA+SYKSI*SYETA+SZKSI*SZETA
         A22=SXETA**2+SYETA**2+SZETA**2
         B1=(XX-SXF)*SXKSI+(YY-SYF)*SYKSI+(ZZ-SZF)*SZKSI
         B2=(XX-SXF)*SXETA+(YY-SYF)*SYETA+(ZZ-SZF)*SZETA
         DET=A11*A22-A12*A12
         DK=(B1*A22-B2*A12)/DET
         DN=(B2*A11-B1*A12)/DET
         RKSI=RKSI+DK
         RETA=RETA+DN
         IF(ABS(DK).LT.1E-5.AND.ABS(DN).LT.1E-5)GOTO 1
      ENDDO
      RETURN
1     IF(RKSI.GT.-ONE.AND.RKSI.LT.ONE
     /  .AND.RETA.GT.-ONE.AND.RETA .LT.ONE)
     /      THEN
         IN=1
      ELSE
         IN=0
      ENDIF
      END
 
