      SUBROUTINE GMFECTR(FIRST,IND,LABEL,NLAB,X,Y,VAL,
     /  IUE,LUE,MUE,MINT,NE,
     /  B1MI,B1MA,B2MI,B2MA,VMIN,VMAX,IVMIN,IVMAX,ICOL)
C
C CONTOURS ON MESH OF ELEMENTS (TRIANGLES OR QUADRILATERALS).
C Vykresleji se UZLOVE hodnoty (DOF)
C Rozklad ctyruhelniku na trojuhelniky a
C linearni interpolace (a+bx+cy). Spojite spektrum barev.
C Barvou ICOL kresli i cary - vrstevnice. Vyuzivaji se procedury
C pro vykreslovani vrstevnic v trojuhelnicich.
C
C FIRST    - =.true. volani GMFAXE
C IND      - INDEX OKNA, LABEL (TEXT NLAB ZNAKU)
C X(*),Y(*)- SOURADNICE UZLU
C VAL(*)   - FUNKCNI HODNOTY V UZLECH
C IUE(*)   - VEKTOR KONEKTIVITY (INDEXY UZLU ELEMENTU 1...NE)
C LUE(NE+1)- INDEX I-TEHO UZLU ELEMENTU IE JE LUE(IE)+I
C MUE(*)   - IABS(MUE)=POCET UZLU ELEMENTU.
C MINT(*)  - pocet vnitrnich uzlu elementu (nekreslit)
C B1MI,... - OBDELNIK (X,Y), OHRANICENY BARVOU ICOL
C VMIN,VMAX- ROZSAH VAL, IVMIN,IVMAX ODPOVIDAJICI KODY BAREV (0-2850)
C ICOL     - BARVA VRSTEVNIC A RAMECKU
C
C Fortran PowerStation 16-Jul-02
C
C MAXX,MAXY pocet pixelu X,Y
C WXT,WYT   delka textu, ale v uzivatelsych souradnicich
C NX,DNX,DX informace pro osy - pocet useku, meritko a tik
C IXMI,...  vnejsi okenko  [I]
C JXMI,...  vnitrni okenko [J]
C FXMI,...  vnejsi okenko v uzivatelskych souradnicich  [F]
C WXMI,...  vnitrni okenko v uzivatelskych souradnicich [W]
C QXMI,...  zaokrouhlene rozsahy uzivatelske souradnice
C
      INTEGER *2 IXMI,IXMA,IYMI,IYMA,JXMI,JXMA,JYMI,JYMA,
     /           MAXX,MAXY
      REAL    *8 WXMI,WXMA,WYMI,WYMA,FXMI,FXMA,FYMI,FYMA,
     /           WXT,WYT
      CHARACTER *16 SYMX,SYMY
      COMMON /GMF$/
     /  IXMI,IXMA,IYMI,IYMA,
     /  JXMI,JXMA,JYMI,JYMA,
     /  WXMI,WXMA,WYMI,WYMA,
     /  FXMI,FXMA,FYMI,FYMA,
     /  QXMI,QXMA,QYMI,QYMA,
     /  NX,NY,DNX,DNY,DX,DY,
     /  MAXX,MAXY,IWIN,IFON,IHEI,
     /  SYMX,SYMY,NXS,NYS,
     /  WXT,WYT
      PARAMETER (NC=10)
      DIMENSION X(*),Y(*),VAL(*),IUE(*),LUE(*),MUE(*),MINT(*),
     /          X3(4),Y3(4),V3(4),V(NC),IQ(3,6),XE(3),YE(3),VE(3)
      CHARACTER *12 LAB, LABEL*(*)
      LOGICAL FIRST,INSIDE
      IF(NE.LT.1) GOTO9999
      DO J=1,NC
         V(J)=VMIN+J*(VMAX-VMIN)/NC
      ENDDO
      IF(FIRST)CALL GMFAXE(IND,7,15)
      IF(VMIN.GE.VMAX)RETURN
      CALL GMFREC(B1MI,B1MA,B2MI,B2MA,ICOL)
      D2=(B2MA-B2MI)/20.
      D1=(B1MA-B1MI)/20.
      BXMI=B1MI-D1/5.
      BXMA=B1MA+D1/5.
      BYMI=B2MI-D2/5.
      BYMA=B2MA+D2/5.
      DO IE=1,NE
         MUEL=MUE(IE)
C NUE pocet vykreslovanych obrysovych uzlu
         NUE=IABS(MUEL)-MINT(IE)
         L0=LUE(IE)
         IF(NUE.GE.3.AND.MUEL.NE.-4)THEN
C ROZKLAD NA 1,2,4,6 TROJUHELNIKU DLE HODNOTY NUE
           CALL DECOMP(NUE,NTR,IQ)
           DO IT=1,NTR
C TROJUHELNIK IT 1,2,3
             INSIDE=.TRUE.
             DO I=1,3
                IQL=IQ(I,IT)
                IU=IABS(IUE(L0+IQL))
                X3(I)=X(IU)
                Y3(I)=Y(IU)
                IF(X3(I).LT.BXMI.OR.X3(I).GT.BXMA.OR.
     /             Y3(I).LT.BYMI.OR.Y3(I).GT.BYMA)INSIDE=.FALSE.
                V3(I)=VAL(IU)
             ENDDO
             IF(INSIDE)CALL GMFCTR(V3,X3,Y3,VMIN,VMAX,IVMIN,IVMAX)
           ENDDO
         ELSEIF(MUEL.EQ.-4)THEN
           INSIDE=.TRUE.
           DO I=1,4
             IU=IABS(IUE(L0+I))
             X3(I)=X(IU)
             Y3(I)=Y(IU)
             IF(X3(I).LT.BXMI.OR.X3(I).GT.BXMA.OR.
     /          Y3(I).LT.BYMI.OR.Y3(I).GT.BYMA)INSIDE=.FALSE.
             V3(I)=VAL(IU)
           ENDDO
           IF(INSIDE)THEN
             CALL TEXP(X3,Y3,XE,YE)
             VE(1)=V3(2)+V3(3)-V3(1)
             VE(2)=V3(1)+V3(3)-V3(2)
             VE(3)=V3(2)+V3(1)-V3(3)
             CALL GMFCTR(VE,XE,YE,VMIN,VMAX,IVMIN,IVMAX)
           ENDIF
         ENDIF
      ENDDO
C DOKRESLENI IZOCAR
      DO IE=1,NE
         MUEL=MUE(IE)
         NUE=IABS(MUEL)-MINT(IE)
         L0=LUE(IE)
         IF(NUE.GE.3.AND.MUEL.NE.-4)THEN
C ROZKLAD NA 1,2,4,6 TROJUHELNIKU DLE HODNOTY NUE
           CALL DECOMP(NUE,NTR,IQ)
           DO IT=1,NTR
C TROJUHELNIK IT 1,2,3
             INSIDE=.TRUE.
             DO I=1,3
                IQL=IQ(I,IT)
                IU=IABS(IUE(L0+IQL))
                X3(I)=X(IU)
                Y3(I)=Y(IU)
                IF(X3(I).LT.BXMI.OR.X3(I).GT.BXMA.OR.
     /             Y3(I).LT.BYMI.OR.Y3(I).GT.BYMA)INSIDE=.FALSE.
                V3(I)=VAL(IU)
             ENDDO
             IF(INSIDE)CALL GMFCTI(V3,X3,Y3,V,NC,ICOL)
           ENDDO
         ELSEIF(MUEL.EQ.-4)THEN
           INSIDE=.TRUE.
           DO I=1,4
             IU=IABS(IUE(L0+I))
             X3(I)=X(IU)
             Y3(I)=Y(IU)
             IF(X3(I).LT.BXMI.OR.X3(I).GT.BXMA.OR.
     /          Y3(I).LT.BYMI.OR.Y3(I).GT.BYMA)INSIDE=.FALSE.
             V3(I)=VAL(IU)
           ENDDO
           IF(INSIDE)THEN
             CALL TEXP(X3,Y3,XE,YE)
             VE(1)=V3(2)+V3(3)-V3(1)
             VE(2)=V3(1)+V3(3)-V3(2)
             VE(3)=V3(2)+V3(1)-V3(3)
             CALL GMFCTI(VE,XE,YE,V,NC,ICOL)
           ENDIF
         ENDIF
      ENDDO
C SET CHART
      B2=B2MI
      D1TINY=D1/20.
      D2TINY=D2/20.
C CHART
      B1L=B1MA
      B1R=FXMA
      B1LT=B1L+(B1R-B1L)*.1
      B2L=FYMI
      B2R=FYMA
      D2=(B2MA-B2MI)/NC
      D2S=D2*.5
      B1S=(B1L+B1R)*.5
      B2=B2MI
      X3(1)=B1R
      X3(2)=B1R
      X3(3)=B1S
      DOJ=1,NC
         CALL GMFREC(B1L,B1R,B2,B2+D2,ICOL)
C VALUES
         ICTEXT=ICOL
         VC=V(J)
         Y3(1)=B2
         Y3(2)=B2+D2
         Y3(3)=B2+D2/2
         V3(1)=VC
         V3(2)=VC
         V3(3)=VC
         CALL GMFCTR(V3,X3,Y3,VMIN,VMAX,IVMIN,IVMAX)
         WRITE(LAB,50)VC
50       FORMAT(E12.5)
         CALL GMFTEXT(B1LT,B2+D2,ICTEXT,8,LAB(1:8))
         IF(D2.GE.WYT)CALL GMFTEXT(B1LT,B2+D2S,ICTEXT,4,LAB(9:12))
         B2=B2+D2
      ENDDO
      IF(NLAB.GT.0)THEN
         DYF=(FYMA-FYMI)/11
         DTI=DYF/5
         TOP=FYMA-DTI
         BOT=TOP-DYF
         CALL GMFREC(B1MI,B1MA,BOT,TOP,1)
         CALL GMFILL(B1MI+D1,TOP-DTI,14,1)
         CALL GMFILL(B1MI+D1,BOT+DTI,14,1)
         CALL GMFREC(B1MI,B1MA,BOT,TOP,ICOL)
         CALL GMFTEXT(B1MI,TOP,ICOL,NLAB,LABEL)
      ENDIF
9999  RETURN
 
      CONTAINS
 
      SUBROUTINE DECOMP(NUE,NTR,IQ)
      DIMENSION IQ(3,6)
      SELECT CASE(NUE)
      CASE(3)
        NTR=1
        IQ(1,1)=1
        IQ(2,1)=2
        IQ(3,1)=3
      CASE(4)
        NTR=2
        IQ(1,1)=1
        IQ(2,1)=2
        IQ(3,1)=3
        IQ(1,2)=1
        IQ(2,2)=3
        IQ(3,2)=4
      CASE(6)
        NTR=4
        IQ(1,1)=1
        IQ(2,1)=4
        IQ(3,1)=6
        IQ(1,2)=4
        IQ(2,2)=2
        IQ(3,2)=5
        IQ(1,3)=5
        IQ(2,3)=3
        IQ(3,3)=6
        IQ(1,4)=5
        IQ(2,4)=6
        IQ(3,4)=4
      CASE(8)
        NTR=6
        IQ(1,1)=1
        IQ(2,1)=5
        IQ(3,1)=8
        IQ(1,2)=5
        IQ(2,2)=2
        IQ(3,2)=6
        IQ(1,3)=6
        IQ(2,3)=3
        IQ(3,3)=7
        IQ(1,4)=7
        IQ(2,4)=4
        IQ(3,4)=8
        IQ(1,5)=8
        IQ(2,5)=5
        IQ(3,5)=7
        IQ(1,6)=7
        IQ(2,6)=5
        IQ(3,6)=6
      END SELECT
      END SUBROUTINE DECOMP
      END
