      SUBROUTINE GMFECTS(IND,LABEL,NLAB,X,Y,VAL,IUE,LUE,MUE,NE,
     /  B1MI,B1MA,B2MI,B2MA,V,IVC,NC,ICOL)
C
C CONTOURS ON MESH OF ELEMENTS (TRIANGLES OR QUADRILATERALS).
C Vykreslovani DOF.
C Rozklad ctyruhelniku na trojuhelniky a
C linearni interpolace (a+bx+cy). NESPOJITE spektrum barev.
C Barvou ICOL kresli i cary - vrstevnice. Vyuzivaji se procedury
C pro vykreslovani vrstevnic v trojuhelnicich.
C
C IND      - INDEX OKNA, LABEL (TEXT NLAB ZNAKU)
C X(*),Y(*)- SOURADNICE UZLU
C VAL(*)   - FUNKCNI HODNOTY V UZLECH
C IUE(*)   - VEKTOR KONEKTIVITY (INDEXY UZLU ELEMENTU 1...NE)
C LUE(NE+1)- INDEX I-TEHO UZLU ELEMENTU IE JE LUE(IE)+I
C MUE(*)   - IABS(MUE)=POCET UZLU ELEMENTU. MUE<0 POSLEDNI UZEL NEKRESLIT.
C B1MI,... - OBDELNIK (X,Y), OHRANICENY BARVOU ICOL
C V(NC)    - HODNOTY ISOCAR
C IVC(NC)  - BARVY IZOCAR A VYPLNOVYCH PROUZKU
C NC       - POCET ISOCAR
C ICOL     - BARVA VRSTEVNIC A RAMECKU
C
      INCLUDE 'GMF$'
      DIMENSION X(*),Y(*),VAL(*),IUE(*),LUE(*),MUE(*),V(*),IVC(*),
     /          X3(3),Y3(3),V3(3),IQ(3,6)
      CHARACTER *12 LAB, LABEL*(*)
      IF(NE.LT.1) GOTO9999
      CALL GMFAXE(IND,7,15)
      CALL GMFREC(B1MI,B1MA,B2MI,B2MA,ICOL)
      D2=(B2MA-B2MI)/20.
      D1=(B1MA-B1MI)/20.
      DO IE=1,NE
         NUE=IABS(MUE(IE))
C MUE<0 - POSLEDNI UZEL JE V TEZISTI ELEMENTU - NEKRESLIT
         IF(MUE(IE).LT.0)NUE=NUE-1
         L0=LUE(IE)
C ROZKLAD NA 1,2,4,6 TROJUHELNIKU DLE HODNOTY NUE
         CALL DECOMP(NUE,NTR,IQ)
         DO IT=1,NTR
C TROJUHELNIK IT 1,2,3
           DO I=1,3
              IQL=IQ(I,IT)
              IU=IABS(IUE(L0+IQL))
              X3(I)=X(IU)
              Y3(I)=Y(IU)
              V3(I)=VAL(IU)
           ENDDO
           CALL GMFCTS(V3,X3,Y3,V,IVC,NC,ICOL)
         ENDDO
      ENDDO
C SET CHART
      B2=B2MI
      D1TINY=D1/20.
      D2TINY=D2/20.
C CHART
      B1L=B1MA
      B1R=FXMA
      B1LT=B1L+(B1R-B1L)*.1
      B2L=FYMI
      B2R=FYMA
      D2=(B2MA-B2MI)/NC
      D2S=D2*.5
      B1S=(B1L+B1R)*.5
      B2=B2MI
      X3(1)=B1R
      X3(2)=B1R
      X3(3)=B1S
      DO J=1,NC
         CALL GMFREC(B1L,B1R,B2,B2+D2,ICOL)
C VALUES
         ICTEXT=ICOL
         Y3(1)=B2
         Y3(2)=B2+D2
         Y3(3)=B2+D2/2
         CALL GMFPLC(3,X3,Y3,ICOL)
         CALL GMFILL((B1R+B1S)/2.,Y3(3),IVC(J),ICOL)
         WRITE(LAB,50)V(J)
50       FORMAT(E12.5)
         CALL GMFTEXT(B1LT,B2+D2,ICTEXT,6,LAB(1:6))
         IF(D2.GE.WYT)CALL GMFTEXT(B1LT,B2+D2S,ICTEXT,4,LAB(9:12))
         B2=B2+D2
      ENDDO
      IF(NLAB.GT.0)THEN
         DYF=(FYMA-FYMI)/11
         DTI=DYF/5
         TOP=FYMA-DTI
         BOT=TOP-DYF
         CALL GMFREC(B1MI,B1MA,BOT,TOP,ICOL)
         CALL GMFILL(B1MI+D1,TOP-DTI,14,ICOL)
         CALL GMFILL(B1MI+D1,BOT+DTI,14,ICOL)
         CALL GMFTEXT(B1MI,TOP,ICOL,NLAB,LABEL)
      ENDIF
9999  RETURN
 
      CONTAINS
 
      SUBROUTINE DECOMP(NUE,NTR,IQ)
      DIMENSION IQ(3,6)
      SELECT CASE(NUE)
      CASE(3)
        NTR=1
        IQ(1,1)=1
        IQ(2,1)=2
        IQ(3,1)=3
      CASE(4)
        NTR=2
        IQ(1,1)=1
        IQ(2,1)=2
        IQ(3,1)=3
        IQ(1,2)=1
        IQ(2,2)=3
        IQ(3,2)=4
      CASE(6)
        NTR=4
        IQ(1,1)=1
        IQ(2,1)=4
        IQ(3,1)=6
        IQ(1,2)=4
        IQ(2,2)=2
        IQ(3,2)=5
        IQ(1,3)=5
        IQ(2,3)=3
        IQ(3,3)=6
        IQ(1,4)=5
        IQ(2,4)=6
        IQ(3,4)=4
      CASE(8)
        NTR=6
        IQ(1,1)=1
        IQ(2,1)=5
        IQ(3,1)=8
        IQ(1,2)=5
        IQ(2,2)=2
        IQ(3,2)=6
        IQ(1,3)=6
        IQ(2,3)=3
        IQ(3,3)=7
        IQ(1,4)=7
        IQ(2,4)=4
        IQ(3,4)=8
        IQ(1,5)=8
        IQ(2,5)=5
        IQ(3,5)=7
        IQ(1,6)=7
        IQ(2,6)=5
        IQ(3,6)=6
      END SELECT
      END SUBROUTINE DECOMP
      END
 
