      SUBROUTINE GMFPLF(N,X,Y,ICOL,IFIL)
C
C FILL CURVE (N, X(N),Y(N), ICOL) BY COLOUR IFIL
C CUBIC SPLINES - STRAIGHT LINE CLOSE THE CURVE
C
      PARAMETER (NMAX=100,ND=9)
      DIMENSION X(1),Y(1),XG(ND),YG(ND),
     / A(NMAX),B(NMAX),C(NMAX),BX(NMAX),BY(NMAX),DX(NMAX),DY(NMAX)
      IF(N.GT.NMAX)RETURN
      DO I=2,N
        A(I)=1.
        B(I)=4.
        C(I)=1.
        BX(I)=3*(X(I+1)-X(I-1))
        BY(I)=3*(Y(I+1)-Y(I-1))
      ENDDO
      A(1)=0
      B(1)=1
      C(1)=0
C      BX(1)=X(2)-X(1)
C      BY(1)=Y(2)-Y(1)
      BX(1)=0
      BY(1)=0
      A(N)=0
      B(N)=1
      C(N)=0
C      BX(N)=X(N)-X(N-1)
C      BY(N)=Y(N)-Y(N-1)
      BX(N)=0
      BY(N)=0
      CALL TRIDAG(A,B,C,BX,DX,N)
      CALL TRIDAG(A,B,C,BY,DY,N)
C CALCULATION OF CUBIC SPLINES
      DT=1./(ND-1)
      XMEAN=X(N)
      YMEAN=Y(N)
      DO I=1,N-1
         XMEAN=XMEAN+X(I)
         YMEAN=YMEAN+Y(I)
C
C INTERVAL I,I+1 - BI-1,BI,BI+1,BI+2
C
         DO J=1,ND
           T=(J-1)*DT
           IF(J.EQ.ND)THEN
              XG(J)=X(I+1)
              YG(J)=Y(I+1)
           ELSEIF(J.EQ.1)THEN
              XG(J)=X(I)
              YG(J)=Y(I)
           ELSE
              XG(J)=X(I)+DX(I)*T+
     /               (3*(X(I+1)-X(I))-2*DX(I)-DX(I+1))*T**2+
     /               (2*(X(I)-X(I+1))+DX(I)+DX(I+1))*T**3
              YG(J)=Y(I)+DY(I)*T+
     /               (3*(Y(I+1)-Y(I))-2*DY(I)-DY(I+1))*T**2+
     /               (2*(Y(I)-Y(I+1))+DY(I)+DY(I+1))*T**3
           ENDIF
         ENDDO
         CALL GMFPL(ND,XG,YG,ICOL)
      ENDDO
      XG(1)=X(1)
      XG(2)=X(N)
      YG(1)=Y(1)
      YG(2)=Y(N)
      CALL GMFPL(2,XG,YG,ICOL)
      CALL GMFILL(XMEAN/N,YMEAN/N,IFIL,ICOL)
      END
 
