      SUBROUTINE PTCR2(X1,Y1,Z1,N1,X2,Y2,Z2,N2,
     /                 NEW,PX1,PY1,PZ1,PX2,PY2,PZ2,TOL)
C
C Pruseciky krivek 1 a 2 (definovanych N1 a N2 body /bud 2 nebo 3/)
C Vystupni parametry NEW - pocet pruseciku (0,1,2) PX1,... souradnice
C TOL - pripustna tolerance rozdilu souradnice Z
C    
      DIMENSION X1(3),Y1(3),Z1(3),X2(3),Y2(3),Z2(3)
      AX1=X1(1)
      AY1=Y1(1)
      AZ1=Z1(1)
      IF(N1.EQ.2)THEN
        BX1=X1(2)-X1(1)
        BY1=Y1(2)-Y1(1)
        BZ1=Z1(2)-Z1(1)
        CX1=0
        CY1=0
        CZ1=0
      ELSEIF(N1.EQ.3)THEN
        BX1=-3*X1(1)-X1(2)+4*X1(3)
        BY1=-3*Y1(1)-Y1(2)+4*Y1(3)
        BZ1=-3*Z1(1)-Z1(2)+4*Z1(3)
        CX1=2*X1(2)-4*X1(3)+2*X1(1)
        CY1=2*Y1(2)-4*Y1(3)+2*Y1(1)
        CZ1=2*Z1(2)-4*Z1(3)+2*Z1(1)
      ENDIF
      AX2=X2(1)
      AY2=Y2(1)
      AZ2=Z2(1)
      IF(N2.EQ.2)THEN
        BX2=X2(2)-X2(1)
        BY2=Y2(2)-Y2(1)
        BZ2=Z2(2)-Z2(1)
        CX2=0
        CY2=0
        CZ2=0
      ELSEIF(N2.EQ.3)THEN
        BX2=-3*X2(1)-X2(2)+4*X2(3)
        BY2=-3*Y2(1)-Y2(2)+4*Y2(3)
        BZ2=-3*Z2(1)-Z2(2)+4*Z2(3)
        CX2=2*X2(2)-4*X2(3)+2*X2(1)
        CY2=2*Y2(2)-4*Y2(3)+2*Y2(1)
        CZ2=2*Z2(2)-4*Z2(3)+2*Z2(1)
      ENDIF
C Rozdeleni krivek 1 a 2 na NSEG segmentu
      NEW=0
      NSEG=40
      DT=1./NSEG
      DO I1=1,NSEG
       T1=DT*(I1-1)
       T2=DT*I1
       X11=AX1+BX1*T1+CX1*T1**2
       X12=AX1+BX1*T2+CX1*T2**2
       Y11=AY1+BY1*T1+CY1*T1**2
       Y12=AY1+BY1*T2+CY1*T2**2
       Z11=AZ1+BZ1*T1+CZ1*T1**2
       Z12=AZ1+BZ1*T2+CZ1*T2**2
       AAX1=X11
       BBX1=X12-X11
       AAY1=Y11
       BBY1=Y12-Y11
       AAZ1=Z11
       BBZ1=Z12-Z11
       DO I2=1,NSEG
         T1=DT*(I2-1)
         T2=DT*I2
         X21=AX2+BX2*T1+CX2*T1**2
         X22=AX2+BX2*T2+CX2*T2**2
         Y21=AY2+BY2*T1+CY2*T1**2
         Y22=AY2+BY2*T2+CY2*T2**2
         Z21=AZ2+BZ2*T1+CZ2*T1**2
         Z22=AZ2+BZ2*T2+CZ2*T2**2
         AAX2=X21
         BBX2=X22-X21
         AAY2=Y21
         BBY2=Y22-Y21
         AAZ2=Z21
         BBZ2=Z22-Z21
C Prusecik
         DET=-BBX1*BBY2+BBY1*BBX2
         IF(DET.NE.0.)THEN
            T1=((AAY2-AAY1)*BBX2-(AAX2-AAX1)*BBY2)/DET
            T2=((AAY2-AAY1)*BBX1-(AAX2-AAX1)*BBY1)/DET
            IF(T1.GE.0..AND.T1.LE.1..AND.T2.GE.0..AND.T2.LE.1.)THEN
C PRUSECIK EXISTUJE
               IF(NEW.EQ.0)THEN
C souradnice pruseciku odvozena z rovnice krivky 1
                 PX1=AAX1+BBX1*T1
                 PY1=AAY1+BBY1*T1
                 PZ1=AAZ1+BBZ1*T1
C souradnice pruseciku odvozena z rovnice krivky 2
                 PZ=AAZ2+BBZ2*T2
                 IF(ABS(PZ-PZ1).LE.TOL)NEW=1
               ELSEIF(NEW.EQ.1)THEN
                 PX2=AAX1+BBX1*T1
                 PY2=AAY1+BBY1*T1
                 PZ2=AAZ1+BBZ1*T1
                 PZ=AAZ2+BBZ2*T2
                 IF(ABS(PZ-PZ2).LE.TOL)NEW=2
               ENDIF
            ENDIF
         ENDIF
       ENDDO
      ENDDO
      END

