      SUBROUTINE PTCTIN(X,Y,XPT,YPT,NPT,IPCR,NPCR,NCR,
     /                  ICRCT,NCRCT,NCT,IN)
C
C Zjisteni, zda bod X,Y lezi uvnitr oblasti, vymezene obrysy CT (contours),
C ktere jsou definovany jako seznam krivek CR a ty jsou zase urceny 2 nebo 3
C body PT. Algoritmus pocita pocet pruseciku s vertikalami.
C
C Vstupni parametry:
C X,Y          souradnice bodu
C XPT(),YPT()  souradnice bodu definujicich krivky
C NPT          pocet bodu
C IPCR(3,ic)   kazdy sloupec definuje jednu krivku 2 nebo 3 body
C NPCR(ic)     pocet bodu definujicich krivku
C NCR          pocet krivek
C ICRCT(50,ic) kazdy sloupec definuje jeden obrys (1.vnejsi, dalsi vnitrni)
C NCRCT(ic)    pocet krivek definujicich obrys
C NCT          pocet obrysu
C
C Vystupni parametr
C IN =0  vnejsi bod
C IN =1  vnitrni bod
C IN=-1  bod obrysu
C
      DIMENSION XPT(*),YPT(*),IPCR(3,*),NPCR(*),ICRCT(50,*),NCRCT(*)
C YV-SOURADNICE PRUSECIKU
      DIMENSION XX(3),YY(3),TT(2),YV(20)
	REAL*8 A,B,DET,S
	LOGICAL NEW
      NPOS=0
      NNEG=0
	NPRUS=0
      DO ICT=1,NCT
        DO IC=1,NCRCT(ICT)
          ICR=ICRCT(IC,ICT)
          IF(ICR.GT.0.AND.ICR.LE.NCR)THEN
C
C Hledame pruseciky krivky ICR s vertikalou X=const
C
            NP=NPCR(ICR)
            DO I=1,NP
              IP=IPCR(I,ICR)
              IF(IP.GT.0.AND.IP.LE.NPT)THEN
                XX(I)=XPT(IP)
                YY(I)=YPT(IP)
              ENDIF
            ENDDO
            SELECT CASE(NP)
            CASE(2)
C
C Prusecik s useckou
C
               IF(XX(1).NE.XX(2))THEN
                 T=(X-XX(1))/(XX(2)-XX(1))
                 IF(T.GE.0..AND.T.LE.1.)THEN
                   YP=YY(1)+(YY(2)-YY(1))*T
	             IF(ABS(YP-Y).LT.1E-10)THEN
	               IN=-1
	               RETURN
                   ELSE
	               NPRUS=NPRUS+1
	               YV(NPRUS)=YP-Y
                   ENDIF
                 ENDIF
	         ELSE
	           IF(ABS(X-XX(1)).LT.1E-10)THEN
	             IF(Y.GE.AMIN1(YY(1),YY(2)).AND.
     /                Y.LE.AMAX1(YY(1),YY(2)))THEN
	                IN=-1
	                RETURN
	             ENDIF
	           ENDIF
               ENDIF
            CASE(3)
C
C prusecik s parabolou
C
               IF(XX(1).NE.XX(2).OR.XX(1).NE.XX(3))THEN
                 A=(XX(2)-XX(1))/2.
                 B=(XX(1)+XX(2))/2.-XX(3)
                 DET=A**2-4*B*(XX(3)-X)
                 IF(DET.GE.0.D0)THEN
                   S=DSQRT(DET)
                   IF(B.NE.0.D0)THEN
                     TT(1)=(-A+S)/(2*B)
                     TT(2)=(-A-S)/(2*B)
                   ELSEIF(A.NE.0.D0)THEN
                     TT(1)=(X-XX(3))/A
                     TT(2)=100
                   ENDIF
                   DO I=1,2
                     IF(ABS(TT(I)).LE.1.)THEN
                       YP=YY(3)+(YY(2)-YY(1))/2.*TT(I)+
     /                    ((YY(1)+YY(2))/2.-YY(3))*TT(I)**2
	                 IF(ABS(YP-Y).LE.1E-10)THEN
	                   IN=-1
	                   RETURN
                       ELSE
                         NPRUS=NPRUS+1
	                   YV(NPRUS)=YP-Y
                       ENDIF
                     ENDIF
                   ENDDO
                 ENDIF
               ELSE
C Vertikala
	           IF(ABS(X-XX(1)).LT.1E-10)THEN
	             IF(Y.GE.AMIN1(YY(1),YY(2)).AND.
     /                Y.LE.AMAX1(YY(1),YY(2)))THEN
	                IN=-1
	                RETURN
	             ENDIF
	           ENDIF
               ENDIF
             END SELECT
          ENDIF
        ENDDO
      ENDDO
C
C NPOS,NNEG jsou pocty ruznych pruseciku
C
      DO I=1,NPRUS
	  YI=YV(I)
	  NEW=.TRUE.
	  DO J=1,I-1
	     IF(YI.EQ.YV(J))THEN
		    NEW=.FALSE. 
	        EXIT
           ENDIF
	  ENDDO
	  IF(NEW)THEN
	     IF(YI.GT.0.)THEN
	        NPOS=NPOS+1
           ELSE
	        NNEG=NNEG+1
	     ENDIF
	  ENDIF
	ENDDO
C
      IN=0
      IF(NPOS.GT.0.AND.MOD(NPOS,2).EQ.1)THEN
C Lichy pocet pozitivnich pruseciku
        IF(NNEG.GT.0.AND.MOD(NNEG,2).EQ.1)THEN
           IN=1
        ELSE
C lichy pocet pozitivnich a sudy pocet zapornych pruseciku - divna situace (tecna k obrysu)
           IN=-2
        ENDIF
      ENDIF
      END
