	SUBROUTINE PTCTXY(XA,YA,XB,YB,XPT,YPT,NPT,IPCR,NPCR,NCR,
     /                  ICRCT,NCRCT,NCT,TAB,NTAB)
C
C Hledani pruseciku obrysu CT s useckou A-B. 
C
C Vstupni parametry:
C XA,YA,XB,YB            souradnice usecky
C XPT(),YPT()  souradnice bodu definujicich krivky
C NPT          pocet bodu
C IPCR(3,ic)   kazdy sloupec definuje jednu krivku 2 nebo 3 body
C NPCR(ic)     pocet bodu definujicich krivku
C NCR          pocet krivek
C ICRCT(20,ic) kazdy sloupec definuje jeden obrys (1.vnejsi, dalsi vnitrni)
C NCRCT(ic)    pocet krivek definujicich obrys
C NCT          pocet obrysu
C
C Vystupni parametr
C TAB(ntab)       souradnice vypoctenych pruseciku (T 0-1)
C NTAB            pocet pruseciku
C
      DIMENSION XPT(*),YPT(*),IPCR(3,*),NPCR(*),ICRCT(50,*),NCRCT(*)
      DIMENSION TAB(*),XX(3),YY(3),TT(2)
C Parametricka rovnice usecky AB  
C  xl=Axl+Bxl*tl     Axl=XA  Bxl=XB-XA
C  yl=Ayl+Byl*tl     Ayl=YA  Byl=YB-YA
      BXL=XB-XA
      BYL=YB-YA
      AXL=XA
      AYL=YA
      NTAB=0
      DO ICT=1,NCT
        DO IC=1,NCRCT(ICT)
          ICR=ICRCT(IC,ICT)
          IF(ICR.GT.0.AND.ICR.LE.NCR)THEN
            NP=NPCR(ICR)
            DO I=1,NP
              IP=IPCR(I,ICR)
              IF(IP.GT.0.AND.IP.LE.NPT)THEN
                XX(I)=XPT(IP)
                YY(I)=YPT(IP)
              ENDIF
            ENDDO
            SELECT CASE(NP)
            CASE(2)
C Prusecik s useckou
C  x=Ax+Bx*t     Ax=X1  Bx=X2-X1
C  y=Ay+By*t     Ay=Y1  By=Y2-Y1
               AX=XX(1)
               AY=YY(1)
               BX=XX(2)-XX(1)
               BY=YY(2)-YY(1)
               D=BXL*BY-BYL*BX
               IF(D.NE.0.)THEN
                 T=((AYL-AY)*BX-(AXL-AX)*BY)/D
	           TG=(-(AXL-AX)*BYL+(AYL-AY)*BXL)/D
                 IF(T.GE.0..AND.T.LE.1..AND.TG.GE.0..AND.TG.LE.1.)THEN
                   NTAB=NTAB+1
                   TAB(NTAB)=T
                 ENDIF
               ENDIF
            CASE(3)
C prusecik s parabolou
C  x=Ax+Bx*t+Cx*t^2     Ax=X1  Bx=4*X3-3*X1-X2  Cx=2*(X1+X2-2*X3)
C  y=Ay+By*t+Cy*t^2     Ay=Y1  By=4*Y3-3*Y1-Y2  Cy=2*(Y1+Y2-2*Y3)
               AX=XX(1)
	         BX=4*XX(3)-3*XX(1)-XX(2)
	         CX=2.*(XX(1)+XX(2)-2*XX(3))
	         AY=YY(1)
	         BY=4*YY(3)-3*YY(1)-YY(2)
	         CY=2.*(YY(1)+YY(2)-2*YY(3))
	         ALFA=CX*BYL-CY*BXL
	         BETA=BX*BYL-BY*BXL
               GAMA=(AX-AXL)*BYL-(AY-AYL)*BXL
               DET=BETA**2-4*ALFA*GAMA
               IF(DET.GT.0.)THEN
                  S=SQRT(DET)
	            TT=100
                  IF(ALFA.NE.0.)THEN
                   TT(1)=(-BETA+S)/(2*ALFA)
                   TT(2)=(-BETA-S)/(2*ALFA)
                 ELSEIF(BETA.NE.0.)THEN
                   TT(1)=-GAMA/BETA
                 ENDIF
                 DO I=1,2
	             T=TT(I)
                   IF(T.LE.1..AND.T.GE.0.)THEN
	                IF(BXL.NE.0.)THEN
	                   TL=(AX+BX*T+CX*T**2-AXL)/BXL
	                ELSEIF(BYL.NE.0.)THEN
	                   TL=(AY+BY*T+CY*T**2-AYL)/BYL
	                ENDIF
	                IF(TL.GE.0.AND.TL.LE.1.)THEN
	                   NTAB=NTAB+1
                         TAB(NTAB)=TL
                      ENDIF	
                   ENDIF
                 ENDDO
               ENDIF
             END SELECT
          ENDIF
        ENDDO
      ENDDO
      END
