      FUNCTION TFUS(INDX,P,M)
C
C Implicitni uzivatelske funkce pro interpret TINE (Small)
C
C INDX - index funkce (1,2,...)
C    1 - min(p1,p2,...,pm)
C    2 - max(p1,p2,...,pm)
C    3 - atn(p)
C    4 - erf(p)
C    5 - Legendreuv polynom P(n,x)
C    6 - Laguerruv polynom  L(n,x)
C    7 - Cebysevuv polynom  T(n,x)
C    8 - RND(0)   generator nahodnych cisel v intervalu (0,1)
C
C P(M) - vektor argumentu
C
C Fortran PowerStation 16-Jul-02
C
      COMMON /SCOM/IS(50)
      DIMENSION P(*),RS(35)
      EQUIVALENCE (IS,RS)
      GOTO (10,20,30,40,50,50,50,120),INDX
10    X=1E32
      DO 11 I=1,M
11    X=AMIN1(X,P(I))
      TFUS=X
      RETURN
20    X=-1E32
      DO 21 I=1,M
21    X=AMAX1(X,P(I))
      TFUS=X
      RETURN
30    TFUS=ATAN(P(1))
      RETURN
40    Z=ABS(P(1))
      T=1./(1.+.5*Z)
      ERFC=T*EXP(-Z*Z-1.26551223+T*(1.00002368+T*(.37409196+
     /     T*(.09678418+T*(-.18628806+T*(.27886807+T*(-1.13520398+
     /     T*(1.48851587+T*(-.82215223+T*.17087277)))))))))
      IF(P(1).LT.0.) ERFC=2.-ERFC
      TFUS=1.-ERFC
      RETURN
50    N=IFIX(P(1)+.5)
      X=P(2)
      T0=1.
      IF(INDX.EQ.6) THEN
         T1=1.-X
      ELSE
         T1=X
      ENDIF
      IF(N.LE.0) THEN
         TFUS=T0
      ELSEIF(N.EQ.1)THEN
         TFUS=T1
      ELSE
         DO 1 I=2,N
         IF(INDX.EQ.6) THEN
           T2=2.*T1-T0-((1.+X)*T1-T0)/I
         ELSEIF(INDX.EQ.5) THEN
           T2=2.*X*T1-T0-(X*T1-T0)/I
         ELSE
           T2=2*X*T1-T0
         ENDIF
         T0=T1
1        T1=T2
         TFUS=T2
      ENDIF
      RETURN
120   IF(P(1).GT.1.)then
          RS(35)=P(1)
          CALL SEED(RS(35))
      ENDIF
      CALL RANDOM(TFUS)
      RETURN
      END
