      SUBROUTINE TINQ(IRPN,LAST,IVAL,TFU,RESULT,IUNIT)
C
C  Rozsireni interpretu TINP umoznujici zpracovavat kod IRPN obsahujici
C  posloupnost prikazu (for i=e1,e2, disp i).
C
C  IRPN(LAST) - interpretovany kod
C       100 len  prirazovaci prikaz nebo vyraz
C       107  adr  vyhodnoceni podminky a skok na adresu
C       108  adr  nepodmineny skok
C       109  DON on
C       110  DOF off
C       111  string zobraz hodnotu vyrazu v zasobniku
C       112  iloc ityp     vlozeni RES do promenne i (realna nebo integer)
C       113  vlozeni RES   do pomocneho zasobniku LIFO (inkrementace zasobniku)
C       114  iloc ityp     inkrementace promenne i (=i+1)
C       115  iloc ityp     dekrementace promenne i (=i-1)
C       116  iloc ityp adr porovnani i>zasobnik a skok na adresu
C       117  dekrementace zasobniku hornich mezi
C       118  RUN PROGRAM
C Adresou je minen index vektoru IRPN.
C
C  IVAL()  vektor promennych a konstant
C  TFU    uzivatelske rozsireni funkci (FUNCTION TFU(INDEX,PAR,NPAR) )
C  RES    vysledna hodnota (posledniho zpracovavaneho prikazu)
C         Jinak jsou ovsem vysledkem interpretace zpravidla prvky vektoru
C         promennych IVAL.
C  IUNIT  cislo zarizeni pro WRITE(iunit,...). Pokud je IUNIT<=0, pouzije se *
C
C  Verze: 2002 PF
C
C$IF DEFINED (compaq)
      USE DFLIB
C$ELSE
C      USE MSFLIB
C$ENDIF
      PARAMETER (ISTMAX=20)
      COMMON /SCOM/IER,IDUMMY(49)
      INTEGER IVAL(*),IFILE(3)
      INTEGER*2 IRESUL
      DIMENSION IRPN(*),STC(ISTMAX)
      CHARACTER*4 CAUX
      CHARACTER*8 DAUX
      CHARACTER*12 FILE
      EQUIVALENCE (RAUX,CAUX,IAUX),(RES,IRES),(FILE,IFILE)
      LOGICAL DISP
      EXTERNAL TFU
      DISP=.FALSE.
      IST=0
C
C IPT - pointer do IRPN
C
      IPT=1
1     IF(IPT.GT.LAST) THEN
         RESULT=RES
         RETURN
      ENDIF
      ICD=IRPN(IPT)
      SELECT CASE (ICD)
C ---------------------------------------------
      CASE(100)
         LEN=IRPN(IPT+1)
         CALL TINE(IRPN(IPT+2),LEN,IVAL,TFU,RES)
         IF(IER.NE.0) RETURN
         IF(DISP)THEN
            IF(IUNIT.GT.0)THEN
               WRITE(IUNIT,500)IPT,RES
            ELSE
               WRITE(*,500)IPT,RES
            ENDIF
500         FORMAT(' Index RPN:',i4,' Result:',e12.4)
         ENDIF
         IPT=IPT+LEN+2
      CASE(107)
         IF(RES.GT.0.1)THEN
            IPT=IPT+2
         ELSE
            IPT=IRPN(IPT+1)
         ENDIF
      CASE(108)
         IPT=IRPN(IPT+1)
      CASE(109)
         DISP=.TRUE.
         IPT=IPT+1
      CASE(110)
         DISP=.FALSE.
         IPT=IPT+1
      CASE(111)
C DISP i - nazev promenne je ve dvou slovech (8 bytu)
         IAUX=IRPN(IPT+1)
         DAUX(1:4)=CAUX
         IAUX=IRPN(IPT+2)
         DAUX(5:8)=CAUX
         IPT=IPT+3
         IB=INDEX(DAUX,']')
         IF(IB.GT.0)DAUX(IB:IB)=' '
         KRES=NINT(RES)
         IF(RES.EQ.FLOAT(KRES))THEN
C Integer            
           IF(IABS(KRES).LE.999)THEN
            IF(IUNIT.GT.0)THEN
               WRITE(IUNIT,501)TRIM(DAUX),KRES
            ELSE
               WRITE(*,501)TRIM(DAUX),KRES
            ENDIF
501         FORMAT(1X,A,' =',I4)
           ELSE
            IF(IUNIT.GT.0)THEN
               WRITE(IUNIT,503)TRIM(DAUX),KRES
            ELSE
               WRITE(*,503)TRIM(DAUX),KRES
            ENDIF
503         FORMAT(1X,A,' =',I8)
           ENDIF
         ELSE
C Real
           IF(ABS(RES).LE.9999..AND.ABS(RES).GT.0.01)THEN
            IF(IUNIT.GT.0)THEN
               WRITE(IUNIT,502)TRIM(DAUX),RES
            ELSE
               WRITE(*,502)TRIM(DAUX),RES
            ENDIF
502         FORMAT(1X,A,' =',F12.6)
           ELSE
            IF(IUNIT.GT.0)THEN
               WRITE(IUNIT,504)TRIM(DAUX),RES
            ELSE
               WRITE(*,504)TRIM(DAUX),RES
            ENDIF
504         FORMAT(1X,A,' =',E11.4)
           ENDIF
         ENDIF
      CASE(112)
         INDX=IRPN(IPT+1)
         ITYP=IRPN(IPT+2)
         IF(ITYP.EQ.1)THEN
            IVAL(INDX)=IRES
         ELSE
            IVAL(INDX)=IFIX(RES)
         ENDIF
         IPT=IPT+3
      CASE(113)
         IF(IST.LT.ISTMAX)THEN
           IST=IST+1
           STC(IST)=RES
         ENDIF
         IPT=IPT+1
      CASE(114)
         INDX=IRPN(IPT+1)
         ITYP=IRPN(IPT+2)
         IF(ITYP.EQ.1)THEN
            IAUX=IVAL(INDX)
            RAUX=RAUX+1.
            IVAL(INDX)=IAUX
         ELSE
            IVAL(INDX)=IVAL(INDX)+1
         ENDIF
         IPT=IPT+3
      CASE(115)
         INDX=IRPN(IPT+1)
         ITYP=IRPN(IPT+2)
         IF(ITYP.EQ.1)THEN
            IAUX=IVAL(INDX)
            RAUX=RAUX-1.
            IVAL(INDX)=IAUX
         ELSE
            IVAL(INDX)=IVAL(INDX)-1
         ENDIF
         IPT=IPT+3
      CASE(116)
         INDX=IRPN(IPT+1)
         ITYP=IRPN(IPT+2)
         IF(ITYP.EQ.1)THEN
            IAUX=IVAL(INDX)
         ELSE
            RAUX=IVAL(INDX)
         ENDIF
         IF(RAUX.GT.STC(IST))THEN
             IPT=IRPN(IPT+3)
         ELSE
             IPT=IPT+4
         ENDIF
      CASE(117)
         IST=IST-1
         IPT=IPT+1
      CASE(118)
         DO II=1,3
            IFILE(II)=IRPN(IPT+II)
         ENDDO
         IRESUL=RUNQQ(FILE,'')
         IPT=IPT+4
      CASE DEFAULT
         RESULT=RES
         RETURN
      END SELECT
      GOTO 1
      END

