      SUBROUTINE TRANSE(ITX,ICTSGN,J,IDENT,IATTR,NOID,LENG,KFR,KMAX,
     / IMAX,ICON,IRPN,A,IA)
C
C ͻ
C   Preklad algebraickeho/logickeho vyrazu nebo prirazeni     
C ͼ
C
C ITX - vektor textu dlouhy ICT bytu
C ICTSGN - absolutni hodnota udava delku analyzovaneho textu
C       ICTSGN>0 analyza prirazovaciho prikazu (nebo vyrazu bez logickeho =)
C       ICTSGN<0 logicky vyraz s relacnimi a logickymi operatory
C J   - prvni znak vyrazu na pozici J+1 textu ITX
C IDENT         - seznam NOID-identifikatoru delky LENG
C IATTR(2,NOID) - matice atributu identifikatoru
C                 1.radek - index /pozice/ identifikatoru ve vektoru A
C                 2.radek - typ identifikatoru
C                           1-REAL,2-INTEGER,3-REAL vektor,4-INTEGER vektor
C                           5-uzivatelska funkce
C KFR - index pole A kam bude ukladana prvni nalezena konstanta
C KMAX- maximalni index pole A kam lze ukladat konstanty
C IMAX- maximalni delka vektoru RPN
C
C Vystupni parametry jsou:
C
C ICON- index posledni konstanty ve vektoru A
C IRPN- index posledniho prvku RPN ve vektoru IA
C A   - vektor promennych a konstant vyrazu (musi byt INTEGER i kdyz muze obsahovat i REAL)
C IA  - vektor kodu RPN
C
C
C Operatory:              Priority   Precedence(syntakt.chyby)
C  1   <=                     5          2
C  2   >=                     5          2
C  3   <> (nerovna se)        5          2
C  4   <                      5          2
C  5   >                      5          2
C  6   = (rovna se)           5          2
C  7   & (logicke AND)        4          2
C  8   | (logicke OR )        3          2
C  9   +                      6          2
C 10   -                      6          2
C 11   **                     9          2
C 12   /                      7          2
C 13   *                      7          2
C 14   := (prirazeni)         1          2
C 15   ,  (oddelovac)         2          2
C 16   )                      2          4
C 17   (                      2            1    implicitne
C 18   \                      8            1
C 19   SIN                   10            ....
C 20   COS                   10
C 21   EXP                  ....
C 22   SQR
C 23   LOG
C 24   LGT
C 25   ABS
C 26   1.uzivatelska funkce ...
C
C Kod RPN ma tento tvar:
C operand (konstanta nebo promenna)     -pozice   typ(1Real,2Int)   2 cisla
C vektor (analyzovany jako funkce)      -pozice   typ(3Real,4Int)   2 cisla
C uzivatelska funkce min(a,b,...)       26,27,..  npar              2 cisla
C operator <= , + ... (                 1,2,..25                    1 cislo
C
      LOGICAL ASGN
      INTEGER *2 NPAR,IPRI,IPRE,IPRE1,IPRE2,LIFO,IST,I,ITYP,LEVEL
      COMMON /SCOM/ICOM(50)
      EQUIVALENCE (ICOM(1),IER),(RR,IRR)
      CHARACTER *(*) ITX,IDENT
      CHARACTER *4 IOPER(25)
      CHARACTER *100 JOPER
      CHARACTER *1 KZ,KZAVL
      INTEGER A(*)
      DIMENSION IATTR(2,*),LIFO(20),
     /          IPRI(18),IPRE(16),NPAR(4),IA(*)
      EQUIVALENCE (IOPER,JOPER)
      DATA IOPER /4H<=  ,4H>=  ,4H<>  ,4H<   ,4H>   ,4H=   ,4H&   ,
     /            4H|   ,
     /            4H+   ,4H-   ,4H**  ,4H/   ,4H*   ,4H:=  ,4H,   ,
     /            4H)   ,4H(   ,4H\   ,4HSIN ,4HCOS ,4HEXP ,4HSQR ,
     /            4HLOG ,4HLGT ,4HABS /
      DATA IPRI,IPRE /6*5,4,3,6,6,9,7,7,1,2,2,2,8,
     /                15*2,4/
      ICT=IABS(ICTSGN)
      IF(ICTSGN.GT.0)THEN
        ASGN=.TRUE.
      ELSEIF(ICTSGN.LT.0)THEN
        ASGN=.FALSE.
      ELSE
        IFCHAR=0
        GOTO 1000
      ENDIF
C Pocatecni nastaveni
C NZAV - pocet nevyrizenych zavorek
C IPRE1 IPRE2 - precedence predchoziho a noveho terminalniho symbolu
C JTX1 - pozice korektne zpracovaneho znaku ITX, na zacatku J
C IST  - pointer zasobniku nevyrizenych OPERATORU na zacatku 0
C I    - index cyklu (slouzi jen jako pocitadlo - jinak nepouzit)
C     CALL SERR(0)
      IERR=0
      IER=0
      NZAV=0
      IPRE2=2
      LEVEL=0
      ICON =KFR-1
      IRPN =0
      IOP1 =0
      JTX1 =J
      IST  =0
      I    =1
 
      Lex: DO WHILE ((JTX1.GT.0.OR.I.EQ.1).AND.IERR.EQ.0)
 
C lexical analysis
C -----------------------------------------
C Pri zpracovani textu ITX se konstanty nebo jednoduche promenne vzdy hned
C ukladaji do RPN (vektor IA), zatimco operatory IOP1 bud do zasobniku
C LIFO nebo take primo do RPN; zalezi na priorite IOP1 a IOP2 (operator na
C vrchu zasobniku). Do zasobniku LIFO se uklada i leva zavorka; vyskyt
C operatoru carka znamena pokyn k vyprazdneni LIFO az k ulozene leve zavorce,
C a vyskyt prave zavorky totez, vcetne te leve zavorky. Operace se zasobnikem
C operatoru a jejich prenos do RPN zajistuji procedury POP a PUSH.
C
      IPRE1=IPRE2
C V pripade, ze je nalezeno rovnitko nebo := (IOP1=14), modifikujeme odkaz
C na promennou leve strany prirazovaciho prikazu
      IF (IOP1.EQ.14) THEN
C ERR=1000 -nevybalancovane zavorky
          IF(NZAV.NE.0) GOTO 1000
          IA(IRPN)=IA(IRPN)+4
          ASGN=.FALSE.
      ENDIF
      I=I+1
      CALL TAKCH$(ITX,ICT,JTX1,KZ,JTX2)
      IFCHAR=JTX1+1
      IF (JTX2.LE.0) EXIT Lex
C Hledani operatoru (s indexem IOP1) v seznamu IOPER
      CALL TSS(ITX,ICT,JTX1,JOPER,25,4,3,IOP1,JTX2)
      IF (JTX2.LE.0) THEN
C Pri neuspechu TSS zkousime hledani identifikatoru (s indexem
C INDI) v seznamu IDENT
         CALL TSI(ITX,ICT,JTX1,IDENT,NOID,LENG,LENG,INDI,JTX2)
         IF (JTX2.LE.0) THEN
C Lexikalni symbol nebyl ani operator ani identifikator, musi to byt
C konstanta, kterou precte OPERAND a ulozi ji do vektoru parametru i
C do vektoru RPN
            CALL OPERAND
            CYCLE Lex
         ENDIF
         ITYP=IATTR(2,INDI)
         LOCV=IATTR(1,INDI)
         IF (ITYP.LE.2) THEN
C Jednoducha promenna (1Real,2Integer) se uklada stejne jako konstanta
C do RPN.
            CALL OPERAND
            CYCLE Lex
         ENDIF
C Identifikator oznacuje vektor nebo funkci a zachazime s nim
C stejne jako s operatorem
         IOP1=INDI+25
      ENDIF
 
C V prohlizenem textu ITX je nalezen operator IOP1 (coz muze byt i vektor
C nebo funkce). Provedeni kontrol na zaklade precedence predchoziho lexikalniho
C symbolu IPRE1. IPRE2 je precedence soucasneho operatoru.
C
C leva zavorka \ a funkce  Precedence 1
C operatory + * ...        Precedence 2
C operand (konst,prom)     Precedence 3
C prava zavorka            Precedence 4
C
      IF (IOP1.EQ.6.AND.ASGN) IOP1=14
      IF (IOP1.EQ.18) EXIT Lex
C unarni minus ? minus ma iop=10, precedenci 2. IOP1=18 je \
      IF (IOP1.EQ.10.AND.IPRE1.LE.2) IOP1=18
C Pro operatory >18 musi nasledovat leva zavorka (IOPER(17))
      IF (IOP1.GE.19)THEN
         CALL TAKCH$(ITX,ICT,JTX2,KZAVL,JTX)
         IF (KZAVL.NE.'('.OR.JTX.LE.0) GOTO 1000
      ENDIF
      IPRE2=1
      IF (IOP1.LE.16) IPRE2=IPRE(IOP1)
C Testovani nepripustnych kombinaci ... IPRE1 IPRE2
C [operator,funkce,(]  .and.  [operator,)]
      IF (IPRE1.LE.2.AND.IPRE2.GE.2) GO TO 2000
C [operand,)] .and. [funkce,(]
      IF (IPRE1.GT.2.AND.IPRE2.LT.2) GO TO 3000
      JTX1=JTX2
 
      SELECT CASE (IOP1)
      CASE(15)
C Carka (vyprazdneni LIFO az k leve zavorce)
         DO WHILE(IST.GT.0.AND.IERR.EQ.0)
            IOP2=LIFO(IST)
            IF (IOP2.EQ.17) THEN
               IF(LEVEL.LE.0) GOTO 1000
               NPAR(LEVEL)=NPAR(LEVEL)-1
               CYCLE Lex
            ENDIF
C Operator IOP2 vytazen ze zasobniku LIFO a vlozen do RPN
            CALL POP
         END DO
 
      CASE(17)
C Leva zavorka (presun IOP1 do LIFO)
         NZAV=NZAV+1
         CALL PUSH
         IF(IERR.LT.0) GOTO 6000
 
      CASE(16)
C Prava zavorka (vyprazdneni LIFO az k leve zavorce /vcetne/)
         IF(NZAV.LE.0) GOTO 1000
         NZAV=NZAV-1
         DO WHILE (IST.GT.0.AND.IERR.EQ.0)
            IOP2=LIFO(IST)
            IF (IOP2.EQ.17) THEN
               IST=IST-1
               CYCLE Lex
            ENDIF
            CALL POP
         END DO
 
      CASE DEFAULT
C Ostatni operatory
         DO WHILE (IST.GT.0.AND.IERR.EQ.0)
            IOP2=LIFO(IST)
            IF (IOP2.EQ.17) EXIT
C Nejvyssi prioritu 10 maji operatory funkci sin,cos,...
            IPRI1=10
            IPRI2=10
            IF (IOP1.LE.18) IPRI1=IPRI(IOP1)
            IF (IOP2.LE.18) IPRI2=IPRI(IOP2)
            IF (IPRI1.GT.IPRI2) EXIT
C Operator IOP2 vytazen z LIFO do RPN jen pokud neni jeho priorita
C mensi nez priorita aktualniho operatoru IOP1
            CALL POP
          END DO
          CALL PUSH
 
      END SELECT
 
      END DO Lex
C---------------------------------------------------
C Konec analyzy?
 
      DO WHILE (IST.GT.0.AND.IERR.EQ.0)
         IOP2=LIFO(IST)
         CALL POP
      END DO
C Ukoncovacim kodem RPN je 0
      IF(IRPN.LT.IMAX)THEN
         IRPN=IRPN+1
         IA(IRPN)=0
      ENDIF
      IF (I.EQ.1) THEN
C Prazdny kod
         IERR=1
         GOTO 9999
      ENDIF
      IF (NZAV.NE.0) GOTO 1000
C Zaverecna overovaci sekvence (simulace TINE)
      IST=0
      I=0
24    I=I+1
      IF(I.LE.IRPN)THEN
        INDI=IA(I)
        IF(INDI.LT.0)THEN
           I=I+1
           ITYP=IA(I)
           IF(ITYP.EQ.1.OR.ITYP.EQ.2.OR.ITYP.EQ.5.OR.ITYP.EQ.6)IST=IST+1
        ELSEIF(INDI.GT.0)THEN
           IF(INDI.LT.17)THEN
              IST=IST-1
           ELSEIF(INDI.GT.25)THEN
              I=I+1
              IST=IST+IA(I)+1
           ENDIF
        ENDIF
        IF(IST.GT.0)GOTO 24
      ENDIF
      IF(IST.EQ.1) GOTO 9999
C
C VSECHNY DALSI CHYBY, (ZATIM CHYBEJICI LEVA ZAVORKA):
C ZPRACOVANA CARKA, ANIZ PREDCHAZELA LEVA ZAVORKA
C ZA IDENTIFIKATOREM FUNKCE NEBO VEKTORU NENI LEVA ZAVORKA
1000  IERR=-4016
      goto 6000
C ZA OPERATOREM NASLEDUJE OPET OPERATOR (BINARNI)
2000  IERR=-4013
      goto 6000
C ZA OPERANDEM NASLEDUJE LEVA ZAVORKA NEBO FUNKCE (UNARNI OP)
3000  IERR=-4012
      goto 6000
C ZAKODOVANI POZICE CHYBNEHO ZNAKU:
6000  IER=IERR-10000*IFCHAR
9999  CONTINUE
 
      CONTAINS
 
      SUBROUTINE OPERAND
C Operand: ciselna konstanta nebo promenna do RPN
C-----------------------------------------
         IPRE2=3
         IF (IPRE1.GT.2) THEN
           IERR=-4011
           RETURN
         ENDIF
         IF (JTX2.LE.0)THEN
C Cteni a ukladani konstanty (hledani technikou narazniku)
           CALL TAKER(ITX,ICT,JTX1,RR,JTX2)
           IF (JTX2.LE.0)THEN
              IERR=-4010
              RETURN
           ELSEIF(ICON.GE.KMAX)THEN
              IERR=-4014
              RETURN
           ENDIF
c tady se musi pouzit equivalence IRR = RR
           A(ICON+1)=IRR
           LOCV=KFR
           DO WHILE (A(LOCV).NE.IRR)
               LOCV=LOCV+1
           ENDDO
           ICON=MAX0(ICON,LOCV)
           ITYP=1
         ENDIF
         JTX1=JTX2
         IRPN=IRPN+2
         IF(IRPN.GT.IMAX) THEN
            IERR=-4015
            RETURN
         ENDIF
         IA(IRPN-1)= -LOCV
         IA(IRPN)  =  ITYP
      END SUBROUTINE OPERAND
 
      SUBROUTINE POP
C Sekce ukladani operatoru do RPN. IST-stack top
C ----------------------------------------------
C IOP2 je vytazen ze zasobniku LIFO a vlozen do RPN
         IST=IST-1
         IF (IOP2.LE.25) THEN
C standardni operace a funkce (uklada se jen jedno cislo, kod operatoru)
            IRPN=IRPN+1
         ELSE
C vektor nebo viceparatricka funkce (ukladaji se dve cisla)
            IRPN=IRPN+2
         ENDIF
         IF(IRPN.GT.IMAX)THEN
            IERR=-4015
            RETURN
         ENDIF
         IF (IOP2.LE.25) THEN
C not a user function
            IA(IRPN)=IOP2
         ELSE
            LOCV=IOP2-25
            ITYP=IATTR(2,LOCV)
            IF (ITYP.LE.4) THEN
C variables (NEGATIVE SIGN)
              IA(IRPN-1)=-IATTR(1,LOCV)
              IA(IRPN  )=ITYP
            ELSE
C user functions
              IA(IRPN-1)=IATTR(1,LOCV)+25
              IA(IRPN  )=NPAR(LEVEL)
            ENDIF
            LEVEL=LEVEL-1
         ENDIF
      END SUBROUTINE POP
 
      SUBROUTINE PUSH
C PUSH operator to stack
C ------------------------------------
         IST=IST+1
         IF(IST.GT.20) THEN
            IERR=-4009
            RETURN
         ENDIF
         LIFO(IST)=IOP1
         IF (IOP1.GT.25) THEN
            LEVEL=LEVEL+1
            IF(LEVEL.GT.4) THEN
               IERR=-4009
               RETURN
            ENDIF
            NPAR(LEVEL)=-1
         ENDIF
      END SUBROUTINE PUSH
 
      END
