      SUBROUTINE TRANSQ(IT,ITL,J,NAME,IATR,LN,   NINIT,KINIT,
     /                  NMAX,KMAX,IMAX,NLST,KLST,ILST,R,IRPN,IEND)
C
C ͻ
C   Rozsireny TRANSP (DISP e1,e2,...  FOR i=e1,e2 DO block, RUN program) 
C                           IF e THEN block   IF e THEN block ELSE block 
C ͼ
C
C Vstupni parametry:
C IT-prekladany text delky ITL slabik J+1 znakem pocinaje (musi byt PROMENNA)
C NAME,IATR -jmena a atributy identifikatoru delky LN (tato pole jsou i vystupni)
C NINIT-pocet preddefinovanych identifikatoru
C KINIT-pocet preddefinovanych promennych nebo konstant (blokovani R(1)-R(KINIT))
C NMAX -maximalni pocet identifikatoru
C KMAX -maximalni index konstanty ve vektoru R (max.pocet konstant je KMAX-KINIT)
C IMAX -maximalni pocet prvku RPN
C
C Vystupni parametry:
C NLST,KLST,ILST-posledni identifikator, konstanta, RPN
C R - vektor promennych a konstant delky minimalne KMAX (INTEGER!)
C IRPN- vektor RPN delky minimalne IMAX
C IEND- >0 pozice posledniho znaku zpracovaneho vyrazu (bez chyby)
C       =0 vycerpany text
C       <0 chyba syntaxe
C
C Gramatika je popsana matici G. Sloupec definuje pravidlo a ma tyto prvky:
C   1     2     3     4     5     6     7     8     9    10    11    12
C delka  var:= atr1 term1  atr2  var2  atr3  var3  atr4  var4  atr5  var5
C
C Pravidlo    Definice
C     
C   1         <prg> = INTEGER <list> <prg>
C   2         <prg> = REAL    <list> <prg>
C   3         <prg> = WHILE   VYRAZ DO <blok> <nprg>
C   4         <prg> = IF      VYRAZ THEN <blok> <nprg>
C   5         <prg> = PRIRAZENI <nprg>
C   6         <prg> = DON     <nprg>
C   7         <prg> = DISP    <dlist> <nprg>
C   8         <prg> = FOR     <loop> DO <blok> <nprg>
C<< 9         <prg> = RUN     filename <nprg>
C< 10        <nprg> = DISP    <dlist> <nprg>
C< 11        <nprg> = FOR     <loop> DO <blok> <nprg>
C  12        <nprg> = DON     <nprg>
C  13        <nprg> = DOFF    <nprg>
C  14        <nprg> = WHILE   VYRAZ DO <blok> <nprg>
C  15        <nprg> = IF      VYRAZ THEN <blok> <nprg>
C  16        <nprg> = ELSE    <blok> <nprg>
C  17        <nprg> = BEGIN   <prg> END <nprg>
C  18        <nprg> = RUN     FILENAME  <nprg>
C  19        <nprg> = PRIRAZENI <nprg>
C  20        <nprg> = e
C  21        <list> = IDENT <elist>
C  22       <elist> = (  CELOCIS.KONST. ) <klist>
C  23       <elist> = , <list>
C  24       <elist> = e
C  25       <klist> = , <list>
C  26       <klist> = e
C  27        <blok> = BEGIN  <prg>  END
C  28        <blok> = PRIRAZENI
C  29        <blok> = DISP <dlist>
C  30        <loop> = ICYCL = VYRAZ,VYRAZ
C  31       <dlist> = VYRAZ <llist>
C  32       <llist> = , <dlist>
C  33       <llist> = e
C  34         <prg> = VYRAZ <nprg>
C
C Terminalove symboly Term > 0 :
C 
C   1-INT(EGER) 2-REAL        3-WHILE            4-DO
C   5-IF        6-THEN        7-BEGIN (nebo [)   8-END (nebo ])
C   9- (       10- )         11- ,              12-DON
C  13-DOFF     14-FOR        15- =              16-DISP
C  17-RUN      18-ELSE       19-filename        20-icycl
C  21-identif  22-relac.op.  23-celocis.konst.  24-prirazeni  25-vyraz
C 100-e-pravidlo.
C
C Metapromenne  Term<0 :
C 
C -1 PRG   -2 NPRG   -3 LIST   -4 ELIST   -5 KLIST   -6 BLOK
C -7 LOOP  -8 DLIST  -9 LLIST
C
C Atributy:
C 
C 1 - WHILE  pouziva se pro uschovani adresy podminky, ktera nasleduje po WHILE.
C         Na tuto adresu se skace na konci bloku prikazu. Tento atribut se da
C         vyuzit i v jinem kontextu, zpusobi ulozeni nasledujici adresy (ILST+1)
C         do zasobniku STC (inkrementace STC+1).
C
C 2 - THEN,DO pouziva se pro vyhodnoceni podminky v prikazech WHILE, IF... 
C         Vlozeni kodu 107 (if_not goto Adr) do ILST+1. Na pozici ILST+2
C         by mela byt adresa skoku Adr, ktery se provadi pri nesplneni podminky
C         IF nebo WHILE. Tato adresa ale jeste neni v teto fazi prekladu znama a
C         ulozi se jen adresa adresy (ILST+2) do zasobniku (inkrementace STC+1).
C         Posun pocitadla generovaneho kodu instrukci RPN: ILST=ILST+2.
C
C 3 - po WHILE_BLOCK.Nepodmineny skok na konci bloku WHILE zpet na vyhodnoceni
C         podminky WHILE. Vlozeni kodu 108 (goto adr) do ILST+1. Dale se
C         vyuziji dve hodnoty v zasobniku (ktery se pak odstrani):
C             STC-1 (adresa zacatku bloku); ulozi se do ILST+2 za kod 108
C             STC   (adresa adresy, kam se ma skocit po skonceni, tj. na ILST+3)
C         Posun pocitadla generovaneho kodu instrukci ILST=ILST+2.
C
C 4 - po IF_BLOCK
C         na vrchu zasobniku STC je adresa adresy skoku-aktualizace teto
C         adresy na ILST+3 a dekrementace zasobniku STC-1.
C         Stale jeste neni znamo, zda pujde o konstrukci IF THEN ELSE, proto
C         vlozime na konec bloku 2 slova: goto <Adr>, kde <Adr> je hned 
C         nasledujici instrukce ( <ILST+1> 108, <ILST+2> ILST+3 ).
C
C 5 - nastaveni typu REAL
C 6 - nastaveni typu INTEGER
C 7 - kod DISP ON  (generovani kodu 109)
C 8 - kod DISP OFF (generovani kodu 110)
C 9 - kod DISP     (generovani kodu 111)
C
C 11- carka v prikazu FOR. Generovani kodu 112 LOC,TYP, 115 LOC,TYP
C         Po precteni carky (i=e1,e2) je jiz vycislena dolni mez
C         e1, a kod 112 znamena, ze ma byt prenesena jeji hodnota
C         do promenne cyklu (i). Kod 115 pak znamena, ze ma byt
C         hodnota parametru cyklu snizena o 1 (i=i-1).
C
C 12- po nacteni horni meze FOR. Generovani kodu 113
C         Kod 113 znamena, ze se vysledek (horni mez cyklu e2) ma ulozit
C         do zasobniku interpretu. Horni mez se tedy vyhodnocuje jen
C         jednou, na zacatku cyklu.
C
C 13- DO prikazu cyklu. Generovani kodu 114 LOC,TYP a 116 LOC TYP Adr.
C         Kod 114 znamena, ze se inkrementuje parametr cyklu (i=i+1).
C         Kod 116 je porovnani hodnoty parametru cyklu s horni mezi e2
C         ulozenou v zasobniku interpretu. Kdyz je i>e2 provede se skok
C         za konec bloku, na adresu Adr, ktera zatim neni znama. Proto
C         se do zasobniku STC ulozi jen adresa adresy.
C
C 14- po FOR BLOCK. Generovani Kodu 108(goto Adr).
C         Adresa Adr skoku na instrukci 114 (inkrementace parametru cyklu) je
C         ulozena v zasobniku (STC-6). Hodnota STC je adresa, kam se ulozi
C         adresa nasledujici instrukce.  Dekrementace zasobniku 1.
C
C 15- RUN filename. Generovani kodu 118(runprogram). Filename je textovy
C         retezec na 12 znaku (uplne jmeno, napr.prg.exe).
C
C 16- ELSE Predchozi dve instrukce byly 108 <adr>. Adresu bude treba zmenit
C         po prelozeni bloku. Adresu adresy proto ulozime do zasobniku.
C
C 17- po ELSE BLOCK. Aktualizujeme adresu adresy ze zasobniku.
C
C IRPN(LAST) - interpretovany kod
C  1 <=,   2  >=,   3  <>,   4  <,   5   >,   6 =,   7  &,  8 |,  9 +,  10 -,
C 11 **,  12   /,  13   *,  14 :=,  15 ,  ,  16 ),  17  (, 18 \, 19 SIN,20 COS,
C 21 EXP, 22 SQR,  23 LOG,  24 LGT, 25 ABS,  26 UF, ...
C   100  len  prirazovaci prikaz nebo vyraz
C   107  adr  vyhodnoceni podminky RESULT a skok na adresu kdyz FALSE (ifnot adr)
C   108  adr  nepodmineny skok (na konci while, goto adr)
C   109       DON trace on
C   110       DOF trace off
C   111 name4 DISP zobrazeni 4znaku a hodnoty zasobniku
C   112 iloc ityp  res->i
C   113       RES -> STACK
C   114 iloc ityp  i=i+1
C   115 iloc ityp  i=i-1
C   116 iloc ityp adr  i>STACK goto_adr
C   117       dekrementace STACK.
C   118 filename*12
C Adresou je minen index vektoru IRPN.
C
C Popis algoritmu:
C
C       Program musi vyhovovat gramatice, zalozene na pravidlech typu
C
C METAPROMENNA := METAKONSTANTA {seznam metakonstant a metapromennych...}
C
C Gramatika muze obsahovat nekolik pravidel se stejnou levou stranou,
C ale ty se musi lisit prvni metakonstantou. Pravidla se zpracovavaji
C zasobnikovym automatem, ktery pouziva zasobnik STC(2,20)
C vzdy s dvojici udaju o metapromenne nebo metakonstante:
C STC1 atribut (napr. uloz adresu RPN do zasobniku, vloz do RPN kod skoku ap)
C STC2 term.symbol, tj. metakonstanta (>0) nebo metapromenna (<0)
C
C Na zacatku analyzy je v zasobniku jen metapromenna STC2 = -1 (PRG)
C
C Obecny krok zpracovani jedne polozky TOS na vrchu zasobniku:
C
C A)  Kdyz je TOS konstanta (TOS>0), vola se procedura TSRCHQ, ktera
C     dle udaje TOS zpracuje cast analyzovaneho textu (napr.klicove slovo,
C     identifikator, celociselne konstanty, vyraz), a vysledkem je
C     napr. preneseni kodu vyrazu do RPN nebo rozsireni seznamu promennych.
C     Pak nasleduje druha cast, zpracovani atributu, viz popis TSRCHQ.
C     Zasobnik se dekrementuje  ISTC=ISTC-1 a cely cyklus se opakuje.
C
C B)  Kdyz je TOS metapromenna (TOS<0), provede se nejprve zpracovani
C     jejich atributu (stejne jako u metakonstanty), proste se zavola TSRCHQ.
C     Pote se v cyklu projdou vsechna pravidla gramatiky, ktera maji levou
C     stranu =TOS. Tech muze byt nekolik a vybira se dle hodnoty prvni
C     metakonstanty na prave strane. Jeji hodnota se porovnava s analyzovanym
C     textem pomoci TSRCHQ. Kdyz TSRCHQ zjisti, ze text metakonstante odpovida,
C     okamzite ji zpracuje (tato konstanta se vubec nedostane do zasobniku)
C     a jenom zbytek pravidla se uklada: ISTC=ISTC+LEN-1. Tim hledani
C     pravidel konci a cyklus se opakuje. V gramatice jsou i pravidla
C     kde na prave strane je metakonstanta 100 (e-pravidlo) - to je jen
C     prazdne pravidlo, ktere se vyjme ze zasobniku a dalsi pravidla
C     se uz neprohlizeji. To znamena, ze na poradi pravidel v matici G zalezi,
C     a pokud se gramatika rozsiruje o nove konstrukce je treba na to dbat.
C
C Programovaci jazyk:
C
C - Vsechny pouzite promenne (skalary, vektory) musi byt deklarovany.
C   Deklarace musi byt na zacatku programu nebo bloku. Meze vektoru musi byt
C   celociselne konstanty, napriklad  REAL ALFA,B,CVECT(125) INT I,J
C
C - Prirazovaci prikazy pouzivejte radeji bez relacnich operatoru, i kdyz
C   i to je pripustne, napr A=2>3 da nulovou hodnotu A, protoze 2 neni vetsi
C   nez 3. Operatory: <=, >=, <>, <, >,=(rovna se),& (and),|(or),+,-,*,/,**.
C   Lze pouzivat standardni funkce SIN(),COS(),EXP(),SQR(),LGT(),LOG(),ABS().
C   i uzivatelske funkce, pokud jsou definovany v externi procedure TFU.
C
C - Kontrolni prikazy jsou tri: IF, WHILE a FOR. Maji ponekud odlisnou
C   konstrukci: hlavicku, definujici podminky, za niz nasleduje blok,
C   ktery se provadi; blok ma vzdy tvar BEGIN prikazy END, nebo [ prikazy ].
C         IF     relace THEN blok
C         WHILE  relace   DO blok
C         FOR i=imin,imax DO blok
C   Blok muze byt i jediny prirazovaci prikaz, pak se nemusi pouzit zavorky bloku.
C   Soucasti bloku mohou byt i vnorene prikazy IF, WHILE, FOR. Priklady
C         WHILE i<5 DO [ FOR j=1,i DO [ DISP i,j i=i+1 ] ]
C         IF i<5 THEN i=10 IF i<10 THEN [FOR j=1,3*i DO [DISP i,j]]
C   Poznamenejme, ze v tele prikazu cyklu je povoleno menit hodnotu parametru
C   cyklu.
C
C - DISP e1,e2,... zpusobi vycisleni vyrazu e1,e2,... a zobrazeni jejich hodnot
C   na displeji (standardni vystup). Pro identifikaci vyrazu jsou zobrazeny
C   prvni 4 znaky. Napr. DISP a(i),2*b  zobrazi: A(I)=1.23E+01  2*B =-1.35E-01
C
C - Prikazem RUN file je mozne spustit externi program. Interpret to zajistuje
C   prikazem iresult=RUNQQ(file,''), coz je konstrukce specificka pro PowerFortran.
C
C - Nerozlisuji se mala a velka pismena, vse se nejprve konvertuje na velka,
C   a v pripade syntakticke chyby je zbytek textu preveden na male
C   znaky (tim je lokalizovana chyba).
C
C -   U nasledujicich klicovych slov je pripustny i zkraceny zapis
C        INTEGER   INT
C        BEGIN      [
C        END        ]
C
C -   Lexikalni symboly je treba oddelovat mezerou (nebo mezerami), ale uvnitr
C     techto symbolu se jiz mezery objevit nesmi (ani ve vyrazu, ktery je take
C     lexikalni symbol). Do textu programu je mozne psat poznamky, vymezene
C     zavorkami { poznamka }. Tato poznamka je ale take lexikalni symbol, takze
C     ji nelze vkladat treba doprostred vyrazu nebo klicoveho slova.
C
C Priklady generovani kodu:
C
C        real a a=2*3
C REAL:  R1 a,   R2=2,    R3=3    (KLST=3)
C IRPN:  100 9   -1 5   -2 1   -3 1   13   14  0
C         expr    a:=     2      3     *   :=
C
C        integer i i=0 while i<3 do i=i+2
C REAL:  R1 i,   R2=0,    R3=3,  R4=2    (KLST=4)
C IRPN:  100 6 -1 6 -2 1 14 0  100 6 -1 2 -3 1  4 0   107 32  100 9  -1 6  -1 2  -4 1  9 14 0   10
C         expr  i:=  0   :=    expr   i    3    <    ifnot32   expr   i:=   i     2    + :=     go
C
C        real a(3) a(2+1)=3.5
C REAL:  R1 a1,   R2=a2,    R3=a3,   R4=2,   R5=1,  R6=3.5    (KLST=6)
C IRPN:  100 11   -4 1   -5 1  9  -1 7     -6 1   14  0
C         expr      2      1   +   a():=    3.5   :=
C
C        integer i  if i<3  then i=5
C REAL:  R1 i,  R2=3,   R3=5   (KLST=3)
C IRPN:  100 6  -1 2  -2 1  4  0   107 19   100 6  -1 6  -3 1  14  0
C         expr    i     3   <      ifnot19   expr   i:=    5   :=
C
      PARAMETER (NG=34,ISTMAX=20)
      CHARACTER *(*) IT,NAME
      INTEGER R(*)
      DIMENSION IATR(2,*),IRPN(*)
      INTEGER*1 G(12,NG),STC(2,ISTMAX),TOS,ATR,TERM,ISTCW
      INTEGER*2 STCW
      COMMON /TSTC1$/ISTCW /TSTC2$/STCW(ISTMAX) /SCOM/ISCOM(50)
      EQUIVALENCE (IER,ISCOM)
      DATA G/
     /  3,-1,    6, 1,    0,-3,    0,-1,    0, 0,    0, 0,               prg=INTEGER list prg
     /  3,-1,    5, 2,    0,-3,    0,-1,    0, 0,    0, 0,               prg=REAL    list prg
     /  5,-1,    1, 3,    0,25,    2, 4,    0,-6,    3,-2,               prg=WHILE EXP DO blok npr
     /  5,-1,    0, 5,    0,25,    2, 6,    0,-6,    4,-2,               prg=IF EXP THEN  blok npr
     /  2,-1,    0,24,    0,-2,    0, 0,    0, 0,    0, 0,               prg=ASSGN nprg
     /  2,-1,    7,12,    0,-2,    0, 0,    0, 0,    0, 0,               prg=DON   nprg
     /  3,-1,    0,16,    0,-8,    0,-2,    0, 0,    0, 0,               prg=DISP  dlist nprg
     /  5,-1,    0,14,    0,-7,   13, 4,    0,-6,   14,-2,               prg=FOR loop DO blok nprg
     /  3,-1,    0,17,   15,19,    0,-2,    0, 0,    0, 0,               prg=RUN FILENAME nprg
     /  5,-2,    0,14,    0,-7,   13, 4,    0,-6,   14,-2,              nprg=FOR loop DO blok nprg
     /  2,-2,    7,12,    0,-2,    0, 0,    0, 0,    0, 0,              nprg=DON nprg
     /  3,-2,    0,16,    0,-8,    0,-2,    0, 0,    0, 0,              nprg=DISP  dlist nprg
     /  2,-2,    8,13,    0,-2,    0, 0,    0, 0,    0, 0,              nprg=DOF  nprg
     /  5,-2,    1, 3,    0,25,    2, 4,    0,-6,    3,-2,              nprg=WHILE EXP DO blok  np
     /  5,-2,    0, 5,    0,25,    2, 6,    0,-6,    4,-2,              nprg=IF EXP THEN blok nprg
     /  3,-2,   16,18,    0,-6,   17,-2,    0, 0,    0, 0,              nprg=ELSE blok nprg 
     /  4,-2,    0, 7,    0,-1,    0, 8,    0,-2,    0, 0,              nprg=BEGIN prg END nprg
     /  2,-2,    0,24,    0,-2,    0, 0,    0, 0,    0, 0,              nprg=ASSGN nprg
     /  3,-2,    0,17,   15,19,    0,-2,    0, 0,    0, 0,              nprg=RUN FILENAME nprg
     /  1,-2,  100,100,   0, 0,    0, 0,    0, 0,    0, 0,              nprg=e
     /  2,-3,    0,21,    0,-4,    0, 0,    0, 0,    0, 0,               list=IDENT elist
     /  4,-4,    0, 9,    0,23,    0,10,    0,-5,    0, 0,              elist=( CELOCIS.KONST ) kl
     /  2,-4,    0,11,    0,-3,    0, 0,    0, 0,    0, 0,              elist= , list
     /  1,-4,    0,100,   0, 0,    0, 0,    0, 0,    0, 0,              elist=e
     /  2,-5,    0,11,    0,-3,    0, 0,    0, 0,    0, 0,              klist= , list
     /  1,-5,    0,100,   0, 0,    0, 0,    0, 0,    0, 0,              klist=e
     /  3,-6,    0, 7,    0,-1,    0, 8,    0, 0,    0, 0,               blok=BEGIN prg END
     /  1,-6,    0,24,    0, 0,    0, 0,    0, 0,    0, 0,               blok=ASSGN
     /  2,-6,    0,16,    0,-8,    0, 0,    0, 0,    0, 0,               blok=DISP dlist
     /  5,-7,    0,20,    0,15,   11,25,    0,11,   12,25,               loop=ICYCL=EXP,EXP
     /  2,-8,    9,25,    0,-9,    0, 0,    0, 0,    0, 0,              dlist=EXP llist
     /  2,-9,    0,11,    0,-8,    0, 0,    0, 0,    0, 0,              llist= , dlist
     /  1,-9,    0,100,   0, 0,    0, 0,    0, 0,    0, 0,              llist=e
     /  2,-1,    0,25,    0,-2,    0, 0,    0, 0,    0, 0/               prg=EXP nprg
      IER=0
C
C Prevod textu na UPPERcase
C
      CALL TUPC(ITL,IT,IT)
      JPT=J
      JOUT=J
      ISTCW=0
      NLST=NINIT
      KLST=KINIT
      ILST=0
      ISTC=1
      STC(1,1)=0
      STC(2,1)=-1
C
1     IF(ISTC.LE.0) GOTO 9999
      TOS=STC(2,ISTC)
      ATR=STC(1,ISTC)
      IF(ATR.EQ.100) THEN
         IF(ISTC.GT.1)THEN
            IER=4028
            GOTO 999
         ENDIF
         GOTO 9999
      ENDIF
      IF(TOS.GT.0) THEN
C
C TERM TOS>0 lexikalni konstanta
C
          CALL TSRCHQ(TOS,ATR,IT,ITL,JPT,NAME,IATR,LN,NLST,NMAX,
     /         KLST,KMAX,ILST,IMAX,R,IRPN,JOUT)
          IF(IER.EQ.0)THEN
             ISTC=ISTC-1
             GOTO 1
          ELSEIF(IER.LT.0) THEN
             GOTO 9999
          ENDIF
      ELSE
C
C VAR-nejprve zpracovani atributu METAPROMENNE TOS
C
          CALL TSRCHQ(TOS,ATR,IT,ITL,JPT,NAME,IATR,LN,NLST,NMAX,
     /               KLST,KMAX,ILST,IMAX,R,IRPN,JOUT)
          DO 10 I=1,NG
C Vyhledani pravidla s levou stranou TOS
          IF(G(2,I).EQ.TOS)THEN
             ATR =G(3,I)
             TERM=G(4,I)
             IF(TERM.EQ.100)THEN
C e-pravidlo
                ISTC=ISTC-1
                IER=0
                GOTO 1
             ENDIF
             CALL TSRCHQ(TERM,ATR,IT,ITL,JPT,NAME,IATR,LN,NLST,NMAX,
     /            KLST,KMAX,ILST,IMAX,R,IRPN,JOUT)
             IF(IER.EQ.0) THEN
C Nalezeno pravidlo zacinajici spravnym TERM-symbolem; ulozeni do zasobniku
                 ISTCO=ISTC
                 ISTC =ISTC+G(1,I)-2
                 IF(ISTC.GT.ISTMAX)THEN
                    IER=4009
                    GOTO 999
                 ENDIF
                 JJ=2*G(1,I)
                 DO 2 K=ISTCO,ISTC
                 STC(1,K)=G(JJ+1,I)
                 STC(2,K)=G(JJ+2,I)
                 JJ=JJ-2
2                CONTINUE
                 GOTO 1
             ENDIF
          ENDIF
10        CONTINUE
          IER=4027
      ENDIF
999   IER=-IER-JOUT*10000
C
C prevod zbytku textu na LOWERCASE
C
9999  DO I=JOUT+1,ITL
         IF(IT(I:I).GE.'A'.AND.IT(I:I).LE.'Z')
     /         IT(I:I)=CHAR(ICHAR(IT(I:I))+32)
      END DO
C vyhodnoceni
      IF(IER.EQ.0)THEN
         IEND=JOUT
      ELSE
         IEND=-JOUT
      ENDIF
      END

