      SUBROUTINE TRIDAG(A,B,C,R,U,N)
c
c Tridiagonal linear set of equations (A-lower, B-diagonal, C-upper, R-RHS)
c according to Press: Numerical recipes, p. 40
c Vectors A,B,C,R are not destroyed.
c
      parameter (nmax=100)
      real gam(nmax),a(n),b(n),c(n),r(n),u(n)
      bet=b(1)
      u(1)=r(1)/bet
      do j=2,n
         gam(j)=c(j-1)/bet
         bet=b(j)-a(j)*gam(j)
         u(j)=(r(j)-a(j)*u(j-1))/bet
      enddo
      do j=n-1,1,-1
         u(j)=u(j)-gam(j+1)*u(j+1)
      enddo
      end
