       SUBROUTINE WOPENH(unit,labela,ixpos,iypos,ixpix,
     / iypix,nrow,ncol,ifontph,ihfontph,icursor,
     / fontphattr,icfR,icfG,icfB, icbR,icbG,icbB,oldwopen)     
C Otevri CHILD - window okenko na jednotce UNIT
C     unit       - unit number 
C     labela    - label of unit 
C     unit       - number of unit 
C     ixpos      - x window position in letter-pixels 
C     iypos      - y window position in letter-pixels 
C     ixpix      - x window width in pixels 
C     iypix      - y window height in pixels
C     nrow       - no. of text rows (attention!)
C     ncol       - no. of text columns (attention!)
C     ifontph    - index of font type 
C  1='Times' , 2='Arial',  3='Algerian', 4='Courier',  5='Helvetica'
C  6='Modern', 7='Seriff', 8='Tahoma',   9='Symbol', default='Times New Roman'
C     ihfontph   - set font height (and size is computed)
C     icursor    - set the cursor visible (1 is visible), default is 0 
C     fontphattr - set font attributes to bold , italic and decorative font  
C                  B as bold, I as Italic, D as Decorative, and combination 
C                  BI, BD, ID, BID. Default is B.
C     icfR,icfG,icfB   - RGB values of font color
C     icbR,icbG,icbB   - RGB values of window background color
C     oldwopen   - switch for old wopen.for subroutine        
$IF DEFINED (compaq)
      USE DFLIB
      USE DFWIN
$ELSE
      USE MSFLIB
      USE MSFWIN
$ENDIF
C GPWIN$ PARAMETRY CHILD-WINDOW (MUSI BYT OZ OTEVRENE)

      PARAMETER (MAXW=40)
      INTEGER *2 MAXWX,MAXWY,ROWS,COLS,ROWSHF,COLSHF
      COMMON /GPFWIN$/
     /   MAXWX(MAXW),MAXWY(MAXW),ROWS(MAXW),COLS(MAXW),
     /   ROWSHF(MAXW),COLSHF(MAXW)

      integer unit
      logical*4 result,STATUS,bret
      integer*4 NUMFONTA
      integer*4 iret
      integer*4 ibackcolor
      integer*4 itextcolor
      integer*4 iHeightFont, iWidthFont  
      
      character*200 labela
      character*3 fontphattr
      character F_CHAR
      type (windowconfig) wc
      record /qwinfo/winfo
      integer oldwopen
      
      IX=ixpos
      IY=iypos 
      MAXXP=ixpix
      MAXYP=iypix

      IF(UNIT.GT.MAXW)RETURN

	CLOSE(UNIT)
	open(unit,file='user',IOFOCUS = .TRUE.,title=labela)
	winfo.h=nrow
	winfo.w=ncol
	winfo.x=ix
	winfo.y=iy
	winfo.type=qwin$set
	result=setwsizeqq(unit,winfo)
	result=setactiveqq(unit)
	status=focusqq(unit)
c INITI... asi zbytecne, je to i nakonci
	NUMFONTA=INITIALIZEFONTS()
        
      IF (oldwopen.eq.1.and.unit.ne.20.and.unit.ne.10) THEN
C zkracene old wopen.for 
C vyjimkou je okno MODE (20), kde je treba nastavit fonty pro zobrazeni MOP     
		STATUS=GETWINDOWCONFIG(WC)
		IF(MAXXP.LE.0)THEN
			MAXWX(UNIT)=WC.NUMXPIXELs
		ELSE
			MAXWX(UNIT)=MAXXP
			WC.NUMXPIXELS=MAXXP
		ENDIF
		IF(MAXYP.LE.0)THEN
			MAXWY(UNIT)=WC.NUMYPIXELs
		ELSE
			MAXWY(UNIT)=MAXYP
			WC.NUMYPIXELS=MAXYP
		ENDIF
		STATUS=SETWINDOWCONFIG(WC)
		IF(.NOT.STATUS)STATUS=SETWINDOWCONFIG(WC)
C  konec puvodni verze wopen-----------------------------------------------------

      ELSE 

C     set the child window properties
		wc%numxpixels = ixpix
		wc%numypixels = iypix
		wc%numtextcols = ncol
		wc%numtextrows = nrow
		wc%numcolors = 256
C      Set the scrolling mode 
C      wc%mode     = QWIN$SCROLLDOWN
		wc%fontsize = QWIN$EXTENDFONT  
C index of font type 
		select case (ifontph)
		case(1)
			wc%extendfontname = 'Times'C
		case(2)
			wc%extendfontname = 'Arial'C           
		case(3)
			wc%extendfontname = 'Algerian'C
		case(4)
			wc%extendfontname = 'Courier'C
		case(5)
			wc%extendfontname = 'Helvetica'C
		case(6)
			wc%extendfontname = 'Modern'C
		case(7)
			wc%extendfontname = 'Seriff'C
		case(8)
			wc%extendfontname = 'Tahoma'C
		case(9)
			wc%extendfontname = 'Symbol'C
		case default
			wc%extendfontname = 'Times New Roman'C
		end select
C      set font height and size
		iHeightFont =  ihfontph
		iWidthFont = ihfontph*10/22
		wc%extendfontsize = makelong(iHeightFont,iWidthFont) 
!     set font attributes to bold, italic and decorative font  
		fontphattr = trim(fontphattr)
		wc%extendfontattributes  = 0
		DO I=1,LEN(trim(fontphattr))
			F_CHAR=fontphattr(I:I) 
			select case (F_CHAR)
			case('B')
       wc%extendfontattributes  = ior(wc%extendfontattributes,
     / QWIN$EXTENDFONT_BOLD ) 
			case('I')
       wc%extendfontattributes  = ior(wc%extendfontattributes,
     / QWIN$EXTENDFONT_ITALIC) 
			case('D')
       wc%extendfontattributes  = ior(wc%extendfontattributes,
     / INT2(QWIN$EXTENDFONT_FF_DECORATIVE))
			case default
       wc%extendfontattributes  = QWIN$EXTENDFONT_NORMAL
			end select  
		ENDDO   
		IF(wc%extendfontattributes .eq. 0) then 
       wc%extendfontattributes  = QWIN$EXTENDFONT_NORMAL
		ENDIF 

		STATUS=SETWINDOWCONFIG(WC)
		IF(.NOT.STATUS)STATUS=SETWINDOWCONFIG(WC)

!     set colors for screen
		ibackcolor = rgbtointeger(icbR,icbG,icbB)      !black
		iret = SETBKCOLORRGB(ibackcolor) 
!      set color for text
		itextcolor = rgbtointeger(icfR,icfG,icfB)      !white
		iret = SETTEXTCOLORRGB(itextcolor)

!      Display cursor:
		select case (icursor)
		case(1)
			RESULT = SETTEXTCURSOR(#0108)
			result = DISPLAYCURSOR($GCURSORON)
		case(0)
			result = DISPLAYCURSOR($GCURSOROFF)          
		case default
			result = DISPLAYCURSOR($GCURSOROFF)
		end select
 
		MAXWX(UNIT)=MAXXP
		MAXWY(UNIT)=MAXYP
      
	ENDIF  
C
C je zajimave, ze nasledujici GETWINDOWCONFIG zpusobi to, ze se FEMINA normalne neukonci
C	STATUS=GETWINDOWCONFIG(WC)

	ROWS(UNIT)=WC.NUMTEXTROWS
	COLS(UNIT)=WC.NUMTEXTCOLS
	ROWSHF(UNIT)=IX
	COLSHF(UNIT)=IY
	NUMFONTA=INITIALIZEFONTS()
      
      END
