      SUBROUTINE FDFP(NOD,X,Y,Z,RL1,RL2,RL3,F,FX,FY,FZ,V)
C
C CTYRSTENNY PRVEK SE 4 NEBO 8 UZLOVYMI BODY.
C
C VSTUPY:
C X(),Y()       SOURADNICE UZLU (1,2,3,4 -VRCHOLY, 5,6,7,8-TEZISTE STEN)
C RL1,RL2=L1,L2 PLOSNE SOURADNICE LIBOVOLNEHO BODU (0,1)
C
C NOD=4	 4 linearni bazove funkce odpovidajici uzlum ve vrcholech
C NOD=8 20 kubickych bazovych funkci (vrcholy - hodnoty a derivace, teziste sten - hodnoty)
C
C VYSTUP:
C F,FX,FY,FZ HODNOTY A PRVNI DERIVACE TVAROVYCH FUNKCI V BODE L1,L2,L3
C V=OBJEM CTYRSTENU (=JAKOBIAN/6)
C
      DIMENSION Y(*),X(*),Z(*),F(*),FY(*),FX(*),FZ(*)
      REAL L(8),LY(4),LX(4),LZ(4)
      L(1)=RL1
      L(2)=RL2
      L(3)=RL3
      L(4)=1.-RL1-RL2-RL3
C 3-UZLY (LINEARNI TVAROVE FUNKCE); TESTED O.K. BY BTEST.FOR
C AREA
	 DET=X(2)*Y(3)*Z(4)-X(2)*Y(4)*Z(3)-X(3)*Y(2)*Z(4)+X(4)*Y(2)*Z(3)+
     /     X(3)*Y(4)*Z(2)-X(4)*Y(3)*Z(2)-X(1)*Y(3)*Z(4)+X(1)*Y(4)*Z(3)+
     /     X(1)*Y(2)*Z(4)-X(1)*Y(2)*Z(3)-X(1)*Y(2)*Z(4)+X(1)*Y(3)*Z(2)+
     /     X(3)*Y(1)*Z(4)-X(4)*Y(1)*Z(3)-X(2)*Y(1)*Z(4)+X(2)*Y(1)*Z(3)+
     /     X(4)*Y(1)*Z(2)-X(3)*Y(1)*Z(2)-X(3)*Y(4)*Z(1)+X(4)*Y(3)*Z(1)+
     /     X(2)*Y(4)*Z(1)-X(2)*Y(3)*Z(1)-X(4)*Y(2)*Z(1)+X(3)*Y(2)*Z(1)
	 V=ABS(DET*(1./6.))
      SELECT CASE(NOD)
      CASE(4)
C LINEARNI BAZOVE FUNKCE VE VRCHOLECH CTYRSTENU
C DERIVATIVES OF AREA COORDINATES
         DO I=1,4
           I1=MOD(I,4)+1
           I2=MOD(I1,4)+1
           I3=MOD(I2,4)+1
           LX(I)=(-1.)**(I+1)*(Y(I2)*Z(I1)-Y(I1)*Z(I2)+Y(I1)*Z(I3)-
     /            Y(I3)*Z(I1)+Y(I3)*Z(I2)-Y(I2)*Z(I3))/DET
           LY(I)=(-1.)**(I)*(X(I2)*Z(I1)-X(I1)*Z(I2)+X(I1)*Z(I3)-
     /            X(I3)*Z(I1)+X(I3)*Z(I2)-X(I2)*Z(I3))/DET
           LZ(I)=(-1.)**(I+1)*(X(I2)*Y(I1)-X(I1)*Y(I2)+X(I1)*Y(I3)-
     /            X(I3)*Y(I1)+X(I3)*Y(I2)-X(I2)*Y(I3))/DET
           F(I)=L(I)
           FX(I)=LX(I)
           FY(I)=LY(I)
           FZ(I)=LZ(I)
         ENDDO
      CASE(8)
C KUBICKE BAZOVE FUNKCE (vrcholy - hodnoty a derivace, teziste sten - hodnoty)
         DO I=1,4
           I1=MOD(I,4)+1
           I2=MOD(I1,4)+1
           I3=MOD(I2,4)+1
           LX(I)=(-1.)**(I+1)*(Y(I2)*Z(I1)-Y(I1)*Z(I2)+Y(I1)*Z(I3)-
     /            Y(I3)*Z(I1)+Y(I3)*Z(I2)-Y(I2)*Z(I3))/DET
           LY(I)=(-1.)**(I)*(X(I2)*Z(I1)-X(I1)*Z(I2)+X(I1)*Z(I3)-
     /            X(I3)*Z(I1)+X(I3)*Z(I2)-X(I2)*Z(I3))/DET
           LZ(I)=(-1.)**(I+1)*(X(I2)*Y(I1)-X(I1)*Y(I2)+X(I1)*Y(I3)-
     /            X(I3)*Y(I1)+X(I3)*Y(I2)-X(I2)*Y(I3))/DET
           F(I)=3*L(I)**2-2*L(I)**3
           FX(I)=6*LX(I)*L(I)-6*LX(I)*L(I)**2
           FY(I)=6*LY(I)*L(I)-6*LY(I)*L(I)**2
           FZ(I)=6*LZ(I)*L(I)-6*LZ(I)*L(I)**2
           F(I+4)=27*L(1)*L(2)*L(3)
           FX(I+4)=27*LX(I1)*L(I2)*L(I3)+27*LX(I2)*L(I1)*L(I3)+
     /             27*LX(I3)*L(I1)*L(I2)
           FY(I+4)=27*LY(I1)*L(I2)*L(I3)+27*LY(I2)*L(I1)*L(I3)+
     /             27*LY(I3)*L(I1)*L(I2)
           FZ(I+4)=27*LZ(I1)*L(I2)*L(I3)+27*LZ(I2)*L(I1)*L(I3)+
     /             27*LZ(I3)*L(I1)*L(I2)
         ENDDO
         DO I=1,4
           I1=MOD(I,4)+1
           I2=MOD(I1,4)+1
           I3=MOD(I2,4)+1
           A1=(FY(I2)*FZ(I3)-FY(I3)*FZ(I2))/(FX(I1)*FY(I2)*FZ(I3)-
     /         FX(I1)*FY(I3)*FZ(I2)-FX(I2)*FY(I1)*FZ(I3)+
     /         FX(I3)*FY(I1)*FZ(I2)+FX(I2)*FY(I3)*FZ(I1)-
     /         FX(I3)*FY(I2)*FZ(I1))
           A2=(-FY(I1)*FZ(I3)+FY(I3)*FZ(I1))/(FX(I1)*FY(I2)*FZ(I3)-
     /         FX(I1)*FY(I3)*FZ(I2)-FX(I2)*FY(I1)*FZ(I3)+
     /         FX(I3)*FY(I1)*FZ(I2)+FX(I2)*FY(I3)*FZ(I1)-
     /         FX(I3)*FY(I2)*FZ(I1))
           A3=(FY(I1)*FZ(I2)-FY(I2)*FZ(I1))/(FX(I1)*FY(I2)*FZ(I3)-
     /         FX(I1)*FY(I3)*FZ(I2)-FX(I2)*FY(I1)*FZ(I3)+
     /         FX(I3)*FY(I1)*FZ(I2)+FX(I2)*FY(I3)*FZ(I1)-
     /         FX(I3)*FY(I2)*FZ(I1))
           F(I+8)=A1*(L(I)**3-L(I)**2)+A2*L(I)*L(I1)+A3*L(I)*L(I2)-
     /            L(I)*(2*L(I1)*L(I2)+L(I1)**2+L(I2)**2)
           FX(I+8)=(3*A1*L(I)**2-2*A1*L(I)+A2*L(I1)+A3*L(I2)-
     /            2*L(I1)*L(I2)-L(I1)**2-L(I2)**2)*LX(I)+(A2*L(I)-
     /            2*L(I)*L(I2)-2*L(I1)*L(I))*LX(I1)+(A3*L(I)-
     /            2*L(I)*L(I1)-2*L(I2)*L(I))*LX(I2)
	   FY(I+8)=(3*A1*L(I)**2-2*A1*L(I)+A2*L(I1)+A3*L(I2)-
     /            2*L(I1)*L(I2)-L(I1)**2-L(I2)**2)*LY(I)+(A2*L(I)-
     /            2*L(I)*L(I2)-2*L(I1)*L(I))*LY(I1)+(A3*L(I)-
     /            2*L(I)*L(I1)-2*L(I2)*L(I))*LY(I2)
           FZ(I+8)=(3*A1*L(I)**2-2*A1*L(I)+A2*L(I1)+A3*L(I2)-  
     /            2*L(I1)*L(I2)-L(I1)**2-L(I2)**2)*LZ(I)+(A2*L(I)-
     /            2*L(I)*L(I2)-2*L(I1)*L(I))*LZ(I1)+(A3*L(I)-
     /            2*L(I)*L(I1)-2*L(I2)*L(I))*LZ(I2)
         ENDDO
      END SELECT
      END
