      SUBROUTINE FMM4VLN(X20,Y20,Z20,N20,NIX,NIY,NIZ,AX,AY,AZ,NUID,NINT,
     /     X,Y,Z,NDOLD,NDNEW,IUE,LUE,MUE,MINT,NEOLD,NENEW)
C
C GENEROVANI ELEMENTU SOLID (CTYRSTEN S 8 UZLY) 
C V ZADANEM OBJEMU DEFINOVANEM 8 NEBO 20 BODY (PT).
C
C GENEROVANE ELEMENTY MOHOU MIT RUZNE POCTY UZLU A RUZNY POCET PARAMETRU
C V UZLOVYCH BODECH. JE MOZNE DEFINOVAT TYTO TYPY ELEMENTU NUIDIN:
C  NUID=8, NINT=4   CTYRSTEN S 8 UZLY
C   
C
C PARAMETRY:
C X20(*),Y20(*),Z20(*) - SOURADNICE DEFINICNICH BODU OBJEMU VL,
C               PRVNICH 8 BODU JSOU VRCHOLY A DALSI CTVERICE UPROSTRED STRAN
C N20         - POCET DEFINICNICH BODU (PRIPUSTNA HODNOTA 8)
C NIX,NIY,NIZ - POCET INTERVALU DELICICH STRANY 1,2,3
C AX,AY,AZ    - ZHUSTENI ELEMENTU (FEMDIV, zaporne hodnoty symetricke zhusteni)
C NUID        - ABS(NUID)=POCET UZLU ELEMENTU (NUID<0 UZEL V TEZISTI)
C X(N),Y(N),Z(N)   - SOURADNICE UZLOVYCH BODU
C NDOLD       - NOVE UZLY BUDOU GENEROVANY INDEXEM NDOLD+1 POCINAJE
C               NOVE ODKAZY NA VEKTOR PARAMETRU IPU INDEXEM NDOLD+1 POCINAJE
C NDNEW       - INDEX POSLEDNIHO GENEROVANEHO UZLU (VYSTUPNI PARAMETR)
C IUE(*)      - VEKTOR KONEKTIVITY ELEMENTU
C LUE(*)      - LUE(IE)+I INDEX I-TEHO UZLU ELEMENTU IE.
C               NOVE SE GENERUJI PRVKY LUE(NEOLD+2),...,LUE(NENEW+1)
C MUE(*)     -  NUID (VYUZIVANO PRO GRAFIKU, MUE<0 POSLEDNI UZEL V TEZISTI)
C NEOLD       - NOVE ELEMENTY BUDOU VYTVARENY INDEXEM NEOLD+1 POCINAJE
C NENEW       - INDEX POSLEDNIHO GENEROVANEHO ELEMENTU
C
      PARAMETER (MAXU=300,MAXEL=100000,MAXND=100000)
      DIMENSION X20(*),Y20(*),Z20(*),X(*),Y(*),Z(*),
     /          IUE(*),LUE(*),MUE(*),MINT(*)
      DIMENSION XA(MAXU),YA(MAXU),ZA(MAXU),F(27),FX(27),FY(27),FZ(27)
      LOGICAL XODD,YODD,ZODD
C Kontrola  parametru NUIDIN. PripustnA hodnoty jsou 8,20
C NU=POCET UZLU ELEMENTU
	NU=IABS(NUID)
	NUA=NU-NINT
C POCET DELICICH INTERVALU
         NX=NIX
         NY=NIY
         NZ=NIZ
         NS=1
C KONTROLA ZADAVANYCH PARAMETRU
      IF(NU.NE.8.OR.
     /   NX.LT.1.OR.NY.LT.1.OR.NZ.LT.1.OR.
     /   NX.GE.MAXU.OR.NY.GE.MAXU.OR.NZ.GE.MAXU)RETURN
C VYPOCET VEKTORU BEZROZMERNYCH SOURADNIC DELICICH BODU
      CALL FEMDIV(-1.,1.,XA,NX,AX)
      CALL FEMDIV(-1.,1.,YA,NY,AY)
      CALL FEMDIV(-1.,1.,ZA,NZ,AZ)
      N=NDOLD
C GENEROVANI SOURADNIC UZLU (ISOPARAMETRICKE FUNKCE)
C A INDEXU UZLOVYCH PARAMETRU LPU.
C NEGENERUJI SE UZLY V TEZISTICH ELEMENTU (ANI KDYZ NUID<0)
C---------------------------------------------------------
      ZODD=.FALSE.
	DO IZ=1,NZ+1
	  ZODD=.NOT.ZODD
        YODD=.FALSE.
        DO IY=1,NY+1
	    YODD=.NOT.YODD
          XODD=.FALSE.
          DO IX=1,NX+1
	        XODD=.NOT.XODD
C UZLY MUSI MIT ALESPON DVE SOURADNICE LICHE
            NODD=0
            IF(XODD)NODD=NODD+1
            IF(YODD)NODD=NODD+1
            IF(ZODD)NODD=NODD+1
            IF(NU.EQ.8.OR.NODD.GE.2)THEN
              N=N+1
              IF(N.GT.MAXND)THEN
                WRITE(*,*)' MAX.NODE=',MAXND
                RETURN
              ENDIF
              CALL FDFVL(N20,X20,Y20,Z20,XA(IX),YA(IY),ZA(IZ),
     /                   F,FX,FY,FZ,DET)
              X(N)=0.
              Y(N)=0.
              Z(N)=0.
              DO I=1,N20
                X(N)=X(N)+X20(I)*F(I)
                Y(N)=Y(N)+Y20(I)*F(I)
                Z(N)=Z(N)+Z20(I)*F(I)
             ENDDO
           ENDIF
         ENDDO
       ENDDO
      ENDDO
C GENEROVANI MATICE KONEKTIVITY
C-------------------------------
      NE=NEOLD
      NDZ8=(NX+1)*(NY+1)
      NDY8=NX+1
      DO IZ=1,NZ,NS
        DO IY=1,NY,NS
         DO IX=1,NX,NS
C CTYRSTEN S 8 UZLY, vznika rozdelenim sestistenu na sest ctyrstenu
               LBY0=NDOLD+(IZ-1)*NDZ8+(IY-1)*NDY8
               LBY1=LBY0+NDY8
               LTY0=LBY0+NDZ8
               LTY1=LTY0+NDY8
               NE=NE+1
               MUE(NE)=8
	         MINT(NE)=NINT
               L0=LUE(NE)
C 1. CTYRSTEN 
               IUE(L0+1)=LBY0+IX            
               IUE(L0+2)=LBY0+IX+1           
               IUE(L0+3)=LBY1+IX+1            
               IUE(L0+4)=LTY0+IX+1
	         N=N+1
			 IUE(L0+5)=N
			 X(N)=(X(LBY0+IX)+X(LBY0+IX+1)+X(LBY1+IX+1))/3
	         Y(N)=(Y(LBY0+IX)+Y(LBY0+IX+1)+Y(LBY1+IX+1))/3
	         Z(N)=(Z(LBY0+IX)+Z(LBY0+IX+1)+Z(LBY1+IX+1))/3
	         N=N+1
	         IUE(L0+6)=N
			 X(N)=(X(LBY0+IX+1)+X(LBY1+IX+1)+X(LTY0+IX+1))/3
	         Y(N)=(Y(LBY0+IX+1)+Y(LBY1+IX+1)+Y(LTY0+IX+1))/3
	         Z(N)=(Z(LBY0+IX+1)+Z(LBY1+IX+1)+Z(LTY0+IX+1))/3
               N=N+1
	         IUE(L0+7)=N
			 X(N)=(X(LBY1+IX+1)+X(LTY0+IX+1)+X(LBY0+IX))/3
	         Y(N)=(Y(LBY1+IX+1)+Y(LTY0+IX+1)+Y(LBY0+IX))/3
	         Z(N)=(Z(LBY1+IX+1)+Z(LTY0+IX+1)+Z(LBY0+IX))/3
	         N=N+1
	         IUE(L0+8)=N
			 X(N)=(X(LBY0+IX)+X(LBY0+IX+1)+X(LTY0+IX+1))/3
	         Y(N)=(Y(LBY0+IX)+Y(LBY0+IX+1)+Y(LTY0+IX+1))/3
	         Z(N)=(Z(LBY0+IX)+Z(LBY0+IX+1)+Z(LTY0+IX+1))/3
C 2. CTYRSTEN 
               LUE(NE+1)=L0+NU
			 NE=NE+1
               MUE(NE)=8
	         MINT(NE)=NINT
               L0=LUE(NE)
			 IUE(L0+1)=LBY1+IX+1                     
               IUE(L0+2)=LBY1+IX            
               IUE(L0+3)=LBY0+IX         
               IUE(L0+4)=LTY0+IX
			 N=N+1
	         IUE(L0+5)=N
			 X(N)=(X(LBY1+IX+1)+X(LBY1+IX)+X(LTY0+IX))/3
	         Y(N)=(Y(LBY1+IX+1)+Y(LBY1+IX)+Y(LTY0+IX))/3
	         Z(N)=(Z(LBY1+IX+1)+Z(LBY1+IX)+Z(LTY0+IX))/3
			 N=N+1
	         IUE(L0+6)=N
			 X(N)=(X(LBY1+IX)+X(LTY0+IX)+X(LTY0+IX))/3
	         Y(N)=(Y(LBY1+IX)+Y(LTY0+IX)+Y(LTY0+IX))/3
	         Z(N)=(Z(LBY1+IX)+Z(LTY0+IX)+Z(LTY0+IX))/3            
	         N=N+1
	         IUE(L0+7)=N
			 X(N)=(X(LTY0+IX)+X(LTY0+IX)+X(LBY1+IX+1))/3
	         Y(N)=(Y(LTY0+IX)+Y(LTY0+IX)+Y(LBY1+IX+1))/3
	         Z(N)=(Z(LTY0+IX)+Z(LTY0+IX)+Z(LBY1+IX+1))/3
	         N=N+1
	         IUE(L0+8)=N
			 X(N)=(X(LBY1+IX+1)+X(LBY1+IX)+X(LTY0+IX))/3
	         Y(N)=(Y(LBY1+IX+1)+Y(LBY1+IX)+Y(LTY0+IX))/3
	         Z(N)=(Z(LBY1+IX+1)+Z(LBY1+IX)+Z(LTY0+IX))/3
C 3. CTYRSTEN 
			 LUE(NE+1)=L0+NU
			 NE=NE+1
               MUE(NE)=8
	         MINT(NE)=NINT
               L0=LUE(NE)
               IUE(L0+1)=LBY1+IX+1          
               IUE(L0+2)=LTY0+IX            
               IUE(L0+3)=LTY0+IX+1            
               IUE(L0+4)=LBY0+IX
	         N=N+1
	         IUE(L0+5)=N
			 X(N)=(X(LBY1+IX+1)+X(LTY0+IX)+X(LTY0+IX+1))/3
	         Y(N)=(Y(LBY1+IX+1)+Y(LTY0+IX)+Y(LTY0+IX+1))/3
	         Z(N)=(Z(LBY1+IX+1)+Z(LTY0+IX)+Z(LTY0+IX+1))/3
	         N=N+1
	         IUE(L0+6)=N
			 X(N)=(X(LTY0+IX)+X(LTY0+IX+1)+X(LBY0+IX))/3
	         Y(N)=(Y(LTY0+IX)+Y(LTY0+IX+1)+Y(LBY0+IX))/3
	         Z(N)=(Z(LTY0+IX)+Z(LTY0+IX+1)+Z(LBY0+IX))/3
			 IUE(L0+7)=N-7
	         IUE(L0+8)=N-3
C 4. CTYRSTEN 
			 LUE(NE+1)=L0+NU
			 NE=NE+1
               MUE(NE)=8
	         MINT(NE)=NINT
	         L0=LUE(NE)
               IUE(L0+1)=LTY1+IX            
               IUE(L0+2)=LTY1+IX+1            
               IUE(L0+3)=LTY0+IX+1             
               IUE(L0+4)=LBY1+IX+1
	         N=N+1
	         IUE(L0+5)=N
			 X(N)=(X(LTY1+IX)+X(LTY1+IX+1)+X(LTY0+IX+1))/3
	         Y(N)=(Y(LTY1+IX)+Y(LTY1+IX+1)+Y(LTY0+IX+1))/3
	         Z(N)=(Z(LTY1+IX)+Z(LTY1+IX+1)+Z(LTY0+IX+1))/3
			 N=N+1
	         IUE(L0+6)=N
			 X(N)=(X(LTY1+IX+1)+X(LTY0+IX+1)+X(LBY1+IX+1))/3
	         Y(N)=(Y(LTY1+IX+1)+Y(LTY0+IX+1)+Y(LBY1+IX+1))/3
	         Z(N)=(Z(LTY1+IX+1)+Z(LTY0+IX+1)+Z(LBY1+IX+1))/3            
	         N=N+1
			 IUE(L0+7)=N
	         X(N)=(X(LTY0+IX+1)+X(LBY1+IX+1)+X(LTY1+IX))/3
	         Y(N)=(Y(LTY0+IX+1)+Y(LBY1+IX+1)+Y(LTY1+IX))/3
	         Z(N)=(Z(LTY0+IX+1)+Z(LBY1+IX+1)+Z(LTY1+IX))/3
	         N=N+1
			 IUE(L0+8)=N
			 X(N)=(X(LTY1+IX)+X(LTY1+IX+1)+X(LBY1+IX+1))/3
	         Y(N)=(Y(LTY1+IX)+Y(LTY1+IX+1)+Y(LBY1+IX+1))/3
	         Z(N)=(Z(LTY1+IX)+Z(LTY1+IX+1)+Z(LBY1+IX+1))/3
C 5. CTYRSTEN 
			 LUE(NE+1)=L0+NU
			 NE=NE+1
               MUE(NE)=8
	         MINT(NE)=NINT
	         L0=LUE(NE)
               IUE(L0+1)=LBY1+IX+1       
               IUE(L0+2)=LTY1+IX          
               IUE(L0+3)=LBY1+IX             
               IUE(L0+4)=LTY0+IX
	         N=N+1
	         IUE(L0+5)=N
			 X(N)=(X(LBY1+IX+1)+X(LTY1+IX)+X(LBY1+IX))/3
	         Y(N)=(Y(LBY1+IX+1)+Y(LTY1+IX)+Y(LBY1+IX))/3
	         Z(N)=(Z(LBY1+IX+1)+Z(LTY1+IX)+Z(LBY1+IX))/3
			 N=N+1
	         IUE(L0+6)=N
			 X(N)=(X(LTY1+IX)+X(LBY1+IX)+X(LTY0+IX))/3
	         Y(N)=(Y(LTY1+IX)+Y(LBY1+IX)+Y(LTY0+IX))/3
	         Z(N)=(Z(LTY1+IX)+Z(LBY1+IX)+Z(LTY0+IX))/3  
	         IUE(L0+7)=N-8
			 N=N+1
			 IUE(L0+8)=N
			 X(N)=(X(LBY1+IX+1)+X(LTY1+IX)+X(LTY0+IX))/3
	         Y(N)=(Y(LBY1+IX+1)+Y(LTY1+IX)+Y(LTY0+IX))/3
	         Z(N)=(Z(LBY1+IX+1)+Z(LTY1+IX)+Z(LTY0+IX))/3
C 6. CTYRSTEN 
			 LUE(NE+1)=L0+NU
			 NE=NE+1
	         MINT(NE)=NINT
               MUE(NE)=8
	         L0=LUE(NE)
               IUE(L0+1)=LBY1+IX+1           
               IUE(L0+2)=LTY0+IX         
               IUE(L0+3)=LTY0+IX+1       
               IUE(L0+4)=LTY1+IX
	         IUE(L0+5)=N-8
			 N=N+1
	         IUE(L0+6)=N
			 X(N)=(X(LTY0+IX)+X(LTY0+IX+1)+X(LTY1+IX))/3
	         Y(N)=(Y(LTY0+IX)+Y(LTY0+IX+1)+Y(LTY1+IX))/3
	         Z(N)=(Z(LTY0+IX)+Z(LTY0+IX+1)+Z(LTY1+IX))/3  
			 IUE(L0+7)=N-6
			 IUE(L0+8)=N-1
			 LUE(NE+1)=L0+NU 
             IF(NE.GT.MAXEL)THEN
              WRITE(*,*)' MAX.ELEMENTS=',MAXEL
              RETURN
            ENDIF
          ENDDO
        ENDDO
      ENDDO
	NDNEW=N
	WRITE(10,*)' NODES GENERATED ND=',N
      NENEW=NE
      END

