C* Backmixing using FEM. Response CN $PBMIX.BMP
C* placed into 2nd column of MOP.
C* Only BATCH (do not use MACRO)
C*
C* Chapter 2.2.10. page 86 User manual
C*
C* F-flowrate backmixing, V-volume of 1 vessel
C* G-flowrate (inlet)
C* N-number of units (vessels)
C* 
C* Unit consists of PIPE+CSTR+PUMP, defined
C* parametrically (length of unit is H).
C* Flowrate of pump is defined by function
C* FUNDEF 1,F, referenced in EGROUP of pump.
C* N-units are generated by loops.
C*
C* Tested by Zitny 12.9.2004
C*
C* Remark: VOLFLOW=1 volumetric balances are
C*         used instead of default mass balances.
C*
VOLFLOW=1
H=0.1
N=4
G=0.005
V=1
F=0.001
T=N*V/G*3
L=300
W=T/L
INIFEM
VISC(1)=0.1
EGROUP 3,PIPE2D,1,0,0; transient(1), circular pipe(0)
RCONST 3,PIPE2D,0.01;  diameter of pipe 0.01 m
ND 0,0
ND H,0
E 2,1,2; element with 2 nodes, from nodes 1,2
EGROUP 2,PUMP,1,-1,1,0;
RCONST 2,PUMP,0,0,0,.001,.0001,0,0.01;
EGROUP 1,CSTR,1,0,0;
RCONST 1,CSTR,0.01,V,0,0,1,0,0,0;
X=H
#LOOP LAB,N
K=ND
ND X+H,0;
ACTSET 1,1; activate CSRT type
ACTSET 3,1; activate CSTR constants
E 2,K,K+1; generate CSTR
X=X+2*H
ND X,0
ACTSET 1,3; activate PIPE type
ACTSET 3,3; activate PIPE constants
E 2,K+1,K+2; generate PIPE
#LABEL LAB
X=H
K=1
#LOOP LABK,N-1
ND X,H
ACTSET 1,3
ACTSET 3,3
E 2,2*N+K+2,2*K
ACTSET 1,2; activate PUMP type
ACTSET 3,2; activate PUMP constants
E 2,2*K+3,2*N+K+2
K=K+1
X=X+2*H
#LABEL LABK 
FUNDEF 1,F; backmixing (flowrate)
CURDEF -2,0,5,0,1,W,1,2*W,1,3*W,0,T,0
K=2*N+2
FND 1,PRES,2,G; flowrate at inlet
FND K,PRES,-1,0; zero pressure at outlet
FND 1,CN,-2,1; impulse function (-2) at inlet
C* start calculation with zero F
A=F
F=0
SOLVE 0,1,1,0,0,30,0,0,0;
F=A
SOLVE 0,1,1,1,0,30,0,0,0;
SOLVE 0,L,W,1,0,0,0,1,0;
TSTEP L,W
J=0
#LOOP L1,L
J=J+1
C1(J)=W*(J-1)
LTN C1(J); load solution from time C1(j)
C2(J)=V3(LPU(CN)+K)
#LABEL L1
NORM 2,2,0
C* Look at the results using GTC.
C* Impulse response can be calculated also by GTIME
