C* PRESP0.GEO $PRESP0.BMP
C* Impulse response of a straight pipe (PIPE2D).
C* Responses are calculated by MWR (HEPI=0) and 
C* by method of characteristics (HEPI=2).
C* Loops are used for reloading concentration
C* to selected column of MOP:
C*
C*   Column 3: method of characteristics (HEPI=2)
C*   Column 4: Galerkin Petrov (upwind)
C*   Column 5: Galerkin method (withou upwind)
C*
C* Tested by Zitny  16.9.2004
C*
H=1
R=0.01
U=0.1
W=3*H/U
C* M=50
C* L=400
C* HEPI=2
C* TAUD=1E-9
VALUE M
VALUE L
VALUE TAUD
C* DN(1)=1e-6 (for example)
VALUE DN(1)
PT 1,0,0;
PT 2,H,0;
CR2PT 1,1,2;
CURDEF -1,0,4,0,0,W/L,1,2*W/L,1,3*W/L,0,W,0;
C*
C* 1D problem (columns 2-7)
C*
INIFEM
SCALE -.500E-02,.101E+01,-.500E-04,.101E-01;
EGROUP 1,PIPE2D,1,0,0;
RCONST 1,PIPE2D,0.02,.100E-03,0,1E-3,0,0,0,0,0,0;
MCR 1,M,1,2,1,0,1;
NFPT 2,PRES,-1,0;
FUNDEF -2,A;
NFPT 1,PRES,-2,1;
A=8
SOLVE .375E+00,1,.750E-01,0,0,4,0,0,0;
NFPT 1,CN,-1,1;
INITIA CN,0;
HEPI=2
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB4,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB4;
NORM 2,3,0;
HEPI=0
UPW=1
RUPW=1
INITIA CN,0;
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB5,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB5;
NORM 2,4,0;
UPW=0
RUPW=0
INITIA CN,0;
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB6,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB6;
NORM 2,5,0;
NORM 2,2,0
C* Uset GTC to see responses