C* $POHMICB.BMP
C* Continuous direct ohmic heating (2 parallel streams downward,
C*      central heated stream flowing upward).
C* 1D model using PIPE2D and HEXC.
C* Time variable hydraulic resistance 
C* in the left channel is used for 
C* the stability analysis (short time disturbance).
C* 
C* Pressures, flowrates, temperatures and
C* tracer concentration response to a short
C* pulse are calculated.
C* 
C* Boussinesque approx. is used for buoyancy
C*
C*
S 1;       set full menu
ANALYS 1;  set degree of freedom for 1D problems
scale -0.05,0.1,-0.1,0.8;
PT 1,  .39E-01,  .7E+00,0;   inlet
PT 2,  .39E-01,  .65E+00,0;
PT 3,  .1E-01,  .585E+00,0;
PT 4,  .1E-01,  .58E+00;
PT 5,  .1E-01,  .3E-01;
PT 6,  .1E-01,  .15E-01;
PT 7,  .39E-01,  .15E-01;
PT 8,  .39E-01,  .3E-01;
PT 9,  .39E-01,  .58E+00;
PT 10, .39E-01,  .585E+00;  outlet
PT 11, .68E-01,  .15E-01;
PT 12, .68E-01,  .3E-01;
PT 13, .68E-01,  .58E+00;
PT 14, .68E-01,  .585E+00;
CR2PT 1,1,2;   inlet pipe
CR2PT 2,2,3;   left arm
CR2PT 3,3,4;   short pipe representing variable flow resistance
CR2PT 4,5,4;   left channel (preheater)
CR2PT 5,5,6;   left channel (at bottom)
CR2PT 6,6,7;   bottom left
CR2PT 7,7,11;  bottom right
CR2PT 8,11,12; right channel (at bottom)
CR2PT 9,12,13; right channel (preheater)
CR2PT 10,13,14; short pipe at right channel
CR2PT 11,14,2; right arm
CR2PT 12,7,8;  central channel (at bottom)
CR2PT 13,8,9;  central channel (heater)
CR2PT 14,9,10; central channel (outlet)
c* EGROUP: No1-circular inlet, No2-valve, No3-others
EGROUP 1,PIPE2D,1,1,0,0,0,0,0,0,0,0,0;   inlet pipe (0-circular cross section)
EGROUP 2,PIPE2D,1,2,10,0,0,0,0,0,0,0,0;  pipe (2-rectangular, 10-variable hydraulic)
EGROUP 3,PIPE2D,1,2,0,0,0,0,0,0,0,0,0;   pipe (2-rectangular)
EGROUP 4,CSTR,1,2,0,0,0,0,0,0,0,0,0;     mixed vessel (mixing streams at bottom)
EGROUP 5,HEXC,1,1;  heat exchanger (parallel channels)
C* MPROP 1,CSTR,0.6,0,4200,0,998,0,0.04,0,0.21E+12,0,0.28,0,0.001,0,0.005,0,0.1E-8,0,0.1E-8,0,0.1E-8,0,0,0,0,0,0,0,0,0;
MPROP 1,CSTR,0.6,0,4200,0,998,0,0.04,0,0.21E+12,0,0.28,0,0.001,0,0.001,0,0.1E-8,0,0.1E-8,0,0.1E-8,0,0,0,0,0,0,0,0,0;
RCONST 1,PIPE2D,.200E-01,0,0,0,10,20,0,0,0,0,0,0,0,0,0,0,0;
RCONST 2,PIPE2D,0.03175,0,0,0,10,20,1.54E-3,0.194,0,0,0,0,0,0,0,0,0;
RCONST 3,PIPE2D,0.03175,0,0,0,10,20,1.54E-3,0.194,0,0,0,0,0,0,0,0,0;
RCONST 4,CSTR,0.04318,0,10,20,9.009E-5,2.21E-3,0.214,0;
RCONST 5,PIPE2D,0.04521,0,0,0,10,20,2.464E-3,0.218,0,0,0,0,0,0,0,0,0;
RCONST 6,PIPE2D,0.04521,0,0,0,10,20,2.464E-3,0.218,6300,0,0,0,0,0,0,0,0;
RCHEX 7,0.077,5000;
C* activate 
ACTSET 1,1;  activate EG=1 (circular pipes) 
MCR 1,2,1,2,1,0,1; cr1=1,elements=2,Last/first=1,Nodes=2,RC=1,
ACTSET 1,3;  activate EG-3 (rectangular cross section)
MCR 2,2,1,2,2,0,1;  RC=2
MCR 3,2,1,2,3,0,1;  RC=3
MCR 4,10,1,2,3,0,1; RC=3 ten elements left
MCR 5,2,1,2,3,0,1;  RC=3
MCR 6,1,1,2,4,0,1;  RC=4
MCR 7,1,1,2,4,0,1;  RC=4
MCR 8,2,1,2,3,0,1;  RC=3
MCR 9,10,1,2,3,0,1; RC=3 ten elements right
MCR 10,2,1,2,3,0,1; RC=3
MCR 11,2,1,2,2,0,1; RC=2
MCR 12,2,1,2,5,0,1; RC=6
MCR 13,10,1,2,6,0,1;RC=6 ten elements central
MCR 14,2,1,2,5,0,1; RC=5
NMERGE ;
ERMEL 4,2,2,1; change element type in the left arm to variable resistance 
ERMEL 19,4,4,1; change element type from PIPE to CSTR at bottom
ERMEL 20,4,4,1; change element type from PIPE to CSTR at bottom
MCR4 4,13,7,5;
MCR4 13,9,7,5;
NFPT 1,PRES,3,0.0247; flowrate at inlet [kg/s]
NFPT 10,PRES,-1,0;  zero pressure at outlet
NFPT 1,TEMP,-1,20;  inlet temperature
NFPT 1,CN,-2,1; inlet concentration defined by function -2
CURDEF -2,0,4,0,0,1,1,2,0,3,0;
CURDEF 10,0,5,0,1,0.5,0.1,10,0.1,10.5,1,100,1; 
FUNDEF 1,TREF;  initial temperature
FUNDEF 2,1-0.00033*TEMP; not used when Boussinesque method is selected
TREF=20
OHMI=1
GY=-9.81
BUOY=2
TAUD=0.001
BL=0.1
UPW=1
RUPW=1
INITIA CN,0; zero concentration at time zero
INITIA TEMP,1;
solve 0,300,0.5,0,0,4,1,1; simulation up to 150 seconds