C* $RPASERI.BMP
C* Identification of parameters A,B,C,D,E
C* of model RPAS.GEO by OPTIMA or SOMA.
C*
C* In this session file an artificial impulse
C* response (parallel series of 1.5 and 5 tanks)
C* is calculated, noised and put into the 3rd
C* column of MOP. Unit weights are put into the
C* column 4.
C*
C* As model parameters the user variables A,B,...,E
C* are defined and the 2nd column of MOP is selected
C* for model prediction (impulse response coresponding
C* to actual values A,B,...,E).
C* Model is opened on unit 7 as RPAS.GEO.
C* 
C* Optimisation must be carried out interactively,
C* you can process this file as a MACRO!! (recommendend).
C*
C* Tested by Zitny 17.9.2004
C*
TSTEP 200,0.03;  maximum time 6 seconds
PASERI 3,1.5,6,.500E+00,.5,1; impulse response into 3rd column 
TCRND 3,3,1,.100E+00;  randomise impulse response (simulated data)
TCRND 3,3,0,.05;
PARDEF 5,A,B,C,D,E;  model parameters used in RPASERI2.GEO
PARLIM .1,3,3,10,.1,.9,.1,.9,.1,5; range of parameters
PARFIT 1,2,1,5,2,1,.7,2,1,.7,2,1,1.3,1,1; initial estimates and methods
COMPAR 1,1,200,2,3,4; comparison of columns 2 (prediction) and 3 (data), C4 are weights
TCFUN C4=1;
MOP rpaseri2.geo; optimised model should be assigned to unit=7
OPTIMA 7,3; 3 iterations using Marquardt Levenberg method
C* write OPTIMA or SOMA