C* Parallel channels separated by wall.
C* Purpose of this solution is to verify the case,
C* when elements FLOW2D and PLANE2D are combined and
C* how the heat is transferred at their interface.
C*
C* FLOW is solved by UVP method.
C* ---------------------------------------------------
C* Inlet temperature at left channel=100 C, right 10 C
C* Heat transfer is prescribed along the left channel
C* Tracer CN injection into the left channel (impulse)
C* ---------------------------------------------------
C* 
C* Tested by Zitny 1.9.2004
C*
ANALYS 2;
PT 1,.000E+00,.000E+00;
PT 2,.300E+00,.000E+00;
CR2PT 1,1,2;
PT 3,.500E+00,.000E+00;
CR2PT 2,2,3;
PT 4,.800E+00,.000E+00;
CR2PT 3,3,4;
PT 5,.800E+00,.100E+01;
CR2PT 4,4,5;
PT 6,.500E+00,.100E+01;
CR2PT 5,5,6;
PT 7,.300E+00,.100E+01;
CR2PT 6,6,7;
PT 8,.000E+00,.100E+01;
CR2PT 7,7,8;
PT 9,.000E+00,.000E+00;
CR2PT 8,8,9;
CR2PT 9,2,7;
CR2PT 10,3,6;
SFCR 1,1,9;
PMERGE ;
SFCR 1,1,9;
SFCR 2,3,4;
SFCR 3,2,10;
C* Auxiliary curves for plotting profiles
PT 9,.000E+00,.400E+00;
PT 10,.800E+00,.400E+00;
PT 11,.000E+00,.900E+00;
PT 12,.800E+00,.900E+00;
PT 13,.000E+00,.100E+00;
PT 14,.800E+00,.100E+00;
PT 15,.500E+00,.400E+00;
PT 16,.400E+00,.000E+00;
PT 17,.400E+00,.100E+01;
CR2PT 14,16,17;
CR2PT 11,13,14;
CR2PT 12,9,10;
CR2PT 13,11,12;
EGROUP 1,FLOW2D,1,7,0,1,0,0,0,0,0,0,0,0;
RCONST 1,FLOW2D,1,0,0,0,0,0;
C* Recommended values 20 x 10
VALUE M
VALUE N
MSF 1,m,n,1,1,6,0;
MSF 2,m,n,1,1,6,0;
EGROUP 2,PLANE2D,1,7,0,0,0,0,0,0,0,0,0,0;
RCONST 2,PLANE2D,1,0,0,0,0,0;
MSF 3,m,n,1,1,6,0;
NMERGE ;
NFCR 5,VY,-1,-0.01,-0.01;
NFCR 7,VY,-1,-.100E-01,-.100E-01;
NFCR 9,VX,-1,0,0;
NFCR 9,VY,-1,0,0;
NFCR 10,VY,-1,0,0;
NFCR 10,VX,-1,0,0;
NFCR 8,VX,-1,0,0;
NFCR 8,VY,-1,0,0;
NFCR 4,VY,-1,0,0;
NFCR 4,VX,-1,0,0;
NFCR 7,VX,-1,0,0;
NFCR 5,VX,-1,0,0;
VISC(1)=0.01
C* time step
VALUE T
SOLVE 0,10,T,0,0,10,0,0,0,0,0;
NFCR 8,TEMP,21,100,100;
TE(1)=20
NFCR 7,TEMP,-1,100,100;
NFCR 5,TEMP,-1,10,10;
SOLVE 0,10,T,0,0,0,1,0,0,0,0;
C* Tracer injection
CURDEF -2,0,4,0,1,3*T,1,4*T,0,5*T,0;
NFCR 7,CN,-2,1,1;
SOLVE 0,10,T,0,0,0,0,1,0,0,0;
