C* Planar channel with step,symmetry
C*
C* Chapter 2.2.6.1. page 57-59 user manual
C*
C* UVP method,Transient case, cartesian c.s.
C* Arbitrary elements with spec.number of nodes.
C* ---------------------------------------------
C* u=0.002, h=0.1 Re=200
C* ---------------------------------------------
C*
C* Tested by Zitny 5.9.2004
C*
ANALYS 2;
C* (M * N) inlet, (L * N) bottom, (L * K) top
C* M=N=5 L=20 K=15
VALUE M
VALUE N
VALUE L
VALUE K
SCALE -.500E-02,12,-.500E-02,.6;
PT 1,.000E+00,.000E+00;
PT 2,.000E+00,.100E+00;
PT 3,.100E+01,.100E+00;
PT 4,.100E+01,.000E+00;
PT 5,1.100E+01,.000E+00;
PT 6,1.100E+01,.100E+00;
PT 7,1.100E+01,.500E+00;
PT 8,.100E+01,.500E+00;
SF4PT 1,1,4,3,2;
SF4PT 2,4,5,6,3;
SF4PT 3,3,6,7,8;
EGROUP 1,FLOW2D,1,7,0,UVP,0;
C* Topology of elements J,I
C* J=-4 I=1 midside nodes triangle (discontinuous pressure)
C* J=6  I=0 midside nodes for veloc. and continuous pressure
VALUE J
VALUE I
MSF 1,M,N,1,1,J,I;
MSF 2,L,N,1.5,1,J,I;
MSF 3,L,K,1.5,-1.5,J,I;
NMERGE ;
FUNDEF -4,0.000375*(1-100*YY**2);
NFCR 4,VX,-4,1,1;
NFCR 4,VY,-1,0,0;
NFCR 1,VY,-1,0,0;
NFCR 5,VY,-1,0,0;
NFCR 3,VY,-1,0,0;
NFCR 10,VY,-1,0,0;
NFCR 9,VY,-1,0,0;
NFCR 3,VX,-1,0,0;
NFCR 10,VX,-1,0,0;
NFCR 9,VX,-1,0,0;
OPTION 0,0,0,0,1,0,0,15,.100E-11,1,.100E+08,1,.100E-04,.100E-04,0,3,0,0,0;
C* 5-time steps
SOLVE 0,5,1000,0,0,5;
