C* Laminar flow in Y-branch using UVP
C*
C* Chapter 2.2.6.3. page 60, User manual
C*
C* --------------------------------
C* Inlet H=0.8m Vx=1.25 m/s
C* Visc=10 Dens=1000, Re=200
C* L=5 m
C* FUNDEF 1,DOF(vx,2,x,y,z)
C* --------------------------------
C*
C* Tested by Zitny 5.9.2004
C*
ANALYS 2;
FUNDEF 1,DOF(VX,2,XX,YY,ZZ)
C* Recommended value M=10
VALUE M
C* Recommended value N=10
VALUE N
C* Recommended value K=20
VALUE K
PT 1,.100E+00,.100E+00;
PT 2,.800E+00,.100E+00;
PT 3,.500E+01,.000E+00;
PT 4,.100E+00,.500E+00;
PT 5,.800E+00,.400E+00;
PT 6,.500E+01,.300E+00;
PT 7,.500E+01,.600E+00;
PT 8,.100E+00,.900E+00;
PT 9,.800E+00,.900E+00;
PT 10,.500E+01,.100E+01;
SF4PT 1,1,2,5,4;
SF4PT 2,2,3,6,5;
SF4PT 3,4,5,9,8;
SF4PT 4,5,7,10,9;
C* Gauss points
VALUE G
EGROUP 1,FLOW2D,0,G,0,UVP,0;
C* Kind of elements J (outer), I (inner)
VALUE J
VALUE I
MSF 1,M,N,1,1,J,I;
MSF 2,K,N,3,1,J,I;
MSF 3,M,N,1,1,J,I;
MSF 4,K,N,3,1,J,I;
CR2PT 14,1,8;
NMERGE ;
NFCR 14,VX,-1,1.25,1.25,1.25;
NFCR 14,VY,-1,0,0,0;
NFCR 1,VX,-1,0,0,0;
NFCR 1,VY,-1,0,0,0;
NFCR 5,VY,-1,0,0,0;
NFCR 5,VX,-1,0,0,0;
NFCR 7,VX,-1,0,0,0;
NFCR 7,VY,-1,0,0,0;
NFCR 11,VY,-1,0,0,0;
NFCR 11,VX,-1,0,0,0;
NFCR 13,VX,-1,0,0,0;
NFCR 13,VY,-1,0,0,0;
NFCR 9,VY,-1,0,0,0;
NFCR 9,VX,-1,0,0,0;
VISC(1)=10
BOX 0.3;
C* Number of iterations
VALUE I
SOLVE 0,2,20,0,0,I,0,0,0,0,0;
INTGCR 12,1;
INTGCR 6,1;
INTGCR 14,1;