C* Identification of axial dispersion model
C* parameter TAUD by comparing impulse response
C* with 2D solution. The solution proceeds
C* in the following steps:
C*
C* PIPEOPT1.GEO - reads impulse response from file
C*      PIPEOPT.DAT (response calculated by 2D
C*      program TRPIPE.GEO is in 10th column of MOP).
C*      Simple 1D mesh is defined and solved for flow.
C*      Parameter TAUD is defined for optimisation,
C*      and model PIPEOPT2.GEO opened.
C* PIPEOPT2.GEO - SOLVE transient for TAUD. 
C*      Results are transferred to the third column
C*      of MOP (also first column-time with time step
C*      0.5s up to time 30s, is calculated)
C* ----------------------------------------------
C*  Length H=1m, R=0.01m, mean velocity=0.1 m/s,
C*  mean residence time 10s, Diffusion coef=1e-7
C* ----------------------------------------------
C* 
C* Tested by Zitny 10.9.2004
C* 
C* 
R 6,PIPEOPT.DAT
H=1
R=0.01
U=0.1
W=3*H/U
L=120
PT 1,0,0;
PT 2,H,0;
CR2PT 1,1,2;
UPW=1
RUPW=1
CURDEF -1,0,4,0,0,W/L,1,2*W/L,1,3*W/L,0,W,0;
C*
C* 1D problem columns 3)
C*
NE=0
ND=0
SCALE -.500E-02,.101E+01,-.500E-04,.101E-01;
EGROUP 1,PIPE2D,1,0,0;
RCONST 1,PIPE2D,0.02,.100E-03,0,1E-3,0,0,0,0,0,0;
MCR 1,30,1,2,1,0,1;
NFPT 2,PRES,-1,0;
FUNDEF -2,A;
NFPT 1,PRES,-2,1;
A=8
SOLVE .375E+00,1,.750E-01,0,0,4,0,0,0;
NFPT 1,CN,-1,1;
DN(1)=1E-7
PARDEF 1,TAUD;
PARLIM 0.1,20;
PARFIT 10,3,1;
COMPAR 1,1,60,3,10,0;
OPEN 7,PIPEOPT2.GEO;
C* Now you can start OPTIMA or SOMA