C* Continuous direct ohmic heating
C* 1D model using PIPE2D and HEXC.
C* Time variable hydraulic resistance
C* in the left channel is used for
C* stability analysis.
C*
C* Pressures, flowrates, temperatures and
C* tracer concentration response to a short
C* pulse are calculated.
C*
C* Boussinesque approx. is used for buoyancy
C* Mass balancig (VOLFLOW=0) method is used.
C*
C* Tested by Zitny 12.9.2004
C*
ANALYS 1
SCALE 0,.3,-.1,1;
PT 1,  .100E+00,  8.00E-01;
PT 2,  .100E+00,  7.50E-01;
PT 3,  .700E-01,  6.90E-01;
PT 4,  .700E-01,  5.90E-01;
PT 5,  .700E-01,  2.10E-02;
PT 6,  .700E-01,  0.00E+00;
PT 7,  .100E+00,  0.00E+00;
PT 8,  .100E+00,  2.10E-02;
PT 9,  .100E+00,  5.90E-01;
PT 10, .100E+00,  6.90E-01;
PT 11, .130E+00,  0.00E+00;
PT 12, .130E+00,  2.10E-02;
PT 13, .130E+00,  5.90E-01;
PT 14, .130E+00,  6.90E-01;
CR2PT 1,1,2;
CR2PT 2,2,3;
CR2PT 3,3,4;
CR2PT 4,5,4;
CR2PT 5,5,6;
CR2PT 6,6,7;
CR2PT 7,7,11;
CR2PT 8,11,12;
CR2PT 9,12,13;
CR2PT 10,13,14;
CR2PT 11,14,2;
CR2PT 12,7,8;
CR2PT 13,8,9;
CR2PT 14,9,10;
C* MCRC CRfirst,n,last/first,nodes,RC-group, CRlast,step
C* e.g.   1     2     1        2      1        1      1
MCRC   1,2,1,2,1,1;
ACTSET 3,2;
MCRC   2,2,1,2,2;
MCRC   3,2,1,2,3;
MCRC   4,10,1,2,3;
MCRC   5,2,1,2,3;
MCRC   6,2,1,2,4;
MCRC   7,2,1,2,4;
MCRC   8,2,1,2,3;
MCRC   9,10,1,2,3;
MCRC   10,2,1,2,3;
MCRC   11,2,1,2,2;
MCRC   12,2,1,2,5;
MCRC   13,10,1,2,6;
MCRC   14,2,1,2,5;
NMERGE ;
C* Change EGROUP 3 at element number 4 in the left branch-time variable
C* hydraulic characteristic defined by function 10 (MPROP and RCONST without changes)
ERMEL 4,3,2,1;
EGROUP 1,PIPE2D,1,0,0,0,0,0,0,0,0,0,0;
MPROP 1,PIPE2D,.600E+00,0,4200,0,998,0,.400E-01,0,.210E+12,0,.280E+00,0,.100E-02,0,.500E-03,0,.100E-08;
EGROUP 2,HEXC,1;
EGROUP 3,PIPE2D,1,0,10,0,0,0,0,0,0,0,0;
C* Generation of heat exchangers in both paralel branches 4-13 a 13-9
C* MCR4 cr1,cr2,RCONST,EGROUP
MCR4 4,13,7,2;
MCR4 13,9,7,2;
C* RCONST 1-inlet pipe 2-branching 3-parallel channels 4-bottom
C*        5-central channel without heating 6-vert.channel with heating 
C*        7-heat exchangers
RCONST 1,PIPE2D,0.02,0,0,0,10,20;
RCONST 2,PIPE2D,0.02,0,0,0,10,20;
RCONST 3,PIPE2D,0.02918,0,0,0,10,20,0.0014,0.19;
RCONST 4,PIPE2D,0.033,0,0,0,10,20,0.0016,0.21;
RCONST 5,PIPE2D,0.051,0,0,0,10,20,0.00291,0.23;
RCONST 6,PIPE2D,0.051,0,0,0,0,0,0.00291,0.23,6.3E3;
RCHEX 7,.6,5000;
C* Zero pressure at outlet, inlet flowrate 65ml/s.
C* Flowrate must be specified in kg/s!!!
NFPT 10,PRES,-1,0;
NFPT 1,PRES,3,.065;
NFPT 1,TEMP,-1,20;
NFPT 1,CN,-2,1;
C* Table -2 Time course of tracer concentration at inlet CN(time)
C* Table 10 Hydraulic characteristics in element in the left branch
C*          Duration of disturbance (10-time increased resistance) is 10s
C* Function 1   Initial temperature
C* Function 2   Temperature depencence of density (not used in case of BUOY=2)
CURDEF -2,0,4,0,0,1,1,2,0,3,0;
CURDEF 10,0,5,0,1,.5,.1,10,.1,10.5,1,100,1;
FUNDEF 1,TREF
FUNDEF 2,1-0.00033*TEMP
TREF=20
OHMI=1
GY=-9.81
C* BUOY=1 temperature dependent density, =2 Boussinesq method
BUOY=2;
TAUD=0.001;  axial dispersion model parameter
BL=.1;       thermal boundary layer thickness reduction
UPW=1;       upwind enabled
RUPW=1
INITIA CN,0; 
INITIA TEMP,1;
DSOLVE 0,200,.5,0,0,10,1,1,0;
