C* PRESP1.GEO 
C* Impulse response of CN in a straight pipe.
C* It is possible to select weighted residual
C* method or method of characteristics (HEPI>1).
C* Loops are used for reloading responses to
C* different columns of MOP:
C*
C*    column 2:   D=1e-9  galerkin
C*    column 3:   D=1e-8  galerkin
C*    column 4:   D=1e-6  galerkin
C*    column 5:   D=1e-9  galerkin-petrov
C*    column 6:   D=1e-8  galerkin-petrov
C*    column 7:   D=1e-7  galerkin-petrov
C*
C* Tested by Zitny 16.9.2004
C*
H=1
R=0.01
U=0.1
W=3*H/U
C* recommended M=50
VALUE M
C* recommended L=400
VALUE L
C* HEPI=2 method of characteristics
VALUE HEPI
C* TAUD=1E-9 time constant of dispersion
VALUE TAUD
PT 1,0,0;
PT 2,H,0;
CR2PT 1,1,2;
UPW=1
RUPW=1
CURDEF -1,0,4,0,0,W/L,1,2*W/L,1,3*W/L,0,W,0;
C*
C* 1D problem (columns 2-7)
C*
INIFEM
SCALE -.500E-02,.101E+01,-.500E-04,.101E-01;
EGROUP 1,PIPE2D,1,0,0;
RCONST 1,PIPE2D,0.02,.100E-03,0,1E-3,0,0,0,0,0,0;
MCR 1,M,1,2,1,0,1;
NFPT 2,PRES,-1,0;
FUNDEF -2,A;
NFPT 1,PRES,-2,1;
A=8
SOLVE .375E+00,1,.750E-01,0,0,4,0,0,0;
NFPT 1,CN,-1,1;
DN(1)=1E-7
INITIA CN,0;
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB4,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB4;
NORM 2,2,0;
TCFUN C7=C2;
DN(1)=1E-8
INITIA CN,0;
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB5,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB5;
NORM 2,2,0;
TCFUN C6=C2;
DN(1)=1E-9
INITIA CN,0;
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB6,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB6;
NORM 2,2,0;
TCFUN C5=C2;
RUPW=0
UPW=0
DN(1)=1E-6
INITIA CN,0;
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB7,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB7;
NORM 2,2,0;
TCFUN C4=C2;
DN(1)=1E-8
INITIA CN,0;
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB8,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB8;
NORM 2,2,0;
TCFUN C3=C2;
DN(1)=1E-9
INITIA CN,0;
SOLVE 0,L,W/L,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB9,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB9;
NORM 2,2,0;
