C* PRESP2.GEO  - this session file runs 1 hour!!
C* Impulse response of a pipe with prescribed laminar
C* velocity profile, calculated either using
C*       2D model (PLANE2D - fixed velocity profile) or
C*       1D model (PIPE2D).
C* Impulse responses are put into different columns of MOP
C*
C*    Column 2  - 1D D=1e-7   Galerkin
C*    Column 3  - 1D D=1e-6   Galerkin
C*    Column 4  - 1D D=1e-5   Galerkin
C*    Column 5  - 1D D=1e-7   Galerkin-Petrov (upwind)
C*    Column 6  - 1D D=1e-6   Galerkin-Petrov (upwind)
C*    Column 7  - 1D D=1e-5   Galerkin-Petrov (upwind)
C*
C*    Column 8  - 2D D=1e-7  weighted residuals upwind
C*    Column 9  - 2D D=1e-6  weighted residuals upwind
C*    Column 10 - 2D D=1e-5  weighted residuals upwind
C*
C* Tested by Zitny 17.9.2004
C*
ANALYS 2;
H=1
R=0.01
U=0.1
W=3*H/U
M=50
N=30
L=400
PT 1,0,0;
PT 2,H,0;
PT 3,H,R;
PT 4,0,R;
SF4PT 1,1,2,3,4;
MSF 1,M,N,1,.5,3;
BOX 0.3;
FUNDEF 1,2*U*(1-(YY/R)**2);
FUNDEF 2,YY*U*(1-(YY/R)**2)*DOF(CN,3,H,YY,0)
INITIA VX,1;
INITIA VY,0;
AXIS(1)=1
UPW=1
RUPW=1
EGROUP 1,PLANE2D,1,1,1,0,0;
CURDEF -1,0,4,0,0,W/L,1,2*W/L,1,3*W/L,0,W,0;
NFCR 4,CN,-1,1,1;
DN(1)=1E-5
INITIA CN,0;
SOLVE 0,L,W/L,0,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB1,NT;
I=I+1
LOADT T;
C1(I)=T
IC 2,2
C2(I)=INTEGRAL
T=T+0.5
#LABEL LAB1;
NORM 2,2,0;
TCFUN C10=C2;
DN(1)=1E-6
INITIA CN,0;
SOLVE 0,400,.750E-01,0,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB2,NT;
I=I+1
LOADT T;
C1(I)=T
IC 2,2
C2(I)=INTEGRAL
T=T+0.5
#LABEL LAB2;
NORM 2,2,0;
TCFUN C9=C2;
DN(1)=1E-7
INITIA CN,0;
SOLVE 0,400,.750E-01,0,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB3,NT;
I=I+1
LOADT T;
C1(I)=T
IC 2,2
C2(I)=INTEGRAL
T=T+0.5
#LABEL LAB3;
NORM 2,2,0;
TCFUN C8=C2;
C*
C* 1D problem (columns 2-7)
C*
NE=0
ND=0
SCALE -.500E-02,.101E+01,-.500E-04,.101E-01;
EGROUP 1,PIPE2D,1,0,0;
RCONST 1,PIPE2D,0.02,.100E-03,0,1E-3,0,0,0,0,0,0;
MCR 1,30,1,2,1,0,1;
NFPT 2,PRES,-1,0;
FUNDEF -2,A;
NFPT 1,PRES,-2,1;
A=8
SOLVE .375E+00,1,.750E-01,0,0,4,0,0,0;
NFPT 1,CN,-1,1;
DN(1)=1E-5
INITIA CN,0;
SOLVE 0,400,.750E-01,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB4,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB4;
NORM 2,2,0;
TCFUN C7=C2;
DN(1)=1E-6
INITIA CN,0;
SOLVE 0,400,.750E-01,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB5,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB5;
NORM 2,2,0;
TCFUN C6=C2;
DN(1)=1E-7
INITIA CN,0;
SOLVE 0,400,.750E-01,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB6,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB6;
NORM 2,2,0;
TCFUN C5=C2;
RUPW=0
UPW=0
DN(1)=1E-5
INITIA CN,0;
SOLVE 0,400,.750E-01,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB7,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB7;
NORM 2,2,0;
TCFUN C4=C2;
DN(1)=1E-6
INITIA CN,0;
SOLVE 0,400,.750E-01,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB8,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB8;
NORM 2,2,0;
TCFUN C3=C2;
DN(1)=1E-7
INITIA CN,0;
SOLVE 0,400,.750E-01,1,0,0,0,1,0;
I=0
T=0
NT=60
#LOOP LAB9,NT;
I=I+1
LOADT T;
C1(I)=T
C2(I)=V3(LPU(CN)+ND)
T=T+0.5
#LABEL LAB9;
NORM 2,2,0;
C* Uset GTC to look at calculated responses