C* Mixed tanks and stagnant regions,
C* modelled by PIPE2D, CSTR and PUMP.
C* Volumetric balances (VOLFLOW=1).
C* Impulse response (CN) calculated by
C* weighted residual method.
C* Remark: Balances method (HEPI=1) can
C*      be used as well, however,
C*      status of outlet CN must be >20.
C* 
C* Results are compared with prediction
C* of RTD model D00.MDT.
C* -----------------------------------------
C* FUNCTION F - fixed flowrate through PUMP
C* 
C*    Column 3  -  response of D00.MDT
C*    Column 2  -  response of FEM model 
C* must be calculated interactively (GT,NORM)
C* -----------------------------------------
C* Remark: This file can be processed
C*      either as batch or macro.
C*
C* Tested by Zitny 19.9.2004
C*
RMODEL D00;
PARSET 1,.2,4,1600;
IMPULS -2,10,300,20;
NORM 3,3,0;
RCONST 1,PIPE2D,.500E-01,.100E-03,0,1,0,0,0,0,0,0,0;
EGROUP 1,PIPE2D,1,0,0;
EGROUP 2,CSTR,1,0,0;
EGROUP 3,PUMP,1,-1,1,0;
RCONST 2,CSTR,0.05,1,0,0,1,0,0,0;
RCONST 3,CSTR,0.05,1,0,0,1,0,0,0;
RCONST 4,PUMP,0,0,0,.100E-01,0,0,.100E-02;
FUNDEF 1,F;
F=0.001
CURDEF -2,0,5,0,0,1,1,30,1,31,0,100,0;
X=0
Y=0
H=0.1
K=NPT
PT NPT+1,X,Y;
PT NPT+1,X+H,Y;
PT NPT+1,X+2*H,Y;
PT NPT+1,X+2*H,Y+H;
PT NPT+1,X+H,Y+H;
J=NCR
CR2PT NCR+1,K+1,K+2;
CR2PT NCR+1,K+2,K+3;
CR2PT NCR+1,K+3,K+4;
CR2PT NCR+1,K+4,K+5;
CR2PT NCR+1,K+5,K+2;
ACTSET 1,1;
ACTSET 3,1;
MCR J+1,1,1,2,0,0,1;
MCR J+5,1,1,2,0,0,1;
ACTSET 1,2;
ACTSET 3,2;
MCR J+2,1,1,2,0,0,1;
ACTSET 3,3;
MCR J+4,1,1,2,0,0,1;
ACTSET 1,3;
ACTSET 3,4;
MCR J+3,1,1,2,0,0,1;
X=X+2*H
K=NPT
PT NPT+1,X,Y;
PT NPT+1,X+H,Y;
PT NPT+1,X+2*H,Y;
PT NPT+1,X+2*H,Y+H;
PT NPT+1,X+H,Y+H;
J=NCR
CR2PT NCR+1,K+1,K+2;
CR2PT NCR+1,K+2,K+3;
CR2PT NCR+1,K+3,K+4;
CR2PT NCR+1,K+4,K+5;
CR2PT NCR+1,K+5,K+2;
ACTSET 1,1;
ACTSET 3,1;
MCR J+1,1,1,2,0,0,1;
MCR J+5,1,1,2,0,0,1;
ACTSET 1,2;
ACTSET 3,2;
MCR J+2,1,1,2,0,0,1;
ACTSET 3,3;
MCR J+4,1,1,2,0,0,1;
ACTSET 1,3;
ACTSET 3,4;
MCR J+3,1,1,2,0,0,1;
X=X+2*H
K=NPT
PT NPT+1,X,Y;
PT NPT+1,X+H,Y;
PT NPT+1,X+2*H,Y;
PT NPT+1,X+2*H,Y+H;
PT NPT+1,X+H,Y+H;
J=NCR
CR2PT NCR+1,K+1,K+2;
CR2PT NCR+1,K+2,K+3;
CR2PT NCR+1,K+3,K+4;
CR2PT NCR+1,K+4,K+5;
CR2PT NCR+1,K+5,K+2;
ACTSET 1,1;
ACTSET 3,1;
MCR J+1,1,1,2,0,0,1;
MCR J+5,1,1,2,0,0,1;
ACTSET 1,2;
ACTSET 3,2;
MCR J+2,1,1,2,0,0,1;
ACTSET 3,3;
MCR J+4,1,1,2,0,0,1;
ACTSET 1,3;
ACTSET 3,4;
MCR J+3,1,1,2,0,0,1;
X=X+2*H
K=NPT
PT NPT+1,X,Y;
PT NPT+1,X+H,Y;
PT NPT+1,X+2*H,Y;
PT NPT+1,X+2*H,Y+H;
PT NPT+1,X+H,Y+H;
J=NCR
CR2PT NCR+1,K+1,K+2;
CR2PT NCR+1,K+2,K+3;
CR2PT NCR+1,K+3,K+4;
CR2PT NCR+1,K+4,K+5;
CR2PT NCR+1,K+5,K+2;
ACTSET 1,1;
ACTSET 3,1;
MCR J+1,1,1,2,0,0,1;
MCR J+5,1,1,2,0,0,1;
ACTSET 1,2;
ACTSET 3,2;
MCR J+2,1,1,2,0,0,1;
ACTSET 3,3;
MCR J+4,1,1,2,0,0,1;
ACTSET 1,3;
ACTSET 3,4;
MCR J+3,1,1,2,0,0,1;
X=X+2*H
NMERGE ;
DISP F
VOLFLOW=1
NFPT 1,PRES,2,5E-3;
NFPT 18,PRES,-1,0;
NFPT 1,CN,-2,1;
SOLVE 0,1,20,0,0,60,0,0,0;
INITIA CN,0;
SOLVE 0,400,20,1,0,0,0,1,0;
C* Use GTC to see responses