C* CLOSED LOOP BUOYANCY (2 HEXC)
C* Boussinesque approximation, steady state.
C* Elements PIPE2D form closed loop 
C* with default RCONST and MPROP.
C* Two lateral pipes with prescribed pressures
C* and inlet temperature.
C*
C* There are problems with convergency
C* because dp(gravity)>>dp(friction).
C* Remark: It is necessary to fix pressure
C*         in a node of the loop.
C* --------------------------------------
C* D=0.05m, alfa(HE)=200 W/(m^2.K)
C* --------------------------------------
C*
C* Tested by Zitny 12.9.2004
C* 
GY=-9.81
BETA(1)=0.0005
BUOY=2
BL=0
PT 1,.100E+00,.000E+00;
PT 2,.900E+00,.000E+00;
CR2PT 1,1,2;
PT 3,.900E+00,.100E+01;
CR2PT 2,2,3;
PT 4,.100E+00,.100E+01;
CR2PT 3,3,4;
PT 5,.100E+00,.000E+00;
CR2PT 4,4,5;
PT 6,.000E+00,.000E+00;
PT 7,.000E+00,.100E+01;
CR2PT 5,6,7;
PT 8,.100E+01,.000E+00;
PT 9,.100E+01,.100E+01;
CR2PT 6,8,9;
MCR2 5,4,5,1,1,1,1,2,1,2;
MCR2 2,6,5,1,1,1,1,2,1,2;
MCR 1,5,1,2,1,3,2;
NMERGE ;
NFPT 1,PRES,-1,0;
NFPT 6,PRES,-1,10;
NFPT 7,PRES,-1,0;
NFPT 8,PRES,-1,10;
NFPT 9,PRES,-1,0;
NFPT 6,TEMP,-1,0;
NFPT 8,TEMP,-1,100;
RCHEX 2,0.1,200;
EGROUP 2,HEXC,0,0;
C* 50 time steps
SOLVE 0,50,10,1,0,35,1,0,0,0,0;
