C* Macro
C* RTD models identification using OPTIMA
C* Several predefined models are tested,
C* each testing consists in the following steps:
C*
C* 1. RM read model
C* 2. impulse response for a given parameters
C* 3. copy responses and randomisation
C* 4. compar-which responses are to be compared
C* 5. parfit-regression method applied fo individial parameters
C* 6. optima-parameter identification
C*
C* Tested models
C*
C* S0b   - series
C* SPA   - series + PF
C* SWA   - series + recycle
C* SS0a  - parallel series
C* D0A   - stagnant regions
C* B0A   - backmixing
C* RP0A  - series in recycle
C* 
C* Tested by Zitny 20.9.2004
C*
TSTEP 100,.05;

TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0

RMODEL SPA;
PARSET 5,.100E+01,.2,1;
IMPULS 1,4,100,.500E-01;
TCFUN C5=C3;
TCFUN C6=C4;
TCRND 6,6,1,.05;
TCRND 5,5,1,.05;
PARFIT 8,3,1,1.3,2,1,.1,3,1,1,1,1;
COMPAR 2,1,100,3,5,0,4,6,0;
c*OPTIMA 0,10;
GTC;
I* check result of optimisation series+PF. 5 and 3, 6 and 4 using TID

