C* Macro
C* RTD models identification using OPTIMA
C* Several predefined models are tested,
C* each testing consists in the following steps:
C*
C* 1. RM read model
C* 2. impulse response for a given parameters
C* 3. copy responses and randomisation
C* 4. compar-which responses are to be compared
C* 5. parfit-regression method applied fo individial parameters
C* 6. optima-parameter identification
C*
C* Tested models
C*
C* S0b   - series
C* SPA   - series + PF
C* SWA   - series + recycle
C* SS0a  - parallel series
C* D0A   - stagnant regions
C* B0A   - backmixing
C* RP0A  - series in recycle
C* 
C* Tested by Zitny 20.9.2004
C*
TSTEP 100,.05;

TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0

RMODEL SWA;
PARSET .100E+00,.3,.3,5,1,1;
IMPULS -2,5,100,.500E-01;
PARSET .100E+00,.300E+00,.300E+00,5,2,1;
IMPULS -2,5,100,.500E-01;
TCFUN C5=C3;
TCFUN C6=C4;
TCRND 5,5,1,.05;
TCRND 6,6,1,.05;
PARFIT .2,3,1,.2,3,1,.4,2,1,7,3,1,2,2,1,1,1,1;
COMPAR 2,1,100,3,5,0,4,6,0;
OPTIMA 0,10;
I* it was series with outer recycle + PF
GTC;
I* check results series outer recycle PF+PF
