C* Macro
C* RTD models identification using OPTIMA
C* Several predefined models are tested,
C* each testing consists in the following steps:
C*
C* 1. RM read model
C* 2. impulse response for a given parameters
C* 3. copy responses and randomisation
C* 4. compar-which responses are to be compared
C* 5. parfit-regression method applied fo individial parameters
C* 6. optima-parameter identification
C*
C* Tested models
C*
C* S0b   - series
C* SPA   - series + PF
C* SWA   - series + recycle
C* SS0a  - parallel series
C* D0A   - stagnant regions
C* B0A   - backmixing
C* RP0A  - series in recycle
C* 
C* Tested by Zitny 20.9.2004
C*
TSTEP 100,.05;

TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0

RMODEL A0A;
PARSET .500E+00,.2,2,3,3,1;
IMPULS -2,5,100,.500E-01;
TCFUN C4=C3;
TCRND 4,4,1,.05;
COMPAR 1,1,100,3,4,0;
PARFIT .3,2,1,.35,2,1,2.5,2,1,5,3,1,3,3,1,1,1,1;
OPTIMA 0,10;
I*
GTC;
I* check parallel series model

