C* Macro
C* RTD models identification using OPTIMA
C* Several predefined models are tested,
C* each testing consists in the following steps:
C*
C* 1. RM read model
C* 2. impulse response for a given parameters
C* 3. copy responses and randomisation
C* 4. compar-which responses are to be compared
C* 5. parfit-regression method applied fo individial parameters
C* 6. optima-parameter identification
C*
C* Tested models
C*
C* S0b   - series
C* SPA   - series + PF
C* SWA   - series + recycle
C* SS0a  - parallel series
C* D0A   - stagnant regions
C* B0A   - backmixing
C* RP0A  - series in recycle
C* 
C* Tested by Zitny 20.9.2004
C*
TSTEP 100,.05;

TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0

RMODEL D0A;
IMPULS -2,10,100,.500E-01;
TCFUN C5=c3;
TCFUN C6=c4;
PARSET .500E+00,.2,5,2,1;
TCRND 5,5,1,.100E+00;
TCRND 6,6,1,.100E+00;
COMPAR 1,1,100,3,5,0;
PARFIT .700E+00,2,1,.300E+00,2,1,5,3,1,2,2,1,1,0,1;
OPTIMA 0,10;
I* it was optimisation of stagant regions
GTC;
I* check series with stagnant regions

TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0

RMODEL B0A;
PARSET .500E+00,2,5,1;
IMPULS -2,5,100,.500E-01;
TCFUN C4=c3;
TCRND 4,4,1,.100E+00;
PARFIT .8,2,1,1.5,2,1,8,3,1,1,1,1;
COMPAR 1,1,100,3,4,0;
OPTIMA 0,10;
I* it was optimisation of backmixing series
GTC;
I* check backmixing series

TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0


RMODEL G0A;
PARSET 1,.500E+00,.100E+00,2,5,5,1;
IMPULS -2,5,100,.500E-01;
TCFUN C4=c3;
TCRND 4,4,1,.100E+00;
COMPAR 1,1,100,3,4,0;
PARFIT .600E+00,2,1,.147E+00,2,1,.200E+00,2,1,2,0,1,5,0,1,5,0,1,1,0,1;
OPTIMA 0,10;
GTC;
I* check G0A two series in recycle with piston flow