C* Macro
C* RTD models identification using SOMA
C* Several predefined models are tested,
C* each testing consists in the following steps:
C*
C* 1. RM read model
C* 2. impulse response for a given parameters
C* 3. copy responses and randomisation
C* 4. compar-which responses are to be compared
C* 5. parfit-regression method applied fo individial parameters
C* 6. SOMA-parameter identification
C*
C* Tested models
C*
C* S0b   - series
C* SPA   - series + PF
C* SWA   - series + recycle
C* A0a   - parallel series
C* D0A   - stagnant regions
C* B0A   - backmixing
C* G0A   - series in recycle
C* S0A   - response to stimulus function
C* 
C* Tested by Zitny 23.9.2005
C*
TSTEP 100,.05;
C* 1 
RMODEL S0B;
IMPULS 1,5,100,.500E-01;
TCFUN C4=C3
TCRND 4,4,1,.05;
PARFIT 0,0,1,8,3,1,1,2,1;
PARLIM 0,1,2,10,.5,2;
TCFUN C2=C3;
COMPAR 1,1,100,3,4,0;
IMPULS 1,5,100,.500E-01;
TCFUN C5=C3
SOMA 0,100;
GTC;
MODLIS
I* TID C5=initial, C3=final

C* 2
TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0
TCFUN C7=0
TCFUN C8=0
RMODEL SPA;
PARSET 5,.100E+01,.2,1;
IMPULS 1,4,100,.500E-01;
TCFUN C5=C3;
TCFUN C6=C4;
TCRND 6,6,1,.05;
TCRND 5,5,1,.05;
PARFIT 8,3,1,1.3,2,1,.1,3,1,1,1,1;
PARLIM 2,10,.1,2,0,1,.1,2;
COMPAR 2,1,100,3,5,0,4,6,0;
IMPULS 1,4,100,.500E-01;
TCFUN C7=C3;
TCFUN C8=C4;
SOMA 0,60;
GTC;
MODLIS
I* TID C7,C8=initial, C3,C4=final

C* 3
TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0
TCFUN C7=0
TCFUN C8=0
RMODEL SWA;
PARSET .100E+00,.300E+00,.300E+00,5,2,1;
IMPULS -2,5,100,.500E-01;
TCFUN C5=C3;
TCFUN C6=C4;
TCRND 5,5,1,.05;
TCRND 6,6,1,.05;
PARFIT .2,3,1,.2,3,1,.4,2,1,7,3,1,2,2,1,1,1,1;
PARLIM 0,1,0,1,0,1,1,10,1,10,.1,2
COMPAR 2,1,100,3,5,0,4,6,0;
IMPULS -2,5,100,.500E-01;
TCFUN C7=C3;
TCFUN C8=C4;
SOMA 0,60;
GTC;
modlis
I* TID series recycle PF+PF. C7,C8=initial C3,C4=final

C* 4
TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0
TCFUN C7=0
TCFUN C8=0
RMODEL A0A;
PARSET .500E+00,.2,2,3,3,1;
IMPULS -2,5,100,.500E-01;
TCFUN C4=C3;
TCRND 4,4,1,.05;
COMPAR 1,1,100,3,4,0;
PARFIT .3,2,1,.35,2,1,2.5,2,1,5,3,1,3,3,1,1,1,1;
SOMA 0,60;
IMPULS -2,5,100,.500E-01;
TCFUN C5=C3;
GTC;
modlis
I* TID parallel series model. C5=initial, C3=final


C* 8
TCFUN C2=0
TCFUN C3=0
TCFUN C4=0
TCFUN C5=0
TCFUN C6=0
TCFUN C7=0
TCFUN C8=0
IDMSER 2,6,.5;
TCRND 2,2,1,0.100E+00;
RMODEL S0A;
CONVOL -2,5,100,0.500E-01;
TCFUN C4=c3;
TCRND 4,4,1,0.100E+00;
TCRND 4,4,0,.03;
PARFIT .5,1,1,2,3,1,1.8,2,1;
PARLIM .1,10,1,10,.1,10;
CONVOL -2,5,100,0.500E-01;
TCFUN C5=c3;
COMPAR 1,1,100,3,4,0;
SOMA 1,60;
GTC;
MODLIS
I* TID C2=stimulus C5=initial, C3=final response


