C* Temperature field in a plate with a hole
C* See manual (steady state, transient, boundary
C* condition, temperature dependent conductivity,
C* internal heat sources)
C* ---------------------------------------------
C* Use macro (M THOLE3.GEO) because I* option is used.
C*
C* Macro tested by Zitny 5.9.2004
C*
ANALYS 2;
EGROUP 1,PLANE2D,0,4,0,0,0;
MPROP 1,PLANE2D,.600E+00,0,4200,0,998,0,.400E-01,0,.210E+12,0,.280E+00,0,.120E-04,0;
RCONST 1,PLANE2D,1,0,0,0;
C* Geometry
SCALE -.1,1.1,-.1,1.1;
PT 1,0,0;
PT 2,.5,0;
PT 3,1,0;
PT 4,1,.5;
PT 5,1,1;
PT 6,.5,1;
PT 7,0,1;
PT 8,0,.5;
PT 9,.2,.2;
PT 10,.2,.8;
PT 11,.8,.8;
PT 12,.8,.2;
PT 13,.5,.5;
PT 14,.65,.65;
CIRCLE 1,13,14,4;
SF8PT 1,1,3,20,18,2,12,19,9;
SF8PT 2,3,5,14,20,4,11,21,12;
SF8PT 3,5,7,16,14,6,10,15,11;
SF8PT 4,7,1,18,16,8,9,17,10;
C* Mesh A * B
VALUE A
VALUE B
MSF 1,A,B,1,1,8,0;
MSF 2,A,B,1,1,8,0;
MSF 3,A,B,1,1,8,0;
MSF 4,A,B,1,1,8,0;
NMERGE ;
C* Boundary condition temperatures at left and right sides
NFCR 12,TEMP,-1,10,10,0;
NFCR 8,TEMP,-1,100,20,50;
C* Solution 1 iter. temperature
DSOLVE 0,1,10000,0,0,0,1,0,0;
GD2 TEMP;
C* Boundary condition of the third kind at the top curve
C* heat transfer coefficient 100 w/m^2/k,
C* external temperature 200 C
TE(1)=200
NFCR 10,TEMP,21,100,100,100;
C* Heat transfer defined on curve 10
I*SOLVE 0,1,.100E+05,0,0,0,1,0,0;
GD2 TEMP;
EGROUP 1,PLANE2D,1,4,0,0,0;
FUNDEF 1,100*(1+SIN(10*XX*YY));
INITIA TEMP,1;
C* transient temperature field: initial temperature defined by function 1
I*SOLVE 0,10,10000,0,0,0,1,0,0;
C* time courses plotted by command gtime
GTIME
FUNDEF -2,50*(1+SIN(1E-6*TIME));
NFCR 3,TEMP,-2,1,1,1;
INITIA TEMP,1;
C* transient temperature field with oscillating boundary condition
I*SOLVE 0,10,100000,0,0,0,1,0,0;
GTIME
EGROUP 1,PLANE2D,0,4,0,0,0;
FUNDEF 2,0.6+0.01*TEMP;
MPROP 1,PLANE2D,.600E+00,2,4200,0,998,0,.400E-01,0,.210E+12,0,.280E+00,0,.120E-04,0;
C* nonlinear problem: temperature dependent conductivity kx
I*SOLVE 0,1,1,0,0,0,5,0,0;
GD2 TEMP;
FUNDEF 10,1E6*(1-XX);
EGROUP 1,PLANE2D,0,4,0,0,10;
OHMI=1
C* internal volumetric heat source defined by function 10
I*SOLVE 0,1,1,0,0,0,1,0,0;
GD2
C* how to calculate integral properties, e.g. mean temperature
C* standard function dof(temp,zone,x,y,z)
C* can be used only if boxing has been performed.
BOX .300E+00;
FUNDEF 11,DOF(TEMP,2,XX,YY,ZZ);
FUNDEF 12,1;
INTGSF 1,11;
S=INTEGRAL
INTGSF 1,12;
DISP S/INTEGRAL
C* Ohmic heating (modified boundary conditions along CR 3)
C* Fouling defined by rate equation No.3
RT=3
FUNDEF 3,A;
A=1E-7
KAPPA(1)=1
KAPPAF(1)=0.01
TE(1)=0
UE(1)=220
KX(1)=0.6
KXF(1)=0.2
NFCR 5,TEMP,-1,0,0,0;
NFCR 8,TEMP,-1,0,0,0;
NFCR 10,TEMP,-1,0,0,0;
NFCR 12,TEMP,-1,0,0,0;
NFCR 5,VOLT,-1,0,0,0;
NFCR 8,VOLT,-1,0,0,0;
NFCR 10,VOLT,-1,0,0,0;
NFCR 12,VOLT,-1,0,0,0;
NFCR 3,VOLT,21,1E10,1E10,1E10;
NFCR 3,TEMP,21,100,100,100;
INITIA TEMP,0;
OHMI=1
SOLVE 0,10,.100E+05,0,1,0,1,0,0,0,0;
