C* TRPIPE.GEO using PLANE2D elements.
C* Impulse response of a pipe with developed
C* laminar velocity profile (prescribed).
C* Method of characteristics (HEPI>1) is
C* used for calculation of CN response
C* evaluated as an integral of concentration
C* along the outlet cross-section. Impulse
C* response is located into 2nd column of MOP
C* and normalised.
C* ----------------------------------------
C* Length=1m, R=0.01m, u=0.1m/s
C* Mean residence time 10s, tmax=30s.
C* diffusion coefficient specified by user.
C* ----------------------------------------
C*
C* Tested by Zitny 10.9.2004
C*
H=1
R=0.01
U=0.1
W=3*H/U
C* M=80
C* N=50
C* L=100
C* method of characteristics - 20 integration steps 
C* HEPI=20
ASSIGN M
ASSIGN N
ASSIGN L
ASSIGN HEPI
PT 1,0,0;
PT 2,H,0;
PT 3,H,R;
PT 4,0,R;
SF4PT 1,1,2,3,4;
INIFEM
MSF 1,M,N,1,.5,3;
BOX 0.3;
FUNDEF 1,2*U*(1-(YY/R)**2);
FUNDEF 2,YY*U*(1-(YY/R)**2)*DOF(CN,3,H,YY,0)
FUNDEF 3,YY*DOF(CN,3,H,YY,0)
INITIA VX,1;
INITIA VY,0;
AXIS(1)=1
C* UPW=1
EGROUP 1,PLANE2D,1,1,1,0,0;
CURDEF -1,0,4,0,0,W/L,1,2*W/L,1,3*W/L,0,W,0;
NFCR 4,CN,-1,1,1;
INITIA CN,0;
C* Diffusion coefficient (1e-6 up to 1e-9)
VALUE DN(1)
SOLVE 0,L,W/L,0,0,0,0,1,0;
C* Integral of function 2 along curve 2
J=0
T=0
NT=60
#LOOP LAB,NT;
J=J+1
LOADT T;
C1(J)=T
IC 2,2
C2(J)=INTEGRAL
T=T+0.5
#LABEL LAB;
NORM 2,2,0;
