!  cooling.f90 
!
!  FUNCTIONS:
!	cooling      - Entry point of console application.
!

!****************************************************************************
!
!  PROGRAM: cooling
!
!  PURPOSE:  Entry point for the console application.
!
!****************************************************************************

	program cooling


	! Variables
    dimension tFnew(1000),tFold(1000),TPNEW(1000),TPOLD(1000),ri(1000),av(1000),bv(1000),cv(1000),rv(1000)
	open(1,file='cabinet.out')
	write(1,'('' time TvC-conv TvB-bottom TvP-plate TvR-radiation TvF-full''/''   t    TC    TB    TP    TR    TF'')')
	open(2,file='cabiRATE.out')
	write(1,'('' time TvC-conv TvB-bottom TvP-plate TvR-radiation TvF-full''/''   t    RC    RB    RP    RR    RF'')')
	sigma=5.67e-8
    rlama=0.024
	aa=19e-6
	rnya=13e-6
	beta=0.0037
	rhov=2700
	cpv=900
	rmalv=200
	rho=7800
	cp=460
	rlam=15
	a=rlam/(rho*cp)
	rm=0.25
	t0=0
	tvCold=20
    tvCnew=20	
	tvBold=20
    tvBnew=20	
	tvPold=20
    tvPnew=20	
	tvRold=20
    tvRnew=20	
	tvFold=20
    tvFnew=20	
	R=0.05
	h=0.1
	hs=0.003
	rmax=10*r
	nr=100
	dr=(rmax-r)/(nr-1)
	dr2=dr*dr
	do i=1,nr
	  ri(i)=r+(i-1)*dr
	  tPold(i)=0
	  tFold(i)=0
	enddo
    nt=2000
	dt=2
    time=0
	do it=1,nt
! cyklus casovych kroku
      time=time+dt
      alfarC=4*sigma*(tvCold+273)**3
	  alfacC=0.59*(beta*9.81*h**3*tvCold/(aa*rnya))**rm
      alfarB=4*sigma*(tvBold+273)**3
	  alfacB=0.59*(beta*9.81*h**3*tvBold/(aa*rnya))**rm
      alfarR=4*sigma*(tvRold+273)**3
	  alfacR=0.59*(beta*9.81*h**3*tvRold/(aa*rnya))**rm
      alfarP=4*sigma*(tvPold+273)**3
	  alfacP=0.59*(beta*9.81*h**3*tvPold/(aa*rnya))**rm
      alfarF=4*sigma*(tvFold+273)**3
	  alfacF=0.59*(beta*9.81*h**3*tvFold/(aa*rnya))**rm
	  alfaC=alfacC
	  alfaB=alfacB
	  alfaR=alfarR
	  alfaP=alfacP
	  alfaF=alfacF+alfarF
! teplotni pole v desce
      do ir=2,nr-1
	    av(ir)=-(ri(ir)+ri(ir-1))*.5/(ri(ir)*dr2)
	    cv(ir)=-(ri(ir)+ri(ir+1))*.5/(ri(ir)*dr2)
        bv(ir)=1/(a*dt)+2/dr2
	    rv(ir)=tPold(ir)/(a*dt)
      enddo
	  bv(1)=1
	  cv(1)=0
	  rv(1)=tvPold
      av(nr)=-1
	  bv(nr)=1
	  rv(nr)=0
      CALL TRIDAG(Av,Bv,Cv,Rv,tPnew,Nr)
! DESKA S ODVODEM TEPLA
      do ir=2,nr-1
	    av(ir)=-(ri(ir)+ri(ir-1))*.5/(ri(ir)*dr2)
	    cv(ir)=-(ri(ir)+ri(ir+1))*.5/(ri(ir)*dr2)
        bv(ir)=1/(a*dt)+2/dr2+4/(RHO*CP*HS)
	    rv(ir)=tFold(ir)/(a*dt)
      enddo
	  bv(1)=1
	  cv(1)=0
	  rv(1)=tvFold
      av(nr)=-1
	  bv(nr)=1
	  rv(nr)=0
      CALL TRIDAG(Av,Bv,Cv,Rv,tFnew,Nr)
	  acc=rhov*cpv*r*h/dt
	  bccC=alfaC*(r+2*h)
	  bccB=alfaB*(2*r+2*h)
	  bccP=0
	  bccR=alfaR*(r+2*h)
	  bccF=alfaF*(2*r+2*h)
	  qFcond=2*hs*rlam*(tFnew(2)-tFnew(1))/dr
	  qPcond=2*hs*rlam*(tPnew(2)-tPnew(1))/dr
	  tvCnew=(tvCold*acc+bccC*t0)/(acc+bccC)
	  tvBnew=(tvBold*acc+bccB*t0)/(acc+bccB)
	  tvRnew=(tvRold*acc+bccR*t0)/(acc+bccF)
	  tvPnew=(tvPold*acc+qPcond)/acc
	  tvFnew=(tvFold*acc+bccF*t0+qFcond)/(acc+bccF)
	  write(1,'(6f7.2)')time,tvCOLD,tvBOLD,tvpOLD,tvrOLD,tvFOLD
! update
      RATC=(TVCOLD-TVCNEW)/DT
      RATB=(TVBOLD-TVBNEW)/DT
      RATP=(TVPOLD-TVPNEW)/DT
      RATR=(TVROLD-TVRNEW)/DT
      RATF=(TVFOLD-TVFNEW)/DT
	  write(2,'(F7.0,6f7.4)')time,RATC,RATB,RATP,RATR,RATF
      tvCold=tvCnew
      tvBold=tvBnew
      tvRold=tvRnew
      tvPold=tvPnew
      tvFold=tvFnew
	  do i=1,nr
	     tFold(i)=tFnew(i)
	     tPold(i)=tPnew(i)
      enddo

    enddo
	end program cooling

