C WAFFLE FOAM
      parameter (pi=3.141)
C Mesc-celkova hmotnost unikle pary
      real M,Mc,Ms,Mw0,Mw,Mv,Mf0,Mf,Mb0,Mb,Mesc,
     /K,n,lams,lamw,lamv,lam
C jednoprikazove funkce T je ve stupnich Celsia
	FCs(T)=1136+3.56*T
	FCw(T)=4170+0.5*T
	Flams(T)=0.0976+0.00167*T
      Flamw(T)=0.58+0.0012*T
      Fdh(T)=2.255e6*((374.15-T)/274.5)**0.38
	FK(T)=0.672*exp(4960/(T+273.15))
C  p=B.exp(-dh/RT) 
	B=4.81e10
	n=0.4
	Rgas=461.9
C PSI.(p-pa) - prutok kg/s
	Psi=2e-10
	Tw=180
	T0=30
C hmotnst a slozeni vzorku. 
C OMEGAW-podil vody
C Z0=Mb0/Mf0   sorption isotherm
      omegaw=0.6
	Z0=0.02/0.04
	M=0.25
	Ms=M*(1-omegaw)
	Mw0=M*omegaw
	Mf0=M*omegaw/(1+Z0)
	Mb0=M*omegaw*Z0/(1+Z0)
      Rb0=2e-6
	Nb=670000
	rhos=1648
	rhow=1000
	lamv=0.02
	H=0.008
	dtime=1
	timax=2400
c rozmery A-celkova teplosmenna plocha (z obou stran)
      Vs=Ms/rhos
	Vw=Mw0/rhow
	V=Vs+Vw
	V0=V
	Vmax=2*V0
	A=2*V/H
      T=T0
	Rb=Rb0
	pa=1e5
c tepelna kapacita pary
	cv=0.02
	open(1,file='foam.out')
C faze I.
C------------------------------------------------
	Mw=Mw0
	Mf=Mf0
	Mb=Mb0
	Mesc=0
	time=0
	do while(T.le.100.)
	  time=time+dtime
	  lams=Flams(T)
	  lamw=Flamw(T)
	  lam=(Mw*lamw+Ms*lams)/M
	  rho=(Mw*rhow+Ms*rhos)/M
	  cs=Fcs(T)
	  cw=Fcw(T)
	  c=(Mw*cw+Ms*cs)/M
        alfa=amax1(2*lam/H,sqrt(lam*rho*c/(pi*time)))
	  Mc=Ms*cs+Mw0*cw
	  T=T+dtime*alfa*a*(Tw-T)/Mc
	  write(1,'(2f10.0)')time,T
	enddo
C faze II. expanze bublin - ukoncena zaplnenim formy
C -------------------------------------------------------
      do while(V.le.Vmax)
	  time=time+dtime
	  Tk=T+273.15
C vyparne teplo
        dh=Fdh(T)
	  lams=Flams(T)
	  lamw=Flamw(T)
	  lam=(Mw*lamw+Ms*lams)/M
	  cs=Fcs(T)
	  cw=Fcw(T)
C rovnovazny tlak
        p=B*exp(-dh/(Rgas*Tk))
C polomer bubliny
	  k=fk(T)
        w=(n/(4*k*(2*sqrt(3.))**(n-1)))**(1/n)
	  Rb=Rb*exp(dtime*w*(p-pa)**(1/n))
C hmotnosti fazi
        Vv=Nb*4./3.*pi*Rb**3
        Mv=Vv*p/(Rgas*Tk)
        V=Ms/rhos+Mw0/rhow+Mv*(Rgas*Tk/p-1/rhow)
	  Mc=Ms*cs+(Mw0-Mv)*cw+Mv*cv+((cv-cw)*T+dh)*
     /     (dh/(Rgas*Tk**2)-1./Tk)*Mv
	  Psig=3*Mv*w*((cv-cw)*T+dh)
	  AH=4/H**2*(lamv*Vv+lam*(V-Vs))
C diferencialni rovnice entalpie, implicitni
        T=(Mc*T/dtime+AH*Tw-psig*(p-pa)**(1/n))/(Mc/dtime+AH)
	  write(1,'(2f10.0,f12.3)')time,T,p/1e5
	enddo
C faze III. unik pary za soucasne existence volne vody
C -------------------------------------------------------
	do while(Mf.gt.0.)
	  time=time+dtime
	  Tk=T+273.15
C vyparne teplo
        dh=Fdh(T)
	  lams=Flams(T)
	  lamw=Flamw(T)
	  lam=(Mw*lamw+Ms*lams)/M
	  cs=Fcs(T)
	  cw=Fcw(T)
C rovnovazny tlak
        p=B*exp(-dh/(Rgas*Tk))
	  Mv=(Vmax-V0)*p/(Rgas*Tk)
	  Psip=Psi*(p-pa)
	  Mesc=Mesc+Psip*dtime
	  Mf=Mf0-Mesc-Mv
	  Mc=Ms*cs+(Mw0-Mesc-Mv)*cw+Mv*cv+(dh-(cw-cv)*T)*
     /     Mv*(dh/(Rgas*Tk**2)-1/Tk)
	  AH=4/H**2*(lamv*Vv+lam*(Vmax-Vs))
        T=(Mc*T/dtime+AH*Tw-Psip*dh)/(Mc/dtime-Psip*(cw-cv)+AH)
	  write(1,'(2f10.0,f12.3,e12.5)')time,T,p/1e5,Mf
      enddo
C faze IV. unik pary jen vazana voda. Zvysene vyparne teplo
C -------------------------------------------------------
      alfa=2.255e6*(Mb0/Ms+0.005)*((374-T)/274)**0.38
C fi-urceno z III.faze
      fi=Psi*(p-pa)/Mb0
	do while(time.lt.timax)
	  time=time+dtime
	  Tk=T+273.15
C vyparne teplo
        dh=Fdh(T)
	  dhb=alfa/(Mb/Ms+0.005)
	  lams=Flams(T)
	  lamw=Flamw(T)
	  lam=(Mw*lamw+Ms*lams)/M
	  cs=Fcs(T)
	  cw=Fcw(T)
	  dMdt=fi*Mb
	  Mesc=Mesc+dMdt*dtime
C Tlak je dan prutokem pary, ale jiz nekontroluje teplotu
        p=pa+dMdt/Psi
        Mv=(Vmax-V0)*p/(Rgas*Tk)
	  Mb=Mw0-Mesc-Mv
	  Mc=Ms*cs+Mb*cw+Mv*(cv+(dh/(Rgas*Tk**2)-1/Tk)*(dh-(cw-cv)*T))
	  AH=4/H**2*(lamv*Vv+lam*(Vmax-Vs))
        T=(Mc*T/dtime-dMdt*dhb+AH*Tw)/(Mc/dtime-dMdt*(cw-cv)+AH)
	  write(1,'(2e12.5)')time,T
	enddo     
	end


        