C WAFFLE FOAM FD
      parameter (pi=3.141)
	real epsi(201),ti(201),rhoi(201),zi(201),
     /     hti(201),hei(201),hfi(201),
     /     f1i(201),f2i(201),fi(201),uz(201),lami(201),
     /     ad(201),bd(201),cd(201),rd(201),tnew(201)
C Mesc-celkova hmotnost unikle pary
      real K,n,lams,lamw,lamv,lamm
C jednoprikazove funkce T je ve stupnich Celsia
	FCs(T)=1136+3.56*T
	FCw(T)=4170+0.5*T
	Flams(T)=0.0976+0.00167*T
      Flamw(T)=0.58+0.0012*T
      Fdh(T)=2.255e6*((374.15-T)/274.5)**0.38
	FK(T)=0.672*exp(4960/(T+273.15))
C  p=B.exp(-dh/RT) 
	B=4.81e10
	n=0.4
	Rgas=461.9
	Tw=180
	T0=30
	Tb0=373.
c kriticke parametry pro poruseni bublin (C)
      Tcrit=150.
	epscrit=1
	omgcrit=0.002
c fiktivni rychlost (setina mm/s)
      u0=1e-4
C hmotnst a slozeni vzorku. 
C OMEGAW-podil vody
      omegaw=0.6
	omegas=0.4
	rhos=1648
	rhow=1000
	lamv=0.02
c polovicni tloustka H
	H=0.002
	dt=0.02
	tmax=50
	imax=tmax/dt
c tepelna kapacita pary
	cv=0.02
	open(1,file='foamfd.out')
	open(2,file='foamfdt.out')
	open(3,file='foamfde.out')
c pocet uzlu site
      m=121
	dz=H/(m-1)
c pocatecni podminky
      do i=1,m
	   epsi(i)=0
	   ti(i)=t0
	   zi(i)=(i-1)*dz
	enddo
	ti(m)=Tw
      write(2,'(i4,f5.0,70e11.3)')
     /         izona,time,(zi(i),i=1,m-2,5),zi(m-1),zi(m)
	write(3,'(i4,f5.0,70e11.3)')
     /         izona,time,(zi(i),i=1,m-2,5),zi(m-1),zi(m)
	
	ti(m)=tw
c cyklus casovych kroku
      time=0
C------------------------------------------------
      do itime=1,imax
	  time=time+dt
c termofyzikalni parametry v uzlech
	  do i=1,m
	     z=(i-1)*dz
	     T=ti(i)
	     eps=epsi(i)
	     lams=Flams(T)
	     lamw=Flamw(T)
	     lam=omegaw*lamw+omegas*lams
	     cs=Fcs(T)
	     cw=Fcw(T)
           dh=Fdh(T)
	     Tk=T+273.1
	     if(t.gt.100.)then
             p=B*exp(-dh/(Rgas*Tk))
  	       k=fk(T)
             F=(n/(4*k*(2*sqrt(3.))**(n-1)))**(1/n)
	       Fi(i)=F
             f1i(i)=p**(1/n)*
     /            (1-exp(-dh/rgas*(1/tb0-1/tk)))**(1/n)
             f2i(i)=p**(1/n)*dh/(n*rgas*tk**2)*
     /            (1-exp(-dh/rgas*(1/tb0-1/tk)))**((1-n)/n)
	       hti(i)=omegas*cs+omegaw*cw+dh*eps/(1-eps)*
     /            p/(rgas*tk**2)*(dh/(rgas*tk)-1)*
     /            (rhos*omegaw+rhow*omegas)/(rhos*rhow)
             hei(i)=dh/(1-eps)**2*p/(rgas*tk)*
     /            (rhos*omegaw+rhow*omegas)/(rhos*rhow)
	       uz(i)=3*f*f1i(i)*u0*(z/H-(z/H)**2)
	     else
	       fi(i)=0
	       f1i(i)=0
	       f2i(i)=0
	       hti(i)=omegas*cs+omegaw*cw
	       hei(i)=0
		   uz(i)=0
	     endif
           rhov=p/(rgas*tk)
           rhoi(i)=eps*rhov+(1-eps)*rhow*
     /             (1+omegas*(rhos-rhow)/(rhos*omegaw+rhow*omegas))
           hfi(i)=3*f*rhoi(i)*hei(i)*(1-eps**2)
           lamm=omegaw*lamw+omegas*lams
	     lami(i)=lamm*(1-eps*(1-0.05/lamm))
        enddo
c generovani tridiagonalni soustavy
        do i=2,m-1
          ad(i)=-(lami(i-1)+lami(i))/(2*dz**2)
          cd(i)=-(lami(i+1)+lami(i))/(2*dz**2)
          if(ti(i).le.100.)then
c modifikace pro teploty mensi nez 100C
              bd(i)=rhoi(i)*hti(i)/dt-ad(i)-cd(i)
	        rd(i)=rhoi(i)*hti(i)/dt*ti(i)
          else
	        bd(i)=rhoi(i)*hti(i)/dt+hfi(i)*f2i(i)
     /           -ad(i)-cd(i)
	        rd(i)=(rhoi(i)*hti(i)/dt+hfi(i)*f2i(i))*ti(i)-
     /          hfi(i)*f1i(i)-rhoi(i)*uz(i)/(2*dz)*
     /          (hti(i)*(ti(i+1)-ti(i-1))+hei(i)*(epsi(i+1)-epsi(i-1)))
	    endif
	  enddo
c okrajove podminky
        ad(m)=0
	  bd(m)=1
	  rd(m)=Tw
	  bd(1)=1
	  cd(1)=-1
	  rd(1)=0
c reseni tridiagonalni soustavy pro teploty
        call tridag(ad,bd,cd,rd,tnew,m)
c porozity
        izona=0
        do i=1,m
c blokovani narustu porozity po prekroceni kriticke teploty 
          Tk=ti(i)+273.15
          p=B*exp(-dh/(Rgas*Tk))
c	    if(ti(i).lt.tcrit*(1-(epsi(i)/epscrit)**4))then
          if(omgcrit.gt.p*epsi(i)/(Rgas*rhos*Tk))then
             ff=3*fi(i)*dt*f1i(i)
	       epsi(i)=(epsi(i)*(1+ff)+ff)/(1+ff*(1+epsi(i)))
	    elseif(izona.eq.0)then
	       izona=i
	    endif
c umele blokovani narustu porozity     
          epsi(i)=amin1(0.98,epsi(i))
	    ti(i)=tnew(i)
        enddo
	  write(1,*)' time step=',itime,' temperatures and eps'
        write(1,'(5e11.3,5x,5e11.3)')(ti(i),i=1,5),(ti(i),i=m-4,m)
        write(1,'(5e11.3,5x,5e11.3)')(epsi(i),i=1,5),(epsi(i),i=m-4,m)
        if(mod(itime,250).eq.0.and.time.gt.10.)then
	    write(2,'(i4,f5.0,70e11.3)')
     /          izona,time,(ti(i),i=1,m-2,5),ti(m-1),ti(m)
	    write(3,'(i4,f5.0,70e11.3)')
     /          izona,time,(epsi(i),i=1,m-2,5),epsi(m-1),epsi(m)
	  endif
	enddo     
	end

      SUBROUTINE TRIDAG(A,B,C,R,U,N)
c
c Tridiagonal linear set of equations (A-lower, B-diagonal, C-upper, R-RHS)
c according to Press: Numerical recipes, p. 40
c Vectors A,B,C,R are not destroyed.
c
      parameter (nmax=201)
      real gam(nmax),a(n),b(n),c(n),r(n),u(n)
      bet=b(1)
      u(1)=r(1)/bet
      do j=2,n
         gam(j)=c(j-1)/bet
         bet=b(j)-a(j)*gam(j)
         u(j)=(r(j)-a(j)*u(j-1))/bet
      enddo
      do j=n-1,1,-1
         u(j)=u(j)-gam(j+1)*u(j+1)
      enddo
      end


